-- name=int_button_hint_impl
function public.Init ()

  public.DIRECTION = 1;
  public.POSITION = 0;

  private.RELOAD_ANIM_FRAME_COUNT = 89;
  public.RELOAD_BEGIN_ANIM_TIME  = 3.7; -- время "ухода" жабы, зависит от тита лягушки
  private.RELOAD_ANIM_TIME  = 0; -- время "прихода" жабы, зависит от тита лягушки
  private.RELOAD_VID_FRAME_COUNT = 1134--1423;
  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME = 0.3;
  private.POS_X = 940;

  --описание полей смотри в скипе(первая реализация в RD3)
  private.VIDEO_STATICS = ObjGetRelations( "obj_int_button_hint_static" ).childs;
  private.CURRENT_STATIC_NUMBER = 0;
  private.STATIC_TIMER_NAME = "tmr_int_button_hint_static";
  private.RANDOM_STATIC_INTERVAL = {3,5};

  ObjSet("spr_int_button_hint_button_back", {
    event_mdown = int_button_hint.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

  ObjSet("obj_int_button_hint_button", {
    event_mdown = int_button_hint.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then
    ObjSet( "spr_int_button_hint_back_add", { visible = false } );
  else
    ObjSet( "spr_int_button_hint_back_add", { visible = true } );
  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_button_hint.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_button_hint", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () int_button_hint.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_button_hint", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.StartAnimStaticCicle()
  local interval = private.RANDOM_STATIC_INTERVAL;
  local tme = math.random(interval[1]*10,interval[2]*10)/10;
  private.CURRENT_STATIC_NUMBER = math.random(1,#private.VIDEO_STATICS);
  local vid = private.VIDEO_STATICS[private.CURRENT_STATIC_NUMBER];

  public.StopAnimStaticCicle();
  
  local function func_end() 
    VidPlay(vid, public.StartAnimStaticCicle);  
  end
  ObjSet( vid, { active = true, visible = true } );
  ld.StartTimer( private.STATIC_TIMER_NAME, tme, func_end );
  
end
--******************************************************************************************
function public.StopAnimStaticCicle()
  for i,o in ipairs(private.VIDEO_STATICS) do
     ObjSet( o, { active = false, visible = false } );
     VidStop(o);
  end
  ObjDelete(private.STATIC_TIMER_NAME);
end
--******************************************************************************************
function public.ChangeToStatic()

  ObjSet( "obj_int_button_hint_reload", { active = false, visible = false } );
  ObjSet( "obj_int_button_hint_static", { active = true, visible = true } );

  ObjSet( "vid_int_button_hint_loader", { active = false, visible = false } );
  ObjSet( "vid_int_button_hint_close", { active = false, visible = false } );
  
  public.StartAnimStatic();
  if #private.VIDEO_STATICS > 0 then
    public.StartAnimStaticCicle();
  end

end;
--******************************************************************************************
function public.ChangeToReload( is_begin )
  
  public.StopAnimStaticCicle()
  ObjSet( "obj_int_button_hint_static", { active = false, visible = false } );
  ObjSet( "obj_int_button_hint_reload", { active = true, visible = true } );
  ObjSet( "vid_int_button_hint_loader", { active = true, visible = true } ); 

  if ( is_begin ) then

    public.ReloadAnim( true );    

  else
    
    public.ReloadAnim( true );

  end;

end;
--******************************************************************************************
function public.ReloadAnim( is_first )
  
  if ( is_first ) then

  end;
 
  if ( not ObjGet( "tmr_int_button_hint_reload" ) ) then
    return;
  end;


  local time_min    = int_button_hint.GetTimeMin();
  local time_remain = int_button_hint.GetTimeRemain();
  local time_full   = int_button_hint.GetTimeFull();

  local frame_count = private.RELOAD_ANIM_FRAME_COUNT;
  local vid_frame_count = private.RELOAD_VID_FRAME_COUNT;

  --  время на один фрейм
  local time_frame = time_full / frame_count;
  local vid_time_frame = time_full / vid_frame_count;  

  local time_current = time_full - time_remain;
  local frame_current = math.floor( time_current / time_frame );
  local vid_frame_current = math.floor( time_current / vid_time_frame );

  --ObjSet( "anm_int_button_hint_active_hint_timer", { frame = frame_current } );
  ObjSet( "vid_int_button_hint_loader", { frame = vid_frame_current } );

  ObjSet( "tmr_int_button_hint_reload", { endtrig = "" });

  if ( frame_current < (frame_count) ) then

    local trg = "int_button_hint_impl.ReloadAnim();";    
    ObjSet( "tmr_int_button_hint_reload_anim", { endtrig = trg, time = time_min, playing = true } );

  else
    
    private.EndAnimReload();
    ObjSet( "vid_int_button_hint_loader", { active = false, visible = false } );

  end;

end;
--******************************************************************************************
-- конец анимации зарядки хинта
function private.EndAnimReload()

  int_button_hint.EventAnimEnd( 'reload' );
  VidStop( "vid_int_button_hint_loader");
  ObjSet( 'vid_int_button_hint_loader', { frame = 0 } );
  ObjSet( 'obj_int_button_hint', { alp = 1 } );

end;
--******************************************************************************************
function public.SetHardcore( is_hardcore )

  if ( is_hardcore ) then

    ObjSet( "obj_int_button_hint_active",   { visible = false } );
    ObjSet( "obj_int_button_hint_hardcore", { active = true, visible = true } );
    ObjSet( "obj_int_button_hint_button",   { input = true, visible = true } );

  else

    ObjSet( "obj_int_button_hint_hardcore", { active = false, visible = false } );
    ObjSet( "obj_int_button_hint_active",   { visible = true } );
    ObjSet( "obj_int_button_hint_button",   { input = true, visible = true } );

  end;

end;
--******************************************************************************************
-- старт анимации зарядки хинта
function public.StartAnimReload()

  PlaySfx( "assets/levels/common/audio/aud_hinton_sfx", 0, "", 0 );

  if ng_global.widget.hint_type_frog == 1 then

    PlaySfx( "assets/levels/common/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ng_global.widget.hint_type_frog == 2 then

    ObjSet( 'obj_int_button_hint', { pos_x = -15, pos_y = 32 } );
    ObjSet( "obj_vid_int_button_hint_reload", { pos_x = 58, pos_y = -77, ang = -4.25 } );
    ObjStopAnimate( "obj_vid_int_button_hint_reload", 7 );
    ObjStopAnimate( "obj_vid_int_button_hint_reload", 3 );
    ObjAnimate( "obj_vid_int_button_hint_reload", 7, 0, 0, "", { 0,3,-4.25, 0.5,3,0 });
    ObjAnimate( "obj_vid_int_button_hint_reload", 3, 0, 0, "", { 0,1,58,-77, 0.15,0,-7,-96, 0.3,1,-67,-71, 0.5,0,58,-77 });
    PlaySfx( "assets/levels/common/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ng_global.widget.hint_type_frog == 3 then

    PlaySfx( "assets/levels/common/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ng_global.widget.hint_type_frog == 4 then

    PlaySfx( "assets/levels/common/audio/oth/aud_hinton_sfx", 0, "", 0 );
    ObjStopAnimate( "obj_int_button_hint", 1 );
    ObjSet( "obj_int_button_hint", { pos_x = 2, pos_y = 32 } );
    local posy = ObjGet( "obj_int_button_hint" ).pos_y;
    ObjAnimate( "obj_int_button_hint", 1, 1, 0, "", { 0,3,posy, 0.5,3,posy-2, 1.5,3,posy+2, 2,3,posy });

  end; 

end;
--******************************************************************************************
-- конец анимации зарядки хинта
function private.EndAnimReload()

  int_button_hint.EventAnimEnd( 'reload' );
  VidStop( "vid_int_button_hint_loader");
  ObjSet( 'vid_int_button_hint_loader', { frame = 0 } );
  ObjSet( 'obj_int_button_hint', { alp = 1 } );
  SoundSfx( "aud_hint_reload" )

end;
--******************************************************************************************
-- старт анимации "разрядки" хинта
function public.StartAnimReloadBegin()

  --ObjSet( "anm_int_button_hint_active_hint_timer", { frame = 0 } );
  ObjSet( "vid_int_button_hint_loader", { active = false, visible = false } );  
  ObjSet( "vid_int_button_hint_close", { active = true, visible = true } );
  ObjSet( "vid_int_button_hint_static", { active = false, visible = false } );    
  ObjSet( "vid_int_button_hint_close", { alp = 1 } );
  VidStop( "vid_int_button_hint_close" );
  VidPlay( "vid_int_button_hint_close", private.EndAnimReloadBegin );

end;
--******************************************************************************************
-- конец анимации "разрядки" хинта
function private.EndAnimReloadBegin()

  ObjSet( 'vid_int_button_hint_close', { active = false, visible = false } );
  ObjSet( "vid_int_button_hint_loader", { active = true, visible = true } ); 
--  ObjStopAnimate( "obj_int_button_hint", 1 );
--  ObjStopAnimate( "obj_int_button_hint", 3 );
--  ObjStopAnimate( "obj_int_button_hint", 8 );
--  ObjStopAnimate( "obj_vid_int_button_hint_reload", 3 );
--  ObjStopAnimate( "obj_vid_int_button_hint_reload", 7 );
--
--  ObjSet( "anm_int_button_hint_active_hint_timer", { frame = 0 } );
--  ObjSet( 'vid_int_button_hint_reload_begin', { active  = false, visible = false, trg = "" } );
--  ObjSet( 'obj_int_button_hint', { alp = 1 } );
--
end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_hint_button_focus";
  local obj_text = "spr_int_button_hint_button_txt";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );
  ObjAnimate( obj_text, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );
end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_hint_button_focus";
  local obj_text = "spr_int_button_hint_button_txt";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );
  ObjAnimate( obj_text, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
-- старт анимации "статики" хинта
function public.StartAnimStatic()

  --ObjSet( "anm_int_button_hint_active_hint_timer", { frame = private.RELOAD_ANIM_FRAME_COUNT } );
  ObjSet( "tmr_int_button_hint_reload", { playing = false } );


end;
--******************************************************************************************
function public.PauseLevel( msg, param )
  if msg == "Command_Level_Pause" then
    ObjSet( "int_button_hint", { active = 1 - param.pause } )
  end;
end
--******************************************************************************************
function public.ChangeParams( params )
  if params.DIRECTION ~= nil then
    private.DIRECTION = params.DIRECTION
  end
  if params.POS_X ~= nil then
    private.POS_X = params.POS_X
    ObjSet( "obj_int_button_hint_impl", { pos_x = params.POS_X  - ( GetWideScreen() and 171 or 0 ) } )
  end
  if params.POS_Y ~= nil then
    --private.POS_Y = params.POS_Y
    ObjSet( "obj_int_button_hint_impl", { pos_y = params.POS_Y } )
  end
  if params.back ~= nil then
    ObjSet( "spr_int_button_hint_back", { visible = params.back } )
  end
  if params.hardcore ~= nil then
    public.SetHardcore( params.hardcore )
  end
end