-- name=int_button_info_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 1;
  public.POSITION = 0;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.MOVE_ANIM_POS_X_BEG =  213;
  private.MOVE_ANIM_POS_X_END =   0;
  private.MOVE_ANIM_TIME      =   0.4;

  ObjSet("obj_int_button_info", {
    event_mdown = int_button_info.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });
  ObjSet("spr_int_button_info_hint", {
    event_mdown = common_impl.ButtonInfoHint_Click,
    event_menter = private.MouseEnterAnimHint,
    event_mleave = private.MouseLeaveAnimHint,
    alp = 0,
    input = 0,
  });

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local obj = "int_button_info_impl";
  local trg = function () int_button_info.EventAnimEnd( event_id ); end;
  local tme = private.MOVE_ANIM_TIME;
  local offset = 0.5 * ( GetAppWidth() - 1024 );

  ObjAnimate( obj, "pos_x", 0, 0, trg,
  {
    0.0, 2, public.DIRECTION*offset + private.MOVE_ANIM_POS_X_BEG,
    tme, 2, public.DIRECTION*offset + private.MOVE_ANIM_POS_X_END
  } );

end;
function public.ShowAnimHint( func )

  common_impl.ButtonInfoHintFunc = func
  --if common_impl.ButtonInfoHintFunc then
    local o = ObjGet( "spr_int_button_info_hint" )
    ObjSet( o.name, { input = 1 } )
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, private.MOVE_ANIM_TIME,0,1 } )
  --end;
end
--******************************************************************************************
function public.HideAnim( event_id )

  local obj = "int_button_info_impl";
  local trg = function () int_button_info.EventAnimEnd( event_id ); end;
  local tme = private.MOVE_ANIM_TIME;
  local offset = 0.5 * ( GetAppWidth() - 1024 );

  ObjAnimate( obj, "pos_x", 0, 0, trg,
  {
    0.0, 1, public.DIRECTION*offset + private.MOVE_ANIM_POS_X_END,
    tme, 1, public.DIRECTION*offset + private.MOVE_ANIM_POS_X_BEG
  } );

  public.HideAnimHint()

end;
function public.HideAnimHint()
  local o = ObjGet( "spr_int_button_info_hint" )
  ObjSet( o.name, { input = 0 } )
  ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, private.MOVE_ANIM_TIME,0,0 } )
end
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_info_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_info_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--*****************************************************************
function private.MouseEnterAnimHint()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_info_hint_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnimHint()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_info_hint_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--*******************************************************************************************************************
