-- name=int_button_lock_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;
  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet( "obj_int_button_lock", {
    event_mdown = function () private.MouseDown(); end,
    event_menter = function () private.MouseEnterAnim(); end,
    event_mleave = function () private.MouseLeaveAnim(); end
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function private.MouseDown()

  if ObjGet( "spr_int_button_lock" ).alp == 1 then
    PlaySfx( "assets/levels/common/audio/aud_inventory_lock_close", 0, "", 0.0 )
  else
    PlaySfx( "assets/levels/common/audio/aud_inventory_lock_open", 0, "", 0.0 )
  end;

  int_button_lock.MouseDown()

end;
--******************************************************************************************
function public.LockAnim( lock, event_id )
  -- lock: true or false
  if lock then
    ObjSet( "spr_int_button_lock", { alp = 1 } );  
    ObjSet( "spr_int_button_lock_1", { alp = 0 } );  
  else                                
    ObjSet( "spr_int_button_lock", { alp = 0 } );  
    ObjSet( "spr_int_button_lock_1", { alp = 1 } );  
  end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

  int_button_lock.MouseEnter();

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_lock_light";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  int_button_lock.MouseLeave();

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_lock_light";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************