--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_providence", interface.originhub );
  ObjSet( "int_button_providence", { pos_z = pos_z } );

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_TIME      =  0.6;

  ObjSet("obj_int_button_providence", {
    event_mdown = public.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function public.Destroy()


end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

  if ( event_id == "show" ) then

    ObjSet( "int_button_providence", { input = true } );

   --common_impl.TutorialShow( "tutorial_page_12" );

   elseif ( event_id == "hide" ) then

    ObjSet( "int_button_providence", { active = false, visible = false, input = false } );

  end;

end;
--******************************************************************************************
function private.ShowAnim( event_id )

  local obj = "int_button_providence";
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.MOVE_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.HideAnim( event_id )

  local obj = "int_button_providence";
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.MOVE_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_providence_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_providence_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.MouseDown()
  DbgTrace(" click int_button_providence");
  common_impl.StartProvidence();  
end;
--******************************************************************************************
function public.Show( event_id )

  
  ObjSet( "int_button_providence", { active = true, visible = true, input = true } );
  private.ShowAnim( "show" );
  
end;
--******************************************************************************************
function public.Hide( event_id )

  private.HideAnim( "hide" );

end;