-- name=int_button_task
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_task", "obj_int_inventory_task" );
  ObjSet( "int_button_task", { pos_z = pos_z, pos_x = 0, pos_y = 0 } );

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_TIME      =  0.6;

  ObjSet( "obj_int_button_task", 
  {
    event_mdown = private.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );

  public.Update ( false, "none" )
  
end;
--******************************************************************************************
function public.Destroy ()

  --

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function private.MouseDown ()

  if ( int_dialog_task.show ) then

    interface.DialogTaskHide();
    

  elseif ( int_dialog_task.hide ) then

    --SoundSfx( "aud_task" )

    --for i = 1, #game.level_tasks do
    --  if not private.IsTakDone(i) then
    --    private.task_current = i
    --    break
    --  end
    --end;
    
    interface.DialogTaskShow( private.task_current, "current_task" );

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  interface.InventoryOpen();
  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_task_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );
  
end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  interface.InventoryClose();
  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_task_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.Update ( state, task )
  ld.LogTrace( task, state )
  private.task_current = task;
  ObjSet( "int_button_task", { active = state, visible = state, input = state } );

end;
--******************************************************************************************
function public.Update_FromSetEventDone ( event_name )

  if ng_global.currentprogress == "scr" then
    return;
  end

  local ce = ng_global.currentprogress == "std" and "" or "ce_"

  for i = 1, #game.level_tasks do
    local val = game.level_tasks[i]
    if type( val ) == "string" then
      if val == event_name then
        interface.SetTask("leveltask_"..ce..i)
        return
      --elseif i == 1 and not ld.CheckRequirements( { val } ) then
      --  ld.LogTrace( event_name )
      --  interface.KeyTaskDone()
      end;
    elseif ld.TableContains( val, event_name ) and ld.CheckRequirements( { val[1] } ) then
      if ld.CheckRequirements( { val[2] } ) then
        interface.KeyTaskDone()
      --elseif i == 1 and not ld.CheckRequirements( { val[1] } ) then
      --  interface.KeyTaskDone()
      else
        interface.SetTask("leveltask_"..ce..i)
      end
      return
    end;
  end;
  
end;
