-- name=int_complex_inv_impl
--******************************************************************************************
local inv;
function public.Init()

  private.SHOW_ANIM_TIME = 0.5;
  private.SKIP_MOUSE_OVER_ANIM_TIME = 0.5;

  ObjSet( "btn_int_complex_inv_impl_close", {
    event_mdown  = int_complex_inv.Hide,
    event_menter = private.CloseMouseEnterAnim,
    event_mleave = private.CloseMouseLeaveAnim
  } );

  ObjSet( "obj_int_complex_inv_impl_exit", {
    event_mdown  = int_complex_inv.Hide,
    event_menter = private.ExitMouseEnterAnim,
    event_mleave = private.ExitMouseLeaveAnim
  } );

  ObjSet( "spr_int_complex_inv_impl_back", {
    event_mdown  = int_complex_inv.Hide
  } );


  if ng_global.currentprogress == "ext" then
    inv = "levelext_inv";
  else
    inv = "level_inv";
  end

end;
--******************************************************************************************
function public.ShowAnim( event_id )
  if not subroom.close_anim then
      ld.CloseSubRoom()
  end

  ld.LockCustom( "complex", 1 )

  local cmplx_obj = ""

  --SoundEnv( "aud_inventory_env", 1 )

  --ObjSet( int_complex_inv.GetCurrentName(), { bake = 1 } );
  --local trg = function () ObjSet( int_complex_inv.GetCurrentName(), { clear_bake = 1, bake = 0 } ); int_complex_inv.EventAnimEnd( event_id ); if cmplx_obj ~="" then if _G[inv][cmplx_obj.."_open"] then _G[inv][cmplx_obj.."_open"]() end end   end;
  local trg = function ()
    ld.LockCustom( "complex", 0 );
    int_complex_inv.EventAnimEnd( event_id );
    if cmplx_obj ~="" then
      common_impl.ZRMeventRun( "OpenBefore", int_complex_inv.GetCurrentName() )
      if _G[inv][cmplx_obj.."_open"] then 
        _G[inv][cmplx_obj.."_open"]();
      end;
      common_impl.ZRMeventRun( "OpenAfter", int_complex_inv.GetCurrentName() )
    end;
  end;
  local tme = private.SHOW_ANIM_TIME;
  ObjSet( "int_complex_inv", { input = true } );


  ObjAnimate( "int_complex_inv", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

  
  if int_complex_inv.GetCurrentName() ~= ""  then
    ObjSet( int_complex_inv.GetCurrentName(), {
      croprect_init = true,
      croprect_x    = - ( 0.5 * 1366  ),
      croprect_y    = - ( 0.5 * 768 ),
      croprect_w    = 1366,
      croprect_h    = 768} );

    ObjAnimate(int_complex_inv.GetCurrentName(),6,0,0,"",{0,0,0,0,tme,0,1,1})
    local pos_x = 0
    cmplx_obj = ld.StringDivide(int_complex_inv.GetCurrentName())[3]
  
    if ObjGet("hub_int_inventory_"..cmplx_obj) then
      local offset= ObjGet("hub_int_inventory_"..cmplx_obj).pos_x
      pos_x=-264+offset
    end
    ObjAnimate(int_complex_inv.GetCurrentName(), 3, 0, 0, "", {0,0,pos_x,384, tme,0,0,0} );
    
    common_impl.ZRMeventRun( "PreOpenBefore", int_complex_inv.GetCurrentName() )
    if _G[inv][cmplx_obj.."_preopen"] then
      _G[inv][cmplx_obj.."_preopen"]()
    end
    common_impl.ZRMeventRun( "PreOpenAfter", int_complex_inv.GetCurrentName() )

  end

end;
--******************************************************************************************
function public.HideAnim( event_id )
  local current_complex = interface.GetCurrentComplexInv()
  if not ObjGet(current_complex) then return end

  if ld.ZzCompleteCheck(current_complex,"get","~=") and not ld.ZzCompleteCheck(current_complex,"get") then
    for i,o in pairs(common_impl.hint) do
      if o.zz == current_complex and o.type == "get" and not ld.CheckRequirements( {i} )then
        _G[inv][i]()
      end
    end
  else
    local cmplx_obj = ""

    --SoundEnv( "aud_inventory_env", 0 )

    --ObjSet( int_complex_inv.GetCurrentName(), { bake = 1 } );
    local trg = function () 
      --ObjSet( int_complex_inv.GetCurrentName(), { clear_bake = 1, bake = 0 } ); 
      int_complex_inv.EventAnimEnd( event_id ); 

      common_impl.ZRMeventRun( "CloseBefore", current_complex )
      if cmplx_obj ~="" and _G[inv][cmplx_obj.."_close"] then 
        _G[inv][cmplx_obj.."_close"]() 
      end 
      common_impl.ZRMeventRun( "CloseAfter", current_complex )

    end;
    local tme = private.SHOW_ANIM_TIME;


    ObjAnimate( "int_complex_inv", "alp", 0, 0, trg,
    {
      0.0, 3, 1,
      tme, 3, 0
    } );
    
    if current_complex ~= ""  then
      ObjAnimate(int_complex_inv.GetCurrentName(),6,0,0,"",{0,0,1,1,tme,0,0,0})
      cmplx_obj = ld.StringDivide(current_complex)[3]

      common_impl.ZRMeventRun( "PreCloseBefore", current_complex )
      if _G[inv][cmplx_obj.."_preclose"] then
        _G[inv][cmplx_obj.."_preclose"]()
      end
      common_impl.ZRMeventRun( "PreCloseAfter", current_complex )

      ---- MiniGameHide ----
      local index = string.len(cmplx_obj);
      local name = cmn.current_mg or "";
      if ( ng_global.progress[ng_global.currentprogress]["win_"..name] ~= nil ) then
        if  ( cmn.IsEventStart( "win_"..name ) ) and ( not cmn.IsEventDone( "win_"..name )  ) then
          cmn.MiniGameHide( name );
        end;
      end;

      if ObjGet("hub_int_inventory_"..cmplx_obj) then
        local offset= ObjGet("hub_int_inventory_"..cmplx_obj).pos_x
        pos_x=-264+offset
      end
      ObjAnimate(int_complex_inv.GetCurrentName(), 3, 0, 0, "", {0,0,0,0, tme,0,pos_x,384} );
      


    end
  end
end;
--******************************************************************************************
function private.ExitMouseEnterAnim()

  SetCursor( CURSOR_DOWN );

  local obj = "spr_int_complex_inv_impl_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.ExitMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_complex_inv_impl_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.CloseMouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_complex_inv_impl_close_focus";

  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.CloseMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_complex_inv_impl_close_focus";

  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************