-- name=int_cube
--******************************************************************************************
function public.Init (pos_z)

  public.InCube = false

  ObjAttach( "int_cube", "inv_casket" );
  public.DIRECTION = -1;
  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;
  --ObjSet( "int_cube", { pos_z = pos_z } );

  --local 
  --ObjSet( "inv_casket", {
  --  event_mdown = function () public.MouseDown(); end,
  --  event_menter = function () public.MouseEnterAnim(); end,
  --  event_mleave = function () public.MouseLeaveAnim(); end
  --} );
  --for i = 1, 2 do
  --  ObjSet( "inv_cube"..i, {
  --    event_mdown = function () private.MouseDown(); end,
  --    event_menter = function () private.MouseEnterAnim(); end,
  --    event_mleave = function () private.MouseLeaveAnim(); end
  --  } );
  --end
  --MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  --private.WideScreenUpdate()

  cmn.AddSubscriber( "LevelLoaded", public.Load )

end;

--******************************************************************************************
function public.Destroy()

  --MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************


--******************************************************************************************
--function private.WideScreenUpdate()
--
--  
--    local offset = 0.5 * ( GetAppWidth() - 1024 );
--
--    ObjSet( "int_cube", { pos_x = ( public.DIRECTION * offset ) } );
--
--end;
--******************************************************************************************
function public.MouseDown()

--  if ObjGet( "spr_int_button_lock" ).alp == 1 then
--    PlaySfx( "assets/levels/common/audio/aud_closed_lock", 0, "", 0.0 )
--  else
--    PlaySfx( "assets/levels/common/audio/aud_unlocking", 0, "", 0.0 )
--  end;
--
--  int_button_lock.MouseDown()

  SoundSfx( "aud_clk_menu" )
  public.GoIn()

  ld.LogTrace( "Cube mdown" );

  --AnimPlay( "anm_int_cube_button", "cube_pasive", _ )

end;
--******************************************************************************************
function public.LockAnim( lock, event_id )
  -- lock: true or false
  --if lock then
  --  ObjSet( "spr_int_button_lock", { alp = 1 } );  
  --  ObjSet( "spr_int_button_lock_1", { alp = 0 } );  
  --else                                
  --  ObjSet( "spr_int_button_lock", { alp = 0 } );  
  --  ObjSet( "spr_int_button_lock_1", { alp = 1 } );  
  --end;

end;
--******************************************************************************************
function public.MouseEnterAnim()

--  int_button_lock.MouseEnter();
--
  if private.enabled then
    SetCursor( CURSOR_HAND );
    local obj = "anm_int_cube_button_light";
    ObjSet( obj, { playing = 1 } )
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );
  end

  --ld.LogTrace( "Cube menter" );
  --AnimPlay( "anm_int_cube_button", "cube_active", _ )

end;
--******************************************************************************************
function public.MouseLeaveAnim()

--  int_button_lock.MouseLeave();
--
  SetCursor( CURSOR_DEFAULT );

  if private.enabled then

    local obj = "anm_int_cube_button_light";
    local alp = ObjGet( obj ).alp;
    local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, function() ObjSet( obj, { playing = 0 } ) end,
    {
      0.0, 1, alp,
      tme, 1, 0
    } );
  end
  --ld.LogTrace( "Cube mleave" );
  --AnimPlay( "anm_int_cube_button", "cube_opened", _ )

end;
--******************************************************************************************
function public.Load()
  local prg = common_impl.SmartHint_GetNearestPrg_InMgHo( "mg_casket", "int_cube_load" )
  if prg and prg ~= "win_casket" then
    if prg:find( "^use" ) then
      if common_impl.SmartHint_IsInvItemUsable( common_impl.hint[ prg ].inv_obj ) then
        public.MakeActive()
      else
        public.MakePasive()
      end
    else
      public.MakeOpened()
    end;
  else
    public.MakePasive()
  end
  --ld.LogTrace( prg, public.GetState() )
end
--******************************************************************************************
function public.MakeActive()
  private.enabled = true
  if not private.Active then
    private.Active = true
    private.Opened = false
    private.Pasive = false
    interface.CheckInvPlusOnOff( "casket", true )
    ObjSet( "anm_int_cube_button", { animfunc = "cube_active", playing = 1, frame = 0 } )
  end
end
--******************************************************************************************
function public.MakeOpened()
  private.enabled = true
  if not private.Opened then
    private.Active = false
    private.Opened = true
    private.Pasive = false
    interface.CheckInvPlusOnOff( "casket", true )
    ObjSet( "anm_int_cube_button", { animfunc = "cube_opened", playing = 1, frame = 0 } )
  end
end
--******************************************************************************************
function public.MakePasive()
  private.enabled = false
  if not private.Pasive then
    private.Active = false
    private.Opened = false
    private.Pasive = true
    interface.CheckInvPlusOnOff( "casket", false )
    ObjSet( "anm_int_cube_button", { animfunc = "cube_pasive", playing = 0, frame = 0 } )
  end
end
--******************************************************************************************
function public.GetState()
  return { Active = private.Active; Opened = private.Opened; Pasive = private.Pasive; }
end;
--******************************************************************************************
function public.GoIn()
  if ObjGet( "int_cube_go_in_lock" ) then
    return
  else
    ld.StartTimer( "int_cube_go_in_lock", 0.05, function()  end )
  end;
  if not public.InCube then
    if common.GetCurrentSubRoom() then 
      ld.CloseSubRoom()
    elseif interface.GetCurrentComplexInv() ~= "" then
      common_impl.HideComplexItem()
    end
    common.CallRoomEventHandlers( "mg_casket" );
    cmn.GotoRoom( "mg_casket", need_fade, true )
    public.InCube = true
    --ObjSet( "obj_int_cube_button", { input = 0 } )
    --ObjAnimate( "obj_int_cube_button", 8,0,0, _, { 0,0,1, 0.3,0,0 } )
  else
    public.GoOut()
  end
end
--******************************************************************************************
function public.GoOut()
  if ObjGet( "int_cube_go_out_lock" ) then
    return
  else
    ld.StartTimer( "int_cube_go_out_lock", 0.05, function()  end )
  end;
  public.InCube = false
  cmn.GotoRoom( ng_global.progress[ ng_global.currentprogress ].common.currentroom )
  --ObjSet( "obj_int_cube_button", { input = 1 } )
  --ObjAnimate( "obj_int_cube_button", 8,0,0, _, { 0,0,0, 0.3,0,1 } )
end
--******************************************************************************************
function public.Return()
  --cmn.GotoRoom( ng_global.progress[ ng_global.currentprogress ].common.currentroom )
  public.InCube = false
  --ObjSet( "obj_int_cube_button", { input = 1 } )
  --ObjAnimate( "obj_int_cube_button", 8,0,0, _, { 0,0,0, 0.3,0,1 } )
end
--******************************************************************************************