--******************************************************************************************
function public.Init (pos_z)

  ObjAttach( "int_deploy_inv", interface.originhub );
  ObjSet( "int_deploy_inv", { pos_z = pos_z } );

  private.SHOW_ANIM_TIME = 1;
  private.SKIP_MOUSE_OVER_ANIM_TIME = 0.5;

  public.show = 0;
  public.show_obj = ""
  ng_global.deploy_show = public.show;
  ng_global.deploy_show_obj = public.show_obj;

  ObjSet("spr_int_deploy_inv_close", {
    event_mdown = function () private.HideAnim("hide"); end,
    event_menter = function () private.CloseMouseEnterAnim(); end,
    event_mleave = function () private.CloseMouseLeaveAnim(); end
  });

  ObjSet("int_deploy_inv_exit", {
    event_mdown = function () private.HideAnim("hide"); end,
    event_menter = function () private.ExitMouseEnterAnim();SetCursor( CURSOR_DOWN ); end,
    event_mleave = function () private.ExitMouseLeaveAnim();SetCursor( CURSOR_DEFAULT ); end
  });

  ObjSet("spr_int_deploy_inv_back", {
    event_mdown = function () private.HideAnim("hide") end
  });

end;
--******************************************************************************************
function public.Destroy()

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

  if ( event_id == "show" ) then

    public.show = 1;
    ng_global.deploy_show = public.show;

    ObjSet( "int_deploy_inv", { input = true } );

    ObjSet( public.show_obj, { input = true, active = true } );
    ng_global.deploy_show_obj = public.show_obj;

    if ng_global.progress[ ng_global.currentprogress ].common.buttonlock ~= 1 then

      --interface.InventoryAutoHideSet( 1 );

    end;

  elseif ( event_id == "hide" ) then

    public.show = 0;
    ng_global.deploy_show = public.show;
    ng_global.deploy_show_obj = public.show;

    ObjSet( "int_deploy_inv", { active = false, visible = false, input = false } );
    ObjAttach( public.show_obj,"__int_deploy_inv_rootobj");

    ObjSet( public.show_obj, { input = false, active = false } );

  end;

end;
--******************************************************************************************
function private.ShowAnim( event_id )

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  --interface.InventoryAutoHideSet( 0 );

  ObjAnimate( "int_deploy_inv", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function private.HideAnim( event_id )

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_deploy_inv", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function private.ExitMouseEnterAnim()

  SetCursor( CURSOR_DOWN );

  local obj = "int_deploy_inv_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.ExitMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "int_deploy_inv_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.CloseMouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_deploy_inv_close_focus";

  if (GetPerformanceMode() == 0)then

    obj = "pfx_int_deploy_inv_close_focus"; 
 
  end;

  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.CloseMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_deploy_inv_close_focus";

  if (GetPerformanceMode() == 0)then

    obj = "pfx_int_deploy_inv_close_focus"; 
 
  end;

  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.Show( inv_obj )

  local inv_obj = inv_obj;
  local event_id = "show";

  public.show_obj = "deploy_"..inv_obj;

  ObjSet( "int_deploy_inv", { active = true, visible = true, alp = 0 } );
  ObjAttach( "deploy_"..inv_obj, "int_deploy_inv" );
  ObjSet( "deploy_"..inv_obj, { pos_x = 0, pos_y = 0 } );

  private.ShowAnim( event_id );

end;
--******************************************************************************************
function public.Hide()

  local event_id = "hide";
  private.HideAnim( event_id );

end;
--******************************************************************************************