-- name=int_dialog_impl
--******************************************************************************************
function public.Init ()

  public.GRID_CORNER_W =  102;
  public.GRID_CORNER_H =  88;
  public.GRID_MID_W    =   0;
  public.GRID_MID_H    =   0;

  public.GRID_BORDER_W = 80;
  public.GRID_BORDER_H = 80;

  public.MIN_W = 220;
  public.MAX_W = 440;
  public.MIN_H = 150;
  public.MAX_H = 500;

  private.SHOW_ANIM_TIME = 0.3;
  ObjSet( "obj_dialog_transpanent", {
    event_mdown = int_dialog.MouseDown
  } );

  if _G[ "int_dialog" ] then
    private.int_dialog = {};
    private.int_dialog.Show = int_dialog.Show;
    int_dialog.Show = private.Show;
    private.pictures_added = {}
  end

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () int_dialog.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_dialog", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_dialog.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_dialog", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

end;
--******************************************************************************************
--вызывать в Open, добавляет картинку с описанием в инфо 
function public.PicturesAdd( dialog_text, obj )
  --добавляет к тексту инфо объект - картинку
  private.pictures_added[ dialog_text ] = private.pictures_added[ dialog_text ] or {}
  table.insert( private.pictures_added[ dialog_text ], obj )
end
--вызывать в Close, очищает инфо от картинок с описанием
function public.PicturesClear( dialog_text )
  --детачим добавленные картинки
  if private.pictures_added[ dialog_text ] and #private.pictures_added[ dialog_text ] > 0 then
    ObjSet( "txt_int_dialog", { disprawtext = false } );
    while #private.pictures_added[ dialog_text ] > 0 do
      ObjDetach( table.remove( private.pictures_added[ dialog_text ] ) )
    end
  end
end
--очистка
function private.PicturesDetach()
  for k, v in pairs( private.pictures_added ) do
    for kk, vv in ipairs( private.pictures_added[ k ] ) do
      ObjDetach( v )
    end
  end
end
--переписанный int_dialog.Show
function private.Show( dialog_text, dialog_pos_x, dialog_pos_y, extended )

  private.PicturesDetach();
  ObjSet( "txt_int_dialog", { disprawtext = false } );

  if private.pictures_added[ dialog_text ] and #private.pictures_added[ dialog_text ] > 0 then
    ObjSet( "txt_int_dialog", { text = dialog_text } );
    local text_obj = ObjGet( "txt_int_dialog" )
    local height = text_obj.draw_height;
    local width = text_obj.draw_width;
    local height_def = height;
    local heights = {}
    local widths = {}
    for k, v in ipairs( private.pictures_added[ dialog_text ] ) do
      ObjAttach( v, "grd_int_dialog" );
      heights[ k ] = ObjGet( v ).draw_height
      widths[ k ] = ObjGet( v ).draw_width
      height = height + heights[ k ]
      
      local d = ld.StringDivide( v )
      text_obj.name = nil;
      text_obj.text = nil;
      text_obj.align = 0;
      text_obj.maxwidth = width - widths[ k ];
      text_obj.pos_x = widths[ k ] / 2;

      local txt_picture = v:gsub( "^"..d[ 1 ], "txt" )
      if ObjGet( txt_picture ) and heights[ k ] > 10 then
        ObjSet( txt_picture, text_obj )
        while ObjGet( txt_picture ).draw_height > heights[ k ] do
          ObjSet( txt_picture, { fontsize = ObjGet( txt_picture ).fontsize - 1 } )
        end
      end
    end;

    local text = StringGet( dialog_text )
    ObjSet( "txt_int_dialog", { disprawtext = true } );
    while ObjGet( "txt_int_dialog" ).draw_height < height do
      text = text.."\n";
      ObjSet( "txt_int_dialog", { text = text } )
    end;

    local height_max = ObjGet( "txt_int_dialog" ).draw_height;

    local height_objs = 0
    for k, v in ipairs( private.pictures_added[ dialog_text ] ) do
      ObjSet( v, { 
        pos_x = - width / 2 + widths[ k ] / 2 ;
        pos_y = - height_max / 2 + height_def + height_objs + heights[ k ] / 2;
      } )
      height_objs = height_objs + heights[ k ]
    end;
  
    dialog_text = text

  end

  private.int_dialog.Show( dialog_text, dialog_pos_x, dialog_pos_y, extended )

end
--******************************************************************************************