-- name=int_dialog_task
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_dialog_task", interface.originhub );
  ObjSet( "int_dialog_task", { pos_z = pos_z } );

  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  MsgSubscribe( Command_Level_Pause, private.PauseLevel );
  
  
  public.show = false;
  public.hide = true;
  private.SHOW_ANIM_TIME = 2.0;
  private.SHOWED_TIME = 3.0;
  private.HIDE_ANIM_TIME = 0.5;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.POS_X = 667
  
  private.FuncEnd = nil;

  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.Hide(); end,
    alp = 0
  } );
  private.WideScreenUpdate()
end;
--******************************************************************************************
function public.Destroy()
  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  MsgUnsubscribe( Command_Level_Pause, private.PauseLevel );
end;
--******************************************************************************************
function private.AnimEnd( event_id )
 
  --ld.LockTask( 0 );

  if ( event_id == "show" ) then
  
    public.show = true;
    public.hide = false;
    ObjDelete("tmr_int_dialog_task_showing_timer");
    ld.StartTimer( "tmr_int_dialog_task_showing_timer", private.SHOWED_TIME, public.Hide )

  elseif ( event_id == "hide" ) then
  
    public.show = false;
    public.hide = true;
    -- ObjSet( "int_dialog_task", { input = false } );

    if ( private.FuncEnd ) then
  
      private.FuncEnd();
      private.FuncEnd = nil;

    end;

  end;

end;
--******************************************************************************************
function private.ShowAnim ( event_id, data )
  
  --local func_end = function () private.AnimEnd( event_id ); end;
  local func_end = function ()     

    
  end;
  local tme = private.SHOW_ANIM_TIME;
  private.TypeAnim( event_id, data );
  
  --ld.LockTask( 1 );
  
  --AnimPlay( "anm_int_task_show", "task", "" );

  --local p = GetObjPosByObj( "spr_int_button_task" )
  --ObjAnimate( "anm_int_task_show", "anim_pos_x",0,0, _, { 0,0,p[1]+171 } )
  --ObjAnimate( "anm_int_task_show", "anim_pos_y",0,0, _, { 0,0,p[2] } )

  ObjAnimate( "obj_int_dialog_task", "alp", 0, 0, func_end,
  {
    0, 3, ObjGet("obj_int_dialog_task").alp,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function private.TypeAnim ( event_id, data )

  local func_end = function () private.AnimEnd( event_id ); end;
  ObjSet( "txt_int_dialog_task_description", {text = "str_dialog_task_"..data.task} );
  ObjAnimate( "txt_int_dialog_task_description", 8, 0, 0, "", {0,0,0, 0.5,0,1} );
  common_impl.PrintText(
    "txt_int_dialog_task_description", 
    "str_dialog_task_"..data.task, 
    private.SHOWED_TIME, 
    func_end
  );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local func_end = function () private.AnimEnd( event_id ); end;
  local tme = private.HIDE_ANIM_TIME;

  --ld.LockTask( 1 );
  ObjAnimate( "obj_int_dialog_task", "alp", 0, 0, func_end,
  {
  0.0, 3, ObjGet("obj_int_dialog_task").alp,
    tme, 3, 0
  } );

end;
--*****************************************************************************************
function public.Show ( data )

  local event_id = "show";
  public.show = false;
  public.hide = false;
  --common_impl.HideDeployInv();

  private.Update( data );
  private.FuncEnd = data.func_end;
  private.ShowAnim( event_id, data );

end;
--******************************************************************************************
function public.Hide ()
  
  ObjDelete("tmr_int_dialog_task_showing_timer");
  public.show = false;
  public.hide = false;
  local event_id = "hide";
  private.HideAnim( event_id );


end;
--******************************************************************************************
function private.Update ( data )

  ObjSet( "txt_int_dialog_task_header", { text = "str_dialog_task_header_"..data.state } );
  --ObjSet( "txt_int_dialog_task_description", { text = "str_dialog_task_"..data.task } );
  ObjSet( "txt_int_dialog_task_description", { text = "" } );

end;
--******************************************************************************************
function private.WideScreenUpdate()
  if ( not GetWideScreen() ) then
    ObjSet( "obj_int_dialog_task",     { pos_x = private.POS_X     } );
  else
    local offset = 0.5 * ( GetAppWidth() - 1024 );
    ObjSet( "obj_int_dialog_task",     { pos_x = ( private.POS_X + offset ) } );
  end;  
end;
--******************************************************************************************
function private.PauseLevel( msg, param )
  if msg == "Command_Level_Pause" then
    ObjSet( "int_dialog_task", { active = 1 - param.pause } )
  end;
end