-- name=int_map_impl
--******************************************************************************************
function public.Init ()

  private.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;

  --прогресс, который не будет учитываться при отображении тасков
  private.prg_ignored = {
    "win_casket";
  }

  private.TimerInit()

  --if ng_global.currentprogress=="std" then
  public.map_rooms = 
    --[комната] =  {принадлежность к странице, заблокированность, комната назад }
    {
      --1--
      ["entrypoint"]      = {1,0,nil};
      ["hall"]            = {1,0,"entrypoint"};
      ["cabinet"]         = {1,0,"hall"};
      ["street"]          = {1,0,"entrypoint"},
      ["nearshop"]        = {1,0,"street"},
      ["shop"]            = {1,0,"nearshop"},
      ["mansion"]         = {1,0,"street"},
      ["river"]           = {1,0,"mansion"},

      --2--               
      ["workshop"]        = {2,0,nil},
      ["citystreets"]     = {2,0,"workshop"},
      ["jewelryshop"]     = {2,0,"citystreets"},
      ["secondfloor"]     = {2,0,"workshop"},
      ["bedroom"]         = {2,0,"secondfloor"},
      ["dressroom"]       = {2,0,"secondfloor"},

      --3--               
      ["newyard"]         = {3,0,nil},
      ["newhall"]         = {3,0,"newyard"},
      ["floor"]           = {3,0,"newhall"},
      ["attic"]           = {3,0,"floor"},
      ["backyard"]        = {3,0,"newhall"},
      ["chapel"]          = {3,0,"backyard"},

      --4--               
      ["entrypointext"]   = {4,0,nil},
      ["corridorext"]     = {4,0,"entrypointext"},
      ["dressingroomext"] = {4,0,"corridorext"},
      ["nearshopext"]     = {4,0,"entrypointext"},
      ["shopext"]         = {4,0,"nearshopext"},

      --5--               
      ["nearcastleext"]   = {5,0,nil},
      ["hallext"]         = {5,0,"nearcastleext"},
      ["seconfloorext"]   = {5,0,"hallext"},

      --["mousehole"]     = {1,0,"secretroom"},

     }

    --screen - { to screen, opn room }
    public.map_arrows = 
    {
      {1,0,"fake"};
      {1,2,"fake"};
      {2,1,"fake"};
      {2,3,"fake"};
      {3,2,"fake"};
      {3,4,"fake"};
      {4,3,"fake"};
      {4,5,"fake"};
    }  

  private.NewLocationShowed = private.NewLocationShowed or {}


  for i = 1, #public.map_arrows do
    local a = public.map_arrows[ i ]
    ObjSet( "spr_map_arrow_"..a[ 1 ].."_"..a[ 2 ], { 
      event_mdown = function() private.MapScreenChange( a[ 1 ], a[ 2 ] ) end;
      event_menter = function() private.MapScreenArrowEnter("spr_map_arrow_"..a[ 1 ].."_"..a[ 2 ]) end;
      event_mleave = function() private.MapScreenArrowLeave("spr_map_arrow_"..a[ 1 ].."_"..a[ 2 ]) end;
      alp = 0;
    } )
    ObjSet( "spr_map_arrow_"..a[ 1 ].."_"..a[ 2 ].."_light", { alp = 0 } )
  end

  for k, v in pairs( public.map_rooms ) do
    ObjSet( "spr_map_impl_"..k.."2", { 
      event_mdown = function() private.MapButtonEnter ( "spr_map_impl_"..k.."2", tostring( k ) ) end;
      --event_mleave = function() private.MapButtonLeave ( "spr_map_impl_"..k.."2", tostring( k ) ) end;
      --event_mdown  = function() private.MapButtonJump  ( k ) end;
      alp = 0;
    } )
    if #ObjGetRelations( "spr_map_impl_"..k.."2" ).childs == 1 then
      ObjSet( ObjGetRelations( "spr_map_impl_"..k.."2" ).childs[ 1 ], { 
        event_mdown = function() private.MapButtonEnter ( "spr_map_impl_"..k.."2", tostring( k ) ) end;
        --event_mleave = function() private.MapButtonLeave ( "spr_map_impl_"..k.."2", tostring( k ) ) end;
        --event_mdown  = function() private.MapButtonJump  ( k ) end;
        alp = 1;
      } )
    end
  end

      ObjSet( "obj_map_btn_close", { 
        event_mdown = function() private.MapButtonClose() end;
        event_menter = function() private.MapButtonEnter("spr_map_btn_close_focus") end;
        event_mleave = function() private.MapButtonLeave("spr_map_btn_close_focus") end;
      } );
      ObjSet( "obj_map_btn_exit", { 
        event_mdown = function() private.MapButtonClose() end;
        event_menter = function() private.MapButtonEnter("spr_map_btn_exit_focus") ld.ShCur(CURSOR_DOWN) end;
        event_mleave = function() private.MapButtonLeave("spr_map_btn_exit_focus") end;
      } );

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

  --public.grm_block_seting = {}

end;
--******************************************************************************************
function public.ShowAnim ( event_id )

  private.MapLockAll( 1 )
  
  
  if common.GetCurrentSubRoom() then
    ld.CloseSubRoom()
  elseif interface.GetCurrentComplexInv() ~= "" then
    common_impl.HideComplexItem();
  end;

  --PlayEnv( "assets/levels/common/audio/aud_map_env", 0, "", 0.5 );
  --SoundEnv( "aud_map_env", -1 )

  local trg = function() 
    private.MapLockAll( 0 ) 
    int_map.EventAnimEnd( '"..event_id.."' ); 
    private.ShowNewLocations()
    if ng_global.currentprogress == 'std' then 
      level.tutorial_map2.first()
    end 
  end

  local tme = private.SHOW_ANIM_TIME;
  
  private.MapScreenNow = false; --для отоброжения карты на странице с игроком
  if not private.MapScreenNow then
    local rm = ld.StringDivide( common.GetCurrentRoom() )[2];

    if rm == "casket" then
      rm = common.GetObjectName( ng_global.progress[ ng_global.currentprogress ].common.currentmaproom );
    end

    if  common_impl.hint[ "win_"..rm ] 
    and common_impl.hint[ "win_"..rm ].room 
    then
      rm = ld.StringDivide( common_impl.hint[ "win_"..rm ].room  )[2];
    end
    for k,v in pairs( public.map_rooms ) do
      if rm == k then
        private.MapScreenNow = v[1];
        break
      end
    end;
  end

  private.UpdateMap(private.MapScreenNow);

  SoundSfx( "aud_map_open" )

  ObjAnimate( "int_map", 8, 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim ( event_id )

  SndStop("assets/levels/common/audio/aud_map_env",0.5);

  local trg = function()
    int_map.EventAnimEnd( event_id );
  end;

  local tme = private.HIDE_ANIM_TIME;

  SoundSfx( "aud_map_close" )

  ObjAnimate( "int_map", 8, 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.UpdateGameMode ( msg, params )

  if ( params.mode == 3 and not ng_global.gamemode_custom[ "tasks" ] ) then
    
  end;

end;
  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************

function private.UpdateMap(screen)
  --local osclock = os.clock()

  screen = screen or 1

  -->> accelerator -->>
  if not private.progress_names then
    private.progress_names = ld.TableCopy( game.progress_names )
    private.map_rooms_not_opened = ld.TableCopy( public.map_rooms )
  end;
  private.opened_rooms = private.opened_rooms or {  }
  for k, v in pairs( private.map_rooms_not_opened ) do
    private.opened_rooms[ v[ 1 ] ] = private.opened_rooms[ v[ 1 ] ] or { inv_complex_inv = true }
    if ng_global.progress[ ng_global.currentprogress ][ "opn_"..k ] and ng_global.progress[ ng_global.currentprogress ][ "opn_"..k ].done == 1 then
      private.opened_rooms[ v[ 1 ] ][ "rm_"..k ] = true
      private.map_rooms_not_opened[ k ] = nil
    end;
  end
  while #private.progress_names > 0 and ng_global.progress[ ng_global.currentprogress ][ private.progress_names[ 1 ] ].done == 1 do
    table.remove( private.progress_names, 1 )
  end
  --<< accelerator --<<
  
  -->> detach old screen >>--
  if private.UpdateMapLastScreen then
    if private.UpdateMapLastScreen ~= screen then
      ObjAttach( "obj_map_impl_screen_"..private.UpdateMapLastScreen.."_root", "int_map_impl_obj_root" )
    end;
  end
  --<< detach old screen <<--

  -->> atach new screen >>--
  private.UpdateMapLastScreen = screen
  ObjAttach( "obj_map_impl_screen_"..private.UpdateMapLastScreen.."_root", "obj_map_impl_root" )
  --<< atach new screen <<--

  -->> change legend >>--
  if ng_global.gamemode < 2 or (ng_global.gamemode == 3 and ng_global.gamemode_custom.tasks ) then
    ObjSet( "spr_map_legend", { res = "assets/interface/resources/map/legend" } )
  else
    ObjSet( "spr_map_legend", { res = "assets/interface/resources/map/legend2" } )
  end
  --<< change legend <<--
  ------------------
  

--позиция игрока

    local prg=ng_global.currentprogress
    local player = "spr_map_impl_pointer_screen_player";
    local name_room = common.GetObjectName( ng_global.progress[ prg ].common.currentmaproom );
    local room_jump = "obj_map_impl_"..name_room.."_pointers";
    ObjAttach(player, room_jump)
    --local lvl = 1
    local lvl = screen

    local task_arr = {}
    for i,o in pairs(public.map_rooms) do
      if type(o[1]) ~= "string" then
        task_arr[i] = 0
        --if i == name_room then
        --  lvl = screen or o[1] 
        --end
      end
    end

---ВЫВОД СТРАНИЦЫ----------------------------------------------------------------------------------------
    for i,o in pairs(public.map_rooms) do
      if o[1] == lvl then
        local v = ( ng_global.progress[prg]["opn_"..i] and ng_global.progress[prg]["opn_"..i].done ) or 0
        if o[1] ~= lvl or o[2] == 1 then
          v = 0
        end
        ObjSet( "spr_map_impl_"..i, {input = v, visible = 1, alp = v == 0 and 0.5 or v} );

        local alp = v
        if private.NewLocationShowed[ "spr_map_impl_"..i ] then
          alp = 1
        end

        ObjSet( "obj_map_impl_"..i.."_pointers", { alp = alp } );
        ObjSet( "spr_map_impl_"..i.."_block", { alp = 1 - alp, input = 0 } );
      end
    end

 ----включение стрелок для перелистывания
    if public.map_arrows then
      for i = 1, #public.map_arrows do
        if public.map_arrows[i] then
          local a = public.map_arrows[ i ]
          if ng_global.progress[ prg ][ "opn_"..a[ 3 ] ] and ng_global.progress[ prg ][ "opn_"..a[ 3 ] ].done == 1 then
            ObjSet( "spr_map_arrow_"..a[ 1 ].."_"..a[ 2 ], { alp = 1 } )
          else
            ObjSet( "spr_map_arrow_"..a[ 1 ].."_"..a[ 2 ], { alp = 0 } )
          end;
          ObjSet( "spr_map_arrow_"..a[ 1 ].."_"..a[ 2 ].."_light", { alp = 0 } )
        end;
      end;
    end;
----

---Подсчет тасков----------------------------------------------------------------------------------------
    local logtrace_arr = {}
    function ld.MapAddCount(room,o) -- заполнение таблицы счетчиков
      room = ld.StringDivide(room)[2]
      if (room ~= "complex") and (not public.map_rooms[room]) then
        private.map_rooms_bad = private.map_rooms_bad or {}
        if not private.map_rooms_bad[room] then
          --ld.LogTrace( "WARNING: ld.MapAddCount >> "..room )
          private.map_rooms_bad[room] = true
        end
        return
      end;

      if room ~= "complex" then
        --DbgTrace(room)

        --ROOM IN ROOM !!!!
        --if public.map_rooms[room][3] and public.map_rooms[room][3] and type( public.map_rooms[room][3] ) =="string" then
        --  room = public.map_rooms[room][3]
        --end;
        --if not task_arr[room] then DbgTrace(room) end
        task_arr[room] = task_arr[room] + 1
      end
      if ng_global.progress[prg]["opn_"..room] then
        if ng_global.progress[prg]["opn_"..room].done == 1 then
            --ld.LogTrace( room.." | "..o );
            if not logtrace_arr[room] then
              logtrace_arr[room] = {}
            end
            table.insert(logtrace_arr[room],o)
        else
          --ld.LogTrace( o );
        end;
      else
          if room == "deploy" then
            --ld.LogTrace( room.." | "..o );
          end;
      end;
    end
   
    local obj

  common_impl.SmartHint_Refresh();
  local nearest_prg_in_room;
  local nearest_prg_room;
  for k, v in pairs( public.map_rooms ) do
    if screen == v[ 1 ] then
      nearest_prg_room = "rm_"..k;
      nearest_prg_in_room = common_impl.SmartHint_GetNearestPrg_InRoom( nearest_prg_room )
      if nearest_prg_in_room and ( not ld.TableContains( private.prg_ignored, nearest_prg_in_room ) ) then
        if  common_impl.hint[nearest_prg_in_room] 
        and common_impl.hint[nearest_prg_in_room].zz 
        and common_impl.hint[nearest_prg_in_room].zz == "mg_casket"
        then
          --МГ псевдо Деплой
        else
          ld.MapAddCount( nearest_prg_room, nearest_prg_in_room )
        end
      end
    end
  end;

  for i,o in pairs(public.map_rooms) do
    if type(o[1]) ~= "string" then
      local room = i
      local num = o[1]
      local lock = o[2]
      local obj_ytask = "spr_map_impl_"..room.."_pointer_screen_action"
      local obj_ntask = "spr_map_impl_"..room.."_pointer_screen_place"
      local obj_xtask = "spr_map_impl_"..room.."_pointer_screen_lock"
      local obj_puzzle = "spr_map_impl_"..room.."_pointer_screen_puzzle"
      ObjSet(obj_ytask,{alp=0})
      ObjSet(obj_ntask,{alp=0})
      ObjSet(obj_xtask,{alp=0})
      ObjSet(obj_puzzle,{alp=0})
      
      if task_arr[room]>0 then
        if ng_global.gamemode < 2 or (ng_global.gamemode == 3 and ng_global.gamemode_custom.tasks ) then
          ObjSet(obj_ytask,{alp=1})
          --ObjSet(obj_ntask,{alp=1})
        else
          ObjSet(obj_ntask,{alp=1})
        end
        if lock == 1 then 
          ld.LogTrace("map_error: locked room have tasks: "..room)  
        end  
      elseif task_arr[room]==0 then
        ObjSet(obj_ntask,{alp=1})
      elseif task_arr[room]<0  then
        ld.LogTrace("map_error: tasks below 0: "..room)
      end
      if lock == 1 then 
        ObjSet(obj_ytask,{alp=0})
        ObjSet(obj_xtask,{alp=1})
        ObjSet(obj_ntask,{alp=0})
      end
    end
  end

  private.MapPuzzleInit()


  for k, v in pairs( private.NewLocationShowed ) do
    ObjSet( k, { visible = 1, input = 1, alp = 1 } )
  end;

  --ld.LogTrace( "MapUpdateTime", os.clock() - osclock )
  ld.LogTrace( { message = "MapUpdate"; screen = screen; currentmaproom = ng_global.progress[ prg ].common.currentmaproom; } )

--вывод доступных тасков
  local map_task_finded = false;
  for i,o in pairs(logtrace_arr) do
    for j,k in ipairs(o) do
      local zz = (common_impl.hint[k].zz and " | "..common_impl.hint[k].zz) or ""
      ld.LogTrace( i..zz.." | "..k );
      map_task_finded = true;
    end
  end

  if not map_task_finded then
    ld.LogTrace( "ERROR: Map Not Have Tasks !" )
    ld.LogTrace( "private.map_rooms_not_opened", private.map_rooms_not_opened )
    ld.LogTrace( "private.opened_rooms", private.opened_rooms )
  end

end


  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************
  --******************************************************************************************

--function xxx()  end
function private.MapPuzzleInit()
    --public.map_rooms = 
    ----[комната] = {принадлежность к странице, заблокированность, принадлежность к блоку ( или "комнате" ), { прогресс открывающий доступ - для первой локи блока  }}
    --{
    --  ["room"]         = {1,1,1,{"opn_room"}};

    --common_impl.hint["puzzle1"]  = {room = "rm_museum",       zz_gate = "gzz_museum_stand",                zz= "zz_stand"}
  
--ng_global.achievements.puzzle[num]
  local alp
  --if ng_global.currentprogress ~= "std" then return end
  local alp_block = {}
  --local alp_zoom = {}
  if ng_global.gamemode < 2 or (ng_global.gamemode == 3 and ng_global.gamemode_custom.tasks ) then
    for i = 1, #ng_global.achievements.miniature do
      --ld.LogTrace( i )
      if ObjGet( "anm_morphcollect_"..i ) then
        local rm = ld.StringDivide( common_impl.ObjGetOwnerZzRmMgHo( "anm_morphcollect_"..i ) )[2]
        if not ng_global.achievements.miniature[i] then

          local rm = ld.StringDivide( common_impl.ObjGetOwnerZzRmMgHo( "anm_morphcollect_"..i ) )[2]
          local n = public.map_rooms[rm][3]

          --ld.LogTrace( i, rm )

          alp = 0
          if alp_block[rm] and alp_block[rm] == 1 then
            alp = 1
          else
            alp = ObjGet( "spr_map_impl_"..rm.."_pointer_screen_place" ).alp
            if alp == 0 then
              alp = ObjGet( "spr_map_impl_"..rm.."_pointer_screen_action" ).alp
            end
            if alp == 1 then
              alp_block[rm] = 1
            end
          end;
          --if not alp_zoom[rm] and alp == 1 then
          --  alp_zoom[rm] = 1
          --  --ld.LogTrace( hnt )
          --end;
          --ld.LogTrace( i, rm, alp )
          --alp = ObjGet( hnt.zz_gate ) and (ObjGet( hnt.zz_gate ).input and 1 or 0 ) or ObjGet( "spr_map_impl_screen_block_"..public.map_rooms[rm][3].."_pointer_block_place" ).alp
          local obj = "spr_map_impl_"..rm.."_pointer_screen_puzzle"
          if not ObjGet( obj ) then
            ObjCreate( obj, "spr" )
            ObjSet( obj, { res = "assets/interface/resources/map/pointer_screen_puzzle", pos_z = 3.5, input = 0 } )
            ObjAttach( obj, "obj_map_impl_"..rm.."_pointers" )
          end;
          ObjSet( obj, { alp = alp } )

        else
        --local rm = ld.StringDivide( common_impl.hint["puzzle"..i].room )[2]
        --local n = tonumber( public.map_rooms[rm][3] )
        --ObjSet( "spr_map_impl_screen_block_"..n.."_pointer_block_puzzle", { alp = alp_block[n] or 0 } )
        --ObjSet( "spr_map_impl_screen_block_"..n.."_pointer_prewiew_puzzle", { alp = alp_block[n] or 0 } )
        --ObjSet( "spr_map_impl_screen_block_"..rm.."_pointer_zoom_puzzle", { alp = alp_zoom[n] or 0 } )
          ObjSet( "spr_map_impl_"..rm.."_pointer_screen_puzzle", { alp = 0 } )
        end
      end
    end

    local puzzle_count = 1
    local div
    while common_impl.hint[ "puzzle"..puzzle_count ] do
      div = ld.StringDivide( common_impl.hint[ "puzzle"..puzzle_count ].room )
      if not ng_global.achievements.puzzle[ puzzle_count ] then
        alp_block[ div[ 2 ] ] = 1
      elseif not alp_block[ div[ 2 ] ] then
        alp_block[ div[ 2 ] ] = 0
      end
      puzzle_count = puzzle_count + 1
    end
    for k, v in pairs( alp_block ) do
      ObjSet( "spr_map_impl_"..k.."_pointer_screen_puzzle", { alp = v } )
    end

  else
    --for i = 1, #ng_global.achievements.miniature do
    --  if ng_global.achievements.miniature[i] 
    --  or ( ng_global.gamemode == 2 or (ng_global.gamemode == 3 and not ng_global.gamemode_custom.tasks ) ) then
    --    local rm = ld.StringDivide( common_impl.ObjGetOwnerZzRmMgHo( "anm_morphcollect_"..i ) )[2]
    --    ObjSet( "spr_map_impl_"..rm.."_pointer_screen_puzzle", { alp = 0 } )
    --  end
    --end
  end



end;






function private.AnimReverse( anim, animfunc, frame_max )
  if ObjGet( anim ).animfunc == animfunc or ObjGet( anim ).animfunc == "" then
    AnimPlay( anim, animfunc, _ )
  else
    local frame_now = ObjGet( anim ).frame
    AnimPlay( anim, animfunc, _ )
    ObjSet( anim, { frame = frame_max - frame_now, animfunc = animfunc, playing = 1 } )
  end;
end


------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
port.mapPopupRm = nil;
port.mapPopupObj = nil;
port.old_rm = nil;
port.old_obj = nil;

function private.MapButtonEnter ( obj, rm )

  if port.mapPopupRm and port.mapPopupObj then
    
    if rm == port.mapPopupRm and port.mapPopupObj == obj then
      private.MapButtonJump(rm);
    else
      ObjDelete("tmr_location_name_show_popup");
      private.MapButtonLeave ( port.mapPopupObj, port.mapPopupRm );
      ld.StartTimer( "tmr_location_name_show_popup_reEnter", 1, function()
        ObjDelete("tmr_location_name_show_popup_reEnter");  
        private.MapButtonEnter ( obj, rm );
      end );
    end;
  else
    if port.old_rm == rm and port.old_obj == obj then
      private.MapButtonJump(rm);
    else
      port.old_rm = rm;
      port.old_obj = obj;
    end;
    -- ld.PlayAudio( "sfx", "common/audio/aud_map1_env", 0);
    if obj == "spr_map_btn_exit_focus" then
      SetCursor(CURSOR_DOWN);
    elseif obj == "spr_map_btn_close_focus" then
      SetCursor(CURSOR_HAND);
      private.AnimReverse( "anm_map_btn_close", "out1", 60*0.4 )
    elseif rm then
      
      port.mapPopupRm = rm;
      port.mapPopupObj = obj;
      SetCursor(CURSOR_HAND)

      local anim = obj.."_magnifier"
      if not ObjGet( anim ) then
        local pos = ObjGet( "spr_map_magnifier" )
        ObjCreate(anim,"anim");
        ObjSet( anim, { res = "assets/interface/resources/map/anm_map"; input = 0; pos_x = -171, pos_z = pos.pos_z - 1 } )
        ObjAttach( anim, "obj_map_general" )

        ObjCreate(anim.."_child_spr","spr");
        ObjSet( anim.."_child_spr", { res = "assets/interface/resources/map/screen_"..private.UpdateMapLastScreen.."/"..rm.."3"; input = 0; anim_tag = "tag"; } )
        ObjAttach( anim.."_child_spr", anim )
      end;

      local o = ObjGet( "spr_map_legend" )
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, 0.35,3,0 } )
      end

      private.LocationNameShow( "pop_"..rm, 1 )
      private.AnimReverse( anim, "magnifer_on", 0.4*60 )
    end;

    local o = ObjGet( obj )
    if o then
      --local alp = 1
      --local scale = 1
      local t = ( 1 - o.alp ) * 0.35
      ObjAnimate( o.name, 8, 0, 0, "", { 0,0,o.alp,  t,3,1 });
      --local owner = o.name:sub( 0, o.name:len() - 1 )
      --local o = ObjGet( owner )
      --if o then
      --  --ObjAnimate( o.name, 6, 0, 0, "", { 0,0,o.scale_x,o.scale_x, t,2,scale,scale });
      --  for k, v in pairs( public.map_rooms ) do
      --    if v[ 1 ] == private.UpdateMapLastScreen then
      --      local o = ObjGet( "spr_map_impl_"..k )
      --      if o and o.name ~= owner then
      --        local c1 = o.color_r;
      --        local c2 = 0.9
      --        ObjAnimate( o.name, 12,0,0, "", { 0,0,c1,c1,c1, t,2,c2,c2,c2 } )
      --      end;
      --    end;
      --  end
      --end
    end
  end;
end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapButtonLeave ( obj, rm )

  SetCursor(CURSOR_DEFAULT);

  if obj == "spr_map_btn_exit_focus" then

  elseif obj == "spr_map_btn_close_focus" then
    local animfunc = ObjGet( "anm_map_btn_close" ).animfunc
    private.AnimReverse( "anm_map_btn_close", "out2", 60*0.4 )
  else
    if ObjGet( obj.."_magnifier" ) then
      local anim = obj.."_magnifier"
      private.AnimReverse( anim, "magnifer_off", 0.4*60 )
      --private.AnimReverse( anim.."_child", "magnifer_greed_off", 0.4*60 )

      local o = ObjGet( "spr_map_legend" )
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, 0.35,3,1 } )
      end

      private.LocationNameShow( "pop_"..rm, 0 )
      port.mapPopupRm = nil;
      port.mapPopupObj = nil;

    end
  end;

  local o = ObjGet( obj )
  if o then
    --local alp = 0
    --local scale = 0.96
    local t = ( o.alp ) * 0.35
    ObjAnimate( o.name, 8, 0, 0, "", { 0,0,o.alp,  t,3,0 });
    --local o = ObjGet( o.name:sub( 0, o.name:len() - 1 ) )
    --if o then
    --  --ObjAnimate( o.name, 6, 0, 0, "", { 0,0,o.scale_x,o.scale_x, t,2,scale,scale });
    --  for k, v in pairs( public.map_rooms ) do
    --    if v[ 1 ] == private.UpdateMapLastScreen then
    --      local o = ObjGet( "spr_map_impl_"..k )
    --      if o and o.name ~= owner then
    --        local c1 = o.color_r;
    --        local c2 = 1
    --        ObjAnimate( o.name, 12,0,0, "", { 0,0,c1,c1,c1, t,2,c2,c2,c2 } )
    --      end;
    --    end;
    --  end
    --end
  end
  
end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapButtonJump ( target_obj, force )
  local room = target_obj;
  if public.map_rooms[room][2] == 0 then -- not locked location check

      private.MapLockAll( 1, 1 )

        for i,o in pairs(public.map_rooms) do
          if type(o[1]) ~= "string" then
            ObjSet( "spr_map_impl_"..i, {input = 0} );
          end
        end
        
        ObjSet( "obj_map_impl_root", {input = 0});
        public.map_show = false;
        cmn.GotoRoom( "rm_"..room, _ )--, "map" );
        ld.StartTimer( "tmr_tmp_map_impl_jump_lock_relase", 1, function() private.MapLockAll( 0, 0 ) end )
        ld.StartTimer( "tmr_tmp_map_impl_jump", 0.5, function() int_map.Close(); private.MapActiveInterface(); end );

  end
  
end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapButtonClose()
  public.map_show = false;
  int_map.Close();
end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapActiveInterface()

  ObjSet( "obj_map_impl_root", {input = 1});

end;
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------


function private.MapScreenChange(from,to)
  if ObjGet( "spr_map_arrow_"..from.."_"..to ).alp == 1 then
    ld.Lock( 1 )

    -->> anims -->>
    local t = 0
    local ta = 0.15
    local ts = 0.05
    local sc = 1.05
    local anims = {}
    local names = {}
    for k, v in pairs( public.map_rooms ) do
      if v[ 1 ] == private.UpdateMapLastScreen then
        local o = ObjGet( "spr_map_impl_"..k )
        if o and o.input then
          table.insert( names, o.name )
          table.insert( anims, math.random( 1, #anims + 1 ), { { 0,0,1,1, t,0,1,1, t+ta,2,sc,sc }; { 0,0,1, t,0,1, t+ta,2,0 } } )
          t = t + ts
        end;
      end;
    end
    for i = 1, #names do
      ObjAnimate( names[ i ], 8,0,0, _, anims[ i ][ 2 ] )
      ObjAnimate( names[ i ], 6,0,0, _, anims[ i ][ 1 ] )   
    end;
    
    local arrow1 = ObjGet( "spr_map_arrow_"..private.UpdateMapLastScreen.."_"..( private.UpdateMapLastScreen - 1 ) )
    if arrow1 and arrow1.alp > 0 then
      ObjAnimate( arrow1.name, 8,0,0, function() ObjSet( arrow1.name, { alp = 1 } ) end, { 0,0,1, t+ta,0,0 } )
    end
    local arrow2 = ObjGet( "spr_map_arrow_"..private.UpdateMapLastScreen.."_"..( private.UpdateMapLastScreen + 1 ) )
    if arrow2 and arrow2.alp > 0 then
      ObjAnimate( arrow2.name, 8,0,0, function() ObjSet( arrow2.name, { alp = 1 } ) end, { 0,0,1, t+ta,0,0 } )
    end
    --<< anims --<<

    ld.StartTimer( t+ta, function() private.MapScreenChangeEnd(from,to) end )
    --ObjAnimate( "obj_map_impl_screen_"..from.."_root", 8,0,0, function() private.MapScreenChangeEnd(from,to) end, { 0,0,1, 0.35,0,0 } )
  else
    --public.map_arrows = 
    --{
    --  {1,0,"fake"};
    --  {1,2,"fountainpark"};
    --  {2,1,"outskirts"};
    --  {2,3,"oldcity"};
    --  {3,2,"underpass"};
    --  {3,4,"fake"};
    --}
    will_open = false
    for i, o in ipairs( public.map_arrows ) do
      if o[ 1 ] == from and o[ 2 ] == to and ObjGet( "rm_"..o[ 3 ] ) then
        will_open = true
        break
      end
    end
    if will_open then
      ld.ShowBbt( "map_screen_not_opened_yet" )
    end
  end
end;

function private.MapScreenChangeEnd(from,to)
  private.MapScreenNow = to
  ObjDetach("obj_map_impl_screen_"..from.."_root");
  private.UpdateMap(private.MapScreenNow)
  --ObjAnimate( "obj_map_impl_screen_"..to.."_root", 8,0,0, function() ld.Lock( 0 ) end, { 0,0,0, 0.35,0,1 } )
  ObjSet( "obj_map_impl_screen_"..from.."_root", { alp = 1 } )
  local t = 0
  local ta = 0.15
  local ts = 0.05
  local sc = 1.05
  local anims = {}
  local names = {}
  for k, v in pairs( public.map_rooms ) do
    if v[ 1 ] == private.UpdateMapLastScreen then
      local o = ObjGet( "spr_map_impl_"..k )
      if o and o.input then
        table.insert( names, o.name )
        table.insert( anims, math.random( 1, #anims + 1 ), { { 0,0,sc,sc, t,0,sc,sc, t+ta,2,1,1 }; { 0,0,0, t,0,0, t+ta,1,1 } } )
        t = t + ts
      end;
    end;
  end
  for i = 1, #names do
    ObjAnimate( names[ i ], 8,0,0, _, anims[ i ][ 2 ] )
    ObjAnimate( names[ i ], 6,0,0, _, anims[ i ][ 1 ] )   
  end;

  local arrow1 = ObjGet( "spr_map_arrow_"..private.UpdateMapLastScreen.."_"..( private.UpdateMapLastScreen - 1 ) )
  if arrow1 and arrow1.alp > 0 then
    ObjAnimate( arrow1.name, 8,0,0, function() ObjSet( arrow1.name, { alp = 1 } ) end, { 0,0,0, t+ta,0,1 } )
  end
  local arrow2 = ObjGet( "spr_map_arrow_"..private.UpdateMapLastScreen.."_"..( private.UpdateMapLastScreen + 1 ) )
  if arrow2 and arrow2.alp > 0 then
    ObjAnimate( arrow2.name, 8,0,0, function() ObjSet( arrow2.name, { alp = 1 } ) end, { 0,0,0, t+ta,0,1 } )
  end
  ld.StartTimer( t+ta, function() ld.Lock( 0 ) end )
end

function private.MapScreenArrowEnter(obj)
  if ObjGet( obj ).alp == 1 then
    ld.ShCur(CURSOR_HAND)
    local obj = obj.."_light";
    local a = ObjGet( obj ).alp;
    ObjAnimate( obj, 8,0,0, "", { 0,0,a, (1-a)/3,0,1 } )
  end
end;

function private.MapScreenArrowLeave(obj)
  if ObjGet( obj ).alp == 1 then
    ld.ShCur(CURSOR_DEFAULT)
    local obj = obj.."_light";
    local a = ObjGet( obj ).alp;
    ObjAnimate( obj, 8,0,0, "", { 0,0,a, a/3,0,0 } )
  end
end;

------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function private.MapLockAll( lock, close )
  --ld.LogTrace( "MapLockAll "..tostring(lock).." "..tostring(close) )
  if lock == 1 then
    ObjSet( "int_map_impl", {input = 0});
    ld.Lock( 1 )
  elseif lock == 0 then
    if not ObjGet("obj_int_button_map").input and not close then

    else
      ObjSet( "int_map_impl", {input = 1});
      ld.Lock( 0 )
    end
  end;
  if close == 1 then
    ObjSet( "obj_map_impl_button", {input = 0});
  elseif lock == 0 then
    ObjSet( "obj_map_impl_button", {input = 1});
  end;
end;

function private.ShowNewLocation( room, func )
  private.NewLocationShowed = private.NewLocationShowed or {}
  local o = ObjGet( "spr_map_impl_"..room )
  if not private.NewLocationShowed[ o.name ] then
    private.NewLocationShowed[ o.name ] = true;
    local t = 0.8
    ObjSet( o.name, { visible = 1, input = 1 } )
    ObjAnimate( o.name, 8,0,0, func, { 0,0,0.5, t,3,1 } )
  
    ObjAnimate( "obj_map_impl_"..room.."_pointers", 8,0,0, func, { 0,0,0, t,3,1 } )
    ObjAnimate( "spr_map_impl_"..room.."_block", 8,0,0, func, { 0,0,1, t,3,0 } )

  end
end

function private.ShowNewLocations()
  
  for k, v in pairs( public.map_rooms ) do
    if v[3] and not ld.CheckRequirements( { "opn_"..k } ) 
    and ng_global.progress[ ng_global.currentprogress ][ "opn_"..v[3] ] 
    and ng_global.progress[ ng_global.currentprogress ][ "opn_"..v[3] ].done == 1
    and ObjGet( "grm_"..v[3].."_"..k ) 
    and ObjGet( "grm_"..v[3].."_"..k ).input 
   then
      ld.LogTrace( "NEW BLOCK SHOWING",k )
      private.ShowNewLocation( k, func )
    end;
  end;

end;

function private.LocationNameShow( text_id, alp, animator )

  alp = alp or 1
  
  local text = StringGet( text_id );--.."asdfghjklqwertyuiopzxcvbnm"
  --DbgTrace("text_id:"..tostring(text_id).." text:"..tostring(text));
  local letter = " ";
  local count = 0;
  local o;
  local t = 0;
  local ta = 0.25;
  local ts = 0.025;
  

  while ne.utf8.Len(text) > 0 do
    count = count + 1;
    letter = ne.utf8.Sub(text, 1, 1 );
    text = ne.utf8.Sub(text, 2 );

    local obj = private.LocationLeterGet( text_id, count, letter )
    if alp == 1 then
      private.Timer( t, function()
      --ld.StartTimer( t, function() 
        local o = ObjGet( obj )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ta,1,1 } )
        ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, ta*0.75,2,1.5,1.15, ta,1,1,1 } )
      end )
    else
      private.Timer( t, function()
      --ld.StartTimer( t, function() 
        local o = ObjGet( obj )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ta,2,0 } )
        ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, ta*0.25,1,1.75,1.15, ta,2,0,0 } )
      end )
    end

    t = t + ts;

  end;

  if alp == 1 then
    ld.StartTimer( "tmr_location_name_show_animator_1", 4, function() private.LocationNameShow( text_id, 0, true ) end );
    ld.StartTimer( "tmr_location_name_show_animator_2", 4.15, function() private.LocationNameShow( text_id, 1, true ) end );
      
    ld.StartTimer( "tmr_location_name_show_popup", 4, function()
      ObjDelete("tmr_location_name_show_popup"); 
      if port.mapPopupRm and port.mapPopupObj then
        private.MapButtonLeave ( port.mapPopupObj, port.mapPopupRm );
      end;
    end );
  elseif not animator then
    ObjDelete( "tmr_location_name_show_animator_1" );
    ObjDelete( "tmr_location_name_show_animator_2" );
    port.mapPopupRm = nil;
    port.mapPopupObj = nil;
  end
  
  
  
end;

function private.TimerInit()
  if private.timer_buf then
    for k, v in ipairs( private.timer_buf ) do
      ObjDelete( v )
    end
    for k, v in ipairs( private.timer_act ) do
      ObjDelete( v )
    end
  end
  private.timer_cnt = 0
  private.timer_buf = {}
  private.timer_act = {}
  for i = 1, 125 do
    private.TimerCreate()
  end
end
  function private.TimerCreate()
    --ld.LogTrace( private.timer_cnt )
    local tmr = "tmr_int_map_impl_"..private.timer_cnt
    private.timer_cnt = private.timer_cnt + 1
    table.insert( private.timer_buf, tmr )
    common_impl.CopyObj("tmr_common_timer", tmr, "timer", "obj_map_impl_tmrs")
    ObjSet( tmr, { endtrig = nil; playing = 0; time = 999; active = 0; } )
  end
  function private.TimerGet()
    if #private.timer_buf > 0 then
      return table.remove( private.timer_buf )
    else
      private.TimerCreate()
      return private.TimerGet()
    end
  end
  function private.TimerReturn( tmr )
    ObjSet( tmr, { playing = 0 } )
    table.insert( private.timer_buf, 1, tmr )
  end
function private.Timer( t, func_end )
  local tmr = private.TimerGet()
  ObjAttach( tmr, "int_map_impl" )
  ObjSet( tmr, { time = t;  active = 1; endtrig = function ()
    func_end();
    private.TimerReturn( tmr );
  end, playing = 1 } );
end

function private.LocationLeterGet( text_id, letter_id, letter_txt )
  local txt = "txt_map_magnifier_letter_"..text_id.."_"..letter_id
  if not ObjGet( txt ) then
    local R = 136
    local FONTSIZE = 24
    local ANG_ADDER = 0.01
    local ang, pos_x, pos_y, o1, o2
    ObjCreate( txt, "text" )
    ObjSet( txt, { 
      res = "assets/fonts/georgia";
      display_outline = true;
      outline_size = 2;
      outline_color_r = 0;
      outline_color_g = 0;
      outline_color_b = 0;
      disprawtext = true;
      fontcolor_r = 254/255;
      fontcolor_g = 182/255;
      fontcolor_b = 055/255;
      fontsize = FONTSIZE;
      drawoff_y = -FONTSIZE / 2;
      text = letter_txt;
      scale_x = 0;
      scale_y = 0;
      alp = 0;
    } )
    ObjAttach( txt, "spr_map_magnifier" )

    if letter_id > 1 then
      o1 = ObjGet( "txt_map_magnifier_letter_"..text_id.."_"..( letter_id - 1 ) )
      if o1.text == "i" then
        o1.draw_width = o1.draw_width - 6;
      end
      if o1.text == "'" then
        o1.draw_width = o1.draw_width - 4;
      end
      o2 = ObjGet( "txt_map_magnifier_letter_"..text_id.."_"..( letter_id - 0 ) )
      if o2.text == "i" or o2.text == "'" then
        o2.draw_width = o2.draw_width - 4;
      end
      ang = o1.ang + math.pi * 0.5 - ( o1.draw_width + o2.draw_width - 2 ) / R / 4
    else
      ang = math.pi * 0.73
    end
    ang = ang - ANG_ADDER
    pos_x = 0 + R * math.cos( ang );
    pos_y = -2 - R * math.sin( ang );
    ObjSet( txt, { 
      ang = ang - math.pi * 0.5;
      pos_x = pos_x;
      pos_y = pos_y;
    } )
  end;
  ObjAttach( txt, "spr_map_magnifier" )
  return txt
end;
