-- name=int_panelscr
--******************************************************************************************
function public.Init(pos_z)
  ObjAttach( "int_panelscr", interface.originhub );
  ObjSet( "int_panelscr", { pos_z = pos_z } );

  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );  
  MsgSubscribe( Command_Level_Pause, private.PauseLevel );
   
  public.DELAY_TIME = 2.5;

  private.direction_timer    =      1;
  private.direction_ico      =     -1; 
  private.direction_close    =      1; 
  private.position_timer     =    434;
  private.position_ico       =   -345;  
  private.position_close       =    458;  
  private.SHOW_POSITION =   185;
  private.HIDE_POSITION = - 185;

  private.SHOW_TIME            = 0.6;
  private.MOUSE_OVER_ANIM_TIME = 0.3;

  
  private.WideScreenUpdate()
  
  ObjSet( "btn_panelscr", {
    event_mdown = function () private.MouseDown(); end,
    event_menter = function () private.MouseEnter(  ); end,
    event_mleave = function () private.MouseLeave(  ); end
  } );
  public.Enabled( false )
end;
--******************************************************************************************
function public.Destroy()
  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );  
  MsgUnsubscribe( Command_Level_Pause, private.PauseLevel );  
end
function public.SetExtended( type, params )

  -- Установка свойств объектов для текущего типа по заданным параметам.
 
end;
--******************************************************************************************
function public.Enabled( bool )
  ObjSet( "int_panelscr_root", { visible = bool, input = bool } )
end
--******************************************************************************************
function public.MouseDownClose() 
  public.GetTime()
   SoundSfx( "aud_clk_menu" );
  common_impl.SaveInterfaceTimers()
  --common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter,"rm_secretroomscr" )
  --rm_secretroomscr.GotoRoom("rm_secretroomscr")
  --rm_masterscr.go_back()
  SaveProfiles();
  SaveSettings();
    ng_global.is_scr = true;
    ng_global.MOD_MASTERSCR_GOTO_ROOM = false

    --ld.LogTrace( ng_global.progress[ "scr" ] )

    common.LevelSwitch( "menu", "game" )
end

function public.ShowAnim( event_id )

  local objname = "int_panelscr_root";

  local hide_position = private.HIDE_POSITION;
  local show_position = private.SHOW_POSITION;

  ObjSet( objname, { pos_x = hide_position } );

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_TIME;

  ObjAnimate( objname, "pos_x", 0, 0, trg,
  {
    0.0, 2, hide_position,
    tme, 2, show_position
  } );

  --SoundSfx( "aud_achievement_show" );
end;
--******************************************************************************************
function public.HideAnim( event_id )

  local objname = "int_panelscr_root";

  local hide_position = private.HIDE_POSITION;
  local show_position = private.SHOW_POSITION;

  local tme = private.SHOW_TIME;
  local trg = function () private.EventAnimEnd( event_id ); end;

  ObjAnimate( objname, "pos_x", 0, 0, trg,
  {
    0.0, 1, show_position,
    tme, 1, hide_position
  } );

  --SoundSfx( "aud_achievement_hide" );
end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

end
----------------------------------------------------------------------------------------------------
function public.ButtonMouseEnter( but_name )
  SoundSfx( "aud_guidance" );
  SetCursor( CURSOR_HAND );
  local obj = "spr_panelscr_panel_"..but_name.."_focus";
  if ObjGet( obj ) then
    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - alp ) ), 0, 1 } );
  end
end;
--------------------------------------------------------------------
function public.ButtonMouseLeave( but_name )

  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_panelscr_panel_"..but_name.."_focus";
  if ObjGet( obj ) then
    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME * alp ), 0, 0 } );
  end
end;
--******************************************************************************************
function private.WideScreenUpdate()
      local offset = 0.5 * ( GetAppWidth() - 1024 );
      local position_ico = private.position_ico
      local direction_ico = private.direction_ico
      ObjSet( "spr_panelscr_ico_panel", { pos_x = position_ico + ( direction_ico * offset ) } );

      --local position_timer = private.position_timer
      --local direction_timer = private.direction_timer
      --ObjSet( "spr_panelscr_timer_back", { pos_x = position_timer + ( direction_timer * offset ) } );
      
      local position_close = private.position_close
      local direction_close = private.direction_close
      ObjSet( "spr_panelscr_panel_close", { pos_x = position_close + ( direction_close * offset ) } );
 end;
--******************************************************************************************
function public.SetCurQuest(quest,param)
  if not private.CurQuestShowed then
    local o = ObjGet( "spr_panelscr_ico_panel_anm" )
    ObjSet( o.name, { pos_x = - o.draw_width } )
    private.SetCurQuestShow(quest,param)
  elseif private.CurQuestShowed == quest then
    private.SetCurQuestValues(quest,param)
  else
    private.SetCurQuestHide(quest,param)
  end
  private.CurQuestShowed = quest
end

function private.SetCurQuestValues(quest,param)
  --if ObjGet( "spr_panelscr_ico_panel_quest" ).res ~= "assets/interface/resources/int_panelscr/ico_task_"..quest then
    ObjSet( "spr_panelscr_ico_panel_quest", { res = "assets/interface/resources/int_panelscr/ico_task_"..quest } );
    ObjSet( "spr_panelscr_ico_panel_quest_gray", { res = "assets/interface/resources/int_panelscr/ico_task_"..quest.."_gray" } );
  --end
  ObjSet( "txt_panelscr_ico_panel", { text = param } );
  --public.SetCurQuestGray( private.CurQuestGrayNow )
end
--private.CurQuestGrayNow = false
function public.SetCurQuestGray( bool )
  local o = ObjGet( "spr_panelscr_ico_panel_quest_gray" )
  ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, 0.4,0,bool and 1 or 0 } )
end

function private.SetCurQuestHide(quest,param)
  local o = ObjGet( "spr_panelscr_ico_panel_anm" )
  --ld.LogTrace( "SetCurQuestHide", 1, quest,param )
  ObjAnimate( o.name, 0,0,0, function() if quest then private.SetCurQuestShow(quest,param) end end, { 0,0,o.pos_x, 0.4,2,-o.draw_width } )
  --ld.LogTrace( "SetCurQuestHide", 2, quest,param )
end

function private.SetCurQuestShow(quest,param)
  private.SetCurQuestValues(quest,param)
  local o = ObjGet( "spr_panelscr_ico_panel_anm" )
  ObjAnimate( o.name, 0,0,0, nil, { 0,0,o.pos_x, 0.4,2,0 } )
end

function public.StartTimer(time)
  --ld.LogTrace( "StartTimer", time )
  time = time or 0 
  ObjSet( "tmr_panelscr_timer_state", {playing=1,time=time} );
  public.SetTimer()
end

function public.SetTimer()
  local t_temp
  if ObjGet("tmr_panelscr_timer_state") then
    t_temp = ObjGet("tmr_panelscr_timer_state").time 
  --ld.LogTrace( "SetTimer", 1, t_temp )
  else 
    if not ng_global.progress then
      return
    end
    t_temp = ng_global.progress[ "scr" ].common.time
  --ld.LogTrace( "SetTimer", 2, t_temp )
  end

  local tm = math.floor(t_temp)
  
  if tm > 720 and not ng_global.progress[ "scr" ].common.failed_less_12min then 
    ObjSet( "tmr_panelscr_timer_state", {playing=0} );
    rm_masterscr.FailedLess12min()
  else 
    if tm>360 and not ng_global.progress[ "scr" ].common.failed_less_6min  then 
      rm_masterscr.FailedLess6min()
    end
    local tms = tm%60
    local tmm = math.tointeger( (tm-tms)/60 )
    --ld.LogTrace( "SetTimer", tmm, tms  )
    if tms<10 then tms = "0"..tms end
    if tmm<10 then tmm = "0"..tmm end
    ObjSet( "txt_panelscr_timer", {text = tmm..":"..tms} );
    ObjSet( "tmr_panelscr_timer_check", {time=1,playing=1,endtrig= function()public.SetTimer()  end} );
  end
end

function public.GetTime()
  ObjSet( "tmr_panelscr_timer_state", {playing = 0} );
  return ObjGet("tmr_panelscr_timer_state").time
end


function private.PauseLevel( msg, param )
  if msg == "Command_Level_Pause" then
    ObjSet( "int_panelscr", { active = 1 - param.pause } )
  end;
end


function public.AchMouseEnter( param )
  --local obj = "spr_panelscr_achimg_"..param
  interface.PopupShow( "str_achievement_"..param );
  --ObjAnimate( obj, "scale_xy", 0, 0, "", {0,0,ObjGet(obj).scale_x,ObjGet(obj).scale_y,0.3,0,1,1} );
  --SetCursor( CURSOR_HAND );

end;
--******************************************************************************************
function public.AchMouseLeave( param )

  interface.PopupHide()
  --local obj = "spr_panelscr_achimg_"..param
  --ObjAnimate( obj, "scale_xy", 0, 0, "", {0,0,ObjGet(obj).scale_x,ObjGet(obj).scale_y,0.3,0,0.8,0.8} );

end;
function public.AchMouseDown( param )
  interface.DialogShow( "str_achievement_"..param.."_description", 512, 384 );
end;



function public.TaskMouseDown()
  local params = ng_global.progress[ "scr" ].common.cur_quest
  -- interface.DialogShow( "str_task_scr_"..param, 512, 384 );
  interface.DialogTaskscr_Show(params)
end


function public.FailedAch(param)
  ld.LogTrace( "FailedAch", param )
  local f_end = function ()
    ObjSet("spr_panelscr_achimg_"..param,{res="assets/interface/resources/int_panelscr/scr_complete_"..( param:gsub( "^scr_", "" ) ) .."_fail"})
    ObjAnimate( "spr_panelscr_achimg_"..param, 8, 0, 0, "", {0,0,0, 0.3,0,1} );
  end
  ObjAnimate( "spr_panelscr_achimg_"..param, 8, 0, 0, f_end, {0,0,1, 0.3,0,0} );
end

function public.AnimPrgBar(func_end)
    local obj = "spr_panelscr_progress_bar_"..private.SetPrgBarNow
  SoundSfx( "aud_progress" );  
  if func_end then
    ld.Lock(1)
  end
  private.SetPrgBarNow = private.SetPrgBarNow + 1
  if private.SetPrgBarNow == 6 then
    private.SetCurQuestHide()
  end
  ObjAnimate( obj, "alp", 0, 0, func_end, {0,0,0, 0.5,0,1} );

end

function public.SetPrgBar( val )
  private.SetPrgBarNow = val
  local param = ng_global.progress[ "scr" ].common.cur_quest

  for i = 1, 6 do
    ObjSet( "spr_panelscr_progress_bar_"..i, { alp = i >= val and 0 or 1 } )
  end

  local ach_arr = 
  {"less_6min",
   "less_12min",
   "without_hint",
  }
  for i=1,3 do 
    local param = ach_arr[i]    
    if not ng_global.progress[ "scr" ].common["failed_"..param] then
      ObjSet("spr_panelscr_achimg_scr_"..param,{res="assets/interface/resources/int_panelscr/scr_complete_"..param})
    else 
      ObjSet("spr_panelscr_achimg_scr_"..param,{res="assets/interface/resources/int_panelscr/scr_complete_"..param.."_fail"})
    end
  end
  
  
end

