-- name=int_strategy_guide_impl
--******************************************************************************************
function public.Init()

  public.DIRECTION = 0;

  local TEXT_WIDTH_1 = 475;
  local TEXT_WIDTH_2 = 600;

  local IMAGE_COLUMN_1 = -85;
  local IMAGE_COLUMN_2 = 95;

  local IMAGE_ROW_1 = - 145;
  local IMAGE_ROW_2 =  0;
  local IMAGE_ROW_3 =   145;

  public.PAGE_CONTENT_DATA = {

    {
      text   =  { maxwidth = TEXT_WIDTH_2 },
      images =  {
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 }
                },
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_2 },
      images =  {
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 }
                }
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_2 },
      images =  {
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_3 }
                }
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_1 },
      images =  {
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 }
                }
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_1 },
      images =  {
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_3 }
                }
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_1 },
      images =  {
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_3 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_3 }
                }
    },
    [0] = 

    {
      text   =  { maxwidth = TEXT_WIDTH_2 },
    }


  };

  --private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet( "btn_int_strategy_guide_button_close", {
    event_mdown  = function () int_strategy_guide.ButtonCloseMouseDown(); end,
    event_menter = function () private.ButtonMouseEnterAnim( "btn_int_strategy_guide_button_close" ); end,
    event_mleave = function () private.ButtonMouseLeaveAnim( "btn_int_strategy_guide_button_close" ); end,
  } );
  ObjSet( "btn_int_strategy_guide_button_toc", {
    event_mdown  = function () int_strategy_guide.ButtonTOCMouseDown(); end,
    event_menter = function () private.ButtonMouseEnterAnim( "btn_int_strategy_guide_button_toc" ); end,
    event_mleave = function () private.ButtonMouseLeaveAnim( "btn_int_strategy_guide_button_toc" ); end,
  } );
  ObjSet( "btn_int_strategy_guide_button_gtips", {
    event_mdown  = function () int_strategy_guide.ButtonChapterMouseDown( 1 ); end,
    event_menter = function () private.ButtonMouseEnterAnim( "btn_int_strategy_guide_button_gtips" ); end,
    event_mleave = function () private.ButtonMouseLeaveAnim( "btn_int_strategy_guide_button_gtips" ); end,
  } );
  ObjSet( "btn_int_strategy_guide_button_next", {
    event_mdown  = function () int_strategy_guide.ButtonNextMouseDown(); end,
    event_menter = function () private.ButtonMouseEnterAnim( "btn_int_strategy_guide_button_next" ); end,
    event_mleave = function () private.ButtonMouseLeaveAnim( "btn_int_strategy_guide_button_next" ); end,
  } );
  ObjSet( "btn_int_strategy_guide_button_prev", {
    event_mdown  = function () int_strategy_guide.ButtonPrevMouseDown(); end,
    event_menter = function () private.ButtonMouseEnterAnim( "btn_int_strategy_guide_button_prev" ); end,
    event_mleave = function () private.ButtonMouseLeaveAnim( "btn_int_strategy_guide_button_prev" ); end,
  } );
  ObjSet( "wnd_int_strategy_guide_image", {
    event_mdown  = function () int_strategy_guide.ImageHide(); end,
    event_menter = function () SetCursor( CURSOR_DOWN ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end,
  } );
  for i = 1, 6 do
    ObjSet( "obj_int_strategy_guide_page_image_"..i, {
      event_mdown  = function () int_strategy_guide.ImageShow( i ); end,
      event_menter = function () private.ButtonMouseEnterAnim( "obj_int_strategy_guide_page_image_"..i, "grd" ); end,
      event_mleave = function () private.ButtonMouseLeaveAnim( "obj_int_strategy_guide_page_image_"..i, "grd" ); end,
    } );
  end;

  for j=1,8 do
    ObjSet( "obj_int_strategy_guide_toc_chapter_"..j, {
      event_menter = function () private.ButtonMouseEnterAnim( "spr_int_strategy_guide_toc_chapter_"..j  ); end,
      event_mleave = function () private.ButtonMouseLeaveAnim( "spr_int_strategy_guide_toc_chapter_"..j ); end,
    } );
  end

  common_impl.SetButtonTextColor({"txt_int_strategy_guide_button_close"}, nil, common_impl.ButtonTextOutlineColor())

  local function GetStringsList(string, n, postfix) 
    local result = {}
    postfix = postfix or ""
    for i = 1, n do
      result[i] = string..i..postfix
    end
    return result;
  end
  local titleSource = ObjGet("txt_int_strategy_guide_title")
  for i,o in ipairs(GetStringsList("txt_int_strategy_guide_toc_chapter_", 8, "")) do
    ObjSet( o, {res = titleSource.res, fontsize = titleSource.fontsize, color_r = titleSource.color_r, color_g = titleSource.color_g, color_b = titleSource.color_b} );
  end
  

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local obj = "int_strategy_guide_impl";
  local trg = function () int_strategy_guide.EventAnimEnd( event_id ); end;

  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 0, 0,
    0.6, 0, 1
  } );



end;
--******************************************************************************************
function public.HideAnim( event_id )

  local obj = "int_strategy_guide_impl";
  local trg = function () 
    int_strategy_guide.EventAnimEnd( event_id ); 
    ObjSet( "tmr_common_anm", { active = true } );
  end;

  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 0, 1,
    0.6, 0, 0
  } );

end;
--******************************************************************************************
function public.PageShowAnim( obj_name, event_id )

  local trg = function () int_strategy_guide.EventAnimEnd( event_id ); end;

  int_strategy_guide.StdPageShowAnimation( obj_name, trg );

end;
--******************************************************************************************
function public.PageHideAnim( obj_name, event_id )

  local trg = function () int_strategy_guide.EventAnimEnd( event_id ); end;

  int_strategy_guide.StdPageHideAnimation( obj_name, trg );

end;
--******************************************************************************************
function private.ButtonMouseEnterAnim( sender, focus_type )

  focus_type = focus_type or "spr";

  local focus = string.format( "%s_%s_focus", focus_type, interface.GetObjectName( sender ) );

  if ( sender == "btn_int_strategy_guide_button_toc") then
    --ObjSet( "txt_int_strategy_guide_button_toc", { fontcolor_r = 1,fontcolor_g = 1,fontcolor_b = 1 } );
  elseif ( sender == "btn_int_strategy_guide_button_close") then
    ObjSet( "txt_int_strategy_guide_button_close", {color_r = 1, color_g = 1, color_b = 1} );
  end;


  interface.ButtonMouseEnterAnim( sender, "alp", focus );


end;
--******************************************************************************************
function private.ButtonMouseLeaveAnim( sender, focus_type )

  focus_type = focus_type or "spr";

  local focus = string.format( "%s_%s_focus", focus_type, interface.GetObjectName( sender ) );

  if ( sender == "btn_int_strategy_guide_button_toc") then
    --ObjSet( "txt_int_strategy_guide_button_toc", { fontcolor_r = 0.737,fontcolor_g = 0.619,fontcolor_b = 1 } );
  elseif ( sender == "btn_int_strategy_guide_button_close") then
    local r,g,b = common_impl.ButtonTextColorLeave()
    ObjSet( "txt_int_strategy_guide_button_close", {color_r = r, color_g = g, color_b = b} );    
  end;

  interface.ButtonMouseLeaveAnim( sender, "alp", focus );

end;
--******************************************************************************************

