--******************************************************************************************
function public.Init()

  public.DIRECTION = 0;

  private.TASK_COLOR_R = 1.0;
  private.TASK_COLOR_G = 0.89411;
  private.TASK_COLOR_B = 0.78;

  private.TASK_MARKED_COLOR_R = 1.0;
  private.TASK_MARKED_COLOR_G = 0.705882;
  private.TASK_MARKED_COLOR_B = 0.368627;

  private.TASK_COMPLETED_COLOR_R = 0.552941;
  private.TASK_COMPLETED_COLOR_G = 0.454902;
  private.TASK_COMPLETED_COLOR_B = 0.443137;

  private.MOVE_ANIM_TIME      = 0.6;
  private.MOVE_ANIM_POS_Y_TOP = 714;
  private.MOVE_ANIM_POS_Y_BOT = 888;

  local pos_offset = - 15;
  private.TASKHEADER_MOVE_ANIM_TIME_BEG  = int_taskheader_impl.MOVE_ANIM_TIME_BEG;
  private.TASKHEADER_MOVE_ANIM_TIME_END  = int_taskheader_impl.MOVE_ANIM_TIME_END;
  private.TASKHEADER_MOVE_ANIM_POS_Y_TOP = int_taskheader_impl.MOVE_ANIM_POS_Y_TOP + pos_offset;
  private.TASKHEADER_MOVE_ANIM_POS_Y_BOT = int_taskheader_impl.MOVE_ANIM_POS_Y_BOT + pos_offset;

  ObjAttach( "obj_int_taskpanel_collect", InterfaceWidget_Top_Name );

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local obj = "int_taskpanel_impl";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  local beg_y = ObjGet( obj ).pos_y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 2, beg_y,--private.MOVE_ANIM_POS_Y_BOT,
    tme, 2, private.MOVE_ANIM_POS_Y_TOP
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local obj = "int_taskpanel_impl";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  local beg_y = ObjGet( obj ).pos_y; 

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 1, beg_y,--private.MOVE_ANIM_POS_Y_TOP,
    tme, 1, private.MOVE_ANIM_POS_Y_BOT
  } );

end;
--******************************************************************************************
function public.TaskHeaderShowAnim( event_id )

  ObjStopAnimate( "obj_int_taskpanel_collect", "pos_y" );
  ObjSet( "obj_int_taskpanel_collect", { pos_y = 0 } );

  local obj = "int_taskpanel_impl";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme_beg = private.TASKHEADER_MOVE_ANIM_TIME_BEG;
  local tme_end = private.TASKHEADER_MOVE_ANIM_TIME_END;

  local beg_y = ObjGet( obj ).pos_y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0,     0, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT,
    tme_beg, 0, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT,
    tme_end, 2, private.TASKHEADER_MOVE_ANIM_POS_Y_TOP
  } );

end;
--******************************************************************************************
function public.TaskHeaderHideAnim( event_id )

  local obj = "int_taskpanel_impl";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme_beg = ( private.TASKHEADER_MOVE_ANIM_TIME_END - private.TASKHEADER_MOVE_ANIM_TIME_BEG );
  local tme_end = private.TASKHEADER_MOVE_ANIM_TIME_END;

  local beg_y = ObjGet( obj ).pos_y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0,     0, beg_y,--private.TASKHEADER_MOVE_ANIM_POS_Y_TOP,
    tme_beg, 1, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT,
    tme_end, 0, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT
  } );

  ObjAnimate( "obj_int_taskpanel_collect", "pos_y", 0, 0, "",
  {
    0.0,     0, 0,
    tme_beg, 1, ( private.TASKHEADER_MOVE_ANIM_POS_Y_BOT - private.TASKHEADER_MOVE_ANIM_POS_Y_TOP )
  } );

end;
--******************************************************************************************
function private.CompleteTaskAnimEnd( task_name, task_count, event_id )

  local fx_task = task_name.."_effect_"..task_count;

  ObjCreate( fx_task, "partsys_pm" );
  ObjSet( fx_task, { res = "assets/interface/resources/fx/tasks" } );
  ObjAttach( fx_task, task_name );

  local trg_del = function () ObjDelete( fx_task ); end;
  ObjAnimate( fx_task, "alp", 0, 0, trg_del,
  {
    0.0, 0, 0,
    0.3, 0, 1,
    0.6, 0, 0
  } );

  local timer = "tmr_"..fx_task;
  ObjCreate( timer, "timer" );
  ObjAttach( timer, "int_taskpanel" );
  ObjSet( timer, {
    playing = true,
    time = 0.3,
    endtrig = function () int_taskpanel.EventAnimEnd( event_id ); ObjDelete( timer ); end
  } );

end;
--******************************************************************************************
function public.CompleteTaskAnim( item_name, task_id, task_count, event_id )

  local task_name = "obj_int_taskpanel_task_"..task_id;

  local trg = function () private.CompleteTaskAnimEnd( task_name, task_count, event_id ); end;

  local fx_item = item_name.."_effect_"..task_count;

  ObjCreate( fx_item, "partsys_pm" );
  ObjSet( fx_item, { res = "assets/interface/resources/fx/p_hint_selection" } );
  ObjAttach( fx_item, item_name );

  int_taskpanel.StdFlyAnimation( fx_item, task_name, function () ObjDelete( fx_item ); end );
  int_taskpanel.StdFlyAnimation( item_name, task_name, trg, 0.2 );

end;
--******************************************************************************************
function public.SetTask( task_id, task_params )

  local task_color_r = private.TASK_COLOR_R;
  local task_color_g = private.TASK_COLOR_G;
  local task_color_b = private.TASK_COLOR_B;

  if ( task_params.count < 1 ) then

    task_color_r = private.TASK_COMPLETED_COLOR_R;
    task_color_g = private.TASK_COMPLETED_COLOR_G;
    task_color_b = private.TASK_COMPLETED_COLOR_B;    

  end;

  if ( task_params.marked == 1 ) then

    task_color_r = private.TASK_MARKED_COLOR_R;
    task_color_g = private.TASK_MARKED_COLOR_G;
    task_color_b = private.TASK_MARKED_COLOR_B;

  end;

  local task_pattern = "str_int_taskpanel_pattern";

  if ( task_params.count > 1 ) then

    task_pattern = "str_int_taskpanel_pattern_multiple";

  end;

  ObjSet( "txt_int_taskpanel_task_"..task_id,
  {
    text   = task_pattern,
    param0 = task_color_r,
    param1 = task_color_g,
    param2 = task_color_b,
    param3 = StringGet( task_params.name ),
    param4 = task_params.count
  } );

end;
--******************************************************************************************
function public.UnmarkTaskAnim( task_id, event_id )

  local task_color_r = private.TASK_COLOR_R;
  local task_color_g = private.TASK_COLOR_G;
  local task_color_b = private.TASK_COLOR_B;

  ObjSet( "txt_int_taskpanel_task_"..task_id,
  {
    param0 = task_color_r,
    param1 = task_color_g,
    param2 = task_color_b
  } );

end;
--******************************************************************************************
function public.MarkTaskAnim( task_id, event_id )

  --

end;
--******************************************************************************************

