-- name=int_taskpanel_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;

  private.TASK_COLOR_R = 0.918;
  private.TASK_COLOR_G = 0.671;
  private.TASK_COLOR_B = 0.278;

  private.TASK_MARKED_COLOR_R = 0.427;
  private.TASK_MARKED_COLOR_G = 0.761;
  private.TASK_MARKED_COLOR_B = 0.996;



  private.TASK_COMPLETED_COLOR_R = 0.259;
  private.TASK_COMPLETED_COLOR_G = 0.259;
  private.TASK_COMPLETED_COLOR_B = 0.259;

  private.MOVE_ANIM_TIME     = 0.5;
  private.MOVE_ANIM_POS_Y_TOP = 691;
  private.MOVE_ANIM_POS_Y_BOT = 847;

  private.SetTaskDoneSpecialParam = "";

  private.ForceHide()
end;
function private.ForceHide()
  ObjSet( "int_taskpanel_impl", { pos_y = private.MOVE_ANIM_POS_Y_BOT } );
end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  ObjAnimate( "int_taskpanel_impl", "pos_y", 0, 0, trg,
  {
    0.0, 2, private.MOVE_ANIM_POS_Y_BOT,
    tme, 2, private.MOVE_ANIM_POS_Y_TOP
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local ho = ld.StringDivide( GetCurrentRoom() )[ 2 ]
  local trg = function () 
    public.SetTaskDoneSpecial( "" );
    int_taskpanel.EventAnimEnd( event_id );
    public.ShowTextPanel( ho )
  end;

  local tme = private.MOVE_ANIM_TIME;

  ObjAnimate( "int_taskpanel_impl", "pos_y", 0, 0, trg,
  {
    0.0, 1, private.MOVE_ANIM_POS_Y_TOP,
    tme, 1, private.MOVE_ANIM_POS_Y_BOT
  } );


end;
--******************************************************************************************
function public.CompleteTaskAnim( object_name, task_id, tsk_count, event_id )

  local trg = function() 
    ObjDetach( object_name ) 
    int_taskpanel.EventAnimEnd( event_id ); 
    ld.LockCustom( "TaskPanelTaskComplete", 0 );
  end;

  --ObjAnimate( object_name, "scale_xy", 0, 0, trg,
  --{
  --  0.0, 3, 1, 1,
  --  0.3, 3, 2, 2,
  --  0.9, 3, 0, 0
  --} );

  if ObjGet( object_name ) then

    --PlaySfx( "assets/levels/common/audio/aud_get_ho", 0, "", 0 )
    if not ObjGet( "tmr_int_taskpabel_impl_complete_task_anim" ) then
      PlaySfx( "assets/levels/common/audio/aud_get_ho", 0, "", 0.0 )
      ld.StartTimer( "tmr_int_taskpabel_impl_complete_task_anim", 0, function()  end )
    end

    local collect_pos = GetObjPosByObj( object_name, InterfaceWidget_Top_Name );
    local collect_drawoff_x = ObjGet( object_name ).drawoff_x;
    local collect_drawoff_y = ObjGet( object_name ).drawoff_y;
    
    local collect_name  = "pfx_int_taskpanel_collect_"..object_name;

    ObjAttach( object_name, InterfaceWidget_Top_Name );
    ObjSet( object_name ,{ pos_x = collect_pos[1], pos_y = collect_pos[2] });
    ObjDelete( collect_name )
    ObjCreate( collect_name, "partsys" );
    
    ObjSet( collect_name,
    {
      res = "assets/interface/resources/effects_ho",
      pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
      active = 1, visible = 1, input = 0, pos_z = 39
    } );
    ObjAttach( collect_name, InterfaceWidget_Top_Name );
    ObjSet(collect_name, {blendmode = 2});
    
    PartSysSetMaskObj( collect_name, object_name );  
    ObjAnimate( object_name, "alp",0,0, trg,
    { 
        0.0, 0, 1,
        0.3, 0, 1,
        0.6, 0, 0
    } );
    ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
  else
    trg();
  end

  ObjAnimate( "spr_int_taskpanel_task_"..task_id, "alp",0,0, "", 
  {
      0.0, 2, 0,
      0.3, 2, 1,
      0.6, 2, 0
  });  

  
end;
--******************************************************************************************
function public.ClearTasks()
  local task_id = 1
  while ObjGet( "txt_int_taskpanel_task_"..task_id ) do
    ObjSet( "txt_int_taskpanel_task_"..task_id,
    {
      param3 = "",
    } );
    task_id = task_id + 1
  end;
end;
--******************************************************************************************
function public.SetTask( task_id, task_params )

  local task_color_r = private.TASK_COLOR_R;
  local task_color_g = private.TASK_COLOR_G;
  local task_color_b = private.TASK_COLOR_B;

  if ( task_params.count < 1 ) then

    task_color_r = private.TASK_COMPLETED_COLOR_R;
    task_color_g = private.TASK_COMPLETED_COLOR_G;
    task_color_b = private.TASK_COMPLETED_COLOR_B;    

  end;

  if ( task_params.marked == 1 ) then

    task_color_r = private.TASK_MARKED_COLOR_R;
    task_color_g = private.TASK_MARKED_COLOR_G;
    task_color_b = private.TASK_MARKED_COLOR_B;

  end;

  local task_pattern = "str_int_taskpanel_pattern";

  if ( task_params.count > 1 ) then

    task_pattern = "str_int_taskpanel_pattern_multiple";

  end;

  local task_text = task_params.name;
  local divide = ld.StringDivide( task_text )
  if ng_global.currentprogress == "scr" and divide[ 2 ]:find( "scr$" ) then
    divide[ 2 ] = divide[ 2 ]:gsub( "scr$", "" );
    task_text = divide[ 1 ]
    for i = 2, #divide do
      task_text = task_text.."_"..divide[ i ];
    end;
  end

  if ( task_params.count < 1 ) then
    task_text = task_text..private.SetTaskDoneSpecialParam  
  end;

  ObjSet( "txt_int_taskpanel_task_"..task_id,
  {
    text   = task_pattern,
    param0 = task_color_r,
    param1 = task_color_g,
    param2 = task_color_b,
    param3 = StringGet( task_text ),
    param4 = task_params.count
  } );

end;
--******************************************************************************************
function public.SetTaskDoneSpecial( param )
  --будет добавлен к йд текста выполненого таска
  --нужно вызывать перед показом панели и в клосе ХО
  private.SetTaskDoneSpecialParam = param
end
--******************************************************************************************
function public.UnmarkTaskAnim( task_id, event_id )

  local task_color_r = private.TASK_COLOR_R;
  local task_color_g = private.TASK_COLOR_G;
  local task_color_b = private.TASK_COLOR_B;

  ObjSet( "txt_int_taskpanel_task_"..task_id,
  {
    param0 = task_color_r,
    param1 = task_color_g,
    param2 = task_color_b,
  } );

end;
--******************************************************************************************
function public.MarkTaskAnim( task_id, event_id )

  --

end;
--******************************************************************************************
function private.TaskDestroy()
  for i=1,12 do 
      ObjSet( "txt_int_taskpanel_task_"..i,{text= ""} );
  end
end
--******************************************************************************************
function public.HideTextPanel( ho_name )

  if private.HideTextPanelNow then return end;

  private.HideTextPanelNow = true

  ObjSet( "obj_int_taskpanel", { visible = false } ); 

  local o1 = ObjGet( "obj_"..ho_name.."_taskpanel" )
  local o2 = ObjGet( "int_taskpanel_impl" )
  ObjSet( o1.name, { pos_x = o1.pos_x - o2.pos_x; pos_y = o1.pos_y - private.MOVE_ANIM_POS_Y_TOP; visible = 1; input = 1; } )

  ObjAttach( "obj_"..ho_name.."_taskpanel", "int_taskpanel_impl" );

end;
--******************************************************************************************
function public.ShowTextPanel( ho_name )

  local o1 = ObjGet( "obj_"..ho_name.."_taskpanel" )
  if not private.HideTextPanelNow or not o1 then return end;
  private.HideTextPanelNow = false

  ObjSet( "obj_int_taskpanel", { visible = true } );

  local o1 = ObjGet( "obj_"..ho_name.."_taskpanel" )
  local o2 = ObjGet( "int_taskpanel_impl" )
  ObjSet( o1.name, { pos_x = o1.pos_x + o2.pos_x; pos_y = o1.pos_y + private.MOVE_ANIM_POS_Y_TOP; visible = 0; input = 0; } )

  ObjDetach( "obj_"..ho_name.."_taskpanel" );

end;
--******************************************************************************************
function public.GetTaskColors()
  return { color_r = private.TASK_COLOR_R; color_g = private.TASK_COLOR_G; color_b = private.TASK_COLOR_B; }
end
--******************************************************************************************
function public.GetTaskMarkedColors()
  return { color_r = private.TASK_MARKED_COLOR_R; color_g = private.TASK_MARKED_COLOR_G; color_b = private.TASK_MARKED_COLOR_B; }
end
--**
--******************************************************************************************
function public.GetTaskCompletedColors()
  return { color_r = private.TASK_COMPLETED_COLOR_R; color_g = private.TASK_COMPLETED_COLOR_G; color_b = private.TASK_COMPLETED_COLOR_B; }
end
--**
--******************************************************************************************