-- name=ho_elfho
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "elfho" );
  game.relations[ "ho_elfho" ].exitroom = "rm_river";
  
  
  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";
  
  private.abc2num = {};
  private.abc2num["aaa"]  = 1;
  private.abc2num["bbb"]  = 2;
  private.abc2num["ccc"]  = 3;
  private.abc2num["ddd"]  = 4;
  private.abc2num["eee"]  = 5;
  private.abc2num["fff"]  = 6;
  private.abc2num["ggg"]  = 7;
  private.abc2num["hhh"]  = 8;
  private.abc2num["iii"]  = 9;
  private.abc2num["jjj"] = 10;
  private.abc2num["kkk"] = 11;
  
  
  
  --------------------------------------------------------------------------------------------------
  private.vid_grumpy_static_list = {
    "vid_elfho_grumpy_static_01";
    "vid_elfho_grumpy_static_02";
    "vid_elfho_grumpy_static_03"
  }
  ld.VidStaticInit( 
    private.vid_grumpy_static_list,
    "ho_elfho",
    { _, _, _},
    {3,6}, 
    false, 
    false, 
    sfx_rnd, 
    "obj_elfho_enemy"
  )
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_elfho" ] = { type = "win", room = "rm_river", zz = "ho_elfho", zz_gate = "gho_river_elfho" };
 
  local win_elfho_func = function ()

    if ( cmn.IsEventDone( "win_elfho" ) ) then
      interface.InventoryItemAdd( "inv_goodbrooch", "spr_elfho_win" );
      ObjDelete( "gho_river_elfho" );
    end;

  end;
  cmn.AddSubscriber( "win_elfho", win_elfho_func );
  
  local unmark_bbb = function () 
    ObjSet( "spr_elfho_bbb", { input = 1 , visible=1} );
    ObjDelete("obj_elfho_unmark_bbb")
    ObjDelete("anm_elfho_anim_box")
  end;
  cmn.AddSubscriber( "elfho_unmark_bbb", unmark_bbb, "ho_elfho" );
  
  local unmark_hhh = function () 
    ObjSet( "spr_elfho_hhh", { input = 1 , visible=1} );
    ObjDelete("obj_elfho_unmark_hhh")
    ObjDelete("anm_elfho_anim_chalk")
    ObjDelete("spr_elfho_hhh_part_1")
    ObjDelete("spr_elfho_hhh_part_1_shadow")
  end;
  cmn.AddSubscriber( "elfho_unmark_hhh", unmark_hhh, "ho_elfho" );
  
  local unmark_jjj = function () 
    ObjSet( "spr_elfho_jjj", { input = 1 , visible=1} );
    ObjDelete("obj_elfho_unmark_jjj")
    ObjDelete("anm_elfho_anim_lock")
    ObjDelete("spr_elfho_jjj_part_2")
    ObjDelete("spr_elfho_jjj_part_2_shadow")
  end;
  cmn.AddSubscriber( "elfho_unmark_jjj", unmark_jjj, "ho_elfho" );
  
  
  
  
  local start_elfho_func = function ()
    if not cmn.IsEventDone("win_elfho") then
      common_impl.ProcessHoStart( "elfho" );
      
      if cmn.IsUnmarkedTask("elfho","bbb") then
        unmark_bbb()
      end
      if cmn.IsUnmarkedTask("elfho","hhh") then
        unmark_hhh()
      end
      if cmn.IsUnmarkedTask("elfho","jjj") then
        unmark_jjj()
      end
      
      local ho_found = ng_global.progress[ "std" ][ "win_elfho" ].found;
      for i = 1, #ho_found do
        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );
      end;
    end
  end;
  cmn.AddSubscriber( "win_elfho", start_elfho_func, "ho_elfho" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  
  local L = #private.abc;
  private.L = L;
  private.count = 0;
  local ang_step = 360/(L);
  local x0 = ObjGet("obj_elfho_enemy") and ObjGet("obj_elfho_enemy").pos_x or 0;
  local y0 = ObjGet("obj_elfho_enemy") and ObjGet("obj_elfho_enemy").pos_y or 0;
  local R = 250/2;
  local scale = 0.55;
  private.scale = scale;

  SoundEnv( "aud_river_env" )
  SoundEnv( "aud_elfho_env", 1 )

  if ( not cmn.IsEventDone( "opn_elfho" ) ) then
    cmn.InitHo( "elfho" );
    
    cmn.SetMarkedTask( "elfho", "bbb" );
    cmn.SetMarkedTask( "elfho", "hhh" );
    cmn.SetMarkedTask( "elfho", "jjj" );
    
    cmn.SetEventDone( "opn_elfho" );
    
    ng_global.progress[ "std" ][ "win_elfho" ].state = {}
    for l=1,L do
      ng_global.progress[ "std" ][ "win_elfho" ].state[l] = 0;
    end
  end;

  for l = 1,L do
    local name = "obj_elfho_lock_"..l;
    local ang = ang_step*(l-1);
    ang = ang*math.pi/180;
    local x = R*math.cos(ang) + x0;
    local y = R*math.sin(ang) + y0;
    --ObjSet(name,{pos_x=x,pos_y=y,scale_x=scale,scale_y=scale})
    ObjSet(name,{scale_x=scale,scale_y=scale})
    
    ObjSet("spr_elfho_snowball_light_"..l,{pos_z=1})
    
    private.set_lock(l)
    
    
    --if ng_global.progress[ "std" ][ "win_elfho" ].state[l] == 1 then
    --  local o = ObjGet("spr_elfho_snowball_"..private.abc[l])
    --  ObjSet("spr_elfho_"..private.abc[l],{pos_x=o.pos_x, pos_y=o.pos_y,res=o.res,inputrect_init=false,alp=1})
    --  ObjSet("itm_elfho_"..private.abc[l],{res=ObjGet("spr_elfho_snowballinv").res})
    --end
    --if ng_global.progress[ "std" ][ "win_elfho" ].state[l] == 2 then
    --  ObjSet("spr_elfho"..private.abc[l],{visible=0,input=0})
    --end
    
  end
  
  
  
  
  
  local ho_items = {};
  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_elfho_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_elfho_bbb","obj_elfho_unmark_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_elfho_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_elfho_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_elfho_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_elfho_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_elfho_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_elfho_hhh","obj_elfho_unmark_hhh","spr_elfho_hhh_part_1"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_elfho_iii"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_elfho_jjj","obj_elfho_unmark_jjj","spr_elfho_jjj_part_2"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_elfho_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_elfho_lll"}); 
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items ); 

  
  local count = 0;
  for n=1,private.L do
    if ng_global.progress[ "std" ][ "win_elfho" ].state[n]==1 then
      count=count+1;
    end  
  end
  if count==3 then
    ObjSet("spr_elfho_shield_cleft_01",{alp=1})
  elseif count==6 then
    ObjSet("spr_elfho_shield_cleft_02",{alp=1})
  elseif count==9 then
    ObjSet("spr_elfho_shield_cleft_03",{alp=1})
  elseif count==11 then
    ObjSet("spr_elfho_lll",{visible=1,active=1,input=1});
    ObjDelete("obj_elfho_enemy")
    ObjDelete("obj_elfho_shieldbbt")
  end
  
end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.ItemPanelHide();
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.DialogHo_Show();
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.TaskComplete( task_name )
  
  
  ld.Lock(1)
  local l = private.abc2num[task_name];
  local task_obj = "spr_elfho_"..task_name;
  local t = 0.5;
  
  local func_end = function()
    ng_global.progress[ "std" ][ "win_elfho" ].state[l]=1;
    ObjSet(task_obj,{ res = ObjGet("spr_elfho_snowball_"..task_name).res, visible=1,pos_z=40, alp=1 ,  pos_x = ObjGet("obj_elfho_lock_"..l).pos_x, pos_y = ObjGet("obj_elfho_lock_"..l).pos_y,  scale_x=private.scale,scale_y=private.scale  })
    cmn.HoItemFind("spr_elfho_"..task_name,"itm_elfho_"..task_name);
    private.set_lock(l);
    
    
    ObjDetach("vid_elfho_grumpy_block");
    ld.VidStaticPlay( private.vid_grumpy_static_list )
    
    local count = 0;
    for n=1,private.L do
      if ng_global.progress[ "std" ][ "win_elfho" ].state[n]==1 then
        count=count+1;
      end  
    end
    
    
    if count==11 then
      local func_end_end = function()
        ObjDelete("obj_elfho_shieldbbt")
        ObjDelete("obj_elfho_enemy")
        ObjSet("spr_elfho_lll",{visible=1,active=1,input=1})
        ld.Lock(0)
      end
      
      --
      SoundEnv( "aud_elfho_env", 0 )
      --ld.VidStaticDetach( private.vid_grumpy_static_list );
      ObjAttach("vid_elfho_grumpy_disappeared","ho_elfho");
      SoundSfx( "aud_goblin_disappeared" )
      VidPlay("vid_elfho_grumpy_disappeared", func_end_end )
      ObjAnimate("obj_elfho_enemy", 8, 0, 0, "", {0,0,1, 0.5,0,0});
      
    else
      ld.Lock(0);
    end
  end
  local func_step_1 = function()  
    SoundSfx( "aud_snowball_to_elf" )
    ld.AnimPlay("anm_elfho_anim_snowball","anim_snowball","");
    
    ld.VidStaticDetach( private.vid_grumpy_static_list );
    ObjAttach("vid_elfho_grumpy_block","obj_elfho_enemy");
    ld.StartTimer( 0.2, function() VidPlay("vid_elfho_grumpy_block",func_end) end);
    
    ld.StartTimer(0.55, function()
      
      local count = 1;
      for n=1,private.L do
        if ng_global.progress[ "std" ][ "win_elfho" ].state[n]==1 then
          count=count+1;
        end  
      end
      if count==3 then
        ObjSet("spr_elfho_shield_cleft_01",{alp=1})
      elseif count==6 then
        ObjSet("spr_elfho_shield_cleft_02",{alp=1})
      elseif count==9 then
        ObjSet("spr_elfho_shield_cleft_03",{alp=1})
      end
    
      end
    )
      
  end

  private.sparkle(task_obj);
  ObjAnimate(task_obj, 8, 0, 0, func_step_1, {0,0,1, 1,0,0});
end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------











----------------------------------------------------------------------------
function private.set_lock(l)
  
  local count = 0;
  
  if ng_global.progress[ "std" ][ "win_elfho" ].state[l]==1 then  
    count = count + 1;
  --if private.done[ private.abc[l] ] then
    ObjDelete("obj_elfho_lock_"..l)
    --ObjSet("spr_elfho_snowball_"..l,{visible=0})
    --ObjSet("spr_elfho_snowball_light_"..l,{visible=0})
    --ObjSet("spr_elfho_snowball_chek_red_"..l,{visible=1})
    --ObjAnimate("spr_elfho_snowball_chek_red_"..l, 12, 1, 0, "", {0,0,1,1,1,  0.3,0,0.7,0.7,0.7,  1+l/20,0,1,1,1});
  else
    ObjSet("spr_elfho_snowball_"..l,{visible=1})
    ObjSet("spr_elfho_snowball_light_"..l,{visible=1})
    ObjSet("spr_elfho_snowball_chek_red_"..l,{visible=0})
    ObjAnimate("spr_elfho_snowball_light_"..l, 8, 1, 0, "", {0,0,1,  0.3,0,0.2,  1+l/20,0,1});
  end
end
----------------------------------------------------------------------------








----------------------------------------------------------------------------
function public.unmark_bbb() 
  local func_end=function()
    ng_global.progress["std"]["win_elfho"].unmark["bbb"].done = 1;
    cmn.CallEventHandler( "elfho_unmark_bbb" );
    ld.Lock(0);
  end
  ld.Lock(1);
  ld.AnimPlay("anm_elfho_anim_box","anim_box",func_end) 
  SoundSfx( "aud_open_casket" )
end;
----------------------------------------------------------------------------


----------------------------------------------------------------------------
function public.unmark_hhh() 
  local func_end=function()
    ng_global.progress["std"]["win_elfho"].unmark["hhh"].done = 1;
    cmn.CallEventHandler( "elfho_unmark_hhh" );
    ld.Lock(0);
  end
  ld.Lock(1);
  ld.AnimPlay("anm_elfho_anim_chalk","anim_chalk",func_end) 
  SoundSfx( "aud_wright4" )
end;
----------------------------------------------------------------------------

----------------------------------------------------------------------------
function public.unmark_jjj() 
  local func_end=function()
    ng_global.progress["std"]["win_elfho"].unmark["jjj"].done = 1;
    cmn.CallEventHandler( "elfho_unmark_jjj" );
    ld.Lock(0);
  end
  ld.Lock(1);
  SoundSfx( "aud_lil_key" )
  ld.AnimPlay("anm_elfho_anim_lock","anim_lock",func_end) 
  
end;
----------------------------------------------------------------------------








function public.stardrag_hhh()
  ObjSet("spr_elfho_hhh_part_1",{inputrect_x=0,inputrect_y=-25,inputrect_w=10,inputrect_h=45})
end




function public.drop_hhh()
  if ObjIntersect("spr_elfho_hhh_part_1","obj_elfho_unmark_hhh") then
    ObjDelete("spr_elfho_hhh_part_1")
    ho_elfho.unmark_hhh();
  else
    ObjSet("spr_elfho_hhh_part_1",{inputrect_x=-19,inputrect_y=-31,inputrect_w=38,inputrect_h=60})
    ObjSet( "spr_elfho_hhh_part_1_shadow", {visible=1} )
  end
  ld.ShCur( CURSOR_DEFAULT );
end



function public.drop_jjj()
  if ObjIntersect("spr_elfho_jjj_part_2","obj_elfho_unmark_jjj") then
    ObjDelete("spr_elfho_jjj_part_2")
    ho_elfho.unmark_jjj();
  else
    ObjSet( "spr_elfho_jjj_part_2_shadow", {visible=1} )
  end
  ld.ShCur( CURSOR_DEFAULT );  
end










function public.idle_jjj()
  if not private.idle_jjj_run then 
    local func_end = function()
      private.idle_jjj_run=false;
      ObjSet("spr_elfho_jjj_part_1",{visible=0})
      ObjSet("anm_elfho_anim_lock",{visible=1})
    end
    SoundSfx( "aud_xx_lock" )
    private.idle_jjj_run=true;
    ObjSet("spr_elfho_jjj_part_1",{visible=1})
    ObjSet("anm_elfho_anim_lock",{visible=0})
    ObjAnimate("spr_elfho_jjj_part_1", 7, 0, 0, func_end, {0,0,0,  0.1,0,-0.05,   0.2,0,0.05,  0.3,0,0});
  end
end



-- simple effect from HO -------------------------------------------------------
function private.sparkle(object_name)

  if not ObjGet( "tmr_ho_elfho_sparkle" ) then
    SoundSfx( "aud_clk_stuff_disapier" )
    ld.StartTimer( "tmr_ho_elfho_sparkle", 0, function()  end )
  end

  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 32, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  ObjSet(collect_name, {});
  
  PartSysSetMaskObj( collect_name, object_name );  
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
end
-- simple effect from HO -------------------------------------------------------