-- name=ho_icearbour
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "icearbour" );
  game.relations[ "ho_icearbour" ].exitroom = "rm_backyard";
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_icearbour" ] = { type = "win", room = "rm_backyard", zz = "ho_icearbour", zz_gate = "gho_backyard_icearbour" };
 
  local win_icearbour_func = function ()

    if ( cmn.IsEventDone( "win_icearbour" ) ) then
      interface.InventoryItemAdd( "inv_childrenstruck", "spr_icearbour_win" );
      ObjDelete( "gho_backyard_icearbour" );
      ObjSet( "inv_childrenstruck", { drag = 0 } )
    end;

  end;
  cmn.AddSubscriber( "win_icearbour", win_icearbour_func );
  
  local start_icearbour_func = function ()
    if not cmn.IsEventDone("win_icearbour") then
      common_impl.ProcessHoStart( "icearbour" );
      local ho_found = ng_global.progress[ "std" ][ "win_icearbour" ].found;
      for i = 1, #ho_found do
        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false} );
        if ObjGet("spr_"..name.."_sh") then
          ObjDelete("spr_"..name.."_sh")
        end
      end;
    end
  end;
  cmn.AddSubscriber( "win_icearbour", start_icearbour_func, "ho_icearbour" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  private.tr_playing={}
  
  SoundEnv( "aud_mansion_env" )
  if ( not cmn.IsEventDone( "opn_icearbour" ) ) then
    cmn.InitHo( "icearbour" );
    cmn.SetEventDone( "opn_icearbour" );
  end;
  local ho_items = {};
  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_icearbour_aaa"}); --1
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_icearbour_bbb"}); --2
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_icearbour_ccc"}); --3
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_icearbour_ddd"}); --4
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_icearbour_eee"}); --5
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_icearbour_fff"}); --6
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_icearbour_ggg"}); --7
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_icearbour_hhh"}); --8
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_icearbour_iii"}); --9
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_icearbour_jjj"}); --10
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_icearbour_kkk"}); --11
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_icearbour_lll"}); --12
  SoundHoTheme( true );
  interface.ItemPanelShow( ho_items );
  
end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.ItemPanelHide();
end;
--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show() 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.TaskComplete( task_name )
  
  --ObjSet( "spr_icearbour_"..task_name, { pos_z = 1 } );
  cmn.HoItemFind("spr_icearbour_"..task_name,"itm_icearbour_"..task_name);
  if ObjGet("spr_icearbour_"..task_name.."_sh") then
    ObjDelete("spr_icearbour_"..task_name.."_sh")
  end
end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.tr_anim(tr)
  if not private.tr_playing[tr] then
    
    private.tr_playing[tr]=true;
    ld.AnimPlay("anm_icearbour_anm_tr_"..tr,"tr_"..tr, function() private.tr_playing[tr]=false; end)
    
    if tr==1 then
      SoundSfx( "aud_xx_bear" )
    end
    if tr==2 then
      SoundSfx( "aud_sfx_keys" )
    end
    if tr==3 then
      SoundSfx( "aud_sfx_grammophone" )
    end  
  end
end