-- name=ho_knightho
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "knightho" );
  game.relations[ "ho_knightho" ].exitroom = "rm_mansion";
 
  --------------------------------------------------------------------------------------------------
  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";

  for n = 1,11 do
    local obj = "spr_knightho_"..(private.abc[n]);
    
    ObjSet(obj,{
      event_mdown    = function() end;
      event_dragdrop = function() private.TaskComplete( private.abc[n] ) end;
      event_startdrag= function() private.shadow_control( private.abc[n] ) end;
      event_drag     = function() private.hint_glow(    private.abc[n] ) end;
      event_menter   = function() ld.ShCur(CURSOR_GET);     end;
      event_mleave   = function() ld.ShCur(CURSOR_DEFAULT); end;
      drag = true;
      --inputrect_init = true;
      --inputrect_x = -50;
      --inputrect_y = -50;
      --inputrect_w = 100;
      --inputrect_h = 100;
    })
    
    ObjSet(obj.."_set",{event_mdown = function() end, visible=0, input=0, pos_z=-10})
    
      ObjSet(obj.."_focus",{input=0,alp=0,blendmode=2})
    
  end
  --------------------------------------------------------------------------------------------------
  
  





  common_impl.hint[ "win_knightho" ] = { type = "win", room = "rm_mansion", zz = "ho_knightho", zz_gate = "gho_mansion_knightho" };
 
  local win_knightho_func = function ()

    if ( cmn.IsEventDone( "win_knightho" ) ) then
      
      interface.InventoryItemAdd( "inv_shield", "spr_knightho_win" );
      ObjDelete( "gho_mansion_knightho" );
      ObjSet("inv_shield",{drag=0})
    end;

  end;
  cmn.AddSubscriber( "win_knightho", win_knightho_func );
  
  local start_knightho_func = function ()
  if not cmn.IsEventDone("win_knightho") then
  
  end
  end;
  cmn.AddSubscriber( "win_knightho", start_knightho_func, "ho_knightho" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_mansion_env" )

  if ( not cmn.IsEventDone( "opn_knightho" ) ) then

    cmn.InitHo( "knightho" );

    cmn.SetEventDone( "opn_knightho" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_knightho_aaa","obj_knightho_aaa_place" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_knightho_bbb","obj_knightho_bbb_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_knightho_ccc","obj_knightho_ccc_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_knightho_ddd","obj_knightho_ddd_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_knightho_eee","obj_knightho_eee_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_knightho_fff","obj_knightho_fff_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_knightho_ggg","obj_knightho_ggg_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_knightho_hhh","obj_knightho_hhh_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_knightho_iii","obj_knightho_iii_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_knightho_jjj","obj_knightho_jjj_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_knightho_kkk","obj_knightho_kkk_place" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_knightho_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "knightho" );

   for j = 1, #ng_global.progress["std"]["win_knightho"].found do

    local name = tostring( ng_global.progress["std"]["win_knightho"].found[j]["object"] );
   
    ObjDelete( name );

    
    local task = tostring( ng_global.progress["std"]["win_knightho"].found[j]["task"] );
    
    ObjDelete("obj_knightho_"..(task).."_place")
    ObjSet("spr_knightho_"..(task).."_set",{visible=1})
    
    
    local obj = "spr_knightho_"..task.."_shadow";
    ObjDelete(obj)
    
    if task=="iii" or task=="ggg" or task=="fff" or task=="eee" then
      local obj = "spr_knightho_"..task.."_dop";
      ObjDelete(obj)
    end
  end;

  private.task_countdown()
  
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  int_taskpanel_impl.ShowTextPanel( "knightho" );

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
function private.shadow_control( task_name )
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get", 0, "", 0 );
  
  ObjSet("spr_knightho_"..task_name,{pos_z=32})
  local obj = "spr_knightho_"..task_name.."_shadow";
  if ObjGet(obj) then
    ObjSet(obj,{alp=0})
  end
  
  if task_name=="iii" or task_name=="ggg" or task_name=="fff" or task_name=="eee" then
    local obj = "spr_knightho_"..task_name.."_dop";
    ObjSet(obj,{visible=0})
    ObjSet("spr_knightho_"..task_name,{visible=1})
  end
  
  
  if task_name == "aaa" or task_name == "hhh" or task_name == "ggg" or task_name == "fff" then
    ObjSet("spr_knightho_"..task_name,{res = "assets/levels/level/ho_knightho/"..task_name.."_set"})
  end
end
--------------------------------------------------------------------------------------------
function private.hint_glow( task_name )
  local obj = "spr_knightho_"..task_name.."_focus";    
  if ObjIntersect("obj_knightho_"..(task_name).."_place", "spr_knightho_"..task_name) then
    if ObjGet(obj).alp==0 then
      ObjAnimate(obj, 8, 0, 0, func_end, {0,0,0,   0.3,0,1});
    end
  else
    if ObjGet(obj).alp>0 then
      ObjStopAnimate(obj,8);
      ObjAnimate(obj, 8, 0, 0, func_end, {0,0,ObjGet(obj).alp,   0.3,0,0});
    end
  end
end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  


  ObjSet("spr_knightho_"..task_name,{pos_z=31})
  
  if ObjIntersect("obj_knightho_"..(task_name).."_place", "spr_knightho_"..task_name) then
    
    local func_end = function()
    
      ObjDelete("obj_knightho_"..(task_name).."_place")
      ObjDelete("spr_knightho_"..task_name.."_focus")
      ObjSet("spr_knightho_"..task_name.."_set",{visible=1,alp=0})
      ObjAnimate("spr_knightho_"..task_name.."_set", 8, 0, 0, "", {0,0,0,  0.2,0,1});
          
      
      
      if #ng_global.progress["std"]["win_knightho"].found == 10 then

        ObjSet("txt_knightho_taskpanel",{param0 = 11})
        
        ObjDelete("spr_knightho_"..task_name)

        --SoundSfx( "aud_win_knightho" )
        
        local t_anim = 0.6;
        ObjSet(    "spr_knightho_chest_open", {visible=1,alp=0})
        ObjSet(    "spr_knightho_chest_close",{visible=1,alp=1})

        SoundSfx( "aud_open_chest" )
        
        ObjAnimate("spr_knightho_chest_open",  8, 0, 0, "", {0, 0, 0,     t_anim, 0, 1});
        ObjAnimate("spr_knightho_chest_close", 8, 0, 0, "", {0, 0, 1,     t_anim, 0, 0});
        ObjAnimate("spr_knightho_chest_close", 5, 0, 0, "", {0, 0, 1,     t_anim, 0, 0.78});
        
        ld.StartTimer( t_anim,
          function() 
            ld.Lock(0);
            ObjSet( "spr_knightho_"..task_name, { pos_z = 1 } );
            cmn.HoTaskFind( "spr_knightho_"..task_name, task_name );    
            private.task_countdown();
          end
        )
      else
        ld.Lock(0)
        ObjSet( "spr_knightho_"..task_name, { pos_z = 1 } );
        cmn.HoTaskFind( "spr_knightho_"..task_name, task_name );    
        private.task_countdown()
      end 
  
    end
    
    ld.Lock(1);
    
    local objt = "spr_knightho_"..task_name
    local curs = GetZoomCursorPos();
    local xm = curs[1];
    local ym = curs[2];
    
    ObjSet(objt,{pos_x=xm,pos_y=ym})
    
    --SoundSfx( "aud_statueparts" )

    ObjAnimate(objt, 3, 0, 0, func_end, {0,0, ObjGet(objt).pos_x,ObjGet(objt).pos_y,    0.25, 0, ObjGet(objt.."_set").pos_x,ObjGet(objt.."_set").pos_y});
    
  else
    
    local obj = "spr_knightho_"..task_name.."_shadow";
    if ObjGet(obj) then
      ObjSet(obj,{alp=1})
    end    
    --SoundSfx( "aud_statuepartsdrop" )    
    
    if task_name == "aaa" or task_name == "hhh" or task_name == "ggg" or task_name == "fff" then
      ObjSet("spr_knightho_"..task_name,{res = "assets/levels/level/ho_knightho/"..task_name})
    end
    
    if task_name=="iii" or task_name=="ggg" or task_name=="fff" or task_name=="eee" then
      local obj = "spr_knightho_"..task_name.."_dop";
      ObjSet(obj,{visible=1})
      ObjSet("spr_knightho_"..task_name,{visible=0})
    end
    
  end


end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------


function private.task_countdown()
  local N = #ng_global.progress["std"]["win_knightho"].found;
  ObjSet("txt_knightho_taskpanel",{param0 = N})  
  
  if N == 11 then
    --ObjSet("anm_knightho_anim_get_lll",{animfunc="get_lll_end"})
    ObjSet("spr_knightho_chest_open",{visible=1,alp=1})
    ObjDelete("spr_knightho_chest_close")
    ObjSet("spr_knightho_lll",{visible=1,input=1})
    
    ObjSet("txt_knightho_taskpanel",{text="tsk_knightho_lll"})
    
  end
end