-- name=ho_sledge
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "sledge" );
  game.relations[ "ho_sledge" ].exitroom = "rm_street";
 
  ld.NoteInit("spr_sledge_note_small", "spr_sledge_note_big",   "txt_sledge_note");
  
  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_sledge" ] = { type = "win", room = "rm_street", zz = "ho_sledge", zz_gate = "gho_street_sledge" };
 
  local win_sledge_func = function ()

    if ( cmn.IsEventDone( "win_sledge" ) ) then
      interface.InventoryItemAdd( "inv_bells", "spr_sledge_win" );
      ObjDelete( "gho_street_sledge" );
    end;

  end;
  cmn.AddSubscriber( "win_sledge", win_sledge_func );
  
  
  
  
  local unmark_aaa = function () 
    ObjSet( "spr_sledge_aaa", { input = 1 , visible=1} );
    ObjDelete("obj_sledge_unmark_aaa")
    ObjDelete("anm_sledge_anim_aaa_anim")
  end;
  cmn.AddSubscriber( "sledge_unmark_aaa", unmark_aaa, "ho_sledge" );
  
  
  local unmark_eee = function () 
    ObjSet( "spr_sledge_eee", { input = 1 , visible=1} );
    ObjDelete("obj_sledge_unmark_eee")
    ObjDelete("anm_sledge_anim_eee_anim")
  end;
  cmn.AddSubscriber( "sledge_unmark_eee", unmark_eee, "ho_sledge" );
  
  
  local unmark_jjj = function () 
    ObjSet( "spr_sledge_jjj", { input = 1 , visible=1} );
    ObjDelete("obj_sledge_unmark_jjj")
    ObjDelete("anm_sledge_anim_jjj_anim")
    ObjDelete("spr_sledge_jjj_part_2")
    
  end;
  cmn.AddSubscriber( "sledge_unmark_jjj", unmark_jjj, "ho_sledge" );
  
  
  
  
  
  
  local start_sledge_func = function ()
  if not cmn.IsEventDone("win_sledge") then
    common_impl.ProcessHoStart( "sledge" );
    
    if cmn.IsUnmarkedTask("sledge","aaa") then
      unmark_aaa()
    end
    if cmn.IsUnmarkedTask("sledge","eee") then
      unmark_eee()
    end
    if cmn.IsUnmarkedTask("sledge","jjj") then
      unmark_jjj()
    end
      
  end
  end;
  cmn.AddSubscriber( "win_sledge", start_sledge_func, "ho_sledge" );  
  
  
  
  
  
  
  
  
  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_street_env" )

  if ( not cmn.IsEventDone( "opn_sledge" ) ) then

    cmn.InitHo( "sledge" );
    
    cmn.SetMarkedTask( "sledge", "aaa" );
    cmn.SetMarkedTask( "sledge", "eee" );
    cmn.SetMarkedTask( "sledge", "jjj" );

    cmn.SetEventDone( "opn_sledge" );
 
  end;

  
  
    
    
  
  
--  local ho_items = {};
--
--  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_sledge_aaa","obj_sledge_unmark_aaa"}); 
--  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_sledge_bbb"}); 
--  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_sledge_ccc"}); 
--  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_sledge_ddd"}); 
--  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_sledge_eee","obj_sledge_unmark_eee"}); 
--  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_sledge_fff"}); 
--  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_sledge_ggg"}); 
--  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_sledge_hhh"}); 
--  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_sledge_iii"}); 
--  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_sledge_jjj","obj_sledge_unmark_jjj", "spr_sledge_jjj_part_2"}); 
--  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_sledge_kkk"}); 
--  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_sledge_lll"}); 
--  
--  SoundHoTheme( true )
--  interface.ItemPanelShow( ho_items );



  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 1, { { "spr_sledge_aaa" }, {"obj_sledge_unmark_aaa"} });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_sledge_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_sledge_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_sledge_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_sledge_eee" }, {"obj_sledge_unmark_eee"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_sledge_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_sledge_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_sledge_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_sledge_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 1, { { "spr_sledge_jjj" }, {"obj_sledge_unmark_jjj", "spr_sledge_jjj_part_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_sledge_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_sledge_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["std"]["win_sledge"].found do

    local name = tostring( ng_global.progress["std"]["win_sledge"].found[j]["object"] );
   
    ObjDelete( name );

  end;








  --private.abc = {};
  --  private.abc[1]  = "aaa";
  --  private.abc[2]  = "bbb";
  --  private.abc[3]  = "ccc";
  --  private.abc[4]  = "ddd";
  --  private.abc[5]  = "eee";
  --  private.abc[6]  = "fff";
  --  private.abc[7]  = "ggg";
  --  private.abc[8]  = "hhh";
  --  private.abc[9]  = "iii";
  --  private.abc[10] = "jjj";
  --  private.abc[11] = "kkk";
  --  private.abc[12] = "lll";
  --  
  --  for n=1,#private.abc do
  --    --ld.LogTrace("spr_sledge_"..private.abc[n])
  --    if ObjGet("spr_sledge_"..private.abc[n]) and private.abc[n] ~= "jjj" then
  --      ObjSet("spr_sledge_"..private.abc[n],{
  --        event_mdown = function() cmn.HoItemFind("spr_sledge_"..private.abc[n],"itm_sledge_"..private.abc[n]); end;
  --      })
  --        --ld.LogTrace(private.abc[n])
  --    end
  --    
  --    if ObjGet("spr_sledge_"..private.abc[n]) and private.abc[n] == "jjj" then
  --      ObjSet("spr_sledge_"..private.abc[n],{
  --        event_menter    = function() ld.ShCur(CURSOR_GET); end;
  --        event_mleave    = function() ld.ShCur(CURSOR_DEFAULT); end;
  --        event_startdrag = function() ld.ShCur(CURSOR_NULL); end;
  --        event_dragdrop  = function() private.drag_drop_jjj() end;
  --      })
  --    end
  --    
  --  end
  
  
end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.TaskPanelHide();
end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.DialogHo_Show()
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_sledge_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_sledge_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------










----------------------------------------------------------------------------
function public.unmark_aaa() 
  local func_end=function()
    --ng_global.progress["std"]["win_sledge"].unmark["aaa"].done = 1;
    cmn.UnmarkTask( "sledge", "aaa" );
    cmn.CallEventHandler( "sledge_unmark_aaa" );
    ld.Lock(0);
  end
  ld.Lock(1);
  SoundSfx( "aud_clk_ho" )
  ld.AnimPlay("anm_sledge_anim_aaa_anim","aaa_anim",func_end) 
end;
----------------------------------------------------------------------------
----------------------------------------------------------------------------
function public.unmark_eee() 
  local func_end=function()
    --ng_global.progress["std"]["win_sledge"].unmark["eee"].done = 1;
    cmn.UnmarkTask( "sledge", "eee" );
    cmn.CallEventHandler( "sledge_unmark_eee" );
    ld.Lock(0);
  end
  ld.Lock(1);
  ld.AnimPlay("anm_sledge_anim_eee_anim","eee_anim",func_end) 
  SoundSfx( "aud_clk_nestingbox" )
end;
----------------------------------------------------------------------------
----------------------------------------------------------------------------
function public.unmark_jjj() 
  local func_end=function()
    --ng_global.progress["std"]["win_sledge"].unmark["jjj"].done = 1;
    cmn.UnmarkTask( "sledge", "jjj" );
    cmn.CallEventHandler( "sledge_unmark_jjj" );
    ld.Lock(0);
  end
  ld.Lock(1);
  ld.AnimPlay("anm_sledge_anim_jjj_anim","jjj_anim",func_end) 
  
end;
----------------------------------------------------------------------------




function public.drop_jjj()
  if ObjIntersect("spr_sledge_jjj_part_2","obj_sledge_unmark_jjj") then
    --local func_end = function()
    --  ho_sledge.unmark_jjj();
    --end
    --
    --ld.Lock(1);
    --local curs = GetZoomCursorPos();
    --ObjSet("spr_sledge_jjj_part_2",{pos_x=curs[1],pos_y=curs[2]})
    --ObjAnimate("spr_sledge_jjj_part_2", 3, 0, 0, func_end, {0, 0, curs[1],curs[2],  0.5, 0, 89,210});
    SoundSfx( "aud_put" )
    ObjDelete("spr_sledge_jjj_part_2")
    ho_sledge.unmark_jjj();
  else

  end

end