-- name=ho_train
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "train" );
  game.relations[ "ho_train" ].exitroom = "rm_attic";
  
  private.TASK_COLOR_R = 0.918;
  private.TASK_COLOR_G = 0.671;
  private.TASK_COLOR_B = 0.278;

  private.TASK_MARKED_COLOR_R = 0.427;
  private.TASK_MARKED_COLOR_G = 0.761;
  private.TASK_MARKED_COLOR_B = 0.996;
  
  private.TASK_COMPLETED_COLOR_R = 0.259;
  private.TASK_COMPLETED_COLOR_G = 0.259;
  private.TASK_COMPLETED_COLOR_B = 0.259;
  
  private.T1 = 5;
  private.T2 = 10;
  private.T3 = 10;
  private.train_items = {"spr_train_aaa", "spr_train_jjj", "spr_train_lll"};
  
  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";
  private.abc[12] = "lll";
  
  private.abc2num = {};
  private.abc2num["aaa"]  = 1;
  private.abc2num["bbb"]  = 2;
  private.abc2num["ccc"]  = 3;
  private.abc2num["ddd"]  = 4;
  private.abc2num["eee"]  = 5;
  private.abc2num["fff"]  = 6;
  private.abc2num["ggg"]  = 7;
  private.abc2num["hhh"]  = 8;
  private.abc2num["iii"]  = 9;
  private.abc2num["jjj"] = 10;
  private.abc2num["kkk"] = 11;
  private.abc2num["lll"] = 12;
  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_train" ] = { type = "win", room = "rm_attic", zz = "ho_train", zz_gate = "gho_attic_train" };
 
  local win_train_func = function ()

    if ( cmn.IsEventDone( "win_train" ) ) then
      --int_simon.SimonSetVisible(1)
      interface.InventoryItemAdd( "inv_beargirl", "spr_train_win" );
      ObjDelete( "gho_attic_train" );
    end;

  end;
  cmn.AddSubscriber( "win_train", win_train_func );
  
  local start_train_func = function ()
  if not cmn.IsEventDone("win_train") then
  
  end
  end;
  cmn.AddSubscriber( "win_train", start_train_func, "ho_train" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  
  private.idle_func_rund={}
  
  for n=1,#private.abc do
    local obj = "spr_train_"..private.abc[n]
    ObjSet(obj,{event_mdown = function() private.TaskComplete(private.abc[n]) end})
  end
  
  
  SoundEnv( "aud_cabinet_env" )

  if ( not cmn.IsEventDone( "opn_train" ) ) then

    cmn.InitHo( "train" );

    cmn.SetEventDone( "opn_train" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_train_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_train_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_train_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_train_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_train_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_train_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_train_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_train_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_train_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_train_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_train_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_train_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  
  ObjSet("spr_train_aaa",{event_mdown = function() end; drag=true;  event_dragdrop = function() private.event_dragdrop("aaa") end; event_startdrag = function() private.event_startdrag("aaa") end; })
  ObjSet("spr_train_iii",{event_mdown = function() end; drag=true;  event_dragdrop = function() private.event_dragdrop("iii") end; event_startdrag = function() private.event_startdrag("iii") end; })
  ObjSet("spr_train_lll",{event_mdown = function() end; drag=true;  event_dragdrop = function() private.event_dragdrop("lll") end; event_startdrag = function() private.event_startdrag("lll") end; })
  ObjSet("spr_train_eee",{event_mdown = function() end; drag=true;  event_dragdrop = function() private.event_dragdrop("eee") end; event_startdrag = function() private.event_startdrag("eee") end; })
  
    
    
  if not ng_global.progress["std"]["win_train"].state then
    ng_global.progress["std"]["win_train"].state = {};
    for n=1,#private.abc do
      local obj = "spr_train_"..private.abc[n]
      ng_global.progress["std"]["win_train"].state[ private.abc[n] ] = false;
    end
    ng_global.progress["std"]["win_train"].state[ "fff_unmark" ] = false;
    ng_global.progress["std"]["win_train"].state[ "ggg_unmark" ] = false;
  end
  
  
  ObjSet("spr_train_fff_part_2",{input=1; drag=1; event_startdrag = function() private.event_startdrag_unmark("fff") end; event_dragdrop = function() private.event_dragdrop_unmark("fff") end; })
  ObjSet("spr_train_ggg_part_2",{input=1; drag=1; event_startdrag = function() private.event_startdrag_unmark("ggg") end; event_dragdrop = function() private.event_dragdrop_unmark("ggg") end; })
  
  if ng_global.progress["std"]["win_train"].state[ "fff_unmark" ] then
    ObjDelete("spr_train_fff_part_2_shadow")
    ObjDelete("obj_train_fff_unmark")
    ObjDelete("anm_train_anim_make_fff")
    ObjDelete("spr_train_fff_part_2")
    ObjSet("spr_train_fff",{visible=1,alp=1,input=1})
  end
  if ng_global.progress["std"]["win_train"].state[ "ggg_unmark" ] then
    ObjDelete("spr_train_ggg_part_2_shadow")
    ObjDelete("obj_train_ggg_unmark")
    ObjDelete("anm_train_anim_make_ggg")
    ObjDelete("spr_train_ggg_part_2")
    ObjSet("spr_train_ggg",{visible=1,alp=1,input=1})
  end
  
  
  
  if not ng_global.progress["std"]["win_train"].state[ "ggg_unmark" ] and not ng_global.progress["std"]["win_train"].state[ "ggg" ] then
    private.MarkTaskAnim( private.abc2num[ "ggg" ] );
  end
  if not ng_global.progress["std"]["win_train"].state[ "fff_unmark" ] and not ng_global.progress["std"]["win_train"].state[ "fff" ] then
    private.MarkTaskAnim( private.abc2num[ "fff" ] );
  end
  
  
  
  if ng_global.progress["std"]["win_train"].state["aaa"] and not ng_global.progress["std"]["win_train"].state["eee"] then
    private.UnmarkTaskAnim( private.abc2num[ "eee" ] );
    ObjSet("spr_train_eee",{input=1});
  end
  if not ng_global.progress["std"]["win_train"].state["aaa"] then
    private.MarkTaskAnim( private.abc2num[ "eee" ] );
  end
  
  local n = 0;
  if ng_global.progress["std"]["win_train"].state["aaa"] then
    ObjSet("anm_train_anim_put_head", {frame=999})
    ObjDelete("obj_train_eee_idle")
    n=n+1
  end
  if ng_global.progress["std"]["win_train"].state["eee"] then
    ObjSet("anm_train_anim_put_bow", {frame=999})
    n=n+1
  end
  if ng_global.progress["std"]["win_train"].state["iii"] then
    ObjSet("anm_train_anim_put_paw_2", {frame=999})
    n=n+1
  end
  if ng_global.progress["std"]["win_train"].state["lll"] then
    ObjSet("anm_train_anim_put_paw_1", {frame=999})
    n=n+1
  end
  if n==4 then
    ObjSet("spr_train_bear_body",{input=0})
  end
  
  
  if not ng_global.progress["std"]["win_train"].state["aaa"] then
    private.MarkTaskAnim( private.abc2num[ "aaa" ] )
  end
  if not ng_global.progress["std"]["win_train"].state["jjj"] then
    private.MarkTaskAnim( private.abc2num[ "jjj" ] )
  end
  if not ng_global.progress["std"]["win_train"].state["lll"] then
    private.MarkTaskAnim( private.abc2num[ "lll" ] )
  end
  
  
  for j = 1, #ng_global.progress["std"]["win_train"].found do
    local name = tostring( ng_global.progress["std"]["win_train"].found[j]["object"] );
    ObjDelete( name );
  end;
  if ObjGet("tmr_train_tmr") then
    ObjDelete("tmr_train_tmr");
  end
  ld.StartTimer( "tmr_train_tmr", private.T1, private.train_stop );
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

  if ObjGet("tmr_train_tmr") then
    ObjDelete("tmr_train_tmr");
  end 
  
  --SoundSfx( "aud_train_stop_305",0 );
  --SoundSfx( "aud_train_start_200",0 );
  
  SndStop( "assets/levels/common/audio/aud_train_stop_305", 0.5 )
  SndStop( "assets/levels/common/audio/aud_train_start_200", 0.5 )
end;
--*********************************************************************************************************************
function public.Close()
  ObjSet("vid_train_vid_train_stop_305",{frame=0,visible=1});
  ObjSet("vid_train_vid_train_start_200",{frame=0,visible=0});
  ObjSet("vid_train_vid_train_wait_134",{frame=0,visible=0});
  ObjSet("spr_train_closed",{input=0})
  ObjSet("anm_train_anim_train",{visible=0,frame=0,animfunc="train_open"});
  
  local name = "spr_train_jjj_tr"
  ObjSet(name,{alp=0,input=0})
  local name = "spr_train_aaa_lll_tr"
  ObjSet(name,{alp=0,input=0})
  
end
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  local obj = "spr_train_"..task_name
  if ObjGet(obj.."_shadow") then
    ObjDelete(obj.."_shadow")
  end
  ng_global.progress["std"]["win_train"].state[ task_name ] = true;
  if task_name=="aaa" then
    private.UnmarkTaskAnim( private.abc2num[ "eee" ] );
    ObjSet("spr_train_eee",{input=1})
  end
  
  local n=0;
  for s=1,#private.abc do
    if ng_global.progress["std"]["win_train"].state[ private.abc[s] ] then
      n=n+1;
    end
  end
  
  local func_end = function()
    ObjSet( obj, { pos_z = 1 } );
    cmn.HoTaskFind( obj, task_name );
  end
    
  if n==12 then
    ld.Lock(1)
    local t = 0.5;
    local names = {"spr_train_bear_body","anm_train_anim_put_paw_1","anm_train_anim_put_paw_2","anm_train_anim_put_head","anm_train_anim_put_bow"};
    for l=1,#names do
      ObjAnimate(names[l], 8, 0, 0, _, {0,0,1, t,0,0});
      private.sparkle(names[l]);
    end
    ld.StartTimer(t*1.1,function() func_end();ld.Lock(0); end);
    
    SoundSfx("aud_get_ho");
    private.sparkle(obj);
    ObjAnimate(obj, 8, 0, 0, function() ObjDelete(obj) end, {0,0,1, 0.5,0,0,  t,0,0});
  else
    func_end()
  end  
  
end;
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;






--------------------------------------------------------------------------------
function private.train_start()
  local func_end = function()
    ObjSet("vid_train_vid_train_stop_305",{visible=1});
    ObjSet("vid_train_vid_train_start_200",{visible=0,frame=0});
    ld.StartTimer( "tmr_train_tmr", private.T1, private.train_stop );
    --ObjSet("spr_train_hhh",{input=1})
    --private.UnmarkTaskAnim( private.abc2num[ "hhh" ] );
  end
  ObjSet("spr_train_closed",{input=0})
  ObjSet("anm_train_anim_train",{visible=0});
  ObjSet("vid_train_vid_train_start_200",{visible=1});
  ObjSet("vid_train_vid_train_wait_134",{frame=0,visible=0})
  
  SoundSfx( "aud_train_start_200" )
  
  VidPlay("vid_train_vid_train_start_200",func_end);
  private.train_is_stop = false;
end
--------------------------------------------------------------------------------
function private.train_stop()
 
  local func_step = function()
    ld.StartTimer( "tmr_train_tmr", private.T2, private.train_start );
    ObjSet("vid_train_vid_train_wait_134",{visible=1,alp=1})
    VidPlay("vid_train_vid_train_wait_134",_)  
    ObjSet("vid_train_vid_train_stop_305",{frame=0,visible=0})
    ObjSet("anm_train_anim_train",{visible=1});
    ObjSet("spr_train_closed",{input=1; event_mdown = function() private.train_open(); end;});
    private.train_is_stop = true;
    --ObjSet("spr_train_hhh",{input=0})
    --private.MarkTaskAnim( private.abc2num[ "hhh" ] );
  end
  
  ObjSet("vid_train_vid_train_stop_305",{visible=1});
  
  SoundSfx( "aud_train_stop_305" )
  
  VidPlay("vid_train_vid_train_stop_305",func_step);
  private.train_is_opened=false;
end
-------------------------------------------------------------------------------






--------------------------------------------------------------------------------
function private.train_open()
  if not private.train_is_opened then
    ObjDelete("tmr_train_tmr");
    local func_end = function()
      ld.StartTimer( "tmr_train_tmr", private.T3, private.train_close );
    end
    private.train_is_opened=true;
    
    for n=1,#private.train_items do
      private.show_item(private.train_items[n]);
    end
    
    if not ng_global.progress["std"]["win_train"].state["aaa"] then
      private.UnmarkTaskAnim( private.abc2num[ "aaa" ] )
    end
    if not ng_global.progress["std"]["win_train"].state["jjj"] then
      private.UnmarkTaskAnim( private.abc2num[ "jjj" ] )
    end
    if not ng_global.progress["std"]["win_train"].state["lll"] then
      private.UnmarkTaskAnim( private.abc2num[ "lll" ] )
    end
    
    local t = 0.5;
    local name = "spr_train_jjj_tr"
    ObjSet(name,{alp=0,visible=1,input=0})
    ObjAnimate(name, 8,0,0, _, {0,0,0, t,0,1});
    local name = "spr_train_aaa_lll_tr"
    ObjSet(name,{alp=0,visible=1,input=0})
    ObjAnimate(name, 8,0,0, _, {0,0,0, t,0,1});
    
    ld.AnimPlay("anm_train_anim_train","train_open",func_end)
    
    SoundSfx("aud_open_vagon")
  end
end
--------------------------------------------------------------------------------
function private.train_close()
  local func_end = function()
    private.train_start()
  end
  
  local t = 0.57;
  local name = "spr_train_jjj_tr"
  ObjSet(name,{alp=0,visible=1,input=0})
  ObjAnimate(name, 8,0,0, _, {0,0,1, t,0,0});
  local name = "spr_train_aaa_lll_tr"
  ObjSet(name,{alp=0,visible=1,input=0})
  ObjAnimate(name, 8,0,0, _, {0,0,1, t,0,0});
  
  if not ng_global.progress["std"]["win_train"].state["aaa"] then
    private.MarkTaskAnim( private.abc2num[ "aaa" ] )
  end
  if not ng_global.progress["std"]["win_train"].state["jjj"] then
    private.MarkTaskAnim( private.abc2num[ "jjj" ] )
  end
  if not ng_global.progress["std"]["win_train"].state["lll"] then
    private.MarkTaskAnim( private.abc2num[ "lll" ] )
  end
  
  
  for n=1,#private.train_items do
    private.hide_item(private.train_items[n]);
  end
  
  ld.AnimPlay("anm_train_anim_train","train_close",func_end)
  
  SoundSfx("aud_close_vagon")
end
-------------------------------------------------------------------------------







-------------------------------------------------------------------------------
function private.show_item(name)
  local t = 0.5;
  if ObjGet(name) then
    if ObjGetRelations(name).parent == "ho_train" then
      ObjStopDrag(name);
      local func_end = function()
        ObjSet(name,{input=1})
      end
      ObjSet(name,{alp=0,visible=1,input=0})
      ObjAnimate(name, 8,0,0, func_end, {0,0,0, t,0,1});
    end
    
  end  
end
--------------------------------------------------------------------------------
function private.hide_item(name)
  local t = 0.5;
  if ObjGet(name) then
    if ObjGetRelations(name).parent == "ho_train" then
      ObjStopDrag(name);
      ObjSet(name,{input=0})
      ObjAnimate(name, 8,0,0, _, {0,0,1, t,0,0});
    end
  end  
end
--------------------------------------------------------------------------------


--______________________________________________________________________________
function private.event_startdrag(key)
  local obj = "spr_train_"..key
  private.pos_z = ObjGet(obj).pos_z;
  ObjSet(obj,{pos_z=60})
  ld.ShCur(CURSOR_NULL);
  if ObjGet(obj.."_shadow") then
    ObjSet(obj.."_shadow",{visible=0})
  end
  SoundSfx("aud_get")
end
--______________________________________________________________________________
function private.event_dragdrop(key)
  local obj = "spr_train_"..key
  ObjSet(obj,{pos_z=private.pos_z})
  ld.ShCur(CURSOR_DEFAULT);
  if ObjIntersect( obj,"spr_train_bear_body" ) then
    
    SoundSfx("aud_bear_part")
    
    local func_end = function()
      private.TaskComplete( key )
    end
    
    local fase_end =true;
    local n = 0;
    if key=="aaa" then
      ld.AnimPlay("anm_train_anim_put_head","put_head",function() ObjDelete("obj_train_eee_idle");func_end(); end)
      fase_end=false;
      n=n+1;
    end
    if key=="eee" then
      ld.AnimPlay("anm_train_anim_put_bow","put_bow",func_end)
      fase_end=false;
      n=n+1;
    end
    if key=="iii" then
      ld.AnimPlay("anm_train_anim_put_paw_2","put_paw_2",func_end)
      fase_end=false;
      n=n+1;
    end
    if key=="lll" then
      ld.AnimPlay("anm_train_anim_put_paw_1","put_paw_1",func_end)
      fase_end=false;
      n=n+1;
    end
    
    if not fast_end then
      ObjSet(obj,{pos_x=-1111});
    end
    
    
    if ng_global.progress["std"]["win_train"].state["aaa"] then
      n=n+1
    end
    if ng_global.progress["std"]["win_train"].state["eee"] then
      n=n+1
    end
    if ng_global.progress["std"]["win_train"].state["iii"] then
      n=n+1
    end
    if ng_global.progress["std"]["win_train"].state["lll"] then
      n=n+1
    end
    if n==4 then
      ObjSet("spr_train_bear_body",{input=0})
    end
    
    if fast_end then
      func_end()
    end
    
  else
    if ObjGet(obj.."_shadow") then
      ObjSet(obj.."_shadow",{visible=1})
    end
  end
  
  
end
--******************************************************************************



--******************************************************************************
function private.event_startdrag_unmark(key)
  local obj = "spr_train_"..key.."_part_2"
  if ObjGet(obj.."_shadow") then
    ObjSet(obj.."_shadow",{visible=0})
  end
  private.pos_z = ObjGet(obj).pos_z;
  ObjSet(obj,{pos_z=60})
  ld.ShCur(CURSOR_NULL);
  SoundSfx("aud_get")
end
--******************************************************************************
function private.event_dragdrop_unmark(key)
  local obj = "spr_train_"..key.."_part_2"
  ObjSet(obj,{pos_z=private.pos_z})
  local item = "spr_train_"..key
  if ObjIntersect(obj,"obj_train_"..key.."_unmark") then
    ld.Lock(1)
    ObjDelete(obj);
    ObjDelete("obj_train_"..key.."_unmark")
    ObjDelete(obj.."_shadow")
    
    if key=="ggg" then
      SoundSfx("aud_get_owentray")
    end
    if key=="fff" then
      SoundSfx("aud_half_apple")
    end
    
    ld.AnimPlay( "anm_train_anim_make_"..key,"make_"..key,
      function()
        private.UnmarkTaskAnim( private.abc2num[ key ] );
        ng_global.progress["std"]["win_train"].state[ key.."_unmark" ]=true;
        ObjSet(item,{visible=1,input=1,alp=1})
        ObjDelete("anm_train_anim_make_"..key)
        ld.Lock(0)
      end
    )
  else
    if ObjGet(obj.."_shadow") then
      ObjSet(obj.."_shadow",{visible=1})
    end
  end
  ld.ShCur(CURSOR_DEFAULT);
end
--******************************************************************************








--******************************************************************************
function private.UnmarkTaskAnim( task_id )
  local task_color_r = private.TASK_COLOR_R;
  local task_color_g = private.TASK_COLOR_G;
  local task_color_b = private.TASK_COLOR_B;
  ObjSet( "txt_int_taskpanel_task_"..task_id,
  {
    param0 = task_color_r,
    param1 = task_color_g,
    param2 = task_color_b,
  } );
end;
--******************************************************************************
function private.MarkTaskAnim( task_id )
  local task_color_r = private.TASK_MARKED_COLOR_R;
  local task_color_g = private.TASK_MARKED_COLOR_G;
  local task_color_b = private.TASK_MARKED_COLOR_B;
  ObjSet( "txt_int_taskpanel_task_"..task_id,
  {
    param0 = task_color_r,
    param1 = task_color_g,
    param2 = task_color_b,
  } );
end;
--******************************************************************************



--------------------------------------------------------------------------------
function private.HintShow(hint_obj_name)
  local hints_table = { hint = {} };
  table.insert( hints_table.hint,  { ["pos_x"]=ObjGet(hint_obj_name).pos_x, ["pos_y"]=ObjGet(hint_obj_name).pos_y, ["obj_name"]=hint_obj_name } )   
  MsgSend( Command_Effect_ShowHoHint, hints_table );
end
--------------------------------------------------------------------------------
function public.clk_hint()
  local n = math.random(1,#private.abc)
  local s = 1;
  for s = 1,#private.abc do
    local key = private.abc[n]
    if not ng_global.progress["std"]["win_train"].state[key] and ObjGet("spr_train_"..key) then
      local done = false;
      if ObjGetRelations("spr_train_"..key).parent == "ho_train" then
        if key=="fff" or key=="ggg" then
          done=true;
          if ng_global.progress["std"]["win_train"].state[ key.."_unmark" ] then
            private.HintShow("spr_train_"..key);
          else
            private.HintShow("obj_train_"..key.."_unmark");
            private.HintShow("spr_train_"..key.."_part_2");
          end
        elseif key=="aaa" or key=="jjj" or key=="lll" then
          if private.train_is_stop then
            done=true;
            private.HintShow("spr_train_"..key);
            if key=="aaa" or key=="lll" then
              private.HintShow("spr_train_bear_body")
            end
          else
            
            if not private.check1() then  
              int_dialog.Show( "ifo_train_wait", 512,384 )
            end
          end
          
        else
          
          if not (key=="eee" and not ng_global.progress["std"]["win_train"].state["aaa"]) then
            private.HintShow("spr_train_"..key);
            done=true;
          end
          
        end
        
        if key=="iii" or key=="eee" then
          if not (key=="eee" and not ng_global.progress["std"]["win_train"].state["aaa"]) then
            private.HintShow("spr_train_bear_body")
          end
        end
      end
      
      if done then
        break;
      end
    end
    
    n=n+1;
    if n>#private.abc then
      n=1;
    end
  end
end




--------------------------------------------------------------------------------
function private.check1()
  local res = false;
  for n=1,#private.abc do
    local key = private.abc[n]
    if not ng_global.progress["std"]["win_train"].state[key] and ObjGet("spr_train_"..key) then
      if ObjGetRelations("spr_train_"..key).parent == "ho_train" then
        if key~="aaa" and key~="jjj" and key~="lll" and not (key=="eee" and not ng_global.progress["std"]["win_train"].state["aaa"]) then
          res = true;
        end
      end
    end
  end
  return res;
end
  


--------------------------------------
function public.idle_func(key)
  
  if not private.idle_func_rund[key] then
    private.idle_func_rund[key]=true;
    --ObjAnimate("anm_train_anim_make_"..key, 7, 0, 0, function() private.idle_func_rund[key]=false; end, {0,0,0, 0.1,0,-0.1, 0.2,0,0});
    local obj = "anm_train_anim_make_"..key 
    --ObjAnimate(obj, 7, 0, 0, function() private.idle_func_rund[key]=false; end, {0,0,0, 0.1,0,-0.003, 0.2,0,0});
    local x = ObjGet(obj).pos_x;
    local y = ObjGet(obj).pos_y;
    ObjAnimate(obj, 3, 0, 0, function() private.idle_func_rund[key]=false; end, {0,0,x,y, 0.1,0,x,y-1, 0.2,0,x,y});
  end
end


-- simple effect from HO -------------------------------------------------------
function private.sparkle(object_name)
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 32, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  
  PartSysSetMaskObj( collect_name, object_name );  
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
end
-- simple effect from HO -------------------------------------------------------