-- name=ho_underfirtreeho
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "underfirtreeho" );
  game.relations[ "ho_underfirtreeho" ].exitroom = "rm_hall";
 
  ld.NoteInit("spr_underfirtreeho_card_small", "spr_underfirtreeho_card_big",   "txt_underfirtreeho_giftcard");
  ld.NoteInit("spr_underfirtreeho_card2_small", "spr_underfirtreeho_card2_big", "txt_underfirtreeho_giftcard2");
  
  
  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";
  private.abc[12] = "lll";
  private.abc[13] = "mmm";
  
  private.contain = {};
  private.contain[1] = {"ddd1","ggg2","kkk2"};
  private.contain[2] = {"aaa2","eee2"};
  private.contain[3] = {"bbb2","eee1","fff2"};
  private.contain[4] = {"hhh1","iii1"};
  private.contain[5] = {"fff1","kkk1","lll1"};
  private.contain[6] = {"ccc1","hhh2","iii2"};
  private.contain[7] = {"aaa1","ggg1","jjj1"};
  private.contain[8] = {"ddd2","jjj2","lll2"};
  private.contain[9] = {"bbb1","ccc2"};
  
  
  private.current_box = 0;
  private.previous_box = 0;
  
  private.current_item = "none";
  private.previous_item = "none";
  private.current_item_mul = 0;
  private.previous_item_mul = 0;
  
  private.highlight_object = "none";
  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_underfirtreeho" ] = { type = "win", room = "rm_hall", zz = "ho_underfirtreeho", zz_gate = "gho_hall_underfirtreeho" };
 
  local win_underfirtreeho_func = function ()

    if ( cmn.IsEventDone( "win_underfirtreeho" ) ) then
      interface.InventoryItemAdd( "inv_gift", "spr_underfirtreeho_win" );
      ObjSet( "inv_gift", { drag = 0 } )
      ObjDelete( "gho_hall_underfirtreeho" );
    end;

  end;
  cmn.AddSubscriber( "win_underfirtreeho", win_underfirtreeho_func );
  
  local start_underfirtreeho_func = function ()
  if not cmn.IsEventDone("win_underfirtreeho") then
  
  end
  end;
  cmn.AddSubscriber( "win_underfirtreeho", start_underfirtreeho_func, "ho_underfirtreeho" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
function public.Open()
  level.tutorial_newho1.first();
  --input = false, alp = 0, visible = 0
  ObjSet("int_simon",{ pos_x = -40 });
end
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_hall_env" )
  --SoundHoTheme( true );

  if ( not cmn.IsEventDone( "opn_underfirtreeho" ) ) then

    cmn.InitHo( "underfirtreeho" );

    cmn.SetEventDone( "opn_underfirtreeho" );
    
    
    ng_global.progress[ "std" ][ "win_underfirtreeho" ].state = {}
    for n=1,9 do
      ng_global.progress[ "std" ][ "win_underfirtreeho" ].state[n] = false;
    end
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          2, 0, { { "spr_underfirtreeho_aaa1" },{"spr_underfirtreeho_aaa2"} });  --1
  interface.TaskPanelTaskAdd( ho_items, "bbb",          2, 0, { { "spr_underfirtreeho_bbb1" },{"spr_underfirtreeho_bbb2"} } ); --2
  interface.TaskPanelTaskAdd( ho_items, "ccc",          2, 0, { { "spr_underfirtreeho_ccc1" },{"spr_underfirtreeho_ccc2"} } ); --3
  interface.TaskPanelTaskAdd( ho_items, "ddd",          2, 0, { { "spr_underfirtreeho_ddd1" },{"spr_underfirtreeho_ddd2"} } ); --4
  interface.TaskPanelTaskAdd( ho_items, "eee",          2, 0, { { "spr_underfirtreeho_eee1" },{"spr_underfirtreeho_eee2"} } ); --5
  interface.TaskPanelTaskAdd( ho_items, "fff",          2, 0, { { "spr_underfirtreeho_fff1" },{"spr_underfirtreeho_fff2"} } ); --6
  interface.TaskPanelTaskAdd( ho_items, "ggg",          2, 0, { { "spr_underfirtreeho_ggg1" },{"spr_underfirtreeho_ggg2"} } ); --7
  interface.TaskPanelTaskAdd( ho_items, "hhh",          2, 0, { { "spr_underfirtreeho_hhh1" },{"spr_underfirtreeho_hhh2"} } ); --8
  interface.TaskPanelTaskAdd( ho_items, "iii",          2, 0, { { "spr_underfirtreeho_iii1" },{"spr_underfirtreeho_iii2"} } ); --9
  interface.TaskPanelTaskAdd( ho_items, "jjj",          2, 0, { { "spr_underfirtreeho_jjj1" },{"spr_underfirtreeho_jjj2"} } ); --10
  interface.TaskPanelTaskAdd( ho_items, "kkk",          2, 0, { { "spr_underfirtreeho_kkk1" },{"spr_underfirtreeho_kkk2"} } ); --11
  interface.TaskPanelTaskAdd( ho_items, "lll",          2, 0, { { "spr_underfirtreeho_lll1" },{"spr_underfirtreeho_lll2"} } ); --12
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 0, { { "spr_underfirtreeho_mmm" } } ); --13
  
  
  
  
  for n=1,#private.abc do
    local name = "spr_underfirtreeho_"..private.abc[n].."1"
    
    if ObjGet( name ) then
      ObjSet(name,{
        event_mdown  = function() private.item_click(private.abc[n],1); end;
        event_menter = function() private.highlight_menter(name.."_light"); end;
        event_mleave = function() private.highlight_mleave(name.."_light"); end;
      })
    end
    local name = "spr_underfirtreeho_"..private.abc[n].."2"
    if ObjGet( name ) then
      ObjSet(name,{
        event_mdown  = function() private.item_click(private.abc[n],2); end;
        event_menter = function() private.highlight_menter(name.."_light"); end;
        event_mleave = function() private.highlight_mleave(name.."_light"); end;
      })
    end
  end
    
  
  for n=1,9 do
    local name = "spr_underfirtreeho_box_"..n.."_cover";
    ObjSet( name ,{
      event_menter = function() private.highlight_menter(name.."_light"); end;
      event_mleave = function() private.highlight_mleave(name.."_light"); end;
      event_mdown  = function() private.box_click(n);                     end;});
  end
  
  

  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "underfirtreeho" );
  
  private.count = 0;
  for j = 1, #ng_global.progress["std"]["win_underfirtreeho"].found do
    local name = tostring( ng_global.progress["std"]["win_underfirtreeho"].found[j]["object"] );
    ObjDelete( name );
    private.count = private.count + 0.5;
    
    --ld.LogTrace( ng_global.progress["std"]["win_underfirtreeho"].found[j] )
  end;
  
  ObjSet("txt_underfirtreeho_taskpanel",{param0=private.count})
  
  
  
  if private.count==12 then
    ObjSet("spr_underfirtreeho_mmm",{input=1})
    ObjSet("txt_underfirtreeho_taskpanel",{text = "tsk_underfirtreeho_task_2"})
    ObjSet("anm_underfirtreeho_anim_branches_open",{frame=999,animfunc="branches_open"})
  end

  
  local first_enter = true;
  for n=1,9 do
    if ng_global.progress[ "std" ][ "win_underfirtreeho" ].state[n] then
      ObjSet("anm_underfirtreeho_anim_box"..n,{frame=0,animfunc="box"..n.."_close"})
      ObjSet("spr_underfirtreeho_box_"..n.."_cover",{input=0});
      private.box_contain(n,1);
      if first_enter then
        private.current_box = n;
        first_enter=false;
      else
        private.previous_box = n;
      end
    end
  end
  
  private.done = {}
  for n=1,#private.contain do
    doit = true;
    for s=1,#private.contain[n] do
      if private.item_check("spr_underfirtreeho_"..private.contain[n][s]) then
        doit = false;
      end
    end
    if doit then
      ObjSet("anm_underfirtreeho_anim_box"..n,{frame=0,animfunc="box"..n.."_close"})
      ObjSet("spr_underfirtreeho_box_"..n.."_cover",{input=0});
      private.done[n] = true;
    else
      private.done[n] = false;
    end
  end
  
end;
--*********************************************************************************************************************
function public.PreClose()

  --SoundHoTheme( false );
  interface.TaskPanelHide();
  ObjSet("int_simon",{ pos_x = 0 });
  
end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
--**********************************
function public.Close ()
  int_taskpanel_impl.ShowTextPanel( "underfirtreeho" );
end;
--***********************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_underfirtreeho_"..task_name, { pos_z = 1 } );
  cmn.HoTaskFind( "spr_underfirtreeho_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------




----------------------------------------------------------------------------
function private.box_click(box_number)
  
  if     private.current_box == 0 and private.previous_box == 0 then
    private.current_box = box_number;
    ng_global.progress[ "std" ][ "win_underfirtreeho" ].state[private.current_box] = true;
    
  elseif private.current_box ~= 0 and private.previous_box == 0 then
    private.previous_box = private.current_box;
    private.current_box = box_number;
    
    ng_global.progress[ "std" ][ "win_underfirtreeho" ].state[private.current_box] = true;
    
  elseif private.current_box ~= 0 and private.previous_box ~= 0 then
    
    ng_global.progress[ "std" ][ "win_underfirtreeho" ].state[private.previous_box] = false;
    ng_global.progress[ "std" ][ "win_underfirtreeho" ].state[private.current_box] = false;
    
    
    for n=1,#private.contain do
      doit = true;
      for s=1,#private.contain[n] do
        if private.item_check("spr_underfirtreeho_"..private.contain[n][s]) then
          doit = false;
        end
      end
      if doit then
        private.done[n] = true;
      else
        private.done[n] = false;
      end
      --ld.LogTrace("private.done["..n.."] = ");
      --ld.LogTrace(private.done[n]);
    end
    local sfx_close = false
    if not private.done[private.previous_box] then
             ObjSet("spr_underfirtreeho_box_"..private.previous_box.."_cover",{input=1})
      SoundSfx( "aud_close_gift_box", 0 )
      sfx_close = true
      ld.AnimPlay( "anm_underfirtreeho_anim_box"..private.previous_box, "box"..private.previous_box.."_close","");
    end
    if not private.done[private.current_box] then
             ObjSet("spr_underfirtreeho_box_"..private.current_box.."_cover", {input=1})
      if not sfx_close then
        SoundSfx( "aud_close_gift_box", 0 )
      end
      ld.AnimPlay( "anm_underfirtreeho_anim_box"..private.current_box, "box"..private.current_box.."_close","");
    end
    
    if ObjGet(private.highlight_object) then
      ObjSet(private.highlight_object,{visible=0})
    end
    
    ObjSet(private.previous_item,{visible=0})
    ObjSet(private.current_item, {visible=0})
    
    private.box_contain(private.previous_box,0)
    private.box_contain(private.current_box, 0)
    
    private.current_box = box_number;
    private.previous_box = 0;
    
    private.previous_item = "none"; 
    private.current_item = "none"; 
    private.highlight_object = "none";
    
    ng_global.progress[ "std" ][ "win_underfirtreeho" ].state[private.current_box] = true;
  end
  
  ld.Lock(1);
  SoundSfx( "aud_open_gift_box" )
  private.box_contain(private.current_box,1)
  ObjSet("spr_underfirtreeho_box_"..private.current_box.."_cover",{input=0})
  ld.AnimPlay( "anm_underfirtreeho_anim_box"..box_number, "box"..box_number.."_open",
  function()
    ld.Lock(0); 
  end )
  
end
----------------------------------------------------------------------------


function private.box_contain(box_number,status)
  for i=1,#private.contain[box_number] do
    local item = "spr_underfirtreeho_"..private.contain[box_number][i];
    if ObjGet(item) then
      ObjSet(item,{input=status})
    end
  end
end




----------------------------------------------------------------------------
function private.item_click(key,mul)
  SoundSfx( "aud_clk_ho" )
  if     private.current_item == "none" and private.previous_item == "none" then
    private.current_item = key;
    private.current_item_mul = mul;
  elseif private.current_item ~= "none" and private.previous_item == "none" then
    private.previous_item = private.current_item;
    private.previous_item_mul = private.current_item_mul;
    private.current_item = key;
    private.current_item_mul = mul;
    
    if private.current_item_mul==private.previous_item_mul and private.previous_item==private.current_item then
      ObjSet("spr_underfirtreeho_"..private.current_item..mul.."_light",{visible=0})
      private.previous_item = "none"; 
      private.current_item = "none"; 
      private.highlight_object = "none";
    end
    
  end
  
  
  
  if private.current_item ~= "none" and private.previous_item ~= "none" then
    if private.current_item == private.previous_item then
      
      ld.Lock(1);
      ld.StartTimer(1.0, function() ld.Lock(0) end)
      private.count=private.count+1;
      ObjSet("txt_underfirtreeho_taskpanel",{param0=private.count})
      for l=1,2 do
        local name = "spr_underfirtreeho_"..private.current_item..l;
        ObjSet( name, { pos_z = 1 } );
        cmn.HoTaskFind( name, private.current_item );
        --ld.StartTimer(1.2, function() ObjDelete(name); end)
      end
      private.previous_item = "none"; 
      private.current_item = "none";      
      if private.count==12 then
        SoundSfx( "aud_weeds_rise" )
        ld.AnimPlay("anm_underfirtreeho_anim_branches_open","branches_open",function() 
          ObjSet("spr_underfirtreeho_mmm",{input=1})
          ObjSet("txt_underfirtreeho_taskpanel",{text = "tsk_underfirtreeho_task_2"})
        end)
      end
      
      
    else
      SoundSfx( "aud_wrong_1" )
      local light1 = "spr_underfirtreeho_"..key..mul.."_light";
      local light2 = "spr_underfirtreeho_"..private.previous_item..private.previous_item_mul.."_light"
      local obj1 = "spr_underfirtreeho_"..key..mul;
      local obj2 = "spr_underfirtreeho_"..private.previous_item..private.previous_item_mul;
      
      
      local func_end = function()
        ObjSet(light1,{visible=0,alp=1,color_g=1,color_b=1});
        ObjSet(light2,{visible=0,alp=1,color_g=1,color_b=1});
        
        private.previous_item = "none"; 
        private.current_item = "none"; 
        private.highlight_object = "none";
        private.bliking = false;
        ld.Lock(0);
        
      end
      
      ld.Lock(1);
      private.bliking = true;
      local t = 0.55;
      
      
      ObjAnimate(light1, 8, 0, 0, "",             {0,0,1,   t*0.25,0,0,  t*0.5,0,1,  t*0.75,0,0,  t,0,1,  t*1.25,0,0});
      ObjAnimate(light2, 8, 0, 0, func_end,       {0,0,1,   t*0.25,0,0,  t*0.5,0,1,  t*0.75,0,0,  t,0,1,  t*1.25,0,0});
      
      ObjAnimate(light1, 10, 0, 0, "", {0,0,0, t,2,1});
      ObjAnimate(light2, 11, 0, 0, "", {0,0,0, t,2,1});
      
      ObjAnimate(obj1, 7, 0, 0, "", {0,0,0,  t*0.25,0,-0.1,   t*0.5,0,0,   t*0.75,0, 0.1,  t,0,0});
      ObjAnimate(obj2, 7, 0, 0, "", {0,0,0,  t*0.25,0, 0.1,   t*0.5,0,0,   t*0.75,0,-0.1,  t,0,0});
      
      
      ObjSet(light2,{color_g=0,color_b=0});
      
      
    end     
    
  else
    private.highlight_object = "spr_underfirtreeho_"..private.current_item..mul.."_light";
    ObjSet("spr_underfirtreeho_"..private.current_item..mul.."_light",{visible=1});
  end
end
----------------------------------------------------------------------------






----------------------------------------------------------------------------
function private.highlight_menter(object_name)
  if not private.bliking then
    ld.ShCur(CURSOR_HAND);
    ObjSet(object_name,{visible=1})
  end  
end
----------------------------------------------------------------------------
----------------------------------------------------------------------------
function private.highlight_mleave(object_name)
  if not private.bliking then
    ld.ShCur(CURSOR_DEFAULT);
    if private.highlight_object ~= object_name then
      ObjSet(object_name,{visible=0});
    end
  end
end
----------------------------------------------------------------------------





---------------------------------------------------------------------------
function private.HintShow(hint_obj_name)
  local hints_table = { hint = {} };
  table.insert( hints_table.hint,  { ["pos_x"]=ObjGet(hint_obj_name).pos_x, ["pos_y"]=ObjGet(hint_obj_name).pos_y, ["obj_name"]=hint_obj_name } )   
  MsgSend( Command_Effect_ShowHoHint, hints_table );
end





function private.item_check(object_name)
  local exist = false;
  if ObjGet(object_name) then
    if ObjGetRelations(object_name).parent == "ho_underfirtreeho" then
      exist = true;
    else
      exist = false;
    end
  else
    exist = false;
  end
  return exist
end


----------------------------------------------------------------------------
function public.clk_hint()
  
  if private.count==12 then
    private.HintShow("spr_underfirtreeho_mmm");
  else
  
  local box_hint1,box_hint2;
  local item_hint1,item_hint2;

  if     private.current_box == 0 and private.previous_box == 0 then
    for n = 1,#private.abc do
      local name = "spr_underfirtreeho_"..private.abc[n].."1";
      if private.item_check(name) then
        item_hint1 = name;
        for r = 1,#private.contain do
          for c = 1,#private.contain[r] do
            if private.abc[n].."1" == private.contain[r][c] and private.item_check("spr_underfirtreeho_"..private.contain[r][c]) then
              box_hint1 = r;
            end
            if private.abc[n].."2" == private.contain[r][c] and private.item_check("spr_underfirtreeho_"..private.contain[r][c]) then
              box_hint2 = r;
            end
          end
        end
        break;
      end
    end
    
    private.HintShow("spr_underfirtreeho_box_"..box_hint1.."_cover");
    private.HintShow("spr_underfirtreeho_box_"..box_hint2.."_cover");
    
    
    
    
  elseif private.current_box ~= 0 and private.previous_box == 0 then
  --else
    
    local key1;
    local fail = true;
    for c = 1,#private.contain[private.current_box] do
      local name = "spr_underfirtreeho_"..private.contain[private.current_box][c];
      if private.item_check(name) then
        fail = false;
        item_hint1 = name;
        key1=private.contain[private.current_box][c];
        key1=string.sub(key1,1,3);
        for rr = 1,#private.contain do
          for cc = 1,#private.contain[rr] do
            if (key1.."1" == private.contain[rr][cc] or key1.."2" == private.contain[rr][cc]) and private.item_check("spr_underfirtreeho_"..private.contain[rr][cc]) and rr ~= private.current_box then
              box_hint2 = rr;
              item_hint2 = "spr_underfirtreeho_"..private.contain[rr][cc];
            end
            
          end
        end
        private.HintShow(item_hint1);
        private.HintShow(item_hint2);
        break;
      end
    end
    
    
    if fail then
      for n = 1,#private.abc do
        local name = "spr_underfirtreeho_"..private.abc[n].."1";
        if private.item_check(name) then
          item_hint1 = name;
          item_hint2 = "spr_underfirtreeho_"..private.abc[n].."2";
          break;
        end
      end
      private.HintShow(item_hint1);
      private.HintShow(item_hint2);
    end
   
   
  elseif private.current_box ~= 0 and private.previous_box ~= 0 then  
    
    local fail_main = true;
    local fail_local = true;
    local key1,key2;
    for s = 1,#private.contain[private.current_box] do
      local name = "spr_underfirtreeho_"..private.contain[private.current_box][s]
      if private.item_check(name) then
        key1 = private.contain[private.current_box][s];
        key1=string.sub(key1,1,3);
        for v = 1,#private.contain[private.previous_box] do
          key2 = private.contain[private.previous_box][v];
          key2=string.sub(key2,1,3);
          
          if key1==key2 then
            
            --ld.LogTrace("way1")
            private.HintShow("spr_underfirtreeho_"..key1.."1");
            private.HintShow("spr_underfirtreeho_"..key2.."2");
            fail_main=false;
            
            break;
          end
        end
        if not fail_main then
          break;
        end
      end
    end  
      
    if fail_main then
      for c = 1,#private.contain[private.current_box] do
        local name = "spr_underfirtreeho_"..private.contain[private.current_box][c];
        if private.item_check(name) then
          fail_local = false;
          item_hint1 = name;
          key1=private.contain[private.current_box][c];
          key1=string.sub(key1,1,3);
          for rr = 1,#private.contain do
            for cc = 1,#private.contain[rr] do
              if (key1.."1" == private.contain[rr][cc] or key1.."2" == private.contain[rr][cc]) and private.item_check("spr_underfirtreeho_"..private.contain[rr][cc]) and rr ~= private.current_box then
                box_hint2 = rr;
                item_hint2 = "spr_underfirtreeho_"..private.contain[rr][cc];
              end
            end
          end
          
          --ld.LogTrace("way2")
          private.HintShow(item_hint1);
          private.HintShow(item_hint2);
          
          break;
        end
      end
        
        
        
        if fail_local then
          for c = 1,#private.contain[private.previous_box] do
            local name = "spr_underfirtreeho_"..private.contain[private.previous_box][c];
            if private.item_check(name) then
              fail_local = false;
              item_hint1 = name;
              key1=private.contain[private.previous_box][c];
              key1=string.sub(key1,1,3);
              for rr = 1,#private.contain do
                for cc = 1,#private.contain[rr] do
                  if (key1.."1" == private.contain[rr][cc] or key1.."2" == private.contain[rr][cc]) and private.item_check("spr_underfirtreeho_"..private.contain[rr][cc]) and rr ~= private.current_box and rr ~=private.previous_box then
                    box_hint2 = rr;
                    item_hint2 = "spr_underfirtreeho_"..private.contain[rr][cc];
                  end
                end
              end
              
              --ld.LogTrace("way3")
              private.HintShow(item_hint1);
              private.HintShow(item_hint2);
              
              break;
            end
          end
        end
        
        if fail_local then
          for n = 1,#private.abc do
            local name = "spr_underfirtreeho_"..private.abc[n].."1";
            if private.item_check(name) then
              item_hint1 = name;
              item_hint2 = "spr_underfirtreeho_"..private.abc[n].."2";
              break;
            end
          end
          
          --ld.LogTrace("way4")
          private.HintShow(item_hint1);
          private.HintShow(item_hint2);
          
        end
        
          
      
      
      
    end
    
  end
  
  
  end
end
----------------------------------------------------------------------------