-- name=ho_winterbalcony
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "winterbalcony" );
  game.relations[ "ho_winterbalcony" ].exitroom = "rm_newhall";
  
  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";
  private.abc[12] = "lll";
  
  private.abc2num = {};
  private.abc2num["aaa"]  = 1;
  private.abc2num["bbb"]  = 2;
  private.abc2num["ccc"]  = 3;
  private.abc2num["ddd"]  = 4;
  private.abc2num["eee"]  = 5;
  private.abc2num["fff"]  = 6;
  private.abc2num["ggg"]  = 7;
  private.abc2num["hhh"]  = 8;
  private.abc2num["iii"]  = 9;
  private.abc2num["jjj"] = 10;
  private.abc2num["kkk"] = 11;
  private.abc2num["lll"] = 12;
  
  --dependence
  private.dep={};
  private.dep[1] = 8;
  private.dep[2] = 7;
  private.dep[3] = 1;
  private.dep[4] = 2;
  private.dep[5] = 6;
  private.dep[6] = 5;
  private.dep[7] = 12;
  private.dep[8] = 11;
  private.dep[9] = 10;
  private.dep[10] = 9;
  private.dep[11] = 4;
  private.dep[12] = 3;
  
  private.xc={};              private.yc={}
  private.xc[1]=390-171;      private.yc[1]=435;
  private.xc[2]=427-171;      private.yc[2]=450;
  private.xc[3]=424-171;      private.yc[3]=484;
  private.xc[4]=368-171;      private.yc[4]=489;
  private.xc[5]=354-171;      private.yc[5]=455;
  private.xc[6]=366-171;      private.yc[6]=457;
  private.xc[7]=392-171;      private.yc[7]=449;
  private.xc[8]=409-171;      private.yc[8]=455;
  private.xc[9]=408-171;      private.yc[9]=472;
  private.xc[10]=376-171;     private.yc[10]=480;
  private.xc[11]=383-171;     private.yc[11]=470;
  private.xc[12]=380-171;     private.yc[12]=459;
  
  
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_winterbalcony" ] = { type = "win", room = "rm_newhall", zz = "ho_winterbalcony", zz_gate = "gho_newhall_winterbalcony" };
 
  local win_winterbalcony_func = function ()

    if ( cmn.IsEventDone( "win_winterbalcony" ) ) then
      interface.InventoryItemAdd( "inv_seastar2", "spr_winterbalcony_win" );
      ObjDelete( "gho_newhall_winterbalcony" );
    end;

  end;
  cmn.AddSubscriber( "win_winterbalcony", win_winterbalcony_func );
  
  local start_winterbalcony_func = function ()
  if not cmn.IsEventDone("win_winterbalcony") then
  
  end
  end;
  cmn.AddSubscriber( "win_winterbalcony", start_winterbalcony_func, "ho_winterbalcony" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_citystreets_env" )

  if ( not cmn.IsEventDone( "opn_winterbalcony" ) ) then

    cmn.InitHo( "winterbalcony" );

    cmn.SetEventDone( "opn_winterbalcony" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_winterbalcony_aaa", "obj_winterbalcony_hare" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_winterbalcony_bbb", "obj_winterbalcony_hare" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_winterbalcony_ccc", "obj_winterbalcony_hare" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_winterbalcony_ddd", "obj_winterbalcony_hare" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_winterbalcony_eee", "obj_winterbalcony_hare" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_winterbalcony_fff", "obj_winterbalcony_hare" } } );
  
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_winterbalcony_ggg" , "obj_winterbalcony_fox"} } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_winterbalcony_hhh" , "obj_winterbalcony_fox"} } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_winterbalcony_iii" , "obj_winterbalcony_fox"} } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_winterbalcony_jjj" , "obj_winterbalcony_fox"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_winterbalcony_kkk" , "obj_winterbalcony_fox"} } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_winterbalcony_lll" , "obj_winterbalcony_fox"} } );
  
  
  
  
  for n=1,#private.abc do
    local obj = "spr_winterbalcony_"..private.abc[n];
    ObjSet(obj,{
      event_mdown = function() end;
      event_dragdrop = function() private.event_dragdrop(private.abc[n]) end;
      event_startdrag = function() private.event_startdrag(private.abc[n]) end;
      drag = true;
      input=true;
    })
  end
  
  private.foodCountFox = 0;
  private.foodCountHare = 0;
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "winterbalcony" );
  
  local ns = 0;
  
  for j = 1, #ng_global.progress["std"]["win_winterbalcony"].found do
    ns=ns+1;
    local name = tostring( ng_global.progress["std"]["win_winterbalcony"].found[j]["object"] );
    ObjDelete( name );
    local key = tostring( ng_global.progress["std"]["win_winterbalcony"].found[j]["task"] );
    local num = private.abc2num[key];
    
    local dep=0;
    if num<=6 then
      private.foodCountHare = private.foodCountHare + 1;
      dep = private.foodCountHare;
    else
      private.foodCountFox = private.foodCountFox + 1;
      dep = private.foodCountFox+6;
    end
    
    local obj = "spr_winterbalcony_seastar_2_p"..(private.dep[dep]);
    local objToAtt = "ho_winterbalcony";
    ObjAttach(obj,objToAtt);
    ObjSet(obj,
    {
      visible=1;
      pos_x = private.xc[(private.dep[dep])];
      pos_y = private.yc[(private.dep[dep])];
    })
    
    if ObjGet(name.."_shadow") then
      ObjSet(name.."_shadow",{visible=false})
    end
  end;
  private.setCounter();
  if ns>0 then
    ObjSet("obj_winterbalcony_needalllstarpiece",{visible=1,input=1});
  end
end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.TaskPanelHide();
end;
--**********************************
function public.Close ()
  int_taskpanel_impl.ShowTextPanel( "winterbalcony" );
end;
--*********************************************************************************************************************
function public.HoComplete()
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_winterbalcony_"..task_name, { pos_z = 1, pos_x=-2000,visible=0,input=0,alp=0 } );
  cmn.HoTaskFind( "spr_winterbalcony_"..task_name, task_name );
  ObjSet("obj_winterbalcony_needalllstarpiece",{visible=1,input=1});
end;
-----------------------------------------------------------------------------------------------------------------------
function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;











-----------------------------------------------------------------------------------------------------------------------
function private.setCounter()
  ObjSet("txt_winterbalcony_taskpanel",{param0=12-private.foodCountHare-private.foodCountFox})
end
-----------------------------------------------------------------------------------------------------------------------
function private.event_startdrag(key)
  SoundSfx("aud_get_stuff")
  local obj = "spr_winterbalcony_"..key;
  ObjSet(obj,{pos_z=33})
  if ObjGet(obj.."_shadow") then
    ObjSet(obj.."_shadow",{visible=false})
  end
end
-----------------------------------------------------------------------------------------------------------------------
function private.event_dragdrop(key)
  local keyNum = private.abc2num[key];
  local obj = "spr_winterbalcony_"..key;
  local dep = 0;
  ObjSet(obj,{pos_z=0})
  local idle=true;
  
  local func_begin_star = function()
    local obj = "spr_winterbalcony_seastar_2_p"..(private.dep[dep]);
    local objToAtt = "anm_winterbalcony_anim_static_hare";
    if dep>6 then
      objToAtt = "anm_winterbalcony_anim_fox_body";
    end
    ObjAttach(obj,objToAtt);
    ObjSet(obj,{visible=1})
  end
  local func_end_star = function()
    local obj = "spr_winterbalcony_seastar_2_p"..(private.dep[dep]);
    local objToAtt = "ho_winterbalcony";
    ObjAttach(obj,objToAtt);
    ObjSet(obj,
    {
      pos_x = private.xc[(private.dep[dep])];
      pos_y = private.yc[(private.dep[dep])];
    })
    private.setCounter();
    
    if private.foodCountHare+private.foodCountFox==12 then
      
      local func_end = function()
        local t = 0.5;
        for p=1,12 do
          ObjAnimate("spr_winterbalcony_seastar_2_p"..p, 8, 0, 0, _, {0,0,1, t,0,0});
          private.sparkle("spr_winterbalcony_seastar_2_p"..p);
        end
        ld.StartTimer(t, function() private.TaskComplete( key );ld.Lock(0); end)
      end 
      
      ObjAnimate("anm_winterbalcony_anim_complete_star", 8, 0, 0, 
      function()
        ld.AnimPlay("anm_winterbalcony_anim_complete_star","complete_star",
        function()
          ObjAnimate("anm_winterbalcony_anim_complete_star", 8, 0, 0, func_end, {0,0,1, 0.3,0,0});
        end)
      end
      , {0,0,0, 0.3,0,1});  
        
    else
      ld.Lock(0)
      private.TaskComplete( key );
    end
    
    
  end
  
  
  if keyNum <=  6 and ObjIntersect(obj,"obj_winterbalcony_hare") then
    
    SoundSfx("aud_feed_rabbit")
    
    ld.Lock(1);
    idle=false;
    private.foodCountHare = private.foodCountHare + 1;
    dep = private.foodCountHare;
    ObjSet(obj,{pos_x=0;pos_y=0})
    if key=="fff" then
      ObjSet(obj,{res = ObjGet("spr_winterbalcony_fff_dop").res});
    end
    ObjAttach(obj,"anm_winterbalcony_anim_static_hare");
    func_begin_star(); 
    ld.AnimPlay("anm_winterbalcony_anim_static_hare","eat_hare",function() func_end_star(); ld.AnimPlay("anm_winterbalcony_anim_static_hare","static_hare", _) end)
  end
  if keyNum > 6 and ObjIntersect(obj,"obj_winterbalcony_fox") then
    
    SoundSfx("aud_feed_fox")
    
    ld.Lock(1);
    idle=false;
    private.foodCountFox = private.foodCountFox + 1;
    dep = private.foodCountFox + 6;
    ObjSet(obj,{pos_x=0;pos_y=0})
    ObjAttach(obj,"anm_winterbalcony_anim_fox_paw")
    func_begin_star();
    ld.AnimPlay("anm_winterbalcony_anim_fox_paw","eat_fox_paw",  function() ld.AnimPlay("anm_winterbalcony_anim_fox_paw","static_fox_paw", _) end)
    ld.AnimPlay("anm_winterbalcony_anim_fox_head","eat_fox_head",function() ld.AnimPlay("anm_winterbalcony_anim_fox_head","static_fox_head", _) end)
    ld.AnimPlay("anm_winterbalcony_anim_fox_body","eat_fox_body",function() func_end_star(); ld.AnimPlay("anm_winterbalcony_anim_fox_body","static_fox_body", _) end)
  end
  
  
  if keyNum <=  6 and not ObjIntersect(obj,"obj_winterbalcony_hare") and ObjIntersect(obj,"obj_winterbalcony_fox") then
    --ObjGet("obj_winterbalcony_fox").event_mdown();
    ld.Lock(1);
    SoundSfx( "aud_feed_fox_wrong" )
    ld.AnimPlay("anm_winterbalcony_anim_fox_paw","wrong_fox_paw",
    function()
      ld.Lock(0);
      common_impl.ShowBbt( 'winterbalcony_wrong_fox' );
      ld.AnimPlay("anm_winterbalcony_anim_fox_paw","static_fox_paw",_);
    end)
    ld.AnimPlay("anm_winterbalcony_anim_fox_head","wrong_fox_head", 
    function()   ld.AnimPlay("anm_winterbalcony_anim_fox_head","static_fox_head",_); end);
    ld.AnimPlay("anm_winterbalcony_anim_fox_body","wrong_fox_body", 
    function()   ld.AnimPlay("anm_winterbalcony_anim_fox_body","static_fox_body",_); end);

  end
  if keyNum >  6 and ObjIntersect(obj,"obj_winterbalcony_hare") and not ObjIntersect(obj,"obj_winterbalcony_fox") then
    --ObjGet("obj_winterbalcony_hare").event_mdown();
    ld.Lock(1);
    SoundSfx( "aud_feed_rabbit_wrong" )
    ld.AnimPlay(
    "anm_winterbalcony_anim_static_hare","wrong_hare",
      function()
        ld.Lock(0);
        common_impl.ShowBbt( 'winterbalcony_wrong_hare' );
        ld.AnimPlay("anm_winterbalcony_anim_static_hare","static_hare",_);
      end
    )  
  end
  
  
  if idle then
  if ObjGet(obj.."_shadow") then
    ObjSet(obj.."_shadow",{visible=true})
  end
  end
end




-- simple effect from HO -------------------------------------------------------
function private.sparkle(object_name)
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 32, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  
  PartSysSetMaskObj( collect_name, object_name );  
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
end
-- simple effect from HO -------------------------------------------------------