-- name=mg_citymg
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_citymg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_citymg" ] = {type = "win", use_place = "mg_citymg", room = "rm_cabinet", zz = "mg_citymg", zz_gate = "gmg_cabinet_citymg" };

  local win_citymg_logic = function()
    if ld.CheckRequirements( {"win_citymg"} ) then
      ObjSet( "spr_citymg_photo2", { visible = 1, input = 1, active = 1 } )
    end
  end;
  local win_citymg = function()
    if ld.CheckRequirements( {"win_citymg"} ) then
      ObjSet( "obj_citymg_root", { input = 0 } )
      ObjSet( "spr_citymg_tr5", { visible = 0 } )
      ObjSet( "anm_citymg_anm", { animfunc = "open_cap", frame = 999 } )
    end
  end;
  cmn.AddSubscriber("win_citymg", win_citymg, private.room_objname )
  cmn.AddSubscriber("win_citymg", win_citymg_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_santasrendeer" ] = { type = "get", get_obj = "spr_citymg_santasrendeer", room = "rm_cabinet", zz = "mg_citymg", zz_gate = "gmg_cabinet_citymg" };

private.get_santasrendeer_logic = function()
  
end;
private.get_santasrendeer_inv = function()
  interface.InventoryItemAdd("inv_santasrendeer","spr_citymg_santasrendeer");
end;
private.get_santasrendeer_beg = function()
  ObjDelete("gfx_citymg_santasrendeer")
end;
private.get_santasrendeer_end = function()
  ObjDelete( "spr_citymg_santasrendeer_shadow" )
end;

cmn.AddSubscriber( "get_santasrendeer", private.get_santasrendeer_inv );
cmn.AddSubscriber( "get_santasrendeer", private.get_santasrendeer_beg, private.room_objname );
cmn.AddSubscriber( "get_santasrendeer", private.get_santasrendeer_end, private.room_objname );
cmn.AddSubscriber( "get_santasrendeer", private.get_santasrendeer_logic );
--------------------------------------------------------------------
function public.get_santasrendeer()
  cmn.SetEventDone( "get_santasrendeer" );
  cmn.CallEventHandler( "get_santasrendeer" );
  if common_impl.ZzCompleteCheck( "get_santasrendeer" ) then cmn.GotoRoom( "rm_cabinet" ); end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_photo2" ] = { type = "get", get_obj = "spr_citymg_photo2", room = "rm_cabinet", zz = "mg_citymg", zz_gate = "gmg_cabinet_citymg" };

private.get_photo2_logic = function()
  ObjSet( "spr_citymg_santasrendeer", { visible = 1, input = 1, active = 1 } )
end;
private.get_photo2_inv = function()
  interface.InventoryItemAdd("inv_photo","spr_citymg_photo2",function() level_inv.ProcessGetPhotoAll( "get_photo2" ) end);
end;
private.get_photo2_beg = function()
  ObjDelete("gfx_citymg_photo2")
end;
private.get_photo2_end = function()
  ObjDelete( "spr_citymg_photo2_shadow" )
end;

cmn.AddSubscriber( "get_photo2", private.get_photo2_inv );
cmn.AddSubscriber( "get_photo2", private.get_photo2_beg, private.room_objname );
cmn.AddSubscriber( "get_photo2", private.get_photo2_end, private.room_objname );
cmn.AddSubscriber( "get_photo2", private.get_photo2_logic );
--------------------------------------------------------------------
function public.get_photo2()
  cmn.SetEventDone( "get_photo2" );
  cmn.CallEventHandler( "get_photo2" );
  if common_impl.ZzCompleteCheck( "get_photo2" ) then cmn.GotoRoom( "rm_cabinet" ); end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_citymg"} ) then
    ObjSet("obj_int_button_info",{ pos_y = 80 });
    ObjSet("obj_int_button_reset",{ pos_y = 154 });
    cmn.MiniGameShow( "citymg" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_cabinet_env" )
  SoundMgTheme( true )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_citymg"} ) then
    ObjSet("obj_int_button_info",{ pos_y = 510 });
    ObjSet("obj_int_button_reset",{ pos_y = 454 });
    cmn.MiniGameHide( "citymg" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
  SoundMgTheme( false )
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  ld.Lock( 1 )
  gm.available_hide_all()
  if gm.event_mdown_last then
    gm.vis_choice_off( gm.event_mdown_last[ 1 ], gm.event_mdown_last[ 2 ] )
    gm.event_mdown_last = false
  end
  for k, v in pairs( gm.visual ) do
    ObjAnimate( v.obj, 8,0,0, _, { 0,0,1, 0.2,2,0 } )
  end
  ld.StartTimer( 0.2, function() 
    gm.default()
    gm.set_all()
    gm.vis_player()
    for k, v in pairs( gm.visual ) do
      ObjAnimate( v.obj, 8,0,0, _, { 0,0,0, 0.2,1,1 } )
    end
    ld.StartTimer( 0.2, function() 
      gm.save()
      ld.Lock( 0 )
    end )
  end )
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  ld.Lock( 1 )
  gm.available_hide_all()
  if gm.event_mdown_last then
    gm.vis_choice_off( gm.event_mdown_last[ 1 ], gm.event_mdown_last[ 2 ] )
  end
  gm.map = {
    {-1,-1, 0, 0, 0, 1, 1, 1,11,-1,-1};
    { 0, 0, 0, 0, 0, 0, 0, 2, 2, 2,22};
    {-1,-1, 0, 0, 0, 3, 3, 3,33,-1,-1};
  }
  gm.visual = {}
  for j = 1, #gm.map do
    for i = 1, #gm.map[ j ] do
      if gm.map[ j ][ i ] > 0 then
        local vis = {}
        table.insert( gm.visual, vis );
        vis.id = #gm.visual
        vis.obj = "obj_citymg_visual_"..vis.id
        vis.anm = "anm_citymg_visual_"..vis.id
        vis.j = j;
        vis.i = i;
        vis.tp = gm.map[ j ][ i ];
        vis.clr = vis.tp % 10;
        vis.way = 1;
        vis.func_name_beg = gm.map[ j ][ i ] > 10 and "san" or "boy";
        ObjSet( vis.anm, { 
          res = "assets/levels/level/mg_citymg/boy"..( vis.clr ).."/anm";
        } )
      end;
    end;
  end;
  for k, v in pairs( gm.visual ) do
    ObjAnimate( v.obj, 8,0,0, _, { 0,0,1, 0.2,2,0 } )
  end
  ld.StartTimer( 0.2, function() 
    gm.set_all()
    gm.vis_player()
    for k, v in pairs( gm.visual ) do
      ObjAnimate( v.obj, 8,0,0, _, { 0,0,0, 0.2,1,1 } )
    end
    ld.StartTimer( 0.2, function() 
      private.Win();
    end )
  end )
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  gm.save()
  cmn.SetEventDone( "win_citymg" );
  cmn.CallEventHandler( "win_citymg" );
  if common_impl.ZzCompleteCheck( "win_citymg" ) then cmn.GotoRoom( "rm_citymg" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  ObjSet("obj_int_button_info",{ pos_y = 510 });
  ObjSet("obj_int_button_reset",{ pos_y = 454 });
  cmn.MiniGameHide();
  ObjDelete( "spr_citymg_tr5" )
  gm.vis_dance()
  SoundSfx( "aud_win_citymg" )
  ld.AnimPlay( "anm_citymg_anm", "open_cap", private.WinEnd )
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    gm.build()
    if ng_global.progress["std"]["win_citymg"].state then
      gm.visual = ld.TableCopy( ng_global.progress["std"]["win_citymg"].state )
    end
    
    gm.set_all()

    gm.vis_player_objs = {}
    gm.mouse_enter_events = {}
    gm.vis_player()

    if ld.CheckRequirements( { "win_citymg" } ) then
      gm.vis_dance()
    end;

    gm.loaded  = true;
  else
  
  end;
end
--*********************************************************************************************************************
function gm.default()
  gm.state ={}
  gm.map = {
    {-1,-1,33, 1, 0, 0, 3, 0, 0,-1,-1};
    { 3, 2,11, 0, 0, 0, 2, 1, 0, 0, 1};
    {-1,-1,22, 3, 0, 2, 0, 0, 0,-1,-1};
  }
  gm.visual = {}
  for j = 1, #gm.map do
    for i = 1, #gm.map[ j ] do
      if gm.map[ j ][ i ] > 0 then
        local vis = {}
        table.insert( gm.visual, vis );
        vis.id = #gm.visual
        vis.obj = "obj_citymg_visual_"..vis.id
        vis.anm = "anm_citymg_visual_"..vis.id
        vis.pfx = "pfx_citymg_visual_"..vis.id
        vis.j = j;
        vis.i = i;
        vis.tp = gm.map[ j ][ i ];
        vis.clr = vis.tp % 10;
        vis.way = 1;
        vis.func_name_beg = gm.map[ j ][ i ] > 10 and "san" or "boy";
      end;
    end;
  end;
  gm.connect = { {}; {}; {}; };
  gm.connect[ 1 ][ 8 ] = { { 2, 9 }; };
  gm.connect[ 2 ][ 9 ] = { { 1, 8 }; { 3, 8 } };
  gm.connect[ 3 ][ 8 ] = { { 2, 9 }; };
end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_citymg"].state = ld.TableCopy( gm.visual )
end;
--*********************************************************************************************************************
function gm.build()
  for j = 1, #gm.map do
    for i = 1, #gm.map[ j ] do
      if gm.map[ j ][ i ] >= 0 then
        ObjSet( "spr_citymg_control_"..j.."_"..i, {
          event_mdown  = function() gm.event_mdown(  j, i ) end;
          event_menter = function() gm.event_menter( j, i ) end;
          event_mleave = function() gm.event_mleave( j, i ) end;
          alp = 0;
          blendmode = 2;
          res = "assets/levels/level/mg_citymg/choice";
        } )
        local o = ObjGet( "spr_citymg_control_"..j.."_"..i )
        local obj = "spr_citymg_control_"..j.."_"..i.."_choice"
        ObjCreate( obj, "spr" )
        ObjSet( obj, { 
          res = "assets/levels/level/mg_citymg/light";
          alp = 0;
          pos_z = -33;
          input = 0;
          blendmode = 2;
          pos_x = o.pos_x;
          pos_y = o.pos_y;
        } )
        ObjAttach( obj, "obj_citymg_control_root" )
      end
      if gm.map[ j ][ i ] > 0 then
        local vis = gm.vis_get( j, i )

        ObjCreate( vis.obj, "obj" )
        ObjAttach( vis.obj, "obj_citymg_pole_root" )

        ObjCreate( vis.anm, "anim" )
        ObjSet( vis.anm, { 
          input = 1;
          inputrect_init = 1;
          event_mdown  = function() local vji = gm.vis_get_by_name( vis.obj ); gm.event_mdown( vji.j, vji.i ) end;
          event_menter = function() local vji = gm.vis_get_by_name( vis.obj ); gm.event_menter( vji.j, vji.i ) end;
          event_mleave = function() local vji = gm.vis_get_by_name( vis.obj ); gm.event_mleave( vji.j, vji.i ) end;
        } )
        ObjAttach( vis.anm, vis.obj )

        ObjCreate( vis.pfx, "partsys" )
        ObjSet( vis.pfx, { 
          res = "assets/levels/level/mg_citymg/fx_snow";
          playing = 0;
          pos_z = -999;
        } )
        ObjAttach( vis.pfx, "obj_citymg_pole_root" )

      end;
    end;
  end;

end
--*********************************************************************************************************************
function gm.set_all()
  local o;

  for k, v in pairs( gm.visual ) do
    o = ObjGet( "spr_citymg_control_"..v.j.."_"..v.i )
    ObjSet( v.obj, { pos_x = o.pos_x; pos_y = o.pos_y, pos_z = o.pos_y, ang = gm.vis_get_ang_by_x( o.pos_x ) } )
    ObjSet( v.anm, { 
      inputrect_x = v.func_name_beg == "boy" and -25 or -45;
      inputrect_y = v.func_name_beg == "boy" and -65 or -110;
      inputrect_w = v.func_name_beg == "boy" and  50 or  90;
      inputrect_h = v.func_name_beg == "boy" and  70 or 130;
      res = "assets/levels/level/mg_citymg/boy"..( v.clr ).."/anm";
    } )
  end;
  for i = 1, 5 do
    o = ObjGet( "spr_citymg_tr"..i )
    ObjSet( o.name, { pos_z = ( o.pos_y + o.draw_height / 2 ) } )
    ObjAttach( o.name, "obj_citymg_pole_root" )
  end;
end
--*********************************************************************************************************************
function gm.available_show( j, i, old )
  old = old or false
  if not old then
    gm.show_available_pathed = {}
  end;
  if gm.show_available_pathed[ j.."__"..i ] then
    return
  end;
  gm.show_available_pathed[ j.."__"..i ] = true;

  local jj, ii, o, vis;

  if gm.connect[ j ][ i ] then
    for z = 1, #gm.connect[ j ][ i ] do
      jj = gm.connect[ j ][ i ][ z ][ 1 ]
      ii = gm.connect[ j ][ i ][ z ][ 2 ]
      if gm.map[ jj ] and gm.map[ jj ][ ii ] and gm.map[ jj ][ ii ] >= 0 then
        vis = gm.vis_get( jj, ii )
        if not vis then
          o = ObjGet( "spr_citymg_control_"..jj.."_"..ii )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ( 1 - o.alp )*0.25,1,1 } )
          gm.available_show( jj, ii, true )
        end;
      end
    end;
  end

  --local w = { { 0, 1 }; { -1, 0 }; { 0, -1 }; { 1, 0 } }
  local w = { { 0, 1 }; { 0, -1 }; }

  for z = 1, #w do
    jj = j + w[ z ][ 1 ]
    ii = i + w[ z ][ 2 ]
    if gm.map[ jj ] and gm.map[ jj ][ ii ] and gm.map[ jj ][ ii ] >= 0 then
      vis = gm.vis_get( jj, ii )
      if not vis then
        o = ObjGet( "spr_citymg_control_"..jj.."_"..ii )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ( 1 - o.alp )*0.25,1,1 } )
        gm.available_show( jj, ii, true )
      end
    end
  end;
end
--*********************************************************************************************************************
function gm.available_hide_all()
  local o;
  for j = 1, #gm.map do
    for i = 1, #gm.map[ j ] do
      if gm.map[ j ][ i ] >= 0 then
        o = ObjGet( "spr_citymg_control_"..j.."_"..i )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ( o.alp )*0.25,2,0 } )
      end
    end;
  end;
end
--*********************************************************************************************************************
function gm.event_mdown( j, i )
  local vis = gm.vis_get( j, i );
  local move = false
  if gm.event_mdown_last then
    if ( gm.event_mdown_last[ 1 ] ~= j or gm.event_mdown_last[ 2 ] ~= i ) and gm.show_available_pathed[ j.."__"..i ] then
      if vis then
        --ld.ShCur(CURSOR_HAND)
        --gm.vis_choice_off( gm.event_mdown_last[ 1 ], gm.event_mdown_last[ 2 ] )
        --gm.vis_choice_on( j, i )
      else
        --ld.ShCur(CURSOR_HAND)
        --gm.vis_choice_on( j, i )
        move = true
        if gm.vis_get( gm.event_mdown_last[ 1 ],gm.event_mdown_last[ 2 ] ).func_name_beg == "boy" then
          SoundSfx( "aud_kid_moves" )
        else
          SoundSfx( "aud_santa_moves" )
        end
        gm.vis_move(  gm.event_mdown_last[ 1 ],gm.event_mdown_last[ 2 ], j, i )
      end
    else

    end
  else
    if vis then
      ld.ShCur(CURSOR_HAND)
      gm.vis_choice_on( j, i )
      SoundSfx( "aud_clk_kid_or_santa" )
    else

    end
  end;


  if gm.event_mdown_last and gm.show_available_pathed[ j.."__"..i ] and ( gm.event_mdown_last[ 1 ] ~= j or gm.event_mdown_last[ 2 ] ~= i ) then
    ld.ShCur(CURSOR_DEFAULT)
    gm.vis_choice_off( gm.event_mdown_last[ 1 ], gm.event_mdown_last[ 2 ] )
    gm.vis_choice_on( j, i )
    gm.event_mdown_last = { j, i }
    if not move then
      SoundSfx( "aud_clk_kid_or_santa" )
    end
  elseif not gm.event_mdown_last and vis then
    gm.vis_choice_on( j, i )
    gm.event_mdown_last = { j, i }
  end;

end
--*********************************************************************************************************************
function gm.vis_player( anm, play_func, loop )
  if not anm then
    gm.vis_player_objs = gm.vis_player_objs or {}
    for k, v in pairs( gm.visual ) do
      gm.vis_player_objs[ v.anm ] = v;
      gm.vis_player( v.anm )
    end
  else
    local vis = gm.vis_player_objs[ anm ]
    local animfunc;
    local o = ObjGet( anm )
    if not o then return end
    if play_func then
      if o.playing and o.animfunc == play_func then
        return
      else
        animfunc = play_func;
      end
    elseif gm.event_menter_last == anm then
      animfunc = vis.func_name_beg..( vis.way == 1 and 1 or 2 ).."_light";
      if o.playing and o.animfunc == animfunc then
        return
      end;
    else
      animfunc = vis.func_name_beg..( vis.way == 1 and 1 or 2 ).."_static"..( math.random() > 0.5 and 2 or "" );
    end
    ld.AnimPlay( vis.anm, animfunc, function() gm.vis_player( anm, loop and animfunc, loop ) end )
  end
end
--*********************************************************************************************************************
function gm.vis_dance()
  local t = 0;
  local ts = 0.1 + math.random()*0.1;
  for k, vis in pairs( gm.visual ) do
    t = t + ts
    ld.StartTimer( t, function() gm.vis_player( vis.anm, vis.func_name_beg..( vis.way == 1 and 1 or 2 ).."_light", true ) end )
  end  
end
--*********************************************************************************************************************
function gm.vis_get( j, i )
  for k, v in pairs( gm.visual ) do
    if v.j == j and v.i == i then
      return v;
    end
  end
  return false;
end;
--*********************************************************************************************************************
function gm.vis_get_by_name( name )
  for k, v in pairs( gm.visual ) do
    if v.obj == name then
      return v;
    end
  end
  return false;
end;
--*********************************************************************************************************************
function gm.vis_get_ang_by_x( x )
  return ( 375 - x ) / 2000
end;
--*********************************************************************************************************************
function gm.vis_move_path( j_from, i_from, j_to, i_to, pathed, path )
  if not pathed then
    pathed = {}
    path = {}
  end;
  if pathed[ j_from.."__"..i_from ] then
    return false
  end;
  pathed[ j_from.."__"..i_from ] = true;
  table.insert( path, { j_from, i_from } )

  if ( j_from == j_to ) and ( i_from == i_to ) then
    return path
  end;

  local jj, ii, o, vis;

  if gm.connect[ j_from ][ i_from ] then
    for z = 1, #gm.connect[ j_from ][ i_from ] do
      jj = gm.connect[ j_from ][ i_from ][ z ][ 1 ]
      ii = gm.connect[ j_from ][ i_from ][ z ][ 2 ]
      if gm.map[ jj ] and gm.map[ jj ][ ii ] and gm.map[ jj ][ ii ] >= 0 then
        vis = gm.vis_get( jj, ii )
        if not vis then
          local dist = gm.vis_move_path( jj, ii, j_to, i_to, pathed, ld.TableCopy( path ) )
          if dist then
            return dist;
          end
        end;
      end
    end;
  end

  --local w = { { 0, 1 }; { -1, 0 }; { 0, -1 }; { 1, 0 } }
  local w = { { 0, 1 }; { 0, -1 }; }
  for z = 1, #w do
    jj = j_from + w[ z ][ 1 ]
    ii = i_from + w[ z ][ 2 ]
    if gm.map[ jj ] and gm.map[ jj ][ ii ] and gm.map[ jj ][ ii ] >= 0 then
      vis = gm.vis_get( jj, ii )
      if not vis then
        local dist = gm.vis_move_path( jj, ii, j_to, i_to, pathed, ld.TableCopy( path ) )
        if dist then
          return dist;
        end
      end
    end
  end;
end;
--*********************************************************************************************************************
function gm.vis_move( j_from, i_from, j_to, i_to )
  ld.Lock( 1 )
  gm.vis_move_now = true;
  gm.available_hide_all()
  gm.event_mdown( gm.event_mdown_last[ 1 ], gm.event_mdown_last[ 2 ] )
  local path = gm.vis_move_path( j_from, i_from, j_to, i_to )
  table.remove( path, 1 )
  vis = gm.vis_get( j_from, i_from )
  ObjSet( vis.pfx, { playing = 1 } )
  PartSysRestart( vis.pfx )
  gm.vis_move_anim( path, vis )
end
--*********************************************************************************************************************
function gm.vis_move_anim( path, vis, last )
  if #path == 0 then
    PartSysStop( vis.pfx, 0 )
    gm.vis_move_anim_end( vis, last )
  else
    local m = table.remove( path, 1 )
    o1 = ObjGet( vis.obj )
    o2 = ObjGet( "spr_citymg_control_"..m[ 1 ].."_"..m[ 2 ] )
    local animfunc;
    if ( o2.pos_x + ( o2.pos_y - o1.pos_y ) / 2 ) > o1.pos_x then
      animfunc = vis.func_name_beg.."1";
    else
      animfunc = vis.func_name_beg.."2";
    end
    gm.vis_player( vis.anm, animfunc )
    local t = ( ( ( o1.pos_x - o2.pos_x ) ^ 2 + ( o1.pos_y - o2.pos_y ) ^ 2 ) ^ 0.5 ) / 300

    ObjAnimate( vis.pfx, 3,0,0, _, { 0,0,o1.pos_x,o1.pos_y, t,0,o2.pos_x,o2.pos_y } )

    ObjAnimate( vis.obj,"pos_z",0,0, _, { 0,0,o1.pos_y, t,0,o2.pos_y } )
    ObjAnimate( vis.obj,"ang",0,0, _, { 0,0,o1.ang, t,0,gm.vis_get_ang_by_x( o2.pos_x ) } )
    ObjAnimate( vis.obj, 3,0,0, function() 
      gm.vis_move_anim( path, vis, m )
    end, { 0,0,o1.pos_x,o1.pos_y, t,0,o2.pos_x,o2.pos_y } )
  end
end;
--*********************************************************************************************************************
function gm.vis_move_anim_end( vis, last )
  gm.vis_move_now = false;
  vis.j = last[ 1 ]
  vis.i = last[ 2 ]
  SndStop( "assets/levels/common/audio/aud_kid_moves", 0.25 )
  SndStop( "assets/levels/common/audio/aud_santa_moves", 0.25 )
  gm.vis_player( vis.anm, vis.func_name_beg.."1_static" )
  gm.event_mdown( last[ 1 ], last[ 2 ] )
  if gm.win_check() then
    gm.vis_choice_off( last[ 1 ], last[ 2 ] )
    private.Win();
  else
    gm.available_show( last[ 1 ], last[ 2 ] )
    gm.save()
    ld.Lock( 0 )
  end
end;
--*********************************************************************************************************************
function gm.vis_choice_on( j, i )
  local o = ObjGet( "spr_citymg_control_"..j.."_"..i.."_choice" )
  ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ( 1 - o.alp ) * 0.25,0,1 } )
end;
--*********************************************************************************************************************
function gm.vis_choice_off( j, i )
  local o = ObjGet( "spr_citymg_control_"..j.."_"..i.."_choice" )
  ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ( o.alp ) * 0.25,0,0 } )
end;
--*********************************************************************************************************************
function gm.win_check()
  local vis, hole
  for k, v in pairs( gm.visual ) do
    if v.clr ~= v.j then
      return false;
    end
  end;
  for j = 1, #gm.map do
    for i = #gm.map[ j ], 1, -1 do
      if gm.map[ j ][ i ] >= 0 then
        hole = false
        for z = i, 1, -1 do
          vis = gm.vis_get( j, z );
          if hole and vis then
            return false
          elseif not vis then
            hole = true;
          end
        end;
        break;
      end;
    end;
  end;
  for j = 1, #gm.map do
    for i = 1, #gm.map[ j ] do
      if  gm.map[ j ][ i + 1 ] then
        local vis1 = gm.vis_get( j, i );
        local vis2 = gm.vis_get( j, i + 1 );
        if vis1 and vis2 and vis1.tp > vis2.tp then
          return false
        end
      end;
    end;
  end;
  return true;
end;
--*********************************************************************************************************************
function gm.event_menter( j, i )
  local vis = gm.vis_get( j, i );
  -->>path
  if vis then
    gm.event_menter_last = vis.anm
    gm.vis_player( gm.event_menter_last )
    gm.available_hide_all()
    gm.available_show( j, i )
  end
  --<<path
  -->>choice
  if gm.event_mdown_last then
    if ( gm.event_mdown_last[ 1 ] ~= j or gm.event_mdown_last[ 2 ] ~= i ) and gm.show_available_pathed[ j.."__"..i ] then
      if vis then
        ld.ShCur(CURSOR_HAND)
        --gm.vis_choice_off( gm.event_mdown_last[ 1 ], gm.event_mdown_last[ 2 ] )
        --gm.vis_choice_on( j, i )
      else
        ld.ShCur(CURSOR_HAND)
        gm.vis_choice_on( j, i )
      end
    else

    end
        if vis then
          if vis.func_name_beg == "boy" then
            if not ObjGet( "tmr_aud_kid_in_focus" ) then
              SoundSfx( "aud_kid_in_focus" )
              ld.StartTimer( "tmr_aud_kid_in_focus", 1, function()  end )
            end
          else
            if not ObjGet( "tmr_aud_santa_in_focuss" ) then
              SoundSfx( "aud_santa_in_focus" )
              ld.StartTimer( "tmr_aud_santa_in_focuss", 1, function()  end )
            end
          end
        end
  else
    if vis then
      ld.ShCur(CURSOR_HAND)
        if vis then
          if vis.func_name_beg == "boy" then
            if not ObjGet( "tmr_aud_kid_in_focus" ) then
              SoundSfx( "aud_kid_in_focus" )
              ld.StartTimer( "tmr_aud_kid_in_focus", 1, function()  end )
            end
          else
            if not ObjGet( "tmr_aud_santa_in_focuss" ) then
              SoundSfx( "aud_santa_in_focus" )
              ld.StartTimer( "tmr_aud_santa_in_focuss", 1, function()  end )
            end
          end
        end
      gm.vis_choice_on( j, i )
    else

    end
  end;
  --<<choice
end;
--*********************************************************************************************************************
function gm.event_mleave( j, i )
  ld.ShCur(CURSOR_DEFAULT)
  if gm.vis_move_now then return end
  local vis = gm.vis_get( j, i );
  gm.event_menter_last = false;

  gm.available_hide_all()
  -->>path
  if gm.event_mdown_last then
    gm.available_show( gm.event_mdown_last[ 1 ], gm.event_mdown_last[ 2 ] )
  end
  --<<path
  -->>choice
  if gm.event_mdown_last then
    if ( gm.event_mdown_last[ 1 ] ~= j or gm.event_mdown_last[ 2 ] ~= i ) and gm.show_available_pathed[ j.."__"..i ] then
      if vis then
        --gm.vis_choice_off( j, i )
        --gm.vis_choice_on( gm.event_mdown_last[ 1 ], gm.event_mdown_last[ 2 ] )
      else
        gm.vis_choice_off( j, i )
      end
    else

    end
  else
    if vis then
      gm.vis_choice_off( j, i )
    else

    end
  end;
  --<<choice
end;