-- name=mg_hatsmg
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_hatsmg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_hatsmg" ] = {type = "win", use_place = "mg_hatsmg", room = "rm_dressroom", zz = "mg_hatsmg", zz_gate = "gmg_dressroom_hatsmg" };

  local win_hatsmg_logic = function()
    if ld.CheckRequirements( {"win_hatsmg"} ) then
      ObjSet("spr_hatsmg_camisole1",{visible=1,active=1,input=1})
      --ObjSet("spr_hatsmg_confectioner",{visible=1,active=1,input=1})
      --ObjSet("spr_hatsmg_goldenthreads",{visible=1,active=1,input=1})
    end
  end;
  local win_hatsmg = function()
    if ld.CheckRequirements( {"win_hatsmg"} ) then
      ObjSet("spr_hatsmg_hat2",{visible=false,active=false,input=false});
      ObjSet("anm_hatsmg_anm",{animfunc="circle1",frame=999});
      
      for n=1,8 do
        ObjSet("spr_hatsmg_hat"..n,{input=false});
      end
    end
  end;
  cmn.AddSubscriber("win_hatsmg", win_hatsmg, private.room_objname )
  cmn.AddSubscriber("win_hatsmg", win_hatsmg_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_goldenthreads" ] = { type = "get", get_obj = "spr_hatsmg_goldenthreads", room = "rm_dressroom", zz = "mg_hatsmg", zz_gate = "gmg_dressroom_hatsmg" };

private.get_goldenthreads_logic = function()
  
end;
private.get_goldenthreads_inv = function()
  interface.InventoryItemAdd("inv_goldenthreads","spr_hatsmg_goldenthreads");
end;
private.get_goldenthreads_beg = function()
  ObjDelete("gfx_hatsmg_goldenthreads")
end;
private.get_goldenthreads_end = function()
  ObjSet("anm_hatsmg_anm",{frame=999,animfunc="circle4"})
end;

cmn.AddSubscriber( "get_goldenthreads", private.get_goldenthreads_inv );
cmn.AddSubscriber( "get_goldenthreads", private.get_goldenthreads_beg, private.room_objname );
cmn.AddSubscriber( "get_goldenthreads", private.get_goldenthreads_end, private.room_objname );
cmn.AddSubscriber( "get_goldenthreads", private.get_goldenthreads_logic );
--------------------------------------------------------------------
function public.get_goldenthreads()
  cmn.SetEventDone( "get_goldenthreads" );
  cmn.CallEventHandler( "get_goldenthreads" );
  if common_impl.ZzCompleteCheck( "get_goldenthreads" ) then cmn.GotoRoom( "rm_dressroom" ); end;
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_confectioner" ] = { type = "get", get_obj = "spr_hatsmg_confectioner", room = "rm_dressroom", zz = "mg_hatsmg", zz_gate = "gmg_dressroom_hatsmg" };

private.get_confectioner_logic = function()
  ObjSet("spr_hatsmg_goldenthreads",{visible=1,active=1,input=1})
end;
private.get_confectioner_inv = function()
  interface.InventoryItemAdd("inv_confectioner","spr_hatsmg_confectioner");
end;
private.get_confectioner_beg = function()
  ObjDelete("gfx_hatsmg_confectioner")
end;
private.get_confectioner_end = function()
  ObjSet("anm_hatsmg_anm",{frame=999,animfunc="circle3"})
end;


cmn.AddSubscriber( "get_confectioner", private.get_confectioner_inv );
cmn.AddSubscriber( "get_confectioner", private.get_confectioner_beg, private.room_objname );
cmn.AddSubscriber( "get_confectioner", private.get_confectioner_end, private.room_objname );
cmn.AddSubscriber( "get_confectioner", private.get_confectioner_logic );
cmn.AddSubscriber( "get_confectioner_beg", private.get_confectioner_inv, private.room_objname );
cmn.AddSubscriber( "get_confectioner_beg", private.get_confectioner_beg, private.room_objname );
cmn.AddSubscriber( "get_confectioner_end", private.get_confectioner_end, private.room_objname );
cmn.AddSubscriber( "get_confectioner_end", private.get_confectioner_logic );

--------------------------------------------------------------------
function public.get_confectioner()
  --cmn.SetEventDone( "get_confectioner" );
  --cmn.CallEventHandler( "get_confectioner" );
  --if common_impl.ZzCompleteCheck( "get_confectioner" ) then cmn.GotoRoom( "rm_dressroom" ); end;
  local func_end = function()
    --ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "get_confectioner" );
    cmn.CallEventHandler( "get_confectioner_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("get_confectioner") then ld.CloseSubRoom() end;
  end;

  --ObjSet(obj,{visible = 0});
  --cmn.CallEventHandler( "get_confectioner_inv" );
  cmn.CallEventHandler( "get_confectioner_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hatsmg_anm", "circle3", func_end );
  SoundSfx( "aud_wheel_rotate" )
  
end
--------------------------------------------------------------------




--------------------------------------------------------------------
common_impl.hint[ "get_camisole1" ] = { type = "get", get_obj = "spr_hatsmg_camisole1", room = "rm_dressroom", zz = "mg_hatsmg", zz_gate = "gmg_dressroom_hatsmg" };

private.get_camisole1_logic = function()
  ObjSet("spr_hatsmg_confectioner",{visible=1,active=1,input=1})
end;
private.get_camisole1_inv = function()
  interface.InventoryItemAdd("inv_camisole","spr_hatsmg_camisole1",function() level_inv.ProcessGetCamisoleAll( "get_camisole1" ) end);
end;
private.get_camisole1_beg = function()
  ObjDelete("gfx_hatsmg_camisole1")
end;
private.get_camisole1_end = function()
  ObjSet("anm_hatsmg_anm",{frame=999,animfunc="circle2"})
end;

cmn.AddSubscriber( "get_camisole1",     private.get_camisole1_inv );
cmn.AddSubscriber( "get_camisole1",     private.get_camisole1_beg,    private.room_objname );
cmn.AddSubscriber( "get_camisole1",     private.get_camisole1_end,    private.room_objname );
cmn.AddSubscriber( "get_camisole1",     private.get_camisole1_logic );
cmn.AddSubscriber( "get_camisole1_beg", private.get_camisole1_inv,    private.room_objname );
cmn.AddSubscriber( "get_camisole1_beg", private.get_camisole1_beg,    private.room_objname );
cmn.AddSubscriber( "get_camisole1_end", private.get_camisole1_end,    private.room_objname );
cmn.AddSubscriber( "get_camisole1_end", private.get_camisole1_logic );
--------------------------------------------------------------------
function public.get_camisole1()
    
  local func_end = function()
    --ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "get_camisole1" );
    cmn.CallEventHandler( "get_camisole1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("get_camisole1") then ld.CloseSubRoom() end;
  end;

  --ObjSet(obj,{visible = 0});
  --cmn.CallEventHandler( "get_camisole1_inv" );
  cmn.CallEventHandler( "get_camisole1_beg" );
  common_impl.Lock(1);

  
  ld.AnimPlay( "anm_hatsmg_anm", "circle2", func_end );
  SoundSfx( "aud_wheel_rotate" )
  
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_hatsmg"} ) then
    cmn.MiniGameShow( "hatsmg" );
    SoundMgTheme( true )
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_dressroom_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_hatsmg"} ) then
    cmn.MiniGameHide( "hatsmg" );
    SoundMgTheme( false );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  
  local state_before = {}
  state_before = ld.TableCopy( gm.state );
  --gm.default();
  
  gm.state.x[1] = gm.etalon_x[5];
  gm.state.y[1] = gm.etalon_y[5];
  gm.state.x[2] = gm.etalon_x[3];
  gm.state.y[2] = gm.etalon_y[3];
  gm.state.x[3] = gm.etalon_x[1];
  gm.state.y[3] = gm.etalon_y[1];
  gm.state.x[4] = gm.etalon_x[2];
  gm.state.y[4] = gm.etalon_y[2];
  gm.state.x[5] = gm.etalon_x[4];
  gm.state.y[5] = gm.etalon_y[4];
  gm.state.x[6] = gm.etalon_x[7];
  gm.state.y[6] = gm.etalon_y[7];
  gm.state.x[7] = gm.etalon_x[6];
  gm.state.y[7] = gm.etalon_y[6];
  gm.state.x[8] = gm.etalon_x[8];
  gm.state.y[8] = gm.etalon_y[8];
  
  
  local slow_end = false;
  local t = 0.5;
  for n = 1,8 do
    if gm.state.x[n]~=state_before.x[n] or gm.state.y[n]~=state_before.y[n] then
      slow_end = true;
      local name = "spr_hatsmg_hat"..n;
      local o = ObjGet(name);
      ObjAnimate(name, 3, 0, 0, _, {0,0, o.pos_x, o.pos_y,       t*0.8,0, gm.state.x[n], gm.state.y[n]-10,     t,0, gm.state.x[n], gm.state.y[n]});
    end
  end
  
  if slow_end then
    ld.Lock(1);
    ld.StartTimer(t, function() ld.Lock(0);gm.save(); end);
  else
      gm.save();
  end
  
  
end;
--*********************************************************************************************************************
function public.Skip()
  
  ld.Lock(1)
  local t = 0.5;
  
  for n = 1,8 do
    if gm.state.x[n]~=gm.etalon_x[n] or gm.state.y[n]~=gm.etalon_y[n] then
      slow_end = true;
      local name = "spr_hatsmg_hat"..n;
      local o = ObjGet(name);
      ObjAnimate(name, 3, 0, 0, _, {0,0, o.pos_x, o.pos_y,       t*0.8,0, gm.etalon_x[n], gm.etalon_y[n]-10,     t,0, gm.etalon_x[n], gm.etalon_y[n]});
    end
  end
  
  ld.StartTimer(t, private.Win )
  
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  gm.save();
  cmn.SetEventDone( "win_hatsmg" );
  cmn.CallEventHandler( "win_hatsmg" );
  if common_impl.ZzCompleteCheck( "win_hatsmg" ) then cmn.GotoRoom( "rm_dressroom" ); end;
  interface_impl.ShowMgAchievements();
  
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide();
  SoundMgTheme( false )
  
  for n=1,8 do
    local name = "spr_hatsmg_hat"..n;
    gm.sparkle(name);
  end
  
  ObjSet("spr_hatsmg_hat2",{active=false,input=false,visible=false});
  ld.AnimPlay("anm_hatsmg_anm","circle1",function() private.WinEnd() end);
  --ld.StartTimer( 0.5, private.WinEnd  );
  SoundSfx("aud_win_hatsmg")
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
    if not ld.CheckRequirements( {"win_hatsmg"} ) then
      gm.default();
    end
    if ng_global.progress["std"]["win_hatsmg"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_hatsmg"].state )
    end
    gm.set_all();
    gm.loaded  = true;
  else
  
  end;
end
--*********************************************************************************************************************
function gm.default()
  gm.etalon_x = {};
  gm.etalon_y = {};
  for n=1,8 do
    local name = "spr_hatsmg_hat"..n;
    local o = ObjGet(name);
    gm.etalon_x[n] = o.pos_x;
    gm.etalon_y[n] = o.pos_y;
    
    ObjSet(name,{
      --event_menter = function() gm.event_menter( name ) end;
      --event_mleave = function() gm.event_mleave( name ) end;
      event_startdrag = function() gm.event_startdrag( n ) end;
      event_dragdrop = function() gm.event_dragdrop( n ) end;  
      drag=true;
      input=true;
      --pos_z=31;
    })
  end
  gm.state={}
  gm.state.x={}
  gm.state.y={}
  
  gm.state.x[1] = gm.etalon_x[5];
  gm.state.y[1] = gm.etalon_y[5];
  gm.state.x[2] = gm.etalon_x[3];
  gm.state.y[2] = gm.etalon_y[3];
  gm.state.x[3] = gm.etalon_x[1];
  gm.state.y[3] = gm.etalon_y[1];
  gm.state.x[4] = gm.etalon_x[2];
  gm.state.y[4] = gm.etalon_y[2];
  gm.state.x[5] = gm.etalon_x[4];
  gm.state.y[5] = gm.etalon_y[4];
  gm.state.x[6] = gm.etalon_x[7];
  gm.state.y[6] = gm.etalon_y[7];
  gm.state.x[7] = gm.etalon_x[6];
  gm.state.y[7] = gm.etalon_y[6];
  gm.state.x[8] = gm.etalon_x[8];
  gm.state.y[8] = gm.etalon_y[8];
  
  
end
--*********************************************************************************************************************
function gm.save()
  for n = 1,8 do
    local name = "spr_hatsmg_hat"..n;
    local o = ObjGet(name);
    gm.state.x[n] = o.pos_x;
    gm.state.y[n] = o.pos_y;
  end
  ng_global.progress["std"]["win_hatsmg"].state = ld.TableCopy( gm.state );
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()
  for n=1,8 do
    local name = "spr_hatsmg_hat"..n;
    ObjSet(name,{pos_x=gm.state.x[n],pos_y=gm.state.y[n]})
    
    if ObjGet(name).pos_y>400 then
      ObjSet(name,{pos_z=3});
    end
  end
end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_GET)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;
--*********************************************************************************************************************
function gm.event_startdrag(n)
  ld.ShCur(CURSOR_NULL)
  local name_n = "spr_hatsmg_hat"..n;
  ObjSet(name_n,{pos_z=33, inputrect_init=true, inputrect_x=-5, inputrect_y=120, inputrect_w=10,inputrect_h=10 })
  
  SoundSfx("aud_get_hat")
  
  for m=1,8 do
    if n~=m then
      local name = "spr_hatsmg_hat"..m;
      ObjSet(name,{inputrect_init=true, inputrect_x=-100, inputrect_y=30, inputrect_w=200,inputrect_h=230})
    end
  end
end
--*********************************************************************************************************************
function gm.event_dragdrop(n)
  ld.ShCur(CURSOR_DEFAULT)
  local droping = false;
  local name_n = "spr_hatsmg_hat"..n;
  SoundSfx( "aud_put_hat" );
  for m=1,8 do
    local name_m = "spr_hatsmg_hat"..m
    if ObjIntersect(name_m,name_n) and n~=m then
      droping=true;
      ld.Lock(1);
      local t = 0.2;
      local o_n = ObjGet(name_n);
      local o_m = ObjGet(name_m);
      local curs = GetZoomCursorPos();
      
      local func_end = function()
        
        
        
        
        if o_m.pos_y>400 then
          ObjSet(name_n,{pos_z=3, inputrect_init=false});
        else
          ObjSet(name_n,{pos_z=1, inputrect_init=false});
        end
        
        if o_n.pos_y>400 then
          ObjSet(name_m,{pos_z=3, inputrect_init=false});
        else
          ObjSet(name_m,{pos_z=1, inputrect_init=false});
        end
        
        
        
        for n = 1,8 do
          local name = "spr_hatsmg_hat"..n;
          local o = ObjGet(name);
          gm.state.x[n] = o.pos_x;
          gm.state.y[n] = o.pos_y;
        end
        
        local count=0;
        for n = 1,8 do
          local name = "spr_hatsmg_hat"..n;
          if gm.state.x[n]==gm.etalon_x[n] and gm.state.y[n]==gm.etalon_y[n] then
            gm.event_menter( name ); 
            count=count+1;
          else
            gm.event_mleave( name ); 
          end
        end
        
        if count==8 then  
          for n=1,8 do
            local name = "spr_hatsmg_hat"..n;
            ObjSet(name,{input=false});
          end  
          private.Win();
        else
          ObjSet(name_m,{pos_x=o_n.pos_x, pos_y=o_n.pos_y});
          gm.save();
          ld.Lock(0);
        end
        
        
      end
      
      ObjSet(name_m,{pos_z=10});
      ObjSet(name_n,{pos_x = curs[1],    pos_y = curs[2], pos_z=10});
      
      ObjAnimate(name_n, 3, 0, 0, _,        {0,0,curs[1],curs[2],       t*0.8,0, o_m.pos_x,o_m.pos_y-10,    t,0,o_m.pos_x,o_m.pos_y});
      ObjAnimate(name_m, 3, 0, 0, func_end, {0,0,o_m.pos_x,o_m.pos_y,   t*0.8,0, o_n.pos_x,o_n.pos_y-10,    t,0,o_n.pos_x,o_n.pos_y});
      
      break;
    end
  end
  
  
  if not droping then
    if ObjGet(name_n).pos_y>400 then
      ObjSet(name_n,{pos_z=3, inputrect_init=false});
    else
      ObjSet(name_n,{pos_z=1, inputrect_init=false});
    end
  end
  
  
  for m=1,8 do
    if n~=m then
      local name = "spr_hatsmg_hat"..m;
      ObjSet(name,{inputrect_init=false});
    end
  end
end
--*********************************************************************************************************************
-- simple effect from HO -------------------------------------------------------
function gm.sparkle(object_name,t_end)
  
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 100, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  
  PartSysSetMaskObj( collect_name, object_name );  
  
  if t_end then
    ld.StartTimer( t_end*0.97, function() PartSysStop(collect_name,0);  end )  
  else
    ld.StartTimer( 5, function() ObjDelete( collect_name ) end )  
  end
  
end
-- simple effect from HO -------------------------------------------------------