-- name=mg_labyrinth
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_labyrinth";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_labyrinth" ] = {type = "win", use_place = "mg_labyrinth", room = "rm_floor", zz = "mg_labyrinth", zz_gate = "gmg_floor_labyrinth" };

  local win_labyrinth_logic = function()
    if ld.CheckRequirements( {"win_labyrinth"} ) then
      ObjSet( "spr_labyrinth_ovalframe", {active = 1, input = 1, visible = 1} );
      ObjSet( "spr_labyrinth_slapstick", {active = 1, input = 1, visible = 1} );
    end
  end;
  local win_labyrinth = function()
    if ld.CheckRequirements( {"win_labyrinth"} ) then
       ObjSet( "obj_labyrinth_field_root_clone", {visible = 0} );
       ObjSet( "obj_labyrinth_logic_case_creator_root", {input = 0} );
    end
  end;
  cmn.AddSubscriber("win_labyrinth", win_labyrinth, private.room_objname )
  cmn.AddSubscriber("win_labyrinth", win_labyrinth_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_slapstick" ] = { type = "get", get_obj = "spr_labyrinth_slapstick", room = "rm_floor", zz = "mg_labyrinth", zz_gate = "gmg_floor_labyrinth" };

private.get_slapstick_logic = function()
  
end;
private.get_slapstick_inv = function()
  interface.InventoryItemAdd("inv_slapstick","spr_labyrinth_slapstick");
end;
private.get_slapstick_beg = function()
  ObjDelete("gfx_labyrinth_slapstick")
end;
private.get_slapstick_end = function()
  ObjDelete("spr_labyrinth_slapstick_sh")
end;

cmn.AddSubscriber( "get_slapstick", private.get_slapstick_inv );
cmn.AddSubscriber( "get_slapstick", private.get_slapstick_beg, private.room_objname );
cmn.AddSubscriber( "get_slapstick", private.get_slapstick_end, private.room_objname );
cmn.AddSubscriber( "get_slapstick", private.get_slapstick_logic );
--------------------------------------------------------------------
function public.get_slapstick()
  cmn.SetEventDone( "get_slapstick" );
  cmn.CallEventHandler( "get_slapstick" );
  if common_impl.ZzCompleteCheck( "get_slapstick" ) then cmn.GotoRoom( "rm_floor" ); end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ovalframe" ] = { type = "get", get_obj = "spr_labyrinth_ovalframe", room = "rm_floor", zz = "mg_labyrinth", zz_gate = "gmg_floor_labyrinth" };

private.get_ovalframe_logic = function()
  
end;
private.get_ovalframe_inv = function()
  interface.InventoryItemAdd("inv_ovalframe","spr_labyrinth_ovalframe");
  ObjSet( "inv_ovalframe", { drag = 0 } );
end;
private.get_ovalframe_beg = function()
  ObjDelete("gfx_labyrinth_ovalframe")
end;
private.get_ovalframe_end = function()
  
end;

cmn.AddSubscriber( "get_ovalframe", private.get_ovalframe_inv );
cmn.AddSubscriber( "get_ovalframe", private.get_ovalframe_beg, private.room_objname );
cmn.AddSubscriber( "get_ovalframe", private.get_ovalframe_end, private.room_objname );
cmn.AddSubscriber( "get_ovalframe", private.get_ovalframe_logic );
--------------------------------------------------------------------
function public.get_ovalframe()
  cmn.SetEventDone( "get_ovalframe" );
  cmn.CallEventHandler( "get_ovalframe" );
  if common_impl.ZzCompleteCheck( "get_ovalframe" ) then cmn.GotoRoom( "rm_floor" ); end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_labyrinth"} ) then
  SoundMgTheme( true )
    cmn.MiniGameShow( "labyrinth" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_hall_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_labyrinth"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "labyrinth" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  gm.state = {};
  gm.default()
  gm.build_arrows()
  gm.save()
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.Win(1);
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_labyrinth" );
  cmn.CallEventHandler( "win_labyrinth" );
  if common_impl.ZzCompleteCheck( "win_labyrinth" ) then cmn.GotoRoom( "rm_floor" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win(skip)
  ld.Lock(1);
  cmn.MiniGameHide();
  SoundMgTheme( false )
  SoundSfx( "aud_win_labyrinth" )
  --ld.StartTimer( 0.5, private.WinEnd  );
  local obj = ObjGet("spr_labyrinth_mose")
  local antime = skip and 2 or gm.anim_time
  ObjAnimate(obj.name, 3, 0, 0, function()
    ObjAnimate(obj.name, 6, 0, 0, function() 

      local time = 0.5
      for i,o in ipairs(gm.state) do
        ld.StartTimer( (i-1)*time/3, function()  
          ObjAnimate( gm.green_main.."_"..i, 8, 0, 0, function() end, {0,0,1, time/2,3,0, time,3,1} );
        end )
      end
    
      ObjAnimate( "obj_labyrinth_field_root_clone", 8, 0, 0, function() 
        private.WinEnd() 
      end, {0,0,1, (#gm.state-1)*time/3+time,0,1, (#gm.state-1)*time/3+time+gm.anim_time,0,0} );

    end, {0,0,1,1, antime/2,0,0.9,0.9} );
  end, {0,0,obj.pos_x,obj.pos_y, antime/2,0,272,3} );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then

    gm.max_state = 9;
    gm.grid_size = 82;
    gm.arrow_main = "spr_labyrinth_step_arrow";
    gm.green_main = "spr_labyrinth_step_green";
    gm.source = {ObjGet(gm.arrow_main),ObjGet(gm.green_main)};
    gm.map = {
      {1,1,1,1,1,1,1,1,1,1,1},
      {1,0,0,0,1,0,0,0,0,0,1},
      {1,0,0,0,1,0,1,0,0,0,1},
      {1,0,0,0,0,0,1,0,0,0,1},
      {1,0,1,1,1,1,1,0,1,0,1},
      {0,0,1,0,0,0,1,0,1,0,0},
      {1,0,1,0,1,0,1,0,1,1,1},
      {1,0,0,0,1,0,1,0,0,0,1},
      {1,1,1,0,1,0,1,1,1,0,1},
      {1,0,0,0,0,0,0,0,0,0,1},
      {1,1,1,1,1,1,1,1,1,1,1}
    } 
    gm.map_start = {-164, -164}
    gm.mouse_start = {1,3}
    gm.mouse_finish = {6,3}
    gm.anim_time = 0.5;
    gm.state = {};
    gm.default()

    if ng_global.progress["std"]["win_labyrinth"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_labyrinth"].state )
    end

    gm.build()

  
    gm.loaded  = true;
  else
  
  end;
end
--*********************************************************************************************************************
function gm.ang_closer( a_beg, a_end )
  if math.abs(a_beg-a_end) > math.pi then
    if a_beg > a_end then
      a_beg = a_beg - math.pi * 2
    else
      a_beg = a_beg + math.pi * 2
    end;
  end;
  return a_beg;
end;
--*********************************************************************************************************************
function gm.default(anim)
  gm.mouse_pos = {1,3}
  if not ng_global.progress["std"]["win_labyrinth"].state then
    gm.set_mouse({0,3})
    ld.Lock(1)
    local obj = ObjGet("spr_labyrinth_mose");
    ObjAnimate( obj.name, 3, 0, 0, function() gm.save() ld.Lock(0) end, 
          {0,0,            obj.pos_x,              obj.pos_y, 
          gm.anim_time,3, obj.pos_x+gm.grid_size, obj.pos_y} );
  else
    if anim then
      local steps = gm.rot_now == 3 and 1 or gm.rot_now;
      ld.Lock(1)
      ld.StartTimer( (steps+2)*gm.anim_time, function() ld.Lock(0) end )
      if gm.ang_closer(ObjGet("obj_labyrinth_field_root").ang,0) > 0.1 then
        SoundSfx( "aud_turn_plate" )
      end
      ObjAnimate( "obj_labyrinth_field_root", 7, 0, 0, function() end,
        {0,0,gm.ang_closer(ObjGet("obj_labyrinth_field_root").ang,0), 
        steps*gm.anim_time,3,0} );

      ObjAnimate( "spr_labyrinth_mose", 8, 0, 0, function() 
        gm.set_mouse()
        ObjAnimate( "spr_labyrinth_mose", 8, 0, 0, function() 
        end, {0,0,0, gm.anim_time,3,1} );
      end, {0,0,1, steps*gm.anim_time,0,1, (steps+1)*gm.anim_time,3,0} );

    else
      gm.set_mouse()
      ObjSet("obj_labyrinth_field_root",{ang = 0})
    end
  end  
end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_labyrinth"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()
  local buttons = {"spr_labyrinth_arrow1","spr_labyrinth_arrow2","spr_labyrinth_arrow3","spr_labyrinth_play"}
  local funcs = {
    function()SoundSfx( "aud_clk_arrow" ) gm.add_rot(-1) end,
    function()SoundSfx( "aud_clk_arrow" ) gm.add_rot(1) end,
    function()SoundSfx( "aud_clk_arrow" ) gm.del_rot() end,
    function()SoundSfx( "aud_clk_arrow" ) gm.play() end
  }
  for i,o in ipairs(buttons) do
    local light = o.."_light"
    ObjSet( o, {
      input = 1;
      event_mdown = funcs[i];
      event_menter = function() gm.button_menter(light) end;
      event_mleave = function() gm.button_mleave(light) end;
    } );
    ld.CopyObj(o, o.."_light", "spr", o)
    ObjSet(light, {pos_x = 0, pos_y = o, blendmode = 2, alp = 0})
  end

  gm.build_arrows()
--
--  if ld.IsLdCheater() then
--    ObjSet( "spr_labyrinth_testsave", {
--      input = 1;
--      visible = 1;
--      event_mdown = function() gm.test() end;
--    } );
--  end  
  --gm.test_build_field()

end

--!! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! TEST !! 
--function gm.test_build_field()
--  local size = (#gm.map-1)/2 -- from 11 to 5
--  for j = 1,size do
--    for i = 1,size do
--      local name = "spr_labyrinth_mose"..i..j
--      if not ObjGet(name) then
--        ld.CopyObj("spr_labyrinth_mose", name, "spr", "obj_labyrinth_field_root")
--        ObjSet( name, {pos_x = gm.map_start[1] + (i-1)*gm.grid_size, pos_y = gm.map_start[2] + (j-1)*gm.grid_size} );
--      end
--    end
--  end
--end
--
--function gm.test()
--  ld.LogTrace( gm.state );
--end
--*********************************************************************************************************************
function gm.button_menter(light)
  ld.ShCur(CURSOR_HAND)
  ObjAnimate( light, 8, 0, 0, function() end, {0,0,ObjGet(light).alp, 0.2,3,1} );
end
function gm.button_mleave(light)
  ld.ShCur(CURSOR_DEFAULT)
  ObjAnimate( light, 8, 0, 0, function() end, {0,0,ObjGet(light).alp, 0.2,3,0} );
end
--*********************************************************************************************************************
function gm.set_mouse(pos, ang)
  ang = ang or 0;
  pos = pos or gm.mouse_start;
  if ld.CheckRequirements( {"win_labyrinth"} ) then
    ObjSet( "spr_labyrinth_mose", {pos_x = 272, pos_y = 3, ang = 0, scale_x = 0.9, scale_y = 0.9} );
  else
    ObjSet( "spr_labyrinth_mose", {pos_x = gm.map_start[1] + (pos[1]-1)*gm.grid_size,
                                   pos_y = gm.map_start[2] + (pos[2]-1)*gm.grid_size,
                                   ang = ang} );
  end
end
--*********************************************************************************************************************
function gm.build_arrows()
  for i = 1,gm.max_state do
    local arrow = "spr_labyrinth_step_arrow_"..i;
    if gm.state[i] then
      if ObjGet(arrow) then
      else
        gm.arrow_add(i)
      end
    else
      gm.arrow_del(i)
    end
  end
end
--*********************************************************************************************************************
function gm.arrow_del(n)
  for i,o in ipairs(gm.source) do
    ObjDelete(o.name.."_"..n)
    ObjDelete(o.name.."_"..n)
  end
end
--*********************************************************************************************************************
function gm.arrow_add(n)
  for i,o in ipairs(gm.source) do
    ld.CopyObj(o.name, o.name.."_"..n, "spr", "obj_labyrinth_green")
    ObjSet( o.name.."_"..n, {pos_x = o.pos_x + (n-1)*24} );
    ObjSet( o.name.."_"..n, {visible = true} );
  end
  ObjSet( gm.arrow_main.."_"..n, {scale_x = -gm.state[n]} );
end
--*********************************************************************************************************************
function gm.del_rot()
  if #gm.state > 0 then
    table.remove(gm.state)
    gm.arrow_del(#gm.state+1)
    gm.save()
  end
end
--*********************************************************************************************************************
function gm.add_rot(rot)
  if #gm.state < gm.max_state then
    table.insert(gm.state,rot)
    gm.arrow_add(#gm.state)
    gm.save()
  end
end
--*********************************************************************************************************************
function gm.play(index)
  local time = gm.anim_time
  if not index then
    gm.rot_now = 0;
  end
  index = index or 1;
  if #gm.state == 0 then
    return
  end
  ObjSet( gm.green_main.."_"..(index-1), {visible = 1} );
  if index > #gm.state or gm.wincheck() then
    ld.Lock(0);
    if not gm.wincheck() then
      ld.Lock(1)
      SoundSfx( "aud_red_mouse" )
      ObjAnimate( "spr_labyrinth_mose", 12, 0, 0, function() ld.Lock(0)
        gm.default(true);
      end, {0,0,1,1,1, gm.anim_time,3,1,0.5,0.5, 2*gm.anim_time,3,1,1,1} );
    else
      private.Win()
    end
    return;
  else
    ObjSet( gm.green_main.."_"..index, {visible = 0} );
  end
  ld.Lock(1);
  local obj = ObjGet("spr_labyrinth_mose")
  local fieldRoot = ObjGet("obj_labyrinth_field_root")
  local rotateTo = gm.state[index] * math.pi/2; -- + or - 90 grades
  gm.rot_now = (gm.rot_now + gm.state[index])%4;
  local xy,movetime = gm.dist_to_wall(gm.rot_now)
  ObjAnimate( fieldRoot.name, 7, 0, 0, function() 
  end, {0,0,fieldRoot.ang, time,3,fieldRoot.ang + rotateTo} );

  SoundSfx( "aud_turn_plate" )

  ObjAnimate( obj.name, 7, 0, 0, function() 
    if xy[1] ~= 0 or xy[2] ~= 0 then
      SoundSfx( "aud_mouse_moves" )
    end
    ObjAnimate( obj.name, 3, 0, 0, function() 
      SndStop( "assets/levels/common/audio/aud_mouse_moves", 0.25 )
      gm.play(index+1);
    end, {0,0,obj.pos_x,obj.pos_y, movetime,3,obj.pos_x + xy[1],obj.pos_y + xy[2]} );
  end, {0,0,obj.ang, time,3,obj.ang - rotateTo} );
  
end
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.dist_to_wall(rot_now)

  local xy = {0,0}
  local movetime = 0
  local celltime = gm.anim_time
  local rot_pattern = {
                      [0] = { 1, 0},
                      [1] = { 0, 1},
                      [2] = {-1, 0},
                      [3] = { 0,-1}
                      }
  local rpn = rot_pattern[rot_now];

  local mt = {
      __add = function(t1, t2)
          return {t1[1]+t2[1], t1[2]+t2[2]}
      end,
      __mul = function(t1, t2) 
          return {t1[1]*t2, t1[2]*t2}
      end
  }

  while (gm.map[ 2*gm.mouse_pos[2] + rpn[2] ][ 2*gm.mouse_pos[1] + rpn[1] ] == 0) do -- следующая ячейка свободна
    setmetatable(xy,mt)
    setmetatable(rpn,mt)
    setmetatable(gm.mouse_pos,mt)
    xy = xy + rpn * gm.grid_size;
    gm.mouse_pos = gm.mouse_pos + rpn;
    movetime = movetime + celltime;
  end
  movetime = movetime == 0 and celltime or movetime; --добавить минимальное время простоя(равно времени хода)
  return xy,movetime;
end
--function <bkp>gm.dist_to_wall(rot_now)
--
--  local x,y,movetime = 0,0,0
--  local celltime = 0.5
--  local rot_pattern = {
--                      [0] = { 1, 0},
--                      [1] = { 0, 1},
--                      [2] = {-1, 0},
--                      [3] = { 0,-1}
--                      }
--  local rpn = rot_pattern[rot_now];
--
--  local function get_dist() 
--    if true then
--      return true;
--    else
--      return false;
--    end
--  end
--
--  if gm.map[ 2*gm.mouse_pos[2] + rpn[2] ][ 2*gm.mouse_pos[1] + rpn[1] ] == 0 then -- следующая ячейка свободна
--
--    x = x + gm.grid_size * rpn[1];
--    y = y + gm.grid_size * rpn[2];
--    movetime = movetime + celltime;
--    gm.mouse_pos = {gm.mouse_pos[1]+rpn[1],gm.mouse_pos[2]+rpn[2]}
--
--  end
--  movetime = movetime == 0 and celltime or movetime; --добавить минимальное время простоя(равно времени хода)
--  return x,y,movetime;
--end
--*********************************************************************************************************************
function gm.wincheck()
  return ld.TableEquals(gm.mouse_pos,gm.mouse_finish);
end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;