-- name=mg_mousemg
private.game = {};
local gm = private.game;
gm.R = 11;
gm.C = 6;
gm.fr1 =   {1,2,3,4,5,6,7,8,9,10,11,12};
gm.fr2 = {0,1,2,3,4,5,6,7,8,9,10,11,12};
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_mousemg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mousemg" ] = {type = "win", use_place = "mg_mousemg", room = "rm_bedroom", zz = "mg_mousemg", zz_gate = "gmg_bedroom_mousemg" };

  local win_mousemg_logic = function()
    if ld.CheckRequirements( {"win_mousemg"} ) then
      ObjSet("spr_mousemg_mousemessage",{visible=1,input=1,active=1})
    end
  end;
  local win_mousemg = function()
    
  end;
  cmn.AddSubscriber("win_mousemg", win_mousemg, private.room_objname )
  cmn.AddSubscriber("win_mousemg", win_mousemg_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_mousemessage" ] = { type = "get", get_obj = "spr_mousemg_mousemessage", room = "rm_bedroom", zz = "mg_mousemg", zz_gate = "gmg_bedroom_mousemg" };

private.get_mousemessage_logic = function()
  
end;
private.get_mousemessage_inv = function()
  interface.InventoryItemAdd("inv_mousemessage","spr_mousemg_mousemessage");
  ObjSet( "inv_mousemessage", { drag = 0 } );
end;
private.get_mousemessage_beg = function()
  ObjDelete("gfx_mousemg_mousemessage")
end;
private.get_mousemessage_end = function()
  
end;

cmn.AddSubscriber( "get_mousemessage", private.get_mousemessage_inv );
cmn.AddSubscriber( "get_mousemessage", private.get_mousemessage_beg, private.room_objname );
cmn.AddSubscriber( "get_mousemessage", private.get_mousemessage_end, private.room_objname );
cmn.AddSubscriber( "get_mousemessage", private.get_mousemessage_logic );
--------------------------------------------------------------------
function public.get_mousemessage()
  cmn.SetEventDone( "get_mousemessage" );
  cmn.CallEventHandler( "get_mousemessage" );
  if common_impl.ZzCompleteCheck( "get_mousemessage" ) then cmn.GotoRoom( "rm_bedroom" ); end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_mousemg"} ) then
    cmn.MiniGameShow( "mousemg" );
    SoundMgTheme( true )
  end
  
  private.anim_list = {"mouse_stat1","mouse_stat2"};
  private.delays = {50,70};
  private.static_anim("anm_mousemg_anm",private.anim_list,private.delays);
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  SoundEnv( "aud_bedroom_env" )
  
  
  gm.x0 = ObjGet("spr_mousemg_stick_player").pos_x;
  gm.y0 = ObjGet("spr_mousemg_stick_player").pos_y;
  
  gm.x1 = ObjGet("spr_mousemg_stick_enemy").pos_x;
  gm.y1 = ObjGet("spr_mousemg_stick_enemy").pos_y;
  
  gm.x2 = ObjGet("spr_mousemg_stick_enemy_throw").pos_x;
  gm.y2 = ObjGet("spr_mousemg_stick_enemy_throw").pos_y;
  
  
  
  gm.default();
  if ng_global.progress["std"]["win_mousemg"].state then
    gm.state = ld.TableCopy( ng_global.progress["std"]["win_mousemg"].state );
  end
  
  gm.set_all();  
    
end;
--*********************************************************************************************************************
function public.Close()
  ObjDelete("tmr_mousemg_anm")
  if not ld.CheckRequirements( {"win_mousemg"} ) then
    cmn.MiniGameHide( "mousemg" );
    SoundMgTheme( false )
  end
end;
--*********************************************************************************************************************
function public.PreClose()
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  gm.move_again=false;
  local t = 1;
  local fast_end = true;

  -- remove all vertical and horizontal sticks
  for r=1,gm.R do
    for c=1,gm.C do
      r=math.tointeger(r)
      c=math.tointeger(c)
      local stick = "spr_mousemg_stick_"..r.."_"..c;
      local res = gm.state.pos[r][c];
      local s;
      if res==1 then
        s=2;
      elseif res==2 then
        s=1;
      end
      if res>0 then
        
        fast_end = false;
        local o = ObjGet(stick)
        local x,y;
        if res==1 then
          x = gm.x0;
          y = gm.y0
        else
          x = gm.x1;
          y = gm.y1;
        end
        
        local func_end = function()
          ObjSet(stick,{pos_x=o.pos_x,pos_y=o.pos_y,ang=o.ang,alp=0,res="assets/levels/level/mg_mousemg/2"})
        end
        
        local t_rand = t*math.random(30,80)/100;
        ObjAnimate(stick, 3, 0, 0, func_end, {0,0,o.pos_x,o.pos_y,   t_rand,0,x,y});
        ObjAnimate(stick, 7, 0, 0, _,        {0,0,o.ang,             t_rand,0,0});
        
      end
    end
  end
  
  -- remove all cross
  for c1=1,gm.C do
    for c2=1,gm.C do  
      if gm.state.cross[c1][c2]>0 then
        c1=math.tointeger(c1)
        c2=math.tointeger(c2)
        local cross = "spr_mousemg_cross_"..c1.."_"..c2;
        local cross_dop = "spr_mousemg_cross_"..c1.."_"..c2.."_dop";
        local o_cross = ObjGet(cross);
        local o_cross_dop = ObjGet(cross_dop);
        
        local func_end = function()
          ObjSet(cross,{alp=0,res="assets/levels/level/mg_mousemg/2",      pos_x = o_cross.pos_x,     pos_y = o_cross.pos_y,     ang=o_cross.ang})
          ObjSet(cross_dop,{alp=0,res="assets/levels/level/mg_mousemg/2",  pos_x = o_cross_dop.pos_x, pos_y = o_cross_dop.pos_y, ang=o_cross_dop.ang})
        end
        
        
        local x,y;
        if gm.state.cross[c1][c2]==1 then
          x = gm.x0;
          y = gm.y0;
        else
          x = gm.x1;
          y = gm.y1;
        end
        
        local t1 = t*math.random(50,90)/100;
        local t2 = t*math.random(50,90)/100;
        ObjAnimate(cross, 7, 0, 0, func_end,     {0,0,o_cross.ang,                                t*1.05,0,0});
        ObjAnimate(cross, 3, 0, 0, _,            {0,0,o_cross.pos_x,  o_cross.pos_y,              t2,0,x,y});

        ObjAnimate(cross_dop, 7, 0, 0, _,        {0,0,o_cross_dop.ang,                            t1,0,0});
        ObjAnimate(cross_dop, 3, 0, 0, _,        {0,0,o_cross_dop.pos_x,  o_cross_dop.pos_y,      t2,0,x,y});

        
      end
    end
  end
  
  
  gm.default();
  if not fast_end then
    SoundSfx( "aud_reset_mousemg" )
    ld.Lock(1)
    ld.StartTimer(t,function() ld.Lock(0);gm.save(); end)
  end
  ObjSet("txt_mousemg_playerpoint",{text = tostring(0)})
  ObjSet("txt_mousemg_enemypoint", {text = tostring(0)})
  
end;
--*********************************************************************************************************************
function public.Skip()
  local func_end = function()
    ObjSet("txt_mousemg_playerpoint",{text = tostring(36)})
    ObjSet("txt_mousemg_enemypoint", {text = tostring(0)})
    
    private.Win();
  end
  
  
  
  SoundSfx( "aud_skip_mousemg" )
  
  
  local func_step = function()
    
    SoundSfx( "aud_skip_mousemg" )
    
    local fast_end_2 = true;
    
    local t = 1;
    
    for r=1,gm.R do
      for c=1,gm.C do
        r=math.tointeger(r)
        c=math.tointeger(c)
        local stick = "spr_mousemg_stick_"..r.."_"..c;
        if ObjGet(stick) then 
          if gm.state.pos[r][c]==0 then
            
            local o1 = ObjGet(stick);
            local t_rand = t*math.random(50,90)/100
            ObjSet(stick,{alp=1})
            ObjAnimate(stick, 7, 0, 0, _,         {0,0,0,                   t_rand,0,o1.ang});
            ObjAnimate(stick, 6, 0, 0, _,         {0,0,1,1,                 t_rand,0,o1.scale_x, o1.scale_y});
            ObjAnimate(stick, 3, 0, 0, _,         {0,0,gm.x0,  gm.y0,       t_rand,0,o1.pos_x,   o1.pos_y});
            
            
            gm.state.pos[r][c]=1;
            
            fast_end_2=false;
          end
        end
      end
    end
    
    for r=1,gm.C do
      for c=1,gm.C do
        
        if gm.state.cross[r][c]==0 then
          
          r=math.tointeger(r)
          c=math.tointeger(c)
          
          local cross = "spr_mousemg_cross_"..r.."_"..c;
          local o_cross = ObjGet(cross);
          local t_rand = t*math.random(50,90)/100
          ObjSet(cross,{alp=1})
          ObjAnimate(cross, 7, 0, 0, _,         {0,0,0,                   t_rand,0,o_cross.ang});
          ObjAnimate(cross, 6, 0, 0, _,         {0,0,1,1,                 t_rand,0,o_cross.scale_x, o_cross.scale_y});
          ObjAnimate(cross, 3, 0, 0, _,         {0,0,gm.x0,  gm.y0,       t_rand,0,o_cross.pos_x,   o_cross.pos_y});
          
          local cross_dop = "spr_mousemg_cross_"..r.."_"..c.."_dop";
          local o_cross_dop = ObjGet(cross_dop);
          local t_rand = t*math.random(50,90)/100
          ObjSet(cross_dop,{alp=1})
          ObjAnimate(cross_dop, 7, 0, 0, _,         {0,0,0,                   t_rand,0,o_cross_dop.ang});
          ObjAnimate(cross_dop, 6, 0, 0, _,         {0,0,1,1,                 t_rand,0,o_cross_dop.scale_x, o_cross_dop.scale_y});
          ObjAnimate(cross_dop, 3, 0, 0, _,         {0,0,gm.x0,  gm.y0,       t_rand,0,o_cross_dop.pos_x,   o_cross_dop.pos_y});
          
          gm.state.cross[r][c]=1
        end
        
      end
    end
    
    if fast_end_2 then
      func_end()
    else
      ld.StartTimer(t,func_end)
    end
    
  end
  
  
  
  
  
  
  
  ---  WARNING! this part of code is duplicate of code in reset (almost)
  ld.Lock(1);
  local t = 1;
  local fast_end = true;
  
  for r=1,gm.R do
    for c=1,gm.C do
      
      r=math.tointeger(r)
      c=math.tointeger(c)
      
      local stick = "spr_mousemg_stick_"..r.."_"..c;
      local res = gm.state.pos[r][c];
      local s;
      if res==1 then
        s=2;
      elseif res==2 then
        s=1;
      end
      if res==2 then
        gm.state.pos[r][c]=0;
        fast_end = false;
        local o = ObjGet(stick)
        local x,y;
        if res==1 then
          x = gm.x0;
          y = gm.y0
        else
          x = gm.x1;
          y = gm.y1;
        end
        local func_end = function()
          ObjSet(stick,{pos_x=o.pos_x,pos_y=o.pos_y,ang=o.ang,alp=0,res="assets/levels/level/mg_mousemg/2"})
        end
        local t_rand = t*math.random(30,80)/100;
        ObjAnimate(stick, 3, 0, 0, func_end, {0,0,o.pos_x,o.pos_y,   t_rand,0,x,y});
        ObjAnimate(stick, 7, 0, 0, _,        {0,0,o.ang,             t_rand,0,0});
      end
    end
  end
  
  
  
  for c1=1,gm.C do
    for c2=1,gm.C do  
      if gm.state.cross[c1][c2]==2 then
        gm.state.cross[c1][c2]=0;
        
        c1=math.tointeger(c1)
        c2=math.tointeger(c2)
        
        local cross     = "spr_mousemg_cross_"..c1.."_"..c2;
        local cross_dop = "spr_mousemg_cross_"..c1.."_"..c2.."_dop";
        
        local o_cross = ObjGet(cross);
        local o_cross_dop = ObjGet(cross_dop);
        
        local func_end = function()
          ObjSet(cross,{alp=0,res="assets/levels/level/mg_mousemg/2",      pos_x = o_cross.pos_x,     pos_y = o_cross.pos_y,     ang=o_cross.ang})
          ObjSet(cross_dop,{alp=0,res="assets/levels/level/mg_mousemg/2",  pos_x = o_cross_dop.pos_x, pos_y = o_cross_dop.pos_y, ang=o_cross_dop.ang})
        end
        
        local x = gm.x1;
        local y = gm.y1;
        local t1 = t*math.random(50,90)/100;
        local t2 = t*math.random(50,90)/100;
        ObjAnimate(cross, 7, 0, 0, func_end,     {0,0,o_cross.ang,                                t*1.05,0,0});
        ObjAnimate(cross, 3, 0, 0, _,            {0,0,o_cross.pos_x,      o_cross.pos_y,          t2,0,x,y});

        ObjAnimate(cross_dop, 7, 0, 0, _,        {0,0,o_cross_dop.ang,                            t1,0,0});
        ObjAnimate(cross_dop, 3, 0, 0, _,        {0,0,o_cross_dop.pos_x,  o_cross_dop.pos_y,      t2,0,x,y});
      end
    end
  end
  
  
  if fast_end then
    func_step()
  else
    ld.StartTimer(t*1.1,func_step)
  end
  
  
  
  
  
  
  
  
end;
--*********************************************************************************************************************
function private.WinEnd()
  gm.save();
  ld.Lock(0);
  cmn.SetEventDone( "win_mousemg" );
  cmn.CallEventHandler( "win_mousemg" );
  if common_impl.ZzCompleteCheck( "win_mousemg" ) then cmn.GotoRoom( "rm_bedroom" ); end;
  interface_impl.ShowMgAchievements();
  
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);

  cmn.MiniGameHide();
  SoundMgTheme( false )
  
  for r=1,gm.R do
    for c=1,gm.C do
      
      r=math.tointeger(r)
      c=math.tointeger(c)
      
      local name = "spr_mousemg_stick_"..r.."_"..c;
      if ObjGet(name) then
        ObjSet(name,{input=false})
      end
    end
  end
  
  --ld.StartTimer( 0.5, private.WinEnd  );
  ObjDelete("tmr_mousemg_anm")
  AnimStop("anm_mousemg_anm");
  
  
  local func_end = function()
    ld.AnimPlay("anm_mousemg_anm","mouse_final",
    function()
      private.WinEnd();
      private.static_anim("anm_mousemg_anm",private.anim_list,private.delays);
    end );
  end
  
  if ObjGet("anm_mousemg_anm").animfunc == "mouse_1" then
    ld.AnimPlay("anm_mousemg_anm","mouse_2",func_end)
  else
    func_end();
  end
  SoundSfx( "aud_win_mousemg" );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.default()
  gm.idling = {}
  gm.state = {}
  gm.state.pos = {}
  for r=1,gm.R do
    r=math.tointeger(r)
    gm.state.pos[r] = {}
    for c=1,gm.C do
      c=math.tointeger(c)
      local name = "spr_mousemg_stick_"..r.."_"..c;
      if ObjGet(name) then
        ObjSet(name,{inputrect_x=-10,inputrect_y=-39,inputrect_w=22,inputrect_h=75,
        input=true;
        event_menter    = function( ) gm.event_menter(r,c)    end;
        event_mleave    = function( ) gm.event_mleave(r,c)    end;
        event_mdown     = function( ) gm.event_mdown(r,c)     end;
        
        })  
      end
      gm.state.pos[r][c]=0;
    end
  end
  
  gm.state.cross = {}
  for c1=1,gm.C do
    gm.state.cross[c1]={}
    for c2=1,gm.C do
      gm.state.cross[c1][c2]=0;
    end
  end
  
  gm.state.player_point = 0;
  gm.state.enemy_point  = 0;
  
  
  
end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_mousemg"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()
  
  for r=1,gm.R do
    for c=1,gm.C do
      r=math.tointeger(r)
      c=math.tointeger(c)
      local name = "spr_mousemg_stick_"..r.."_"..c;
      local res = gm.state.pos[r][c];
      local s;
      if res==1 then
        s=2;
      elseif res==2 then
        s=1;
      end
      s=math.tointeger(s)
      if res>0 then
        ObjSet(name,{res = "assets/levels/level/mg_mousemg/"..s,alp=1})
      else
        --ObjSet(name,{res = "assets/levels/level/mg_mousemg/2",  alp=0});
        ObjSet(name,{alp=0});
      end
    end 
  end
  
  for r=1,gm.C do
    for c=1,gm.C do
       r=math.tointeger(r)
       c=math.tointeger(c)
       local res = gm.state.cross[r][c];       
       local name = "spr_mousemg_cross_"..r.."_"..c;
       if res>0 then
         if res==1 then
           s=2;
         elseif res==2 then
           s=1;
         end
         s=math.tointeger(s)
         ObjSet(name,{res = "assets/levels/level/mg_mousemg/"..s,alp=1});
         ObjSet(name.."_dop",{res = "assets/levels/level/mg_mousemg/"..s,alp=1});
       else
         --ObjSet(name,{res = "assets/levels/level/mg_mousemg/2",alp=0});
         --ObjSet(name.."_dop",{res = "assets/levels/level/mg_mousemg/2",alp=0});
         ObjSet(name,{alp=0});
         ObjSet(name.."_dop",{alp=0});
       end
    end
  end
  
  ObjSet("txt_mousemg_playerpoint",{text = tostring(gm.state.player_point)})
  ObjSet("txt_mousemg_enemypoint", {text = tostring(gm.state.enemy_point)})
  
  if ld.CheckRequirements( {"win_mousemg"} ) then
    for r=1,gm.R do
      for c=1,gm.C do
        r=math.tointeger(r)
        c=math.tointeger(c)
        local name = "spr_mousemg_stick_"..r.."_"..c;
        if ObjGet(name) then
          ObjSet(name,{input=false})
        end
      end
    end
  end
end
--*********************************************************************************************************************
function gm.set_one(r,c, player_move)
  local stick = "";
  r=math.tointeger(r)
  c=math.tointeger(c)
  local stick_set = "spr_mousemg_stick_"..r.."_"..c
  local x0=0;
  local y0=0;
  local s = 0;
  gm.flag = 0;
  if player_move then
    s = 2;
    gm.flag=1;
    x0=gm.x0;
    y0=gm.y0;
    stick = "spr_mousemg_stick_player";
  else
    s = 1;
    gm.flag=2;
    x0=gm.x2;
    y0=gm.y2;
    stick = "spr_mousemg_stick_enemy_throw";
  end
  
  gm.s=s;
  
  --gm.move_again = false;
  
  local o1 = ObjGet(stick)
  local o2 = ObjGet(stick_set);
  
  
  
  local func_end = function()
    
    ObjSet("txt_mousemg_playerpoint",{text = tostring(gm.state.player_point)})
    ObjSet("txt_mousemg_enemypoint", {text = tostring(gm.state.enemy_point)})
    
    
    if gm.state.player_point+gm.state.enemy_point >= 36 then
      if gm.state.player_point>18 then
        private.Win();
      else
        public.Reset();
        if not player_move then
          ld.AnimPlay("anm_mousemg_anm","mouse_2",
          function()
            private.static_anim("anm_mousemg_anm",private.anim_list,private.delays);
          end);
        end
      end
      
      
      
    else
      if not player_move then
        if not gm.move_again then
          gm.save();
          ld.Lock(0);
          ld.AnimPlay("anm_mousemg_anm","mouse_2",
          function()
            private.static_anim("anm_mousemg_anm",private.anim_list,private.delays);
          end);
        else
          gm.enemy_move();
        end
        
      else
        if not gm.move_again then
          gm.enemy_move();
        else
          gm.save();
          ld.Lock(0);
        end
      end
    end
    
    
    
  end
  
  local func_step = function()
    
    SoundSfx( "aud_put_skewer" );
    
    local t = 0.45;
    
    local function func_put_cross(rc,cc)
      
      --ld.LogTrace("==========================")
      --ld.LogTrace("rc="..rc..",cc="..cc)
      --ld.LogTrace("==========================")
      
      rc = math.tointeger(rc);
      cc = math.tointeger(cc);
      
      local cross     = "spr_mousemg_cross_"..rc.."_"..cc;
      local cross_dop = "spr_mousemg_cross_"..rc.."_"..cc.."_dop";
      local o_cross = ObjGet(cross);
      local o_cross_dop = ObjGet(cross_dop);
      
      gm.s=math.tointeger(gm.s)
      ObjSet(cross,    {alp=1, res="assets/levels/level/mg_mousemg/"..gm.s, pos_x = o1.pos_x, pos_y = o1.pos_y });
      ObjSet(cross_dop,{alp=1, res="assets/levels/level/mg_mousemg/"..gm.s, pos_x = o1.pos_x, pos_y = o1.pos_y});
      
      
      local t1 = t*math.random(50,90)/100;
      local t2 = t*math.random(50,90)/100;
      if gm.move_again then
        t=0.2;
        t1=0.2;
        t2=0.2;
        
      end
      
      ObjAnimate(cross, 7, 0, 0, _,     {0,0,o1.ang,                   t1,0,o_cross.ang});
      ObjAnimate(cross, 6, 0, 0, _,     {0,0,o1.scale_x,o1.scale_y,    t,0,o_cross.scale_x, o_cross.scale_y});
      ObjAnimate(cross, 3, 0, 0, _,     {0,0,o1.pos_x,  o1.pos_y,      t2,0,o_cross.pos_x,   o_cross.pos_y});

      ObjAnimate(cross_dop, 7, 0, 0, _, {0,0,o1.ang,                   t1,0,o_cross_dop.ang});
      ObjAnimate(cross_dop, 6, 0, 0, _, {0,0,o1.scale_x,o1.scale_y,    t,0,o_cross_dop.scale_x, o_cross_dop.scale_y});
      ObjAnimate(cross_dop, 3, 0, 0, _, {0,0,o1.pos_x,  o1.pos_y,      t,0,o_cross_dop.pos_x,   o_cross_dop.pos_y});
        
      if gm.flag==1 then
        gm.state.player_point = gm.state.player_point + 1;
      else
        gm.state.enemy_point  = gm.state.enemy_point + 1;
      end
      
      gm.state.cross[rc][cc]=gm.flag;
      
      
    end
    
    ObjSet(stick_set,{alp=1,blendmode=0, res="assets/levels/level/mg_mousemg/"..s });
    ObjSet(stick,    {alp=0,pos_x=x0,pos_y=y0,scale_x=1,scale_y=1,ang=o1.ang});
    
    gm.state.pos[r][c] = gm.flag;
    
    local fast_end = true;
    
    local res = gm.cpos_check(r,c);
    gm.move_again=false;
    if res[1]["r"] ~= 0 then
      gm.move_again=true;
      fast_end = false;
      func_put_cross(res[1]["r"],res[1]["c"]);
    end
    if res[2]["r"] ~= 0 then
      func_put_cross(res[2]["r"],res[2]["c"]);
    end
    
    
    if fast_end then
      func_end()
    else
      ld.StartTimer(t*1.02,
      function()
        func_end()
        SoundSfx( "aud_make_cross" );
      end
      )
    end
    
    
  end
  
  
  ld.Lock(1)
  
  local t = 0.4;
  if gm.move_again and not player_move then
    t=0.2;
  end
  
  local func_droping = function()
    ObjSet(stick,{alp=1});
    ObjAnimate(stick, 7, 0, 0, func_step, {0,0,o1.ang,                   t,0,o2.ang});
    ObjAnimate(stick, 6, 0, 0, _,         {0,0,o1.scale_x,o1.scale_y,    t,0,o2.scale_x,o2.scale_y});
    ObjAnimate(stick, 3, 0, 0, _,         {0,0,o1.pos_x,  o1.pos_y,      t,0,o2.pos_x,  o2.pos_y});
  end
  
  
  
  if player_move then
    func_droping();
  else
    if gm.move_again then
      func_droping();
    else
      ld.StartTimer(0.6,func_droping);
    end
  end
  
end
--*********************************************************************************************************************
function gm.cpos_check(r,c, mode)
  
  local res = {}
  res[1] = {}
  res[1]["r"] = 0
  res[1]["c"] = 0
  
  res[2] = {}
  res[2]["r"] = 0
  res[2]["c"] = 0
  
  local res2 = {0,0}
  
  
  local ind = 1;
  
  local rl = 0;
  local cl = 0;
  local p = 0;
  
  
  if r%2 == 0 then
    
    rl=r-1;
    cl=c-1;
    p = p + gm.pos_check(rl,cl);  
    rl=r-2;
    cl=c;
    p = p + gm.pos_check(rl,cl);  
    rl=r-1;
    cl=c;
    p = p + gm.pos_check(rl,cl); 
    res2[1]=p
    if p==3 then
      res[ind]["r"]=r*0.5;
      res[ind]["c"]=c;
      ind=ind+1;
    end
    
    p=0;
    rl=r+1;
    cl=c-1;
    p = p + gm.pos_check(rl,cl);  
    rl=r+2;
    cl=c;
    p = p + gm.pos_check(rl,cl);
    rl=r+1;
    cl=c;
    p = p + gm.pos_check(rl,cl);
    res2[2]=p
    if p==3 then
      res[ind]["r"]=r*0.5+1;
      res[ind]["c"]=c;
    end
    
    
  else
    
    rl=r-1;
    cl=c;
    p = p + gm.pos_check(rl,cl);  
    rl=r;
    cl=c-1;
    p = p + gm.pos_check(rl,cl); 
    rl=r+1;
    cl=c;
    p = p + gm.pos_check(rl,cl); 
    res2[1]=p
    if p==3 then
      res[ind]["r"]=(r+1)*0.5;
      res[ind]["c"]=c;
      ind=ind+1;
    end
    
    
    p=0;
    rl=r-1;
    cl=c+1;
    p = p + gm.pos_check(rl,cl); 
    rl=r;
    cl=c+1;
    p = p + gm.pos_check(rl,cl); 
    rl=r+1;
    cl=c+1;
    p = p + gm.pos_check(rl,cl); 
    res2[2]=p
    if p==3 then
      res[ind]["r"]=(r+1)*0.5;
      res[ind]["c"]=c+1;
      ind=ind+1;
    end
  
  end
  
  if mode then
    res=res2
  end
  
  return res; 
end
--*********************************************************************************************************************
function gm.pos_check(r,c)
  local p = 0;
  r=math.tointeger(r)
  c=math.tointeger(c)
  if not ObjGet("spr_mousemg_stick_"..r.."_"..c) then
    p=1;
  else
    if gm.state.pos[r][c]>0 then
      p=1;
    end
  end
  return p;
end
--*********************************************************************************************************************
function gm.event_mdown( r,c )
  r=math.tointeger(r)
  c=math.tointeger(c)
  if gm.state.pos[r][c]==0 then
    gm.set_one(r,c, true)
  else
    local name = "spr_mousemg_stick_"..r.."_"..c
    if not gm.idling[name] then
      SoundSfx( "aud_clk_stick" )
      gm.idling[name]=true;
      local t = 0.3;
      local ang = ObjGet(name).ang;
      ObjAnimate(name, 7, 0, 0, function() gm.idling[name]=false; end, {0,0,ang, 1*t/4,0,ang-0.1,   2*t/4,0,ang,  3*t/4,0,ang+0.1,   t,0,ang});
    end
  end
end
--*********************************************************************************************************************
function gm.event_menter( r,c )
  r=math.tointeger(r)
  c=math.tointeger(c)
  if gm.state.pos[r][c]==0 then
    ld.ShCur(CURSOR_HAND)
    local name = "spr_mousemg_stick_"..r.."_"..c
    gm.scale_x = ObjGet(name).scale_x;
    ObjSet(name,{alp=1,blendmode=2,scale_x=2})
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( r,c )
  r=math.tointeger(r)
  c=math.tointeger(c)
  ld.ShCur(CURSOR_DEFAULT)
  local name = "spr_mousemg_stick_"..r.."_"..c
  if gm.state.pos[r][c]==0 then
    ObjSet(name,{alp=0,blendmode=0,scale_x=gm.scale_x})
  end
end;





--*********************************************************************************************************************
function gm.enemy_move()
  
  -- check for end of possible moves
  local move_end  = true;
  for r=1,gm.R do  
    for c=1,gm.C do
      r=math.tointeger(r)
      c=math.tointeger(c)
      local name = "spr_mousemg_stick_"..r.."_"..c;
      if ObjGet(name) then
        if gm.state.pos[r][c]==0 then
          move_end=false;
        end
      end
    end
  end
  
  if move_end then---<< if all possible move is end, we need to compute points and restart (player lose) ot finish (player win) game
    
    if gm.state.player_point>18 then
      private.Win();
    else
      public.Reset();
      ld.AnimPlay("anm_mousemg_anm","mouse_2",
      function()
        private.static_anim("anm_mousemg_anm",private.anim_list,private.delays);
      end);
    end
    
    
    
  else---<<
    
    if not gm.move_again then
      ObjDelete("tmr_mousemg_anm")
      AnimStop("anm_mousemg_anm");
      ld.AnimPlay("anm_mousemg_anm","mouse_1","");
    end
    
    local move_is_done = false;
    local candidats = {}  
    local ind = 1;
    
    for r=1,gm.R do  
      for c=1,gm.C do
        r=math.tointeger(r)
        c=math.tointeger(c)
        local name = "spr_mousemg_stick_"..r.."_"..c;
        if ObjGet(name) then
          if gm.state.pos[r][c]==0 then
            local res = gm.cpos_check(r,c);
            if res[1]["r"]~=0 then
              candidats[ind]={}
              candidats[ind]["r"]=r;
              candidats[ind]["c"]=c;
              candidats[ind]["score"]=1;
            end
            if res[2]["r"]~=0 then
              candidats[ind]["score"]=2;
            end
            if res[1]["r"]~=0 then
              ind=ind+1;
            end
          end
        end
      end
    end
    
    
    
    if ind>1 then
      for i=1,#candidats do
        local score = candidats[i]["score"];
        if score>1 then
          move_is_done=true;
          gm.set_one(candidats[i]["r"],candidats[i]["c"],false);
          break;
        end
      end 
      
      if not move_is_done then
        local i;
        if #candidats==1 then
          i=1;
        else
          i=math.random(1,#candidats);
        end
        gm.set_one(candidats[i]["r"],candidats[i]["c"],false);
      end
      
    else
      local num_of_try = 0;
      while (not move_is_done ) do
        local r = math.random(1,gm.R)
        local c = math.random(1,gm.C)
        r=math.tointeger(r)
        c=math.tointeger(c)
        local name = "spr_mousemg_stick_"..r.."_"..c;
        if ObjGet(name) then
          if gm.state.pos[r][c]==0 then
            local check = gm.cpos_check(r,c,true);
            
            if (check[1]<2 and check[2]<2) or num_of_try>12 then
              gm.set_one(r,c,false);
              move_is_done=true;
            else
              num_of_try=num_of_try+1;
            end
          end
        end
      end;
    
      
    end
    
    
    
    
    
  end--<<
end




















--------------------------------------------------------------------------------
function private.static_anim(anim_target,anim_list,delays)
  local delays_set;
  if not delays then
    delays_set = math.random(400,700)/100;
  else
    delays_set = math.random(delays[1],delays[2])/100;
  end
  
  local delays_out;
  if delays then
    delays_out=delays;
  else
    delays_out=false;
  end
  
  local ind = math.random(1,#anim_list);
  
  if ObjGet("tmr_mousemg_anm") then
    ObjDelete("tmr_mousemg_anm")
  end
  
  ld.StartTimer("tmr_mousemg_anm",delays_set, function()
    ld.AnimPlay(anim_target,anim_list[ind], function() private.static_anim(anim_target,anim_list,delays_out); end )
  end)
end
--------------------------------------------------------------------------------