-- name=rm_backyard
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_backyard";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  
  private.vid_list_1 = 
  {
    "vid_arbourroof_vid_grumpy_cycle",
  }
  ld.VidStaticInit(
    private.vid_list_1,
    "zz_arbourroof",            --owners
    false, --sounds
    false,                    --{t_min,t_max}, default = {0,0} 
    {"clk_startclimbs"},      --run after that progress event
    {"use_slapstick"},        --stop after that progress event
    sfx_rnd,                  --sounds under all videos
    "obj_arbourroof_vid_grumpy_root_1" --root holder
  );
  
  private.vid_list_2 = 
  {
    "vid_arbourroof_vid_grumpy_hanging_cycle",
  }
  ld.VidStaticInit( 
    private.vid_list_2,
    "zz_arbourroof", 
    false,--sfx, 
    false, 
    {"use_slapstick"},--prg_true, 
    {"use_nippers_arbourroof"}, --prg_false,
    false,--sfx_rnd, 
    "obj_arbourroof_vid_grumpy_root_2"--root
  );
  
  private.vid_list_3 = 
  {
    "vid_backyard_vid_grumpy_loca_static_1",
    "vid_backyard_vid_grumpy_loca_static_2"
  }
  ld.VidStaticInit( 
    private.vid_list_3, 
    "rm_backyard", 
    false,--sfx, 
    false, 
    {"use_slapstick"},--prg_true, 
    {"use_nippers_arbourroof"}, --prg_false,
    false,--sfx_rnd, 
    "obj_backyard_vid_grumpy_root_3"--root
  );
  
  
  --------------------------------------------------------------------------------------------
function private.opn_backyard()
  if not ( cmn.IsEventDone( "opn_backyard" ) ) then
    local func_end = function()
      --common_impl.Gate_MDown( "gzz_backyard_arbourroof" )
      common_impl.Gate_MDown( "gzz_backyard_arbourroof", { ObjGet( "gzz_backyard_arbourroof" ).pos_x, ObjGet( "gzz_backyard_arbourroof" ).pos_y } )
      ld.StartTimer(0.5,
      function()
        ObjDetach("vid_backyard_vid_grumpy_emerging");
        ObjSet("vid_backyard_vid_grumpy_static",{visible=1});
      end
      )
    end;
    SoundSfx( "aud_grumpy_emerging" )
    VidPlay("vid_backyard_vid_grumpy_emerging",func_end)
  end;
end;
--------------------------------------------------------------------
local opn_backyard = function() end;
local opn_backyard_logic = function() end;
cmn.AddSubscriber( "opn_backyard", opn_backyard_logic )
cmn.AddSubscriber( "opn_backyard", opn_backyard, private.room_objname )
--------------------------------------------------------------------------------------------


--------------------------------------------------------------------------------------------
function public.click_firtree()
  if not private.click_firtree then
    local func_end = function()
      private.click_firtree=false;
    end
    private.click_firtree=true;
    SoundSfx( "aud_clk_shake_tree" )
    ld.AnimPlay("anm_backyard_anim_backyard_click_firtree","click_firtree",func_end)
  end
end

--------------------------------------------------------------------------------------------
function public.click_ball()
  if not private.click_ball then
    local func_end = function()
      private.click_ball=false;
    end
    private.click_ball=true;
    SoundSfx( "aud_clk_weed" )
    ld.AnimPlay("anm_backyard_anim_backyard_click_ball","click_ball",func_end)
  end
end

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_snowpath *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_ball1" ] = { type = "get", get_obj = "spr_snowpath_ball1", room = "rm_backyard", zz = "zz_snowpath", zz_gate = "gzz_backyard_snowpath" };

private.get_ball1_logic = function()
  
end;
private.get_ball1_inv = function()
  interface.InventoryItemAdd("inv_ball","spr_snowpath_ball1",function() level_inv.ProcessGetBallAll( "get_ball1" ) end);
end;
private.get_ball1_beg = function()
  ObjDelete("gfx_snowpath_ball1")
end;
private.get_ball1_end = function()
  if common_impl.ZzCompleteCheck("get_ball1") then ObjSet( common_impl.hint["get_ball1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_snowpath_ball_tr")
end;

cmn.AddSubscriber( "get_ball1", private.get_ball1_inv );
cmn.AddSubscriber( "get_ball1", private.get_ball1_beg, private.room_objname );
cmn.AddSubscriber( "get_ball1", private.get_ball1_end, private.room_objname );
cmn.AddSubscriber( "get_ball1", private.get_ball1_logic );
--------------------------------------------------------------------
function public.get_ball1()
  cmn.SetEventDone( "get_ball1" );
  cmn.CallEventHandler( "get_ball1" );
  if common_impl.ZzCompleteCheck("get_ball1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_map" ] = { type = "use", inv_obj = "inv_map", use_place = "gfx_snowpath_map_zone", room = "rm_backyard", zz = "zz_snowpath", zz_gate = "gzz_backyard_snowpath" };

private.use_map_logic = function()
  ObjSet( "gfx_snowpath_win_snowpath_zone", { visible = 1, input = 1, active = 1 } )
  ld.mmgZoomInit("win_snowpath");
end;
private.use_map_inv = function()
  common_impl.ProcessMultiUseAll("map", "map")
end;
private.use_map_beg = function()
  ObjDelete( "gfx_snowpath_map_zone" );
end;
private.use_map_end = function()
  if common_impl.ZzCompleteCheck("use_map") then ObjSet( common_impl.hint["use_map"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("spr_snowpath_map_sh",{visible=1})
  ObjSet("spr_snowpath_map_mini",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_map", private.use_map_inv );
cmn.AddSubscriber( "use_map", private.use_map_beg, private.room_objname );
cmn.AddSubscriber( "use_map", private.use_map_end, private.room_objname );
cmn.AddSubscriber( "use_map", private.use_map_logic );
cmn.AddSubscriber( "use_map_inv", private.use_map_inv, private.room_objname );
cmn.AddSubscriber( "use_map_beg", private.use_map_beg, private.room_objname );
cmn.AddSubscriber( "use_map_end", private.use_map_end, private.room_objname );
cmn.AddSubscriber( "use_map_end", private.use_map_logic );
--------------------------------------------------------------------------------------------
function public.use_map( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_map" );
    cmn.CallEventHandler( "use_map_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_map") then ld.CloseSubRoom() end;
    
    public.win_snowpath_load()
    
    ObjGet( "gfx_snowpath_win_snowpath_zone" ).event_mdown()  
    
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_map_inv" );
  cmn.CallEventHandler( "use_map_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_map_backyard" )
  --func_end()
  ObjSet("spr_snowpath_map_sh",{visible=1})
  ObjSet("spr_snowpath_map_mini",{visible=1})
  ObjAnimate("spr_snowpath_map_sh",   8, 0, 0, ""       , {0,0,0, 0.5,0,1});
  ObjAnimate("spr_snowpath_map_mini", 8, 0, 0, func_end , {0,0,0, 0.5,0,1});

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_snowpath" ] = { type = "click", use_place = "gfx_snowpath_win_snowpath_zone", room = "rm_backyard", zz = "zz_snowpath", zz_gate = "gzz_backyard_snowpath" };

private.win_snowpath_logic = function()
  if ld.CheckRequirements({"win_snowpath"}) then
    ObjSet( "grm_backyard_chapel", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_backyard_chapel_focus");
    end;
  end;
end;
private.win_snowpath_beg = function()
  if ld.CheckRequirements({"win_snowpath"}) then
    ObjDelete( "gfx_snowpath_win_snowpath_zone" );
  end
end;
private.win_snowpath_end = function()
  if ld.CheckRequirements({"win_snowpath"}) then
    if common_impl.ZzCompleteCheck("win_snowpath") then ObjSet( common_impl.hint["win_snowpath"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_snowpath", private.win_snowpath_beg, private.room_objname );
cmn.AddSubscriber( "win_snowpath", private.win_snowpath_end, private.room_objname );
cmn.AddSubscriber( "win_snowpath", private.win_snowpath_logic );
cmn.AddSubscriber( "win_snowpath_beg", private.win_snowpath_beg, private.room_objname );
cmn.AddSubscriber( "win_snowpath_end", private.win_snowpath_end, private.room_objname );
cmn.AddSubscriber( "win_snowpath_end", private.win_snowpath_logic );
--------------------------------------------------------------------------------------------
function public.win_snowpath()

  local func_end = function()
    cmn.SetEventDone( "win_snowpath" );
    cmn.CallEventHandler( "win_snowpath_end" );
    common_impl.Lock(0);
    ld.CloseSubRoom();
  end;
  local func_step_2 = function()
    ObjGet("obj_snowpath_win_snowpath_zoom").event_mdown();
    ld.StartTimer(0.5,func_end);
  end
  local func_step_1 = function()
    ObjAnimate("obj_snowpath_mmg_fogofwar",  8, 0, 0, _,           {0,0,1, 0.4,0,0});
    ObjAnimate("spr_snowpath_light_victory", 8, 0, 0, func_step_2, {0,0,0, 0.5,0,1,  1,0,0,  1.5,0,1});
  end
  
  cmn.CallEventHandler( "win_snowpath_beg" );
  common_impl.Lock(1);
  
  
  local oCurrent = ObjGet("anm_snowpath_anm_man");
  local oEnd = ObjGet("spr_snowpath_marker_21");
  -- gm.offset = -30;
  if oCurrent.pos_x == oEnd.pos_x and oCurrent.pos_y == oEnd.pos_y-30 then
    func_step_1()
  else
    ObjAnimate("anm_snowpath_anm_man", 8,0,0, func_step_1, {0,0,1,  0.4,0,0,   0.41,0,0,   0.8,0,1});
    ObjAnimate("anm_snowpath_anm_man", 3,0,0, _,           {0,   0,oCurrent.pos_x,oCurrent.pos_y,    
                                                            0.4, 0,oCurrent.pos_x,oCurrent.pos_y,   
                                                            0.41,0,oEnd.pos_x, oEnd.pos_y-30} );
  end
  
  SoundSfx( "aud_win_snowpath" )
  --func_end()
  
            
end;


function public.win_snowpath_load()
  if not private.win_snowpath_game then
    private.win_snowpath_game = {}
  end
  local gm = private.win_snowpath_game;
  gm.state = {};
  ---------------------------------------------
  function gm.default() 
    gm.offset = 30;     
    gm.state.pos = 1;
    gm.state.fogOfWar = {};
    gm.M = 25;
    gm.F = 29;
    for f=1,gm.F do
      gm.state.fogOfWar[f]=true;
    end
    gm.state.LockAnims = {false,false,false, false,false}
  end
  ----------------------------------------------
  function gm.save()
    for f=1,gm.F do
      local fog = "spr_snowpath_square_"..f
      if ObjGet(fog).alp==0 then
        gm.state.fogOfWar[f]=false;
      else
        gm.state.fogOfWar[f]=true;
      end
    end
    ng_global.progress["std"]["win_snowpath"].state = ld.TableCopy( gm.state )
  end
  -------------------------------------------
  function gm.reset()
    
    local func_end = function()
      for a=1,5 do
        ObjSet("anm_snowpath_anm_let_"..a,{frame=0,alp=1})
      end
      gm.default();
      gm.save();
      ld.Lock(0)
    end
    local t = 1;
    ld.Lock(1);
    if gm.state.pos ~= 1 then
      local oCurrent = ObjGet("anm_snowpath_anm_man");
      local oEnd = ObjGet("spr_snowpath_marker_1");
      ObjAnimate("anm_snowpath_anm_man", 8,0,0, _, {0,0, 1,  0.4,0,0,   0.41,0,0,   0.8,0,1});
      ObjAnimate("anm_snowpath_anm_man", 3,0,0, _, {0,   0,  oCurrent.pos_x,oCurrent.pos_y,    
                                                    0.4, 0,  oCurrent.pos_x,oCurrent.pos_y,   
                                                    0.41,0,  oEnd.pos_x, oEnd.pos_y-30} );
      
    end
    for f=1,gm.F do
      local fog = "spr_snowpath_square_"..f
      if ObjGet(fog).alp==0 then
        ObjAnimate(fog, 8, 0, 0, _, {0,0,0, t,0,1});
      end
    end
    for a=1,5 do
      ObjAnimate("anm_snowpath_anm_let_"..a, 8, 0, 0, _, {0,0,1, 0.4,0,0});
    end
    ld.StartTimer(t,func_end);
  end
  -------------------------------------------
  function gm.skip()
    public.win_snowpath();
  end
  -------------------------------------------
  function gm.event_mdown(xDir,yDir)

    SoundSfx("aud_clk_ho")
    
    local oc = ObjGet("spr_snowpath_marker_"..gm.state.pos);
    local xc = oc.pos_x;
    local yc = oc.pos_y;
    local moving = false;
    local posNew = gm.state.pos;
    local xNew = 0;
    local yNew = 0;
    local r = 0;
    if xDir==0 then
      if yDir > 0 then
        for m=1,gm.M do
          local op = ObjGet("spr_snowpath_marker_"..m);
          local xp = op.pos_x;
          local yp = op.pos_y;
          
          if yc<yp and xc==xp and m~=gm.state.pos then
            if r==0 then
              r = gm.distance(xc,yc,xp,yp);
              xNew = xp;
              yNew = yp;
              posNew=m;
              moving=true;
            else
              if gm.distance(xc,yc,xp,yp)<r then
                r=gm.distance(xc,yc,xp,yp);
                xNew = xp;
                yNew = yp;
                posNew=m;
              end
            end
          end
        end
      else
        for m=1,gm.M do
          local op = ObjGet("spr_snowpath_marker_"..m);
          local xp = op.pos_x;
          local yp = op.pos_y;
          if yc>yp and xc==xp and m~=gm.state.pos  then
            if r==0 then
              r = gm.distance(xc,yc,xp,yp);
              xNew = xp;
              yNew = yp;
              posNew=m;
              moving=true;
            else
              if gm.distance(xc,yc,xp,yp)<r then
                r=gm.distance(xc,yc,xp,yp);
                xNew = xp;
                yNew = yp;
                posNew=m;
              end
            end
          end
        end
      end
    end
    
    
    if yDir==0 then
      if xDir > 0 then
        for m=1,gm.M do
          local op = ObjGet("spr_snowpath_marker_"..m);
          local xp = op.pos_x;
          local yp = op.pos_y;
          if yc==yp and xc<xp and m~=gm.state.pos  then
            if r==0 then
              r = gm.distance(xc,yc,xp,yp);
              xNew = xp;
              yNew = yp;
              posNew=m;
              moving=true;
            else
              if gm.distance(xc,yc,xp,yp)<r then
                r=gm.distance(xc,yc,xp,yp);
                xNew = xp;
                yNew = yp;
                posNew=m;
              end
            end
          end
        end
      else
        for m=1,gm.M do
          local op = ObjGet("spr_snowpath_marker_"..m);
          local xp = op.pos_x;
          local yp = op.pos_y;
          if yc==yp and xc>xp and m~=gm.state.pos  then
            if r==0 then
              r = gm.distance(xc,yc,xp,yp);
              xNew = xp;
              yNew = yp;
              posNew=m;
              moving=true;
            else
              if gm.distance(xc,yc,xp,yp)<r then
                r=gm.distance(xc,yc,xp,yp);
                xNew = xp;
                yNew = yp;
                posNew=m;
              end
            end
          end
        end
      end
      
    end
    
    ------------------------
    if moving then
      
      
      -- FUNC END --
      local func_end = function()
        ObjSet("anm_snowpath_anm_man",{playing=false,frame=0})
        gm.state.pos=posNew;
        gm.isUpdate = false;
        local fastEnd = true;
        
        -- FUNC END END --
        local func_end_end = function()
          if posNew== 4 then
            gm.state.LockAnims[1]=true;
          end
          if posNew== 20 or posNew==18 then
            gm.state.LockAnims[2]=true;
          end
          if posNew== 6 then
            gm.state.LockAnims[3]=true;
          end
          if posNew== 8 then
            gm.state.LockAnims[4]=true;
          end
          if posNew== 23 or posNew==22 then
            gm.state.LockAnims[5]=true;
          end
          
          if posNew == 21 then
            public.win_snowpath();
          else
            gm.save();
            ld.Lock(0);
          end
        end
        -- FUNC END END --
        
        local a = 1;
        if posNew== 4 and not gm.state.LockAnims[1]  then
          fastEnd=false;
          a=1;
        end
        if (posNew== 20 or posNew==18) and not gm.state.LockAnims[2] then
          fastEnd=false;
          a=2;
        end
        if posNew== 6  and not gm.state.LockAnims[3] then
          fastEnd=false;
          a=3;
        end
        if posNew== 8  and not gm.state.LockAnims[4] then
          fastEnd=false;
          a=4;
        end
        if (posNew== 23 or posNew==22)  and not gm.state.LockAnims[5] then
          fastEnd=false;
          a=5;
        end
        
        
        if fastEnd then
          func_end_end()
        else
          ld.AnimPlay("anm_snowpath_anm_let_"..a, "let_"..a, func_end_end )
          if a==1 or a==2 then
            SoundSfx("aud_firtreefall")
          end
          if a==3 then
            SoundSfx("aud_holeontheroad")
          end
          if a==4 then
            SoundSfx("aud_wolfsontheroad")
          end
          if a==5 then
            SoundSfx("aud_bearontheroad")
          end
        end
      end
      
      
      ld.Lock(1);
      local t = gm.distance(xc,yc,xNew,yNew)/90;
      if xNew>=xc then
        ObjSet("anm_snowpath_anm_man",{scale_x=1});
      else
        ObjSet("anm_snowpath_anm_man",{scale_x=-1});
      end
      ObjSet("anm_snowpath_anm_man",{playing=true});
      if ObjGet("tmr_snowpath_tmr") then
        ObjDelete("tmr_snowpath_tmr");
      end
      gm.isUpdate = true;
      gm.Update();
      ObjAnimate("anm_snowpath_anm_man", 3, 0, 0, func_end, {0,0,xc,yc-gm.offset,  t,0, xNew,yNew-gm.offset});
    end
    -- FUNC END --
  end
  
  ----------------------------------- highlight
  function gm.event_menter(name)
    ObjSet(name,{alp=0.5});
    ld.ShCur( CURSOR_HAND);
  end
  function gm.event_mleave(name)
    ObjSet(name,{alp=0});
    ld.ShCur( CURSOR_DEFAULT);
  end
  
  -----------------------------
  function gm.Update()
    for f=1,gm.F do
      local fog = "spr_snowpath_square_"..f
      if ObjIntersect("anm_snowpath_anm_man",fog) and ObjGet(fog).alp==1 then
        ObjAnimate(fog, 8, 0, 0, "", {0,0,1, 0.3,0,0});
      end
    end
    if gm.isUpdate then
      ld.StartTimer("tmr_snowpath_tmr",0.4,gm.Update);
    end
  end
  
  
  ------------------------------
  function gm.distance(x1,y1,x2,y2)
    return ( math.sqrt( ( (x2-x1)^2)+((y2-y1)^2) ) )
  end
  
  ------------------------
  --set according the progress:
  ------------------------
  gm.default();
  if ng_global.progress["std"]["win_snowpath"].state then
    gm.state = ld.TableCopy( ng_global.progress["std"]["win_snowpath"].state );
  end
  --set player pos
  ObjSet("anm_snowpath_anm_man",{
    pos_x = ObjGet("spr_snowpath_marker_"..gm.state.pos).pos_x;
    pos_y = ObjGet("spr_snowpath_marker_"..gm.state.pos).pos_y-gm.offset;
  })
  --set fog of war
  for f=1,gm.F do
    local fog = "spr_snowpath_square_"..f
    if gm.state.fogOfWar[f] then
      ObjSet(fog,{alp=1})
    else
      ObjSet(fog,{alp=0})
    end
  end
  if ObjGet("tmr_snowpath_tmr") then
    ObjDelete("tmr_snowpath_tmr");
  end
  
  for a=1,5 do
    if gm.state.LockAnims[a] then
      ObjSet("anm_snowpath_anm_let_"..a,{frame=999})
    else
      ObjSet("anm_snowpath_anm_let_"..a,{frame=0})
    end
  end
  
  --set button control
  ObjSet("spr_snowpath_up",   {event_mdown = function() gm.event_mdown( 0,-1) end; event_menter = function() gm.event_menter("spr_snowpath_up_light") end;event_mleave = function() gm.event_mleave("spr_snowpath_up_light"); end})
  ObjSet("spr_snowpath_down", {event_mdown = function() gm.event_mdown( 0,1)  end;  event_menter = function() gm.event_menter("spr_snowpath_down_light") end; event_mleave = function() gm.event_mleave("spr_snowpath_down_light"); end;})
  ObjSet("spr_snowpath_right",{event_mdown = function() gm.event_mdown( 1,0)  end;  event_menter = function() gm.event_menter("spr_snowpath_right_light") end; event_mleave = function() gm.event_mleave("spr_snowpath_right_light"); end;})
  ObjSet("spr_snowpath_left", {event_mdown = function() gm.event_mdown(-1,0)  end;  event_menter = function() gm.event_menter("spr_snowpath_left_light") end;  event_mleave = function() gm.event_mleave("spr_snowpath_left_light"); end})
  ------------------------
  
end
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_arbour *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_mosaicmoon" ] = { type = "get", get_obj = "spr_arbour_mosaicmoon", room = "rm_backyard", zz = "zz_arbour", zz_gate = "gzz_backyard_arbour" };

private.get_mosaicmoon_logic = function()
  
end;
private.get_mosaicmoon_inv = function()
  interface.InventoryItemAdd("inv_mosaicmoon","spr_arbour_mosaicmoon");
end;
private.get_mosaicmoon_beg = function()
  ObjDelete("gfx_arbour_mosaicmoon")
end;
private.get_mosaicmoon_end = function()
  if common_impl.ZzCompleteCheck("get_mosaicmoon") then ObjSet( common_impl.hint["get_mosaicmoon"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_arbour_mosaicmoon_sh")
  ObjDelete("spr_backyard_moon_shadow")
  ObjDelete("spr_backyard_moon")
end;

cmn.AddSubscriber( "get_mosaicmoon", private.get_mosaicmoon_inv );
cmn.AddSubscriber( "get_mosaicmoon", private.get_mosaicmoon_beg, private.room_objname );
cmn.AddSubscriber( "get_mosaicmoon", private.get_mosaicmoon_end, private.room_objname );
cmn.AddSubscriber( "get_mosaicmoon", private.get_mosaicmoon_logic );
--------------------------------------------------------------------
function public.get_mosaicmoon()
  cmn.SetEventDone( "get_mosaicmoon" );
  cmn.CallEventHandler( "get_mosaicmoon" );
  if common_impl.ZzCompleteCheck("get_mosaicmoon") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_abigailletter3" ] = { type = "get", get_obj = "spr_arbour_abigailletter3", room = "rm_backyard", zz = "zz_arbour", zz_gate = "gzz_backyard_arbour" };

private.get_abigailletter3_logic = function()
  
end;
private.get_abigailletter3_inv = function()
  interface.InventoryItemAdd("inv_abigailletter","spr_arbour_abigailletter3",function() level_inv.ProcessGetAbigailletterAll( "get_abigailletter3" ) end);
end;
private.get_abigailletter3_beg = function()
  ObjDelete("gfx_arbour_abigailletter3")
end;
private.get_abigailletter3_end = function()
  if common_impl.ZzCompleteCheck("get_abigailletter3") then ObjSet( common_impl.hint["get_abigailletter3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_backyard_letter")
  ObjDelete("spr_arbour_abigailletter3_sh")
  
  
end;

cmn.AddSubscriber( "get_abigailletter3", private.get_abigailletter3_inv );
cmn.AddSubscriber( "get_abigailletter3", private.get_abigailletter3_beg, private.room_objname );
cmn.AddSubscriber( "get_abigailletter3", private.get_abigailletter3_end, private.room_objname );
cmn.AddSubscriber( "get_abigailletter3", private.get_abigailletter3_logic );
--------------------------------------------------------------------
function public.get_abigailletter3()
  --cmn.SetEventDone( "get_abigailletter3" );
  cmn.CallEventHandler( "get_abigailletter3" );
  --if common_impl.ZzCompleteCheck("get_abigailletter3") then ld.CloseSubRoom() end;
  public.clk_flashback33();
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_flashback33" ] = { type = "click", use_place = "gfx_arbour_clk_flashback33_zone", room = "rm_backyard", zz = "zz_arbour", zz_gate = "gzz_backyard_arbour" };

private.clk_flashback33_logic = function()
  --ObjSet( "spr_arbour_mosaicmoon", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "spr_arbour_abigailletter3", { visible = 1, input = 1, active = 1 } )

end;
private.clk_flashback33_beg = function()
  ObjDelete( "gfx_arbour_clk_flashback33_zone" );
end;
private.clk_flashback33_end = function()
  if common_impl.ZzCompleteCheck("clk_flashback33") then ObjSet( common_impl.hint["clk_flashback33"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_flashback33", private.clk_flashback33_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback33", private.clk_flashback33_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback33", private.clk_flashback33_logic );
cmn.AddSubscriber( "clk_flashback33_beg", private.clk_flashback33_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback33_end", private.clk_flashback33_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback33_end", private.clk_flashback33_logic );
--------------------------------------------------------------------------------------------
function public.clk_flashback33()

  local func_end = function()
    SoundSfx( 0 )
    SoundEnv( "aud_mansion_env", -1 )
    common_impl.FlashbackHide();
    cmn.SetEventDone( "clk_flashback33" );
    cmn.CallEventHandler( "clk_flashback33_end" );
    common_impl.Lock(0);
    
    cmn.SetEventDone( "get_abigailletter3" );
    --common_impl.Gate_MDown( "gzz_backyard_arbour" )
    common_impl.Gate_MDown( "gzz_backyard_arbour", { ObjGet( "gzz_backyard_arbour" ).pos_x, ObjGet( "gzz_backyard_arbour" ).pos_y } )
    
    
    if common_impl.ZzCompleteCheck("clk_flashback33") then ld.CloseSubRoom() end;
    ld.ShowBbt( "after_clk_flashback33" )
  end;

  cmn.CallEventHandler( "clk_flashback33_beg" );
  
  local obj_root = "obj_backyard_vid_flashback_abigail3"
  local vid_prefix = "vid_backyard_vid_flashback_abigail3_"
  local str_prefix = "str_backyard_vid_flashback_abigail3_"
  local lip_prefix = "vid_backyard_vid_flashback_3"
  local aud_count_dif = 3
  common_impl.FlashbackInit( obj_root, func_end, vid_prefix, str_prefix, lip_prefix, aud_count_dif )  
  local func_step_3 = function()
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_2" )
    SoundEnv( "aud_entrypoint_env", -1 )
    SoundEnv( "aud_mansion_env", -1 )
    common_impl.FlashbackShow( 3, func_end    );
  end;
  local func_step_2 = function()
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_35" )
    common_impl.FlashbackShow( 2, func_step_3 );
  end;
  local func_step_1 = function()
    SoundSfx( "aud_flashback_34" )
    SoundEnv( "aud_entrypoint_env", -1 )
    common_impl.FlashbackShow( 1, func_step_2 );
  end;
  ld.CloseSubRoom();
  func_step_1();
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crystalflower" ] = { type = "use", inv_obj = "inv_crystalflower", use_place = "gfx_arbour_crystalflower_zone", room = "rm_backyard", zz = "zz_arbour", zz_gate = "gzz_backyard_arbour" };

private.use_crystalflower_logic = function()
  ObjSet("gho_backyard_icearbour",{visible=1,active=1,input=1})
end;
private.use_crystalflower_inv = function()
  common_impl.ProcessMultiUseAll("crystalflower", "crystalflower")
end;
private.use_crystalflower_beg = function()
  ObjDelete( "gfx_arbour_crystalflower_zone" );
end;
private.use_crystalflower_end = function()
  if common_impl.ZzCompleteCheck("use_crystalflower") then ObjSet( common_impl.hint["use_crystalflower"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("spr_backyard_open_door",{alp=1})
  ObjSet("spr_backyard_open_light",{alp=1})
  ObjDelete("spr_backyard_close_door")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crystalflower", private.use_crystalflower_inv );
cmn.AddSubscriber( "use_crystalflower", private.use_crystalflower_beg, private.room_objname );
cmn.AddSubscriber( "use_crystalflower", private.use_crystalflower_end, private.room_objname );
cmn.AddSubscriber( "use_crystalflower", private.use_crystalflower_logic );
cmn.AddSubscriber( "use_crystalflower_inv", private.use_crystalflower_inv, private.room_objname );
cmn.AddSubscriber( "use_crystalflower_beg", private.use_crystalflower_beg, private.room_objname );
cmn.AddSubscriber( "use_crystalflower_end", private.use_crystalflower_end, private.room_objname );
cmn.AddSubscriber( "use_crystalflower_end", private.use_crystalflower_logic );
--------------------------------------------------------------------------------------------
function public.use_crystalflower( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crystalflower" );
    cmn.CallEventHandler( "use_crystalflower_end" );
    common_impl.Lock(0);
    
  end;

  local func_step = function()
    
    ld.CloseSubRoom();
    ld.StartTimer(0.5, function()
      local t = 0.5;
      ObjAnimate("spr_backyard_close_door", 8, 0, 0, _, {0,0,1, t,0,0});
      ObjAnimate("spr_backyard_open_door",  8, 0, 0, _, {0,0,0, t,0,1});
      ObjAnimate("spr_backyard_open_light",  8, 0, 0, _, {0,0,0, t,0,1});
      ld.StartTimer(t,func_end)
    end
    )
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crystalflower_inv" );
  cmn.CallEventHandler( "use_crystalflower_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_crystalflower_backyard" )
  --func_end()
  ld.AnimPlay("anm_arbour_anm","dooropen",func_step)
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_arbourroof *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_startclimbs" ] = { type = "click", use_place = "gfx_arbourroof_clk_startclimbs_zone", room = "rm_backyard", zz = "zz_arbourroof", zz_gate = "gzz_backyard_arbourroof" };

private.clk_startclimbs_logic = function()
  ObjSet("gfx_arbourroof_slapstick_zone",{visible=1,active=1,input=1});
end;
private.clk_startclimbs_beg = function()
  ObjDelete( "gfx_arbourroof_clk_startclimbs_zone" );
end;
private.clk_startclimbs_end = function()
  if common_impl.ZzCompleteCheck("clk_startclimbs") then ObjSet( common_impl.hint["clk_startclimbs"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_startclimbs", private.clk_startclimbs_beg, private.room_objname );
cmn.AddSubscriber( "clk_startclimbs", private.clk_startclimbs_end, private.room_objname );
cmn.AddSubscriber( "clk_startclimbs", private.clk_startclimbs_logic );
cmn.AddSubscriber( "clk_startclimbs_beg", private.clk_startclimbs_beg, private.room_objname );
cmn.AddSubscriber( "clk_startclimbs_end", private.clk_startclimbs_end, private.room_objname );
cmn.AddSubscriber( "clk_startclimbs_end", private.clk_startclimbs_logic );
--------------------------------------------------------------------------------------------
function public.clk_startclimbs()

  local func_end = function()
    cmn.SetEventDone( "opn_backyard" );
    cmn.CallEventHandler( "opn_backyard" )
      
    cmn.SetEventDone( "clk_startclimbs" );
    cmn.CallEventHandler( "clk_startclimbs_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_startclimbs") then ld.CloseSubRoom() end;
    
    ObjDetach("vid_arbourroof_vid_grumpy_letter_cycle");
    ld.VidStaticPlay(private.vid_list_1);
    ld.ShowBbt( "after_clk_startclimbs" )
  end;

  local func_step = function()
    ObjDetach("vid_arbourroof_vid_grumpy_climbs");
    local vid = "vid_arbourroof_vid_grumpy_letter_cycle";
    ObjAttach(vid,"obj_arbourroof_pivot");
    SoundSfx( "aud_grumpy_letter_cycle" )
    VidPlay(vid,func_end);
  end
  
  cmn.CallEventHandler( "clk_startclimbs_beg" );
  common_impl.Lock(1);
    
  ObjAnimate("obj_arbourroof_pivot", 1, 0,0, _, {0,0,-147, 7, 0,147});
  ObjAttach("vid_arbourroof_vid_grumpy_climbs","obj_arbourroof_pivot");
  --SoundSfx( "aud_grumpy_emerging" )
  VidPlay("vid_arbourroof_vid_grumpy_climbs",func_step)


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_harefoot" ] = { type = "get", get_obj = "spr_arbourroof_harefoot", room = "rm_backyard", zz = "zz_arbourroof", zz_gate = "gzz_backyard_arbourroof" };

private.get_harefoot_logic = function()
  
end;
private.get_harefoot_inv = function()
  interface.InventoryItemAdd("inv_harefoot","spr_arbourroof_harefoot");
end;
private.get_harefoot_beg = function()
  ObjDelete("gfx_arbourroof_harefoot")
end;
private.get_harefoot_end = function()
  if common_impl.ZzCompleteCheck("get_harefoot") then ObjSet( common_impl.hint["get_harefoot"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_arbourroof_harefoot_shadow")
  ObjDelete("spr_backyard_harefoot")
end;

cmn.AddSubscriber( "get_harefoot", private.get_harefoot_inv );
cmn.AddSubscriber( "get_harefoot", private.get_harefoot_beg, private.room_objname );
cmn.AddSubscriber( "get_harefoot", private.get_harefoot_end, private.room_objname );
cmn.AddSubscriber( "get_harefoot", private.get_harefoot_logic );
--------------------------------------------------------------------
function public.get_harefoot()
  cmn.SetEventDone( "get_harefoot" );
  cmn.CallEventHandler( "get_harefoot" );
  if common_impl.ZzCompleteCheck("get_harefoot") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_slapstick" ] = { type = "use", inv_obj = "inv_slapstick", use_place = "gfx_arbourroof_slapstick_zone", room = "rm_backyard", zz = "zz_arbourroof", zz_gate = "gzz_backyard_arbourroof" };

private.use_slapstick_logic = function()
  ObjSet( "spr_arbourroof_ball3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_arbourroof_nippers_arbourroof_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_slapstick_inv = function()
  common_impl.ProcessMultiUseAll("slapstick", "slapstick")
end;
private.use_slapstick_beg = function()
  ObjDelete( "gfx_arbourroof_slapstick_zone" );
end;
private.use_slapstick_end = function()
  if common_impl.ZzCompleteCheck("use_slapstick") then ObjSet( common_impl.hint["use_slapstick"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("obj_arbourroof_pivot",{pos_y=-100})
  --ObjSet("spr_arbourroof_ball3_sh",{visible=1})
  ObjDelete("vid_backyard_vid_grumpy_static")
  --ObjSet("spr_backyard_ball_click",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_slapstick", private.use_slapstick_inv );
cmn.AddSubscriber( "use_slapstick", private.use_slapstick_beg, private.room_objname );
cmn.AddSubscriber( "use_slapstick", private.use_slapstick_end, private.room_objname );
cmn.AddSubscriber( "use_slapstick", private.use_slapstick_logic );
cmn.AddSubscriber( "use_slapstick_inv", private.use_slapstick_inv, private.room_objname );
cmn.AddSubscriber( "use_slapstick_beg", private.use_slapstick_beg, private.room_objname );
cmn.AddSubscriber( "use_slapstick_end", private.use_slapstick_end, private.room_objname );
cmn.AddSubscriber( "use_slapstick_end", private.use_slapstick_logic );
--------------------------------------------------------------------------------------------
function public.use_slapstick( obj )

  local func_end = function()
    
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_slapstick" );
    cmn.CallEventHandler( "use_slapstick_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_slapstick") then ld.CloseSubRoom() end;
    
    ld.VidStaticPlay( private.vid_list_2 );
    ld.VidStaticPlay( private.vid_list_3 );
    ObjDetach("vid_arbourroof_vid_grumpy_petard")
    ld.ShowBbt( "after_use_slapstick" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_slapstick_inv" );
  cmn.CallEventHandler( "use_slapstick_beg" );
  common_impl.Lock(1);
  
  
  ld.VidStaticDetach(private.vid_list_1);
  
  ObjAnimate("obj_arbourroof_pivot", 1, 0,0, _, {0,0,147, 1,0,147,  2,0,-100});
  
  
  
  
  ObjAttach("vid_arbourroof_vid_grumpy_petard","obj_arbourroof_pivot");
  VidPlay("vid_arbourroof_vid_grumpy_petard",func_end)
  --ld.StartTimer(1,function() ObjSet( "spr_arbourroof_ball3", { visible = 1,active=1,alp=1 } );  ObjSet("spr_arbourroof_ball3_sh",{visible=1})  end)
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_slapstick_backyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
function public.idle_0()
  
  local vid = "vid_arbourroof_vid_grumpy_letter_cycle"
  local rnd = math.random(1,5);
  if rnd>3 then
    rnd=1;
  end
  
  if rnd==1 then
    SoundSfx( "aud_grumpy_letter_cycle" )
    vid = "vid_arbourroof_vid_grumpy_letter_cycle"
  elseif rnd==2 then
    SoundSfx( "aud_grumpy_face_contorts_cycle" )
    vid = "vid_arbourroof_vid_grumpy_face_contorts_cycle"
  elseif rnd==3 then
    SoundSfx( "aud_grumpy_laugh_cycle" )
    vid = "vid_arbourroof_vid_grumpy_laugh_cycle"
  end
  
  local func_end = function()
    ld.VidStaticPlay( private.vid_list_1 );
    common_impl.ShowBbt( 'need_slapstick' )
    ObjDetach(vid)
    ld.Lock(0)
  end
  
  ld.Lock(1)
  
  ld.VidStaticDetach( private.vid_list_1 );
  
  
  ObjAttach(vid,"obj_arbourroof_pivot")
  VidPlay(vid,func_end)
end
--------------------------------------------------------------------------------------------
function public.idle_1()
  local func_end = function()
    common_impl.ShowBbt( 'need_nippers_arbourroof' )
    ld.VidStaticPlay( private.vid_list_2 );
    ObjDetach("vid_arbourroof_vid_grumpy_hanging_click")
    ld.Lock(0)
  end
  
  ld.Lock(1);
  ld.VidStaticDetach( private.vid_list_2 );
  ObjAttach("vid_arbourroof_vid_grumpy_hanging_click","obj_arbourroof_pivot")
  SoundSfx( "aud_grumpy_hanging_click" )
  VidPlay("vid_arbourroof_vid_grumpy_hanging_click",func_end)
end
--------------------------------------------------------------------
common_impl.hint[ "get_ball3" ] = { type = "get", get_obj = "spr_arbourroof_ball3", room = "rm_backyard", zz = "zz_arbourroof", zz_gate = "gzz_backyard_arbourroof" };

private.get_ball3_logic = function()
  
end;
private.get_ball3_inv = function()
  interface.InventoryItemAdd("inv_ball","spr_arbourroof_ball3",function() level_inv.ProcessGetBallAll( "get_ball3" ) end);
end;
private.get_ball3_beg = function()
  ObjDelete("gfx_arbourroof_ball3")
end;
private.get_ball3_end = function()
  if common_impl.ZzCompleteCheck("get_ball3") then ObjSet( common_impl.hint["get_ball3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_arbourroof_ball3_sh")
  ObjDelete("spr_backyard_ball_click")
end;

cmn.AddSubscriber( "get_ball3", private.get_ball3_inv );
cmn.AddSubscriber( "get_ball3", private.get_ball3_beg, private.room_objname );
cmn.AddSubscriber( "get_ball3", private.get_ball3_end, private.room_objname );
cmn.AddSubscriber( "get_ball3", private.get_ball3_logic );
--------------------------------------------------------------------
function public.get_ball3()  
  cmn.SetEventDone( "get_ball3" );
  cmn.CallEventHandler( "get_ball3" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_nippers_arbourroof" ] = { type = "use", inv_obj = "inv_nippers", use_place = "gfx_arbourroof_nippers_arbourroof_zone", room = "rm_backyard", zz = "zz_arbourroof", zz_gate = "gzz_backyard_arbourroof" };

private.use_nippers_arbourroof_logic = function()
  ObjSet("spr_arbour_abigailletter3",{visible=1,input=1,active=1});
end;
private.use_nippers_arbourroof_inv = function()
  common_impl.ProcessMultiUseAll("nippers", "nippers_arbourroof")
end;
private.use_nippers_arbourroof_beg = function()
  ObjDelete( "gfx_arbourroof_nippers_arbourroof_zone" );
end;
private.use_nippers_arbourroof_end = function()
  if common_impl.ZzCompleteCheck("use_nippers_arbourroof") then ObjSet( common_impl.hint["use_nippers_arbourroof"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("spr_backyard_letter",{visible=1})
  ObjSet("spr_backyard_garland",{visible=1})
  ObjDelete("spr_backyard_garland_1")
  ObjSet("spr_arbour_abigailletter3_sh",{visible=1})
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_nippers_arbourroof", private.use_nippers_arbourroof_inv );
cmn.AddSubscriber( "use_nippers_arbourroof", private.use_nippers_arbourroof_beg, private.room_objname );
cmn.AddSubscriber( "use_nippers_arbourroof", private.use_nippers_arbourroof_end, private.room_objname );
cmn.AddSubscriber( "use_nippers_arbourroof", private.use_nippers_arbourroof_logic );
cmn.AddSubscriber( "use_nippers_arbourroof_inv", private.use_nippers_arbourroof_inv, private.room_objname );
cmn.AddSubscriber( "use_nippers_arbourroof_beg", private.use_nippers_arbourroof_beg, private.room_objname );
cmn.AddSubscriber( "use_nippers_arbourroof_end", private.use_nippers_arbourroof_end, private.room_objname );
cmn.AddSubscriber( "use_nippers_arbourroof_end", private.use_nippers_arbourroof_logic );
--------------------------------------------------------------------------------------------
function public.use_nippers_arbourroof( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_nippers_arbourroof" );
    cmn.CallEventHandler( "use_nippers_arbourroof_end" );
    common_impl.Lock(0);
    
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_nippers_arbourroof_inv" );
  cmn.CallEventHandler( "use_nippers_arbourroof_beg" );
  common_impl.Lock(1);
  
  local func_step_2 = function()
    ObjDetach("vid_backyard_vid_grumpy_falls_teleport")
    ObjDetach("vid_backyard_vid_letter")
    ObjSet("spr_backyard_letter",{visible=1})
    ObjSet("spr_arbour_abigailletter3_sh",{visible=1})
    ObjSet("spr_backyard_garland",{visible=1})
    ObjSet("spr_arbour_abigailletter3",{visible=1,input=1,active=1});
    --ObjGet("gzz_backyard_arbour").event_mdown();
    common_impl.Gate_MDown( "gzz_backyard_arbour", { ObjGet( "gzz_backyard_arbour" ).pos_x, ObjGet( "gzz_backyard_arbour" ).pos_y } )
    ld.ShowBbt( "after_use_nippers_arbourroof_end" )
    ld.StartTimer(0.5,func_end);
  end
  
  local func_step = function()
    ld.CloseSubRoom();
    
    
    ld.VidStaticDetach( private.vid_list_3 );
    ObjAttach("vid_backyard_vid_grumpy_falls_teleport","rm_backyard")
    ObjAttach("vid_backyard_vid_letter","rm_backyard");
    ld.StartTimer(0.5,function() 
      VidPlay("vid_backyard_vid_grumpy_falls_teleport",func_step_2) 
      VidPlay("vid_backyard_vid_letter",_);
      ObjDetach("vid_arbourroof_vid_grumpy_torn_garland");
    end)
  end
  
  SoundSfx("aud_use_nippers_arbourroof");
  ld.AnimPlay("anm_arbourroof_anm","nippers",
  function()
    ld.VidStaticDetach( private.vid_list_2 );
    ld.VidStaticDetach( private.vid_list_3 );
    ObjAttach("vid_arbourroof_vid_grumpy_torn_garland","obj_arbourroof_pivot");
    VidPlay("vid_arbourroof_vid_grumpy_torn_garland", func_step);
  end);
  
  
end;

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_icearbour_for_backyard = function()
    if ld.CheckRequirements( {"win_icearbour"} ) then
      ObjSet( "gho_backyard_icearbour", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_icearbour", win_icearbour_for_backyard, private.room_objname )

end;
--*********************************************************************************************************************
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  if mg_name == "zz_snowpath" then
    private.win_snowpath_game.reset();
  end
end
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  if mg_name == "zz_snowpath" then
    private.win_snowpath_game.skip();
  end
end
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_backyard();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_mansion_env" )
  if not ( cmn.IsEventDone( "opn_backyard" ) ) then
    --local func_end = function()
    --  common_impl.Gate_MDown( "gzz_backyard_arbourroof" )
    --  ld.StartTimer(0.5,
    --  function()
    --    ObjDetach("vid_backyard_vid_grumpy_emerging");
    --    ObjSet("vid_backyard_vid_grumpy_static",{visible=1});
    --  end
    --  )
    --end;
    ld.Lock(1)
    ObjSet("vid_backyard_vid_grumpy_static",{visible=0});
    ObjAttach("vid_backyard_vid_grumpy_emerging","rm_backyard")
    --VidPlay("vid_backyard_vid_grumpy_emerging",func_end)
  end;
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;

--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_arbourroof" );
  function zz_arbourroof.Open()
  end;
  function zz_arbourroof.PreOpen()
    if not ld.CheckRequirements({"clk_startclimbs"}) then
      public.clk_startclimbs();
    end
  end;
  function zz_arbourroof.PreClose()
  end;
  function zz_arbourroof.Close()
  end;

  subroom.Define( "zz_arbour" );
  function zz_arbour.Open()
  end;
  function zz_arbour.PreOpen()
  end;
  function zz_arbour.PreClose()
  end;
  function zz_arbour.Close()
  end;

  subroom.Define( "zz_snowpath" );
  function zz_snowpath.Open()
  end;
  function zz_snowpath.PreOpen()
    
    if ld.CheckRequirements( {"use_map"} ) and not ld.CheckRequirements( {"win_snowpath"} ) then
      public.win_snowpath_load()
    end
    
  end;
  function zz_snowpath.PreClose()
    if ObjGet("tmr_snowpath_tmr") then
      ObjDelete("tmr_snowpath_tmr");
    end
  end;
  function zz_snowpath.Close()
  end;
  
end;
--*********************************************************************************************************************