-- name=rm_chapel
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_chapel";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_chapelzz_tape_small", "spr_chapelzz_tape", "txt_chapelzz_about_boy")
  --------------------------------------------------------------------------------------------
function private.opn_chapel()
  if not ( cmn.IsEventDone( "opn_chapel" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_chapel" );
      cmn.CallEventHandler( "opn_chapel" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_chapel = function() end;
local opn_chapel_logic = function() end;
cmn.AddSubscriber( "opn_chapel", opn_chapel_logic )
cmn.AddSubscriber( "opn_chapel", opn_chapel, private.room_objname )
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "jack31" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then
      common_impl.continue_visible = true
    elseif count_txt == 3 then 
      common_impl.continue_visible = true
      ld.AnimPlay( "anm_chapel_jack31", "give_diary", nil )
    elseif count_txt == 4 then 
      cmn.CallEventHandler( "get_jackalbum" );
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_chapel_jack31" ] = { type = "click", use_place = "gfx_chapel_dlg_chapel_jack31_zone", room = "rm_chapel" };

private.dlg_chapel_jack31_logic = function()
  ObjSet( "spr_chapel_jackalbum", { visible = 1, input = 1, active = 1 } )
end;
private.dlg_chapel_jack31_beg = function()
  ObjDelete( "gfx_chapel_dlg_chapel_jack31_zone" );
end;
private.dlg_chapel_jack31_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_chapel_jack31", private.dlg_chapel_jack31_beg, private.room_objname );
cmn.AddSubscriber( "dlg_chapel_jack31", private.dlg_chapel_jack31_end, private.room_objname );
cmn.AddSubscriber( "dlg_chapel_jack31", private.dlg_chapel_jack31_logic );
cmn.AddSubscriber( "dlg_chapel_jack31_beg", private.dlg_chapel_jack31_beg, private.room_objname );
cmn.AddSubscriber( "dlg_chapel_jack31_end", private.dlg_chapel_jack31_end, private.room_objname );
cmn.AddSubscriber( "dlg_chapel_jack31_end", private.dlg_chapel_jack31_logic );
--------------------------------------------------------------------------------------------
function public.dlg_chapel_jack31( called_func_end )

  local func_end = function()
    called_func_end()

    cmn.SetEventDone( "dlg_chapel_jack31" );
    cmn.CallEventHandler( "dlg_chapel_jack31_end" );

    cmn.SetEventDone( "get_jackalbum" );
    if ObjGetRelations( "inv_jackalbum" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_jackalbum" );
    end    
    ld.ShowBbt( "after_dlg_chapel_jack31" )
  end;

  function public.dlg_chapel_jack31_end( )
    func_end()
  end

  cmn.CallEventHandler( "dlg_chapel_jack31_beg" );
  common_impl.Lock(1);
  ld.CloseSubRoom()
  ld.StartTimer( 0.5, function() 
    common_impl.Lock(0);
    local func_step = function() 
      int.DialogVideoHide()
      
      common_impl.Start( "jack31", 4, nil, nil, true, "dlg_chapel_jack31_end", { "aud_jack_frost_8_voc", "aud_jack_frost_9_voc", "aud_jack_frost_10_voc" } );
    end

    int.DialogVideoShow( "vid_chapel_vid_jack_arriving_81", 1, func_step, 1 );
    SoundVid( "aud_jack_arriving_81" )
    VidPlay( "vid_chapel_vid_jack_arriving_81", func_step )
  end )




end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_jackalbum" ] = { type = "get", get_obj = "spr_chapel_jackalbum", room = "rm_chapel" };

private.get_jackalbum_logic = function()
  
end;
private.get_jackalbum_inv = function()
  interface.InventoryItemAdd("inv_jackalbum","spr_chapel_jackalbum");
end;
private.get_jackalbum_beg = function()
  ObjSet( "spr_chapel_jackalbum", { visible = 1, input = 1, active = 1 } )
  ObjDelete("gfx_chapel_jackalbum")
end;
private.get_jackalbum_end = function()

end;

cmn.AddSubscriber( "get_jackalbum", private.get_jackalbum_inv );
cmn.AddSubscriber( "get_jackalbum", private.get_jackalbum_beg, private.room_objname );
cmn.AddSubscriber( "get_jackalbum", private.get_jackalbum_end, private.room_objname );
cmn.AddSubscriber( "get_jackalbum", private.get_jackalbum_logic );
--------------------------------------------------------------------
function public.get_jackalbum()
  cmn.SetEventDone( "get_jackalbum" );
  cmn.CallEventHandler( "get_jackalbum" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_chapelzz *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_crystalflower" ] = { type = "get", get_obj = "spr_chapelzz_crystalflower", room = "rm_chapel", zz = "zz_chapelzz", zz_gate = "gzz_chapel_chapelzz" };

private.get_crystalflower_logic = function()
  
end;
private.get_crystalflower_inv = function()
  interface.InventoryItemAdd("inv_crystalflower","spr_chapelzz_crystalflower");
end;
private.get_crystalflower_beg = function()
  ObjDelete("gfx_chapelzz_crystalflower")
end;
private.get_crystalflower_end = function()
  ObjSet( "spr_chapelzz_tape_small", { input = 1 } )
  ObjDelete( "spr_chapel_crystalflower_tr" )
  ObjDelete( "spr_chapelzz_crystalflower_shadow" )
  if common_impl.ZzCompleteCheck("get_crystalflower") then ObjSet( common_impl.hint["get_crystalflower"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_crystalflower", private.get_crystalflower_inv );
cmn.AddSubscriber( "get_crystalflower", private.get_crystalflower_beg, private.room_objname );
cmn.AddSubscriber( "get_crystalflower", private.get_crystalflower_end, private.room_objname );
cmn.AddSubscriber( "get_crystalflower", private.get_crystalflower_logic );
--------------------------------------------------------------------
function public.get_crystalflower()
  cmn.SetEventDone( "get_crystalflower" );
  cmn.CallEventHandler( "get_crystalflower" );
  if common_impl.ZzCompleteCheck("get_crystalflower") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_photoboy" ] = { type = "use", inv_obj = "inv_photoboy", use_place = "gfx_chapelzz_photoboy_zone", room = "rm_chapel", zz = "zz_chapelzz", zz_gate = "gzz_chapel_chapelzz" };

private.use_photoboy_logic = function()
  if ld.CheckRequirements( {"use_photoboy","use_truck","use_cookiesready"} ) then
    ObjSet( "gfx_chapel_dlg_chapel_jack31_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_photoboy_inv = function()
  common_impl.ProcessMultiUseAll("photoboy", "photoboy")
end;
private.use_photoboy_beg = function()
  ObjDelete( "gfx_chapelzz_photoboy_zone" );
  ObjSet( "spr_chapel_photoboy_tr", { visible = 1 } )
end;
private.use_photoboy_end = function()
  ObjSet( "anm_chapelzz_anm_use_photoboy", { animfunc = "use_photoboy", frame = 999 } )
  if common_impl.ZzCompleteCheck("use_photoboy") then ObjSet( common_impl.hint["use_photoboy"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_photoboy", private.use_photoboy_inv );
cmn.AddSubscriber( "use_photoboy", private.use_photoboy_beg, private.room_objname );
cmn.AddSubscriber( "use_photoboy", private.use_photoboy_end, private.room_objname );
cmn.AddSubscriber( "use_photoboy", private.use_photoboy_logic );
cmn.AddSubscriber( "use_photoboy_inv", private.use_photoboy_inv, private.room_objname );
cmn.AddSubscriber( "use_photoboy_beg", private.use_photoboy_beg, private.room_objname );
cmn.AddSubscriber( "use_photoboy_end", private.use_photoboy_end, private.room_objname );
cmn.AddSubscriber( "use_photoboy_end", private.use_photoboy_logic );
--------------------------------------------------------------------------------------------
function public.use_photoboy( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_photoboy" );
    cmn.CallEventHandler( "use_photoboy_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_photoboy_inv" );
  cmn.CallEventHandler( "use_photoboy_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_photoboy_chapel" )
  local o = ObjGet( "anm_chapelzz_anm_use_photoboy" )
  ObjSet( o.name, { pos_z = 11 } )
  ld.AnimPlay( "anm_chapelzz_anm_use_photoboy", "use_photoboy", function() 
    ObjSet( o.name, { pos_z = o.pos_z } )
    if ld.CheckRequirements( { "use_cookiesready", "use_truck", "use_photoboy" }, 1 ) == 2 then
      public.dlg_chapel_jack31( func_end )
    else
      func_end()
    end
  end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_truck" ] = { type = "use", inv_obj = "inv_truck", use_place = "gfx_chapelzz_truck_zone", room = "rm_chapel", zz = "zz_chapelzz", zz_gate = "gzz_chapel_chapelzz" };

private.use_truck_logic = function()
  if ld.CheckRequirements( {"use_truck","use_photoboy","use_cookiesready"} ) then
    ObjSet( "gfx_chapel_dlg_chapel_jack31_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_truck_inv = function()
  common_impl.ProcessMultiUseAll("truck", "truck")
end;
private.use_truck_beg = function()
  ObjDelete( "gfx_chapelzz_truck_zone" );
  ObjSet( "spr_chapel_truck_tr", { visible = 1 } )
end;
private.use_truck_end = function()
  ObjSet( "anm_chapelzz_anm_use_truck", { animfunc = "use_truck", frame = 999 } )
  if common_impl.ZzCompleteCheck("use_truck") then ObjSet( common_impl.hint["use_truck"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_truck", private.use_truck_inv );
cmn.AddSubscriber( "use_truck", private.use_truck_beg, private.room_objname );
cmn.AddSubscriber( "use_truck", private.use_truck_end, private.room_objname );
cmn.AddSubscriber( "use_truck", private.use_truck_logic );
cmn.AddSubscriber( "use_truck_inv", private.use_truck_inv, private.room_objname );
cmn.AddSubscriber( "use_truck_beg", private.use_truck_beg, private.room_objname );
cmn.AddSubscriber( "use_truck_end", private.use_truck_end, private.room_objname );
cmn.AddSubscriber( "use_truck_end", private.use_truck_logic );
--------------------------------------------------------------------------------------------
function public.use_truck( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_truck" );
    cmn.CallEventHandler( "use_truck_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_truck_inv" );
  cmn.CallEventHandler( "use_truck_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_truck_chapel" )

  ld.AnimPlay( "anm_chapelzz_anm_use_truck", "use_truck", function() 
    if ld.CheckRequirements( { "use_cookiesready", "use_truck", "use_photoboy" }, 1 ) == 2 then
      public.dlg_chapel_jack31( func_end )
    else
      func_end()
    end
  end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cookiesready" ] = { type = "use", inv_obj = "inv_cookiesready", use_place = "gfx_chapelzz_cookiesready_zone", room = "rm_chapel", zz = "zz_chapelzz", zz_gate = "gzz_chapel_chapelzz" };

private.use_cookiesready_logic = function()
  if ld.CheckRequirements( {"use_cookiesready","use_photoboy","use_truck"} ) then
    ObjSet( "gfx_chapel_dlg_chapel_jack31_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_cookiesready_inv = function()
  common_impl.ProcessMultiUseAll("cookiesready", "cookiesready")
end;
private.use_cookiesready_beg = function()
  ObjDelete( "gfx_chapelzz_cookiesready_zone" );
  ObjSet( "spr_chapel_cake_tr", { visible = 1 } )
end;
private.use_cookiesready_end = function()
  ObjSet( "anm_chapelzz_anm_use_cake", { animfunc = "use_cake", frame = 999 } )
  if common_impl.ZzCompleteCheck("use_cookiesready") then ObjSet( common_impl.hint["use_cookiesready"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cookiesready", private.use_cookiesready_inv );
cmn.AddSubscriber( "use_cookiesready", private.use_cookiesready_beg, private.room_objname );
cmn.AddSubscriber( "use_cookiesready", private.use_cookiesready_end, private.room_objname );
cmn.AddSubscriber( "use_cookiesready", private.use_cookiesready_logic );
cmn.AddSubscriber( "use_cookiesready_inv", private.use_cookiesready_inv, private.room_objname );
cmn.AddSubscriber( "use_cookiesready_beg", private.use_cookiesready_beg, private.room_objname );
cmn.AddSubscriber( "use_cookiesready_end", private.use_cookiesready_end, private.room_objname );
cmn.AddSubscriber( "use_cookiesready_end", private.use_cookiesready_logic );
--------------------------------------------------------------------------------------------
function public.use_cookiesready( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cookiesready" );
    cmn.CallEventHandler( "use_cookiesready_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cookiesready_inv" );
  cmn.CallEventHandler( "use_cookiesready_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_cookiesready_chapel" )
  ld.AnimPlay( "anm_chapelzz_anm_use_cake", "use_cake", function() 
    if ld.CheckRequirements( { "use_cookiesready", "use_truck", "use_photoboy" }, 1 ) == 2 then
      public.dlg_chapel_jack31( func_end )
    else
      func_end()
    end
  end );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_chapel();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_entrypoint_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_chapelzz" );
  function zz_chapelzz.Open()
  end;
  function zz_chapelzz.PreOpen()
  end;
  function zz_chapelzz.PreClose()
  end;
  function zz_chapelzz.Close()
  end;
  
end;
--*********************************************************************************************************************