-- name=rm_citystreets
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_citystreets";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_streetfirtree_paper_shadow", "spr_streetfirtree_paper_big", "txt_streetfirtree_note" )
  ld.NoteRelaseLock("spr_streetfirtree_paper_shadow");
  --------------------------------------------------------------------------------------------
function private.opn_citystreets()
  if not ( cmn.IsEventDone( "opn_citystreets" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_citystreets" );
      cmn.CallEventHandler( "opn_citystreets" )
      ld.ShowBbtOpn( private.room_objname )
      int.DialogVideoHide();
  end;
  int.DialogVideoShow( "vid_citystreets_grumpy_wendydoll", 1, func_end );
  ObjAnimate( "vid_citystreets_grumpy_wendydoll", 7, 0, 0, function() 
    SoundVid( "aud_grumpy_wendydoll" )
    VidPlay("vid_citystreets_grumpy_wendydoll",func_end)
  end, {0,0,0, 0.5,0,0} );
  --func_end()
  end;
end;
--------------------------------------------------------------------
local opn_citystreets = function() 
  ObjSet( "obj_citystreets_wolf", {visible = 1} );
end;
local opn_citystreets_logic = function() end;
cmn.AddSubscriber( "opn_citystreets", opn_citystreets_logic )
cmn.AddSubscriber( "opn_citystreets", opn_citystreets, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mouse_citystreets" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_citystreets_mouse_citystreets_zone", room = "rm_citystreets" };

private.use_mouse_citystreets_logic = function()
  ObjSet( "gfx_citystreets_lead_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_mouse_citystreets_inv = function()
  common_impl.ProcessMultiUseAll("mouse", "mouse_citystreets")
end;
private.use_mouse_citystreets_beg = function()
  ObjDelete( "gfx_citystreets_mouse_citystreets_zone" );
end;
private.use_mouse_citystreets_end = function()
  ObjDelete("vid_citystreets_vid_icewolf_static")
  ObjSet( "spr_citystreets_icewolf_fall", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mouse_citystreets", private.use_mouse_citystreets_inv );
cmn.AddSubscriber( "use_mouse_citystreets", private.use_mouse_citystreets_beg, private.room_objname );
cmn.AddSubscriber( "use_mouse_citystreets", private.use_mouse_citystreets_end, private.room_objname );
cmn.AddSubscriber( "use_mouse_citystreets", private.use_mouse_citystreets_logic );
cmn.AddSubscriber( "use_mouse_citystreets_inv", private.use_mouse_citystreets_inv, private.room_objname );
cmn.AddSubscriber( "use_mouse_citystreets_beg", private.use_mouse_citystreets_beg, private.room_objname );
cmn.AddSubscriber( "use_mouse_citystreets_end", private.use_mouse_citystreets_end, private.room_objname );
cmn.AddSubscriber( "use_mouse_citystreets_end", private.use_mouse_citystreets_logic );
--------------------------------------------------------------------------------------------
function public.use_mouse_citystreets( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mouse_citystreets" );
    cmn.CallEventHandler( "use_mouse_citystreets_end" );
    common_impl.Lock(0);
    --int_inventory.StdItemFlyAnimation( "spr_cats_simon", "obj_int_button_map_point_for_cube", func_end_2 );
    interface.SimonReturn()
    ObjDelete("vid_citystreets_vid_icewolf_catch")
  end;
  local func_end_2 = function()
    ObjDelete("vid_citystreets_vid_icewolf_static")
    ObjAttach("vid_citystreets_vid_icewolf_catch","obj_citystreets_wolf")
    SoundVid( "aud_use_mouse_citystreets" )
    VidPlay("vid_citystreets_vid_icewolf_catch",func_end)
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mouse_citystreets_inv" );
  cmn.CallEventHandler( "use_mouse_citystreets_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  interface.SimonJump(func_end_2)

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lead" ] = { type = "use", inv_obj = "inv_lead", use_place = "gfx_citystreets_lead_zone", room = "rm_citystreets" };

private.use_lead_logic = function()
  ObjSet( "gzz_citystreets_doortojewelryshop", { visible = 1, input = 1, active = 1 } )

end;
private.use_lead_inv = function()
  common_impl.ProcessMultiUseAll("lead", "lead")
end;
private.use_lead_beg = function()
  ObjDelete( "gfx_citystreets_lead_zone" );
  ObjAttach("vid_citystreets_vid_icewolf_arcan", "obj_citystreets_wolf")
end;
private.use_lead_end = function()
  ObjDelete("spr_citystreets_icewolf_fall")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lead", private.use_lead_inv );
cmn.AddSubscriber( "use_lead", private.use_lead_beg, private.room_objname );
cmn.AddSubscriber( "use_lead", private.use_lead_end, private.room_objname );
cmn.AddSubscriber( "use_lead", private.use_lead_logic );
cmn.AddSubscriber( "use_lead_inv", private.use_lead_inv, private.room_objname );
cmn.AddSubscriber( "use_lead_beg", private.use_lead_beg, private.room_objname );
cmn.AddSubscriber( "use_lead_end", private.use_lead_end, private.room_objname );
cmn.AddSubscriber( "use_lead_end", private.use_lead_logic );
--------------------------------------------------------------------------------------------
function public.use_lead( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lead" );
    cmn.CallEventHandler( "use_lead_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lead_inv" );
  cmn.CallEventHandler( "use_lead_beg" );
  common_impl.Lock(1);
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_lead_citystreets" )
  ObjAnimate( "spr_citystreets_icewolf_fall", 8, 0, 0, function() end, {0,0,1, 0.5,1,0} );
  ObjAnimate( "vid_citystreets_vid_icewolf_arcan", 8, 0, 0, function() func_end() end, {0,0,0, 0.5,2,1} );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_streetfirtree *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_woodhorse2" ] = { type = "get", get_obj = "spr_streetfirtree_woodhorse2", room = "rm_citystreets", zz = "zz_streetfirtree", zz_gate = "gzz_citystreets_streetfirtree" };

private.get_woodhorse2_logic = function()
  
end;
private.get_woodhorse2_inv = function()
  interface.InventoryItemAdd("inv_woodhorse2","spr_streetfirtree_woodhorse2");
end;
private.get_woodhorse2_beg = function()
  ObjDelete("gfx_streetfirtree_woodhorse2")
end;
private.get_woodhorse2_end = function()
  ObjDelete("spr_streetfirtree_woodhorse2_shadow")
  ObjDelete("spr_citystreets_tr_horse")
  if common_impl.ZzCompleteCheck("get_woodhorse2") then ObjSet( common_impl.hint["get_woodhorse2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_woodhorse2", private.get_woodhorse2_inv );
cmn.AddSubscriber( "get_woodhorse2", private.get_woodhorse2_beg, private.room_objname );
cmn.AddSubscriber( "get_woodhorse2", private.get_woodhorse2_end, private.room_objname );
cmn.AddSubscriber( "get_woodhorse2", private.get_woodhorse2_logic );
--------------------------------------------------------------------
function public.get_woodhorse2()
  cmn.SetEventDone( "get_woodhorse2" );
  cmn.CallEventHandler( "get_woodhorse2" );
  if common_impl.ZzCompleteCheck("get_woodhorse2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_horn" ] = { type = "use", inv_obj = "inv_horn", use_place = "gfx_streetfirtree_horn_zone", room = "rm_citystreets", zz = "zz_streetfirtree", zz_gate = "gzz_citystreets_streetfirtree" };

private.use_horn_logic = function()
  ObjSet( "spr_streetfirtree_crown", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_streetfirtree_puzzle2", { visible = 1, input = 1, active = 1 } )

end;
private.use_horn_inv = function()
  common_impl.ProcessMultiUseAll("horn", "horn")
end;
private.use_horn_beg = function()
  ObjDelete( "gfx_streetfirtree_horn_zone" );
end;
private.use_horn_end = function()
  ObjDelete("spr_citystreets_tr_close")
  ObjSet( "spr_citystreets_tr_golden_horn", {visible = 1} );
  ObjSet( "anm_streetfirtree_anim_deer", {animfunc = "anim_use_horn_end", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_horn") then ObjSet( common_impl.hint["use_horn"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_horn", private.use_horn_inv );
cmn.AddSubscriber( "use_horn", private.use_horn_beg, private.room_objname );
cmn.AddSubscriber( "use_horn", private.use_horn_end, private.room_objname );
cmn.AddSubscriber( "use_horn", private.use_horn_logic );
cmn.AddSubscriber( "use_horn_inv", private.use_horn_inv, private.room_objname );
cmn.AddSubscriber( "use_horn_beg", private.use_horn_beg, private.room_objname );
cmn.AddSubscriber( "use_horn_end", private.use_horn_end, private.room_objname );
cmn.AddSubscriber( "use_horn_end", private.use_horn_logic );
--------------------------------------------------------------------------------------------
function public.use_horn( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_horn" );
    cmn.CallEventHandler( "use_horn_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_horn") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_horn_inv" );
  cmn.CallEventHandler( "use_horn_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_streetfirtree_anim_deer", "anim_use_horn", func_end );
  SoundSfx( "aud_use_horn_streetfirtree" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_crown" ] = { type = "get", get_obj = "spr_streetfirtree_crown", room = "rm_citystreets", zz = "zz_streetfirtree", zz_gate = "gzz_citystreets_streetfirtree" };

private.get_crown_logic = function()
  
end;
private.get_crown_inv = function()
  interface.InventoryItemAdd("inv_crown","spr_streetfirtree_crown");
end;
private.get_crown_beg = function()
  ObjDelete("gfx_streetfirtree_crown")
end;
private.get_crown_end = function()
  ObjDelete("spr_streetfirtree_crown_shadow")
  if common_impl.ZzCompleteCheck("get_crown") then ObjSet( common_impl.hint["get_crown"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_crown", private.get_crown_inv );
cmn.AddSubscriber( "get_crown", private.get_crown_beg, private.room_objname );
cmn.AddSubscriber( "get_crown", private.get_crown_end, private.room_objname );
cmn.AddSubscriber( "get_crown", private.get_crown_logic );
--------------------------------------------------------------------
function public.get_crown()
  cmn.SetEventDone( "get_crown" );
  cmn.CallEventHandler( "get_crown" );
  if common_impl.ZzCompleteCheck("get_crown") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_puzzle2" ] = { type = "get", get_obj = "spr_streetfirtree_puzzle2", room = "rm_citystreets", zz = "zz_streetfirtree", zz_gate = "gzz_citystreets_streetfirtree" };

private.get_puzzle2_logic = function()
  
end;
private.get_puzzle2_inv = function()
  interface.InventoryItemAdd("inv_puzzle","spr_streetfirtree_puzzle2",function() level_inv.ProcessGetPuzzleAll( "get_puzzle2" ) end);
end;
private.get_puzzle2_beg = function()
  ObjDelete("gfx_streetfirtree_puzzle2")
end;
private.get_puzzle2_end = function()
  ObjDelete("spr_streetfirtree_puzzle2_shadow")
  if common_impl.ZzCompleteCheck("get_puzzle2") then ObjSet( common_impl.hint["get_puzzle2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_puzzle2", private.get_puzzle2_inv );
cmn.AddSubscriber( "get_puzzle2", private.get_puzzle2_beg, private.room_objname );
cmn.AddSubscriber( "get_puzzle2", private.get_puzzle2_end, private.room_objname );
cmn.AddSubscriber( "get_puzzle2", private.get_puzzle2_logic );
--------------------------------------------------------------------
function public.get_puzzle2()
  cmn.SetEventDone( "get_puzzle2" );
  cmn.CallEventHandler( "get_puzzle2" );
  if common_impl.ZzCompleteCheck("get_puzzle2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_specs" ] = { type = "use", inv_obj = "inv_specs", use_place = "gfx_streetfirtree_specs_zone", room = "rm_citystreets", zz = "zz_streetfirtree", zz_gate = "gzz_citystreets_streetfirtree" };

private.use_specs_logic = function()
  ObjSet( "spr_streetfirtree_candy5", { visible = 1, input = 1, active = 1 } )

end;
private.use_specs_inv = function()
  common_impl.ProcessMultiUseAll("specs", "specs")
end;
private.use_specs_beg = function()
  ObjDelete( "gfx_streetfirtree_specs_zone" );
end;
private.use_specs_end = function()
  ObjSet( "spr_citystreets_hand", {visible = 1} );
  ObjSet( "spr_streetfirtree_candy5_sh", {visible = 1} );
  ObjSet( "anm_streetfirtree_anim_santa", {animfunc = "anim_give_santa_end", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_specs") then ObjSet( common_impl.hint["use_specs"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_specs", private.use_specs_inv );
cmn.AddSubscriber( "use_specs", private.use_specs_beg, private.room_objname );
cmn.AddSubscriber( "use_specs", private.use_specs_end, private.room_objname );
cmn.AddSubscriber( "use_specs", private.use_specs_logic );
cmn.AddSubscriber( "use_specs_inv", private.use_specs_inv, private.room_objname );
cmn.AddSubscriber( "use_specs_beg", private.use_specs_beg, private.room_objname );
cmn.AddSubscriber( "use_specs_end", private.use_specs_end, private.room_objname );
cmn.AddSubscriber( "use_specs_end", private.use_specs_logic );
--------------------------------------------------------------------------------------------
function public.use_specs( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_specs" );
    cmn.CallEventHandler( "use_specs_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_specs") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_specs_inv" );
  cmn.CallEventHandler( "use_specs_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_streetfirtree_anim_santa", "anim_give_santa", func_end );
  SoundSfx( "aud_use_specs_streetfirtree" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_candy5" ] = { type = "get", get_obj = "spr_streetfirtree_candy5", room = "rm_citystreets", zz = "zz_streetfirtree", zz_gate = "gzz_citystreets_streetfirtree" };

private.get_candy5_logic = function()
  
end;
private.get_candy5_inv = function()
  interface.InventoryItemAdd("inv_candy","spr_streetfirtree_candy5",function() level_inv.ProcessGetCandyAll( "get_candy5" ) end);
end;
private.get_candy5_beg = function()
  ObjDelete("gfx_streetfirtree_candy5")
end;
private.get_candy5_end = function()
  ObjDelete("spr_streetfirtree_candy5_sh")
  if common_impl.ZzCompleteCheck("get_candy5") then ObjSet( common_impl.hint["get_candy5"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_candy5", private.get_candy5_inv );
cmn.AddSubscriber( "get_candy5", private.get_candy5_beg, private.room_objname );
cmn.AddSubscriber( "get_candy5", private.get_candy5_end, private.room_objname );
cmn.AddSubscriber( "get_candy5", private.get_candy5_logic );
--------------------------------------------------------------------
function public.get_candy5()
  cmn.SetEventDone( "get_candy5" );
  cmn.CallEventHandler( "get_candy5" );
  if common_impl.ZzCompleteCheck("get_candy5") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_musicans *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_collar" ] = { type = "get", get_obj = "spr_musicans_collar", room = "rm_citystreets", zz = "zz_musicans", zz_gate = "gzz_citystreets_musicans" };

private.get_collar_logic = function()
  
end;
private.get_collar_inv = function()
  interface.InventoryItemAdd("inv_collar","spr_musicans_collar");
  ObjSet( "inv_collar", { drag = 0 } );
end;
private.get_collar_beg = function()
  ObjDelete("gfx_musicans_collar")
  ObjSet( "spr_musicans_collar", {visible = 1} );
end;
private.get_collar_end = function()
  ObjDelete("anm_musicans_anim_collar")
  ObjDelete("spr_citystreets_tr_collar")
  if common_impl.ZzCompleteCheck("get_collar") then ObjSet( common_impl.hint["get_collar"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_collar", private.get_collar_inv );
cmn.AddSubscriber( "get_collar", private.get_collar_beg, private.room_objname );
cmn.AddSubscriber( "get_collar", private.get_collar_end, private.room_objname );
cmn.AddSubscriber( "get_collar", private.get_collar_logic );
--------------------------------------------------------------------
function public.get_collar()
  cmn.SetEventDone( "get_collar" );
  cmn.CallEventHandler( "get_collar" );
  if common_impl.ZzCompleteCheck("get_collar") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fife" ] = { type = "use", inv_obj = "inv_fife", use_place = "gfx_musicans_fife_zone", room = "rm_citystreets", zz = "zz_musicans", zz_gate = "gzz_citystreets_musicans" };

private.use_fife_logic = function()
  ObjSet( "gho_citystreets_musicansho", { visible = 1, input = 1, active = 1 } )

end;
private.use_fife_inv = function()
  common_impl.ProcessMultiUseAll("fife", "fife")
end;
private.use_fife_beg = function()
  ObjDelete( "gfx_musicans_fife_zone" );
end;
private.use_fife_end = function()
  ObjSet( "anm_musicans_anim_2", {animfunc = "anim_fleita", frame = 999 } );
  ObjSet( "spr_citystreets_tr_fleita", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_fife") then ObjSet( common_impl.hint["use_fife"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fife", private.use_fife_inv );
cmn.AddSubscriber( "use_fife", private.use_fife_beg, private.room_objname );
cmn.AddSubscriber( "use_fife", private.use_fife_end, private.room_objname );
cmn.AddSubscriber( "use_fife", private.use_fife_logic );
cmn.AddSubscriber( "use_fife_inv", private.use_fife_inv, private.room_objname );
cmn.AddSubscriber( "use_fife_beg", private.use_fife_beg, private.room_objname );
cmn.AddSubscriber( "use_fife_end", private.use_fife_end, private.room_objname );
cmn.AddSubscriber( "use_fife_end", private.use_fife_logic );
--------------------------------------------------------------------------------------------
function public.use_fife( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fife" );
    cmn.CallEventHandler( "use_fife_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fife") then ld.CloseSubRoom() common_impl.Gate_MDown( "gho_citystreets_musicansho" ) end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fife_inv" );
  cmn.CallEventHandler( "use_fife_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_musicans_anim_2", "anim_fleita", func_end );
  SoundSfx( "aud_use_fife_musicans" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doortojewelryshop *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_candy3" ] = { type = "get", get_obj = "spr_doortojewelryshop_candy3", room = "rm_citystreets", zz = "zz_doortojewelryshop", zz_gate = "gzz_citystreets_doortojewelryshop" };

private.get_candy3_logic = function()
  
end;
private.get_candy3_inv = function()
  interface.InventoryItemAdd("inv_candy","spr_doortojewelryshop_candy3",function() level_inv.ProcessGetCandyAll( "get_candy3" ) end);
end;
private.get_candy3_beg = function()
  ObjDelete("gfx_doortojewelryshop_candy3")
end;
private.get_candy3_end = function()
  ObjDelete("spr_doortojewelryshop_tr_candy")
  ObjDelete("spr_doortojewelryshop_candy3_sh")
  if common_impl.ZzCompleteCheck("get_candy3") then ObjSet( common_impl.hint["get_candy3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_candy3", private.get_candy3_inv );
cmn.AddSubscriber( "get_candy3", private.get_candy3_beg, private.room_objname );
cmn.AddSubscriber( "get_candy3", private.get_candy3_end, private.room_objname );
cmn.AddSubscriber( "get_candy3", private.get_candy3_logic );
--------------------------------------------------------------------
function public.get_candy3()
  cmn.SetEventDone( "get_candy3" );
  cmn.CallEventHandler( "get_candy3" );
  if common_impl.ZzCompleteCheck("get_candy3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_christmaswreath" ] = { type = "use", inv_obj = "inv_christmaswreath", use_place = "gfx_doortojewelryshop_christmaswreath_zone", room = "rm_citystreets", zz = "zz_doortojewelryshop", zz_gate = "gzz_citystreets_doortojewelryshop" };

private.use_christmaswreath_logic = function()
  ObjSet( "gfx_doortojewelryshop_clk_doortojewelryshopopen_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_christmaswreath_inv = function()
  common_impl.ProcessMultiUseAll("christmaswreath", "christmaswreath")
end;
private.use_christmaswreath_beg = function()
  ObjDelete( "gfx_doortojewelryshop_christmaswreath_zone" );
end;
private.use_christmaswreath_end = function()
  ObjSet( "anm_doortojewelryshop_anim_venok", {animfunc = "anim_venok", frame = 999 } );
  ObjSet( "spr_citystreets_tr_christmaswreath", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_christmaswreath") then ObjSet( common_impl.hint["use_christmaswreath"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_christmaswreath", private.use_christmaswreath_inv );
cmn.AddSubscriber( "use_christmaswreath", private.use_christmaswreath_beg, private.room_objname );
cmn.AddSubscriber( "use_christmaswreath", private.use_christmaswreath_end, private.room_objname );
cmn.AddSubscriber( "use_christmaswreath", private.use_christmaswreath_logic );
cmn.AddSubscriber( "use_christmaswreath_inv", private.use_christmaswreath_inv, private.room_objname );
cmn.AddSubscriber( "use_christmaswreath_beg", private.use_christmaswreath_beg, private.room_objname );
cmn.AddSubscriber( "use_christmaswreath_end", private.use_christmaswreath_end, private.room_objname );
cmn.AddSubscriber( "use_christmaswreath_end", private.use_christmaswreath_logic );
--------------------------------------------------------------------------------------------
function public.use_christmaswreath( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_christmaswreath" );
    cmn.CallEventHandler( "use_christmaswreath_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_christmaswreath") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_christmaswreath_inv" );
  cmn.CallEventHandler( "use_christmaswreath_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortojewelryshop_anim_venok", "anim_venok", function() 
    ld.AnimPlay( "anm_doortojewelryshop_anim_sparkl", "anim_sparkl", func_end );
  end );
  SoundSfx( "aud_use_christmaswreath_doortojewelryshop" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_doortojewelryshopopen" ] = { type = "click", use_place = "gfx_doortojewelryshop_clk_doortojewelryshopopen_zone", room = "rm_citystreets", zz = "zz_doortojewelryshop", zz_gate = "gzz_citystreets_doortojewelryshop" };

private.clk_doortojewelryshopopen_logic = function()
  
  ObjSet( "grm_citystreets_jewelryshop", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_citystreets_jewelryshop_focus");
  end;

end;
private.clk_doortojewelryshopopen_beg = function()
  ObjDelete( "gfx_doortojewelryshop_clk_doortojewelryshopopen_zone" );
end;
private.clk_doortojewelryshopopen_end = function()
  ObjSet( "spr_citystreets_open_door", {visible = 1} );
  if common_impl.ZzCompleteCheck("clk_doortojewelryshopopen") then ObjSet( common_impl.hint["clk_doortojewelryshopopen"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_doortojewelryshopopen", private.clk_doortojewelryshopopen_beg, private.room_objname );
cmn.AddSubscriber( "clk_doortojewelryshopopen", private.clk_doortojewelryshopopen_end, private.room_objname );
cmn.AddSubscriber( "clk_doortojewelryshopopen", private.clk_doortojewelryshopopen_logic );
cmn.AddSubscriber( "clk_doortojewelryshopopen_beg", private.clk_doortojewelryshopopen_beg, private.room_objname );
cmn.AddSubscriber( "clk_doortojewelryshopopen_end", private.clk_doortojewelryshopopen_end, private.room_objname );
cmn.AddSubscriber( "clk_doortojewelryshopopen_end", private.clk_doortojewelryshopopen_logic );
--------------------------------------------------------------------------------------------
function public.clk_doortojewelryshopopen()

  local func_end = function()
    cmn.SetEventDone( "clk_doortojewelryshopopen" );
    cmn.CallEventHandler( "clk_doortojewelryshopopen_end" );
    common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("clk_doortojewelryshopopen") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    ld.CloseSubRoom()
    ObjSet( "spr_citystreets_open_door", {visible = 1,alp = 0} );
    ObjAnimate( "spr_citystreets_open_door", 8, 0, 0, function() func_end() end, {0,0,0, 0.5,0,1} );
  end

  cmn.CallEventHandler( "clk_doortojewelryshopopen_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortojewelryshop_anim", "anim_hol_handle", func_end_2 );
  SoundSfx( "aud_clk_doortojewelryshopopen" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_sweettruck *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletcake" ] = { type = "use", inv_obj = "inv_amuletcake", use_place = "gfx_sweettruck_amuletcake_zone", room = "rm_citystreets", zz = "zz_sweettruck", zz_gate = "gzz_citystreets_sweettruck" };

private.use_amuletcake_logic = function()
  if ld.CheckRequirements( {"use_amuletcake","use_cherry"} ) then
    ObjSet( "spr_sweettruck_pretzel", { input = 1, active = 1 } )
    --ObjSet( "spr_sweettruck_powder", { input = 1, active = 1 } )
  end;

end;
private.use_amuletcake_inv = function()
  common_impl.ProcessMultiUseAll("amuletcake", "amuletcake")
end;
private.use_amuletcake_beg = function()
  ObjDelete( "gfx_sweettruck_amuletcake_zone" );
  ObjSet( "anm_sweettruck_anim_focus", {animfunc = "anim_opendoor", frame = 0 } );
end;
private.use_amuletcake_end = function()
  ObjSet( "anm_sweettruck_anim_cake", {animfunc = "anim_use_cake", frame = 999 } );
  if ld.CheckRequirements( {"use_amuletcake","use_cherry"} ) then
    ObjDelete("anm_sweettruck_anim_cake")
    ObjDelete("anm_sweettruck_anim_cherry")
    ObjSet( "anm_sweettruck_anim_focus", {animfunc = "anim_opendoor", frame = 999 } );
    ObjSet( "spr_citystreets_open", {visible = 1} );
    ObjSet( "gfx_sweettruck_powder", { visible = 1 } )
    ObjSet( "gfx_sweettruck_pretzel", { visible = 1 } )
  end;
  if common_impl.ZzCompleteCheck("use_amuletcake") then ObjSet( common_impl.hint["use_amuletcake"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletcake", private.use_amuletcake_inv );
cmn.AddSubscriber( "use_amuletcake", private.use_amuletcake_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletcake", private.use_amuletcake_end, private.room_objname );
cmn.AddSubscriber( "use_amuletcake", private.use_amuletcake_logic );
cmn.AddSubscriber( "use_amuletcake_inv", private.use_amuletcake_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletcake_beg", private.use_amuletcake_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletcake_end", private.use_amuletcake_end, private.room_objname );
cmn.AddSubscriber( "use_amuletcake_end", private.use_amuletcake_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletcake( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletcake" );
    cmn.CallEventHandler( "use_amuletcake_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletcake") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    if ld.IsLastActionLeft({"use_amuletcake","use_cherry"}) then
      SoundSfx( "aud_box_open_sweettruck" )
      ld.AnimPlay( "anm_sweettruck_anim_focus", "anim_opendoor", func_end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletcake_inv" );
  cmn.CallEventHandler( "use_amuletcake_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sweettruck_anim_cake", "anim_use_cake", func_end_2 );
  SoundSfx( "aud_use_amuletcake_sweettruck" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cherry" ] = { type = "use", inv_obj = "inv_cherry", use_place = "gfx_sweettruck_cherry_zone", room = "rm_citystreets", zz = "zz_sweettruck", zz_gate = "gzz_citystreets_sweettruck" };

private.use_cherry_logic = function()
  if ld.CheckRequirements( {"use_cherry","use_amuletcake"} ) then
    ObjSet( "spr_sweettruck_pretzel", { input = 1, active = 1 } )
    --ObjSet( "spr_sweettruck_powder", { input = 1, active = 1 } )
  end;
end;
private.use_cherry_inv = function()
  common_impl.ProcessMultiUseAll("cherry", "cherry")
end;
private.use_cherry_beg = function()
  ObjDelete( "gfx_sweettruck_cherry_zone" );
  ObjSet( "anm_sweettruck_anim_focus", {animfunc = "anim_opendoor", frame = 0 } );
end;
private.use_cherry_end = function()
  ObjSet( "anm_sweettruck_anim_cherry", {animfunc = "anim_use_chery", frame = 999 } );
  if ld.CheckRequirements( {"use_amuletcake","use_cherry"} ) then
    ObjDelete("anm_sweettruck_anim_cake")
    ObjDelete("anm_sweettruck_anim_cherry")
    ObjSet( "anm_sweettruck_anim_focus", {animfunc = "anim_opendoor", frame = 999 } );
    ObjSet( "spr_citystreets_open", {visible = 1} );
    ObjSet( "gfx_sweettruck_powder", { visible = 1 } )
    ObjSet( "gfx_sweettruck_pretzel", { visible = 1 } )
  end;
  if common_impl.ZzCompleteCheck("use_cherry") then ObjSet( common_impl.hint["use_cherry"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cherry", private.use_cherry_inv );
cmn.AddSubscriber( "use_cherry", private.use_cherry_beg, private.room_objname );
cmn.AddSubscriber( "use_cherry", private.use_cherry_end, private.room_objname );
cmn.AddSubscriber( "use_cherry", private.use_cherry_logic );
cmn.AddSubscriber( "use_cherry_inv", private.use_cherry_inv, private.room_objname );
cmn.AddSubscriber( "use_cherry_beg", private.use_cherry_beg, private.room_objname );
cmn.AddSubscriber( "use_cherry_end", private.use_cherry_end, private.room_objname );
cmn.AddSubscriber( "use_cherry_end", private.use_cherry_logic );
--------------------------------------------------------------------------------------------
function public.use_cherry( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cherry" );
    cmn.CallEventHandler( "use_cherry_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cherry") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    if ld.IsLastActionLeft({"use_amuletcake","use_cherry"}) then
      SoundSfx( "aud_box_open_sweettruck" )
      ld.AnimPlay( "anm_sweettruck_anim_focus", "anim_opendoor", func_end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cherry_inv" );
  cmn.CallEventHandler( "use_cherry_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sweettruck_anim_cherry", "anim_use_chery", func_end_2 );
  SoundSfx( "aud_use_cherry_sweettruck" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pretzel" ] = { type = "get", get_obj = "spr_sweettruck_pretzel", room = "rm_citystreets", zz = "zz_sweettruck", zz_gate = "gzz_citystreets_sweettruck" };

private.get_pretzel_logic = function()
  ObjSet( "spr_sweettruck_powder", { input = 1, active = 1 } )
end;
private.get_pretzel_inv = function()
  interface.InventoryItemAdd("inv_pretzel","spr_sweettruck_pretzel");
end;
private.get_pretzel_beg = function()
  ObjDelete("gfx_sweettruck_pretzel")
  ObjSet( "spr_sweettruck_pretzel", {visible = 1} );
end;
private.get_pretzel_end = function()
  if ld.CheckRequirements( {"get_powder"} ) then
    ObjSet( "anm_sweettruck_anim_focus", {animfunc = "anim_opendoor_end", frame = 0 } );
  else
    ObjSet( "anm_sweettruck_anim_focus", {animfunc = "anim_opendoor_pudr", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_pretzel") then ObjSet( common_impl.hint["get_pretzel"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_pretzel", private.get_pretzel_inv );
cmn.AddSubscriber( "get_pretzel", private.get_pretzel_beg, private.room_objname );
cmn.AddSubscriber( "get_pretzel", private.get_pretzel_end, private.room_objname );
cmn.AddSubscriber( "get_pretzel", private.get_pretzel_logic );
--------------------------------------------------------------------
function public.get_pretzel()
  cmn.SetEventDone( "get_pretzel" );
  cmn.CallEventHandler( "get_pretzel" );
  if common_impl.ZzCompleteCheck("get_pretzel") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_powder" ] = { type = "get", get_obj = "spr_sweettruck_powder", room = "rm_citystreets", zz = "zz_sweettruck", zz_gate = "gzz_citystreets_sweettruck" };

private.get_powder_logic = function()
  
end;
private.get_powder_inv = function()
  interface.InventoryItemAdd("inv_powder","spr_sweettruck_powder");
end;
private.get_powder_beg = function()
  ObjDelete("gfx_sweettruck_powder")
  ObjSet( "spr_sweettruck_powder", {visible = 1} );
end;
private.get_powder_end = function()
  if ld.CheckRequirements( {"get_pretzel"} ) then
    ObjSet( "anm_sweettruck_anim_focus", {animfunc = "anim_opendoor_end", frame = 0 } );
  else
    ObjSet( "anm_sweettruck_anim_focus", {animfunc = "anim_opendoor_pretzel", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_powder") then ObjSet( common_impl.hint["get_powder"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_powder", private.get_powder_inv );
cmn.AddSubscriber( "get_powder", private.get_powder_beg, private.room_objname );
cmn.AddSubscriber( "get_powder", private.get_powder_end, private.room_objname );
cmn.AddSubscriber( "get_powder", private.get_powder_logic );
--------------------------------------------------------------------
function public.get_powder()
  cmn.SetEventDone( "get_powder" );
  cmn.CallEventHandler( "get_powder" );
  if common_impl.ZzCompleteCheck("get_powder") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_confectioner" ] = { type = "use", inv_obj = "inv_confectioner", use_place = "gfx_sweettruck_confectioner_zone", room = "rm_citystreets", zz = "zz_sweettruck", zz_gate = "gzz_citystreets_sweettruck" };

private.use_confectioner_logic = function()
  ObjSet( "spr_sweettruck_lily1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_sweettruck_mitten", { visible = 1, input = 1, active = 1 } )

end;
private.use_confectioner_inv = function()
  common_impl.ProcessMultiUseAll("confectioner", "confectioner")
end;
private.use_confectioner_beg = function()
  ObjDelete( "gfx_sweettruck_confectioner_zone" );
end;
private.use_confectioner_end = function()
  ObjDelete("anm_sweettruck_anim_head")
  if common_impl.ZzCompleteCheck("use_confectioner") then ObjSet( common_impl.hint["use_confectioner"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_confectioner", private.use_confectioner_inv );
cmn.AddSubscriber( "use_confectioner", private.use_confectioner_beg, private.room_objname );
cmn.AddSubscriber( "use_confectioner", private.use_confectioner_end, private.room_objname );
cmn.AddSubscriber( "use_confectioner", private.use_confectioner_logic );
cmn.AddSubscriber( "use_confectioner_inv", private.use_confectioner_inv, private.room_objname );
cmn.AddSubscriber( "use_confectioner_beg", private.use_confectioner_beg, private.room_objname );
cmn.AddSubscriber( "use_confectioner_end", private.use_confectioner_end, private.room_objname );
cmn.AddSubscriber( "use_confectioner_end", private.use_confectioner_logic );
--------------------------------------------------------------------------------------------
function public.use_confectioner( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_confectioner" );
    cmn.CallEventHandler( "use_confectioner_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_confectioner") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_confectioner_inv" );
  cmn.CallEventHandler( "use_confectioner_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sweettruck_anim_head", "anim_bublehead", function() 
    ld.AnimPlay( "anm_sweettruck_anim_head", "anim_open", func_end );    
  end);
  SoundSfx( "aud_use_confectioner_sweettruck" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lily1" ] = { type = "get", get_obj = "spr_sweettruck_lily1", room = "rm_citystreets", zz = "zz_sweettruck", zz_gate = "gzz_citystreets_sweettruck" };

private.get_lily1_logic = function()
  
end;
private.get_lily1_inv = function()
  interface.InventoryItemAdd("inv_lily1","spr_sweettruck_lily1");
end;
private.get_lily1_beg = function()
  ObjDelete("gfx_sweettruck_lily1")
end;
private.get_lily1_end = function()
  ObjDelete("spr_sweettruck_lily1_shadow")
  if common_impl.ZzCompleteCheck("get_lily1") then ObjSet( common_impl.hint["get_lily1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lily1", private.get_lily1_inv );
cmn.AddSubscriber( "get_lily1", private.get_lily1_beg, private.room_objname );
cmn.AddSubscriber( "get_lily1", private.get_lily1_end, private.room_objname );
cmn.AddSubscriber( "get_lily1", private.get_lily1_logic );
--------------------------------------------------------------------
function public.get_lily1()
  cmn.SetEventDone( "get_lily1" );
  cmn.CallEventHandler( "get_lily1" );
  if common_impl.ZzCompleteCheck("get_lily1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mitten" ] = { type = "get", get_obj = "spr_sweettruck_mitten", room = "rm_citystreets", zz = "zz_sweettruck", zz_gate = "gzz_citystreets_sweettruck" };

private.get_mitten_logic = function()
  
end;
private.get_mitten_inv = function()
  interface.InventoryItemAdd("inv_mitten","spr_sweettruck_mitten");
end;
private.get_mitten_beg = function()
  ObjDelete("gfx_sweettruck_mitten")
end;
private.get_mitten_end = function()
  ObjDelete("spr_sweettruck_mitten_shadow")
  if common_impl.ZzCompleteCheck("get_mitten") then ObjSet( common_impl.hint["get_mitten"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mitten", private.get_mitten_inv );
cmn.AddSubscriber( "get_mitten", private.get_mitten_beg, private.room_objname );
cmn.AddSubscriber( "get_mitten", private.get_mitten_end, private.room_objname );
cmn.AddSubscriber( "get_mitten", private.get_mitten_logic );
--------------------------------------------------------------------
function public.get_mitten()
  cmn.SetEventDone( "get_mitten" );
  cmn.CallEventHandler( "get_mitten" );
  if common_impl.ZzCompleteCheck("get_mitten") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_musicansho_for_citystreets = function()
    if ld.CheckRequirements( {"win_musicansho"} ) then
      ObjSet( "gho_citystreets_musicansho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_musicansho", win_musicansho_for_citystreets, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_citystreets();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_citystreets_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_sweettruck" );
  function zz_sweettruck.Open()
  end;
  function zz_sweettruck.PreOpen()
  end;
  function zz_sweettruck.PreClose()
  end;
  function zz_sweettruck.Close()
  end;

  subroom.Define( "zz_doortojewelryshop" );
  function zz_doortojewelryshop.Open()
  end;
  function zz_doortojewelryshop.PreOpen()
  end;
  function zz_doortojewelryshop.PreClose()
  end;
  function zz_doortojewelryshop.Close()
  end;

  subroom.Define( "zz_musicans" );
  function zz_musicans.Open()
  end;
  function zz_musicans.PreOpen()
  end;
  function zz_musicans.PreClose()
  end;
  function zz_musicans.Close()
  end;

  subroom.Define( "zz_streetfirtree" );
  function zz_streetfirtree.Open()
  end;
  function zz_streetfirtree.PreOpen()
  end;
  function zz_streetfirtree.PreClose()
  end;
  function zz_streetfirtree.Close()
  end;
  
end;
--*********************************************************************************************************************