-- name=rm_dressroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_dressroom";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_dressroom()
  if not ( cmn.IsEventDone( "opn_dressroom" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_dressroom" );
      cmn.CallEventHandler( "opn_dressroom" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_dressroom = function() end;
local opn_dressroom_logic = function() end;
cmn.AddSubscriber( "opn_dressroom", opn_dressroom_logic )
cmn.AddSubscriber( "opn_dressroom", opn_dressroom, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wardrobewithcells *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_frame" ] = { type = "get", get_obj = "spr_wardrobewithcells_frame", room = "rm_dressroom", zz = "zz_wardrobewithcells", zz_gate = "gzz_dressroom_wardrobewithcells" };

private.get_frame_logic = function()
  
end;
private.get_frame_inv = function()
  interface.InventoryItemAdd("inv_frame","spr_wardrobewithcells_frame");
end;
private.get_frame_beg = function()
  ObjDelete("gfx_wardrobewithcells_frame")
  ObjSet( "spr_wardrobewithcells_frame", {visible = 1} );
end;
private.get_frame_end = function()
  ObjDelete("spr_wardrobewithcells_frame_sh")
  ObjDelete("spr_wardrobewithcells_frame_tr")
  ObjDelete("spr_dressroom_frame")
  if common_impl.ZzCompleteCheck("get_frame") then ObjSet( common_impl.hint["get_frame"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_frame", private.get_frame_inv );
cmn.AddSubscriber( "get_frame", private.get_frame_beg, private.room_objname );
cmn.AddSubscriber( "get_frame", private.get_frame_end, private.room_objname );
cmn.AddSubscriber( "get_frame", private.get_frame_logic );
--------------------------------------------------------------------
function public.get_frame()
  cmn.SetEventDone( "get_frame" );
  cmn.CallEventHandler( "get_frame" );
  if common_impl.ZzCompleteCheck("get_frame") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
function public.need_lily(n)
  if ld.CheckRequirements( {"use_lily1","use_lily2"},1 ) == 0 then
    ld.Lock(1)
    SoundSfx( "aud_xx_cabinet" )
    ld.AnimPlay( "anm_wardrobewithcells_anm", "idle_door", function() 
      ld.Lock(0)
      ld.ShowBbt("need_lily"..n);
    end )
  else
    ld.ShowBbt("need_lily"..n);
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lily1" ] = { type = "use", inv_obj = "inv_lily1", use_place = "gfx_wardrobewithcells_lily1_zone", room = "rm_dressroom", zz = "zz_wardrobewithcells", zz_gate = "gzz_dressroom_wardrobewithcells" };

private.use_lily1_logic = function()
  if ld.CheckRequirements( {"use_lily1","use_lily2"} ) then
    ObjSet( "spr_wardrobewithcells_latchkey", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_wardrobewithcells_camisole2", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_lily1_inv = function()
  common_impl.ProcessMultiUseAll("lily1", "lily1")
end;
private.use_lily1_beg = function()
  ObjDelete( "gfx_wardrobewithcells_lily1_zone" );
end;
private.use_lily1_end = function()
  if ld.CheckRequirements( {"use_lily1","use_lily2"} ) then
    ObjDelete("spr_dressroom_lily1")
    ObjDelete("spr_dressroom_lily2")
    ObjDelete("spr_dressroom_door_cell_closed")
    ObjSet( "spr_dressroom_door_cell_opened", {visible = 1} );    
    ObjDelete("anm_wardrobewithcells_anm_lily")
    ObjSet( "anm_wardrobewithcells_anm", {animfunc = "use2_liiy1_opendoor", frame = 999 } );
  else
    ObjSet( "spr_dressroom_lily1", {visible = 1} );
    ObjSet( "anm_wardrobewithcells_anm_lily", {animfunc = "use_liiy1", frame = 0 } );
    ObjSet( "anm_wardrobewithcells_anm", {animfunc = "use2_liiy2_opendoor", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("use_lily1") then ObjSet( common_impl.hint["use_lily1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lily1", private.use_lily1_inv );
cmn.AddSubscriber( "use_lily1", private.use_lily1_beg, private.room_objname );
cmn.AddSubscriber( "use_lily1", private.use_lily1_end, private.room_objname );
cmn.AddSubscriber( "use_lily1", private.use_lily1_logic );
cmn.AddSubscriber( "use_lily1_inv", private.use_lily1_inv, private.room_objname );
cmn.AddSubscriber( "use_lily1_beg", private.use_lily1_beg, private.room_objname );
cmn.AddSubscriber( "use_lily1_end", private.use_lily1_end, private.room_objname );
cmn.AddSubscriber( "use_lily1_end", private.use_lily1_logic );
--------------------------------------------------------------------------------------------
function public.use_lily1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lily1" );
    cmn.CallEventHandler( "use_lily1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lily1") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    SoundSfx( "aud_use_lily1_wardrobewithcells" )
    
    if ld.IsLastActionLeft({"use_lily1","use_lily2"}) then
      ld.StartTimer( 0.8, function() SoundSfx( "aud_open_ambry" ) end )
      ObjDelete("anm_wardrobewithcells_anm_lily")
      ld.AnimPlay( "anm_wardrobewithcells_anm", "use2_liiy1_opendoor", func_end )
    else
      ld.AnimPlay( "anm_wardrobewithcells_anm_lily", "use_liiy1", func_end )
    end
    
  end

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lily1_inv" );
  cmn.CallEventHandler( "use_lily1_beg" );
  common_impl.Lock(1);
  func_end_2()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lily2" ] = { type = "use", inv_obj = "inv_lily2", use_place = "gfx_wardrobewithcells_lily2_zone", room = "rm_dressroom", zz = "zz_wardrobewithcells", zz_gate = "gzz_dressroom_wardrobewithcells" };

private.use_lily2_logic = function()
  if ld.CheckRequirements( {"use_lily2","use_lily1"} ) then
    ObjSet( "spr_wardrobewithcells_latchkey", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_wardrobewithcells_camisole2", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_lily2_inv = function()
  common_impl.ProcessMultiUseAll("lily2", "lily2")
end;
private.use_lily2_beg = function()
  ObjDelete( "gfx_wardrobewithcells_lily2_zone" );
end;
private.use_lily2_end = function()
  if ld.CheckRequirements( {"use_lily1","use_lily2"} ) then
    ObjDelete("spr_dressroom_lily1")
    ObjDelete("spr_dressroom_lily2")
    ObjDelete("spr_dressroom_door_cell_closed")
    ObjSet( "spr_dressroom_door_cell_opened", {visible = 1} );
    ObjDelete("anm_wardrobewithcells_anm_lily")
    ObjSet( "anm_wardrobewithcells_anm", {animfunc = "use2_liiy2_opendoor", frame = 999 } );
  else
    ObjSet( "spr_dressroom_lily2", {visible = 1} );
    ObjSet( "anm_wardrobewithcells_anm_lily", {animfunc = "use_liiy1", frame = 0 } );
    ObjSet( "anm_wardrobewithcells_anm", {animfunc = "use2_liiy1_opendoor", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("use_lily2") then ObjSet( common_impl.hint["use_lily2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lily2", private.use_lily2_inv );
cmn.AddSubscriber( "use_lily2", private.use_lily2_beg, private.room_objname );
cmn.AddSubscriber( "use_lily2", private.use_lily2_end, private.room_objname );
cmn.AddSubscriber( "use_lily2", private.use_lily2_logic );
cmn.AddSubscriber( "use_lily2_inv", private.use_lily2_inv, private.room_objname );
cmn.AddSubscriber( "use_lily2_beg", private.use_lily2_beg, private.room_objname );
cmn.AddSubscriber( "use_lily2_end", private.use_lily2_end, private.room_objname );
cmn.AddSubscriber( "use_lily2_end", private.use_lily2_logic );
--------------------------------------------------------------------------------------------
function public.use_lily2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lily2" );
    cmn.CallEventHandler( "use_lily2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lily2") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    SoundSfx( "aud_use_lily2_wardrobewithcells" )
    
    if ld.IsLastActionLeft({"use_lily1","use_lily2"}) then
      ld.StartTimer( 0.8, function() SoundSfx( "aud_open_ambry" ) end )
      ObjDelete("anm_wardrobewithcells_anm_lily")
      ld.AnimPlay( "anm_wardrobewithcells_anm", "use2_liiy2_opendoor", func_end )
    else
      ld.AnimPlay( "anm_wardrobewithcells_anm_lily", "use_liiy2", func_end )
    end
    
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lily2_inv" );
  cmn.CallEventHandler( "use_lily2_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  func_end_2()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_latchkey" ] = { type = "get", get_obj = "spr_wardrobewithcells_latchkey", room = "rm_dressroom", zz = "zz_wardrobewithcells", zz_gate = "gzz_dressroom_wardrobewithcells" };

private.get_latchkey_logic = function()
  
end;
private.get_latchkey_inv = function()
  interface.InventoryItemAdd("inv_latchkey","spr_wardrobewithcells_latchkey");
end;
private.get_latchkey_beg = function()
  ObjDelete("gfx_wardrobewithcells_latchkey")
end;
private.get_latchkey_end = function()
  ObjDelete("spr_wardrobewithcells_latchkey_sh")
  ObjDelete("spr_wardrobewithcells_back_tr")
  if common_impl.ZzCompleteCheck("get_latchkey") then ObjSet( common_impl.hint["get_latchkey"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_latchkey", private.get_latchkey_inv );
cmn.AddSubscriber( "get_latchkey", private.get_latchkey_beg, private.room_objname );
cmn.AddSubscriber( "get_latchkey", private.get_latchkey_end, private.room_objname );
cmn.AddSubscriber( "get_latchkey", private.get_latchkey_logic );
--------------------------------------------------------------------
function public.get_latchkey()
  cmn.SetEventDone( "get_latchkey" );
  cmn.CallEventHandler( "get_latchkey" );
  if common_impl.ZzCompleteCheck("get_latchkey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_camisole2" ] = { type = "get", get_obj = "spr_wardrobewithcells_camisole2", room = "rm_dressroom", zz = "zz_wardrobewithcells", zz_gate = "gzz_dressroom_wardrobewithcells" };

private.get_camisole2_logic = function()
  
end;
private.get_camisole2_inv = function()
  interface.InventoryItemAdd("inv_camisole","spr_wardrobewithcells_camisole2",function() level_inv.ProcessGetCamisoleAll( "get_camisole2" ) end);
end;
private.get_camisole2_beg = function()
  ObjDelete("gfx_wardrobewithcells_camisole2")
end;
private.get_camisole2_end = function()
  ObjDelete("spr_wardrobewithcells_camisole2_sh")
  ObjDelete("spr_dressroom_camisole2")
  if common_impl.ZzCompleteCheck("get_camisole2") then ObjSet( common_impl.hint["get_camisole2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_camisole2", private.get_camisole2_inv );
cmn.AddSubscriber( "get_camisole2", private.get_camisole2_beg, private.room_objname );
cmn.AddSubscriber( "get_camisole2", private.get_camisole2_end, private.room_objname );
cmn.AddSubscriber( "get_camisole2", private.get_camisole2_logic );
--------------------------------------------------------------------
function public.get_camisole2()
  cmn.SetEventDone( "get_camisole2" );
  cmn.CallEventHandler( "get_camisole2" );
  if common_impl.ZzCompleteCheck("get_camisole2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_hats *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_puzzle3" ] = { type = "get", get_obj = "spr_hats_puzzle3", room = "rm_dressroom", zz = "zz_hats", zz_gate = "gzz_dressroom_hats" };

private.get_puzzle3_logic = function()
  
end;
private.get_puzzle3_inv = function()
  interface.InventoryItemAdd("inv_puzzle","spr_hats_puzzle3",function() level_inv.ProcessGetPuzzleAll( "get_puzzle3" ) end);
end;
private.get_puzzle3_beg = function()
  ObjDelete("gfx_hats_puzzle3")
end;
private.get_puzzle3_end = function()
  ObjDelete("spr_hats_puzzle3_tr_sh")
  ObjDelete("spr_dressroom_puzzle3_tr")
  if common_impl.ZzCompleteCheck("get_puzzle3") then ObjSet( common_impl.hint["get_puzzle3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_puzzle3", private.get_puzzle3_inv );
cmn.AddSubscriber( "get_puzzle3", private.get_puzzle3_beg, private.room_objname );
cmn.AddSubscriber( "get_puzzle3", private.get_puzzle3_end, private.room_objname );
cmn.AddSubscriber( "get_puzzle3", private.get_puzzle3_logic );
--------------------------------------------------------------------
function public.get_puzzle3()
  cmn.SetEventDone( "get_puzzle3" );
  cmn.CallEventHandler( "get_puzzle3" );
  if common_impl.ZzCompleteCheck("get_puzzle3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_carnivalhat" ] = { type = "use", inv_obj = "inv_carnivalhat", use_place = "gfx_hats_carnivalhat_zone", room = "rm_dressroom", zz = "zz_hats", zz_gate = "gzz_dressroom_hats" };

private.use_carnivalhat_logic = function()
  ObjSet( "gmg_dressroom_hatsmg", { visible = 1, input = 1, active = 1 } )

end;
private.use_carnivalhat_inv = function()
  common_impl.ProcessMultiUseAll("carnivalhat", "carnivalhat")
end;
private.use_carnivalhat_beg = function()
  ObjDelete( "gfx_hats_carnivalhat_zone" );
end;
private.use_carnivalhat_end = function()
  ObjSet( "spr_dressroom_hat", {visible = 1} );
  ObjSet( "anm_hats_anm", {animfunc = "use_carnivalhat", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_carnivalhat") then ObjSet( common_impl.hint["use_carnivalhat"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_carnivalhat", private.use_carnivalhat_inv );
cmn.AddSubscriber( "use_carnivalhat", private.use_carnivalhat_beg, private.room_objname );
cmn.AddSubscriber( "use_carnivalhat", private.use_carnivalhat_end, private.room_objname );
cmn.AddSubscriber( "use_carnivalhat", private.use_carnivalhat_logic );
cmn.AddSubscriber( "use_carnivalhat_inv", private.use_carnivalhat_inv, private.room_objname );
cmn.AddSubscriber( "use_carnivalhat_beg", private.use_carnivalhat_beg, private.room_objname );
cmn.AddSubscriber( "use_carnivalhat_end", private.use_carnivalhat_end, private.room_objname );
cmn.AddSubscriber( "use_carnivalhat_end", private.use_carnivalhat_logic );
--------------------------------------------------------------------------------------------
function public.use_carnivalhat( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_carnivalhat" );
    cmn.CallEventHandler( "use_carnivalhat_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_carnivalhat") then ld.CloseSubRoom() end;
    common_impl.Gate_MDown( "gmg_dressroom_hatsmg" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_carnivalhat_inv" );
  cmn.CallEventHandler( "use_carnivalhat_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hats_anm", "use_carnivalhat", func_end );
  SoundSfx( "aud_use_carnivalhat_hats" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_manequin *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pliers" ] = { type = "use", inv_obj = "inv_pliers", use_place = "gfx_manequin_pliers_zone", room = "rm_dressroom", zz = "zz_manequin", zz_gate = "gzz_dressroom_manequin" };

private.use_pliers_logic = function()
  ObjSet( "gfx_manequin_clk_manequinopn_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_pliers_inv = function()
  common_impl.ProcessMultiUseAll("pliers", "pliers")
end;
private.use_pliers_beg = function()
  ObjDelete( "gfx_manequin_pliers_zone" );
end;
private.use_pliers_end = function()
  ObjDelete("anm_manequin_anm")
  ObjDelete("spr_dressroom_hole_small")
  ObjSet( "spr_dressroom_hole_big", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_pliers") then ObjSet( common_impl.hint["use_pliers"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pliers", private.use_pliers_inv );
cmn.AddSubscriber( "use_pliers", private.use_pliers_beg, private.room_objname );
cmn.AddSubscriber( "use_pliers", private.use_pliers_end, private.room_objname );
cmn.AddSubscriber( "use_pliers", private.use_pliers_logic );
cmn.AddSubscriber( "use_pliers_inv", private.use_pliers_inv, private.room_objname );
cmn.AddSubscriber( "use_pliers_beg", private.use_pliers_beg, private.room_objname );
cmn.AddSubscriber( "use_pliers_end", private.use_pliers_end, private.room_objname );
cmn.AddSubscriber( "use_pliers_end", private.use_pliers_logic );
--------------------------------------------------------------------------------------------
function public.use_pliers( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pliers" );
    cmn.CallEventHandler( "use_pliers_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pliers") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pliers_inv" );
  cmn.CallEventHandler( "use_pliers_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_manequin_anm", "use_pliers", func_end );
  SoundSfx( "aud_use_pliers_manequin" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_manequinopn" ] = { type = "click", use_place = "gfx_manequin_clk_manequinopn_zone", room = "rm_dressroom", zz = "zz_manequin", zz_gate = "gzz_dressroom_manequin" };

private.clk_manequinopn_logic = function()
  ObjSet( "gfx_manequin_mouse_manequin_zone", { visible = 1, input = 1, active = 1 } )
end;
private.clk_manequinopn_beg = function()
  ObjDelete( "gfx_manequin_clk_manequinopn_zone" );
end;
private.clk_manequinopn_end = function()
  ObjDelete("anm_manequin_anm_fall");
  if common_impl.ZzCompleteCheck("clk_manequinopn") then ObjSet( common_impl.hint["clk_manequinopn"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_manequinopn", private.clk_manequinopn_beg, private.room_objname );
cmn.AddSubscriber( "clk_manequinopn", private.clk_manequinopn_end, private.room_objname );
cmn.AddSubscriber( "clk_manequinopn", private.clk_manequinopn_logic );
cmn.AddSubscriber( "clk_manequinopn_beg", private.clk_manequinopn_beg, private.room_objname );
cmn.AddSubscriber( "clk_manequinopn_end", private.clk_manequinopn_end, private.room_objname );
cmn.AddSubscriber( "clk_manequinopn_end", private.clk_manequinopn_logic );
--------------------------------------------------------------------------------------------
function public.clk_manequinopn()

  local func_end = function()
    cmn.SetEventDone( "clk_manequinopn" );
    cmn.CallEventHandler( "clk_manequinopn_end" );
    common_impl.Lock(0);
    ld.ShowBbt( "clk_manequinopn" )
    if common_impl.ZzCompleteCheck("clk_manequinopn") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_manequinopn_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_manequin_anm_fall", "click_objects", func_end );
  SoundSfx( "aud_clk_rubin_falls" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mouse_manequin" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_manequin_mouse_manequin_zone", room = "rm_dressroom", zz = "zz_manequin", zz_gate = "gzz_dressroom_manequin" };

private.use_mouse_manequin_logic = function()
  --ObjSet( "spr_manequin_ruby", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "spr_manequin_diplompart", { visible = 1, input = 1, active = 1 } )

end;
private.use_mouse_manequin_inv = function()
  common_impl.ProcessMultiUseAll("elf", "mouse_manequin")
end;
private.use_mouse_manequin_beg = function()
  ObjDelete( "gfx_manequin_mouse_manequin_zone" );
end;
private.use_mouse_manequin_end = function()
  --ObjDelete("spr_manequin_diplompart_tr")
  --ObjDelete("spr_manequin_ruby_tr")
  if common_impl.ZzCompleteCheck("use_mouse_manequin") then ObjSet( common_impl.hint["use_mouse_manequin"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mouse_manequin", private.use_mouse_manequin_inv );
cmn.AddSubscriber( "use_mouse_manequin", private.use_mouse_manequin_beg, private.room_objname );
cmn.AddSubscriber( "use_mouse_manequin", private.use_mouse_manequin_end, private.room_objname );
cmn.AddSubscriber( "use_mouse_manequin", private.use_mouse_manequin_logic );
cmn.AddSubscriber( "use_mouse_manequin_inv", private.use_mouse_manequin_inv, private.room_objname );
cmn.AddSubscriber( "use_mouse_manequin_beg", private.use_mouse_manequin_beg, private.room_objname );
cmn.AddSubscriber( "use_mouse_manequin_end", private.use_mouse_manequin_end, private.room_objname );
cmn.AddSubscriber( "use_mouse_manequin_end", private.use_mouse_manequin_logic );
--------------------------------------------------------------------------------------------
function public.use_mouse_manequin( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "get_diplompart" );
    cmn.SetEventDone( "get_ruby" );
    cmn.SetEventDone( "use_mouse_manequin" );
    cmn.CallEventHandler( "use_mouse_manequin_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mouse_manequin") then ld.CloseSubRoom() end;
    public.get_diplompart()
    public.get_ruby()
    ObjDelete("vid_manequin_vid_mother_mouse_end_39")
    --int_inventory.StdItemFlyAnimation( "spr_cats_simon", "obj_int_button_map_point_for_cube", func_end_2 );
    interface.SimonReturn()
  end;
  local func_end_4 = function()
    cmn.CallEventHandler( "get_diplompart" );
    ObjDelete("vid_manequin_vid_mother_mouse_scroll_44")
    ObjAttach("vid_manequin_vid_mother_mouse_end_39","obj_manequin_mouse_vid")
    VidPlay("vid_manequin_vid_mother_mouse_end_39", function() 
      ObjAnimate( "vid_manequin_vid_mother_mouse_end_39", 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
    end )
    
  end
  local func_end_3 = function()
    cmn.CallEventHandler( "get_ruby" );
    ObjDelete("vid_manequin_vid_mother_mouse_ruby_245")
    ObjAttach("vid_manequin_vid_mother_mouse_scroll_44","obj_manequin_mouse_vid")
    VidPlay("vid_manequin_vid_mother_mouse_scroll_44", func_end_4 )
  end
  local func_end_2 = function()
    SoundVid( "aud_use_mouse_manequin" )
    ObjAttach("vid_manequin_vid_mother_mouse_ruby_245","obj_manequin_mouse_vid")
    ObjAnimate( "vid_manequin_vid_mother_mouse_ruby_245", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
    VidPlay("vid_manequin_vid_mother_mouse_ruby_245", func_end_3 )
  end

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mouse_manequin_inv" );
  cmn.CallEventHandler( "use_mouse_manequin_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "aud_use_mouse_manequin" )
  interface.SimonJump(func_end_2)
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ruby" ] = { type = "get", get_obj = "spr_manequin_ruby", room = "rm_dressroom", zz = "zz_manequin", zz_gate = "gzz_dressroom_manequin" };

private.get_ruby_logic = function()
  
end;
private.get_ruby_inv = function()
  interface.InventoryItemAdd("inv_ruby","spr_manequin_ruby");
end;
private.get_ruby_beg = function()
  ObjDelete("gfx_manequin_ruby")
  ObjSet( "spr_manequin_ruby", {visible = 1} );
end;
private.get_ruby_end = function()
  if common_impl.ZzCompleteCheck("get_ruby") then ObjSet( common_impl.hint["get_ruby"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ruby", private.get_ruby_inv );
cmn.AddSubscriber( "get_ruby", private.get_ruby_beg, private.room_objname );
cmn.AddSubscriber( "get_ruby", private.get_ruby_end, private.room_objname );
cmn.AddSubscriber( "get_ruby", private.get_ruby_logic );
--------------------------------------------------------------------
function public.get_ruby()
  cmn.SetEventDone( "get_ruby" );
  cmn.CallEventHandler( "get_ruby" );
  if common_impl.ZzCompleteCheck("get_ruby") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_diplompart" ] = { type = "get", get_obj = "spr_manequin_diplompart", room = "rm_dressroom", zz = "zz_manequin", zz_gate = "gzz_dressroom_manequin" };

private.get_diplompart_logic = function()
  
end;
private.get_diplompart_inv = function()
  interface.InventoryItemAdd("inv_diplompart","spr_manequin_diplompart");
end;
private.get_diplompart_beg = function()
  ObjDelete("gfx_manequin_diplompart")
  ObjSet( "spr_manequin_diplompart", {visible = 1} );
end;
private.get_diplompart_end = function()
  if common_impl.ZzCompleteCheck("get_diplompart") then ObjSet( common_impl.hint["get_diplompart"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_diplompart", private.get_diplompart_inv );
cmn.AddSubscriber( "get_diplompart", private.get_diplompart_beg, private.room_objname );
cmn.AddSubscriber( "get_diplompart", private.get_diplompart_end, private.room_objname );
cmn.AddSubscriber( "get_diplompart", private.get_diplompart_logic );
--------------------------------------------------------------------
function public.get_diplompart()
  cmn.SetEventDone( "get_diplompart" );
  cmn.CallEventHandler( "get_diplompart" );
  if common_impl.ZzCompleteCheck("get_diplompart") then ld.CloseSubRoom() end;
  if port.isPortable()==1 then
    iOS_RateMe();
  end;
end
--------------------------------------------------------------------

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local get_goldenthreads_for_dressroom = function()
    ObjSet( "gmg_dressroom_hatsmg", {input = 0, visible = 0} );
  end;
  cmn.AddSubscriber("get_goldenthreads", get_goldenthreads_for_dressroom, private.room_objname )
  local win_hatsmg_for_dressroom = function()
    if ld.CheckRequirements( {"win_hatsmg"} ) then
      ObjDelete("spr_dressroom_hats_wrong")
      ObjSet( "spr_dressroom_hats_right", {visible = 1} );
    end
  end
  cmn.AddSubscriber("win_hatsmg", win_hatsmg_for_dressroom, private.room_objname )
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_dressroom();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_dressroom_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_manequin" );
  function zz_manequin.Open()
  end;
  function zz_manequin.PreOpen()
  end;
  function zz_manequin.PreClose()
  end;
  function zz_manequin.Close()
  end;

  subroom.Define( "zz_hats" );
  function zz_hats.Open()
  end;
  function zz_hats.PreOpen()
  end;
  function zz_hats.PreClose()
  end;
  function zz_hats.Close()
  end;

  subroom.Define( "zz_wardrobewithcells" );
  function zz_wardrobewithcells.Open()
  end;
  function zz_wardrobewithcells.PreOpen()
  end;
  function zz_wardrobewithcells.PreClose()
  end;
  function zz_wardrobewithcells.Close()
  end;
  
end;
--*********************************************************************************************************************