-- name=rm_floor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_floor";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_bear_note", "spr_bear_note_big", "zz_bear_note")
function private.opn_floor()
  if not ( cmn.IsEventDone( "opn_floor" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_floor" );
      cmn.CallEventHandler( "opn_floor" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_floor = function() end;
local opn_floor_logic = function() end;
cmn.AddSubscriber( "opn_floor", opn_floor_logic )
cmn.AddSubscriber( "opn_floor", opn_floor, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_atticdoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_casketpart2" ] = { type = "get", get_obj = "spr_atticdoor_casketpart2", room = "rm_floor", zz = "zz_atticdoor", zz_gate = "gzz_floor_atticdoor" };

private.get_casketpart2_logic = function()
  ObjSet( "gfx_atticdoor_griffonhead_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_casketpart2_inv = function()
  interface.InventoryItemAdd("inv_casketpart","spr_atticdoor_casketpart2",function() level_inv.ProcessGetCasketpartAll( "get_casketpart2" ) end);
end;
private.get_casketpart2_beg = function()
  ObjDelete("gfx_atticdoor_casketpart2")
end;
private.get_casketpart2_end = function()
  ObjDelete("spr_floor_casket_part")
  if common_impl.ZzCompleteCheck("get_casketpart2") then ObjSet( common_impl.hint["get_casketpart2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_casketpart2", private.get_casketpart2_inv );
cmn.AddSubscriber( "get_casketpart2", private.get_casketpart2_beg, private.room_objname );
cmn.AddSubscriber( "get_casketpart2", private.get_casketpart2_end, private.room_objname );
cmn.AddSubscriber( "get_casketpart2", private.get_casketpart2_logic );
--------------------------------------------------------------------
function public.get_casketpart2()
  cmn.SetEventDone( "get_casketpart2" );
  cmn.CallEventHandler( "get_casketpart2" );
  if common_impl.ZzCompleteCheck("get_casketpart2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_griffonhead" ] = { type = "use", inv_obj = "inv_griffonhead", use_place = "gfx_atticdoor_griffonhead_zone", room = "rm_floor", zz = "zz_atticdoor", zz_gate = "gzz_floor_atticdoor" };

private.use_griffonhead_logic = function()
  ObjSet( "obj_atticdoor_mmg_root", { visible = 1, input = 1, active = 1 } )

end;
private.use_griffonhead_inv = function()
  common_impl.ProcessMultiUseAll("griffonhead", "griffonhead")
end;
private.use_griffonhead_beg = function()
  ObjDelete( "gfx_atticdoor_griffonhead_zone" );
end;
private.use_griffonhead_end = function()
  ObjSet( "spr_floor_griffin_head", {visible = 1} );
  ObjSet( "anm_atticdoor_anim_2", {animfunc = "out_griffin", frame = 0  } );
  if common_impl.ZzCompleteCheck("use_griffonhead") then ObjSet( common_impl.hint["use_griffonhead"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_griffonhead", private.use_griffonhead_inv );
cmn.AddSubscriber( "use_griffonhead", private.use_griffonhead_beg, private.room_objname );
cmn.AddSubscriber( "use_griffonhead", private.use_griffonhead_end, private.room_objname );
cmn.AddSubscriber( "use_griffonhead", private.use_griffonhead_logic );
cmn.AddSubscriber( "use_griffonhead_inv", private.use_griffonhead_inv, private.room_objname );
cmn.AddSubscriber( "use_griffonhead_beg", private.use_griffonhead_beg, private.room_objname );
cmn.AddSubscriber( "use_griffonhead_end", private.use_griffonhead_end, private.room_objname );
cmn.AddSubscriber( "use_griffonhead_end", private.use_griffonhead_logic );
--------------------------------------------------------------------------------------------
function public.use_griffonhead( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_griffonhead" );
    cmn.CallEventHandler( "use_griffonhead_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_griffonhead") then ld.CloseSubRoom() end;
    public.win_atticdoor_load()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_griffonhead_inv" );
  cmn.CallEventHandler( "use_griffonhead_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_atticdoor_anim_2", "use_head", func_end );
  SoundSfx( "aud_use_griffonhead_floor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
function public.win_atticdoor_load()
  if not private.win_atticdoor_gm then
    private.win_atticdoor_gm = {}
    local gm = private.win_atticdoor_gm

    gm.ORDER = {
                "monkey",
                "griffin",
                "fox",
                "lion",
                "wolf"
               }
    gm.zone = "obj_atticdoor_mmg_"
    gm.anim = "anm_atticdoor_anim_"

    if not ng_global.progress["std"]["win_atticdoor"].state or reset then
      ng_global.progress["std"]["win_atticdoor"].state = {}
    end
    gm.state = ld.TableCopy(ng_global.progress["std"]["win_atticdoor"].state)
    
    function gm.default() 
      for i = 1,#gm.ORDER do
        ObjSet( gm.zone..i, {
          event_mdown = function() gm.click(i) end,
          event_menter = function() gm.menter()  end,
          event_mleave = function() gm.mleave() end,
        } );
      end
    end

    function gm.unset(n)
      ObjSet( gm.zone..n, {input = 1} );
      ObjSet( gm.anim..n, {animfunc = "out_"..gm.ORDER[n], frame = 0} );
    end
    function gm.set(n)
      ObjSet( gm.zone..n, {input = 0} );
      ObjSet( gm.anim..n, {animfunc = "in_"..gm.ORDER[n], frame = 0} );
    end

    function gm.load()
      for i,o in ipairs(gm.state) do
        gm.set(i)
      end
    end

    function gm.skip()
      for i = 1,#gm.ORDER do
        if not gm.state[i] then
          gm.click(i,true)
        end
      end
    end
    function gm.reset() 
      --ld.LogTrace( "reset" );
      local function func_end(i)
        ld.LockCustom(gm.anim..i,0)
        gm.unset(i)
      end
      for i,o in ipairs(gm.state) do
        ld.LockCustom(gm.anim..o,1)
        ld.AnimPlay( gm.anim..o, "in_"..gm.ORDER[o], function() func_end(o) end )
        if i == #gm.state then
          SoundSfx( "aud_dagger_hide" )
          gm.state = {}
          gm.save()
        end
      end
    end

    function gm.save()
      ng_global.progress["std"]["win_atticdoor"].state = ld.TableCopy(gm.state)
    end

    function gm.click(n,skip)
      local function func_end()  
        ld.LockCustom(n,0)
        if n == #gm.state or skip then
          gm.set(n)
          if #gm.state == #gm.ORDER then
            if not gm.winning then
              public.win_atticdoor()
            end
            gm.winning = true
          else
            gm.save()
          end
        else
          gm.reset() 
        end
      end
      table.insert(gm.state,n)
      ld.LockCustom(n,1)
      SoundSfx( "aud_dagger_show" )
      ld.AnimPlay( gm.anim..n, "out_"..gm.ORDER[n], func_end )
    
    end

    function gm.menter()
      ld.ShCur(CURSOR_HAND)
    end
    function gm.mleave()
      ld.ShCur(CURSOR_DEFAULT)
    end

    gm.default() 
    gm.load()

  else
  end

  if ld.CheckRequirements( {"use_griffonhead"} ) and not ld.CheckRequirements( {"win_atticdoor"} ) then
    cmn.MiniGameShow( "atticdoor" );
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_atticdoor" ] = { type = "click", use_place = "obj_atticdoor_mmg_root", room = "rm_floor", zz = "zz_atticdoor", zz_gate = "gzz_floor_atticdoor" };

private.win_atticdoor_logic = function()
  if ld.CheckRequirements( {"win_atticdoor"} ) then
    ObjSet( "grm_floor_attic", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_floor_attic_focus");
    end;
  end
end;
private.win_atticdoor_beg = function()
  if ld.CheckRequirements( {"win_atticdoor"} ) then
    ObjSet( "obj_atticdoor_mmg_root", {input = 0} );
  end
end;
private.win_atticdoor_end = function()
  if ld.CheckRequirements( {"win_atticdoor"} ) then
    ObjSet( "anm_floor_anim_open", {animfunc = "open_attic", frame = 999 } );
    if common_impl.ZzCompleteCheck("win_atticdoor") then ObjSet( common_impl.hint["win_atticdoor"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_atticdoor", private.win_atticdoor_beg, private.room_objname );
cmn.AddSubscriber( "win_atticdoor", private.win_atticdoor_end, private.room_objname );
cmn.AddSubscriber( "win_atticdoor", private.win_atticdoor_logic );
cmn.AddSubscriber( "win_atticdoor_beg", private.win_atticdoor_beg, private.room_objname );
cmn.AddSubscriber( "win_atticdoor_end", private.win_atticdoor_end, private.room_objname );
cmn.AddSubscriber( "win_atticdoor_end", private.win_atticdoor_logic );
--------------------------------------------------------------------------------------------
function public.win_atticdoor()

  local func_end = function()
    cmn.SetEventDone( "win_atticdoor" );
    cmn.CallEventHandler( "win_atticdoor_end" );
  ld.LogTrace( "unlock1" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_atticdoor") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_atticdoor_beg" );
  ld.LogTrace( "lock1" );

  common_impl.Lock(1);
  ObjSet( "obj_atticdoor_mmg_root", {input = 0} );
  cmn.MiniGameHide( "atticdoor" );--no win
  ld.AnimPlay( "anm_atticdoor_anim_win", "win", function() 
    ld.CloseSubRoom()
    ld.AnimPlay( "anm_floor_anim_open", "open_attic", func_end );
  end
  );
  SoundSfx( "aud_win_atticdoor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bear *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pretzel" ] = { type = "use", inv_obj = "inv_pretzel", use_place = "gfx_bear_pretzel_zone", room = "rm_floor", zz = "zz_bear", zz_gate = "gzz_floor_bear" };

private.use_pretzel_logic = function()
  ObjSet( "spr_bear_amuletelf7", { visible = 1, input = 1, active = 1 } )


end;
private.use_pretzel_inv = function()
  common_impl.ProcessMultiUseAll("pretzel", "pretzel")
end;
private.use_pretzel_beg = function()
  ObjDelete( "gfx_bear_pretzel_zone" );
end;
private.use_pretzel_end = function()
  ObjSet( "spr_floor_amuletelf7", {visible = 1} );
  ObjSet( "anm_bear_anim", {animfunc = "end_get_pretzel", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_pretzel") then ObjSet( common_impl.hint["use_pretzel"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pretzel", private.use_pretzel_inv );
cmn.AddSubscriber( "use_pretzel", private.use_pretzel_beg, private.room_objname );
cmn.AddSubscriber( "use_pretzel", private.use_pretzel_end, private.room_objname );
cmn.AddSubscriber( "use_pretzel", private.use_pretzel_logic );
cmn.AddSubscriber( "use_pretzel_inv", private.use_pretzel_inv, private.room_objname );
cmn.AddSubscriber( "use_pretzel_beg", private.use_pretzel_beg, private.room_objname );
cmn.AddSubscriber( "use_pretzel_end", private.use_pretzel_end, private.room_objname );
cmn.AddSubscriber( "use_pretzel_end", private.use_pretzel_logic );
--------------------------------------------------------------------------------------------
function public.use_pretzel( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pretzel" );
    cmn.CallEventHandler( "use_pretzel_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pretzel") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pretzel_inv" );
  cmn.CallEventHandler( "use_pretzel_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bear_anim", "get_pretzel", func_end );
  SoundSfx( "aud_use_pretzel_floor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletelf7" ] = { type = "get", get_obj = "spr_bear_amuletelf7", room = "rm_floor", zz = "zz_bear", zz_gate = "gzz_floor_bear" };

private.get_amuletelf7_logic = function()
  ObjSet( "gfx_bear_beargirl_zone", { visible = 1, input = 1, active = 1 } )  
end;
private.get_amuletelf7_inv = function()
  interface.InventoryItemAdd("inv_amuletelf7","spr_bear_amuletelf7");
end;
private.get_amuletelf7_beg = function()
  ObjDelete("gfx_bear_amuletelf7")
end;
private.get_amuletelf7_end = function()
  ObjDelete("spr_floor_amuletelf7")
  ObjSet( "anm_bear_anim", {animfunc = "idle_bear_bear", frame = 0 } );
  if common_impl.ZzCompleteCheck("get_amuletelf7") then ObjSet( common_impl.hint["get_amuletelf7"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletelf7", private.get_amuletelf7_inv );
cmn.AddSubscriber( "get_amuletelf7", private.get_amuletelf7_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletelf7", private.get_amuletelf7_end, private.room_objname );
cmn.AddSubscriber( "get_amuletelf7", private.get_amuletelf7_logic );

cmn.AddSubscriber( "get_amuletelf7_beg", private.get_amuletelf7_inv );
cmn.AddSubscriber( "get_amuletelf7_beg", private.get_amuletelf7_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletelf7_end", private.get_amuletelf7_end, private.room_objname );
cmn.AddSubscriber( "get_amuletelf7_end", private.get_amuletelf7_logic );
--------------------------------------------------------------------
function public.get_amuletelf7()
  local function func_end() 
    ld.Lock(0)
    ld.ShowBbt('need_beargirl') 
    cmn.SetEventDone( "get_amuletelf7" );
    cmn.CallEventHandler( "get_amuletelf7_end" );
    if common_impl.ZzCompleteCheck("get_amuletelf7") then ld.CloseSubRoom() end;
  end
  ld.Lock(1)
  cmn.CallEventHandler( "get_amuletelf7_beg" );
  SoundSfx( "aud_anim_bear" )
  ld.AnimPlay( "anm_bear_anim", "ask_bear", func_end )
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_beargirl" ] = { type = "use", inv_obj = "inv_beargirl", use_place = "gfx_bear_beargirl_zone", room = "rm_floor", zz = "zz_bear", zz_gate = "gzz_floor_bear" };

private.use_beargirl_logic = function()
  ObjSet( "spr_bear_dough", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_bear_funnyracoon", { visible = 1, input = 1, active = 1 } )

end;
private.use_beargirl_inv = function()
  common_impl.ProcessMultiUseAll("beargirl", "beargirl")
end;
private.use_beargirl_beg = function()
  ObjDelete( "gfx_bear_beargirl_zone" );
  ObjSet( "spr_bear_dough", { visible = 1 } )
  ObjSet( "spr_bear_funnyracoon", { visible = 1 } )

end;
private.use_beargirl_end = function()
  ObjSet( "spr_floor_bear_girl", {visible = 1} );
  ObjSet( "spr_floor_funnyracoon", {visible = 1} );
  ObjSet( "spr_floor_dough", {visible = 1} );
  ObjSet( "anm_bear_anim", {animfunc = "get_bear", frame = 999 } );
  ObjSet( "gfx_bear_funnyracoon", {active = 1, visible = 1} );
  ObjSet( "gfx_bear_dough", {active = 1, visible = 1} );
  if common_impl.ZzCompleteCheck("use_beargirl") then ObjSet( common_impl.hint["use_beargirl"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_beargirl", private.use_beargirl_inv );
cmn.AddSubscriber( "use_beargirl", private.use_beargirl_beg, private.room_objname );
cmn.AddSubscriber( "use_beargirl", private.use_beargirl_end, private.room_objname );
cmn.AddSubscriber( "use_beargirl", private.use_beargirl_logic );
cmn.AddSubscriber( "use_beargirl_inv", private.use_beargirl_inv, private.room_objname );
cmn.AddSubscriber( "use_beargirl_beg", private.use_beargirl_beg, private.room_objname );
cmn.AddSubscriber( "use_beargirl_end", private.use_beargirl_end, private.room_objname );
cmn.AddSubscriber( "use_beargirl_end", private.use_beargirl_logic );
--------------------------------------------------------------------------------------------
function public.use_beargirl( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_beargirl" );
    cmn.CallEventHandler( "use_beargirl_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_beargirl") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_beargirl_inv" );
  cmn.CallEventHandler( "use_beargirl_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bear_anim", "get_bear", func_end );
  SoundSfx( "aud_use_beargirl_floor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dough" ] = { type = "get", get_obj = "spr_bear_dough", room = "rm_floor", zz = "zz_bear", zz_gate = "gzz_floor_bear" };

private.get_dough_logic = function()
  
end;
private.get_dough_inv = function()
  interface.InventoryItemAdd("inv_dough","spr_bear_dough");
end;
private.get_dough_beg = function()
  ObjDelete("gfx_bear_dough")
end;
private.get_dough_end = function()
  ObjDelete("spr_floor_dough")
  if common_impl.ZzCompleteCheck("get_dough") then ObjSet( common_impl.hint["get_dough"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_dough", private.get_dough_inv );
cmn.AddSubscriber( "get_dough", private.get_dough_beg, private.room_objname );
cmn.AddSubscriber( "get_dough", private.get_dough_end, private.room_objname );
cmn.AddSubscriber( "get_dough", private.get_dough_logic );
--------------------------------------------------------------------
function public.get_dough()
  cmn.SetEventDone( "get_dough" );
  cmn.CallEventHandler( "get_dough" );
  if common_impl.ZzCompleteCheck("get_dough") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_funnyracoon" ] = { type = "get", get_obj = "spr_bear_funnyracoon", room = "rm_floor", zz = "zz_bear", zz_gate = "gzz_floor_bear" };

private.get_funnyracoon_logic = function()
  
end;
private.get_funnyracoon_inv = function()
  interface.InventoryItemAdd("inv_funnyracoon","spr_bear_funnyracoon");
end;
private.get_funnyracoon_beg = function()
  ObjDelete("gfx_bear_funnyracoon")
end;
private.get_funnyracoon_end = function()
  ObjDelete("spr_floor_funnyracoon")
  if common_impl.ZzCompleteCheck("get_funnyracoon") then ObjSet( common_impl.hint["get_funnyracoon"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_funnyracoon", private.get_funnyracoon_inv );
cmn.AddSubscriber( "get_funnyracoon", private.get_funnyracoon_beg, private.room_objname );
cmn.AddSubscriber( "get_funnyracoon", private.get_funnyracoon_end, private.room_objname );
cmn.AddSubscriber( "get_funnyracoon", private.get_funnyracoon_logic );
--------------------------------------------------------------------
function public.get_funnyracoon()
  cmn.SetEventDone( "get_funnyracoon" );
  cmn.CallEventHandler( "get_funnyracoon" );
  if common_impl.ZzCompleteCheck("get_funnyracoon") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_commode *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_toyhouse" ] = { type = "use", inv_obj = "inv_toyhouse", use_place = "gfx_commode_toyhouse_zone", room = "rm_floor", zz = "zz_commode", zz_gate = "gzz_floor_commode" };

private.use_toyhouse_logic = function()
  if ld.CheckRequirements( {"use_toyhouse","use_boytoy"} ) then
    ObjSet( "spr_commode_casketpart3", {active = 1, input = 1, visible = 1} );
    ObjSet( "spr_commode_drumstick", {active = 1, input = 1, visible = 1} );
  end;

end;
private.use_toyhouse_inv = function()
  common_impl.ProcessMultiUseAll("toyhouse", "toyhouse")
end;
private.use_toyhouse_beg = function()
  ObjDelete( "gfx_commode_toyhouse_zone" );
  ObjSet( "spr_commode_house", {visible = 1} );
end;
private.use_toyhouse_end = function()
  ObjSet( "spr_floor_house", {visible = 1} );
  if ld.CheckRequirements( {"use_boytoy","use_toyhouse"} ) then
    ObjDelete("spr_floor_house")
    ObjDelete("spr_floor_boy")
    ObjSet( "spr_floor_cover_off", {visible = 1} );
    ObjDelete("spr_floor_casket_cover")
    ObjDelete("anm_commode_anim")
  end  
  if common_impl.ZzCompleteCheck("use_toyhouse") then ObjSet( common_impl.hint["use_toyhouse"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_toyhouse", private.use_toyhouse_inv );
cmn.AddSubscriber( "use_toyhouse", private.use_toyhouse_beg, private.room_objname );
cmn.AddSubscriber( "use_toyhouse", private.use_toyhouse_end, private.room_objname );
cmn.AddSubscriber( "use_toyhouse", private.use_toyhouse_logic );
cmn.AddSubscriber( "use_toyhouse_inv", private.use_toyhouse_inv, private.room_objname );
cmn.AddSubscriber( "use_toyhouse_beg", private.use_toyhouse_beg, private.room_objname );
cmn.AddSubscriber( "use_toyhouse_end", private.use_toyhouse_end, private.room_objname );
cmn.AddSubscriber( "use_toyhouse_end", private.use_toyhouse_logic );
--------------------------------------------------------------------------------------------
function public.use_toyhouse( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_toyhouse" );
    cmn.CallEventHandler( "use_toyhouse_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_toyhouse") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    if ld.IsLastActionLeft({"use_toyhouse","use_boytoy"}) then
      SoundSfx( "aud_open_box2" )
      ld.AnimPlay( "anm_commode_anim", "open_box", func_end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_toyhouse_inv" );
  cmn.CallEventHandler( "use_toyhouse_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_commode_anim", "use_house", func_end_2 );
  SoundSfx( "aud_use_toyhouse_floor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_boytoy" ] = { type = "use", inv_obj = "inv_boytoy", use_place = "gfx_commode_boytoy_zone", room = "rm_floor", zz = "zz_commode", zz_gate = "gzz_floor_commode" };

private.use_boytoy_logic = function()
  if ld.CheckRequirements( {"use_boytoy","use_toyhouse"} ) then
    ObjSet( "spr_commode_casketpart3", {active = 1, input = 1, visible = 1} );
    ObjSet( "spr_commode_drumstick", {active = 1, input = 1, visible = 1} );
  end;

end;
private.use_boytoy_inv = function()
  common_impl.ProcessMultiUseAll("boytoy", "boytoy")
end;
private.use_boytoy_beg = function()
  ObjDelete( "gfx_commode_boytoy_zone" );
  ObjSet( "spr_commode_boy", {visible = 1} );
end;
private.use_boytoy_end = function()
  ObjSet( "spr_floor_boy", {visible = 1} );
  if ld.CheckRequirements( {"use_boytoy","use_toyhouse"} ) then
    ObjDelete("spr_floor_house")
    ObjDelete("spr_floor_boy")
    ObjSet( "spr_floor_cover_off", {visible = 1} );
    ObjDelete("spr_floor_casket_cover")
    ObjDelete("anm_commode_anim")
  end
  if common_impl.ZzCompleteCheck("use_boytoy") then ObjSet( common_impl.hint["use_boytoy"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_boytoy", private.use_boytoy_inv );
cmn.AddSubscriber( "use_boytoy", private.use_boytoy_beg, private.room_objname );
cmn.AddSubscriber( "use_boytoy", private.use_boytoy_end, private.room_objname );
cmn.AddSubscriber( "use_boytoy", private.use_boytoy_logic );
cmn.AddSubscriber( "use_boytoy_inv", private.use_boytoy_inv, private.room_objname );
cmn.AddSubscriber( "use_boytoy_beg", private.use_boytoy_beg, private.room_objname );
cmn.AddSubscriber( "use_boytoy_end", private.use_boytoy_end, private.room_objname );
cmn.AddSubscriber( "use_boytoy_end", private.use_boytoy_logic );
--------------------------------------------------------------------------------------------
function public.use_boytoy( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_boytoy" );
    cmn.CallEventHandler( "use_boytoy_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_boytoy") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    if ld.IsLastActionLeft({"use_toyhouse","use_boytoy"}) then
      SoundSfx( "aud_open_box2" )
      ld.AnimPlay( "anm_commode_anim", "open_box", func_end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_boytoy_inv" );
  cmn.CallEventHandler( "use_boytoy_beg" );  
  common_impl.Lock(1);

  ld.AnimPlay( "anm_commode_anim", "use_kid", func_end_2 );
  SoundSfx( "aud_use_toyhouse_floor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_casketpart3" ] = { type = "get", get_obj = "spr_commode_casketpart3", room = "rm_floor", zz = "zz_commode", zz_gate = "gzz_floor_commode" };

private.get_casketpart3_logic = function()
  
end;
private.get_casketpart3_inv = function()
  interface.InventoryItemAdd("inv_casketpart","spr_commode_casketpart3",function() level_inv.ProcessGetCasketpartAll( "get_casketpart3" ) end);
end;
private.get_casketpart3_beg = function()
  ObjDelete("gfx_commode_casketpart3")
end;
private.get_casketpart3_end = function()
  if common_impl.ZzCompleteCheck("get_casketpart3") then ObjSet( common_impl.hint["get_casketpart3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_casketpart3", private.get_casketpart3_inv );
cmn.AddSubscriber( "get_casketpart3", private.get_casketpart3_beg, private.room_objname );
cmn.AddSubscriber( "get_casketpart3", private.get_casketpart3_end, private.room_objname );
cmn.AddSubscriber( "get_casketpart3", private.get_casketpart3_logic );
--------------------------------------------------------------------
function public.get_casketpart3()
  cmn.SetEventDone( "get_casketpart3" );
  cmn.CallEventHandler( "get_casketpart3" );
  if common_impl.ZzCompleteCheck("get_casketpart3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_drumstick" ] = { type = "get", get_obj = "spr_commode_drumstick", room = "rm_floor", zz = "zz_commode", zz_gate = "gzz_floor_commode" };

private.get_drumstick_logic = function()
  
end;
private.get_drumstick_inv = function()
  interface.InventoryItemAdd("inv_drumstick","spr_commode_drumstick");
end;
private.get_drumstick_beg = function()
  ObjDelete("gfx_commode_drumstick")
end;
private.get_drumstick_end = function()
  ObjDelete("spr_commode_drumstick_shadow")
  if common_impl.ZzCompleteCheck("get_drumstick") then ObjSet( common_impl.hint["get_drumstick"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_drumstick", private.get_drumstick_inv );
cmn.AddSubscriber( "get_drumstick", private.get_drumstick_beg, private.room_objname );
cmn.AddSubscriber( "get_drumstick", private.get_drumstick_end, private.room_objname );
cmn.AddSubscriber( "get_drumstick", private.get_drumstick_logic );
--------------------------------------------------------------------
function public.get_drumstick()
  cmn.SetEventDone( "get_drumstick" );
  cmn.CallEventHandler( "get_drumstick" );
  if common_impl.ZzCompleteCheck("get_drumstick") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_newbutton" ] = { type = "use", inv_obj = "inv_newbutton", use_place = "gfx_commode_newbutton_zone", room = "rm_floor", zz = "zz_commode", zz_gate = "gzz_floor_commode" };

private.use_newbutton_logic = function()
  ObjSet( "gfx_commode_clk_newbutton1_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "gfx_commode_clk_newbutton2_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_newbutton_inv = function()
  common_impl.ProcessMultiUseAll("newbutton", "newbutton")
end;
private.use_newbutton_beg = function()
  ObjDelete( "gfx_commode_newbutton_zone" );
end;
private.use_newbutton_end = function()
  ObjSet( "spr_floor_button_1", {visible = 1} );
  ObjSet( "spr_floor_button_2", {visible = 1} );
  ObjSet( "anm_commode_anim_drawer", {animfunc = "use_buttons", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_newbutton") then ObjSet( common_impl.hint["use_newbutton"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_newbutton", private.use_newbutton_inv );
cmn.AddSubscriber( "use_newbutton", private.use_newbutton_beg, private.room_objname );
cmn.AddSubscriber( "use_newbutton", private.use_newbutton_end, private.room_objname );
cmn.AddSubscriber( "use_newbutton", private.use_newbutton_logic );
cmn.AddSubscriber( "use_newbutton_inv", private.use_newbutton_inv, private.room_objname );
cmn.AddSubscriber( "use_newbutton_beg", private.use_newbutton_beg, private.room_objname );
cmn.AddSubscriber( "use_newbutton_end", private.use_newbutton_end, private.room_objname );
cmn.AddSubscriber( "use_newbutton_end", private.use_newbutton_logic );
--------------------------------------------------------------------------------------------
function public.use_newbutton( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_newbutton" );
    cmn.CallEventHandler( "use_newbutton_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_newbutton") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_newbutton_inv" );
  cmn.CallEventHandler( "use_newbutton_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_commode_anim_drawer", "use_buttons", func_end );
  SoundSfx( "aud_use_newbutton_floor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_newbutton1" ] = { type = "click", use_place = "gfx_commode_clk_newbutton1_zone", room = "rm_floor", zz = "zz_commode", zz_gate = "gzz_floor_commode" };

private.clk_newbutton1_logic = function()
  if ld.CheckRequirements( {"clk_newbutton1","clk_newbutton2"} ) then
    ObjSet( "spr_commode_dragon2", { input = 1 } )
  end
end;
private.clk_newbutton1_beg = function()
  ObjDelete( "gfx_commode_clk_newbutton1_zone" );
end;
private.clk_newbutton1_end = function()
  if ld.CheckRequirements( {"clk_newbutton1","clk_newbutton2"} ) then
    ObjDelete("spr_floor_button_1")
    ObjDelete("spr_floor_button_2")
    ObjSet( "spr_floor_open_pull_box", {visible = 1} );
    ObjSet( "gfx_commode_dragon2", { visible = 1, active = 1 } )
    ObjSet( "anm_commode_anim_drawer", {animfunc = "open_pullbox", frame = 999 } );
  else
    ObjSet( "anm_commode_anim_drawer", {animfunc = "click_button_2_2", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("clk_newbutton1") then ObjSet( common_impl.hint["clk_newbutton1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_newbutton1", private.clk_newbutton1_beg, private.room_objname );
cmn.AddSubscriber( "clk_newbutton1", private.clk_newbutton1_end, private.room_objname );
cmn.AddSubscriber( "clk_newbutton1", private.clk_newbutton1_logic );
cmn.AddSubscriber( "clk_newbutton1_beg", private.clk_newbutton1_beg, private.room_objname );
cmn.AddSubscriber( "clk_newbutton1_end", private.clk_newbutton1_end, private.room_objname );
cmn.AddSubscriber( "clk_newbutton1_end", private.clk_newbutton1_logic );
--------------------------------------------------------------------------------------------
function public.clk_newbutton1()

  local func_end = function()
    cmn.SetEventDone( "clk_newbutton1" );
    cmn.CallEventHandler( "clk_newbutton1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_newbutton1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_newbutton1_beg" );
  common_impl.Lock(1);
  if ld.IsLastActionLeft({"clk_newbutton1","clk_newbutton2"}) then
    ld.AnimPlay( "anm_commode_anim_drawer", "click_button_1_2", function() 
      SoundSfx( "aud_open_drawer" )
      ld.AnimPlay( "anm_commode_anim_drawer", "open_pullbox", func_end );
    end );
  else    
    ld.AnimPlay( "anm_commode_anim_drawer", "click_button_1_1", func_end );
  end
  SoundSfx( "aud_press_button2" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_newbutton2" ] = { type = "click", use_place = "gfx_commode_clk_newbutton2_zone", room = "rm_floor", zz = "zz_commode", zz_gate = "gzz_floor_commode" };

private.clk_newbutton2_logic = function()
  if ld.CheckRequirements( {"clk_newbutton1","clk_newbutton2"} ) then
    ObjSet( "spr_commode_dragon2", { input = 1 } )
  end
end;
private.clk_newbutton2_beg = function()
  ObjDelete( "gfx_commode_clk_newbutton2_zone" );
end;
private.clk_newbutton2_end = function()
  if ld.CheckRequirements( {"clk_newbutton1","clk_newbutton2"} ) then
    ObjDelete("spr_floor_button_1")
    ObjDelete("spr_floor_button_2")
    ObjSet( "spr_floor_open_pull_box", {visible = 1} );
    ObjSet( "gfx_commode_dragon2", { visible = 1, active = 1 } )
    ObjSet( "anm_commode_anim_drawer", {animfunc = "open_pullbox", frame = 999 } );
  else
    ObjSet( "anm_commode_anim_drawer", {animfunc = "click_button_1_2", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("clk_newbutton2") then ObjSet( common_impl.hint["clk_newbutton2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_newbutton2", private.clk_newbutton2_beg, private.room_objname );
cmn.AddSubscriber( "clk_newbutton2", private.clk_newbutton2_end, private.room_objname );
cmn.AddSubscriber( "clk_newbutton2", private.clk_newbutton2_logic );
cmn.AddSubscriber( "clk_newbutton2_beg", private.clk_newbutton2_beg, private.room_objname );
cmn.AddSubscriber( "clk_newbutton2_end", private.clk_newbutton2_end, private.room_objname );
cmn.AddSubscriber( "clk_newbutton2_end", private.clk_newbutton2_logic );
--------------------------------------------------------------------------------------------
function public.clk_newbutton2()

  local func_end = function()
    cmn.SetEventDone( "clk_newbutton2" );
    cmn.CallEventHandler( "clk_newbutton2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_newbutton2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_newbutton2_beg" );
  common_impl.Lock(1);

  if ld.IsLastActionLeft({"clk_newbutton1","clk_newbutton2"}) then
    ld.AnimPlay( "anm_commode_anim_drawer", "click_button_2_2", function() 
      SoundSfx( "aud_open_drawer" )
      ld.AnimPlay( "anm_commode_anim_drawer", "open_pullbox", func_end );
    end );
  else    
    ld.AnimPlay( "anm_commode_anim_drawer", "click_button_2_1", func_end );
  end
  SoundSfx( "aud_press_button2" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dragon2" ] = { type = "get", get_obj = "spr_commode_dragon2", room = "rm_floor", zz = "zz_commode", zz_gate = "gzz_floor_commode" };

private.get_dragon2_logic = function()
  
end;
private.get_dragon2_inv = function()
  interface.InventoryItemAdd("inv_dragon2","spr_commode_dragon2");
end;
private.get_dragon2_beg = function()
  ObjDelete("gfx_commode_dragon2")
  ObjSet( "spr_commode_dragon2", {visible = 1} );
  ObjSet( "anm_commode_anim_drawer", {animfunc = "open_pullbox_end", frame = 0 } );
end;
private.get_dragon2_end = function()
  if common_impl.ZzCompleteCheck("get_dragon2") then ObjSet( common_impl.hint["get_dragon2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_dragon2", private.get_dragon2_inv );
cmn.AddSubscriber( "get_dragon2", private.get_dragon2_beg, private.room_objname );
cmn.AddSubscriber( "get_dragon2", private.get_dragon2_end, private.room_objname );
cmn.AddSubscriber( "get_dragon2", private.get_dragon2_logic );
--------------------------------------------------------------------
function public.get_dragon2()
  cmn.SetEventDone( "get_dragon2" );
  cmn.CallEventHandler( "get_dragon2" );
  if common_impl.ZzCompleteCheck("get_dragon2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_chair *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mouseready" ] = { type = "use", inv_obj = "inv_mouseready", use_place = "gfx_chair_mouseready_zone", room = "rm_floor", zz = "zz_chair", zz_gate = "gzz_floor_chair" };

private.use_mouseready_logic = function()
  ObjSet( "gmg_floor_labyrinth", { visible = 1, input = 1, active = 1 } )

end;
private.use_mouseready_inv = function()
  common_impl.ProcessMultiUseAll("mouseready", "mouseready")
end;
private.use_mouseready_beg = function()
  ObjDelete( "gfx_chair_mouseready_zone" );
end;
private.use_mouseready_end = function()
  ObjSet( "anm_chair_anm", {animfunc = "use_mouse", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_mouseready") then ObjSet( common_impl.hint["use_mouseready"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mouseready", private.use_mouseready_inv );
cmn.AddSubscriber( "use_mouseready", private.use_mouseready_beg, private.room_objname );
cmn.AddSubscriber( "use_mouseready", private.use_mouseready_end, private.room_objname );
cmn.AddSubscriber( "use_mouseready", private.use_mouseready_logic );
cmn.AddSubscriber( "use_mouseready_inv", private.use_mouseready_inv, private.room_objname );
cmn.AddSubscriber( "use_mouseready_beg", private.use_mouseready_beg, private.room_objname );
cmn.AddSubscriber( "use_mouseready_end", private.use_mouseready_end, private.room_objname );
cmn.AddSubscriber( "use_mouseready_end", private.use_mouseready_logic );
--------------------------------------------------------------------------------------------
function public.use_mouseready( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mouseready" );
    cmn.CallEventHandler( "use_mouseready_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mouseready") then ld.CloseSubRoom() end;
    common_impl.Gate_MDown( "gmg_floor_labyrinth" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mouseready_inv" );
  cmn.CallEventHandler( "use_mouseready_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_chair_anm", "use_mouse", func_end );
  SoundSfx( "aud_use_mouseready_floor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  if ( mg_name == "zz_atticdoor" ) then
    private.win_atticdoor_gm.reset()
  end
end;
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  if ( mg_name == "zz_atticdoor" ) then
    private.win_atticdoor_gm.skip()
  end
end;

  local win_labyrinth_for_floor = function()
    if ld.CheckRequirements( {"get_slapstick","get_ovalframe"} ) then
      ObjSet( "gmg_floor_labyrinth", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("get_slapstick", win_labyrinth_for_floor, private.room_objname )
  cmn.AddSubscriber("get_ovalframe", win_labyrinth_for_floor, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_floor();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_hall_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_chair" );
  function zz_chair.Open()
  end;
  function zz_chair.PreOpen()
  end;
  function zz_chair.PreClose()
  end;
  function zz_chair.Close()
  end;

  subroom.Define( "zz_commode" );
  function zz_commode.Open()
  end;
  function zz_commode.PreOpen()
  end;
  function zz_commode.PreClose()
  end;
  function zz_commode.Close()
  end;

  subroom.Define( "zz_bear" );
  function zz_bear.Open()
  end;
  function zz_bear.PreOpen()
  end;
  function zz_bear.PreClose()
  end;
  function zz_bear.Close()
  end;

  subroom.Define( "zz_atticdoor" );
  function zz_atticdoor.Open()
  end;
  function zz_atticdoor.PreOpen()
    public.win_atticdoor_load()
  end;
  function zz_atticdoor.PreClose()
  end;
  function zz_atticdoor.Close()
  end;
  
end;
--*********************************************************************************************************************