-- name=rm_hall
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ----------------------------------------------------------------
  
  ld.NoteInit( "spr_hall_gift_small", "spr_hall_gift_big", "txt_hall_note" );
  
  ld.NoteInit( "spr_onthewall_book", "spr_onthewall_book_tr" )
  ld.NoteRelaseLock( "spr_onthewall_book" )
  
  --------------------------------------------------------------------------------------------
function private.opn_hall()
  if not ( cmn.IsEventDone( "opn_hall" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_hall" );
      cmn.CallEventHandler( "opn_hall" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_hall = function() end;
local opn_hall_logic = function() end;
cmn.AddSubscriber( "opn_hall", opn_hall_logic )
cmn.AddSubscriber( "opn_hall", opn_hall, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_flashback2" ] = { type = "click", use_place = "gfx_hall_clk_flashback2_zone", room = "rm_hall" };

private.clk_flashback2_logic = function()
  ObjSet("gfx_hall_lighter_zone",{visible=1,active=1,input=1})
  ObjSet("gzz_hall_cupboard",{visible=1,active=1,input=1})
  
  ObjSet("gzz_hall_cabinetdoor",{visible=1,active=1,input=1})
  ObjSet("gzz_hall_onthewall",{visible=1,active=1,input=1})
  ObjSet("gzz_hall_sewingmachine",{visible=1,active=1,input=1})
  
  ObjSet("spr_hall_gift_small",{visible=1,active=1,input=1})
end;
private.clk_flashback2_beg = function()
  ObjDelete( "gfx_hall_clk_flashback2_zone" );
end;
private.clk_flashback2_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_flashback2", private.clk_flashback2_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback2", private.clk_flashback2_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback2", private.clk_flashback2_logic );
cmn.AddSubscriber( "clk_flashback2_beg", private.clk_flashback2_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback2_end", private.clk_flashback2_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback2_end", private.clk_flashback2_logic );
--------------------------------------------------------------------------------------------
function public.clk_flashback2()

  local func_end = function()
    cmn.SetEventDone( "clk_flashback2" );
    cmn.CallEventHandler( "clk_flashback2_end" );
    
    common_impl.FlashbackHide();
    ld.ShowBbt( "after_clk_flashback2" )
    common_impl.Lock(0);
    level.tutorial_map1.first()
  end;

  cmn.CallEventHandler( "clk_flashback2_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  
  local obj_root   = "obj_hall_vid_flashback_root"
  local vid_prefix = "vid_hall_vid_flashback_"
  local str_prefix = "str_hall_vid_flashback_"
  local lip_prefix = "vid_hall_vid_flashback_"
  local aud_count_dif = 0
  common_impl.FlashbackInit( obj_root, func_end, vid_prefix, str_prefix, lip_prefix, aud_count_dif )  

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )

  local func_step_6 = function()
    --SoundEnv( "aud_square_env" )
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_6" )
    common_impl.FlashbackShow( 6, func_end )
  end;

  local func_step_5 = function()
    --SoundEnv( "aud_street_env" )
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_2" )
    common_impl.FlashbackShow( 5, func_step_6 )
  end;

  local func_step_4 = function()
    --SoundEnv( "aud_hall_env" )
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_2" )
    common_impl.FlashbackShow( 4, func_step_5 )
  end;

  --ld.CloseSubRoom()
  func_step_4()
  

end;


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lighter" ] = { type = "use", inv_obj = "inv_lighter", use_place = "gfx_hall_lighter_zone", room = "rm_hall" };

private.use_lighter_logic = function()
  ObjSet( "gho_hall_underfirtreeho", { visible = 1, input = 1, active = 1 } )

end;
private.use_lighter_inv = function()
  common_impl.ProcessMultiUseAll("lighter", "lighter")
end;
private.use_lighter_beg = function()
  ObjDelete( "gfx_hall_lighter_zone" );
end;
private.use_lighter_end = function()
  ObjSet("anm_hall_anim_fire_on",{animfunc="static_tree_light",playing=true})
  ObjSet("fx_hall_sparks_light_on_fx",{visible=1,active=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lighter", private.use_lighter_inv );
cmn.AddSubscriber( "use_lighter", private.use_lighter_beg, private.room_objname );
cmn.AddSubscriber( "use_lighter", private.use_lighter_end, private.room_objname );
cmn.AddSubscriber( "use_lighter", private.use_lighter_logic );
cmn.AddSubscriber( "use_lighter_inv", private.use_lighter_inv, private.room_objname );
cmn.AddSubscriber( "use_lighter_beg", private.use_lighter_beg, private.room_objname );
cmn.AddSubscriber( "use_lighter_end", private.use_lighter_end, private.room_objname );
cmn.AddSubscriber( "use_lighter_end", private.use_lighter_logic );
--------------------------------------------------------------------------------------------
function public.use_lighter( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lighter" );
    cmn.CallEventHandler( "use_lighter_end" );
    common_impl.Lock(0);
    level.tutorial_hosparkles.first()
    if common_impl.ZzCompleteCheck("use_lighter") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lighter_inv" );
  cmn.CallEventHandler( "use_lighter_beg" );
  common_impl.Lock(1);

  
  ld.AnimPlay( "anm_hall_anim_fire_on", "fire_on", func_end );
  SoundSfx( "aud_lighter" )

end;
--------------------------------------------------------------------------------------------



function public.click_cat()
  if not private.click_cat_run then
    private.click_cat_run = true;
    SoundSfx( "aud_xx_cat" )
    ld.AnimPlay("anm_hall_anim_static_cat","click_cat", function() ld.AnimPlay("anm_hall_anim_static_cat","static_cat",""); private.click_cat_run=false; end);
  end
end



function public.click_tree()
  local fx = "fx_hall_click_tree_fx";
  if not ObjGet(fx) then
    ObjCreate( fx, "partsys_pm" )
    ObjAttach( fx, "rm_hall")
    ObjSet( fx,
    {
      active  = 1;
      input   = 0;
      visible = 1;
      pos_x   = 0;
      pos_y   = 0;
      pos_z   = 0;
      res     = "assets/levels/level/rm_hall/click_tree_fx";
    })
    ld.StartTimer(3.3, function() ObjDelete(fx); end);
  end
end


--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_onthewall *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_monogram" ] = { type = "get", get_obj = "spr_onthewall_monogram", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.get_monogram_logic = function()
  
end;
private.get_monogram_inv = function()
  interface.InventoryItemAdd("inv_monogram","spr_onthewall_monogram");
end;
private.get_monogram_beg = function()
  ObjDelete("gfx_onthewall_monogram")
end;
private.get_monogram_end = function()
  if common_impl.ZzCompleteCheck("get_monogram") then ObjSet( common_impl.hint["get_monogram"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_onthewall_monogram_sh")
end;

cmn.AddSubscriber( "get_monogram", private.get_monogram_inv );
cmn.AddSubscriber( "get_monogram", private.get_monogram_beg, private.room_objname );
cmn.AddSubscriber( "get_monogram", private.get_monogram_end, private.room_objname );
cmn.AddSubscriber( "get_monogram", private.get_monogram_logic );
--------------------------------------------------------------------
function public.get_monogram()
  cmn.SetEventDone( "get_monogram" );
  cmn.CallEventHandler( "get_monogram" );
  if common_impl.ZzCompleteCheck("get_monogram") then ld.CloseSubRoom() end;
  ObjSet("spr_onthewall_monogram",{res="assets/levels/level/rm_hall/zz_onthewall/monogram"})
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bunchofrowan" ] = { type = "use", inv_obj = "inv_bunchofrowan", use_place = "gfx_onthewall_bunchofrowan_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.use_bunchofrowan_logic = function()
  if ld.CheckRequirements( {"clk_apples"} ) then
    ObjSet( "gfx_onthewall_clk_bunchofrowan_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_bunchofrowan_inv = function()
  common_impl.ProcessMultiUseAll("bunchofrowan", "bunchofrowan")
end;
private.use_bunchofrowan_beg = function()
  ObjDelete( "gfx_onthewall_bunchofrowan_zone" );
end;
private.use_bunchofrowan_end = function()
  if common_impl.ZzCompleteCheck("use_bunchofrowan") then ObjSet( common_impl.hint["use_bunchofrowan"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm_use_bunchofrowan",{frame=999,animfunc="use_bunchofrowan"})
  ObjSet("spr_onthewall_bunchofrowan_idle",{input=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bunchofrowan", private.use_bunchofrowan_inv );
cmn.AddSubscriber( "use_bunchofrowan", private.use_bunchofrowan_beg, private.room_objname );
cmn.AddSubscriber( "use_bunchofrowan", private.use_bunchofrowan_end, private.room_objname );
cmn.AddSubscriber( "use_bunchofrowan", private.use_bunchofrowan_logic );
cmn.AddSubscriber( "use_bunchofrowan_inv", private.use_bunchofrowan_inv, private.room_objname );
cmn.AddSubscriber( "use_bunchofrowan_beg", private.use_bunchofrowan_beg, private.room_objname );
cmn.AddSubscriber( "use_bunchofrowan_end", private.use_bunchofrowan_end, private.room_objname );
cmn.AddSubscriber( "use_bunchofrowan_end", private.use_bunchofrowan_logic );
--------------------------------------------------------------------------------------------
function public.use_bunchofrowan( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bunchofrowan" );
    cmn.CallEventHandler( "use_bunchofrowan_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bunchofrowan") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bunchofrowan_inv" );
  cmn.CallEventHandler( "use_bunchofrowan_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onthewall_anm_use_bunchofrowan", "use_bunchofrowan", func_end );
  SoundSfx( "aud_cone" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cone" ] = { type = "use", inv_obj = "inv_cone", use_place = "gfx_onthewall_cone_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.use_cone_logic = function()
  --if ld.CheckRequirements( {"use_cone","use_bunchofrowan"} ) then
    ObjSet( "gfx_onthewall_clk_cone_zone", { visible = 1, input = 1, active = 1 } )
  --end;

end;
private.use_cone_inv = function()
  common_impl.ProcessMultiUseAll("cone", "cone")
end;
private.use_cone_beg = function()
  ObjDelete( "gfx_onthewall_cone_zone" );
end;
private.use_cone_end = function()
  if common_impl.ZzCompleteCheck("use_cone") then ObjSet( common_impl.hint["use_cone"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm_use_cone",{frame=999,animfunc="use_cone"})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cone", private.use_cone_inv );
cmn.AddSubscriber( "use_cone", private.use_cone_beg, private.room_objname );
cmn.AddSubscriber( "use_cone", private.use_cone_end, private.room_objname );
cmn.AddSubscriber( "use_cone", private.use_cone_logic );
cmn.AddSubscriber( "use_cone_inv", private.use_cone_inv, private.room_objname );
cmn.AddSubscriber( "use_cone_beg", private.use_cone_beg, private.room_objname );
cmn.AddSubscriber( "use_cone_end", private.use_cone_end, private.room_objname );
cmn.AddSubscriber( "use_cone_end", private.use_cone_logic );
--------------------------------------------------------------------------------------------
function public.use_cone( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cone" );
    cmn.CallEventHandler( "use_cone_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cone") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cone_inv" );
  cmn.CallEventHandler( "use_cone_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onthewall_anm_use_cone", "use_cone", func_end );
  SoundSfx( "aud_cone" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_cone" ] = { type = "click", use_place = "gfx_onthewall_clk_cone_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.clk_cone_logic = function()
  ObjSet("gfx_onthewall_clk_apples_zone",{active=1,visible=1,input=1})
end;
private.clk_cone_beg = function()
  ObjDelete( "gfx_onthewall_clk_cone_zone" );
end;
private.clk_cone_end = function()
  if common_impl.ZzCompleteCheck("clk_cone") then ObjSet( common_impl.hint["clk_cone"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm",{frame=999,animfunc="use_click_cone"})
  ObjDelete( "anm_onthewall_anm_use_cone" );
  ObjDelete("spr_onthewall_apple_idle")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_cone", private.clk_cone_beg, private.room_objname );
cmn.AddSubscriber( "clk_cone", private.clk_cone_end, private.room_objname );
cmn.AddSubscriber( "clk_cone", private.clk_cone_logic );
cmn.AddSubscriber( "clk_cone_beg", private.clk_cone_beg, private.room_objname );
cmn.AddSubscriber( "clk_cone_end", private.clk_cone_end, private.room_objname );
cmn.AddSubscriber( "clk_cone_end", private.clk_cone_logic );
--------------------------------------------------------------------------------------------
function public.clk_cone()

  local func_end = function()
    cmn.SetEventDone( "clk_cone" );
    cmn.CallEventHandler( "clk_cone_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_cone") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_cone_beg" );
  common_impl.Lock(1);

  ObjDelete( "anm_onthewall_anm_use_cone" )
  ld.AnimPlay( "anm_onthewall_anm", "use_click_cone", func_end );
  SoundSfx( "aud_clk_cone" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_apples" ] = { type = "click", use_place = "gfx_onthewall_clk_apples_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.clk_apples_logic = function()
  if ld.CheckRequirements( {"use_bunchofrowan"} ) then
    ObjSet("gfx_onthewall_clk_bunchofrowan_zone",{active=1,visible=1,input=1})
  end
end;
private.clk_apples_beg = function()
  ObjDelete( "gfx_onthewall_clk_apples_zone" );
end;
private.clk_apples_end = function()
  if common_impl.ZzCompleteCheck("clk_apples") then ObjSet( common_impl.hint["clk_apples"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm",{frame=999,animfunc="use_click_apples"})
  ObjDelete("spr_onthewall_bunchofrowan_idle");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_apples", private.clk_apples_beg, private.room_objname );
cmn.AddSubscriber( "clk_apples", private.clk_apples_end, private.room_objname );
cmn.AddSubscriber( "clk_apples", private.clk_apples_logic );
cmn.AddSubscriber( "clk_apples_beg", private.clk_apples_beg, private.room_objname );
cmn.AddSubscriber( "clk_apples_end", private.clk_apples_end, private.room_objname );
cmn.AddSubscriber( "clk_apples_end", private.clk_apples_logic );
--------------------------------------------------------------------------------------------
function public.clk_apples()

  local func_end = function()
    cmn.SetEventDone( "clk_apples" );
    cmn.CallEventHandler( "clk_apples_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_apples") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_apples_beg" );
  common_impl.Lock(1);
  
  
  ld.AnimPlay( "anm_onthewall_anm", "use_click_apples", func_end );
  SoundSfx( "aud_clk_cone" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_bunchofrowan" ] = { type = "click", use_place = "gfx_onthewall_clk_bunchofrowan_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.clk_bunchofrowan_logic = function()
  ObjSet("gfx_onthewall_clk_balloons_zone",{visible=1,active=1,input=1})
end;
private.clk_bunchofrowan_beg = function()
  ObjDelete( "gfx_onthewall_clk_bunchofrowan_zone" );
end;
private.clk_bunchofrowan_end = function()
  if common_impl.ZzCompleteCheck("clk_bunchofrowan") then ObjSet( common_impl.hint["clk_bunchofrowan"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm",{frame=999,animfunc="use_click_bunchofrowan"})
  ObjDelete("anm_onthewall_anm_use_bunchofrowan")
  ObjDelete("spr_onthewall_balloons_idle")
  ObjSet("spr_onthewall_tape_idle",{input=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_bunchofrowan", private.clk_bunchofrowan_beg, private.room_objname );
cmn.AddSubscriber( "clk_bunchofrowan", private.clk_bunchofrowan_end, private.room_objname );
cmn.AddSubscriber( "clk_bunchofrowan", private.clk_bunchofrowan_logic );
cmn.AddSubscriber( "clk_bunchofrowan_beg", private.clk_bunchofrowan_beg, private.room_objname );
cmn.AddSubscriber( "clk_bunchofrowan_end", private.clk_bunchofrowan_end, private.room_objname );
cmn.AddSubscriber( "clk_bunchofrowan_end", private.clk_bunchofrowan_logic );
--------------------------------------------------------------------------------------------
function public.clk_bunchofrowan()

  local func_end = function()
    cmn.SetEventDone( "clk_bunchofrowan" );
    cmn.CallEventHandler( "clk_bunchofrowan_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_bunchofrowan") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_bunchofrowan_beg" );
  common_impl.Lock(1);
  
  ObjDelete("anm_onthewall_anm_use_bunchofrowan")
  ld.AnimPlay( "anm_onthewall_anm", "use_click_bunchofrowan", func_end );
  SoundSfx( "aud_clk_cone" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_balloons" ] = { type = "click", use_place = "gfx_onthewall_clk_balloons_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.clk_balloons_logic = function()
  ObjSet("gfx_onthewall_clk_bow_zone",{visible=1,active=1,input=1})
end;
private.clk_balloons_beg = function()
  ObjDelete( "gfx_onthewall_clk_balloons_zone" );
end;
private.clk_balloons_end = function()
  if common_impl.ZzCompleteCheck("clk_balloons") then ObjSet( common_impl.hint["clk_balloons"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm",{frame=999,animfunc="use_click_balloons"})
  ObjDelete("spr_onthewall_bow_tr")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_balloons", private.clk_balloons_beg, private.room_objname );
cmn.AddSubscriber( "clk_balloons", private.clk_balloons_end, private.room_objname );
cmn.AddSubscriber( "clk_balloons", private.clk_balloons_logic );
cmn.AddSubscriber( "clk_balloons_beg", private.clk_balloons_beg, private.room_objname );
cmn.AddSubscriber( "clk_balloons_end", private.clk_balloons_end, private.room_objname );
cmn.AddSubscriber( "clk_balloons_end", private.clk_balloons_logic );
--------------------------------------------------------------------------------------------
function public.clk_balloons()

  local func_end = function()
    cmn.SetEventDone( "clk_balloons" );
    cmn.CallEventHandler( "clk_balloons_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_balloons") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_balloons_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onthewall_anm", "use_click_balloons", func_end );
  SoundSfx( "aud_clk_cone" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_bow" ] = { type = "click", use_place = "gfx_onthewall_clk_bow_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.clk_bow_logic = function()
  ObjSet("gfx_onthewall_clk_bow1_zone",{visible=1,active=1,input=1})
end;
private.clk_bow_beg = function()
  ObjDelete( "gfx_onthewall_clk_bow_zone" );
end;
private.clk_bow_end = function()
  if common_impl.ZzCompleteCheck("clk_bow") then ObjSet( common_impl.hint["clk_bow"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm",{frame=999,animfunc="use_click_bow"})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_bow", private.clk_bow_beg, private.room_objname );
cmn.AddSubscriber( "clk_bow", private.clk_bow_end, private.room_objname );
cmn.AddSubscriber( "clk_bow", private.clk_bow_logic );
cmn.AddSubscriber( "clk_bow_beg", private.clk_bow_beg, private.room_objname );
cmn.AddSubscriber( "clk_bow_end", private.clk_bow_end, private.room_objname );
cmn.AddSubscriber( "clk_bow_end", private.clk_bow_logic );
--------------------------------------------------------------------------------------------
function public.clk_bow()

  local func_end = function()
    cmn.SetEventDone( "clk_bow" );
    cmn.CallEventHandler( "clk_bow_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_bow") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_bow_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onthewall_anm", "use_click_bow", func_end );
  SoundSfx( "aud_clk_tape" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_bow1" ] = { type = "click", use_place = "gfx_onthewall_clk_bow1_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.clk_bow1_logic = function()
  ObjSet("gfx_onthewall_clk_tape_zone",{visible=1,active=1,input=1})
end;
private.clk_bow1_beg = function()
  ObjDelete( "gfx_onthewall_clk_bow1_zone" );
end;
private.clk_bow1_end = function()
  if common_impl.ZzCompleteCheck("clk_bow1") then ObjSet( common_impl.hint["clk_bow1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm",{frame=999,animfunc="use_click_bow1"})
  ObjDelete("spr_onthewall_tape_idle")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_bow1", private.clk_bow1_beg, private.room_objname );
cmn.AddSubscriber( "clk_bow1", private.clk_bow1_end, private.room_objname );
cmn.AddSubscriber( "clk_bow1", private.clk_bow1_logic );
cmn.AddSubscriber( "clk_bow1_beg", private.clk_bow1_beg, private.room_objname );
cmn.AddSubscriber( "clk_bow1_end", private.clk_bow1_end, private.room_objname );
cmn.AddSubscriber( "clk_bow1_end", private.clk_bow1_logic );
--------------------------------------------------------------------------------------------
function public.clk_bow1()

  local func_end = function()
    cmn.SetEventDone( "clk_bow1" );
    cmn.CallEventHandler( "clk_bow1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_bow1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_bow1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onthewall_anm", "use_click_bow1", func_end );
  SoundSfx( "aud_make_knot" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_tape" ] = { type = "click", use_place = "gfx_onthewall_clk_tape_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.clk_tape_logic = function()
  ObjSet("gfx_onthewall_clk_snow_zone",{visible=1,active=1,input=1})
end;
private.clk_tape_beg = function()
  ObjDelete( "gfx_onthewall_clk_tape_zone" );
end;
private.clk_tape_end = function()
  if common_impl.ZzCompleteCheck("clk_tape") then ObjSet( common_impl.hint["clk_tape"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm",{frame=999,animfunc="use_click_tape"})
  ObjDelete("spr_onthewall_snow_idle")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_tape", private.clk_tape_beg, private.room_objname );
cmn.AddSubscriber( "clk_tape", private.clk_tape_end, private.room_objname );
cmn.AddSubscriber( "clk_tape", private.clk_tape_logic );
cmn.AddSubscriber( "clk_tape_beg", private.clk_tape_beg, private.room_objname );
cmn.AddSubscriber( "clk_tape_end", private.clk_tape_end, private.room_objname );
cmn.AddSubscriber( "clk_tape_end", private.clk_tape_logic );
--------------------------------------------------------------------------------------------
function public.clk_tape()

  local func_end = function()
    cmn.SetEventDone( "clk_tape" );
    cmn.CallEventHandler( "clk_tape_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_tape") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_tape_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onthewall_anm", "use_click_tape", func_end );
  SoundSfx( "aud_clk_tape2" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_snow" ] = { type = "click", use_place = "gfx_onthewall_clk_snow_zone", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.clk_snow_logic = function()
  --gfx_onthewall_clk_snow_zone
  ObjSet("anm_onthewall_anm",{input=1})
end;
private.clk_snow_beg = function()
  ObjDelete( "gfx_onthewall_clk_snow_zone" );
end;
private.clk_snow_end = function()
  if common_impl.ZzCompleteCheck("clk_snow") then ObjSet( common_impl.hint["clk_snow"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_onthewall_anm",{animfunc="end_christmaswreath",playing=true})
  ObjSet("gfx_onthewall_christmaswreath",{visible=1,active=1})
  ObjSet("spr_onthewall_book",{input=0})
  
  ObjDelete("spr_hall_wreath");
  ObjSet("spr_hall_christmaswreath",{visible=1}); 
  ObjDelete("spr_hall_wreath_stuff")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_snow", private.clk_snow_beg, private.room_objname );
cmn.AddSubscriber( "clk_snow", private.clk_snow_end, private.room_objname );
cmn.AddSubscriber( "clk_snow", private.clk_snow_logic );
cmn.AddSubscriber( "clk_snow_beg", private.clk_snow_beg, private.room_objname );
cmn.AddSubscriber( "clk_snow_end", private.clk_snow_end, private.room_objname );
cmn.AddSubscriber( "clk_snow_end", private.clk_snow_logic );
--------------------------------------------------------------------------------------------
function public.clk_snow()

  local func_end = function()
    cmn.SetEventDone( "clk_snow" );
    cmn.CallEventHandler( "clk_snow_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_snow") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_snow_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_onthewall_anm", "use_click_snow", func_end );
  SoundSfx( "aud_clk_bank_with_snow" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_lockpart4" ] = { type = "get", get_obj = "spr_onthewall_lockpart4", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.get_lockpart4_logic = function()
  
end;
private.get_lockpart4_inv = function()
  interface.InventoryItemAdd("inv_lockpart","spr_onthewall_lockpart4",function() level_inv.ProcessGetLockpartAll( "get_lockpart4" ) end);
end;
private.get_lockpart4_beg = function()
  ObjDelete("gfx_onthewall_lockpart4")
end;
private.get_lockpart4_end = function()
  ObjDelete("spr_hall_lockpart_wall")
  if common_impl.ZzCompleteCheck("get_lockpart4") then ObjSet( common_impl.hint["get_lockpart4"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lockpart4", private.get_lockpart4_inv );
cmn.AddSubscriber( "get_lockpart4", private.get_lockpart4_beg, private.room_objname );
cmn.AddSubscriber( "get_lockpart4", private.get_lockpart4_end, private.room_objname );
cmn.AddSubscriber( "get_lockpart4", private.get_lockpart4_logic );
--------------------------------------------------------------------
function public.get_lockpart4()
  cmn.SetEventDone( "get_lockpart4" );
  cmn.CallEventHandler( "get_lockpart4" );
  if common_impl.ZzCompleteCheck("get_lockpart4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_christmaswreath" ] = { type = "get", get_obj = "anm_onthewall_anm", room = "rm_hall", zz = "zz_onthewall", zz_gate = "gzz_hall_onthewall" };

private.get_christmaswreath_logic = function()
  ObjSet("spr_onthewall_lockpart4",{input=1})
end;
private.get_christmaswreath_inv = function()
  interface.InventoryItemAdd("inv_christmaswreath","anm_onthewall_anm");
end;
private.get_christmaswreath_beg = function()
  ObjDelete("gfx_onthewall_christmaswreath")
  
end;
private.get_christmaswreath_end = function()
  if common_impl.ZzCompleteCheck("get_christmaswreath") then ObjSet( common_impl.hint["get_christmaswreath"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("gfx_onthewall_lockpart4",{visible=1,active=1})
  ObjDelete("spr_hall_christmaswreath")
  ObjDelete("spr_onthewall_anm_shadow")
end;

cmn.AddSubscriber( "get_christmaswreath", private.get_christmaswreath_inv );
cmn.AddSubscriber( "get_christmaswreath", private.get_christmaswreath_beg, private.room_objname );
cmn.AddSubscriber( "get_christmaswreath", private.get_christmaswreath_end, private.room_objname );
cmn.AddSubscriber( "get_christmaswreath", private.get_christmaswreath_logic );
--------------------------------------------------------------------
function public.get_christmaswreath()
  cmn.SetEventDone( "get_christmaswreath" );
  cmn.CallEventHandler( "get_christmaswreath" );
  if common_impl.ZzCompleteCheck("get_christmaswreath") then ld.CloseSubRoom() end;
end


private.item_idle_name = {}
function public.item_idle(name)
  if not private.item_idle_name[name] then
    private.item_idle_name[name] = true;
    local t = 0.5
    SoundSfx( "aud_xx_onthewall" )
    ObjAnimate(name, 8, 0, 0, function() private.item_idle_name[name]=false; end, {0,1,0,  t*0.5,2,1,  t,0,0,  t+0.1,0,0});
  end
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_sewingmachine *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_lockpart1" ] = { type = "get", get_obj = "spr_sewingmachine_lockpart1", room = "rm_hall", zz = "zz_sewingmachine", zz_gate = "gzz_hall_sewingmachine" };

private.get_lockpart1_logic = function()
  
end;
private.get_lockpart1_inv = function()
  interface.InventoryItemAdd("inv_lockpart","spr_sewingmachine_lockpart1",function() level_inv.ProcessGetLockpartAll( "get_lockpart1" ) end);
end;
private.get_lockpart1_beg = function()
  ObjDelete("gfx_sewingmachine_lockpart1")
end;
private.get_lockpart1_end = function()
  if common_impl.ZzCompleteCheck("get_lockpart1") then ObjSet( common_impl.hint["get_lockpart1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sewingmachine_lockpart1_shadow")
  ObjDelete("spr_hall_lockpart1")
end;

cmn.AddSubscriber( "get_lockpart1", private.get_lockpart1_inv );
cmn.AddSubscriber( "get_lockpart1", private.get_lockpart1_beg, private.room_objname );
cmn.AddSubscriber( "get_lockpart1", private.get_lockpart1_end, private.room_objname );
cmn.AddSubscriber( "get_lockpart1", private.get_lockpart1_logic );
--------------------------------------------------------------------
function public.get_lockpart1()
  cmn.SetEventDone( "get_lockpart1" );
  cmn.CallEventHandler( "get_lockpart1" );
  if common_impl.ZzCompleteCheck("get_lockpart1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_santasrendeer" ] = { type = "use", inv_obj = "inv_santasrendeer", use_place = "gfx_sewingmachine_santasrendeer_zone", room = "rm_hall", zz = "zz_sewingmachine", zz_gate = "gzz_hall_sewingmachine" };

private.use_santasrendeer_logic = function()
  ObjSet( "spr_sewingmachine_buttons", { visible = 1, input = 1, active = 1 } )

end;
private.use_santasrendeer_inv = function()
  common_impl.ProcessMultiUseAll("santasrendeer", "santasrendeer")
end;
private.use_santasrendeer_beg = function()
  ObjDelete( "gfx_sewingmachine_santasrendeer_zone" );
end;
private.use_santasrendeer_end = function()
  if common_impl.ZzCompleteCheck("use_santasrendeer") then ObjSet( common_impl.hint["use_santasrendeer"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_sewingmachine_anim_use_deer");
  ObjDelete("spr_hall_cover_box")
  ObjDelete("spr_hall_tr_deer")
  ObjSet("spr_hall_box_cover_off",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_santasrendeer", private.use_santasrendeer_inv );
cmn.AddSubscriber( "use_santasrendeer", private.use_santasrendeer_beg, private.room_objname );
cmn.AddSubscriber( "use_santasrendeer", private.use_santasrendeer_end, private.room_objname );
cmn.AddSubscriber( "use_santasrendeer", private.use_santasrendeer_logic );
cmn.AddSubscriber( "use_santasrendeer_inv", private.use_santasrendeer_inv, private.room_objname );
cmn.AddSubscriber( "use_santasrendeer_beg", private.use_santasrendeer_beg, private.room_objname );
cmn.AddSubscriber( "use_santasrendeer_end", private.use_santasrendeer_end, private.room_objname );
cmn.AddSubscriber( "use_santasrendeer_end", private.use_santasrendeer_logic );
--------------------------------------------------------------------------------------------
function public.use_santasrendeer( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_santasrendeer" );
    cmn.CallEventHandler( "use_santasrendeer_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_santasrendeer") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_santasrendeer_inv" );
  cmn.CallEventHandler( "use_santasrendeer_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewingmachine_anim_use_deer", "use_deer", func_end );
  SoundSfx( "aud_santas_reindeer" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_buttons" ] = { type = "get", get_obj = "spr_sewingmachine_buttons", room = "rm_hall", zz = "zz_sewingmachine", zz_gate = "gzz_hall_sewingmachine" };

private.get_buttons_logic = function()
  
end;
private.get_buttons_inv = function()
  interface.InventoryItemAdd("inv_buttons","spr_sewingmachine_buttons");
end;
private.get_buttons_beg = function()
  ObjDelete("gfx_sewingmachine_buttons")
end;
private.get_buttons_end = function()
  if common_impl.ZzCompleteCheck("get_buttons") then ObjSet( common_impl.hint["get_buttons"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sewingmachine_buttons_shadow")
  ObjDelete("spr_hall_buttons")
end;

cmn.AddSubscriber( "get_buttons", private.get_buttons_inv );
cmn.AddSubscriber( "get_buttons", private.get_buttons_beg, private.room_objname );
cmn.AddSubscriber( "get_buttons", private.get_buttons_end, private.room_objname );
cmn.AddSubscriber( "get_buttons", private.get_buttons_logic );
--------------------------------------------------------------------
function public.get_buttons()
  cmn.SetEventDone( "get_buttons" );
  cmn.CallEventHandler( "get_buttons" );
  if common_impl.ZzCompleteCheck("get_buttons") then ld.CloseSubRoom() end;
  if port.isPortable()==1 then
    iOS_RateMe();
  end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_solvent" ] = { type = "use", inv_obj = "inv_solvent", use_place = "gfx_sewingmachine_solvent_zone", room = "rm_hall", zz = "zz_sewingmachine", zz_gate = "gzz_hall_sewingmachine" };

private.use_solvent_logic = function()
  if ld.CheckRequirements( {"use_solvent","use_wadding"} ) then
    --ObjSet( "spr_sewingmachine_insulatingtape", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_sewingmachine_needlthreads", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_solvent_inv = function()
  common_impl.ProcessMultiUseAll("solvent", "solvent")
end;
private.use_solvent_beg = function()
  ObjDelete( "gfx_sewingmachine_solvent_zone" );
end;
private.use_solvent_end = function()
  if common_impl.ZzCompleteCheck("use_solvent") then ObjSet( common_impl.hint["use_solvent"].zz_gate, { visible = 0, input = 0 } ); end;
  
  if ld.CheckRequirements(  {"use_wadding","use_solvent"} ) then
    ObjDelete("anm_sewingmachine_use_vata_1")
    ObjDelete("anm_sewingmachine_use_detergent_1")
    ObjSet("anm_sewingmachine_anim_open_cover",{animfunc="open_cover",frame=999})  
    
    ObjDelete("spr_hall_rust")
    ObjDelete("spr_hall_cover")
    ObjSet("spr_hall_cover_opened",{visible=1})
    
    ObjDelete("spr_hall_detergent")
    ObjDelete("spr_hall_vata")
  else
    ObjSet("anm_sewingmachine_use_detergent_1",{frame=999,animfunc="use_detergent_1"})
    ObjSet("spr_hall_detergent",{visible=1})
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_solvent", private.use_solvent_inv );
cmn.AddSubscriber( "use_solvent", private.use_solvent_beg, private.room_objname );
cmn.AddSubscriber( "use_solvent", private.use_solvent_end, private.room_objname );
cmn.AddSubscriber( "use_solvent", private.use_solvent_logic );
cmn.AddSubscriber( "use_solvent_inv", private.use_solvent_inv, private.room_objname );
cmn.AddSubscriber( "use_solvent_beg", private.use_solvent_beg, private.room_objname );
cmn.AddSubscriber( "use_solvent_end", private.use_solvent_end, private.room_objname );
cmn.AddSubscriber( "use_solvent_end", private.use_solvent_logic );
--------------------------------------------------------------------------------------------
function public.use_solvent( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_solvent" );
    cmn.CallEventHandler( "use_solvent_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_solvent") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_solvent_inv" );
  cmn.CallEventHandler( "use_solvent_beg" );
  common_impl.Lock(1);

  

  if ld.CheckRequirements( {"use_wadding"} ) then
    SoundSfx( "aud_use_wadding" )
    ld.AnimPlay( "anm_sewingmachine_use_vata_1", "use_detergent_2", function()
      ObjDelete("anm_sewingmachine_use_vata_1")
      ObjDelete("anm_sewingmachine_use_detergent_1")
      ld.AnimPlay("anm_sewingmachine_anim_open_cover","open_cover", func_end)
    end );
  else
    SoundSfx( "aud_solvent" )
    ld.AnimPlay( "anm_sewingmachine_use_detergent_1", "use_detergent_1", func_end );
  end
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wadding" ] = { type = "use", inv_obj = "inv_wadding", use_place = "gfx_sewingmachine_wadding_zone", room = "rm_hall", zz = "zz_sewingmachine", zz_gate = "gzz_hall_sewingmachine" };

private.use_wadding_logic = function()
  if ld.CheckRequirements( {"use_wadding","use_solvent"} ) then
    --ObjSet( "spr_sewingmachine_insulatingtape", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_sewingmachine_needlthreads", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_wadding_inv = function()
  common_impl.ProcessMultiUseAll("wadding", "wadding")
end;
private.use_wadding_beg = function()
  ObjDelete( "gfx_sewingmachine_wadding_zone" );
end;
private.use_wadding_end = function()
  if common_impl.ZzCompleteCheck("use_wadding") then ObjSet( common_impl.hint["use_wadding"].zz_gate, { visible = 0, input = 0 } ); end;
  
  if ld.CheckRequirements(  {"use_wadding","use_solvent"} ) then
    ObjDelete("anm_sewingmachine_use_vata_1")
    ObjDelete("anm_sewingmachine_use_detergent_1")
    ObjDelete("spr_hall_vata")
    ObjDelete("spr_hall_detergent")
    
    ObjDelete("spr_hall_rust")
    ObjDelete("spr_hall_cover")
    ObjSet("spr_hall_cover_opened",{visible=1})
    
    ObjSet("anm_sewingmachine_anim_open_cover",{animfunc="open_cover",frame=999})
  else
    ObjSet("anm_sewingmachine_use_vata_1",{frame=999,animfunc="use_vata_1"})
    ObjSet("spr_hall_vata",{visible=1})
  end
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wadding", private.use_wadding_inv );
cmn.AddSubscriber( "use_wadding", private.use_wadding_beg, private.room_objname );
cmn.AddSubscriber( "use_wadding", private.use_wadding_end, private.room_objname );
cmn.AddSubscriber( "use_wadding", private.use_wadding_logic );
cmn.AddSubscriber( "use_wadding_inv", private.use_wadding_inv, private.room_objname );
cmn.AddSubscriber( "use_wadding_beg", private.use_wadding_beg, private.room_objname );
cmn.AddSubscriber( "use_wadding_end", private.use_wadding_end, private.room_objname );
cmn.AddSubscriber( "use_wadding_end", private.use_wadding_logic );
--------------------------------------------------------------------------------------------
function public.use_wadding( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wadding" );
    cmn.CallEventHandler( "use_wadding_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wadding") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wadding_inv" );
  cmn.CallEventHandler( "use_wadding_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()

  if ld.CheckRequirements( {"use_solvent"} ) then
    SoundSfx( "aud_use_wadding" )
    ld.AnimPlay( "anm_sewingmachine_use_detergent_1", "use_vata_2", function()
      ObjDelete("anm_sewingmachine_use_vata_1")
      ObjDelete("anm_sewingmachine_use_detergent_1")
      ld.AnimPlay("anm_sewingmachine_anim_open_cover","open_cover", func_end)
    end );
  else
    SoundSfx( "aud_absorbent_cotton" )
    ld.AnimPlay( "anm_sewingmachine_use_vata_1", "use_vata_1", func_end );
  end
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_insulatingtape" ] = { type = "get", get_obj = "spr_sewingmachine_insulatingtape", room = "rm_hall", zz = "zz_sewingmachine", zz_gate = "gzz_hall_sewingmachine" };

private.get_insulatingtape_logic = function()
  
end;
private.get_insulatingtape_inv = function()
  interface.InventoryItemAdd("inv_insulatingtape","spr_sewingmachine_insulatingtape");
end;
private.get_insulatingtape_beg = function()
  ObjDelete("gfx_sewingmachine_insulatingtape")
end;
private.get_insulatingtape_end = function()
  if common_impl.ZzCompleteCheck("get_insulatingtape") then ObjSet( common_impl.hint["get_insulatingtape"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sewingmachine_insulatingtape_shadow")
end;

cmn.AddSubscriber( "get_insulatingtape", private.get_insulatingtape_inv );
cmn.AddSubscriber( "get_insulatingtape", private.get_insulatingtape_beg, private.room_objname );
cmn.AddSubscriber( "get_insulatingtape", private.get_insulatingtape_end, private.room_objname );
cmn.AddSubscriber( "get_insulatingtape", private.get_insulatingtape_logic );
--------------------------------------------------------------------
function public.get_insulatingtape()
  cmn.SetEventDone( "get_insulatingtape" );
  cmn.CallEventHandler( "get_insulatingtape" );
  if common_impl.ZzCompleteCheck("get_insulatingtape") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_needlthreads" ] = { type = "get", get_obj = "spr_sewingmachine_needlthreads", room = "rm_hall", zz = "zz_sewingmachine", zz_gate = "gzz_hall_sewingmachine" };

private.get_needlthreads_logic = function()
  ObjSet( "spr_sewingmachine_insulatingtape", { visible = 1, input = 1, active = 1 } )
end;
private.get_needlthreads_inv = function()
  interface.InventoryItemAdd("inv_needlthreads","spr_sewingmachine_needlthreads");
end;
private.get_needlthreads_beg = function()
  ObjDelete("gfx_sewingmachine_needlthreads")
end;
private.get_needlthreads_end = function()
  if common_impl.ZzCompleteCheck("get_needlthreads") then ObjSet( common_impl.hint["get_needlthreads"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_sewingmachine_needlthreads_shadow")
end;

cmn.AddSubscriber( "get_needlthreads", private.get_needlthreads_inv );
cmn.AddSubscriber( "get_needlthreads", private.get_needlthreads_beg, private.room_objname );
cmn.AddSubscriber( "get_needlthreads", private.get_needlthreads_end, private.room_objname );
cmn.AddSubscriber( "get_needlthreads", private.get_needlthreads_logic );
--------------------------------------------------------------------
function public.get_needlthreads()
  cmn.SetEventDone( "get_needlthreads" );
  cmn.CallEventHandler( "get_needlthreads" );
  if common_impl.ZzCompleteCheck("get_needlthreads") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cabinetdoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_titmouse" ] = { type = "get", get_obj = "spr_cabinetdoor_titmouse", room = "rm_hall", zz = "zz_cabinetdoor", zz_gate = "gzz_hall_cabinetdoor" };

private.get_titmouse_logic = function()
  
end;
private.get_titmouse_inv = function()
  interface.InventoryItemAdd("inv_titmouse","spr_cabinetdoor_titmouse");
end;
private.get_titmouse_beg = function()
  ObjDelete("gfx_cabinetdoor_titmouse")
end;
private.get_titmouse_end = function()
  if common_impl.ZzCompleteCheck("get_titmouse") then ObjSet( common_impl.hint["get_titmouse"].zz_gate, { visible = 0, input = 0 } ); end;
  if not private.spr_cabinetdoor_chain_fading then
    ObjDelete("spr_cabinetdoor_chain")
  end
  ObjDelete("spr_hall_bird")
end;

cmn.AddSubscriber( "get_titmouse", private.get_titmouse_inv );
cmn.AddSubscriber( "get_titmouse", private.get_titmouse_beg, private.room_objname );
cmn.AddSubscriber( "get_titmouse", private.get_titmouse_end, private.room_objname );
cmn.AddSubscriber( "get_titmouse", private.get_titmouse_logic );
--------------------------------------------------------------------
function public.get_titmouse()
  
  private.spr_cabinetdoor_chain_fading = true;
  ObjAnimate("spr_cabinetdoor_chain", 8, 0, 0, function() ObjDelete("spr_cabinetdoor_chain"); end, {0, 0, 1, 0.3, 0, 0});
  
  cmn.SetEventDone( "get_titmouse" );
  cmn.CallEventHandler( "get_titmouse" );
  if common_impl.ZzCompleteCheck("get_titmouse") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
-------------------------------------------------------------------------------------------- 
common_impl.hint[ "use_lockpart" ] = { type = "use", inv_obj = "inv_lockpart", use_place = "gfx_cabinetdoor_lockpart_zone", room = "rm_hall", zz = "zz_cabinetdoor", zz_gate = "gzz_hall_cabinetdoor" };

private.use_lockpart_logic = function()
  ObjSet( "grm_hall_cabinet", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_hall_cabinet_focus");
    end;
end;
private.use_lockpart_inv = function()
  common_impl.ProcessMultiUseAll("lockpart", "lockpart")
end;
private.use_lockpart_beg = function()
  ObjDelete( "gfx_cabinetdoor_lockpart_zone" );
end;
private.use_lockpart_end = function()
  if common_impl.ZzCompleteCheck("use_lockpart") then ObjSet( common_impl.hint["use_lockpart"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_cabinetdoor_anm",{animfunc="use_lockpar",frame=999})
  ObjSet("anm_hall_anim_open_door",{animfunc="open_door",frame=999})
  ObjDelete("spr_hall_door_closed")
  --ObjDelete("spr_hall_door_closed")
  --ObjSet("spr_hall_door_opened",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lockpart", private.use_lockpart_inv );
cmn.AddSubscriber( "use_lockpart", private.use_lockpart_beg, private.room_objname );
cmn.AddSubscriber( "use_lockpart", private.use_lockpart_end, private.room_objname );
cmn.AddSubscriber( "use_lockpart", private.use_lockpart_logic );
cmn.AddSubscriber( "use_lockpart_inv", private.use_lockpart_inv, private.room_objname );
cmn.AddSubscriber( "use_lockpart_beg", private.use_lockpart_beg, private.room_objname );
cmn.AddSubscriber( "use_lockpart_end", private.use_lockpart_end, private.room_objname );
cmn.AddSubscriber( "use_lockpart_end", private.use_lockpart_logic );
--------------------------------------------------------------------------------------------
function public.use_lockpart( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lockpart" );
    cmn.CallEventHandler( "use_lockpart_end" );
    common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_lockpart") then ld.CloseSubRoom() end;
  end;
  
  local func_pre_end = function()
    ld.CloseSubRoom();
    --local t_offset = 0.3;
    --local t = 0.4;
    --ObjSet("spr_hall_door_opened",{visible=1,alp=0})
    --ObjAnimate("spr_hall_door_closed", 8, 0, 0, func_end, {0,0,1,  t_offset,0,1,  t+t_offset,0,0});
    --ObjAnimate("spr_hall_door_opened", 8, 0, 0, "",       {0,0,0,  t_offset,0,0,  t+t_offset,0,1});
    ld.StartTimer( 0.3, function() ld.AnimPlay("anm_hall_anim_open_door","open_door",func_end); end);
  end

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lockpart_inv" );
  cmn.CallEventHandler( "use_lockpart_beg" );
  common_impl.Lock(1);

  ObjDelete("spr_hall_door_closed")
  ld.AnimPlay( "anm_cabinetdoor_anm", "use_lockpar", func_pre_end );
  SoundSfx( "aud_lock_parts" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cupboard *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_thongs" ] = { type = "get", get_obj = "spr_cupboard_thongs", room = "rm_hall", zz = "zz_cupboard", zz_gate = "gzz_hall_cupboard" };

private.get_thongs_logic = function()
  
end;
private.get_thongs_inv = function()
  interface.InventoryItemAdd("inv_thongs","spr_cupboard_thongs");
end;
private.get_thongs_beg = function()
  ObjDelete("gfx_cupboard_thongs")
end;
private.get_thongs_end = function()
  if common_impl.ZzCompleteCheck("get_thongs") then ObjSet( common_impl.hint["get_thongs"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cupboard_thongs_shadow");
  ObjDelete("spr_hall_thongs");
end;

cmn.AddSubscriber( "get_thongs", private.get_thongs_inv );
cmn.AddSubscriber( "get_thongs", private.get_thongs_beg, private.room_objname );
cmn.AddSubscriber( "get_thongs", private.get_thongs_end, private.room_objname );
cmn.AddSubscriber( "get_thongs", private.get_thongs_logic );
--------------------------------------------------------------------
function public.get_thongs()
  cmn.SetEventDone( "get_thongs" );
  cmn.CallEventHandler( "get_thongs" );
  if common_impl.ZzCompleteCheck("get_thongs") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_silverwing" ] = { type = "use", inv_obj = "inv_silverwing", use_place = "gfx_cupboard_silverwing_zone", room = "rm_hall", zz = "zz_cupboard", zz_gate = "gzz_hall_cupboard" };

private.use_silverwing_logic = function()
  --if ld.CheckRequirements( {"use_silverwing","use_butterfly"} ) then
    ObjSet( "spr_cupboard_brokenrackets", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_cupboard_bucket", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_cupboard_wadding", { visible = 1, input = 1, active = 1 } )
  --end;

end;
private.use_silverwing_inv = function()
  common_impl.ProcessMultiUseAll("silverwing", "silverwing")
end;
private.use_silverwing_beg = function()
  ObjDelete( "gfx_cupboard_silverwing_zone" );
end;
private.use_silverwing_end = function()
  if common_impl.ZzCompleteCheck("use_silverwing") then ObjSet( common_impl.hint["use_silverwing"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_cupboard_anim_use_silver_wing");
  ObjDelete("anm_cupboard_open_right_door");  
  ObjDelete("spr_hall_right_wing")
  ObjDelete("spr_hall_trash_butterfly_body")
  
  ObjSet("spr_hall_right_door_open",{visible=1})
  ObjDelete("spr_hall_right_door_closed")
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_silverwing", private.use_silverwing_inv );
cmn.AddSubscriber( "use_silverwing", private.use_silverwing_beg, private.room_objname );
cmn.AddSubscriber( "use_silverwing", private.use_silverwing_end, private.room_objname );
cmn.AddSubscriber( "use_silverwing", private.use_silverwing_logic );
cmn.AddSubscriber( "use_silverwing_inv", private.use_silverwing_inv, private.room_objname );
cmn.AddSubscriber( "use_silverwing_beg", private.use_silverwing_beg, private.room_objname );
cmn.AddSubscriber( "use_silverwing_end", private.use_silverwing_end, private.room_objname );
cmn.AddSubscriber( "use_silverwing_end", private.use_silverwing_logic );
--------------------------------------------------------------------------------------------
function public.use_silverwing( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_silverwing" );
    cmn.CallEventHandler( "use_silverwing_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_silverwing") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_silverwing_inv" );
  cmn.CallEventHandler( "use_silverwing_beg" );
  common_impl.Lock(1);
  
  ObjSet("anm_cupboard_open_right_door",{animfunc="idle_right_door_body",frame=0})
  ld.AnimPlay("anm_cupboard_anim_use_silver_wing","use_gold_wing",function()
    SoundSfx( "aud_cupboard_door_open" )
    ObjDelete("anm_cupboard_anim_use_silver_wing");
    ld.AnimPlay("anm_cupboard_open_right_door","open_right_door",func_end);  
  end)
  
  SoundSfx( "aud_silver_wing" )

end;
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_brokenrackets" ] = { type = "get", get_obj = "spr_cupboard_brokenrackets", room = "rm_hall", zz = "zz_cupboard", zz_gate = "gzz_hall_cupboard" };

private.get_brokenrackets_logic = function()
  
end;
private.get_brokenrackets_inv = function()
  interface.InventoryItemAdd("inv_brokenrackets","spr_cupboard_brokenrackets");
  ObjSet( "inv_brokenrackets", { drag = 0 } );
end;
private.get_brokenrackets_beg = function()
  ObjDelete("gfx_cupboard_brokenrackets")
end;
private.get_brokenrackets_end = function()
  if common_impl.ZzCompleteCheck("get_brokenrackets") then ObjSet( common_impl.hint["get_brokenrackets"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cupboard_brokenrackets_shadow")
  ObjDelete("spr_hall_brokenrackets")
end;

cmn.AddSubscriber( "get_brokenrackets", private.get_brokenrackets_inv );
cmn.AddSubscriber( "get_brokenrackets", private.get_brokenrackets_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenrackets", private.get_brokenrackets_end, private.room_objname );
cmn.AddSubscriber( "get_brokenrackets", private.get_brokenrackets_logic );
--------------------------------------------------------------------
function public.get_brokenrackets()
  cmn.SetEventDone( "get_brokenrackets" );
  cmn.CallEventHandler( "get_brokenrackets" );
  if common_impl.ZzCompleteCheck("get_brokenrackets") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bucket" ] = { type = "get", get_obj = "spr_cupboard_bucket", room = "rm_hall", zz = "zz_cupboard", zz_gate = "gzz_hall_cupboard" };

private.get_bucket_logic = function()
  
end;
private.get_bucket_inv = function()
  interface.InventoryItemAdd("inv_bucket","spr_cupboard_bucket");
end;
private.get_bucket_beg = function()
  ObjDelete("gfx_cupboard_bucket")
end;
private.get_bucket_end = function()
  if common_impl.ZzCompleteCheck("get_bucket") then ObjSet( common_impl.hint["get_bucket"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cupboard_bucket_shadow")
  ObjDelete("spr_hall_bucket")
end;

cmn.AddSubscriber( "get_bucket", private.get_bucket_inv );
cmn.AddSubscriber( "get_bucket", private.get_bucket_beg, private.room_objname );
cmn.AddSubscriber( "get_bucket", private.get_bucket_end, private.room_objname );
cmn.AddSubscriber( "get_bucket", private.get_bucket_logic );
--------------------------------------------------------------------
function public.get_bucket()
  cmn.SetEventDone( "get_bucket" );
  cmn.CallEventHandler( "get_bucket" );
  if common_impl.ZzCompleteCheck("get_bucket") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wadding" ] = { type = "get", get_obj = "spr_cupboard_wadding", room = "rm_hall", zz = "zz_cupboard", zz_gate = "gzz_hall_cupboard" };

private.get_wadding_logic = function()
  
end;
private.get_wadding_inv = function()
  interface.InventoryItemAdd("inv_wadding","spr_cupboard_wadding");
end;
private.get_wadding_beg = function()
  ObjDelete("gfx_cupboard_wadding")
end;
private.get_wadding_end = function()
  if common_impl.ZzCompleteCheck("get_wadding") then ObjSet( common_impl.hint["get_wadding"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cupboard_wadding_shadow")
  ObjDelete("spr_hall_wadding")
end;

cmn.AddSubscriber( "get_wadding", private.get_wadding_inv );
cmn.AddSubscriber( "get_wadding", private.get_wadding_beg, private.room_objname );
cmn.AddSubscriber( "get_wadding", private.get_wadding_end, private.room_objname );
cmn.AddSubscriber( "get_wadding", private.get_wadding_logic );
--------------------------------------------------------------------
function public.get_wadding()
  cmn.SetEventDone( "get_wadding" );
  cmn.CallEventHandler( "get_wadding" );
  if common_impl.ZzCompleteCheck("get_wadding") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goldenwing" ] = { type = "use", inv_obj = "inv_goldenwing", use_place = "gfx_cupboard_goldenwing_zone", room = "rm_hall", zz = "zz_cupboard", zz_gate = "gzz_hall_cupboard" };

private.use_goldenwing_logic = function()
  ObjSet( "spr_cupboard_smallaxe", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_cupboard_photo3", { visible = 1, input = 1, active = 1 } )

end;
private.use_goldenwing_inv = function()
  common_impl.ProcessMultiUseAll("goldenwing", "goldenwing")
end;
private.use_goldenwing_beg = function()
  ObjDelete( "gfx_cupboard_goldenwing_zone" );
end;
private.use_goldenwing_end = function()
  if common_impl.ZzCompleteCheck("use_goldenwing") then ObjSet( common_impl.hint["use_goldenwing"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_cupboard_anim_use_goldenwing")
  ObjDelete("spr_hall_left_door_closed")
  ObjSet("spr_hall_left_door_open",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goldenwing", private.use_goldenwing_inv );
cmn.AddSubscriber( "use_goldenwing", private.use_goldenwing_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenwing", private.use_goldenwing_end, private.room_objname );
cmn.AddSubscriber( "use_goldenwing", private.use_goldenwing_logic );
cmn.AddSubscriber( "use_goldenwing_inv", private.use_goldenwing_inv, private.room_objname );
cmn.AddSubscriber( "use_goldenwing_beg", private.use_goldenwing_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenwing_end", private.use_goldenwing_end, private.room_objname );
cmn.AddSubscriber( "use_goldenwing_end", private.use_goldenwing_logic );
--------------------------------------------------------------------------------------------
function public.use_goldenwing( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_goldenwing" );
    cmn.CallEventHandler( "use_goldenwing_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_goldenwing") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goldenwing_inv" );
  cmn.CallEventHandler( "use_goldenwing_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_silver_wing" )
  ld.StartTimer( 0.44, function() SoundSfx( "aud_cupboard_door_open" ) end )
  ld.AnimPlay( "anm_cupboard_anim_use_goldenwing", "use_silver_wing", func_end );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_smallaxe" ] = { type = "get", get_obj = "spr_cupboard_smallaxe", room = "rm_hall", zz = "zz_cupboard", zz_gate = "gzz_hall_cupboard" };

private.get_smallaxe_logic = function()
  
end;
private.get_smallaxe_inv = function()
  interface.InventoryItemAdd("inv_smallaxe","spr_cupboard_smallaxe");
end;
private.get_smallaxe_beg = function()
  ObjDelete("gfx_cupboard_smallaxe")
end;
private.get_smallaxe_end = function()
  if common_impl.ZzCompleteCheck("get_smallaxe") then ObjSet( common_impl.hint["get_smallaxe"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cupboard_smallaxe_shadow");
  ObjDelete("spr_hall_smallaxe");
end;

cmn.AddSubscriber( "get_smallaxe", private.get_smallaxe_inv );
cmn.AddSubscriber( "get_smallaxe", private.get_smallaxe_beg, private.room_objname );
cmn.AddSubscriber( "get_smallaxe", private.get_smallaxe_end, private.room_objname );
cmn.AddSubscriber( "get_smallaxe", private.get_smallaxe_logic );
--------------------------------------------------------------------
function public.get_smallaxe()
  cmn.SetEventDone( "get_smallaxe" );
  cmn.CallEventHandler( "get_smallaxe" );
  if common_impl.ZzCompleteCheck("get_smallaxe") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_photo3" ] = { type = "get", get_obj = "spr_cupboard_photo3", room = "rm_hall", zz = "zz_cupboard", zz_gate = "gzz_hall_cupboard" };

private.get_photo3_logic = function()
  
end;
private.get_photo3_inv = function()
  interface.InventoryItemAdd("inv_photo","spr_cupboard_photo3",function() level_inv.ProcessGetPhotoAll( "get_photo3" ) end);
end;
private.get_photo3_beg = function()
  ObjDelete("gfx_cupboard_photo3")
end;
private.get_photo3_end = function()
  if common_impl.ZzCompleteCheck("get_photo3") then ObjSet( common_impl.hint["get_photo3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cupboard_photo3_shadow")
  ObjDelete("spr_hall_photo3")
end;

cmn.AddSubscriber( "get_photo3", private.get_photo3_inv );
cmn.AddSubscriber( "get_photo3", private.get_photo3_beg, private.room_objname );
cmn.AddSubscriber( "get_photo3", private.get_photo3_end, private.room_objname );
cmn.AddSubscriber( "get_photo3", private.get_photo3_logic );
--------------------------------------------------------------------
function public.get_photo3()
  cmn.SetEventDone( "get_photo3" );
  cmn.CallEventHandler( "get_photo3" );
  if common_impl.ZzCompleteCheck("get_photo3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_underfirtreeho_for_hall = function()
    if ld.CheckRequirements( {"win_underfirtreeho"} ) then
      ObjSet( "gho_hall_underfirtreeho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_underfirtreeho", win_underfirtreeho_for_hall, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_hall();
  level.tutorial_map1.first()
  level.tutorial_hosparkles.first()

end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_hall_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_cupboard" );
  function zz_cupboard.Open()
  end;
  function zz_cupboard.PreOpen()
  end;
  function zz_cupboard.PreClose()
  end;
  function zz_cupboard.Close()
  end;

  subroom.Define( "zz_underfirtree" );
  function zz_underfirtree.Open()
  end;
  function zz_underfirtree.PreOpen()
  end;
  function zz_underfirtree.PreClose()
  end;
  function zz_underfirtree.Close()
  end;

  subroom.Define( "zz_cabinetdoor" );
  function zz_cabinetdoor.Open()
  end;
  function zz_cabinetdoor.PreOpen()
  end;
  function zz_cabinetdoor.PreClose()
  end;
  function zz_cabinetdoor.Close()
  end;

  subroom.Define( "zz_sewingmachine" );
  function zz_sewingmachine.Open()
  end;
  function zz_sewingmachine.PreOpen()
  end;
  function zz_sewingmachine.PreClose()
  end;
  function zz_sewingmachine.Close()
  end;

  subroom.Define( "zz_onthewall" );
  function zz_onthewall.Open()
  end;
  function zz_onthewall.PreOpen()
  end;
  function zz_onthewall.PreClose()
  end;
  function zz_onthewall.Close()
  end;
  
end;
--*********************************************************************************************************************