-- name=rm_newhall
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_newhall";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("anm_newfireplace_anm_paper", "spr_newfireplace_paper_big", "txt_newfireplace_paper")
  ld.NoteInit("spr_newhall_label_stand", "spr_newhall_tape_big", "txt_cerber_note","","")
  ld.NoteRelaseLock("anm_newfireplace_anm_paper")
  --------------------------------------------------------------------------------------------
  SoundEnvInit( "aud_cerber_env", "rm_newhall", { "opn_newhall" }, { "win_cerber" } )
  SoundEnvInit( "aud_zz_cerber_env", "zz_cerber", { "opn_newhall" }, { "win_cerber" } )
  --------------------------------------------------------------------------------------------
function private.opn_newhall()
  if not ( cmn.IsEventDone( "opn_newhall" ) ) then
    local func_end = function()
        ld.Lock(0)
        common_impl.SetWidgetsVisible( "DialogVideoShow", true )
        cmn.SetEventDone( "opn_newhall" );
        cmn.CallEventHandler( "opn_newhall_end" )
        ld.ShowBbtOpn( private.room_objname )
      SoundEnv( "aud_cerber_env", 1 )
    end;
    local func_end_2 = function()
      ld.Lock(1)
      cmn.CallEventHandler( "opn_newhall_beg" )
      int.DialogVideoHide();
      VidPause( "vid_newhall_vid_open", 1 )
      ObjAnimate( "vid_newhall_vid_open", 8,0,0, func_end, { 0,0,1, 0.3,0,0 } )
    end
    int.DialogVideoShow( "", 1, func_end_2, 1 );
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_vid_newhall_vid_open_1" , aud_voc_false, 0, 10 };
      { "srt_vid_newhall_vid_open_2" , aud_voc_false, 11.5, 20 };
    } );
    ]]
    SoundVid( "aud_berta_casket" );
    SoundVoice( "aud_berta_casket_voc" );
    VidPlay("vid_newhall_vid_open",func_end_2);
  end;
end;
--------------------------------------------------------------------
local opn_newhall_beg = function() 
  ObjDelete("spr_newhall_cerber_stand")
  ObjSet( "anm_newhall_anim_dog", {visible = 1} );
  ObjSet( "spr_newhall_casket", {visible = 1} );
  
end;
local opn_newhall_end = function() 

  ObjDelete("vid_newhall_vid_open")
end;
local opn_newhall_logic = function() end;
cmn.AddSubscriber( "opn_newhall", opn_newhall_logic )
cmn.AddSubscriber( "opn_newhall", opn_newhall_beg, private.room_objname )
cmn.AddSubscriber( "opn_newhall", opn_newhall_end, private.room_objname )

cmn.AddSubscriber( "opn_newhall_end", opn_newhall_logic )
cmn.AddSubscriber( "opn_newhall_beg", opn_newhall_beg, private.room_objname )
cmn.AddSubscriber( "opn_newhall_end", opn_newhall_end, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_cerber *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_letterscasket" ] = { type = "get", get_obj = "spr_cerber_letterscasket", room = "rm_newhall", zz = "zz_cerber", zz_gate = "gzz_newhall_cerber" };

private.get_letterscasket_logic = function()
  
end;
private.get_letterscasket_inv = function()
  interface.InventoryItemAdd("inv_letterscasket","spr_cerber_letterscasket");
  ObjSet( "inv_letterscasket", { drag = 0 } );
end;
private.get_letterscasket_beg = function()
  ObjDelete("gfx_cerber_letterscasket")
end;
private.get_letterscasket_end = function()
  ObjDelete("spr_newhall_casket")
  ObjDelete("spr_cerber_letterscasket_shadow")
  if common_impl.ZzCompleteCheck("get_letterscasket") then ObjSet( common_impl.hint["get_letterscasket"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_letterscasket", private.get_letterscasket_inv );
cmn.AddSubscriber( "get_letterscasket", private.get_letterscasket_beg, private.room_objname );
cmn.AddSubscriber( "get_letterscasket", private.get_letterscasket_end, private.room_objname );
cmn.AddSubscriber( "get_letterscasket", private.get_letterscasket_logic );
--------------------------------------------------------------------
function public.get_letterscasket()
  cmn.SetEventDone( "get_letterscasket" );
  cmn.CallEventHandler( "get_letterscasket" );
  if common_impl.ZzCompleteCheck("get_letterscasket") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_magicpipe" ] = { type = "use", inv_obj = "inv_magicpipe", use_place = "gfx_cerber_magicpipe_zone", room = "rm_newhall", zz = "zz_cerber", zz_gate = "gzz_newhall_cerber" };

private.use_magicpipe_logic = function()
  ObjSet( "obj_cerber_win_cerber_zoom", { input = 1 } )
end;
private.use_magicpipe_inv = function()
  common_impl.ProcessMultiUseAll("magicpipe", "magicpipe")
end;
private.use_magicpipe_beg = function()
  ObjDelete( "gfx_cerber_magicpipe_zone" );
end;
private.use_magicpipe_end = function()
  ObjSet( "anm_cerber_anm", {animfunc = "pipe_static", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_magicpipe") then ObjSet( common_impl.hint["use_magicpipe"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_magicpipe", private.use_magicpipe_inv );
cmn.AddSubscriber( "use_magicpipe", private.use_magicpipe_beg, private.room_objname );
cmn.AddSubscriber( "use_magicpipe", private.use_magicpipe_end, private.room_objname );
cmn.AddSubscriber( "use_magicpipe", private.use_magicpipe_logic );
cmn.AddSubscriber( "use_magicpipe_inv", private.use_magicpipe_inv, private.room_objname );
cmn.AddSubscriber( "use_magicpipe_beg", private.use_magicpipe_beg, private.room_objname );
cmn.AddSubscriber( "use_magicpipe_end", private.use_magicpipe_end, private.room_objname );
cmn.AddSubscriber( "use_magicpipe_end", private.use_magicpipe_logic );
--------------------------------------------------------------------------------------------
function public.use_magicpipe( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_magicpipe" );
    cmn.CallEventHandler( "use_magicpipe_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_magicpipe") then ld.CloseSubRoom() end;
    cmn.MiniGameShow( "cerber" );
    public.win_cerber_load();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_magicpipe_inv" );
  cmn.CallEventHandler( "use_magicpipe_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cerber_anm", "use_pipe", func_end );
  SoundSfx( "aud_use_magicpipe_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
local cerberloaded;
function public.win_cerber_load(reset,skip)
  if not private.win_cerber_gm and not ld.CheckRequirements( { "win_cerber" } ) then
    private.win_angels_gm = {}
    local gm = private.win_angels_gm

    local begstate = {3,3,3}
    local winstate = {1,1,1}  
    local min = 1;
    local max = 3;
    local animtime = 0.2;
    local arrows_names = {[-1] = "down", [1] = "up"}
    local arrows = {
      {-1,-1, 1},
      {-1, 1,-1},
      { 1,-1,-1}
    }

    if skip or reset then
      gm.oldstate = ld.TableCopy(ng_global.progress["std"]["win_cerber"].state)
    end
    if not ng_global.progress["std"]["win_cerber"].state or reset then
      ng_global.progress["std"]["win_cerber"].state = ld.TableCopy(begstate)
    end
    gm.state = ld.TableCopy(ng_global.progress["std"]["win_cerber"].state)

    local function load_map(skip)
      for i,o in ipairs(ObjGetRelations( "obj_cerber_win_cerber_heads" ).childs) do
        ObjSet( o, {alp = 0} );
      end
      local toload = skip and winstate or gm.state
      for i,o in ipairs(toload) do
        ObjSet( "obj_cerber_mmg_button_"..i, {
          event_mdown = function() gm.button_click(i) end,
          event_menter = function() gm.button_hover(i) end,
          event_mleave = function() gm.button_leave(i) end,  
        } ); 
   
        ObjSet( "anm_cerber_anm_"..i.."_"..o, {alp = 1} );
      end
      ObjSet( "obj_cerber_win_cerber_root", {event_mdown = function() public.win_cerber_load(1) end} );
    end

    function gm.button_hover(n)
      local time = animtime
      for i,o in ipairs(arrows[n]) do
        local obj = ObjGet("anm_cerber_win_cerber_arrows_"..i.."_"..arrows_names[o])
        ObjAnimate ( obj.name, 8, 0, 0, function() end, {0,0,obj.alp, time,0,1} );
      end
      local light = ObjGet("spr_cerber_mmg_button_"..n)
      ObjAnimate( light.name, 8, 0, 0, function() end, {0,0,light.alp, time,0,1} );
      ld.ShCur(CURSOR_HAND)
    end
    function gm.button_leave(n)
      local time = animtime
      for i,o in ipairs(arrows[n]) do
        local obj = ObjGet("anm_cerber_win_cerber_arrows_"..i.."_"..arrows_names[o])
        ObjAnimate ( obj.name, 8, 0, 0, function() end, {0,0,obj.alp, time,0,0} );
      end
      local light = ObjGet("spr_cerber_mmg_button_"..n)
      ObjAnimate( light.name, 8, 0, 0, function() end, {0,0,light.alp, time,0,0} );
      ld.ShCur(CURSOR_DEFAULT)
    end

    --wincheck
    local function wincheck(skip)
      local function win()
        public.win_cerber()
      end
      if ld.TableEquals(gm.state,winstate) or skip then
        ld.Lock(1)
        win()
        if skip then
          return false
        else
          return true
        end
      else
        return false
      end
    end

    --load
    local function load(skip)
      load_map(skip)
    end
    local function chooseload(reset,skip)
      if reset or skip then
        local toload = skip and winstate or begstate
        local time = animtime
        for i,o in ipairs(toload) do
          local newval = toload[i]
          local oldstate = gm.oldstate[i]
          if oldstate ~= newval then
            ObjAnimate( "anm_cerber_anm_"..i.."_"..oldstate, 8, 0, 0, function() end, {0,0,1, time,1,0} );
            ObjAnimate( "anm_cerber_anm_"..i.."_"..newval, 8, 0, 0, function() end, {0,0,0, time,2,1} );
          end
        end
        ld.Lock(1)
        ld.StartTimer( time, function() ld.Lock(0) load(skip) wincheck(skip)  end )
      else
        load()
      end
    end
    chooseload(reset,skip)
    --save
    local function save(n)
      local time = animtime;

      local function trySleep() 
        for i,o in ipairs(gm.state) do
          if arrows[n][i] < 0 then
            local newval = gm.state[i] + arrows[n][i]
            local oldstate = gm.state[i]
            gm.state[i] = newval < min and min or newval
            if oldstate ~= gm.state[i] then
              ObjAnimate( "anm_cerber_anm_"..i.."_"..oldstate, 8, 0, 0, function() end, {0,0,1, time,1,0} );
              ObjAnimate( "anm_cerber_anm_"..i.."_"..gm.state[i], 8, 0, 0, function() end, {0,0,0, time,2,1} );
            end
          end
        end
      end
      local function tryAwake() 
        for i,o in ipairs(gm.state) do
          if arrows[n][i] > 0 then
            local newval = gm.state[i] + arrows[n][i]
            local oldstate = gm.state[i]
            gm.state[i] = newval > max and max or newval
             if oldstate ~= gm.state[i] then
              ObjAnimate( "anm_cerber_anm_"..i.."_"..oldstate, 8, 0, 0, function() end, {0,0,1, time,1,0} );
              ObjAnimate( "anm_cerber_anm_"..i.."_"..gm.state[i], 8, 0, 0, function() end, {0,0,0, time,2,1} );
            end
          end
        end
      end
      local function saveData() 
        ng_global.progress["std"]["win_cerber"].state = ld.TableCopy(gm.state)
      end
      ld.Lock(1)
      trySleep()
      ld.StartTimer( time+time, function()
        if wincheck() then
          ld.Lock(0)
          return;
        else
          tryAwake() 
          ld.StartTimer( time, function() 
            ld.Lock(0)
            saveData()
          end)
        end
      end )
      
    end  

    --public
    function gm.button_click(n)
      ld.Lock(1)
      SoundSfx( "aud_change_head_"..math.random( 1, 4 ) )
      ld.AnimPlay( "anm_cerber_anm_"..n, "button"..n, function() ld.Lock(0) save(n) end )
      --ld.StartTimer( 0.5, function() ld.Lock(0) save()   end )
      --ObjAnimate( obj, 8, 0, 0, function() end, {0,0,ObjGet(obj).alp, 0.5,0,(ng_global.progress["std"]["win_cerber"].state[1] + 1)/winstate[1]} );
    end

    cerberloaded = true;
  else
  end

  if ld.CheckRequirements( { "use_magicpipe" } ) and not ld.CheckRequirements( { "win_cerber" } ) then
    cmn.MiniGameShow( "cerber" );
    ObjSet( "obj_cerber_win_cerber_buttons", {visible = 1} );
    for i,o in ipairs(ObjGetRelations( "obj_cerber_win_cerber_arrows" ).childs) do
      ObjSet( o, {alp = 0} );
    end
  end
end

--------------------------------------------------------------------------------------------
common_impl.hint[ "win_cerber" ] = { type = "click", use_place = "obj_cerber_win_cerber_zoom", room = "rm_newhall", zz = "zz_cerber", zz_gate = "gzz_newhall_cerber" };

private.win_cerber_logic = function()
  if ld.CheckRequirements( {"win_cerber"} ) then
    ObjSet( "grm_newhall_floor", {active = 1, input = 1, visible = 1} );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_newhall_floor_focus");
    end;
  end
end;
private.win_cerber_beg = function()
  if ld.CheckRequirements( {"win_cerber"} ) then
    ObjDelete( "gfx_cerber_win_cerber_zone" );
  end
end;
private.win_cerber_end = function()
  if ld.CheckRequirements( {"win_cerber"} ) then
    ObjDelete("anm_newhall_anim_dog")
    ObjSet( "anm_newhall_anim_dog_sleep", {visible = 1} );
    ObjDelete("anm_cerber_anm_body")
    ObjDelete("obj_cerber_win_cerber_heads")
    ObjDelete("obj_cerber_win_cerber_buttons")
    ObjSet( "obj_cerber_win_cerber_zoom", {input = 0} );
    ObjSet( "anm_cerber_anm", {animfunc = "dog_sleep_static", playing = 1, frame = 0 } );
    if common_impl.ZzCompleteCheck("win_cerber") then ObjSet( common_impl.hint["win_cerber"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_cerber", private.win_cerber_beg, private.room_objname );
cmn.AddSubscriber( "win_cerber", private.win_cerber_end, private.room_objname );
cmn.AddSubscriber( "win_cerber", private.win_cerber_logic );
cmn.AddSubscriber( "win_cerber_beg", private.win_cerber_beg, private.room_objname );
cmn.AddSubscriber( "win_cerber_end", private.win_cerber_end, private.room_objname );
cmn.AddSubscriber( "win_cerber_end", private.win_cerber_logic );
--------------------------------------------------------------------------------------------
function public.win_cerber()

  local func_end = function()
    cmn.SetEventDone( "win_cerber" );
    cmn.CallEventHandler( "win_cerber_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_cerber") then ld.CloseSubRoom() end;
    ld.AnimPlay( "anm_cerber_anm", "dog_sleep_static", _ )
  end;

  cmn.CallEventHandler( "win_cerber_beg" );
  common_impl.Lock(1)
  cmn.MiniGameHide( "cerber", true );

  ObjSet( "obj_cerber_win_cerber_zoom", {input = 0} );
  ObjDelete("anm_cerber_anm_body")
  ObjDelete("obj_cerber_win_cerber_heads")
  ObjSet( "obj_cerber_win_cerber_buttons", {visible = 0} );

  
  ld.AnimPlay( "anm_cerber_anm", "dog_sleep", func_end );
  SoundSfx( "aud_win_cerber" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_newfireplace *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_nimbus" ] = { type = "get", get_obj = "spr_newfireplace_nimbus", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.get_nimbus_logic = function()
  ObjSet( "gfx_newfireplace_seastar1_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "gfx_newfireplace_seastar2_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_nimbus_inv = function()
  interface.InventoryItemAdd("inv_nimbus","spr_newfireplace_nimbus");
end;
private.get_nimbus_beg = function()
  ObjDelete("gfx_newfireplace_nimbus")
end;
private.get_nimbus_end = function()
  ObjDelete("spr_newfireplace_nimbus_shadow")
  if common_impl.ZzCompleteCheck("get_nimbus") then ObjSet( common_impl.hint["get_nimbus"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_nimbus", private.get_nimbus_inv );
cmn.AddSubscriber( "get_nimbus", private.get_nimbus_beg, private.room_objname );
cmn.AddSubscriber( "get_nimbus", private.get_nimbus_end, private.room_objname );
cmn.AddSubscriber( "get_nimbus", private.get_nimbus_logic );
--------------------------------------------------------------------
function public.get_nimbus()
  cmn.SetEventDone( "get_nimbus" );
  cmn.CallEventHandler( "get_nimbus" );
  if common_impl.ZzCompleteCheck("get_nimbus") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_seastar1" ] = { type = "use", inv_obj = "inv_seastar1", use_place = "gfx_newfireplace_seastar1_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.use_seastar1_logic = function()
  if ld.CheckRequirements( {"use_seastar1","use_seastar2"} ) then
    ObjSet( "gfx_newfireplace_win_newfireplace_zone", { visible = 1, input = 1, active = 1 } )
    ld.mmgZoomInit("win_newfireplace");
  end;

end;
private.use_seastar1_inv = function()
  common_impl.ProcessMultiUseAll("seastar1", "seastar1")
end;
private.use_seastar1_beg = function()
  ObjDelete( "gfx_newfireplace_seastar1_zone" );
end;
private.use_seastar1_end = function()
  ObjDelete("anm_newfireplace_anm_box_star1")
  ObjSet( "spr_newfireplace_box_star_1", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_seastar1") then ObjSet( common_impl.hint["use_seastar1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_seastar1", private.use_seastar1_inv );
cmn.AddSubscriber( "use_seastar1", private.use_seastar1_beg, private.room_objname );
cmn.AddSubscriber( "use_seastar1", private.use_seastar1_end, private.room_objname );
cmn.AddSubscriber( "use_seastar1", private.use_seastar1_logic );
cmn.AddSubscriber( "use_seastar1_inv", private.use_seastar1_inv, private.room_objname );
cmn.AddSubscriber( "use_seastar1_beg", private.use_seastar1_beg, private.room_objname );
cmn.AddSubscriber( "use_seastar1_end", private.use_seastar1_end, private.room_objname );
cmn.AddSubscriber( "use_seastar1_end", private.use_seastar1_logic );
--------------------------------------------------------------------------------------------
function public.use_seastar1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_seastar1" );
    cmn.CallEventHandler( "use_seastar1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_seastar1") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_seastar1","use_seastar2"} ) then
      public.win_newfireplace_load()
      ObjGet( "gfx_newfireplace_win_newfireplace_zone" ).event_mdown()
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_seastar1_inv" );
  cmn.CallEventHandler( "use_seastar1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newfireplace_anm_box_star1", "use_star1", func_end );
  SoundSfx( "aud_use_seastar1_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_seastar2" ] = { type = "use", inv_obj = "inv_seastar2", use_place = "gfx_newfireplace_seastar2_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.use_seastar2_logic = function()
  if ld.CheckRequirements( {"use_seastar2","use_seastar1"} ) then
    ObjSet( "gfx_newfireplace_win_newfireplace_zone", { visible = 1, input = 1, active = 1 } )
    ld.mmgZoomInit("win_newfireplace");
  end;

end;
private.use_seastar2_inv = function()
  common_impl.ProcessMultiUseAll("seastar2", "seastar2")
end;
private.use_seastar2_beg = function()
  ObjDelete( "gfx_newfireplace_seastar2_zone" );
end;
private.use_seastar2_end = function()
  ObjDelete("anm_newfireplace_anm_box_star2")
  ObjSet( "spr_newfireplace_box_star_2", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_seastar2") then ObjSet( common_impl.hint["use_seastar2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_seastar2", private.use_seastar2_inv );
cmn.AddSubscriber( "use_seastar2", private.use_seastar2_beg, private.room_objname );
cmn.AddSubscriber( "use_seastar2", private.use_seastar2_end, private.room_objname );
cmn.AddSubscriber( "use_seastar2", private.use_seastar2_logic );
cmn.AddSubscriber( "use_seastar2_inv", private.use_seastar2_inv, private.room_objname );
cmn.AddSubscriber( "use_seastar2_beg", private.use_seastar2_beg, private.room_objname );
cmn.AddSubscriber( "use_seastar2_end", private.use_seastar2_end, private.room_objname );
cmn.AddSubscriber( "use_seastar2_end", private.use_seastar2_logic );
--------------------------------------------------------------------------------------------
function public.use_seastar2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_seastar2" );
    cmn.CallEventHandler( "use_seastar2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_seastar2") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_seastar2","use_seastar1"} ) then
      public.win_newfireplace_load()
      ObjGet( "gfx_newfireplace_win_newfireplace_zone" ).event_mdown()
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_seastar2_inv" );
  cmn.CallEventHandler( "use_seastar2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newfireplace_anm_box_star2", "use_star2", func_end );
  SoundSfx( "aud_use_seastar1_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
function public.win_newfireplace_load()

  if not private.win_newfireplace_gm then
    private.win_newfireplace_gm = {}
    local gm = private.win_newfireplace_gm

    local animtime = 0.2
    local rays = 5
    local angStep = math.floor(2*math.pi/rays * 10)/10
    local begstate = {0,0,0}
    local winstate = {4,4,2}
    local colors = {
                    ["red"] = {255,0,72};
                    ["yellow"] = {255,185,0};
                    ["blue"] = {0,173,255};
                    ["green"] = {0,255,71};
    }
    local starcolors = {
      {"green","blue","green","red","yellow"};
      {"yellow","green","blue","red","blue"};
      {"green","yellow","green","red","blue"};
    }
    local gems = 
    {
      {3,4};
      {1,5};
      {1,2};      
    }
    local gemsPic = 
    {
      {"1_2a","3_3b"};
      {"1_2b","2_3b"};
      {"3_3a","2_3a"};      
    }

    --local obj = "spr_newfireplace_win_newfireplace_test"
    if not ng_global.progress["std"]["win_newfireplace"].state then
      ng_global.progress["std"]["win_newfireplace"].state = ld.TableCopy(begstate)
    end
    gm.state = ld.TableCopy(ng_global.progress["std"]["win_newfireplace"].state)

    for i = 1,3 do
      ObjSet( "spr_newfireplace_"..i, {
        input = 1;
        event_mdown = function() gm.click(i) end;
        event_menter = function() ld.ShCur(CURSOR_HAND) end;
        event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end
      } );
    end

    
    function gm.ang_norm( ang )
      while ang > math.pi * 2 do ang = ang - math.pi * 2 end
      while ang < 0 do ang = ang + math.pi * 2 end
      return ang
    end;
    function gm.ang_closer( a_beg, a_end )
      if math.abs(a_beg-a_end) > math.pi then
        if a_beg > a_end then
          a_beg = a_beg - math.pi * 2
        else
          a_beg = a_beg + math.pi * 2
        end;
      end;
      return a_beg;
    end;

    local function setColor(toload,i,time) 
      toload = toload or gm.state
      
      
      for k,o in ipairs(gemsPic[i]) do
        local colorID = colors[ starcolors[i][ (toload[i]+gems[i][k] - 1)%rays + 1 ] ]
        local r,g,b = colorID[1]/255,colorID[2]/255,colorID[3]/255
        if time then
          ObjAnimate( "spr_newfireplace_"..o, 12, 0, 0, function() end, {0,0,ObjGet("spr_newfireplace_"..o).color_r,ObjGet("spr_newfireplace_"..o).color_g,ObjGet("spr_newfireplace_"..o).color_b, 
          time,0,r,g,b} );
        else
          ObjSet( "spr_newfireplace_"..o, {color_r = r,color_g = g,color_b = b} );
        end
      end
    end

    local function load_map(skip)
      local toload = skip and winstate or gm.state
      for i,o in ipairs(toload) do
        --ObjSet( obj, {alp = toload[i]/winstate[i]} );
        ObjSet( "spr_newfireplace_"..i, {ang =  angStep*toload[i] })
        setColor(toload,i)

      end
    end
    
    --wincheck
    local function wincheck(skip)
      local function win()
        public.win_newfireplace()
      end
      if ld.TableEquals(gm.state,winstate) or skip then
        ld.Lock(1)
        ld.StartTimer( 2*animtime, function() win() end )
        return true
      else
        return false
      end
    end

    --load
    local function load(skip)
      load_map(skip)
    end
   
    local function chooseload(reset,skip)
      if reset or skip then
        local toload = skip and winstate or gm.state
        local time = animtime
        ld.Lock(1)
        for i, o in ipairs(toload) do
          local obj = ObjGet("spr_newfireplace_"..i)
          setColor(toload,i,time)
          ObjAnimate( obj.name, 7, 0, 0, function() ObjSet(obj.name, {ang = gm.ang_norm(ObjGet(obj.name).ang)} ) end, {0,0,gm.ang_closer(obj.ang, angStep*toload[i]), time,0,angStep*toload[i]} );
        end
        ld.StartTimer( time, function() ld.Lock(0) load(skip) wincheck(skip)  end )
      else

        load()
      end
    end

    chooseload()
    --save
    local function save()
      if not wincheck() then
        ng_global.progress["std"]["win_newfireplace"].state = ld.TableCopy(gm.state)
      end
    end  

    function gm.Reset()
      gm.state = ld.TableCopy(begstate)
      save()
      chooseload(1)
    end
    function gm.Skip()
      chooseload(nil,1)
    end 

    --public
    function gm.click(n)
      SoundSfx( "aud_clk_star" )
      local time = animtime
      ld.Lock(1)
      gm.state[n] = (gm.state[n]+1)%rays

      local obj = ObjGet("spr_newfireplace_"..n)
      ObjAnimate( obj.name, 7, 0, 0, function() end, {0,0,gm.ang_closer(obj.ang, angStep*gm.state[n]), time,0,angStep*gm.state[n]} );
      ld.StartTimer( time, function() setColor(nil,n,time) ld.Lock(0) ObjSet( obj.name, {ang = gm.ang_norm(ObjGet("spr_newfireplace_"..n).ang)} ); save() end )
      --ObjAnimate( obj, 8, 0, 0, function()   end, {0,0,ObjGet(obj).alp, time,0,(ng_global.progress["std"]["win_newfireplace"].state[1] + 1)/winstate[1]} );
    end

  end

end
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_newfireplace" ] = { type = "click", use_place = "gfx_newfireplace_win_newfireplace_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.win_newfireplace_logic = function()
  if ld.CheckRequirements( {"win_newfireplace"} ) then
    ObjSet( "spr_newfireplace_umbrella", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_newfireplace_sandpaper", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_newfireplace_beg = function()
  if ld.CheckRequirements( {"win_newfireplace"} ) then
    ObjDelete( "gfx_newfireplace_win_newfireplace_zone" );
  end
end;
private.win_newfireplace_end = function()
  if ld.CheckRequirements( {"win_newfireplace"} ) then
    ObjDelete("anm_newfireplace_anm_box")
    if common_impl.ZzCompleteCheck("win_newfireplace") then ObjSet( common_impl.hint["win_newfireplace"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_newfireplace", private.win_newfireplace_beg, private.room_objname );
cmn.AddSubscriber( "win_newfireplace", private.win_newfireplace_end, private.room_objname );
cmn.AddSubscriber( "win_newfireplace", private.win_newfireplace_logic );
cmn.AddSubscriber( "win_newfireplace_beg", private.win_newfireplace_beg, private.room_objname );
cmn.AddSubscriber( "win_newfireplace_end", private.win_newfireplace_end, private.room_objname );
cmn.AddSubscriber( "win_newfireplace_end", private.win_newfireplace_logic );
--------------------------------------------------------------------------------------------
function public.win_newfireplace()

  local func_end = function()
    cmn.SetEventDone( "win_newfireplace" );
    cmn.CallEventHandler( "win_newfireplace_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_newfireplace") then ld.CloseSubRoom() end;
  end;

  SoundSfx( "aud_win_newfireplace" )

  cmn.CallEventHandler( "win_newfireplace_beg" );
  common_impl.Lock(1);
  ObjDelete( "gfx_newfireplace_win_newfireplace_zone" );
  ObjGet( "obj_newfireplace_win_newfireplace_zoom" ).event_mdown()
  cmn.MiniGameHide( "newfireplace", true );
  ObjDelete("spr_newfireplace_box_star_1")
  ObjDelete("spr_newfireplace_box_star_2")
  ObjSet( "anm_newfireplace_anm_box", {animfunc = "open_cap_box", frame = 0 } );
  ld.AnimPlay( "anm_newfireplace_anm_box", "open_cap_box", func_end );
  --SoundSfx( 0 )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_umbrella" ] = { type = "get", get_obj = "spr_newfireplace_umbrella", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.get_umbrella_logic = function()
  
end;
private.get_umbrella_inv = function()
  interface.InventoryItemAdd("inv_umbrella","spr_newfireplace_umbrella");
  ObjSet( "inv_umbrella", { drag = 0 } );
end;
private.get_umbrella_beg = function()
  ObjDelete("gfx_newfireplace_umbrella")
end;
private.get_umbrella_end = function()
  ObjDelete("spr_newfireplace_umbrella_shadow")
  if common_impl.ZzCompleteCheck("get_umbrella") then ObjSet( common_impl.hint["get_umbrella"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_umbrella", private.get_umbrella_inv );
cmn.AddSubscriber( "get_umbrella", private.get_umbrella_beg, private.room_objname );
cmn.AddSubscriber( "get_umbrella", private.get_umbrella_end, private.room_objname );
cmn.AddSubscriber( "get_umbrella", private.get_umbrella_logic );
--------------------------------------------------------------------
function public.get_umbrella()
  cmn.SetEventDone( "get_umbrella" );
  cmn.CallEventHandler( "get_umbrella" );
  if common_impl.ZzCompleteCheck("get_umbrella") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sandpaper" ] = { type = "get", get_obj = "spr_newfireplace_sandpaper", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.get_sandpaper_logic = function()
  
end;
private.get_sandpaper_inv = function()
  interface.InventoryItemAdd("inv_sandpaper","spr_newfireplace_sandpaper");
end;
private.get_sandpaper_beg = function()
  ObjDelete("gfx_newfireplace_sandpaper")
end;
private.get_sandpaper_end = function()
  ObjDelete("spr_newfireplace_sandpaper_shadow")
  if common_impl.ZzCompleteCheck("get_sandpaper") then ObjSet( common_impl.hint["get_sandpaper"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sandpaper", private.get_sandpaper_inv );
cmn.AddSubscriber( "get_sandpaper", private.get_sandpaper_beg, private.room_objname );
cmn.AddSubscriber( "get_sandpaper", private.get_sandpaper_end, private.room_objname );
cmn.AddSubscriber( "get_sandpaper", private.get_sandpaper_logic );
--------------------------------------------------------------------
function public.get_sandpaper()
  cmn.SetEventDone( "get_sandpaper" );
  cmn.CallEventHandler( "get_sandpaper" );
  if common_impl.ZzCompleteCheck("get_sandpaper") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_oldbook" ] = { type = "use", inv_obj = "inv_oldbook", use_place = "gfx_newfireplace_oldbook_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.use_oldbook_logic = function()
  if ld.CheckRequirements( {"use_oldbook","use_oldbook2","use_hinrletter"} ) then
    ObjSet( "gfx_newfireplace_clk_newfireplace1_zone", { visible = 1, input = 1, active = 1 } )
  end;
  if ld.CheckRequirements( {"use_oldbook2","use_oldbook"} ) then
    ObjSet( "gfx_newfireplace_hinrletter_zone", {active = 1, input = 1, visible = 1} );
  end
end;
private.use_oldbook_inv = function()
  common_impl.ProcessMultiUseAll("oldbook", "oldbook")
end;
private.use_oldbook_beg = function()
  ObjSet( "spr_newhall_book_left", { visible = 1 } )
  ObjDelete( "gfx_newfireplace_oldbook_zone" );
end;
private.use_oldbook_end = function()
  ObjSet( "anm_newfireplace_anm_book1", {animfunc = "use_book2", frame = 999 } );
  if ld.CheckRequirements( {"use_oldbook2","use_oldbook"} ) then
    ObjSet( "anm_newfireplace_anm_book_cap", {animfunc = "push_book", frame = 0 } );
    ObjDelete("anm_newfireplace_anm_book1")
    ObjDelete("anm_newfireplace_anm_book2")
  end  
  if common_impl.ZzCompleteCheck("use_oldbook") then ObjSet( common_impl.hint["use_oldbook"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_oldbook", private.use_oldbook_inv );
cmn.AddSubscriber( "use_oldbook", private.use_oldbook_beg, private.room_objname );
cmn.AddSubscriber( "use_oldbook", private.use_oldbook_end, private.room_objname );
cmn.AddSubscriber( "use_oldbook", private.use_oldbook_logic );
cmn.AddSubscriber( "use_oldbook_inv", private.use_oldbook_inv, private.room_objname );
cmn.AddSubscriber( "use_oldbook_beg", private.use_oldbook_beg, private.room_objname );
cmn.AddSubscriber( "use_oldbook_end", private.use_oldbook_end, private.room_objname );
cmn.AddSubscriber( "use_oldbook_end", private.use_oldbook_logic );
--------------------------------------------------------------------------------------------
function public.use_oldbook( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_oldbook" );
    cmn.CallEventHandler( "use_oldbook_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_oldbook") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_oldbook_inv" );
  cmn.CallEventHandler( "use_oldbook_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newfireplace_anm_book1", "use_book2", func_end );
  SoundSfx( "aud_use_oldbook_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_oldbook2" ] = { type = "use", inv_obj = "inv_oldbook2", use_place = "gfx_newfireplace_oldbook2_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.use_oldbook2_logic = function()
  if ld.CheckRequirements( {"use_oldbook2","use_oldbook","use_hinrletter"} ) then
    ObjSet( "gfx_newfireplace_clk_newfireplace1_zone", { visible = 1, input = 1, active = 1 } )
    
  end;
  if ld.CheckRequirements( {"use_oldbook2","use_oldbook"} ) then
    ObjSet( "gfx_newfireplace_hinrletter_zone", {active = 1, input = 1, visible = 1} );
  end
end;
private.use_oldbook2_inv = function()
  common_impl.ProcessMultiUseAll("oldbook2", "oldbook2")
end;
private.use_oldbook2_beg = function()
  ObjSet( "spr_newhall_book_right", { visible = 1 } )
  ObjDelete( "gfx_newfireplace_oldbook2_zone" );
end;
private.use_oldbook2_end = function()
  ObjSet( "anm_newfireplace_anm_book2", {animfunc = "use_book4", frame = 999 } );
  if ld.CheckRequirements( {"use_oldbook2","use_oldbook"} ) then
    ObjSet( "anm_newfireplace_anm_book_cap", {animfunc = "push_book", frame = 0 } );
    ObjDelete("anm_newfireplace_anm_book1")
    ObjDelete("anm_newfireplace_anm_book2")
  end  
  if common_impl.ZzCompleteCheck("use_oldbook2") then ObjSet( common_impl.hint["use_oldbook2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_oldbook2", private.use_oldbook2_inv );
cmn.AddSubscriber( "use_oldbook2", private.use_oldbook2_beg, private.room_objname );
cmn.AddSubscriber( "use_oldbook2", private.use_oldbook2_end, private.room_objname );
cmn.AddSubscriber( "use_oldbook2", private.use_oldbook2_logic );
cmn.AddSubscriber( "use_oldbook2_inv", private.use_oldbook2_inv, private.room_objname );
cmn.AddSubscriber( "use_oldbook2_beg", private.use_oldbook2_beg, private.room_objname );
cmn.AddSubscriber( "use_oldbook2_end", private.use_oldbook2_end, private.room_objname );
cmn.AddSubscriber( "use_oldbook2_end", private.use_oldbook2_logic );
--------------------------------------------------------------------------------------------
function public.use_oldbook2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_oldbook2" );
    cmn.CallEventHandler( "use_oldbook2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_oldbook2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_oldbook2_inv" );
  cmn.CallEventHandler( "use_oldbook2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newfireplace_anm_book2", "use_book4", func_end );
  SoundSfx( "aud_use_oldbook_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hinrletter" ] = { type = "use", inv_obj = "inv_hinrletter", use_place = "gfx_newfireplace_hinrletter_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.use_hinrletter_logic = function()
  if ld.CheckRequirements( {"use_hinrletter","use_oldbook","use_oldbook2"} ) then
    ObjSet( "gfx_newfireplace_clk_newfireplace1_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_hinrletter_inv = function()
  common_impl.ProcessMultiUseAll("hinrletter", "hinrletter")
end;
private.use_hinrletter_beg = function()
  ObjDelete( "gfx_newfireplace_hinrletter_zone" );
end;
private.use_hinrletter_end = function()
  ObjSet( "anm_newfireplace_anm_paper", {animfunc = "use_paper", frame = 999, input = 1 } );
  if common_impl.ZzCompleteCheck("use_hinrletter") then ObjSet( common_impl.hint["use_hinrletter"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hinrletter", private.use_hinrletter_inv );
cmn.AddSubscriber( "use_hinrletter", private.use_hinrletter_beg, private.room_objname );
cmn.AddSubscriber( "use_hinrletter", private.use_hinrletter_end, private.room_objname );
cmn.AddSubscriber( "use_hinrletter", private.use_hinrletter_logic );
cmn.AddSubscriber( "use_hinrletter_inv", private.use_hinrletter_inv, private.room_objname );
cmn.AddSubscriber( "use_hinrletter_beg", private.use_hinrletter_beg, private.room_objname );
cmn.AddSubscriber( "use_hinrletter_end", private.use_hinrletter_end, private.room_objname );
cmn.AddSubscriber( "use_hinrletter_end", private.use_hinrletter_logic );
--------------------------------------------------------------------------------------------
function public.use_hinrletter( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hinrletter" );
    cmn.CallEventHandler( "use_hinrletter_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hinrletter") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hinrletter_inv" );
  cmn.CallEventHandler( "use_hinrletter_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newfireplace_anm_paper", "use_paper", func_end );
  SoundSfx( "aud_use_hinrletter_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_newfireplace1" ] = { type = "click", use_place = "gfx_newfireplace_clk_newfireplace1_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

--------------------------------------------------------------------------------------------
function public.clk_newfireplace1()
  public.clk_newfireplace2()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_newfireplace2" ] = { type = "click", use_place = "gfx_newfireplace_clk_newfireplace2_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.clk_newfireplace2_logic = function()
  if ld.CheckRequirements( {"clk_newfireplace2","clk_newfireplace1"} ) then
    ObjSet( "spr_newfireplace_abigailletter1", { visible = 1, input = 1, active = 1 } )

  end;

end;
private.clk_newfireplace2_beg = function()
  ObjDelete( "gfx_newfireplace_clk_newfireplace1_zone" ); 
  ObjDelete( "gfx_newfireplace_clk_newfireplace2_zone" ); 
end;
private.clk_newfireplace2_end = function()
  ObjDelete("spr_newhall_cover_shelf")
  ObjSet( "anm_newfireplace_anm_book_cap", {animfunc = "push_book", frame = 999 } );
  ObjSet( "anm_newfireplace_anm_paper", {input = 0} );
  if common_impl.ZzCompleteCheck("clk_newfireplace2") then ObjSet( common_impl.hint["clk_newfireplace2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_newfireplace2", private.clk_newfireplace2_beg, private.room_objname );
cmn.AddSubscriber( "clk_newfireplace2", private.clk_newfireplace2_end, private.room_objname );
cmn.AddSubscriber( "clk_newfireplace2", private.clk_newfireplace2_logic );
cmn.AddSubscriber( "clk_newfireplace2_beg", private.clk_newfireplace2_beg, private.room_objname );
cmn.AddSubscriber( "clk_newfireplace2_end", private.clk_newfireplace2_end, private.room_objname );
cmn.AddSubscriber( "clk_newfireplace2_end", private.clk_newfireplace2_logic );
--------------------------------------------------------------------------------------------
function public.clk_newfireplace2()

  local func_end = function()
    cmn.SetEventDone( "clk_newfireplace1" );
    cmn.SetEventDone( "clk_newfireplace2" );
    cmn.CallEventHandler( "clk_newfireplace2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_newfireplace2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_newfireplace2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newfireplace_anm_book_cap", "push_book", func_end );
  SoundSfx( "aud_clk_newfireplace1_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_griffonhead" ] = { type = "get", get_obj = "spr_newfireplace_griffonhead", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.get_griffonhead_logic = function()
      ObjSet( "spr_newfireplace_railroadpart", { visible = 1, input = 1, active = 1 } )
    
end;
private.get_griffonhead_inv = function()
  interface.InventoryItemAdd("inv_griffonhead","spr_newfireplace_griffonhead");
end;
private.get_griffonhead_beg = function()
  ObjDelete("gfx_newfireplace_griffonhead")
  ObjDelete( "spr_newhall_griffonhead" )
end;
private.get_griffonhead_end = function()
  ObjDelete("spr_newfireplace_griffonhead_trash")
  if common_impl.ZzCompleteCheck("get_griffonhead") then ObjSet( common_impl.hint["get_griffonhead"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_griffonhead", private.get_griffonhead_inv );
cmn.AddSubscriber( "get_griffonhead", private.get_griffonhead_beg, private.room_objname );
cmn.AddSubscriber( "get_griffonhead", private.get_griffonhead_end, private.room_objname );
cmn.AddSubscriber( "get_griffonhead", private.get_griffonhead_logic );
--------------------------------------------------------------------
function public.get_griffonhead()
  cmn.SetEventDone( "get_griffonhead" );
  cmn.CallEventHandler( "get_griffonhead" );
  if common_impl.ZzCompleteCheck("get_griffonhead") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_railroadpart" ] = { type = "get", get_obj = "spr_newfireplace_railroadpart", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.get_railroadpart_logic = function()
  --ObjSet( "gfx_newfireplace_clk_flashback31_zone", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "spr_newfireplace_abigailletter1", { visible = 1, input = 1, active = 1 } )
end;
private.get_railroadpart_inv = function()
  interface.InventoryItemAdd("inv_railroadpart","spr_newfireplace_railroadpart");
end;
private.get_railroadpart_beg = function()
  ObjDelete( "spr_newhall_railroadpart" )
  ObjDelete("gfx_newfireplace_railroadpart")
end;
private.get_railroadpart_end = function()
  ObjDelete("spr_newfireplace_railroadpart_shadow")
  if common_impl.ZzCompleteCheck("get_railroadpart") then ObjSet( common_impl.hint["get_railroadpart"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_railroadpart", private.get_railroadpart_inv );
cmn.AddSubscriber( "get_railroadpart", private.get_railroadpart_beg, private.room_objname );
cmn.AddSubscriber( "get_railroadpart", private.get_railroadpart_end, private.room_objname );
cmn.AddSubscriber( "get_railroadpart", private.get_railroadpart_logic );
--------------------------------------------------------------------
function public.get_railroadpart()
  cmn.SetEventDone( "get_railroadpart" );
  cmn.CallEventHandler( "get_railroadpart" );
  if common_impl.ZzCompleteCheck("get_railroadpart") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_flashback31" ] = { type = "click", use_place = "gfx_newfireplace_clk_flashback31_zone", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.clk_flashback31_logic = function()
  ObjSet( "spr_newfireplace_griffonhead", { visible = 1, input = 1, active = 1 } )
  
end;
private.clk_flashback31_beg = function()
  ObjDelete( "gfx_newfireplace_clk_flashback31_zone" );
end;
private.clk_flashback31_end = function()
  if common_impl.ZzCompleteCheck("clk_flashback31") then ObjSet( common_impl.hint["clk_flashback31"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_flashback31", private.clk_flashback31_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback31", private.clk_flashback31_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback31", private.clk_flashback31_logic );
cmn.AddSubscriber( "clk_flashback31_beg", private.clk_flashback31_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback31_end", private.clk_flashback31_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback31_end", private.clk_flashback31_logic );
--------------------------------------------------------------------------------------------
function public.clk_flashback31()

  local func_end = function()
    SoundSfx( 0 )
    common_impl.FlashbackHide()
    cmn.SetEventDone( "clk_flashback31" );
    cmn.SetEventDone( "get_abigailletter1" );
    cmn.CallEventHandler( "clk_flashback31_end" );
    common_impl.Lock(0);
    common_impl.Gate_MDown( 'gzz_newhall_newfireplace', { ObjGet( "gzz_newhall_newfireplace" ).pos_x, ObjGet( "gzz_newhall_newfireplace" ).pos_y } )
    
    if common_impl.ZzCompleteCheck("clk_flashback31") then ld.CloseSubRoom() end;
    ld.ShowBbt( "after_clk_flashback31" )
  end;

  cmn.CallEventHandler( "clk_flashback31_beg" );
  local obj_root   = "obj_newhall_vid_flashback_root"
  local vid_prefix = "vid_newhall_vid_flashback_"
  local str_prefix = "str_newhall_vid_flashback_"
  local lip_prefix = "vid_newhall_vid_flashback_3"
  local aud_count_dif = 0
  common_impl.FlashbackInit( obj_root, func_end, vid_prefix, str_prefix, lip_prefix, aud_count_dif )  

  local func_step_2 = function()
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_31" )
    SoundEnv( "aud_river_env", -1 )
    common_impl.FlashbackShow( 2, func_end )
  end;

  local func_step_1 = function()
    SoundSfx( "aud_flashback_31" )
    SoundEnv( "aud_river_env", -1 )
    common_impl.FlashbackShow( 1, func_step_2 )
  end;

  local func_fb_start = function()
    ld.Lock(0)
    ld.CloseSubRoom()
    func_step_1()
  end

  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  func_fb_start()

end;
--------------------------------------------------------------------
common_impl.hint[ "get_abigailletter1" ] = { type = "get", get_obj = "spr_newfireplace_abigailletter1", room = "rm_newhall", zz = "zz_newfireplace", zz_gate = "gzz_newhall_newfireplace" };

private.get_abigailletter1_logic = function()

end;
private.get_abigailletter1_inv = function()
  interface.InventoryItemAdd("inv_abigailletter","spr_newfireplace_abigailletter1",function() level_inv.ProcessGetAbigailletterAll( "get_abigailletter1" ) end);
end;
private.get_abigailletter1_beg = function()
  ObjDelete("gfx_newfireplace_abigailletter1")
  ObjDelete( "spr_newhall_abigailletter1" )
end;
private.get_abigailletter1_end = function()
  ObjDelete("spr_newfireplace_abigailletter1_shadow")
  if common_impl.ZzCompleteCheck("get_abigailletter1") then ObjSet( common_impl.hint["get_abigailletter1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_abigailletter1", private.get_abigailletter1_inv );
cmn.AddSubscriber( "get_abigailletter1", private.get_abigailletter1_beg, private.room_objname );
cmn.AddSubscriber( "get_abigailletter1", private.get_abigailletter1_end, private.room_objname );
cmn.AddSubscriber( "get_abigailletter1", private.get_abigailletter1_logic );
--------------------------------------------------------------------
function public.get_abigailletter1()
  cmn.CallEventHandler( "get_abigailletter1" );
  public.clk_flashback31()
  if common_impl.ZzCompleteCheck("get_abigailletter1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_coffeetable *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_twocoins" ] = { type = "use", inv_obj = "inv_twocoins", use_place = "gfx_coffeetable_twocoins_zone", room = "rm_newhall", zz = "zz_coffeetable", zz_gate = "gzz_newhall_coffeetable" };

private.use_twocoins_logic = function()
  ObjSet( "spr_coffeetable_casketpart1", { visible = 1, input = 1, active = 1 } )

end;
private.use_twocoins_inv = function()
  common_impl.ProcessMultiUseAll("twocoins", "twocoins")
end;
private.use_twocoins_beg = function()
  ObjDelete( "gfx_coffeetable_twocoins_zone" );
end;
private.use_twocoins_end = function()
  ObjDelete("spr_newhall_casketpart1")
  ObjSet( "spr_newhall_casketpart2", {visible = 1} );
  ObjSet( "anm_coffeetable_anm_pig", {animfunc = "pig_static", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_twocoins") then ObjSet( common_impl.hint["use_twocoins"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_twocoins", private.use_twocoins_inv );
cmn.AddSubscriber( "use_twocoins", private.use_twocoins_beg, private.room_objname );
cmn.AddSubscriber( "use_twocoins", private.use_twocoins_end, private.room_objname );
cmn.AddSubscriber( "use_twocoins", private.use_twocoins_logic );
cmn.AddSubscriber( "use_twocoins_inv", private.use_twocoins_inv, private.room_objname );
cmn.AddSubscriber( "use_twocoins_beg", private.use_twocoins_beg, private.room_objname );
cmn.AddSubscriber( "use_twocoins_end", private.use_twocoins_end, private.room_objname );
cmn.AddSubscriber( "use_twocoins_end", private.use_twocoins_logic );
--------------------------------------------------------------------------------------------
function public.use_twocoins( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_twocoins" );
    cmn.CallEventHandler( "use_twocoins_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_twocoins") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_twocoins_inv" );
  cmn.CallEventHandler( "use_twocoins_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coffeetable_anm_pig", "use_coin", func_end );
  SoundSfx( "aud_use_twocoins_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_casketpart1" ] = { type = "get", get_obj = "spr_coffeetable_casketpart1", room = "rm_newhall", zz = "zz_coffeetable", zz_gate = "gzz_newhall_coffeetable" };

private.get_casketpart1_logic = function()
  
end;
private.get_casketpart1_inv = function()
  interface.InventoryItemAdd("inv_casketpart","spr_coffeetable_casketpart1",function() level_inv.ProcessGetCasketpartAll( "get_casketpart1" ) end);
end;
private.get_casketpart1_beg = function()
  ObjDelete("gfx_coffeetable_casketpart1")
end;
private.get_casketpart1_end = function()
  ObjDelete("spr_newhall_casketpart2")
  if common_impl.ZzCompleteCheck("get_casketpart1") then ObjSet( common_impl.hint["get_casketpart1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_casketpart1", private.get_casketpart1_inv );
cmn.AddSubscriber( "get_casketpart1", private.get_casketpart1_beg, private.room_objname );
cmn.AddSubscriber( "get_casketpart1", private.get_casketpart1_end, private.room_objname );
cmn.AddSubscriber( "get_casketpart1", private.get_casketpart1_logic );
--------------------------------------------------------------------
function public.get_casketpart1()
  cmn.SetEventDone( "get_casketpart1" );
  cmn.CallEventHandler( "get_casketpart1" );
  if common_impl.ZzCompleteCheck("get_casketpart1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shugar" ] = { type = "click", use_place = "gfx_coffeetable_clk_shugar_zone", room = "rm_newhall", zz = "zz_coffeetable", zz_gate = "gzz_newhall_coffeetable" };

private.clk_shugar_logic = function()
  ObjSet( "gfx_coffeetable_spoon_zone", {active = 1, input = 1, visible = 1} );
end;
private.clk_shugar_beg = function()
  ObjDelete( "gfx_coffeetable_clk_shugar_zone" );
end;
private.clk_shugar_end = function()
  ObjDelete("spr_newhall_cap_sugar")
  ObjSet( "anm_coffeetable_anm_shugar", {animfunc = "shugar_idle1", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_shugar") then ObjSet( common_impl.hint["clk_shugar"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shugar", private.clk_shugar_beg, private.room_objname );
cmn.AddSubscriber( "clk_shugar", private.clk_shugar_end, private.room_objname );
cmn.AddSubscriber( "clk_shugar", private.clk_shugar_logic );
cmn.AddSubscriber( "clk_shugar_beg", private.clk_shugar_beg, private.room_objname );
cmn.AddSubscriber( "clk_shugar_end", private.clk_shugar_end, private.room_objname );
cmn.AddSubscriber( "clk_shugar_end", private.clk_shugar_logic );
--------------------------------------------------------------------------------------------
function public.clk_shugar()

  local func_end = function()
    cmn.SetEventDone( "clk_shugar" );
    cmn.CallEventHandler( "clk_shugar_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shugar") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_shugar_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coffeetable_anm_shugar", "open_cup", func_end );
  SoundSfx( "aud_open_sugarbowl" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_spoon" ] = { type = "use", inv_obj = "inv_spoon", use_place = "gfx_coffeetable_spoon_zone", room = "rm_newhall", zz = "zz_coffeetable", zz_gate = "gzz_newhall_coffeetable" };

private.use_spoon_logic = function()
  ObjSet( "spr_coffeetable_sugarspoon", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_coffeetable_newbutton1", { visible = 1, input = 1, active = 1 } )

end;
private.use_spoon_inv = function()
  common_impl.ProcessMultiUseAll("spoon", "spoon")
end;
private.use_spoon_beg = function()
  ObjDelete( "gfx_coffeetable_spoon_zone" );
end;
private.use_spoon_end = function()
  ObjSet( "anm_coffeetable_anm_shugar", {animfunc = "use_spoon", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_spoon") then ObjSet( common_impl.hint["use_spoon"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_spoon", private.use_spoon_inv );
cmn.AddSubscriber( "use_spoon", private.use_spoon_beg, private.room_objname );
cmn.AddSubscriber( "use_spoon", private.use_spoon_end, private.room_objname );
cmn.AddSubscriber( "use_spoon", private.use_spoon_logic );
cmn.AddSubscriber( "use_spoon_inv", private.use_spoon_inv, private.room_objname );
cmn.AddSubscriber( "use_spoon_beg", private.use_spoon_beg, private.room_objname );
cmn.AddSubscriber( "use_spoon_end", private.use_spoon_end, private.room_objname );
cmn.AddSubscriber( "use_spoon_end", private.use_spoon_logic );
--------------------------------------------------------------------------------------------
function public.use_spoon( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_spoon" );
    cmn.CallEventHandler( "use_spoon_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_spoon") then ld.CloseSubRoom() end;
    public.get_sugarspoon()
    public.get_newbutton1()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_spoon_inv" );
  cmn.CallEventHandler( "use_spoon_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coffeetable_anm_shugar", "use_spoon", func_end );
  SoundSfx( "aud_use_spoon_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sugarspoon" ] = { type = "get", get_obj = "spr_coffeetable_sugarspoon", room = "rm_newhall", zz = "zz_coffeetable", zz_gate = "gzz_newhall_coffeetable" };

private.get_sugarspoon_logic = function()
  
end;
private.get_sugarspoon_inv = function()
  interface.InventoryItemAdd("inv_sugarspoon","spr_coffeetable_sugarspoon");
end;
private.get_sugarspoon_beg = function()
  ObjDelete("gfx_coffeetable_sugarspoon")
end;
private.get_sugarspoon_end = function()
  if common_impl.ZzCompleteCheck("get_sugarspoon") then ObjSet( common_impl.hint["get_sugarspoon"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sugarspoon", private.get_sugarspoon_inv );
cmn.AddSubscriber( "get_sugarspoon", private.get_sugarspoon_beg, private.room_objname );
cmn.AddSubscriber( "get_sugarspoon", private.get_sugarspoon_end, private.room_objname );
cmn.AddSubscriber( "get_sugarspoon", private.get_sugarspoon_logic );
--------------------------------------------------------------------
function public.get_sugarspoon()
  cmn.SetEventDone( "get_sugarspoon" );
  cmn.CallEventHandler( "get_sugarspoon" );
  if common_impl.ZzCompleteCheck("get_sugarspoon") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_newbutton1" ] = { type = "get", get_obj = "spr_coffeetable_newbutton1", room = "rm_newhall", zz = "zz_coffeetable", zz_gate = "gzz_newhall_coffeetable" };

private.get_newbutton1_logic = function()
  
end;
private.get_newbutton1_inv = function()
  interface.InventoryItemAdd("inv_newbutton","spr_coffeetable_newbutton1",function() level_inv.ProcessGetNewbuttonAll( "get_newbutton1" ) end);
end;
private.get_newbutton1_beg = function()
  ObjDelete("gfx_coffeetable_newbutton1")
end;
private.get_newbutton1_end = function()
  if common_impl.ZzCompleteCheck("get_newbutton1") then ObjSet( common_impl.hint["get_newbutton1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_newbutton1", private.get_newbutton1_inv );
cmn.AddSubscriber( "get_newbutton1", private.get_newbutton1_beg, private.room_objname );
cmn.AddSubscriber( "get_newbutton1", private.get_newbutton1_end, private.room_objname );
cmn.AddSubscriber( "get_newbutton1", private.get_newbutton1_logic );
--------------------------------------------------------------------
function public.get_newbutton1()
  cmn.SetEventDone( "get_newbutton1" );
  cmn.CallEventHandler( "get_newbutton1" );
  if common_impl.ZzCompleteCheck("get_newbutton1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ball" ] = { type = "use", inv_obj = "inv_ball", use_place = "gfx_coffeetable_ball_zone", room = "rm_newhall", zz = "zz_coffeetable", zz_gate = "gzz_newhall_coffeetable" };

private.use_ball_logic = function()
  ObjSet( "spr_coffeetable_nippers", {  input = 1 } )

end;
private.use_ball_inv = function()
  common_impl.ProcessMultiUseAll("ball", "ball")
end;
private.use_ball_beg = function()
  ObjDelete( "gfx_coffeetable_ball_zone" );
end;
private.use_ball_end = function()
  ObjSet( "gfx_coffeetable_nippers", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_newhall_box_cap", {visible = 1} );
  ObjSet( "spr_newhall_nippers", {visible = 1} );
  ObjSet( "spr_newhall_balls", {visible = 1} );
  ObjSet( "anm_coffeetable_anm_balls", {animfunc = "use_ball", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_ball") then ObjSet( common_impl.hint["use_ball"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ball", private.use_ball_inv );
cmn.AddSubscriber( "use_ball", private.use_ball_beg, private.room_objname );
cmn.AddSubscriber( "use_ball", private.use_ball_end, private.room_objname );
cmn.AddSubscriber( "use_ball", private.use_ball_logic );
cmn.AddSubscriber( "use_ball_inv", private.use_ball_inv, private.room_objname );
cmn.AddSubscriber( "use_ball_beg", private.use_ball_beg, private.room_objname );
cmn.AddSubscriber( "use_ball_end", private.use_ball_end, private.room_objname );
cmn.AddSubscriber( "use_ball_end", private.use_ball_logic );
--------------------------------------------------------------------------------------------
function public.use_ball( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ball" );
    cmn.CallEventHandler( "use_ball_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ball") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ball_inv" );
  cmn.CallEventHandler( "use_ball_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_coffeetable_anm_balls", "use_ball", func_end );
  SoundSfx( "aud_use_ball_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_nippers" ] = { type = "get", get_obj = "spr_coffeetable_nippers", room = "rm_newhall", zz = "zz_coffeetable", zz_gate = "gzz_newhall_coffeetable" };

private.get_nippers_logic = function()
  
end;
private.get_nippers_inv = function()
  interface.InventoryItemAdd("inv_nippers","spr_coffeetable_nippers");
end;
private.get_nippers_beg = function()
  ObjDelete("gfx_coffeetable_nippers")
  ObjSet( "anm_coffeetable_anm_balls", {animfunc = "open_box_static", frame = 0 } );
  ObjSet( "spr_coffeetable_nippers", {visible = 1} );
end;
private.get_nippers_end = function()
  ObjDelete("spr_newhall_nippers")
  if common_impl.ZzCompleteCheck("get_nippers") then ObjSet( common_impl.hint["get_nippers"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_nippers", private.get_nippers_inv );
cmn.AddSubscriber( "get_nippers", private.get_nippers_beg, private.room_objname );
cmn.AddSubscriber( "get_nippers", private.get_nippers_end, private.room_objname );
cmn.AddSubscriber( "get_nippers", private.get_nippers_logic );
--------------------------------------------------------------------
function public.get_nippers()
  cmn.SetEventDone( "get_nippers" );
  cmn.CallEventHandler( "get_nippers" );
  if common_impl.ZzCompleteCheck("get_nippers") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_balcony *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_balconyhandle" ] = { type = "use", inv_obj = "inv_balconyhandle", use_place = "gfx_balcony_balconyhandle_zone", room = "rm_newhall", zz = "zz_balcony", zz_gate = "gzz_newhall_balcony" };

private.use_balconyhandle_logic = function()
  ObjSet( "gfx_balcony_clk_balcony_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_balconyhandle_inv = function()
  common_impl.ProcessMultiUseAll("balconyhandle", "balconyhandle")
end;
private.use_balconyhandle_beg = function()
  ObjDelete( "gfx_balcony_balconyhandle_zone" );
end;
private.use_balconyhandle_end = function()
  ObjSet( "anm_balcony_anm", {animfunc = "open_door", frame = 0 } );
  ObjDelete("spr_newhall_no_handle")
  if common_impl.ZzCompleteCheck("use_balconyhandle") then ObjSet( common_impl.hint["use_balconyhandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_balconyhandle", private.use_balconyhandle_inv );
cmn.AddSubscriber( "use_balconyhandle", private.use_balconyhandle_beg, private.room_objname );
cmn.AddSubscriber( "use_balconyhandle", private.use_balconyhandle_end, private.room_objname );
cmn.AddSubscriber( "use_balconyhandle", private.use_balconyhandle_logic );
cmn.AddSubscriber( "use_balconyhandle_inv", private.use_balconyhandle_inv, private.room_objname );
cmn.AddSubscriber( "use_balconyhandle_beg", private.use_balconyhandle_beg, private.room_objname );
cmn.AddSubscriber( "use_balconyhandle_end", private.use_balconyhandle_end, private.room_objname );
cmn.AddSubscriber( "use_balconyhandle_end", private.use_balconyhandle_logic );
--------------------------------------------------------------------------------------------
function public.use_balconyhandle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_balconyhandle" );
    cmn.CallEventHandler( "use_balconyhandle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_balconyhandle") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_balconyhandle_inv" );
  cmn.CallEventHandler( "use_balconyhandle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_balcony_anm", "use_handle", func_end );
  SoundSfx( "aud_use_balconyhandle_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_balcony" ] = { type = "click", use_place = "gfx_balcony_clk_balcony_zone", room = "rm_newhall", zz = "zz_balcony", zz_gate = "gzz_newhall_balcony" };

private.clk_balcony_logic = function()
  ObjSet( "gho_newhall_winterbalcony", { visible = 1, input = 1, active = 1 } )

end;
private.clk_balcony_beg = function()
  ObjDelete( "gfx_balcony_clk_balcony_zone" );
end;
private.clk_balcony_end = function()
  ObjSet( "anm_balcony_anm", {animfunc = "open_door", frame = 999 } );
  ObjSet( "anm_newhall_anim_door_balcony", {animfunc = "open_balcony", frame = 999 } );
  if common_impl.ZzCompleteCheck("clk_balcony") then ObjSet( common_impl.hint["clk_balcony"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_balcony", private.clk_balcony_beg, private.room_objname );
cmn.AddSubscriber( "clk_balcony", private.clk_balcony_end, private.room_objname );
cmn.AddSubscriber( "clk_balcony", private.clk_balcony_logic );
cmn.AddSubscriber( "clk_balcony_beg", private.clk_balcony_beg, private.room_objname );
cmn.AddSubscriber( "clk_balcony_end", private.clk_balcony_end, private.room_objname );
cmn.AddSubscriber( "clk_balcony_end", private.clk_balcony_logic );
--------------------------------------------------------------------------------------------
function public.clk_balcony()

  local func_end = function()
    cmn.SetEventDone( "clk_balcony" );
    cmn.CallEventHandler( "clk_balcony_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_balcony") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_balcony_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_balcony_anm", "open_door", 
    function() 
      ld.CloseSubRoom()
      ld.AnimPlay( "anm_newhall_anim_door_balcony", "open_balcony", func_end);      
    end
  );
  SoundSfx( "aud_clk_balcony_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doortobackyard *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dragon1" ] = { type = "use", inv_obj = "inv_dragon1", use_place = "gfx_doortobackyard_dragon1_zone", room = "rm_newhall", zz = "zz_doortobackyard", zz_gate = "gzz_newhall_doortobackyard" };

private.use_dragon1_logic = function()
  if ld.CheckRequirements( {"use_dragon1","use_dragon2"} ) then
  ObjSet( "gfx_doortobackyard_clk_doortobackyard_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_dragon1_inv = function()
  common_impl.ProcessMultiUseAll("dragon1", "dragon1")
end;
private.use_dragon1_beg = function()
  ObjDelete( "gfx_doortobackyard_dragon1_zone" );
end;
private.use_dragon1_end = function()
  ObjSet( "spr_newhall_dragon_1", {visible = 1} );
  if ld.CheckRequirements( {"use_dragon1","use_dragon2"} ) then
    ObjDelete("obj_doortobackyard_clk_doortobackyard_zone")
  end
  ObjSet( "anm_doortobackyard_anm_dr1", {animfunc = "use_dragon1", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_dragon1") then ObjSet( common_impl.hint["use_dragon1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dragon1", private.use_dragon1_inv );
cmn.AddSubscriber( "use_dragon1", private.use_dragon1_beg, private.room_objname );
cmn.AddSubscriber( "use_dragon1", private.use_dragon1_end, private.room_objname );
cmn.AddSubscriber( "use_dragon1", private.use_dragon1_logic );
cmn.AddSubscriber( "use_dragon1_inv", private.use_dragon1_inv, private.room_objname );
cmn.AddSubscriber( "use_dragon1_beg", private.use_dragon1_beg, private.room_objname );
cmn.AddSubscriber( "use_dragon1_end", private.use_dragon1_end, private.room_objname );
cmn.AddSubscriber( "use_dragon1_end", private.use_dragon1_logic );
--------------------------------------------------------------------------------------------
function public.use_dragon1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dragon1" );
    cmn.CallEventHandler( "use_dragon1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dragon1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dragon1_inv" );
  cmn.CallEventHandler( "use_dragon1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortobackyard_anm_dr1", "use_dragon1", func_end );
  SoundSfx( "aud_use_dragon1_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dragon2" ] = { type = "use", inv_obj = "inv_dragon2", use_place = "gfx_doortobackyard_dragon2_zone", room = "rm_newhall", zz = "zz_doortobackyard", zz_gate = "gzz_newhall_doortobackyard" };

private.use_dragon2_logic = function()
  if ld.CheckRequirements( {"use_dragon2","use_dragon1"} ) then
  ObjSet( "gfx_doortobackyard_clk_doortobackyard_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_dragon2_inv = function()
  common_impl.ProcessMultiUseAll("dragon2", "dragon2")
end;
private.use_dragon2_beg = function()
  ObjDelete( "gfx_doortobackyard_dragon2_zone" );
end;
private.use_dragon2_end = function()
  ObjSet( "spr_newhall_dragon_2", {visible = 1} );
  if ld.CheckRequirements( {"use_dragon1","use_dragon2"} ) then
    ObjDelete("obj_doortobackyard_clk_doortobackyard_zone")
  end
  ObjSet( "anm_doortobackyard_anm_dr2", {animfunc = "use_dragon2", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_dragon2") then ObjSet( common_impl.hint["use_dragon2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dragon2", private.use_dragon2_inv );
cmn.AddSubscriber( "use_dragon2", private.use_dragon2_beg, private.room_objname );
cmn.AddSubscriber( "use_dragon2", private.use_dragon2_end, private.room_objname );
cmn.AddSubscriber( "use_dragon2", private.use_dragon2_logic );
cmn.AddSubscriber( "use_dragon2_inv", private.use_dragon2_inv, private.room_objname );
cmn.AddSubscriber( "use_dragon2_beg", private.use_dragon2_beg, private.room_objname );
cmn.AddSubscriber( "use_dragon2_end", private.use_dragon2_end, private.room_objname );
cmn.AddSubscriber( "use_dragon2_end", private.use_dragon2_logic );
--------------------------------------------------------------------------------------------
function public.use_dragon2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dragon2" );
    cmn.CallEventHandler( "use_dragon2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dragon2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dragon2_inv" );
  cmn.CallEventHandler( "use_dragon2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortobackyard_anm_dr2", "use_dragon2", func_end );
  SoundSfx( "aud_use_dragon1_newhall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_doortobackyard" ] = { type = "click", use_place = "gfx_doortobackyard_clk_doortobackyard_zone", room = "rm_newhall", zz = "zz_doortobackyard", zz_gate = "gzz_newhall_doortobackyard" };

private.clk_doortobackyard_logic = function()
  ObjSet( "grm_newhall_backyard", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_newhall_backyard_focus");
    end;
end;
private.clk_doortobackyard_beg = function()
  ObjDelete( "gfx_doortobackyard_clk_doortobackyard_zone" );
end;
private.clk_doortobackyard_end = function()
  ObjSet( "anm_doortobackyard_anm", {animfunc = "door_open", frame = 999 } );
  ObjSet( "anm_newhall_anim_door_backyard", {animfunc = "open_backyard", frame = 999 } );
  if common_impl.ZzCompleteCheck("clk_doortobackyard") then ObjSet( common_impl.hint["clk_doortobackyard"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_doortobackyard", private.clk_doortobackyard_beg, private.room_objname );
cmn.AddSubscriber( "clk_doortobackyard", private.clk_doortobackyard_end, private.room_objname );
cmn.AddSubscriber( "clk_doortobackyard", private.clk_doortobackyard_logic );
cmn.AddSubscriber( "clk_doortobackyard_beg", private.clk_doortobackyard_beg, private.room_objname );
cmn.AddSubscriber( "clk_doortobackyard_end", private.clk_doortobackyard_end, private.room_objname );
cmn.AddSubscriber( "clk_doortobackyard_end", private.clk_doortobackyard_logic );
--------------------------------------------------------------------------------------------
function public.clk_doortobackyard()

  local func_end = function()
    cmn.SetEventDone( "clk_doortobackyard" );
    cmn.CallEventHandler( "clk_doortobackyard_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_doortobackyard") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_doortobackyard_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortobackyard_anm", "door_open", function() 
    ld.CloseSubRoom()
    ld.AnimPlay( "anm_newhall_anim_door_backyard", "open_backyard", func_end );
  end );
  SoundSfx( "aud_open_doortobedroom" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_cerber" ) then
    public.win_cerber_load(1)
  end

  if ( mg_name == "zz_newfireplace" ) then
    private.win_newfireplace_gm.Reset()
  end

end;
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
    
  if ( mg_name == "zz_cerber" ) then
    public.win_cerber_load(nil,1)
  end

  if ( mg_name == "zz_newfireplace" ) then
    private.win_newfireplace_gm.Skip()
  end

end;

  local win_winterbalcony_for_newhall = function()
    if ld.CheckRequirements( {"win_winterbalcony"} ) then
      ObjSet( "gho_newhall_winterbalcony", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_winterbalcony", win_winterbalcony_for_newhall, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_newhall();
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( { "opn_newhall" } ) then
    ObjAttach( "vid_newhall_vid_open", "rm_newhall" )
    common_impl.SetWidgetsVisible( "DialogVideoShow", false )
  end
  SoundEnv( "aud_newhall_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_doortobackyard" );
  function zz_doortobackyard.Open()
  end;
  function zz_doortobackyard.PreOpen()
  end;
  function zz_doortobackyard.PreClose()
  end;
  function zz_doortobackyard.Close()
  end;

  subroom.Define( "zz_balcony" );
  function zz_balcony.Open()
  end;
  function zz_balcony.PreOpen()
  end;
  function zz_balcony.PreClose()
  end;
  function zz_balcony.Close()
  end;

  subroom.Define( "zz_coffeetable" );
  function zz_coffeetable.Open()
  end;
  function zz_coffeetable.PreOpen()
  end;
  function zz_coffeetable.PreClose()
  end;
  function zz_coffeetable.Close()
  end;

  subroom.Define( "zz_newfireplace" );
  function zz_newfireplace.Open()
  end;
  function zz_newfireplace.PreOpen()
    public.win_newfireplace_load()
  end;
  function zz_newfireplace.PreClose()
  end;
  function zz_newfireplace.Close()
  end;

  subroom.Define( "zz_cerber" );
  function zz_cerber.Open()
  end;
  function zz_cerber.PreOpen()
    public.win_cerber_load()
  end;
  function zz_cerber.PreClose()
  end;
  function zz_cerber.Close()
  end;
  
end;
--*********************************************************************************************************************