-- name=rm_secondfloor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_secondfloor";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_secondfloor()
  if not ( cmn.IsEventDone( "opn_secondfloor" ) ) then
    local func_end = function()
      cmn.SetEventDone( "opn_secondfloor" );
      cmn.CallEventHandler( "opn_secondfloor" )
      ld.ShowBbtOpn( private.room_objname )
      ld.Lock( 0 )
    end;
    ld.Lock( 1 )
    SoundVid( "aud_leaving_cat" )
    ld.AnimPlay( "anm_secondfloor_anim_cat", "default", func_end )
  end;
end;
--------------------------------------------------------------------
local opn_secondfloor = function()
  ObjDelete( "anm_secondfloor_anim_cat" )
  ObjSet( "spr_secondfloor_bell", { visible = 1 } )
  ObjSet( "spr_secondfloor_door_bedroom_close", { visible = 1 } )
end;
local opn_secondfloor_logic = function() end;
cmn.AddSubscriber( "opn_secondfloor", opn_secondfloor_logic )
cmn.AddSubscriber( "opn_secondfloor", opn_secondfloor, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doortobedroom *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_bell1" ] = { type = "get", get_obj = "spr_doortobedroom_bell1", room = "rm_secondfloor", zz = "zz_doortobedroom", zz_gate = "gzz_secondfloor_doortobedroom" };

private.get_bell1_logic = function()
  
end;
private.get_bell1_inv = function()
  interface.InventoryItemAdd("inv_bell1","spr_doortobedroom_bell1");
end;
private.get_bell1_beg = function()
  ObjDelete("gfx_doortobedroom_bell1")
end;
private.get_bell1_end = function()
  ObjDelete( "spr_secondfloor_bell" )
  ObjDelete( "spr_doortobedroom_bell1_shadow" )
  if common_impl.ZzCompleteCheck("get_bell1") then ObjSet( common_impl.hint["get_bell1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bell1", private.get_bell1_inv );
cmn.AddSubscriber( "get_bell1", private.get_bell1_beg, private.room_objname );
cmn.AddSubscriber( "get_bell1", private.get_bell1_end, private.room_objname );
cmn.AddSubscriber( "get_bell1", private.get_bell1_logic );
--------------------------------------------------------------------
function public.get_bell1()
  cmn.SetEventDone( "get_bell1" );
  cmn.CallEventHandler( "get_bell1" );
  if common_impl.ZzCompleteCheck("get_bell1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_angel" ] = { type = "use", inv_obj = "inv_angel", use_place = "gfx_doortobedroom_angel_zone", room = "rm_secondfloor", zz = "zz_doortobedroom", zz_gate = "gzz_secondfloor_doortobedroom" };

private.use_angel_logic = function()
  ObjSet( "obj_doortobedroom_mmg_root", { visible = 1, input = 1, active = 1 } )
end;
private.use_angel_inv = function()
  common_impl.ProcessMultiUseAll("angel", "angel")
end;
private.use_angel_beg = function()
  ObjDelete( "gfx_doortobedroom_angel_zone" );
end;
private.use_angel_end = function()
  ObjSet( "anm_doortobedroom_anm_use_angel", { animfunc = "use_angel", frame = 999 } )
  ObjSet( "anm_secondfloor_anim_secondfloor_open_doorbed", { animfunc = "open_doorbed", frame = 0 } )
  ObjDelete( "spr_secondfloor_door_bedroom_close" )
  ObjSet( "spr_secondfloor_mmg_bedroom_trash", { visible = 1 } )
  if common_impl.ZzCompleteCheck("use_angel") then ObjSet( common_impl.hint["use_angel"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_angel", private.use_angel_inv );
cmn.AddSubscriber( "use_angel", private.use_angel_beg, private.room_objname );
cmn.AddSubscriber( "use_angel", private.use_angel_end, private.room_objname );
cmn.AddSubscriber( "use_angel", private.use_angel_logic );
cmn.AddSubscriber( "use_angel_inv", private.use_angel_inv, private.room_objname );
cmn.AddSubscriber( "use_angel_beg", private.use_angel_beg, private.room_objname );
cmn.AddSubscriber( "use_angel_end", private.use_angel_end, private.room_objname );
cmn.AddSubscriber( "use_angel_end", private.use_angel_logic );
--------------------------------------------------------------------------------------------
function public.use_angel( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_angel" );
    cmn.CallEventHandler( "use_angel_end" );
    common_impl.Lock(0);
    cmn.MiniGameShow( "angels" );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_angel_inv" );
  cmn.CallEventHandler( "use_angel_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortobedroom_anm_use_angel", "use_angel", func_end );
  SoundSfx( "aud_use_angel_doortobedroom" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_angels" ] = { type = "click", use_place = "obj_doortobedroom_mmg_root", room = "rm_secondfloor", zz = "zz_doortobedroom", zz_gate = "gzz_secondfloor_doortobedroom" };

private.win_angels_logic = function()
  if ld.CheckRequirements( { "win_angels" } ) then
    ObjSet( "gfx_doortobedroom_clk_doortobedroom_zone", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_angels_beg = function()

end;
private.win_angels_end = function()
  if ld.CheckRequirements( { "win_angels" } ) then
    ObjDelete( "obj_doortobedroom_mmg_root" )
    ObjDelete( "spr_secondfloor_mmg_bedroom_trash" )
    ObjSet( "anm_doortobedroom_anm_use_angel", { animfunc = "mmg_win", frame = 999 } )
  end
  if common_impl.ZzCompleteCheck("win_angels") then ObjSet( common_impl.hint["win_angels"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_angels", private.win_angels_beg, private.room_objname );
cmn.AddSubscriber( "win_angels", private.win_angels_end, private.room_objname );
cmn.AddSubscriber( "win_angels", private.win_angels_logic );
cmn.AddSubscriber( "win_angels_beg", private.win_angels_beg, private.room_objname );
cmn.AddSubscriber( "win_angels_end", private.win_angels_end, private.room_objname );
cmn.AddSubscriber( "win_angels_end", private.win_angels_logic );
--------------------------------------------------------------------------------------------
function public.win_angels()

  local func_end = function()
    cmn.SetEventDone( "win_angels" );
    cmn.CallEventHandler( "win_angels_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_angels") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_angels_beg" );
  common_impl.Lock(1);
  cmn.MiniGameHide( "angels", true );

  ObjDelete( "obj_doortobedroom_mmg_root" )
  SoundSfx( "aud_win_doortobedroom" )
  ld.AnimPlay( "anm_doortobedroom_anm_use_angel", "mmg_win", func_end );
  --SoundSfx( 0 )

end;
function public.win_angels_load()
  if not private.win_angels_gm and not ld.CheckRequirements( { "win_angels" } ) then
    private.win_angels_gm = {}
    local gm = private.win_angels_gm

    function gm.default() 
      gm.state_def = {3,6,1,7,8,4,5,2}
      gm.state = ld.TableCopy( gm.state_def )
      gm.state_win = {1,2,3,4,5,6,7,8}
    end

    function gm.save() 
      ng_global.progress["std"]["win_angels"].state = ld.TableCopy( gm.state )
    end

    function gm.event_menter( obj, time_scale, alp )
      if gm.draging then return end
      ld.ShCur(CURSOR_GET)
      time_scale = time_scale or 0.25
      alp = alp or 0.75
      obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
      obj = obj.."_light"
      local o = ObjGet( obj )
      if not o then
        obj = obj:gsub( "_light$", "" )
        o = ObjGet( obj )
      end
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (alp-o.alp)*time_scale,0,alp } )
      end
    end;
  
    function gm.event_mleave( obj, time_scale, alp )
      ld.ShCur(CURSOR_DEFAULT)
      time_scale = time_scale or 0.25
      alp = alp or 0.75
      obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
      obj = obj.."_light"
      local o = ObjGet( obj )
      if not o then
        obj = obj:gsub( "_light$", "" )
        o = ObjGet( obj )
      end
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)*time_scale,0,0 } )
      end
    end;

    function gm.event_mdown(n)

    end

    function gm.event_startdrag(n)
      gm.draging = true
      ld.ShCur(CURSOR_NULL)
      ObjSet( "spr_doortobedroom_"..n, { pos_z = 39 } )
      SoundSfx( "aud_drag_note" )
      gm.set_inpurect( "spr_doortobedroom_"..n, false )
      ObjAttach( "spr_doortobedroom_"..n, "zz_doortobedroom" )
    end

    function gm.set_inpurect( obj, bool )
      ObjSet( obj, { 
        inputrect_init = 1; 
        inputrect_x = bool and -33 or -3; 
        inputrect_y = bool and -23 or -3; 
        inputrect_w = bool and 66 or 6; 
        inputrect_h = bool and 46 or 6; 
      } ); 
    end
    
    function gm.event_dragdrop(n,val)
      ld.Lock(1);
      checkIn = 0;
      SoundSfx( "aud_drop_note" );
      local obj = "spr_doortobedroom_"..n;
      for i = 1, #gm.state do
        if i ~= n and ApplyObj( obj, "spr_doortobedroom_"..i ) then
          ObjSet( obj, { pos_x = 0; pos_y = 0;  pos_z = 0; } )
          gm.set_inpurect( obj, true )
          ObjAttach( obj, "obj_doortobedroom_"..gm.get_place( i ) )
          gm.state[ gm.get_place( i ) ], gm.state[ gm.get_place( n ) ] = gm.state[ gm.get_place( n ) ], gm.state[ gm.get_place( i ) ]
          if not gm.win_check() then
            checkIn = 1;
            ld.StartTimer( 0, function() 
              --ObjStartDrag( "spr_doortobedroom_"..i ); 
              ObjSet("spr_doortobedroom_"..i,{ pos_x = -1000 });
              gm.event_dragdrop(i, true);
              end );
            
          else
            ObjAttach( "spr_doortobedroom_"..i, "obj_doortobedroom_"..gm.get_place( i ) )
          end
          gm.event_end();
          return;
        end
      end
      ObjSet( obj, { pos_x = 0; pos_y = 0;  pos_z = 0; } )
      gm.set_inpurect( obj, true );
      ObjAttach( obj, "obj_doortobedroom_"..gm.get_place( n ) );
      gm.event_mleave( obj );
      gm.draging = false;
      if (val) or checkIn == 0 then
        ld.Lock(0);
      end;
    end

    function gm.event_end(n)
      ld.Lock(0);
      if gm.win_check() then
        gm.win();
      else
        gm.save()
        ld.Lock( 0 );
      end
    end

    function gm.get_place( n )
      for i = 1, #gm.state do
        if gm.state[ i ] == n then
          return i;
        end
      end
    end

    function gm.win_check()
      return ld.TableEquals( gm.state, gm.state_win )
    end

    function gm.init()
      local o;
      for i = 1, #gm.state do
        o = ObjGet( "spr_doortobedroom_"..i )
        ObjSet( o.name, {
          event_startdrag = function() gm.event_startdrag( i ) end;
          event_dragdrop = function() gm.event_dragdrop( i ) end;
          --event_menter = gm.event_menter;
          --event_mleave = gm.event_mleave;
          input = 1;
          drag = 1;
        } )
        common_impl.ObjCreate( o.name.."_light", "spr", o.name, {
          res = o.res;
          blendmode = 2;
          input = 0;
          alp = 0;
        } )
        common_impl.ObjCreate( "obj_doortobedroom_"..i, "obj", "obj_doortobedroom_mmg_root", {
          pos_x = o.pos_x;
          pos_y = o.pos_y;
        } )
      end
    end

    function gm.set_all()
      for i = 1, #gm.state do
        ObjAttach( "spr_doortobedroom_"..gm.state[ i ], "obj_doortobedroom_"..i )
        ObjSet( "spr_doortobedroom_"..gm.state[ i ], { pos_x = 0; pos_y = 0; } )
        gm.set_inpurect( "spr_doortobedroom_"..gm.state[ i ], true )
      end
    end

    gm.default()

    if ng_global.progress["std"]["win_angels"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_angels"].state )
    else

    end

    -->> init and restore objects  >>--
    gm.init()
    gm.set_all()
    --<< init and restore objects <<--
    
    function gm.win()
      public.win_angels()
    end

    function gm.reset()
      if ld.Lock( 1 ) then
        if not ld.TableEquals( gm.state_def, gm.state ) then
          gm.default()
          gm.anim_to_state( gm.state, gm.event_end )
        else
          ld.Lock( 0 )
        end
      end;
    end;

    function gm.skip()
      if ld.Lock( 1 ) then
        gm.state = gm.state_win
        gm.anim_to_state( gm.state, gm.event_end )
      end;
    end;

    function gm.anim_to_state( state, func_end )
      SoundSfx( "aud_skip_doortobedroom" )
      local t = 0.5
      func_end = func_end or function()  end
      local p, obj
      for i = 1, #state do
        obj = "spr_doortobedroom_"..i
        obj_place = "obj_doortobedroom_"..gm.get_place( i )
        p1 = GetObjPosByObj( obj, "obj_doortobedroom_mmg_root" )
        p2 = GetObjPosByObj( obj_place, "obj_doortobedroom_mmg_root" )
        if p1[ 1 ] ~= p2[ 1 ] or p1[ 2 ] ~= p2[ 2 ] then
          ObjAttach( obj, "obj_doortobedroom_mmg_root" )
          ObjSet( obj, { pos_x = p1[ 1 ]; pos_y = p1[ 2 ]; pos_z = 9; } )
          ObjAnimate( obj, 3,0,0, function()
            ObjSet( obj, { pos_x = 0; pos_y = 0; pos_z = 0; } ) 
            ObjAttach( obj, obj_place )
          end, { 0,0,p1[ 1 ],p1[ 2 ], t,3,p2[ 1 ],p2[ 2 ] } )
        end
      end
      ld.StartTimer( t, func_end )
    end

    gm.loaded = true;
  else
    
  end

  if ld.CheckRequirements( { "use_angel" } ) and not ld.CheckRequirements( { "win_angels" } ) then
    cmn.MiniGameShow( "angels" );
  end

end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_doortobedroom" ] = { type = "click", use_place = "gfx_doortobedroom_clk_doortobedroom_zone", room = "rm_secondfloor", zz = "zz_doortobedroom", zz_gate = "gzz_secondfloor_doortobedroom" };

private.clk_doortobedroom_logic = function()
  ObjSet( "grm_secondfloor_bedroom", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_secondfloor_bedroom_focus");
    end;
end;
private.clk_doortobedroom_beg = function()
  ObjDelete( "gfx_doortobedroom_clk_doortobedroom_zone" );
end;
private.clk_doortobedroom_end = function()
  ObjSet( "anm_secondfloor_anim_secondfloor_open_doorbed", { animfunc = "open_doorbed", frame = 999 } )
  if common_impl.ZzCompleteCheck("clk_doortobedroom") then ObjSet( common_impl.hint["clk_doortobedroom"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_doortobedroom", private.clk_doortobedroom_beg, private.room_objname );
cmn.AddSubscriber( "clk_doortobedroom", private.clk_doortobedroom_end, private.room_objname );
cmn.AddSubscriber( "clk_doortobedroom", private.clk_doortobedroom_logic );
cmn.AddSubscriber( "clk_doortobedroom_beg", private.clk_doortobedroom_beg, private.room_objname );
cmn.AddSubscriber( "clk_doortobedroom_end", private.clk_doortobedroom_end, private.room_objname );
cmn.AddSubscriber( "clk_doortobedroom_end", private.clk_doortobedroom_logic );
--------------------------------------------------------------------------------------------
function public.clk_doortobedroom()

  local func_end = function()
    cmn.SetEventDone( "clk_doortobedroom" );
    cmn.CallEventHandler( "clk_doortobedroom_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_doortobedroom") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_doortobedroom_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortobedroom_anm_handle_idle", "handle_open", function() 
    ld.CloseSubRoom()
    ld.AnimPlay( "anm_secondfloor_anim_secondfloor_open_doorbed", "open_doorbed", func_end )
  end );
  SoundSfx( "aud_open_doortobedroom" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_floorshelfs *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_tweezers" ] = { type = "get", get_obj = "spr_floorshelfs_tweezers", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.get_tweezers_logic = function()
  
end;
private.get_tweezers_inv = function()
  interface.InventoryItemAdd("inv_tweezers","spr_floorshelfs_tweezers");
end;
private.get_tweezers_beg = function()
  ObjDelete("gfx_floorshelfs_tweezers")
end;
private.get_tweezers_end = function()
  ObjDelete( "spr_floorshelfs_shadow" )
  if common_impl.ZzCompleteCheck("get_tweezers") then ObjSet( common_impl.hint["get_tweezers"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_tweezers", private.get_tweezers_inv );
cmn.AddSubscriber( "get_tweezers", private.get_tweezers_beg, private.room_objname );
cmn.AddSubscriber( "get_tweezers", private.get_tweezers_end, private.room_objname );
cmn.AddSubscriber( "get_tweezers", private.get_tweezers_logic );
--------------------------------------------------------------------
function public.get_tweezers()
  cmn.SetEventDone( "get_tweezers" );
  cmn.CallEventHandler( "get_tweezers" );
  if common_impl.ZzCompleteCheck("get_tweezers") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_aflamesparkler" ] = { type = "use", inv_obj = "inv_aflamesparkler", use_place = "gfx_floorshelfs_aflamesparkler_zone", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.use_aflamesparkler_logic = function()
  ObjSet( "gfx_floorshelfs_tweezers_floorshelfs1_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_aflamesparkler_inv = function()
  common_impl.ProcessMultiUseAll("aflamesparkler", "aflamesparkler")
end;
private.use_aflamesparkler_beg = function()
  ObjDelete( "gfx_floorshelfs_aflamesparkler_zone" );
end;
private.use_aflamesparkler_end = function()
  ObjDelete( "spr_secondfloor_candle" )
  ObjSet( "anm_floorshelfs_anm_shelf_use_sparkle", { animfunc = "collect_angel", frame = 0 } )
  if common_impl.ZzCompleteCheck("use_aflamesparkler") then ObjSet( common_impl.hint["use_aflamesparkler"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_aflamesparkler", private.use_aflamesparkler_inv );
cmn.AddSubscriber( "use_aflamesparkler", private.use_aflamesparkler_beg, private.room_objname );
cmn.AddSubscriber( "use_aflamesparkler", private.use_aflamesparkler_end, private.room_objname );
cmn.AddSubscriber( "use_aflamesparkler", private.use_aflamesparkler_logic );
cmn.AddSubscriber( "use_aflamesparkler_inv", private.use_aflamesparkler_inv, private.room_objname );
cmn.AddSubscriber( "use_aflamesparkler_beg", private.use_aflamesparkler_beg, private.room_objname );
cmn.AddSubscriber( "use_aflamesparkler_end", private.use_aflamesparkler_end, private.room_objname );
cmn.AddSubscriber( "use_aflamesparkler_end", private.use_aflamesparkler_logic );
--------------------------------------------------------------------------------------------
function public.use_aflamesparkler( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_aflamesparkler" );
    cmn.CallEventHandler( "use_aflamesparkler_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_aflamesparkler") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_aflamesparkler_inv" );
  cmn.CallEventHandler( "use_aflamesparkler_beg" );
  common_impl.Lock(1);

  ObjSet( "fx_floorshelfs_sparkle_fx", { active = 1 } )
  PartSysRestart( "fx_floorshelfs_sparkle_fx" )
  ObjAnimate( "fx_floorshelfs_sparkle_fx", 8, 0, 0, "", { 0, 0, 0, 0.15, 0, 0.5, 0.3167, 0, 1, 1.5833, 0, 1, 1.7, 0, 0.5, 1.8, 0, 0 } )
  ObjAnimate( "fx_floorshelfs_sparkle_fx", 1, 0, 0, "", { 0, 0, -165.1635, 0.15, 0, -179.1693, 0.3167, 0, -185.8763, 0.8833, 0, -231.0301, 1.1333, 0, -198.7182, 1.45, 0, -198.3039, 1.5833, 0, -223.3034, 1.7, 0, -244.3481, 1.8, 0, -257.9568 } )
  ObjAnimate( "fx_floorshelfs_sparkle_fx", 0, 0, 0, "", { 0, 0, 67.218, 0.15, 0, 44.4142, 0.3167, 0, 24.5497, 0.8833, 0, -76.5287, 1.1333, 0, -91.0277, 1.45, 0, -90.1992, 1.5833, 0, -66.5686, 1.8, 0, -16.0474 } )


  ld.AnimPlay( "anm_floorshelfs_anm_shelf_use_sparkle", "use_sparkle", func_end );
  SoundSfx( "aud_use_aflamesparkler_floorshelfs" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_tweezers_floorshelfs1" ] = { type = "use", inv_obj = "inv_tweezers", use_place = "gfx_floorshelfs_tweezers_floorshelfs1_zone", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.use_tweezers_floorshelfs1_logic = function()
  ObjSet( "spr_floorshelfs_angel", { visible = 1, input = 1, active = 1 } )
end;
private.use_tweezers_floorshelfs1_inv = function()
  common_impl.ProcessMultiUseAll("tweezers", "tweezers_floorshelfs1")
end;
private.use_tweezers_floorshelfs1_beg = function()
  ObjDelete( "gfx_floorshelfs_tweezers_floorshelfs1_zone" );
end;
private.use_tweezers_floorshelfs1_end = function()
  if common_impl.ZzCompleteCheck("use_tweezers_floorshelfs1") then ObjSet( common_impl.hint["use_tweezers_floorshelfs1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tweezers_floorshelfs1", private.use_tweezers_floorshelfs1_inv );
cmn.AddSubscriber( "use_tweezers_floorshelfs1", private.use_tweezers_floorshelfs1_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs1", private.use_tweezers_floorshelfs1_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs1", private.use_tweezers_floorshelfs1_logic );
cmn.AddSubscriber( "use_tweezers_floorshelfs1_inv", private.use_tweezers_floorshelfs1_inv, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs1_beg", private.use_tweezers_floorshelfs1_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs1_end", private.use_tweezers_floorshelfs1_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs1_end", private.use_tweezers_floorshelfs1_logic );
--------------------------------------------------------------------------------------------
function public.use_tweezers_floorshelfs1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tweezers_floorshelfs1" );
    cmn.CallEventHandler( "use_tweezers_floorshelfs1_end" );
    common_impl.Lock(0);
    public.get_angel()
    ld.InvSetDropable( obj, true )
  end;

  ObjSet(obj,{visible = 0});
  ld.InvSetDropable( obj, false )
  cmn.CallEventHandler( "use_tweezers_floorshelfs1_inv" );
  cmn.CallEventHandler( "use_tweezers_floorshelfs1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_floorshelfs_anm_shelf_use_sparkle", "collect_angel", func_end );
  SoundSfx( "aud_use_tweezers_floorshelfs" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_angel" ] = { type = "get", get_obj = "spr_floorshelfs_angel", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.get_angel_logic = function()
  ObjSet( "gfx_floorshelfs_tweezers_floorshelfs2_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_angel_inv = function()
  interface.InventoryItemAdd("inv_angel","spr_floorshelfs_angel");
end;
private.get_angel_beg = function()
  ObjDelete("gfx_floorshelfs_angel")
end;
private.get_angel_end = function()
  ObjSet( "anm_floorshelfs_anm_shelf_use_sparkle", { animfunc = "collect_candy", frame = 0 } )
  if common_impl.ZzCompleteCheck("get_angel") then ObjSet( common_impl.hint["get_angel"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_angel", private.get_angel_inv );
cmn.AddSubscriber( "get_angel", private.get_angel_beg, private.room_objname );
cmn.AddSubscriber( "get_angel", private.get_angel_end, private.room_objname );
cmn.AddSubscriber( "get_angel", private.get_angel_logic );
--------------------------------------------------------------------
function public.get_angel()
  cmn.SetEventDone( "get_angel" );
  cmn.CallEventHandler( "get_angel" );
  if common_impl.ZzCompleteCheck("get_angel") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_tweezers_floorshelfs2" ] = { type = "use", inv_obj = "inv_tweezers", use_place = "gfx_floorshelfs_tweezers_floorshelfs2_zone", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.use_tweezers_floorshelfs2_logic = function()
  ObjSet( "spr_floorshelfs_candy2", { visible = 1, input = 1, active = 1 } )
end;
private.use_tweezers_floorshelfs2_inv = function()
  common_impl.ProcessMultiUseAll("tweezers", "tweezers_floorshelfs2")
end;
private.use_tweezers_floorshelfs2_beg = function()
  ObjDelete( "gfx_floorshelfs_tweezers_floorshelfs2_zone" );
end;
private.use_tweezers_floorshelfs2_end = function()
  if common_impl.ZzCompleteCheck("use_tweezers_floorshelfs2") then ObjSet( common_impl.hint["use_tweezers_floorshelfs2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tweezers_floorshelfs2", private.use_tweezers_floorshelfs2_inv );
cmn.AddSubscriber( "use_tweezers_floorshelfs2", private.use_tweezers_floorshelfs2_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs2", private.use_tweezers_floorshelfs2_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs2", private.use_tweezers_floorshelfs2_logic );
cmn.AddSubscriber( "use_tweezers_floorshelfs2_inv", private.use_tweezers_floorshelfs2_inv, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs2_beg", private.use_tweezers_floorshelfs2_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs2_end", private.use_tweezers_floorshelfs2_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_floorshelfs2_end", private.use_tweezers_floorshelfs2_logic );
--------------------------------------------------------------------------------------------
function public.use_tweezers_floorshelfs2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tweezers_floorshelfs2" );
    cmn.CallEventHandler( "use_tweezers_floorshelfs2_end" );
    common_impl.Lock(0);
    public.get_candy2()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tweezers_floorshelfs2_inv" );
  cmn.CallEventHandler( "use_tweezers_floorshelfs2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_floorshelfs_anm_shelf_use_sparkle", "collect_candy", func_end );
  SoundSfx( "aud_use_tweezers_floorshelfs" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_candy2" ] = { type = "get", get_obj = "spr_floorshelfs_candy2", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.get_candy2_logic = function()
  
end;
private.get_candy2_inv = function()
  interface.InventoryItemAdd("inv_candy","spr_floorshelfs_candy2",function() level_inv.ProcessGetCandyAll( "get_candy2" ) end);
end;
private.get_candy2_beg = function()
  ObjDelete("gfx_floorshelfs_candy2")
end;
private.get_candy2_end = function()
  ObjSet( "anm_floorshelfs_anm_shelf_use_sparkle", { animfunc = "collect_candy_end", frame = 0 } )
  if common_impl.ZzCompleteCheck("get_candy2") then ObjSet( common_impl.hint["get_candy2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_candy2", private.get_candy2_inv );
cmn.AddSubscriber( "get_candy2", private.get_candy2_beg, private.room_objname );
cmn.AddSubscriber( "get_candy2", private.get_candy2_end, private.room_objname );
cmn.AddSubscriber( "get_candy2", private.get_candy2_logic );
--------------------------------------------------------------------
function public.get_candy2()
  cmn.SetEventDone( "get_candy2" );
  cmn.CallEventHandler( "get_candy2" );
  if common_impl.ZzCompleteCheck("get_candy2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_figure" ] = { type = "use", inv_obj = "inv_figure", use_place = "gfx_floorshelfs_figure_zone", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.use_figure_logic = function()
  ObjSet( "obj_floorshelfs_win_figures_root", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_floorshelfs_hoof_zone", { visible = 0, input = 0, active = 0 } )
end;
private.use_figure_inv = function()
  common_impl.ProcessMultiUseAll("figure", "figure")
end;
private.use_figure_beg = function()
  ObjDelete( "gfx_floorshelfs_figure_zone" );
  ObjSet( "obj_floorshelfs_win_figures_root", { pos_z = 9 } )
  ObjSet( "anm_floorshelfs_anm_shelf_mmg_sample_start", { pos_z = 8.9 } )
end;
private.use_figure_end = function()
  ObjSet( "spr_secondfloor_ded_moroz", { visible = 1 } )
  ObjSet( "anm_floorshelfs_anm_shelf_mmg_1", { alp = 1 } )
  ObjDelete( "anm_floorshelfs_anm_shelf_use_ded" )
  ObjSet( "anm_floorshelfs_anm_shelf_mmg_sample_start", { animfunc = "mmg_sample_end", frame = 0 } )
  if common_impl.ZzCompleteCheck("use_figure") then ObjSet( common_impl.hint["use_figure"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_figure", private.use_figure_inv );
cmn.AddSubscriber( "use_figure", private.use_figure_beg, private.room_objname );
cmn.AddSubscriber( "use_figure", private.use_figure_end, private.room_objname );
cmn.AddSubscriber( "use_figure", private.use_figure_logic );
cmn.AddSubscriber( "use_figure_inv", private.use_figure_inv, private.room_objname );
cmn.AddSubscriber( "use_figure_beg", private.use_figure_beg, private.room_objname );
cmn.AddSubscriber( "use_figure_end", private.use_figure_end, private.room_objname );
cmn.AddSubscriber( "use_figure_end", private.use_figure_logic );
--------------------------------------------------------------------------------------------
function public.use_figure( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_figure" );
    cmn.CallEventHandler( "use_figure_end" );
    common_impl.Lock(0);
    cmn.MiniGameShow( "figures" );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_figure_inv" );
  cmn.CallEventHandler( "use_figure_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_floorshelfs_anm_shelf_mmg_sample_start", "mmg_sample_start", _ )

  ld.AnimPlay( "anm_floorshelfs_anm_shelf_use_ded", "use_ded", func_end );
  SoundSfx( "aud_use_figure_floorshelfs" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_figures" ] = { type = "click", use_place = "obj_floorshelfs_win_figures_root", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.win_figures_logic = function()
  if ld.CheckRequirements( { "win_figures" } ) then
    ObjSet( "gfx_floorshelfs_hoof_zone", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_floorshelfs_bulb", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_floorshelfs_apron", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_figures_beg = function()

end;
private.win_figures_end = function()
  if ld.CheckRequirements( { "win_figures" } ) then
    ObjSet( "gfx_floorshelfs_bulb", { visible = 1, active = 1 } )
    ObjSet( "gfx_floorshelfs_apron", { visible = 1, active = 1 } )
    ObjDelete( "spr_secondfloor_ded_moroz" )
    ObjDelete( "spr_secondfloor_shelf_box_close" )
    ObjSet( "spr_secondfloor_shelf_box_open", { visible = 1 } )
    ObjDelete( "obj_floorshelfs_win_figures_root" )
    ObjSet( "anm_floorshelfs_anm_shelf_click_box", { animfunc = "open_box_end"; frame = 0; } )
    ObjSet( "anm_floorshelfs_anm_shelf_mmg_sample_start", { animfunc = "mmg_sample_start", frame = 0, pos_z = 3 } )
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_figures", private.win_figures_beg, private.room_objname );
cmn.AddSubscriber( "win_figures", private.win_figures_end, private.room_objname );
cmn.AddSubscriber( "win_figures", private.win_figures_logic );
cmn.AddSubscriber( "win_figures_beg", private.win_figures_beg, private.room_objname );
cmn.AddSubscriber( "win_figures_end", private.win_figures_end, private.room_objname );
cmn.AddSubscriber( "win_figures_end", private.win_figures_logic );
--------------------------------------------------------------------------------------------
function public.win_figures()

  local func_end = function()
    cmn.SetEventDone( "win_figures" );
    cmn.CallEventHandler( "win_figures_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_figures") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_figures_beg" );
  common_impl.Lock(1);
  cmn.MiniGameHide( "figures", true );

  ObjSet( "anm_floorshelfs_anm_shelf_click_box", { pos_z = 9.1 } )
  ld.AnimPlay( "anm_floorshelfs_anm_shelf_mmg_sample_start", "mmg_sample_end", _ )
  ld.AnimPlay( "anm_floorshelfs_anm_shelf_click_box", "open_box", func_end );
  SoundSfx( "aud_open_santas_box" )

end;
function public.win_figures_load()
  if not private.win_figures_gm then
    private.win_figures_gm = {}
    local gm = private.win_figures_gm

    function gm.default() 
      gm.state_def = { 3, 2, 3, 2 }
      gm.state = ld.TableCopy( gm.state_def )
      gm.state_win = { 1, 1, 1, 1 }
    end

    function gm.save() 
      ng_global.progress["std"]["win_figures"].state = ld.TableCopy( gm.state )
    end

    function gm.event_menter( obj, time_scale, alp )
      ld.ShCur(CURSOR_HAND)
      time_scale = time_scale or 0.25
      alp = alp or 0.5
      obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
      obj = obj.."_light"
      local o = ObjGet( obj )
      if not o then
        obj = obj:gsub( "_light$", "" )
        o = ObjGet( obj )
      end
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (alp-o.alp)*time_scale,0,alp } )
      end
    end;

    function gm.event_mleave( obj, time_scale, alp )
      ld.ShCur(CURSOR_DEFAULT)
      time_scale = time_scale or 0.25
      alp = alp or 0.5
      obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
      obj = obj.."_light"
      local o = ObjGet( obj )
      if not o then
        obj = obj:gsub( "_light$", "" )
        o = ObjGet( obj )
      end
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)*time_scale,0,0 } )
      end
    end;

    function gm.change( n, value, func_end )
      SoundSfx( "aud_figurine_change_pose" )
      local t = 0.25
      local num_next = value or ( gm.state[ n ] % gm.nums + 1 )
      local o = ObjGet( "anm_floorshelfs_anm_shelf_mmg_"..n )
      ObjSet( "anm_floorshelfs_anm_shelf_mmg_0", { animfunc = gm.names[ n ]..num_next, pos_z = o.pos_z } )
      ObjAnimate( o.name, 8,0,0, _, { 0,0,1, t,1,0 } )
      ObjAnimate( "anm_floorshelfs_anm_shelf_mmg_0", 8,0,0, _, { 0,0,0, t,2,1 } )
      ld.StartTimer( t, function() 
        gm.state[ n ] = num_next
        ObjSet( o.name, { animfunc = gm.names[ n ]..num_next; alp = 1; } )
        ObjSet( "anm_floorshelfs_anm_shelf_mmg_0", { alp = 0 } )
        if func_end then
          func_end()
        else
          gm.event_end()
        end
      end )
    end

    function gm.event_mdown( n )
      if ld.Lock( 1 ) then
        gm.change( n )
      end
    end

    function gm.event_end()
      if gm.win_check() then
        gm.win()
      else
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.win_check()
      return ld.TableEquals( gm.state, gm.state_win )
    end

    function gm.init()
      gm.names = {
        "anim_ded";
        "anim_santa";
        "anim_poncho";
        "anim_china";
      }
      gm.nums = 3;
      for i = 1, #gm.state do
        ObjSet( "obj_floorshelfs_mmg_"..i, {
          event_mdown = function() gm.event_mdown( i ) end;
          event_menter = gm.event_menter;
          event_mleave = gm.event_mleave;
        } )
      end
    end

    function gm.set_all()
      for i = 1, #gm.state do
        ObjSet( "anm_floorshelfs_anm_shelf_mmg_"..i, {
          animfunc = gm.names[ i ]..gm.state[ i ];
        } )
      end
    end

    gm.default()

    if ng_global.progress["std"]["win_tag"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_tag"].state )
    else

    end

    -->> init and restore objects  >>--
    gm.init()
    gm.set_all()
    --<< init and restore objects <<--
    
    function gm.win()
      ObjDelete( "obj_floorshelfs_win_figures_root" )
      public.win_figures()
    end

    function gm.reset( n )
      if ld.Lock( 1 ) then
        if not ld.TableEquals( gm.state_def, gm.state ) then
          local func_end = function() 
            --gm.default()
            --gm.set_all()
            gm.save()
            ld.Lock( 0 )
          end
          local change = function() 
          end
          change = function() 
            for i = 1, #gm.state_def do
              if gm.state[ i ] ~= gm.state_def[ i ] then
                gm.change( i, gm.state_def[ i ], change )
                return
              end
            end
            func_end()
          end
          change()
        else
          ld.Lock( 0 )
        end
      end;
    end;

    function gm.skip()
      if ld.Lock( 1 ) then
        local func_end = function() 
          gm.win()
        end
        local change = function() 
        end
        change = function() 
          for i = 1, #gm.state_win do
            if gm.state[ i ] ~= gm.state_win[ i ] then
              gm.change( i, gm.state_win[ i ], change )
              return
            end
          end
          func_end()
        end
        change()
      end;
    end;

    gm.loaded = true;
  else
    
  end

  if ld.CheckRequirements( { "use_figure" } ) and not ld.CheckRequirements( { "win_figures" } ) then
    cmn.MiniGameShow( "figures" );
  end

end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bulb" ] = { type = "get", get_obj = "spr_floorshelfs_bulb", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.get_bulb_logic = function()
  
end;
private.get_bulb_inv = function()
  interface.InventoryItemAdd("inv_bulb","spr_floorshelfs_bulb");
end;
private.get_bulb_beg = function()
  ObjDelete("gfx_floorshelfs_bulb")
end;
private.get_bulb_end = function()
  if common_impl.ZzCompleteCheck("get_bulb") then ObjSet( common_impl.hint["get_bulb"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bulb", private.get_bulb_inv );
cmn.AddSubscriber( "get_bulb", private.get_bulb_beg, private.room_objname );
cmn.AddSubscriber( "get_bulb", private.get_bulb_end, private.room_objname );
cmn.AddSubscriber( "get_bulb", private.get_bulb_logic );
--------------------------------------------------------------------
function public.get_bulb()
  cmn.SetEventDone( "get_bulb" );
  cmn.CallEventHandler( "get_bulb" );
  if common_impl.ZzCompleteCheck("get_bulb") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_apron" ] = { type = "get", get_obj = "spr_floorshelfs_apron", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.get_apron_logic = function()
  
end;
private.get_apron_inv = function()
  interface.InventoryItemAdd("inv_apron","spr_floorshelfs_apron");
end;
private.get_apron_beg = function()
  ObjDelete("gfx_floorshelfs_apron")
end;
private.get_apron_end = function()
  if common_impl.ZzCompleteCheck("get_apron") then ObjSet( common_impl.hint["get_apron"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_apron", private.get_apron_inv );
cmn.AddSubscriber( "get_apron", private.get_apron_beg, private.room_objname );
cmn.AddSubscriber( "get_apron", private.get_apron_end, private.room_objname );
cmn.AddSubscriber( "get_apron", private.get_apron_logic );
--------------------------------------------------------------------
function public.get_apron()
  cmn.SetEventDone( "get_apron" );
  cmn.CallEventHandler( "get_apron" );
  if common_impl.ZzCompleteCheck("get_apron") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hoof" ] = { type = "use", inv_obj = "inv_hoof", use_place = "gfx_floorshelfs_hoof_zone", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.use_hoof_logic = function()
  ObjSet( "spr_floorshelfs_loupe", { visible = 1, input = 1, active = 1 } )
end;
private.use_hoof_inv = function()
  common_impl.ProcessMultiUseAll("hoof", "hoof")
end;
private.use_hoof_beg = function()
  ObjDelete( "gfx_floorshelfs_hoof_zone" );
end;
private.use_hoof_end = function()
  ObjSet( "spr_secondfloor_hand_open", { visible = 1 } )
  ObjSet( "anm_floorshelfs_anm_shelf_use_hoof", { animfunc = "use_hoof_end", frame = 0 } )
  if common_impl.ZzCompleteCheck("use_hoof") then ObjSet( common_impl.hint["use_hoof"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hoof", private.use_hoof_inv );
cmn.AddSubscriber( "use_hoof", private.use_hoof_beg, private.room_objname );
cmn.AddSubscriber( "use_hoof", private.use_hoof_end, private.room_objname );
cmn.AddSubscriber( "use_hoof", private.use_hoof_logic );
cmn.AddSubscriber( "use_hoof_inv", private.use_hoof_inv, private.room_objname );
cmn.AddSubscriber( "use_hoof_beg", private.use_hoof_beg, private.room_objname );
cmn.AddSubscriber( "use_hoof_end", private.use_hoof_end, private.room_objname );
cmn.AddSubscriber( "use_hoof_end", private.use_hoof_logic );
--------------------------------------------------------------------------------------------
function public.use_hoof( obj )

  local func_end = function()
    ObjSet( "anm_floorshelfs_anm_shelf_use_hoof", { pos_z = 5 } )
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hoof" );
    cmn.CallEventHandler( "use_hoof_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hoof") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hoof_inv" );
  cmn.CallEventHandler( "use_hoof_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_floorshelfs_anm_shelf_use_hoof", { pos_z = 7 } )
  ld.AnimPlay( "anm_floorshelfs_anm_shelf_use_hoof", "use_hoof", func_end );
  SoundSfx( "aud_use_hoof_floorshelfs" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_loupe" ] = { type = "get", get_obj = "spr_floorshelfs_loupe", room = "rm_secondfloor", zz = "zz_floorshelfs", zz_gate = "gzz_secondfloor_floorshelfs" };

private.get_loupe_logic = function()
  
end;
private.get_loupe_inv = function()
  interface.InventoryItemAdd("inv_loupe","spr_floorshelfs_loupe");
end;
private.get_loupe_beg = function()
  ObjDelete("gfx_floorshelfs_loupe")
end;
private.get_loupe_end = function()
  ObjDelete( "spr_secondfloor_loupe" )
  if common_impl.ZzCompleteCheck("get_loupe") then ObjSet( common_impl.hint["get_loupe"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_loupe", private.get_loupe_inv );
cmn.AddSubscriber( "get_loupe", private.get_loupe_beg, private.room_objname );
cmn.AddSubscriber( "get_loupe", private.get_loupe_end, private.room_objname );
cmn.AddSubscriber( "get_loupe", private.get_loupe_logic );
--------------------------------------------------------------------
function public.get_loupe()
  cmn.SetEventDone( "get_loupe" );
  cmn.CallEventHandler( "get_loupe" );
  if common_impl.ZzCompleteCheck("get_loupe") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doortodressroom *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_tweezers_doortodressroom1" ] = { type = "use", inv_obj = "inv_tweezers", use_place = "gfx_doortodressroom_tweezers_doortodressroom1_zone", room = "rm_secondfloor", zz = "zz_doortodressroom", zz_gate = "gzz_secondfloor_doortodressroom" };

private.use_tweezers_doortodressroom1_logic = function()
  ObjSet( "spr_doortodressroom_woodhorse", { visible = 1, input = 1, active = 1 } )
end;
private.use_tweezers_doortodressroom1_inv = function()
  common_impl.ProcessMultiUseAll("tweezers", "tweezers_doortodressroom")
end;
private.use_tweezers_doortodressroom1_beg = function()
  ObjDelete( "gfx_doortodressroom_tweezers_doortodressroom1_zone" );
end;
private.use_tweezers_doortodressroom1_end = function()
  ObjSet( "anm_doortodressroom_anim_doortodressroom_use_tweezers_horse", { animfunc = "use_tweezers_candy", frame = 0 } )
  if common_impl.ZzCompleteCheck("use_tweezers_doortodressroom1") then ObjSet( common_impl.hint["use_tweezers_doortodressroom1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tweezers_doortodressroom1", private.use_tweezers_doortodressroom1_inv );
cmn.AddSubscriber( "use_tweezers_doortodressroom1", private.use_tweezers_doortodressroom1_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom1", private.use_tweezers_doortodressroom1_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom1", private.use_tweezers_doortodressroom1_logic );
cmn.AddSubscriber( "use_tweezers_doortodressroom1_inv", private.use_tweezers_doortodressroom1_inv, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom1_beg", private.use_tweezers_doortodressroom1_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom1_end", private.use_tweezers_doortodressroom1_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom1_end", private.use_tweezers_doortodressroom1_logic );
--------------------------------------------------------------------------------------------
function public.use_tweezers_doortodressroom1( obj )

  if private.use_tweezers_doortodressroom1 then return end

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tweezers_doortodressroom1" );
    cmn.CallEventHandler( "use_tweezers_doortodressroom1_end" );
    common_impl.Lock(0);
    public.get_woodhorse()
    ld.InvSetDropable( obj, true )
  end;

    ld.InvSetDropable( obj, false )

    ObjSet(obj,{visible = 0});

    cmn.CallEventHandler( "use_tweezers_doortodressroom1_inv" );
    cmn.CallEventHandler( "use_tweezers_doortodressroom1_beg" );
    common_impl.Lock(1);

    ld.AnimPlay( "anm_doortodressroom_anim_doortodressroom_use_tweezers_horse", "use_tweezers_horse", func_end );
    SoundSfx( "aud_use_tweezers_doortodressroom" )

  --end

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_woodhorse" ] = { type = "get", get_obj = "spr_doortodressroom_woodhorse", room = "rm_secondfloor", zz = "zz_doortodressroom", zz_gate = "gzz_secondfloor_doortodressroom" };

private.get_woodhorse_logic = function()
  ObjSet( "gfx_doortodressroom_tweezers_doortodressroom2_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_woodhorse_inv = function()
  interface.InventoryItemAdd("inv_woodhorse","spr_doortodressroom_woodhorse");
end;
private.get_woodhorse_beg = function()
  ObjDelete("gfx_doortodressroom_woodhorse")
end;
private.get_woodhorse_end = function()
  ObjDelete( "spr_secondfloor_horse" )
  if common_impl.ZzCompleteCheck("get_woodhorse") then ObjSet( common_impl.hint["get_woodhorse"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_woodhorse", private.get_woodhorse_inv );
cmn.AddSubscriber( "get_woodhorse", private.get_woodhorse_beg, private.room_objname );
cmn.AddSubscriber( "get_woodhorse", private.get_woodhorse_end, private.room_objname );
cmn.AddSubscriber( "get_woodhorse", private.get_woodhorse_logic );
--------------------------------------------------------------------
function public.get_woodhorse()
  cmn.SetEventDone( "get_woodhorse" );
  cmn.CallEventHandler( "get_woodhorse" );
  if common_impl.ZzCompleteCheck("get_woodhorse") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_tweezers_doortodressroom2" ] = { type = "use", inv_obj = "inv_tweezers", use_place = "gfx_doortodressroom_tweezers_doortodressroom2_zone", room = "rm_secondfloor", zz = "zz_doortodressroom", zz_gate = "gzz_secondfloor_doortodressroom" };

private.use_tweezers_doortodressroom2_logic = function()
  ObjSet( "spr_doortodressroom_candy1", { visible = 1, input = 1, active = 1 } )
end;
private.use_tweezers_doortodressroom2_inv = function()
  common_impl.ProcessMultiUseAll("tweezers", "tweezers_doortodressroom2")
end;
private.use_tweezers_doortodressroom2_beg = function()
  ObjDelete( "gfx_doortodressroom_tweezers_doortodressroom2_zone" );
end;
private.use_tweezers_doortodressroom2_end = function()
  ObjSet( "anm_doortodressroom_anim_doortodressroom_use_tweezers_horse", { animfunc = "use_tweezers_candy_end", frame = 0 } )
  if common_impl.ZzCompleteCheck("use_tweezers_doortodressroom2") then ObjSet( common_impl.hint["use_tweezers_doortodressroom2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tweezers_doortodressroom2", private.use_tweezers_doortodressroom2_inv );
cmn.AddSubscriber( "use_tweezers_doortodressroom2", private.use_tweezers_doortodressroom2_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom2", private.use_tweezers_doortodressroom2_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom2", private.use_tweezers_doortodressroom2_logic );
cmn.AddSubscriber( "use_tweezers_doortodressroom2_inv", private.use_tweezers_doortodressroom2_inv, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom2_beg", private.use_tweezers_doortodressroom2_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom2_end", private.use_tweezers_doortodressroom2_end, private.room_objname );
cmn.AddSubscriber( "use_tweezers_doortodressroom2_end", private.use_tweezers_doortodressroom2_logic );
--------------------------------------------------------------------------------------------
function public.use_tweezers_doortodressroom2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tweezers_doortodressroom2" );
    cmn.CallEventHandler( "use_tweezers_doortodressroom2_end" );
    common_impl.Lock(0);
    public.get_candy1()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tweezers_doortodressroom2_inv" );
  cmn.CallEventHandler( "use_tweezers_doortodressroom2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortodressroom_anim_doortodressroom_use_tweezers_horse", "use_tweezers_candy", func_end );
  SoundSfx( "aud_use_tweezers_doortodressroom" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_candy1" ] = { type = "get", get_obj = "spr_doortodressroom_candy1", room = "rm_secondfloor", zz = "zz_doortodressroom", zz_gate = "gzz_secondfloor_doortodressroom" };

private.get_candy1_logic = function()
  
end;
private.get_candy1_inv = function()
  interface.InventoryItemAdd("inv_candy","spr_doortodressroom_candy1",function() level_inv.ProcessGetCandyAll( "get_candy1" ) end);
end;
private.get_candy1_beg = function()
  ObjDelete("gfx_doortodressroom_candy1")
end;
private.get_candy1_end = function()
  ObjDelete( "spr_secondfloor_candy" )
  if common_impl.ZzCompleteCheck("get_candy1") then ObjSet( common_impl.hint["get_candy1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_candy1", private.get_candy1_inv );
cmn.AddSubscriber( "get_candy1", private.get_candy1_beg, private.room_objname );
cmn.AddSubscriber( "get_candy1", private.get_candy1_end, private.room_objname );
cmn.AddSubscriber( "get_candy1", private.get_candy1_logic );
--------------------------------------------------------------------
function public.get_candy1()
  cmn.SetEventDone( "get_candy1" );
  cmn.CallEventHandler( "get_candy1" );
  if common_impl.ZzCompleteCheck("get_candy1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_key" ] = { type = "use", inv_obj = "inv_key", use_place = "gfx_doortodressroom_key_zone", room = "rm_secondfloor", zz = "zz_doortodressroom", zz_gate = "gzz_secondfloor_doortodressroom" };

private.use_key_logic = function()
  ObjSet( "grm_secondfloor_dressroom", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_secondfloor_dressroom_focus");
    end;
end;
private.use_key_inv = function()
  common_impl.ProcessMultiUseAll("key", "key")
end;
private.use_key_beg = function()
  ObjDelete( "gfx_doortodressroom_key_zone" );
end;
private.use_key_end = function()
  ObjSet( "anm_secondfloor_anim_secondfloor_open_doordress", { animfunc = "open_doordress", frame = 999 } )
  if common_impl.ZzCompleteCheck("use_key") then ObjSet( common_impl.hint["use_key"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_key", private.use_key_inv );
cmn.AddSubscriber( "use_key", private.use_key_beg, private.room_objname );
cmn.AddSubscriber( "use_key", private.use_key_end, private.room_objname );
cmn.AddSubscriber( "use_key", private.use_key_logic );
cmn.AddSubscriber( "use_key_inv", private.use_key_inv, private.room_objname );
cmn.AddSubscriber( "use_key_beg", private.use_key_beg, private.room_objname );
cmn.AddSubscriber( "use_key_end", private.use_key_end, private.room_objname );
cmn.AddSubscriber( "use_key_end", private.use_key_logic );
--------------------------------------------------------------------------------------------
function public.use_key( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_key" );
    cmn.CallEventHandler( "use_key_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_key_inv" );
  cmn.CallEventHandler( "use_key_beg" );
  common_impl.Lock(1);
  
  ObjSet( "anm_doortodressroom_anim_doortodressroom_use_key", { pos_z = 7.1 } )

  ld.AnimPlay( "anm_doortodressroom_anim_doortodressroom_use_key", "use_key", function() 
    ld.CloseSubRoom()
    ld.AnimPlay( "anm_secondfloor_anim_secondfloor_open_doordress", "open_doordress", func_end )
  end );
  SoundSfx( "aud_use_key_doortodressroom" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_phonetable *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bear" ] = { type = "use", inv_obj = "inv_bear", use_place = "gfx_phonetable_bear_zone", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.use_bear_logic = function()
  if ld.CheckRequirements( {"use_wolf","use_bear"} ) then
    ObjSet( "gfx_phonetable_clk_phonetablecsket_zone", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_bear_inv = function()
  common_impl.ProcessMultiUseAll("bear", "bear")
end;
private.use_bear_beg = function()
  ObjDelete( "gfx_phonetable_bear_zone" );
  ObjSet( "spr_phonetable_bear", { visible = 1 } )
end;
private.use_bear_end = function()
  if ld.CheckRequirements( {"use_wolf","use_bear"} ) then
    ObjSet( "anm_phonetable_anm_cap_idle", { animfunc = "open_cap", frame = 0 } )
  end
  if common_impl.ZzCompleteCheck("use_bear") then ObjSet( common_impl.hint["use_bear"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bear", private.use_bear_inv );
cmn.AddSubscriber( "use_bear", private.use_bear_beg, private.room_objname );
cmn.AddSubscriber( "use_bear", private.use_bear_end, private.room_objname );
cmn.AddSubscriber( "use_bear", private.use_bear_logic );
cmn.AddSubscriber( "use_bear_inv", private.use_bear_inv, private.room_objname );
cmn.AddSubscriber( "use_bear_beg", private.use_bear_beg, private.room_objname );
cmn.AddSubscriber( "use_bear_end", private.use_bear_end, private.room_objname );
cmn.AddSubscriber( "use_bear_end", private.use_bear_logic );
--------------------------------------------------------------------------------------------
function public.use_bear( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bear" );
    cmn.CallEventHandler( "use_bear_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bear") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bear_inv" );
  cmn.CallEventHandler( "use_bear_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_phonetable_anm_cap_idle", "use_bear", function() 
    if ld.CheckRequirements( {"use_wolf","use_bear"}, true ) == 1 then
      SoundSfx( "aud_unlock_phonetable_box" )
      ld.AnimPlay( "anm_phonetable_anm_cap_idle", "open_lock", func_end )
    else
      func_end()
    end
  end );
  SoundSfx( "aud_use_bear_phonetable" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wolf" ] = { type = "use", inv_obj = "inv_wolf", use_place = "gfx_phonetable_wolf_zone", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.use_wolf_logic = function()
  if ld.CheckRequirements( {"use_wolf","use_bear"} ) then
    ObjSet( "gfx_phonetable_clk_phonetablecsket_zone", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_wolf_inv = function()
  common_impl.ProcessMultiUseAll("wolf", "wolf")
end;
private.use_wolf_beg = function()
  ObjDelete( "gfx_phonetable_wolf_zone" );
  ObjSet( "spr_phonetable_wolf", { visible = 1 } )
end;
private.use_wolf_end = function()
  if ld.CheckRequirements( {"use_wolf","use_bear"} ) then
    ObjSet( "anm_phonetable_anm_cap_idle", { animfunc = "open_cap", frame = 0 } )
  end
  if common_impl.ZzCompleteCheck("use_wolf") then ObjSet( common_impl.hint["use_wolf"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wolf", private.use_wolf_inv );
cmn.AddSubscriber( "use_wolf", private.use_wolf_beg, private.room_objname );
cmn.AddSubscriber( "use_wolf", private.use_wolf_end, private.room_objname );
cmn.AddSubscriber( "use_wolf", private.use_wolf_logic );
cmn.AddSubscriber( "use_wolf_inv", private.use_wolf_inv, private.room_objname );
cmn.AddSubscriber( "use_wolf_beg", private.use_wolf_beg, private.room_objname );
cmn.AddSubscriber( "use_wolf_end", private.use_wolf_end, private.room_objname );
cmn.AddSubscriber( "use_wolf_end", private.use_wolf_logic );
--------------------------------------------------------------------------------------------
function public.use_wolf( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wolf" );
    cmn.CallEventHandler( "use_wolf_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wolf") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wolf_inv" );
  cmn.CallEventHandler( "use_wolf_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_phonetable_anm_cap_idle", "use_wolf", function() 
    if ld.CheckRequirements( {"use_wolf","use_bear"}, true ) == 1 then
      SoundSfx( "aud_unlock_phonetable_box" )
      ld.AnimPlay( "anm_phonetable_anm_cap_idle", "open_lock", func_end )
    else
      func_end()
    end
  end );
  SoundSfx( "aud_use_wolf_phonetable" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_phonetablecsket" ] = { type = "click", use_place = "gfx_phonetable_clk_phonetablecsket_zone", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.clk_phonetablecsket_logic = function()
  ObjSet( "spr_phonetable_whitethreads", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_phonetable_amuletelf5", { visible = 1, input = 1, active = 1 } )
end;
private.clk_phonetablecsket_beg = function()
  ObjDelete( "gfx_phonetable_clk_phonetablecsket_zone" );
end;
private.clk_phonetablecsket_end = function()
  ObjSet( "anm_phonetable_anm_cap_idle", { animfunc = "open_cap", frame = 999 } )
  ObjSet( "spr_secondfloor_open_tablebox_1", { visible = 1 } )
  ObjDelete( "spr_secondfloor_close_tablebox" )
  if common_impl.ZzCompleteCheck("clk_phonetablecsket") then ObjSet( common_impl.hint["clk_phonetablecsket"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_phonetablecsket", private.clk_phonetablecsket_beg, private.room_objname );
cmn.AddSubscriber( "clk_phonetablecsket", private.clk_phonetablecsket_end, private.room_objname );
cmn.AddSubscriber( "clk_phonetablecsket", private.clk_phonetablecsket_logic );
cmn.AddSubscriber( "clk_phonetablecsket_beg", private.clk_phonetablecsket_beg, private.room_objname );
cmn.AddSubscriber( "clk_phonetablecsket_end", private.clk_phonetablecsket_end, private.room_objname );
cmn.AddSubscriber( "clk_phonetablecsket_end", private.clk_phonetablecsket_logic );
--------------------------------------------------------------------------------------------
function public.clk_phonetablecsket()

  local func_end = function()
    cmn.SetEventDone( "clk_phonetablecsket" );
    cmn.CallEventHandler( "clk_phonetablecsket_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_phonetablecsket") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_phonetablecsket_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_phonetable_anm_cap_idle", "open_cap", func_end );
  SoundSfx( "aud_clk_open_phonetable_box" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_whitethreads" ] = { type = "get", get_obj = "spr_phonetable_whitethreads", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.get_whitethreads_logic = function()
  
end;
private.get_whitethreads_inv = function()
  interface.InventoryItemAdd("inv_whitethreads","spr_phonetable_whitethreads");
end;
private.get_whitethreads_beg = function()
  ObjDelete("gfx_phonetable_whitethreads")
end;
private.get_whitethreads_end = function()
  ObjDelete( "spr_phonetable_whitethreads_shadow" )
  if common_impl.ZzCompleteCheck("get_whitethreads") then ObjSet( common_impl.hint["get_whitethreads"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_whitethreads", private.get_whitethreads_inv );
cmn.AddSubscriber( "get_whitethreads", private.get_whitethreads_beg, private.room_objname );
cmn.AddSubscriber( "get_whitethreads", private.get_whitethreads_end, private.room_objname );
cmn.AddSubscriber( "get_whitethreads", private.get_whitethreads_logic );
--------------------------------------------------------------------
function public.get_whitethreads()
  cmn.SetEventDone( "get_whitethreads" );
  cmn.CallEventHandler( "get_whitethreads" );
  if common_impl.ZzCompleteCheck("get_whitethreads") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletelf5" ] = { type = "get", get_obj = "spr_phonetable_amuletelf5", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.get_amuletelf5_logic = function()
  
end;
private.get_amuletelf5_inv = function()
  interface.InventoryItemAdd("inv_amuletelf5","spr_phonetable_amuletelf5");
end;
private.get_amuletelf5_beg = function()
  ObjDelete("gfx_phonetable_amuletelf5")
end;
private.get_amuletelf5_end = function()
  ObjDelete( "spr_phonetable_amuletelf5_shadow" )
  if common_impl.ZzCompleteCheck("get_amuletelf5") then ObjSet( common_impl.hint["get_amuletelf5"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletelf5", private.get_amuletelf5_inv );
cmn.AddSubscriber( "get_amuletelf5", private.get_amuletelf5_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletelf5", private.get_amuletelf5_end, private.room_objname );
cmn.AddSubscriber( "get_amuletelf5", private.get_amuletelf5_logic );
--------------------------------------------------------------------
function public.get_amuletelf5()
  cmn.SetEventDone( "get_amuletelf5" );
  cmn.CallEventHandler( "get_amuletelf5" );
  if common_impl.ZzCompleteCheck("get_amuletelf5") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_puzzle" ] = { type = "use", inv_obj = "inv_puzzle", use_place = "gfx_phonetable_puzzle_zone", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.use_puzzle_logic = function()
  ObjSet( "gfx_phonetable_win_tag_zone", { visible = 1, input = 1, active = 1 } )
  ld.mmgZoomInit( "win_tag" )
end;
private.use_puzzle_inv = function()
  common_impl.ProcessMultiUseAll("puzzle", "puzzle")
end;
private.use_puzzle_beg = function()
  ObjDelete( "gfx_phonetable_puzzle_zone" );
end;
private.use_puzzle_end = function()
  ObjSet( "anm_phonetable_anm_use_mmg_part", { animfunc = "use_mmg_part", frame = 999 } )
  if common_impl.ZzCompleteCheck("use_puzzle") then ObjSet( common_impl.hint["use_puzzle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_puzzle", private.use_puzzle_inv );
cmn.AddSubscriber( "use_puzzle", private.use_puzzle_beg, private.room_objname );
cmn.AddSubscriber( "use_puzzle", private.use_puzzle_end, private.room_objname );
cmn.AddSubscriber( "use_puzzle", private.use_puzzle_logic );
cmn.AddSubscriber( "use_puzzle_inv", private.use_puzzle_inv, private.room_objname );
cmn.AddSubscriber( "use_puzzle_beg", private.use_puzzle_beg, private.room_objname );
cmn.AddSubscriber( "use_puzzle_end", private.use_puzzle_end, private.room_objname );
cmn.AddSubscriber( "use_puzzle_end", private.use_puzzle_logic );
--------------------------------------------------------------------------------------------
function public.use_puzzle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_puzzle" );
    cmn.CallEventHandler( "use_puzzle_end" );
    common_impl.Lock(0);
    ObjGet( "gfx_phonetable_win_tag_zone" ).event_mdown()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_puzzle_inv" );
  cmn.CallEventHandler( "use_puzzle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_phonetable_anm_use_mmg_part", "use_mmg_part", func_end );
  SoundSfx( "aud_use_puzzle_phonetable" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_tag" ] = { type = "click", use_place = "gfx_phonetable_win_tag_zone", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.win_tag_logic = function()
  if ld.CheckRequirements( { "win_tag" } ) then
    ObjSet( "spr_phonetable_pliers", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_phonetable_hatbase", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_tag_beg = function()

end;
private.win_tag_end = function()
  if ld.CheckRequirements( { "win_tag" } ) then
    ObjSet( "gfx_phonetable_hatbase", { visible = 1, active = 1 } )
    ObjSet( "gfx_phonetable_pliers", { visible = 1, active = 1 } )
    ObjSet( "spr_secondfloor_open_tablecase", { visible = 1 } )
    ObjDelete( "gfx_phonetable_win_tag_zone" );
    ObjSet( "anm_phonetable_anm_use_mmg_part", { animfunc = "open_box1_static", frame = 0 } )
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_tag", private.win_tag_beg, private.room_objname );
cmn.AddSubscriber( "win_tag", private.win_tag_end, private.room_objname );
cmn.AddSubscriber( "win_tag", private.win_tag_logic );
cmn.AddSubscriber( "win_tag_beg", private.win_tag_beg, private.room_objname );
cmn.AddSubscriber( "win_tag_end", private.win_tag_end, private.room_objname );
cmn.AddSubscriber( "win_tag_end", private.win_tag_logic );
--------------------------------------------------------------------------------------------
function public.win_tag()

  local func_end = function()
    iOS_NeedDrag(1);
    cmn.SetEventDone( "win_tag" );
    cmn.CallEventHandler( "win_tag_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_tag") then ld.CloseSubRoom() end;
  end;
  
  cmn.CallEventHandler( "win_tag_beg" );
  common_impl.Lock(1);
  cmn.MiniGameHide( "tag", true );

  SoundSfx( "aud_win_puzzle_phonetable" )

  for i = 1, 5 do
    ObjAnimate( "spr_phonetable_"..i.."_light", 8,0,0, _, { 0,0,0, 0.5,0,0.5, 1,0,0 } )
  end

  ObjSet( "anm_phonetable_anm_use_mmg_part", { animfunc = "open_box", frame = 0 } )

  ld.StartTimer( 1, function() 
    ObjGet( "obj_phonetable_win_tag_zoom" ).event_mdown()
    ld.StartTimer( 0.5, function() 
      ld.AnimPlay( "anm_phonetable_anm_use_mmg_part", "open_box", func_end )
    end )
  end )

end;
function public.win_tag_load()
  
  if not private.win_tag_gm then
    private.win_tag_gm = {}
    local gm = private.win_tag_gm


    function gm.default()
      gm.X = -146
      gm.Y = -146
      gm.W = 146

      gm.obj_drag = "spr_phonetable_drag";

      gm.map = {
        { 5, 0, 0 };
        { 0, 1, 3 };
        { 0, 2, 4 };
      }
      gm.map_def = ld.TableCopy( gm.map )
      gm.map_win = {
        { 0, 1, 0 };
        { 4, 5, 2 };
        { 0, 3, 0 };
      }
    end

    function gm.save() 
      ng_global.progress["std"]["win_tag"].state = ld.TableCopy( gm.map )
    end

    function gm.event_menter( obj, time_scale, alp )
      ld.ShCur(CURSOR_GET)
    end;

    function gm.event_mleave( obj, time_scale, alp )
      ld.ShCur(CURSOR_DEFAULT)
    end;

    function gm.event_mdown(n)
      ObjSet( gm.obj_drag, { 
        event_startdrag = function() gm.event_startdrag( n ) end;
        event_drag = function() gm.event_drag( n ) end;
        event_dragdrop = function() gm.event_dragdrop( n ) end;
      } )
      ObjStartDrag( gm.obj_drag )
    end
    function gm.event_startdrag(n)
      --ld.ShCur(CURSOR_NULL)
      gm.cursor = GetZoomCursorPos()
      SoundSfx( "aud_drag_puzzle_part" )
    end
    function gm.event_drag(n)
      local cursor = GetZoomCursorPos()
      local dx = cursor[ 1 ] - gm.cursor[ 1 ]
      local dy = cursor[ 2 ] - gm.cursor[ 2 ]
      if not gm.move_type then
        if math.abs( dx ) > 5 or math.abs( dy ) > 5 then
          gm.move_type = math.abs( dx ) > math.abs( dy ) and "x" or "y"
        end
      end

      --gm.event_drag_sfx_now
      --gm.event_drag_sfx_last

      if gm.move_type == "x" and dx ~= 0 then

        local o = ObjGet( "spr_phonetable_"..n )
        local pos = GetObjPosByObj( "spr_phonetable_"..n );
        local place = gm.get_place( n )
        local i_new, pos_x

        if dx > 0 then

          local pos_x_max;
          for i = place.i + 1, #gm.map[ place.j ], 1 do
            if gm.map[ place.j ][ i ] > 0 then
              pos_x_max = gm.get_x( i ) - gm.W
              break
            end
          end
          i_new, pos_x = gm.get_i( math.min( o.pos_x + dx, pos_x_max or ( o.pos_x + dx ) ) )

        elseif dx < 0 then

          local pos_x_min;
          for i = place.i - 1, 1, -1 do
            if gm.map[ place.j ][ i ] > 0 then
              pos_x_min = gm.get_x( i ) + gm.W
              break
            end
          end
          i_new, pos_x = gm.get_i( math.max( o.pos_x + dx, pos_x_min or ( o.pos_x + dx ) ) )

        end

        if dx ~= ( pos_x - o.pos_x ) then
          gm.event_drag_sfx_now = "aud_hit_puzzle_part"
        else
          gm.event_drag_sfx_now = false--"aud_drag_puzzle_part"
        end

        dx = pos_x - o.pos_x
        if i_new ~= place.i then
          --ld.LogTrace( place.i, i_new )
          gm.map[ place.j ][ place.i ], gm.map[ place.j ][ i_new ] = gm.map[ place.j ][ i_new ], gm.map[ place.j ][ place.i ]
        end
        gm.cursor[ 1 ] = gm.cursor[ 1 ] + dx
        ObjSet( "spr_phonetable_"..n, { pos_x = pos_x } )
        --gm.cursor = cursor

        --if ( i_new == #gm.map[ place.j ] and pos_x == gm.get_x( i_new ) )
        --or ( i_new == 1 and pos_x == gm.get_x( i_new ) ) then
        --  gm.move_type = false
        --end
        --if pos_x == gm.get_x( i_new ) then
        --  gm.move_type = false
        --end


        if dx == 0 then
          gm.event_drag_sfx_now = false
        end
        if gm.event_drag_sfx_now then
          if not ObjGet( "tmr_sfx_"..gm.event_drag_sfx_now ) then
            PlaySfx( "assets/levels/common/audio/"..gm.event_drag_sfx_now, 0, 0.0 )
            ld.StartTimer( "tmr_sfx_"..gm.event_drag_sfx_now, 0.1, function()  end )
          end
        elseif gm.event_drag_sfx_last then
          SndStop( "assets/levels/common/audio/"..gm.event_drag_sfx_last, 0.2 )
        end
        gm.event_drag_sfx_last = gm.event_drag_sfx_now


      elseif gm.move_type == "y" and dy ~= 0 then

        local o = ObjGet( "spr_phonetable_"..n )
        local pos = GetObjPosByObj( "spr_phonetable_"..n );
        local place = gm.get_place( n )
        local j_new, pos_y

        if dy > 0 then

          local pos_y_max;
          for j = place.j + 1, #gm.map, 1 do
            if gm.map[ j ][ place.i ] > 0 then
              pos_y_max = gm.get_y( j ) - gm.W
              break
            end
          end
          j_new, pos_y = gm.get_j( math.min( o.pos_y + dy, pos_y_max or ( o.pos_y + dy ) ) )

        elseif dy < 0 then

          local pos_y_min;
          for j = place.j - 1, 1, -1 do
            if gm.map[ j ][ place.i ] > 0 then
              pos_y_min = gm.get_y( j ) + gm.W
              break
            end
          end
          j_new, pos_y = gm.get_j( math.max( o.pos_y + dy, pos_y_min or ( o.pos_y + dy ) ) )

        end

        if dy ~= ( pos_y - o.pos_y ) then
          gm.event_drag_sfx_now = "aud_hit_puzzle_part"
        else
          gm.event_drag_sfx_now = false--"aud_drag_puzzle_part"
        end

        dy = pos_y - o.pos_y
        if j_new ~= place.j then
          --ld.LogTrace( place.j, j_new )
          gm.map[ place.j ][ place.i ], gm.map[ j_new ][ place.i ] = gm.map[ j_new ][ place.i ], gm.map[ place.j ][ place.i ]
        end
        gm.cursor[ 2 ] = gm.cursor[ 2 ] + dy
        ObjSet( "spr_phonetable_"..n, { pos_y = pos_y } )

        --if ( j_new == #gm.map and pos_y == gm.get_y( j_new ) )
        --or ( j_new == 1 and pos_y == gm.get_y( j_new ) ) then
        --  gm.move_type = false
        --end
        --if pos_y == gm.get_y( j_new ) then
        --  gm.move_type = false
        --end

        --gm.cursor = cursor

        if dy == 0 then
          gm.event_drag_sfx_now = false
        end
        if gm.event_drag_sfx_now then
          if not ObjGet( "tmr_sfx_"..gm.event_drag_sfx_now ) then
            PlaySfx( "assets/levels/common/audio/"..gm.event_drag_sfx_now, 0, 0.0 )
            ld.StartTimer( "tmr_sfx_"..gm.event_drag_sfx_now, 0.1, function()  end )
          end
        elseif gm.event_drag_sfx_last then
          SndStop( "assets/levels/common/audio/"..gm.event_drag_sfx_last, 0.2 )
        end
        gm.event_drag_sfx_last = gm.event_drag_sfx_now

      end
      
    end

    function gm.event_dragdrop(n)
      ld.ShCur(CURSOR_DEFAULT)
      gm.move_type = false
      gm.roll_back( n )
    end

    function gm.event_end()
      if gm.win_check() then
        public.win_tag()
      else
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.win_check()
      return ld.TableEquals(gm.map,gm.map_win)
    end

    function gm.roll_back( n )
      ld.Lock( 1 )
      local o = ObjGet( "spr_phonetable_"..n )
      local place = gm.get_place( n )
      local x, y = gm.get_x( place.i ), gm.get_y( place.j )
      local t = ( ( ( o.pos_x - x ) ^ 2 + ( o.pos_y - y ) ^ 2 ) ^ 0.5 ) / 500
      --SoundSfx( "aud_drag_puzzle_part" )
      ObjAnimate( o.name, 3,0,0, function() 

        if x ~= o.pos_x then
          if ( not gm.map[ place.j ][ place.i + 1 ] ) or ( not gm.map[ place.j ][ place.i - 1 ] )
          or ( gm.map[ place.j ][ place.i + 1 ] ~= 0 ) or ( gm.map[ place.j ][ place.i - 1 ] ~= 0 )
          then
            SoundSfx( "aud_hit_puzzle_part" )
          end
        elseif y ~= o.pos_y then
          if ( not gm.map[ place.j + 1 ] ) or ( not gm.map[ place.j - 1 ] )
          or ( not gm.map[ place.j + 1 ][ place.i ] ) or ( not gm.map[ place.j - 1 ][ place.i ] )
          or ( gm.map[ place.j + 1 ][ place.i ] ~= 0 ) or ( gm.map[ place.j - 1 ][ place.i ] ~= 0 )
          then
            SoundSfx( "aud_hit_puzzle_part" )
          end
        end

        gm.event_end()
      end, { 0,0,o.pos_x,o.pos_y, t,3,x,y } )
    end

    function gm.get_place( n )
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ] == n then
            return { j = j; i = i; }
          end
        end
      end
    end

    function gm.get_i( pos_x )
      if ( pos_x <  gm.get_x( 1 ) ) then
        return 1, gm.get_x( 1 )
      elseif ( pos_x > gm.get_x( #gm.map[ 1 ] ) ) then
        return #gm.map[ 1 ], gm.get_x( #gm.map[ 1 ] )
      else
        for i = 1, #gm.map[ 1 ] do
          if math.abs( gm.get_x( i ) - pos_x ) <= gm.W * 0.5 then
            return i, pos_x
          end
        end
      end
    end

    function gm.get_j( pos_y )
      if ( pos_y <  gm.get_y( 1 ) ) then
        return 1, gm.get_y( 1 )
      elseif ( pos_y > gm.get_y( #gm.map ) ) then
        return #gm.map, gm.get_y( #gm.map )
      else
        for j = 1, #gm.map do
          if math.abs( gm.get_y( j ) - pos_y ) <= gm.W * 0.5 then
            return j, pos_y
          end
        end
      end
    end

    function gm.get_x( i )
      return  gm.X + ( i - 1 ) * gm.W
    end

    function gm.get_y( j )
      return  gm.Y + ( j - 1 ) * gm.W
    end

    function gm.init()
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          local n = gm.map[ j ][ i ]
          if n > 0 then
            ObjSet( "spr_phonetable_"..n, {
              event_mdown = function() gm.event_mdown( n ) end;
              event_menter = function() gm.event_menter( "spr_phonetable_"..n, false, 0.25 ) end;
              event_mleave = function() gm.event_mleave( "spr_phonetable_"..n ) end;
              input = 1;
              pos_z = 3;
            } )
            common_impl.ObjCreate( "spr_phonetable_"..n.."_light", "spr", "spr_phonetable_"..n, {
              blendmode = 2;
              alp = 0;
              input = 0;
              res = "assets/levels/level/rm_secondfloor/zz_phonetable/"..n;
            } );
          end
        end
      end
    end

    function gm.set_all()
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          local n = gm.map[ j ][ i ]
          if n > 0 then
            ObjSet( "spr_phonetable_"..n, {
              pos_x = gm.get_x( i );
              pos_y = gm.get_y( j );
            } )
          end
        end
      end
    end

    function gm.anim_to_state( map, func_end )
      SoundSfx( "aud_reset_puzzle" )
      local t = 0.5
      func_end = func_end or function()  end
      for j = 1, #map do
        for i = 1, #map[ j ] do
          local n = map[ j ][ i ]
          if n > 0 then
            local o = ObjGet( "spr_phonetable_"..n )
            ObjAnimate( o.name, 3,0,0, _, { 0,0,o.pos_x,o.pos_y, t,3,gm.get_x( i ),gm.get_y( j ) } )
          end
        end
      end
      ld.StartTimer( t, func_end )
    end

    gm.default()
    if ng_global.progress["std"]["win_tag"].state then
      gm.map = ld.TableCopy( ng_global.progress["std"]["win_tag"].state )
    else

    end

    -->> init and restore objects  >>--
    gm.init()
    gm.set_all()
    --<< init and restore objects <<--

    function gm.reset()
      if ld.Lock( 1 ) then
        if not ld.TableEquals( gm.map_def, gm.map ) then
          gm.default()
          gm.anim_to_state( gm.map, gm.event_end )
        else
          ld.Lock( 0 )
        end
      end;
    end;
    function gm.skip()
      if ld.Lock( 1 ) then
        gm.map = gm.map_win
        gm.anim_to_state( gm.map, gm.event_end )
      end;
    end;

    gm.loaded = true;
  else
    
  end
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pliers" ] = { type = "get", get_obj = "spr_phonetable_pliers", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.get_pliers_logic = function()
  
end;
private.get_pliers_inv = function()
  interface.InventoryItemAdd("inv_pliers","spr_phonetable_pliers");
end;
private.get_pliers_beg = function()
  ObjDelete("gfx_phonetable_pliers")
end;
private.get_pliers_end = function()
  ObjDelete( "spr_phonetable_pliers_shadow" )
  ObjDelete( "spr_phonetable_pliers_shadow2" )
  if common_impl.ZzCompleteCheck("get_pliers") then ObjSet( common_impl.hint["get_pliers"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_pliers", private.get_pliers_inv );
cmn.AddSubscriber( "get_pliers", private.get_pliers_beg, private.room_objname );
cmn.AddSubscriber( "get_pliers", private.get_pliers_end, private.room_objname );
cmn.AddSubscriber( "get_pliers", private.get_pliers_logic );
--------------------------------------------------------------------
function public.get_pliers()
  cmn.SetEventDone( "get_pliers" );
  cmn.CallEventHandler( "get_pliers" );
  if common_impl.ZzCompleteCheck("get_pliers") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hatbase" ] = { type = "get", get_obj = "spr_phonetable_hatbase", room = "rm_secondfloor", zz = "zz_phonetable", zz_gate = "gzz_secondfloor_phonetable" };

private.get_hatbase_logic = function()
  
end;
private.get_hatbase_inv = function()
  interface.InventoryItemAdd("inv_hatbase","spr_phonetable_hatbase");
  ObjSet( "inv_hatbase", { drag = 0 } );
end;
private.get_hatbase_beg = function()
  ObjDelete("gfx_phonetable_hatbase")
end;
private.get_hatbase_end = function()
  ObjDelete( "spr_phonetable_hatbase_shadow" )
  if common_impl.ZzCompleteCheck("get_hatbase") then ObjSet( common_impl.hint["get_hatbase"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_hatbase", private.get_hatbase_inv );
cmn.AddSubscriber( "get_hatbase", private.get_hatbase_beg, private.room_objname );
cmn.AddSubscriber( "get_hatbase", private.get_hatbase_end, private.room_objname );
cmn.AddSubscriber( "get_hatbase", private.get_hatbase_logic );
--------------------------------------------------------------------
function public.get_hatbase()
  cmn.SetEventDone( "get_hatbase" );
  cmn.CallEventHandler( "get_hatbase" );
  if common_impl.ZzCompleteCheck("get_hatbase") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_phonetable" ) then
    private.win_tag_gm.reset()
  elseif ( mg_name == "zz_floorshelfs" ) then
    private.win_figures_gm.reset()
  elseif ( mg_name == "zz_doortobedroom" ) then
    private.win_angels_gm.reset()
  end

end;
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
    
  if ( mg_name == "zz_phonetable" ) then
    private.win_tag_gm.skip()
  elseif ( mg_name == "zz_floorshelfs" ) then
    private.win_figures_gm.skip()
  elseif ( mg_name == "zz_doortobedroom" ) then
    private.win_angels_gm.skip()
  end

end;

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_secondfloor();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_secondfloor_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_phonetable" );
  function zz_phonetable.Open()
  end;
  function zz_phonetable.PreOpen()
    public.win_tag_load()
  end;
  function zz_phonetable.PreClose()
    iOS_NeedDrag(1);
  end;
  function zz_phonetable.Close()
  end;

  subroom.Define( "zz_doortodressroom" );
  function zz_doortodressroom.Open()
  end;
  function zz_doortodressroom.PreOpen()
  end;
  function zz_doortodressroom.PreClose()
  end;
  function zz_doortodressroom.Close()
  end;

  subroom.Define( "zz_floorshelfs" );
  function zz_floorshelfs.Open()
  end;
  function zz_floorshelfs.PreOpen()
    public.win_figures_load()
  end;
  function zz_floorshelfs.PreClose()
  end;
  function zz_floorshelfs.Close()
  end;

  subroom.Define( "zz_doortobedroom" );
  function zz_doortobedroom.Open()
  end;
  function zz_doortobedroom.PreOpen()
    public.win_angels_load()
  end;
  function zz_doortobedroom.PreClose()
  end;
  function zz_doortobedroom.Close()
  end;
  
end;
--*********************************************************************************************************************