-- name=rm_street
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_street";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_street()
  if not ( cmn.IsEventDone( "opn_street" ) ) then
    local func_end = function()
        cmn.SetEventDone( "opn_street" );
        cmn.CallEventHandler( "opn_street" )
        ld.ShowBbtOpn( private.room_objname )
    end;
    func_end()
  else
    if ld.CheckRequirements( {"win_sledge"} ) and not ld.CheckRequirements( {"clk_sledge"} ) then
      public.clk_sledge()
    end
  end;
end;
--------------------------------------------------------------------
local opn_street = function() end;
local opn_street_logic = function() end;
cmn.AddSubscriber( "opn_street", opn_street_logic )
cmn.AddSubscriber( "opn_street", opn_street, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "use_brush" ] = { type = "use", inv_obj = "inv_brush", use_place = "gfx_street_brush_zone", room = "rm_street" };

private.use_brush_logic = function()
  ObjSet( "gho_street_sledge", {active = 1, input = 1, visible = 1} );
end;
private.use_brush_inv = function()
  common_impl.ProcessMultiUseAll("brush", "brush")
end;
private.use_brush_beg = function()
  ObjDelete( "gfx_street_brush_zone" );
end;
private.use_brush_end = function()
  ObjDelete("anm_street_anim")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_brush", private.use_brush_inv );
cmn.AddSubscriber( "use_brush", private.use_brush_beg, private.room_objname );
cmn.AddSubscriber( "use_brush", private.use_brush_end, private.room_objname );
cmn.AddSubscriber( "use_brush", private.use_brush_logic );
cmn.AddSubscriber( "use_brush_inv", private.use_brush_inv, private.room_objname );
cmn.AddSubscriber( "use_brush_beg", private.use_brush_beg, private.room_objname );
cmn.AddSubscriber( "use_brush_end", private.use_brush_end, private.room_objname );
cmn.AddSubscriber( "use_brush_end", private.use_brush_logic );
--------------------------------------------------------------------------------------------
function public.use_brush( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_brush" );
    cmn.CallEventHandler( "use_brush_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_brush_inv" );
  cmn.CallEventHandler( "use_brush_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_street_anim", "use_brush", func_end );
  SoundSfx( "aud_broom" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_sledge" ] = { type = "click", use_place = "gfx_street_clk_sledge_zone", room = "rm_street" };

private.clk_sledge_logic = function()
  ObjSet( "grm_street_nearshop", {active = 1, input = 1, visible = 1} );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_street_nearshop_focus");
    end;
end;
private.clk_sledge_beg = function()
  ObjDelete( "gfx_street_clk_sledge_zone" );
end;
private.clk_sledge_end = function()
  ObjSet( "anm_street_anim_sledge", {animfunc = "move_sledge", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_sledge", private.clk_sledge_beg, private.room_objname );
cmn.AddSubscriber( "clk_sledge", private.clk_sledge_end, private.room_objname );
cmn.AddSubscriber( "clk_sledge", private.clk_sledge_logic );
cmn.AddSubscriber( "clk_sledge_beg", private.clk_sledge_beg, private.room_objname );
cmn.AddSubscriber( "clk_sledge_end", private.clk_sledge_end, private.room_objname );
cmn.AddSubscriber( "clk_sledge_end", private.clk_sledge_logic );
--------------------------------------------------------------------------------------------
function public.clk_sledge()

  local func_end = function()
    cmn.SetEventDone( "clk_sledge" );
    cmn.CallEventHandler( "clk_sledge_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_sledge_beg" );
  common_impl.Lock(1);

  
  ld.AnimPlay( "anm_street_anim_sledge", "move_sledge", func_end );
  SoundSfx( "aud_sledge_moves" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_mansiongates *** () end
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------
common_impl.hint[ "use_gateskey" ] = { type = "use", inv_obj = "inv_gateskey", use_place = "gfx_mansiongates_gateskey_zone", room = "rm_street", zz = "zz_mansiongates", zz_gate = "gzz_street_mansiongates" };

private.use_gateskey_logic = function()
  ObjSet( "grm_street_mansion", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_street_mansion_focus");
    end;

end;
private.use_gateskey_inv = function()
  common_impl.ProcessMultiUseAll("gateskey", "gateskey")
end;
private.use_gateskey_beg = function()
  ObjDelete( "gfx_mansiongates_gateskey_zone" );
end;
private.use_gateskey_end = function()
  ObjSet( "anm_mansiongates_anm", {animfunc = "use_key", frame = 999 } );
  ObjSet( "spr_street_gates_open", {visible = 1} );
  ObjDelete("spr_street_gates_clsoed")
  if common_impl.ZzCompleteCheck("use_gateskey") then ObjSet( common_impl.hint["use_gateskey"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_gateskey", private.use_gateskey_inv );
cmn.AddSubscriber( "use_gateskey", private.use_gateskey_beg, private.room_objname );
cmn.AddSubscriber( "use_gateskey", private.use_gateskey_end, private.room_objname );
cmn.AddSubscriber( "use_gateskey", private.use_gateskey_logic );
cmn.AddSubscriber( "use_gateskey_inv", private.use_gateskey_inv, private.room_objname );
cmn.AddSubscriber( "use_gateskey_beg", private.use_gateskey_beg, private.room_objname );
cmn.AddSubscriber( "use_gateskey_end", private.use_gateskey_end, private.room_objname );
cmn.AddSubscriber( "use_gateskey_end", private.use_gateskey_logic );
--------------------------------------------------------------------------------------------
function public.use_gateskey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_gateskey" );
    cmn.CallEventHandler( "use_gateskey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_gateskey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_gateskey_inv" );
  cmn.CallEventHandler( "use_gateskey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mansiongates_anm", "use_key", func_end );
  SoundSfx( "aud_gateskey" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_artiststuff *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_solvent" ] = { type = "get", get_obj = "spr_artiststuff_solvent", room = "rm_street", zz = "zz_artiststuff", zz_gate = "gzz_street_artiststuff" };

private.get_solvent_logic = function()
  
end;
private.get_solvent_inv = function()
  interface.InventoryItemAdd("inv_solvent","spr_artiststuff_solvent");
end;
private.get_solvent_beg = function()
  ObjDelete("gfx_artiststuff_solvent")
end;
private.get_solvent_end = function()
  ObjDelete("spr_street_detergent")
  if common_impl.ZzCompleteCheck("get_solvent") then ObjSet( common_impl.hint["get_solvent"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_solvent", private.get_solvent_inv );
cmn.AddSubscriber( "get_solvent", private.get_solvent_beg, private.room_objname );
cmn.AddSubscriber( "get_solvent", private.get_solvent_end, private.room_objname );
cmn.AddSubscriber( "get_solvent", private.get_solvent_logic );
--------------------------------------------------------------------
function public.get_solvent()
  cmn.SetEventDone( "get_solvent" );
  cmn.CallEventHandler( "get_solvent" );
  if common_impl.ZzCompleteCheck("get_solvent") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletpalette" ] = { type = "use", inv_obj = "inv_amuletpalette", use_place = "gfx_artiststuff_amuletpalette_zone", room = "rm_street", zz = "zz_artiststuff", zz_gate = "gzz_street_artiststuff" };

private.use_amuletpalette_logic = function()
  ObjSet( "spr_artiststuff_paints", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_artiststuff_button_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_amuletpalette_inv = function()
  common_impl.ProcessMultiUseAll("amuletpalette", "amuletpalette")
end;
private.use_amuletpalette_beg = function()
  ObjDelete( "gfx_artiststuff_amuletpalette_zone" );
end;
private.use_amuletpalette_end = function()
  ObjSet( "anm_artiststuff_anm", {animfunc = "static_sketchbook", frame = 0 } );
  ObjSet( "spr_artiststuff_paints_sh", {visible = 1} );
  ObjDelete("spr_street_art_close")
  ObjSet( "spr_street_art_open", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_amuletpalette") then ObjSet( common_impl.hint["use_amuletpalette"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletpalette", private.use_amuletpalette_inv );
cmn.AddSubscriber( "use_amuletpalette", private.use_amuletpalette_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletpalette", private.use_amuletpalette_end, private.room_objname );
cmn.AddSubscriber( "use_amuletpalette", private.use_amuletpalette_logic );
cmn.AddSubscriber( "use_amuletpalette_inv", private.use_amuletpalette_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletpalette_beg", private.use_amuletpalette_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletpalette_end", private.use_amuletpalette_end, private.room_objname );
cmn.AddSubscriber( "use_amuletpalette_end", private.use_amuletpalette_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletpalette( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletpalette" );
    cmn.CallEventHandler( "use_amuletpalette_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletpalette") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletpalette_inv" );
  cmn.CallEventHandler( "use_amuletpalette_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_artiststuff_anm", "use_amuletpalette", func_end );
  SoundSfx( "aud_amuletpalette" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_paints" ] = { type = "get", get_obj = "spr_artiststuff_paints", room = "rm_street", zz = "zz_artiststuff", zz_gate = "gzz_street_artiststuff" };

private.get_paints_logic = function()
  
end;
private.get_paints_inv = function()
  interface.InventoryItemAdd("inv_paints","spr_artiststuff_paints");
end;
private.get_paints_beg = function()
  ObjDelete("gfx_artiststuff_paints")
end;
private.get_paints_end = function()
  ObjDelete("spr_artiststuff_paints_sh")
  ObjDelete("spr_street_paints")
  if common_impl.ZzCompleteCheck("get_paints") then ObjSet( common_impl.hint["get_paints"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_paints", private.get_paints_inv );
cmn.AddSubscriber( "get_paints", private.get_paints_beg, private.room_objname );
cmn.AddSubscriber( "get_paints", private.get_paints_end, private.room_objname );
cmn.AddSubscriber( "get_paints", private.get_paints_logic );
--------------------------------------------------------------------
function public.get_paints()
  cmn.SetEventDone( "get_paints" );
  cmn.CallEventHandler( "get_paints" );
  if common_impl.ZzCompleteCheck("get_paints") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_button" ] = { type = "use", inv_obj = "inv_button", use_place = "gfx_artiststuff_button_zone", room = "rm_street", zz = "zz_artiststuff", zz_gate = "gzz_street_artiststuff" };

private.use_button_logic = function()
  ObjSet( "gfx_artiststuff_clk_button_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_button_inv = function()
  common_impl.ProcessMultiUseAll("button", "button")
end;
private.use_button_beg = function()
  ObjDelete( "gfx_artiststuff_button_zone" );
end;
private.use_button_end = function()
  ObjSet( "spr_street_red_btn", {visible = 1} );
  ObjSet( "anm_artiststuff_anm", {animfunc = "click_cover", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_button") then ObjSet( common_impl.hint["use_button"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_button", private.use_button_inv );
cmn.AddSubscriber( "use_button", private.use_button_beg, private.room_objname );
cmn.AddSubscriber( "use_button", private.use_button_end, private.room_objname );
cmn.AddSubscriber( "use_button", private.use_button_logic );
cmn.AddSubscriber( "use_button_inv", private.use_button_inv, private.room_objname );
cmn.AddSubscriber( "use_button_beg", private.use_button_beg, private.room_objname );
cmn.AddSubscriber( "use_button_end", private.use_button_end, private.room_objname );
cmn.AddSubscriber( "use_button_end", private.use_button_logic );
--------------------------------------------------------------------------------------------
function public.use_button( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_button" );
    cmn.CallEventHandler( "use_button_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_button") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_button_inv" );
  cmn.CallEventHandler( "use_button_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_artiststuff_anm", "use_button", func_end );
  SoundSfx( "aud_button" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_button" ] = { type = "click", use_place = "gfx_artiststuff_clk_button_zone", room = "rm_street", zz = "zz_artiststuff", zz_gate = "gzz_street_artiststuff" };

private.clk_button_logic = function()
  ObjSet( "spr_artiststuff_goldsprayer", { visible = 1, input = 1, active = 1 } )
end;
private.clk_button_beg = function()
  ObjDelete( "gfx_artiststuff_clk_button_zone" );
end;
private.clk_button_end = function()
  ObjSet( "anm_artiststuff_anm", {animfunc = "static_cover", frame = 0 } );
  ObjSet( "spr_artiststuff_goldsprayer_sh", {visible = 1} );
  ObjSet( "spr_street_goldsprayer", {visible = 1} );
  ObjDelete("spr_street_cover_art")
  ObjDelete("spr_street_red_btn")
  ObjSet( "spr_street_cover_art_moved", {visible = 1} );
  if common_impl.ZzCompleteCheck("clk_button") then ObjSet( common_impl.hint["clk_button"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_button", private.clk_button_beg, private.room_objname );
cmn.AddSubscriber( "clk_button", private.clk_button_end, private.room_objname );
cmn.AddSubscriber( "clk_button", private.clk_button_logic );
cmn.AddSubscriber( "clk_button_beg", private.clk_button_beg, private.room_objname );
cmn.AddSubscriber( "clk_button_end", private.clk_button_end, private.room_objname );
cmn.AddSubscriber( "clk_button_end", private.clk_button_logic );
--------------------------------------------------------------------------------------------
function public.clk_button()

  local func_end = function()
    cmn.SetEventDone( "clk_button" );
    cmn.CallEventHandler( "clk_button_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_button") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_button_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_artiststuff_anm", "click_cover", func_end );
  SoundSfx( "aud_clk_button" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_goldsprayer" ] = { type = "get", get_obj = "spr_artiststuff_goldsprayer", room = "rm_street", zz = "zz_artiststuff", zz_gate = "gzz_street_artiststuff" };

private.get_goldsprayer_logic = function()
  
end;
private.get_goldsprayer_inv = function()
  interface.InventoryItemAdd("inv_goldsprayer","spr_artiststuff_goldsprayer");
end;
private.get_goldsprayer_beg = function()
  ObjDelete("gfx_artiststuff_goldsprayer")
end;
private.get_goldsprayer_end = function()
  ObjDelete("spr_artiststuff_goldsprayer_sh")
  ObjDelete("spr_street_goldsprayer")
  if common_impl.ZzCompleteCheck("get_goldsprayer") then ObjSet( common_impl.hint["get_goldsprayer"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_goldsprayer", private.get_goldsprayer_inv );
cmn.AddSubscriber( "get_goldsprayer", private.get_goldsprayer_beg, private.room_objname );
cmn.AddSubscriber( "get_goldsprayer", private.get_goldsprayer_end, private.room_objname );
cmn.AddSubscriber( "get_goldsprayer", private.get_goldsprayer_logic );
--------------------------------------------------------------------
function public.get_goldsprayer()
  cmn.SetEventDone( "get_goldsprayer" );
  cmn.CallEventHandler( "get_goldsprayer" );
  if common_impl.ZzCompleteCheck("get_goldsprayer") then ld.CloseSubRoom() end;
  if port.isPortable()==1 then
    iOS_RateMe();
  end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tree *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brokenbrush" ] = { type = "get", get_obj = "spr_tree_brokenbrush", room = "rm_street", zz = "zz_tree", zz_gate = "gzz_street_tree" };

private.get_brokenbrush_logic = function()
  ObjSet( "gfx_tree_ironbowl_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_brokenbrush_inv = function()
  interface.InventoryItemAdd("inv_brokenbrush","spr_tree_brokenbrush");
  ObjSet( "inv_brokenbrush", { drag = 0 } );
end;
private.get_brokenbrush_beg = function()
  ObjDelete("gfx_tree_brokenbrush")
end;
private.get_brokenbrush_end = function()
  ObjDelete("spr_tree_brokenbrush_sh")
  ObjDelete("spr_street_brokenbrush")
  if common_impl.ZzCompleteCheck("get_brokenbrush") then ObjSet( common_impl.hint["get_brokenbrush"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_brokenbrush", private.get_brokenbrush_inv );
cmn.AddSubscriber( "get_brokenbrush", private.get_brokenbrush_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenbrush", private.get_brokenbrush_end, private.room_objname );
cmn.AddSubscriber( "get_brokenbrush", private.get_brokenbrush_logic );
--------------------------------------------------------------------
function public.get_brokenbrush()
  cmn.SetEventDone( "get_brokenbrush" );
  cmn.CallEventHandler( "get_brokenbrush" );
  if common_impl.ZzCompleteCheck("get_brokenbrush") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------

common_impl.hint[ "use_elfclimber" ] = { type = "use", inv_obj = "inv_elfclimber", use_place = "gfx_tree_elfclimber_zone", room = "rm_street", zz = "zz_tree", zz_gate = "gzz_street_tree" };

private.use_elfclimber_logic = function()
  int_simon.SimonSetVisible(1)
end;
private.use_elfclimber_inv = function()
  common_impl.ProcessMultiUseAll("elfclimber", "elfclimber")
end;
private.use_elfclimber_beg = function()
  ObjDelete( "gfx_tree_elfclimber_zone" );
end;
private.use_elfclimber_end = function()
  ObjSet( "spr_tree_garland", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_elfclimber") then ObjSet( common_impl.hint["use_elfclimber"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_elfclimber", private.use_elfclimber_inv );
cmn.AddSubscriber( "use_elfclimber", private.use_elfclimber_beg, private.room_objname );
cmn.AddSubscriber( "use_elfclimber", private.use_elfclimber_end, private.room_objname );
cmn.AddSubscriber( "use_elfclimber", private.use_elfclimber_logic );
cmn.AddSubscriber( "use_elfclimber_inv", private.use_elfclimber_inv, private.room_objname );
cmn.AddSubscriber( "use_elfclimber_beg", private.use_elfclimber_beg, private.room_objname );
cmn.AddSubscriber( "use_elfclimber_end", private.use_elfclimber_end, private.room_objname );
cmn.AddSubscriber( "use_elfclimber_end", private.use_elfclimber_logic );
--------------------------------------------------------------------------------------------
function public.use_elfclimber( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "get_mittens" );
    cmn.SetEventDone( "use_elfclimber" );
    cmn.CallEventHandler( "use_elfclimber_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_elfclimber") then ld.CloseSubRoom() end;
    --ObjSet( "spr_tree_elf", {visible = 0} );
    ObjDelete( "spr_tree_elf" )
    interface.SimonReturn()
  end;
  local func_end_2 = function()
    ObjSet( "spr_tree_elf", {visible = 1} );
    ObjDelete("vid_tree_goodie_climb_p2")
    ObjSet( "spr_tree_garland", {visible = 1} );
    int_inventory.StdItemFlyAnimation( "spr_tree_elf", "obj_int_button_map_point_for_cube", func_end );
  end
  local func_end_3 = function()
    cmn.CallEventHandler( "get_mittens" );
    ObjDelete("vid_tree_goodie_climb_p1")
    ObjAttach("vid_tree_goodie_climb_p2", "zz_tree")
    VidPlay("vid_tree_goodie_climb_p2",func_end_2)
    SoundVid( "aud_goodie_climb_95_p2" )
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_elfclimber_inv" );
  cmn.CallEventHandler( "use_elfclimber_beg" );
  common_impl.Lock(1);
  --interface.SimonJump(func_3)
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  ObjAttach("vid_tree_goodie_climb_p1", "zz_tree")
  SoundVid( "aud_goodie_climb_144_p1" )
  VidPlay("vid_tree_goodie_climb_p1",func_end_3)

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mittens" ] = { type = "get", get_obj = "spr_tree_mittens", room = "rm_street", zz = "zz_tree", zz_gate = "gzz_street_tree" };

private.get_mittens_logic = function()
  
end;
private.get_mittens_inv = function()
  interface.InventoryItemAdd("inv_mittens","spr_tree_mittens");
end;
private.get_mittens_beg = function()
  ObjDelete("gfx_tree_mittens")
  ObjDelete("anm_tree_anm_mitten")
  ObjSet( "spr_tree_mittens", { visible = 1 } )
end;
private.get_mittens_end = function()
  if common_impl.ZzCompleteCheck("get_mittens") then ObjSet( common_impl.hint["get_mittens"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mittens", private.get_mittens_inv );
cmn.AddSubscriber( "get_mittens", private.get_mittens_beg, private.room_objname );
cmn.AddSubscriber( "get_mittens", private.get_mittens_end, private.room_objname );
cmn.AddSubscriber( "get_mittens", private.get_mittens_logic );
--------------------------------------------------------------------
function public.get_mittens()
  cmn.SetEventDone( "get_mittens" );
  cmn.CallEventHandler( "get_mittens" );
  if common_impl.ZzCompleteCheck("get_mittens") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ironbowl" ] = { type = "use", inv_obj = "inv_ironbowl", use_place = "gfx_tree_ironbowl_zone", room = "rm_street", zz = "zz_tree", zz_gate = "gzz_street_tree" };

private.use_ironbowl_logic = function()
  ObjSet( "spr_tree_frozenpitch", { visible = 1, input = 1, active = 1 } )

end;
private.use_ironbowl_inv = function()
  common_impl.ProcessMultiUseAll("ironbowl", "ironbowl")
end;
private.use_ironbowl_beg = function()
  ObjDelete( "gfx_tree_ironbowl_zone" );
end;
private.use_ironbowl_end = function()
  ObjDelete("anm_tree_anm_tar")
  if common_impl.ZzCompleteCheck("use_ironbowl") then ObjSet( common_impl.hint["use_ironbowl"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ironbowl", private.use_ironbowl_inv );
cmn.AddSubscriber( "use_ironbowl", private.use_ironbowl_beg, private.room_objname );
cmn.AddSubscriber( "use_ironbowl", private.use_ironbowl_end, private.room_objname );
cmn.AddSubscriber( "use_ironbowl", private.use_ironbowl_logic );
cmn.AddSubscriber( "use_ironbowl_inv", private.use_ironbowl_inv, private.room_objname );
cmn.AddSubscriber( "use_ironbowl_beg", private.use_ironbowl_beg, private.room_objname );
cmn.AddSubscriber( "use_ironbowl_end", private.use_ironbowl_end, private.room_objname );
cmn.AddSubscriber( "use_ironbowl_end", private.use_ironbowl_logic );
--------------------------------------------------------------------------------------------
function public.use_ironbowl( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ironbowl" );
    cmn.CallEventHandler( "use_ironbowl_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ironbowl") then ld.CloseSubRoom() end;
    public.get_frozenpitch()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ironbowl_inv" );
  cmn.CallEventHandler( "use_ironbowl_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tree_anm_tar", "use_ironbowl", func_end );
  SoundSfx( "aud_ironbowl" )
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_frozenpitch" ] = { type = "get", get_obj = "spr_tree_frozenpitch", room = "rm_street", zz = "zz_tree", zz_gate = "gzz_street_tree" };

private.get_frozenpitch_logic = function()
  
end;
private.get_frozenpitch_inv = function()
  interface.InventoryItemAdd("inv_frozenpitch","spr_tree_frozenpitch");
end;
private.get_frozenpitch_beg = function()
  ObjDelete("gfx_tree_frozenpitch")
end;
private.get_frozenpitch_end = function()
  if common_impl.ZzCompleteCheck("get_frozenpitch") then ObjSet( common_impl.hint["get_frozenpitch"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_frozenpitch", private.get_frozenpitch_inv );
cmn.AddSubscriber( "get_frozenpitch", private.get_frozenpitch_beg, private.room_objname );
cmn.AddSubscriber( "get_frozenpitch", private.get_frozenpitch_end, private.room_objname );
cmn.AddSubscriber( "get_frozenpitch", private.get_frozenpitch_logic );
--------------------------------------------------------------------
function public.get_frozenpitch()
  cmn.SetEventDone( "get_frozenpitch" );
  cmn.CallEventHandler( "get_frozenpitch" );
  if common_impl.ZzCompleteCheck("get_frozenpitch") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_rasp_tree" ] = { type = "use", inv_obj = "inv_rasp", use_place = "gfx_tree_rasp_tree_zone", room = "rm_street", zz = "zz_tree", zz_gate = "gzz_street_tree" };

private.use_rasp_tree_logic = function()
  ObjSet( "spr_tree_figurboy", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_tree_scarf", { input = 1, active = 1 } )

end;
private.use_rasp_tree_inv = function()
  common_impl.ProcessMultiUseAll("rasp", "rasp_tree")
end;
private.use_rasp_tree_beg = function()
  ObjDelete( "gfx_tree_rasp_tree_zone" );
end;
private.use_rasp_tree_end = function()
  ObjSet( "anm_tree_anm_rasp", {animfunc = "end_rasp1", frame = 0 } );
  ObjSet( "anm_tree_anm_rasp_1", {visible = 1} );
  ObjSet( "gfx_tree_scarf", { visible = 1 } )
  ObjSet( "spr_street_nutcracker", {pos_x = 526, pos_y = 246, ang = 1.31} );
  if common_impl.ZzCompleteCheck("use_rasp_tree") then ObjSet( common_impl.hint["use_rasp_tree"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rasp_tree", private.use_rasp_tree_inv );
cmn.AddSubscriber( "use_rasp_tree", private.use_rasp_tree_beg, private.room_objname );
cmn.AddSubscriber( "use_rasp_tree", private.use_rasp_tree_end, private.room_objname );
cmn.AddSubscriber( "use_rasp_tree", private.use_rasp_tree_logic );
cmn.AddSubscriber( "use_rasp_tree_inv", private.use_rasp_tree_inv, private.room_objname );
cmn.AddSubscriber( "use_rasp_tree_beg", private.use_rasp_tree_beg, private.room_objname );
cmn.AddSubscriber( "use_rasp_tree_end", private.use_rasp_tree_end, private.room_objname );
cmn.AddSubscriber( "use_rasp_tree_end", private.use_rasp_tree_logic );
--------------------------------------------------------------------------------------------
function public.use_rasp_tree( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rasp_tree" );
    cmn.CallEventHandler( "use_rasp_tree_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rasp_tree") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rasp_tree_inv" );
  cmn.CallEventHandler( "use_rasp_tree_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tree_anm_rasp", "use_rasp", func_end );
  SoundSfx( "aud_file1" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_figurboy" ] = { type = "get", get_obj = "spr_tree_figurboy", room = "rm_street", zz = "zz_tree", zz_gate = "gzz_street_tree" };

private.get_figurboy_logic = function()
  
end;
private.get_figurboy_inv = function()
  interface.InventoryItemAdd("inv_figurboy","spr_tree_figurboy");
end;
private.get_figurboy_beg = function()
  ObjDelete("gfx_tree_figurboy")
end;
private.get_figurboy_end = function()
  ObjDelete("spr_street_nutcracker")
  if common_impl.ZzCompleteCheck("get_figurboy") then ObjSet( common_impl.hint["get_figurboy"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_figurboy", private.get_figurboy_inv );
cmn.AddSubscriber( "get_figurboy", private.get_figurboy_beg, private.room_objname );
cmn.AddSubscriber( "get_figurboy", private.get_figurboy_end, private.room_objname );
cmn.AddSubscriber( "get_figurboy", private.get_figurboy_logic );
--------------------------------------------------------------------
function public.get_figurboy()
  cmn.SetEventDone( "get_figurboy" );
  cmn.CallEventHandler( "get_figurboy" );
  if common_impl.ZzCompleteCheck("get_figurboy") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scarf" ] = { type = "get", get_obj = "spr_tree_scarf", room = "rm_street", zz = "zz_tree", zz_gate = "gzz_street_tree" };

private.get_scarf_logic = function()
  
end;
private.get_scarf_inv = function()
  interface.InventoryItemAdd("inv_scarf","spr_tree_scarf");
end;
private.get_scarf_beg = function()
  ObjDelete("gfx_tree_scarf")
  ObjSet( "spr_tree_scarf", {visible = 1} );
  ObjDelete("anm_tree_anm_rasp_1")
end;
private.get_scarf_end = function()
  ObjDelete("spr_street_scraf")
  if common_impl.ZzCompleteCheck("get_scarf") then ObjSet( common_impl.hint["get_scarf"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_scarf", private.get_scarf_inv );
cmn.AddSubscriber( "get_scarf", private.get_scarf_beg, private.room_objname );
cmn.AddSubscriber( "get_scarf", private.get_scarf_end, private.room_objname );
cmn.AddSubscriber( "get_scarf", private.get_scarf_logic );
--------------------------------------------------------------------
function public.get_scarf()
  cmn.SetEventDone( "get_scarf" );
  cmn.CallEventHandler( "get_scarf" );
  if common_impl.ZzCompleteCheck("get_scarf") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_sledge_for_street_logic = function()
    if ld.CheckRequirements( {"win_sledge"} ) then
      ObjSet( "grm_street_nearshop", {active = 1, input = 1, visible = 1} );
      if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_street_nearshop_focus");
    end;
    end
  end
  local win_sledge_for_street = function()
    if ld.CheckRequirements( {"win_sledge"} ) then
      ObjSet( "gho_street_sledge", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_sledge", win_sledge_for_street_logic )
  cmn.AddSubscriber("win_sledge", win_sledge_for_street, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_street();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_street_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_tree" );
  function zz_tree.Open()
  end;
  function zz_tree.PreOpen()
  end;
  function zz_tree.PreClose()
  end;
  function zz_tree.Close()
  end;

  subroom.Define( "zz_artiststuff" );
  function zz_artiststuff.Open()
  end;
  function zz_artiststuff.PreOpen()
  end;
  function zz_artiststuff.PreClose()
  end;
  function zz_artiststuff.Close()
  end;

  subroom.Define( "zz_mansiongates" );
  function zz_mansiongates.Open()
  end;
  function zz_mansiongates.PreOpen()
  end;
  function zz_mansiongates.PreClose()
  end;
  function zz_mansiongates.Close()
  end;
  
end;
--*********************************************************************************************************************