-- name=ho_portalext
--*********************************************************************************************************************
private.ho_name = "portalext";
function private.ReverseItemsBuild()

  private.ReverseTaskComplete_in_progress = private.ReverseTaskComplete_in_progress or {}

  if not private.Builded then
    for i = 1, #private.taskpanel do
      local name = private.taskpanel[i][1]
      local style = private.taskpanel[i][2]

      private.ObjLevitationStart( "spr_portalext_"..name );

      local obj = "obj_"..private.ho_name.."_taskpanel_"..name;
      ObjSet( "spr_"..private.ho_name.."_"..name, { input = 0 } )

      local o = ObjGet( "obj_portalext_"..name ) or ObjGet( "obj_portalext_"..name.."_zone" )
      ObjSet( "obj_portalext_anim_"..name, { pos_x = o.pos_x; pos_y = o.pos_y; } )
      ObjSet( "anm_portalext_anim_"..name, { pos_x = -o.pos_x - 171; pos_y = -o.pos_y; } )
      ObjSet( "obj_portalext_"..name, { pos_x = 0; pos_y = 0; } )
      ObjSet( "obj_portalext_"..name.."_zone", { pos_x = 0; pos_y = 0; } )

      if style == "text" then
        
        ObjCreate( obj, "text" )
        local o = ObjGet( "txt_int_taskpanel_task_1" )
        o.name = nil
        ObjSet( obj, o )
        ObjSet( obj, int_taskpanel_impl.GetTaskColors() )
        ObjSet( obj, { text = "tsk_"..private.ho_name.."_"..name; input = 0 } )

      elseif style == "item" then

        ObjCreate( obj, "spr" )
        ObjSet( obj, { 
          res = "assets/levels/levelext/ho_"..private.ho_name.."/"..name.."_tr_item"; 
          pos_y = 5;
          input = 0;
          inputrect_init = 1;
          inputrect_x = -50;
          inputrect_y = -50;
          inputrect_w = 100;
          inputrect_h = 100;
          drag = 1;
          event_startdrag = function() SoundSfx( "aud_get", -1 ) PartSysStop("fx_"..obj,0)  ld.ShCur(CURSOR_NULL) end;
          event_dragdrop = function() PartSysRestart("fx_"..obj) ld.ShCur(CURSOR_DEFAULT) private.ReverseTaskComplete( name ) end;
        } )
        ObjSet( "obj_"..private.ho_name.."_"..name, { input = 0 } )

        local o = ObjGet( obj )
        ObjCreate( "fx_"..obj, "partsys" )
        ObjSet( "fx_"..obj, { 
          res = "assets/levels/levelext/ho_"..private.ho_name.."/item_fx"; 
        } )
        ObjAttach( "fx_"..obj, obj )

      end;

      --ObjSet( "obj_"..private.ho_name.."_"..private.taskpanel[i][1].."_root", { input = i > 1 and 0 or 1 } )

    end;
    private.ReverseItemShowNext()
    private.ReverseRestore()
    private.Builded = true
  else

  end;
end;

function private.ReverseItemShowNext( name )

  if name then

    --if name == "aaa" then
    --  level.tutorial_newho2_1.first()
    --end;

    local n = ld.TableContains( private.taskpanel, name, true )
    local obj_now = "obj_"..private.ho_name.."_taskpanel_"..name
    local obj_next = "obj_"..private.ho_name.."_taskpanel_"..(private.taskpanel[n+1][1])

    ObjSet( "fx_"..private.ho_name.."_task_"..n, { active = 1 } )

    ObjCreate( "fx_"..private.ho_name.."_task_start_"..n, "partsys" )
    ObjSet( "fx_"..private.ho_name.."_task_start_"..n, { res = "assets/levels/levelext/ho_"..private.ho_name.."/light_on_fx"; } )
    ObjAttach( "fx_"..private.ho_name.."_task_start_"..n, "fx_"..private.ho_name.."_task_"..n )
    
    ObjAnimate( obj_now, 8,0,0, function() 
      ObjDelete( obj_now )
    end, { 0,0,1, 0.5,0,0 } )
    ObjAttach( obj_next, "obj_"..private.ho_name.."_taskpanel" )
    if private.taskpanel[n+1][2] == "item" then
      private.ReverseObjDestroyFx( obj_next, true )
    else
      ObjAnimate( obj_next, 8,0,0, _, { 0,0,0, 0.5,0,1 } )
    end;

    cmn.HoTaskFind( "xxx", name )

    ld.Lock( 0 )
    private.ReverseLoad()
  else
    local tasks = ld.TableCopy( private.taskpanel )
    if ng_global.progress["ext"]["win_"..private.ho_name].found then
      for j = 1, #ng_global.progress["ext"]["win_"..private.ho_name].found do
        local n = ld.TableContains( tasks, ng_global.progress["ext"]["win_"..private.ho_name].found[j].task, true )
        if n ~= 0 then
          table.remove( tasks, n );
        end;
      end
    end

    local obj_next = "obj_"..private.ho_name.."_taskpanel_"..(tasks[1][1])
    --ObjSet( obj_next, { input = tasks[1][2] == "item" and 1 or 0 } )
    ObjAttach( obj_next, "obj_"..private.ho_name.."_taskpanel" )
  end
  private.ReverseLoad()
end;
function private.ReverseRestore()
  --for i = 1, #ng_global.progress[ "ext" ][ "win_"..private.ho_name ].found do
  --  ld.LogTrace( ng_global.progress[ "ext" ][ "win_"..private.ho_name ].found[ i ].task )
  --end
  for i = 1, #private.taskpanel-1 do
    if ld.TableContains( ng_global.progress[ "ext" ][ "win_"..private.ho_name ].found, private.taskpanel[i][1] )
    then

      local name = private.taskpanel[i][1]
      ObjDelete( "spr_"..private.ho_name.."_"..name )
      ObjDelete( "obj_"..private.ho_name.."_"..name )
      ObjDelete( "obj_"..private.ho_name.."_"..name.."_zone" )

      --ObjSet( "fx_"..private.ho_name.."_task_"..i, { active = 1 } )

      if private.taskpanel[i][2] == "item" then
        ObjSet( "anm_"..private.ho_name.."_anim_"..name, { animfunc = "open_"..name, frame = 999 } )
      else
        ObjSet( "anm_"..private.ho_name.."_anim_"..name, { animfunc = "click_"..name, frame = 999 } )
      end

    end
  end;
end
function private.ReverseLoad()

  local clr = { 
    item = { 255/255, 200/255, 40/255 };
    text = { 25/255, 120/255, 255/255 };
  }

  for i = 2, #private.taskpanel do
    local name = private.taskpanel[i][1]
    ObjSet( "obj_"..private.ho_name.."_anim_"..name, { input = 0 } )
    ObjSet( "obj_"..private.ho_name.."_"..name, { input = 0 } )
  end

  for i = 1, #private.taskpanel-1 do
    ObjSet( "fx_"..private.ho_name.."_task_"..i, { 
      active = ld.TableContains( ng_global.progress[ "ext" ][ "win_"..private.ho_name ].found, private.taskpanel[i][1] );
      color_r = clr[ private.taskpanel[ i ][ 2 ] ][ 1 ];
      color_g = clr[ private.taskpanel[ i ][ 2 ] ][ 2 ];
      color_b = clr[ private.taskpanel[ i ][ 2 ] ][ 3 ];
    } )

  end
  --ld.LogTrace( ng_global.progress[ "ext" ][ "win_"..private.ho_name ], private.taskpanel )
  for i = 1, #private.taskpanel-1 do
    if ld.TableContains( ng_global.progress[ "ext" ][ "win_"..private.ho_name ].found, private.taskpanel[i][1] )
    and not ld.TableContains( ng_global.progress[ "ext" ][ "win_"..private.ho_name ].found, private.taskpanel[i+1][1] ) 
    then

      local name = private.taskpanel[i][1]
      ObjDelete( "spr_"..private.ho_name.."_"..name )

      ObjDelete( "obj_"..private.ho_name.."_"..name.."_zone" )



      ObjSet( "obj_"..private.ho_name.."_anim_"..private.taskpanel[i+1][1], { input = 1 } )
      ObjSet( "fx_"..private.ho_name.."_task_"..i, { active = 1 } )

      if private.taskpanel[i+1][2] == "item" then
        ObjSet( "obj_"..private.ho_name.."_taskpanel_"..private.taskpanel[i+1][1], { input = 1 } )
        ObjSet( "obj_"..private.ho_name.."_"..private.taskpanel[i+1][1].."_zone", { input = 1 } )
        ObjSet( "anm_"..private.ho_name.."_anim_"..name, { animfunc = "click_"..name, frame = 999 } )
      else
        ObjSet( "obj_"..private.ho_name.."_"..private.taskpanel[i+1][1], { input = 1 } )
        ObjSet( "anm_"..private.ho_name.."_anim_"..name, { animfunc = "open_"..name, frame = 999 } )
      end

      break
    end
  end;

end

function private.ReverseTaskComplete( name )

  if not private.ReverseTaskComplete_in_progress[ name ] then
    if private.taskpanel[ ld.TableContains( private.taskpanel, name, true ) ][ 2 ] == "item" then
      private.ReverseTaskComplete_in_progress[ name ] = 0
    else
      private.ReverseTaskComplete_in_progress[ name ] = 1
    end
  end;

  --ld.LogTrace( name, private.ReverseTaskComplete_in_progress[ name ] )

  if private.ReverseTaskComplete_in_progress[ name ] == 0 then
    if ApplyObj( "obj_"..private.ho_name.."_taskpanel_"..name, "obj_"..private.ho_name.."_"..name.."_zone" ) then
      ld.Lock( 1 )

      local sfx = {
        ccc = "aud_key_insert";
        eee = "aud_put_ho";
        ggg = "aud_put_ho";
        iii = "aud_put_ho";
        kkk = "aud_put_ho";
      }
      SoundSfx( sfx[name] )

      SoundSfx( "aud_use_stuff" )

      local p = GetObjPosByObj( "spr_"..private.ho_name.."_"..name )
      ObjCreate( "fx_".."spr_"..private.ho_name.."_"..name, "partsys" )
      ObjSet( "fx_".."spr_"..private.ho_name.."_"..name, { 
        pos_x = p[ 1 ]; pos_y = p[ 2 ]; pos_z = 33;
        res = "assets/levels/levelext/ho_"..private.ho_name.."/scroll_fx"; 
      } )
      ObjAttach( "fx_".."spr_"..private.ho_name.."_"..name, "ho_"..private.ho_name )

      ObjDelete( "obj_"..private.ho_name.."_taskpanel_"..name )
      ObjDelete( "obj_"..private.ho_name.."_"..name.."_zone" )
      ld.AnimPlay( "anm_"..private.ho_name.."_anim_"..name, "open_"..name, function()
        --ObjSet( "obj_"..private.ho_name.."_"..name, { input = 1 } ) 
        ObjSet( "spr_"..private.ho_name.."_"..name, { input = 1 } ) 
        private.ReverseTaskComplete_in_progress[ name ] = private.ReverseTaskComplete_in_progress[ name ] + 2
        ld.Lock( 0 )
      end )
    else
      
    end;
  elseif private.ReverseTaskComplete_in_progress[ name ] == 1 then

    --level.tutorial_newho2_1.first()

    ld.Lock( 1 )
    ObjDelete( "obj_"..private.ho_name.."_"..name )
    ObjSet( "spr_"..private.ho_name.."_"..name, { input = 1 } ) 

    local p = GetObjPosByObj( "spr_"..private.ho_name.."_"..name )
    ObjCreate( "fx_".."spr_"..private.ho_name.."_"..name, "partsys" )
    ObjSet( "fx_".."spr_"..private.ho_name.."_"..name, { 
      pos_x = p[ 1 ]; pos_y = p[ 2 ]; pos_z = 33;
      res = "assets/levels/levelext/ho_"..private.ho_name.."/scroll_fx"; 
    } )
    ObjAttach( "fx_".."spr_"..private.ho_name.."_"..name, "ho_"..private.ho_name )

      --local sfx = {
      --  --bbb = "aud_click_ho_"..private.ho_name.."_fan";
      --  --ccc = "aud_click_ho_"..private.ho_name.."_sun";
      --  --ddd = "aud_click_ho_"..private.ho_name.."_basket";
      --  --eee = "aud_click_ho_"..private.ho_name.."_casket";
      --  --fff = "aud_click_ho_"..private.ho_name.."_mask";
      --  --ggg = "aud_click_ho_"..private.ho_name.."_gloves";
      --  --hhh = "aud_click_ho_"..private.ho_name.."_hat";
      --  --iii = "aud_click_ho_"..private.ho_name.."_matryoshka";
      --  --jjj = "aud_click_ho_"..private.ho_name.."_elephant";
      --  --kkk = "aud_click_ho_"..private.ho_name.."_eagle";
      --}
      --SoundSfx( sfx[name] )

    SoundSfx( "aud_discover" )

    ld.AnimPlay( "anm_"..private.ho_name.."_anim_"..name, "click_"..name, function() 
      --if name == "bbb" then
      --  level.tutorial_newho2_2.first()  
      --end
      private.ReverseTaskComplete_in_progress[ name ] = private.ReverseTaskComplete_in_progress[ name ] + 1
      ld.Lock( 0 )
    end )
  elseif private.ReverseTaskComplete_in_progress[ name ] == 2 then
    ld.Lock( 1 )
    PartSysStop( "fx_".."spr_"..private.ho_name.."_"..name, 0 );
    SoundSfx( "aud_shine_lantern" )
    private.ReverseFlyToItem(name,function() 
      --if name == "bbb" then
      --  level.tutorial_newho2_3.first()  
      --end
      private.ReverseTaskComplete_in_progress[ name ] = private.ReverseTaskComplete_in_progress[ name ] + 1
      private.ReverseItemShowNext( name )
    end)
  end
end

function private.ReverseFlyToItem(name,func_end)
  
  private.ReverseObjDestroyFx( "spr_"..private.ho_name.."_"..name )

  ObjSet( "spr_"..private.ho_name.."_"..name, { pos_z = 999 } )
  local p = GetObjPosByObj( "spr_"..private.ho_name.."_"..name, "obj_"..private.ho_name.."_taskpanel" )

  local t = ( ld.Len( p[ 1 ], p[ 2 ] ) / 400 ) ^ 0.5

  local fx = "fx_"..private.ho_name.."_fly_to_item_"..name
  ObjCreate( fx, "partsys" )
  ObjSet( fx, { res = "assets/levels/levelext/ho_"..private.ho_name.."/fly_fx", pos_z = 999 } )
  ObjAttach( fx, "obj_"..private.ho_name.."_taskpanel" )
  
  ObjAnimate( fx, 0,0,0, function()
    PartSysStop( fx, 0 ) 
  end, { 0,0,p[1], t,1,0 } )
  ObjAnimate( fx, 1,0,0, func_end, { 0,0,p[2], t,2,0 } )
end;

function private.ReverseObjDestroyFx( object_name, not_destroy )
  
  local func_end = function()
    if not not_destroy then
      ObjDelete( object_name )
    end
  end
  --ObjSet( object_name, {pos_z = 1} );

  private.ObjLevitationStop( object_name )

  local collect_pos = GetObjPosByObj( object_name, InterfaceWidget_Top_Name );
  local collect_drawoff_x = ObjGet( object_name ).drawoff_x;
  local collect_drawoff_y = ObjGet( object_name ).drawoff_y;
  
  local collect_name  = "fx_item_name_collect_"..object_name;

  PlaySfx( "assets/levels/common/audio/aud_get_ho", 0, "", 0.0 )
  if not not_destroy then
    ObjAttach( object_name, InterfaceWidget_Top_Name );
    ObjSet( object_name ,{ pos_x = collect_pos[1], pos_y = collect_pos[2] });
  end

  if ObjGet(collect_name) then ObjDelete(collect_name) end
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,
  {
    res = "assets/interface/resources/effects_ho",
    pos_x = collect_drawoff_x + ( not_destroy and collect_pos[1] or 0 ),
    pos_y = collect_drawoff_y + ( not_destroy and collect_pos[2] or 0 ),
    active = 1, visible = 1, input = 0, pos_z = 10
  } );

  ObjAttach( collect_name, InterfaceWidget_Top_Name );
  ObjSet(collect_name, {blendmode = 2,pos_z = 50});
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
  
  PartSysSetMaskObj( collect_name, object_name );  
  ObjAnimate( object_name, "alp",0,0, func_end,
  { 
      0.0, 0, not_destroy and 0 or 1,
      0.3, 0, not_destroy and 0 or 1,
      0.6, 0, not_destroy and 1 or 0
  } );

end

function private.ReverseGetTaskParams( name, set_objects )
  if set_objects == nil then
    set_objects = true
  end
  local n = ld.TableContains( private.taskpanel, name, true )
  local m;
  if private.taskpanel[n][2] == "text" then
    m = { 
      { "obj_"..private.ho_name.."_"..name }; 
      { "spr_"..private.ho_name.."_"..name }; 
    };
  elseif private.taskpanel[n][2] == "item" then
    m = { 
      { "obj_"..private.ho_name.."_taskpanel_"..name, "obj_"..private.ho_name.."_"..name.."_zone" }; 
      { "obj_"..private.ho_name.."_"..name }; 
      { "spr_"..private.ho_name.."_"..name }; 
    };
    ObjSet( "obj_"..private.ho_name.."_"..name, { 
      event_menter = function() ld.ShCur(CURSOR_HAND) end;
      event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
    } )
  end;

  if set_objects then
    private.ReverseSetTaskParams( name )
  end

  return name, 1, 0, m
end;
function private.ReverseSetTaskParams( name )
    ObjSet( "spr_"..private.ho_name.."_"..name, { 
      event_mdown  = function() private.ReverseTaskComplete( name ) end;
      event_menter = function() ld.ShCur(CURSOR_HAND) end;
      event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
      inputrect_init = 1;
      inputrect_x = -30;
      inputrect_y = -30;
      inputrect_w = 60;
      inputrect_h = 60;
      blendmode = 2;
    } )
    --ld.LogTrace( ObjGet( "spr_"..private.ho_name.."_"..name ) )
    ObjSet( "obj_"..private.ho_name.."_"..name.."_zone", { 
      --event_mdown  = function() ld.ShowBbt( "apartment_need_"..name ) end;
      --event_menter = function() ld.ShCur(CURSOR_USE) end;
      --event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
    } )
    ObjSet( "obj_"..private.ho_name.."_"..name, { 
      event_mdown  = function() private.ReverseTaskComplete( name ) end;
    } )
    --ld.LogTrace( ObjGet( "obj_"..private.ho_name.."_"..name ) )
end
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "portalext" );
  game.relations[ "ho_portalext" ].exitroom = "rm_entrypointext";
 
   private.taskpanel = {
    { "aaa"; "text"; };
    { "bbb"; "item"; };
    { "ccc"; "text"; };
    { "ddd"; "item"; };
    { "eee"; "text"; };
    { "fff"; "item"; };
    { "ggg"; "text"; };
    { "hhh"; "item"; };
    { "iii"; "text"; };
    { "jjj"; "item"; };
    { "kkk"; "text"; };
    { "lll"; "item"; };
    { "mmm"; "text"; };
  }

--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_portalext" ] = { type = "win", room = "rm_entrypointext", zz = "ho_portalext", zz_gate = "gho_entrypointext_portalext" };
 
  local win_portalext_func = function ()

    if ( cmn.IsEventDone( "win_portalext" ) ) then
      interface.InventoryItemAdd( "inv_snowmaidenext1", "spr_portalext_win" );
      ObjDelete( "gho_entrypointext_portalext" );
    end;

  end;
  cmn.AddSubscriber( "win_portalext", win_portalext_func );
  
  local start_portalext_func = function ()
  if not cmn.IsEventDone("win_portalext") then
  
  end
  end;
  cmn.AddSubscriber( "win_portalext", start_portalext_func, "ho_portalext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_workshop_env" )
  SoundHoTheme( true );

  if ( not cmn.IsEventDone( "opn_portalext" ) ) then

    cmn.InitHo( "portalext" );

    cmn.SetEventDone( "opn_portalext" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "aaa" ) )
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "bbb" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "ccc" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "ddd" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "eee" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "fff" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "ggg" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "hhh" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "iii" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "jjj" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "kkk" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "lll" ) );
  --interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "lll" ) );
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 0, { { "obj_portalext_mmm" } } );
  
  
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "portalext" );

  private.ReverseItemsBuild()

  ObjSet( "obj_portalext_mmm", { 
    event_mdown = function() 
      private.ObjLevitationStop( "spr_portalext_mmm" )
      ObjSet( "obj_portalext_mmm", { input = 0 } );
      private.TaskComplete( "mmm" );
    end;
  } )

  if not private.levitation_started then
    local childs = ObjGetRelations( "obj_portalext_logic_case_creator_root" ).childs
    for k, v in ipairs( childs ) do
      private.ObjLevitationStart( v );
    end
    
  end

   for j = 1, #ng_global.progress["ext"]["win_portalext"].found do

    local name = tostring( ng_global.progress["ext"]["win_portalext"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_portalext_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_portalext_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function private.ObjLevitationStart( obj, config )
  --[[
  private.ObjLevitation_cache = private.ObjLevitation_cache or {}
  if not config then
    config = {
      pos_x = { t_min = 3.5; t_max = 5.5; delta_min = 2.0; delta_max = 4.0; };
      pos_y = { t_min = 4.0; t_max = 6.0; delta_min = 2.0; delta_max = 4.0; };
      ang   = { t_min = 4.5; t_max = 6.5; delta_min = 0.02; delta_max = 0.04; };
    }
  end
  private.ObjLevitation_cache[ obj ] = config
  for k, v in pairs( config ) do
    private.ObjLevitation( obj, k, v, true )
  end
  ]]
end
function private.ObjLevitationStop( obj )
  --[[
  local config = private.ObjLevitation_cache[ obj ]
  if config then
    for k, v in pairs( config ) do
      ObjStopAnimate( obj, k )
    end
    return true
  else
    return false
  end
  ]]
end
function private.ObjLevitation( obj, anim_type, config, random_step )
  --[[
  local o = ObjGet( obj )
  if o then
    local t_anim = config.t_min + ( config.t_max - config.t_min ) * math.random()
    local delta_anim = config.delta_min + ( config.delta_max - config.delta_min ) * math.random()
    local anm = {
      0,0,o[ anim_type ];
      t_anim*0.25,2,o[ anim_type ]+delta_anim; 
      t_anim*0.50,1,o[ anim_type ];
      t_anim*0.75,2,o[ anim_type ]-delta_anim;
      t_anim,1,o[ anim_type ];
    }
    -->> сеим хаос
    if random_step then
      step = math.random( 1, 4 )
      for i = 1, step - 1 do
        table.remove( anm, 1 )
        table.remove( anm, 1 )
        table.remove( anm, 1 )
      end
      for i = 0, step - 1 do
        anm[ 1 + i * 3 ] = i * 0.25 * t_anim
      end
      local set = {}
      set[ anim_type ] = anm[ 3 ]
      ObjSet( obj, set )
    end
    --<< сеим хаос
    ObjAnimate( o.name, anim_type,0,0, function()
      private.ObjLevitation( obj, anim_type, config );
      end, anm );
  end
  ]]
end;