-- name=mg_fightext
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_fightext";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_fightext" ] = {type = "win", use_place = "mg_fightext", room = "rm_seconfloorext", zz = "mg_fightext", zz_gate = "gmg_seconfloorext_fightext" };

  local win_fightext_logic = function()
    if ld.CheckRequirements( {"win_fightext"} ) then
      ObjSet( "gfx_fightext_clk_outroext_zone", { visible = 1, input = 1, active = 1 } )
    end
  end;
  local win_fightext = function()
    if ld.CheckRequirements( {"win_fightext"} ) then
      ObjSet( "obj_fightext_mmg_root", { input = 0, active = 0 } )
    end
  end;
  cmn.AddSubscriber("win_fightext", win_fightext, private.room_objname )
  cmn.AddSubscriber("win_fightext", win_fightext_logic )
  --------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fairyext_fightext" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_fightext_fairyext_fightext_zone", room = "rm_seconfloorext", zz = "mg_fightext", zz_gate = "gmg_seconfloorext_fightext" };

private.use_fairyext_fightext_logic = function()
  ObjSet( "obj_fightext_mmg_root", { visible = 1, input = 1, active = 1 } )
  int_simon.SimonSetVisible(0)
end;
private.use_fairyext_fightext_inv = function()
  common_impl.ProcessMultiUseAll("fairyext", "fairyext_fightext")
end;
private.use_fairyext_fightext_beg = function()
  ObjDelete( "gfx_fightext_fairyext_fightext_zone" );
end;
private.use_fairyext_fightext_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fairyext_fightext", private.use_fairyext_fightext_inv );
cmn.AddSubscriber( "use_fairyext_fightext", private.use_fairyext_fightext_beg, private.room_objname );
cmn.AddSubscriber( "use_fairyext_fightext", private.use_fairyext_fightext_end, private.room_objname );
cmn.AddSubscriber( "use_fairyext_fightext", private.use_fairyext_fightext_logic );
cmn.AddSubscriber( "use_fairyext_fightext_inv", private.use_fairyext_fightext_inv, private.room_objname );
cmn.AddSubscriber( "use_fairyext_fightext_beg", private.use_fairyext_fightext_beg, private.room_objname );
cmn.AddSubscriber( "use_fairyext_fightext_end", private.use_fairyext_fightext_end, private.room_objname );
cmn.AddSubscriber( "use_fairyext_fightext_end", private.use_fairyext_fightext_logic );
--------------------------------------------------------------------------------------------
function public.use_fairyext_fightext( obj )

  local func_end = function()
    SoundMgTheme( true )
    cmn.MiniGameShow( "fightext" );
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fairyext_fightext" );
    cmn.CallEventHandler( "use_fairyext_fightext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck( "use_fairyext_fightext" ) then cmn.GotoRoom( "rm_seconfloorext" ); end;
    gm.animator()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fairyext_fightext_inv" );
  cmn.CallEventHandler( "use_fairyext_fightext_beg" );
  common_impl.Lock(1);

  interface.SimonJump( function() 
    SoundSfx( "aud_use_fairyext_fightext" )
    gm.animator( "cat3_1", function() 
      gm.animator( "cat1_cast", func_end )
    end )
    ObjAttach( "obj_fightext_amulet_root", "mg_fightext" )
    ObjSet( "obj_fightext_amulet_root", { alp = 0 } )
    ObjAnimate( "obj_fightext_amulet_root", 8,0,0, nil, { 0,0,0, 0.5,0,1 } )
    gm.vid_player( "vid_fightext_vid_fairy_static_32" )
  end )  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_outroext" ] = { type = "click", use_place = "gfx_fightext_clk_outroext_zone", room = "rm_seconfloorext", zz = "mg_fightext", zz_gate = "gmg_seconfloorext_fightext" };

private.clk_outroext_logic = function()

end;
private.clk_outroext_beg = function()
  ObjDelete( "gfx_fightext_clk_outroext_zone" );
end;
private.clk_outroext_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_outroext", private.clk_outroext_beg, private.room_objname );
cmn.AddSubscriber( "clk_outroext", private.clk_outroext_end, private.room_objname );
cmn.AddSubscriber( "clk_outroext", private.clk_outroext_logic );
cmn.AddSubscriber( "clk_outroext_beg", private.clk_outroext_beg, private.room_objname );
cmn.AddSubscriber( "clk_outroext_end", private.clk_outroext_end, private.room_objname );
cmn.AddSubscriber( "clk_outroext_end", private.clk_outroext_logic );
--------------------------------------------------------------------------------------------
function public.clk_outroext()

  local func_end = function()

    ObjSet( "mg_fightext", { color_r = 0; color_g = 0; color_b = 0; } )
    int.DialogVideoHide()
    VidPause( "vid_fightext_vid_outroext", 1 )

    cmn.SetEventDone( "clk_outroext" );
    cmn.CallEventHandler( "clk_outroext_end" );
    common_impl.Lock(0);

    common.MenuCredits("game")
  end;

  cmn.CallEventHandler( "clk_outroext_beg" );
  common_impl.Lock(1);

  int.DialogVideoShow( "vid_fightext_vid_outroext", 1, func_end );
  common_impl.SetWidgetsVisible( "DialogVideoShow", false )
  ObjAnimate( "vid_fightext_vid_outroext", 7, 0, 0, function() 
    common_impl.Lock(0);
    int.DialogVideoShow( "vid_hallext_vid_morgana_prince", 1, func_end, 1 );
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_vid_outroext_1" , aud_voc_false, 13.5,23 };
      { "srt_vid_outroext_2" , aud_voc_false, 23.5,28.5 };
    } );
    ]]
    SoundEnv( 0 );
    SoundVid( "aud_outroext" );
    SoundVoice( "aud_outroext_voc" );
    VidPlay( "vid_fightext_vid_outroext", func_end );;
    
  end, {0,0,0, 0,0,0} );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if ld.CheckRequirements( {"win_fightext", "use_fairyext_fightext" }, true ) == 1 then
    SoundMgTheme( true )
    cmn.MiniGameShow( "fightext" );
  end
  if ld.CheckRequirements( {"win_fightext"} ) and ( not ld.CheckRequirements( { "clk_outroext" } ) ) then
    public.clk_outroext()
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_street_env" )
  gm.load();

  if ld.CheckRequirements( {"win_fightext", "use_fairyext_fightext" }, true ) == 1 then
    gm.vid_player( "vid_fightext_vid_fairy_static_32" )
  end

  int_button_map_impl.Lock() 
  ObjSet( "grm_fightext_seconfloorext", { visible = 0, input = 0 } )

  if ld.CheckRequirements( {"win_fightext"} ) and ( not ld.CheckRequirements( { "clk_outroext" } ) ) then
    ld.SetWidgetsVisible( "DialogVideoShow", false );
    ObjSet( "mg_fightext", { color_r = 0; color_g = 0; color_b = 0; } )
  end
end;
--*********************************************************************************************************************
function public.Close()
  if ld.CheckRequirements( {"win_fightext", "use_fairyext_fightext" }, true ) == 1 then
    SoundMgTheme( false )
    cmn.MiniGameHide( "fightext" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
  int_button_map_impl.UnLock() 
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  gm.lvl_reset();
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  gm.lvl_skip()
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_fightext" );
  cmn.CallEventHandler( "win_fightext" );
  if common_impl.ZzCompleteCheck( "win_fightext" ) then cmn.GotoRoom( "rm_seconfloorext" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide();
  SoundMgTheme( false )
  ObjAnimate( "mg_fightext", 8,0,0, private.WinEnd, { 0,0,1, 0.5,0,0 } )
  public.clk_outroext()
  --ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then

    gm.TICKER_TIME = 0.010;

    gm.LVL_SCORE = 600

    gm.D_LEN = 2
    --gm.BALL_POS_STEP = 0.065;
    gm.BALL_D = 45
    gm.BALL_R = gm.BALL_D / 2
    gm.BALL_MAGNITING_SPEED = -0.08
    --gm.BALL_PIX_PER_TICK = { 1.10, 0.79, 0.79 }
    gm.BALL_PIX_PER_TICK = { 1.5, 1.15, 0.90 }
    gm.SCORE_LVL = { 500, 600, 900 }

    --if ld.IsLdCheater() then
    --  gm.SCORE_LVL = { 50, 60, 90 }
    --end

    gm.RANDOM_RANGE = { 3, 4, 3 }

    --gm.BALL_COLLISION_LEN = 0.1

    gm.AMULET_SHOOT_FLY_LEN = 1000;
    gm.AMULET_SHOOT_FLY_TIME = 0.8;
    gm.AMULET_CHARGE_TIME = 0.5;

    gm.AMULET_POS = {
      { 800, 643 };
      { 354, 648 };
      { 512, 643 };
    };

    gm.lvl = ng_global.progress["ext"]["win_fightext"].state or 1

    if ng_global.progress["ext"]["win_fightext"].start == 1 then
      --ObjAttach( "spr_fightext_greta_"..gm.lvl, "mg_fightext" )
      --AnimPlay( "anm_fightext_anm", "greta"..gm.lvl, _ )
    end  
    --ld.LogTrace( "LEVEL",gm.lvl )

    gm.balls_init();

    gm.lifebar_init();

    gm.ticker()

    gm.animator()

    gm.amulet_add_score_anim()

    --for i = 20, -20, -1 do
    --  ld.LogTrace( i, gm.ball_get_x_y( i, 1 ) )
    --end;

    gm.loaded  = true;
  else
  
  end;
end

function gm.path_init()
  gm.lines = {
    --1
    {
      --1_1
      {
        { 195, 357 };  { 195, 372 };  { 194, 387 };  { 194, 402 };  { 194, 417 };  { 195, 432 };  { 197, 447 };  { 200, 462 };  { 204, 477 };  { 210, 492 };  { 217, 507 };  { 227, 522 };  { 242, 536 };  { 257, 547 };  { 272, 554 };  { 287, 558 };  { 302, 561 };  { 317, 563 };  { 332, 562 };  { 347, 560 };  { 362, 556 };  { 377, 549 };  { 392, 540 };  { 406, 527 };  { 417, 512 };  { 425, 497 };  { 430, 482 };  { 434, 467 };  { 437, 452 };  { 440, 437 };  { 442, 422 };  { 443, 407 };  { 445, 392 };  { 445, 377 };  { 445, 362 };  { 444, 347 };  { 442, 332 };  { 437, 317 };  { 430, 302 };  { 419, 287 };  { 404, 273 };  { 389, 263 };  { 374, 256 };  { 359, 250 };  { 344, 246 };  { 329, 244 };  { 314, 243 };  { 299, 243 };  { 284, 244 };  { 269, 246 };  { 254, 248 };  { 239, 252 };  { 224, 255 };  { 209, 260 };  { 194, 264 };  { 179, 269 };  { 164, 274 };  { 149, 277 };  { 134, 280 };  { 119, 281 };  { 104, 276 };  { 90, 264 };  { 81, 249 };  { 75, 234 };  { 70, 219 };  { 67, 204 };  { 65, 189 };  { 64, 174 };  { 65, 159 };  { 67, 144 };  { 70, 129 };  { 76, 114 };  { 83, 99 };  { 95, 84 };  { 110, 74 };  { 125, 69 };  { 140, 66 };  { 155, 65 };  { 170, 65 };  { 185, 67 };  { 200, 72 };  { 213, 84 };  { 217, 99 };  { 216, 114 };  { 209, 129 };  { 194, 135 };  { 179, 132 };  { 164, 130 };  { 149, 133 };  { 136, 146 };  { 129, 161 };  { 127, 176 };  { 129, 191 };  { 140, 204 };  { 155, 209 };  { 170, 210 };  { 185, 208 };  { 200, 205 };  { 215, 201 };  { 230, 195 };  { 245, 188 };  { 259, 175 };  { 274, 162 };  { 289, 152 };  { 304, 145 };  { 319, 140 };  { 334, 136 };  { 349, 133 };  { 364, 131 };  { 379, 129 };  { 394, 129 };  { 409, 128 };  { 424, 128 };  { 439, 129 };  { 454, 129 };  { 469, 130 };  { 484, 130 };  { 499, 129 };  { 514, 129 };  { 529, 128 };  { 544, 128 };  { 559, 127 };  { 574, 126 };  { 589, 125 };  { 604, 124 };  { 619, 123 };  { 634, 122 };  { 649, 121 };  { 664, 119 };  { 679, 118 };  { 694, 115 };  { 709, 113 };  { 724, 109 };  { 739, 105 };  { 754, 97 };  { 769, 87 };  { 784, 78 };  { 799, 73 };  { 814, 69 };  { 829, 67 };  { 844, 66 };  { 859, 65 };  { 874, 64 };  { 889, 65 };  { 904, 67 };  { 919, 70 };  { 934, 77 };  { 947, 91 };  { 953, 106 };  { 954, 121 };  { 955, 136 };  { 954, 151 };  { 952, 166 };  { 946, 181 };  { 935, 195 };  { 920, 200 };  { 905, 201 };  { 890, 199 };  { 875, 196 };  { 860, 193 };  { 845, 190 };  { 830, 187 };  { 815, 185 };  { 800, 183 };  { 785, 181 };  { 770, 180 };  { 755, 180 };  { 740, 179 };  { 725, 180 };  { 710, 180 };  { 695, 181 };  { 680, 183 };  { 665, 184 };  { 650, 186 };  { 635, 188 };  { 620, 190 };  { 605, 192 };  { 590, 194 };  { 575, 196 };  { 560, 198 };  { 545, 200 };  { 530, 204 };  { 515, 208 };  { 500, 212 };  { 485, 219 };  { 472, 233 };  { 472, 248 };  { 480, 263 };  { 494, 276 };  { 509, 283 };  { 524, 287 };  { 539, 289 };  { 554, 288 };  { 569, 287 };  { 584, 285 };  { 599, 282 };  { 614, 279 };  { 629, 276 };  { 644, 272 };  { 659, 268 };  { 674, 265 };  { 689, 263 };  { 704, 261 };  { 719, 258 };  { 734, 256 };  { 749, 255 };  { 764, 254 };  { 779, 253 };  { 794, 253 };  { 809, 254 };  { 824, 256 };  { 839, 258 };  { 854, 260 };  { 869, 264 };  { 884, 268 };  { 899, 273 };  { 914, 280 };  { 929, 289 };  { 944, 302 };  { 955, 317 };  { 959, 332 };  { 957, 347 };  { 947, 362 };  { 932, 368 };  { 917, 369 };  { 902, 368 };  { 887, 365 };  { 872, 363 };  { 857, 360 };  { 842, 357 };  { 827, 354 };  { 812, 352 };  { 797, 349 };  { 782, 347 };  { 767, 345 };  { 752, 344 };  { 737, 343 };  { 722, 343 };  { 707, 344 };  { 692, 346 };  { 677, 348 };  { 662, 352 };  { 647, 356 };  { 632, 361 };  { 617, 366 };  { 602, 372 };  { 587, 378 };  { 572, 385 };  { 557, 393 };  { 544, 407 };  { 541, 422 };  { 543, 437 };  { 551, 452 };  { 566, 464 };  { 581, 470 };  { 596, 471 };  { 611, 469 };  { 626, 467 };  { 641, 463 };  { 656, 459 };  { 671, 454 };  { 686, 449 };  { 701, 444 };  { 716, 440 };  { 731, 437 };  { 746, 435 };  { 761, 435 };  { 776, 437 };  { 791, 440 };  { 806, 446 };  { 821, 454 };  { 836, 464 };  { 846, 479 };  { 849, 494 };  { 849, 509 };  { 846, 524 };  { 843, 539 };  { 839, 554 };  { 833, 569 };  { 825, 584 };  { 814, 576 };
      };    
    };
    --2
    {
      --2_1
      {
        { 640, 336 };  { 625, 348 };  { 613, 363 };  { 607, 378 };  { 605, 393 };  { 608, 408 };  { 615, 423 };  { 627, 438 };  { 639, 453 };  { 646, 468 };  { 654, 483 };  { 662, 498 };  { 671, 513 };  { 681, 528 };  { 693, 543 };  { 708, 555 };  { 723, 561 };  { 738, 563 };  { 753, 561 };  { 768, 555 };  { 783, 547 };  { 798, 538 };  { 813, 528 };  { 827, 515 };  { 841, 500 };  { 854, 485 };  { 866, 470 };  { 878, 455 };  { 888, 440 };  { 898, 425 };  { 906, 410 };  { 913, 395 };  { 919, 380 };  { 924, 365 };  { 928, 350 };  { 931, 335 };  { 933, 320 };  { 935, 305 };  { 937, 290 };  { 939, 275 };  { 940, 260 };  { 942, 245 };  { 943, 230 };  { 944, 215 };  { 945, 200 };  { 946, 185 };  { 947, 170 };  { 949, 155 };  { 948, 140 };  { 945, 125 };  { 942, 110 };  { 937, 95 };  { 929, 80 };  { 915, 67 };  { 900, 59 };  { 885, 55 };  { 870, 53 };  { 855, 52 };  { 840, 53 };  { 825, 55 };  { 810, 58 };  { 795, 62 };  { 780, 67 };  { 765, 73 };  { 750, 79 };  { 735, 86 };  { 720, 89 };  { 705, 92 };  { 690, 94 };  { 675, 96 };  { 660, 97 };  { 645, 98 };  { 630, 99 };  { 615, 100 };  { 600, 100 };  { 585, 101 };  { 570, 101 };  { 555, 101 };  { 540, 101 };  { 525, 101 };  { 510, 101 };  { 495, 101 };  { 480, 101 };  { 465, 101 };  { 450, 100 };  { 435, 100 };  { 420, 100 };  { 405, 99 };  { 390, 99 };  { 375, 98 };  { 360, 97 };  { 345, 96 };  { 330, 96 };  { 315, 94 };  { 300, 93 };  { 285, 92 };  { 270, 90 };  { 255, 88 };  { 240, 86 };  { 225, 83 };  { 210, 80 };  { 195, 77 };  { 180, 74 };  { 165, 70 };  { 150, 67 };  { 135, 65 };  { 120, 64 };  { 105, 64 };  { 90, 66 };  { 75, 72 };  { 60, 84 };  { 49, 99 };  { 44, 114 };  { 45, 129 };  { 51, 144 };  { 60, 159 };  { 74, 169 };  { 89, 172 };  { 104, 174 };  { 119, 176 };  { 134, 177 };  { 149, 178 };  { 164, 179 };  { 179, 179 };  { 194, 180 };  { 209, 180 };  { 224, 181 };  { 239, 181 };  { 254, 182 };  { 269, 182 };  { 284, 182 };  { 299, 183 };  { 314, 183 };  { 329, 183 };  { 344, 184 };  { 359, 184 };  { 374, 184 };  { 389, 184 };  { 404, 185 };  { 419, 185 };  { 434, 185 };  { 449, 186 };  { 464, 186 };  { 479, 186 };  { 494, 187 };  { 509, 187 };  { 524, 188 };  { 539, 188 };  { 554, 188 };  { 569, 188 };  { 584, 186 };  { 599, 187 };  { 614, 193 };  { 628, 207 };  { 635, 222 };  { 638, 237 };  { 637, 252 };  { 629, 267 };  { 614, 279 };  { 599, 288 };  { 584, 294 };  { 569, 299 };  { 554, 304 };  { 539, 309 };  { 524, 312 };  { 509, 315 };  { 494, 317 };  { 479, 318 };  { 464, 318 };  { 449, 317 };  { 434, 316 };  { 419, 313 };  { 404, 310 };  { 389, 306 };  { 374, 302 };  { 359, 299 };  { 344, 295 };  { 329, 292 };  { 314, 289 };  { 299, 286 };  { 284, 284 };  { 269, 283 };  { 254, 282 };  { 239, 282 };  { 224, 282 };  { 209, 283 };  { 194, 283 };  { 179, 285 };  { 164, 286 };  { 149, 287 };  { 134, 289 };  { 119, 291 };  { 104, 295 };  { 89, 300 };  { 74, 309 };  { 61, 323 };  { 53, 338 };  { 51, 353 };  { 57, 368 };  { 71, 381 };  { 86, 388 };  { 101, 393 };  { 116, 397 };  { 131, 400 };  { 146, 402 };  { 161, 404 };  { 176, 405 };  { 191, 406 };  { 206, 407 };  { 221, 408 };  { 236, 409 };  { 251, 410 };  { 266, 410 };  { 281, 411 };  { 296, 411 };  { 311, 412 };  { 326, 412 };  { 341, 412 };  { 356, 412 };  { 371, 412 };  { 386, 413 };  { 401, 413 };  { 416, 413 };  { 431, 413 };  { 446, 412 };  { 461, 414 };  { 476, 422 };  { 486, 437 };  { 490, 452 };  { 490, 467 };  { 486, 482 };  { 477, 497 };  { 462, 508 };  { 447, 513 };  { 432, 516 };  { 417, 517 };  { 402, 518 };  { 387, 518 };  { 372, 518 };  { 357, 517 };  { 342, 516 };  { 327, 515 };  { 312, 514 };  { 297, 512 };  { 282, 519 };  { 269, 532 };  { 265, 547 };  { 264, 562 };          
      };
    };
    --3
    {
      --3_1
      {
        { 391, 138 }; { 401, 153 }; { 411, 168 }; { 422, 183 }; { 434, 198 }; { 449, 212 }; { 464, 224 }; { 479, 231 }; { 494, 234 }; { 509, 231 }; { 523, 219 }; { 534, 204 }; { 542, 189 }; { 549, 174 }; { 556, 159 }; { 562, 144 }; { 568, 129 }; { 576, 114 }; { 589, 100 }; { 604, 93 }; { 619, 89 }; { 634, 88 }; { 649, 87 }; { 664, 87 }; { 679, 87 }; { 694, 87 }; { 709, 87 }; { 724, 86 }; { 739, 86 }; { 754, 84 }; { 769, 79 }; { 784, 72 }; { 799, 63 }; { 814, 57 }; { 829, 53 }; { 844, 51 }; { 859, 50 }; { 874, 49 }; { 889, 49 }; { 904, 49 }; { 919, 51 }; { 934, 55 }; { 949, 63 }; { 961, 77 }; { 969, 92 }; { 967, 107 }; { 958, 122 }; { 943, 130 }; { 928, 133 }; { 913, 136 }; { 898, 137 }; { 883, 138 }; { 868, 140 }; { 853, 141 }; { 838, 142 }; { 823, 143 }; { 808, 145 }; { 793, 146 }; { 778, 148 }; { 763, 149 }; { 748, 149 }; { 733, 149 }; { 718, 149 }; { 703, 151 }; { 688, 155 }; { 674, 166 }; { 671, 181 }; { 673, 196 }; { 681, 211 }; { 695, 225 }; { 710, 232 }; { 725, 235 }; { 740, 235 }; { 755, 235 }; { 770, 235 }; { 785, 234 }; { 800, 232 }; { 815, 231 }; { 830, 228 }; { 845, 226 }; { 860, 223 }; { 875, 221 }; { 890, 220 }; { 905, 220 }; { 920, 222 }; { 935, 229 }; { 950, 240 }; { 960, 254 }; { 968, 269 }; { 972, 284 }; { 968, 299 }; { 954, 310 }; { 939, 315 }; { 924, 319 }; { 909, 321 }; { 894, 323 }; { 879, 324 }; { 864, 325 }; { 849, 326 }; { 834, 326 }; { 819, 326 }; { 804, 326 }; { 789, 325 }; { 774, 324 }; { 759, 322 }; { 744, 321 }; { 729, 318 }; { 714, 316 }; { 699, 313 }; { 684, 310 }; { 669, 307 }; { 654, 306 }; { 639, 309 }; { 624, 315 }; { 609, 326 }; { 594, 338 }; { 579, 350 }; { 564, 361 }; { 549, 371 }; { 534, 378 }; { 519, 382 }; { 504, 384 }; { 489, 384 }; { 474, 383 }; { 459, 380 }; { 444, 376 }; { 429, 372 }; { 414, 370 }; { 399, 371 }; { 385, 379 }; { 378, 394 }; { 376, 409 }; { 378, 424 }; { 385, 439 }; { 398, 452 }; { 413, 458 }; { 428, 461 }; { 443, 463 }; { 458, 464 }; { 473, 465 }; { 488, 466 }; { 503, 466 }; { 518, 465 }; { 533, 463 }; { 548, 460 }; { 563, 455 }; { 578, 448 }; { 593, 441 }; { 608, 432 }; { 623, 424 }; { 638, 417 }; { 653, 412 }; { 668, 409 }; { 683, 408 }; { 698, 409 }; { 713, 411 }; { 728, 414 }; { 743, 418 }; { 758, 422 }; { 773, 427 }; { 788, 432 }; { 803, 438 }; { 818, 446 }; { 833, 459 }; { 845, 473 }; { 852, 488 }; { 856, 503 }; { 858, 518 }; { 859, 533 }; { 858, 548 }; { 857, 563 }; { 855, 578 }; { 851, 593 }; { 847, 608 }; { 842, 623 }; { 836, 638 }; { 830, 653 }; { 823, 668 }; { 815, 683 }; { 807, 698 }; { 799, 713 }; { 785, 726 }; { 770, 732 }; { 755, 733 }; { 740, 731 }; { 725, 727 }; { 710, 723 }; { 695, 718 }; { 680, 713 }; { 665, 709 }; { 650, 705 }; { 635, 701 }; { 620, 697 }; { 605, 693 }; { 590, 689 }; { 586, 688 };         
      };
      --3_2
      {
        { 616, 218 }; { 609, 233 }; { 601, 248 }; { 593, 263 }; { 583, 278 }; { 572, 293 }; { 557, 307 }; { 542, 317 }; { 527, 323 }; { 512, 326 }; { 497, 328 }; { 482, 327 }; { 467, 324 }; { 452, 320 }; { 437, 313 }; { 422, 304 }; { 407, 292 }; { 392, 279 }; { 377, 264 }; { 363, 249 }; { 352, 234 }; { 342, 219 }; { 334, 204 }; { 326, 189 }; { 320, 174 }; { 315, 159 }; { 310, 144 }; { 304, 129 }; { 297, 114 }; { 287, 99 }; { 273, 84 }; { 258, 73 }; { 243, 65 }; { 228, 60 }; { 213, 56 }; { 198, 54 }; { 183, 53 }; { 168, 53 }; { 153, 54 }; { 138, 57 }; { 123, 63 }; { 108, 72 }; { 93, 85 }; { 81, 100 }; { 72, 115 }; { 64, 130 }; { 59, 145 }; { 54, 160 }; { 51, 175 }; { 49, 190 }; { 47, 205 }; { 46, 220 }; { 45, 235 }; { 45, 250 }; { 45, 265 }; { 45, 280 }; { 47, 295 }; { 48, 310 }; { 50, 325 }; { 53, 340 }; { 57, 355 }; { 61, 370 }; { 67, 385 }; { 74, 400 }; { 82, 415 }; { 91, 430 }; { 101, 445 }; { 111, 460 }; { 121, 475 }; { 128, 490 }; { 134, 505 }; { 138, 520 }; { 141, 535 }; { 144, 550 }; { 146, 565 }; { 149, 580 }; { 151, 595 }; { 155, 610 }; { 158, 625 }; { 163, 640 }; { 169, 655 }; { 176, 670 }; { 184, 685 }; { 192, 700 }; { 202, 715 }; { 216, 729 }; { 231, 735 }; { 246, 730 }; { 258, 715 }; { 264, 700 }; { 267, 685 }; { 268, 670 }; { 269, 655 }; { 268, 640 }; { 267, 625 }; { 266, 610 }; { 264, 595 }; { 262, 580 }; { 260, 565 }; { 258, 550 }; { 255, 535 }; { 253, 520 }; { 250, 505 }; { 248, 490 }; { 245, 475 }; { 239, 460 }; { 226, 445 }; { 211, 434 }; { 196, 423 }; { 181, 410 }; { 167, 396 }; { 157, 381 }; { 150, 366 }; { 144, 351 }; { 141, 336 }; { 138, 321 }; { 136, 306 }; { 135, 291 }; { 134, 276 }; { 133, 261 }; { 133, 246 }; { 133, 231 }; { 133, 216 }; { 133, 201 }; { 134, 186 }; { 136, 171 }; { 140, 156 }; { 150, 141 }; { 165, 134 }; { 180, 132 }; { 195, 134 }; { 210, 140 }; { 225, 151 }; { 239, 165 }; { 248, 180 }; { 256, 195 }; { 263, 210 }; { 269, 225 }; { 275, 240 }; { 280, 255 }; { 286, 270 }; { 291, 285 }; { 296, 300 }; { 301, 315 }; { 305, 330 }; { 308, 345 }; { 311, 360 }; { 312, 375 }; { 313, 390 }; { 313, 405 }; { 313, 420 }; { 313, 435 }; { 314, 450 }; { 314, 465 }; { 315, 480 }; { 316, 495 }; { 318, 510 }; { 320, 525 }; { 323, 540 }; { 325, 555 }; { 328, 570 }; { 332, 585 }; { 335, 600 }; { 338, 615 }; { 342, 630 }; { 347, 645 }; { 353, 660 }; { 362, 675 }; { 373, 690 }; { 388, 702 }; { 403, 710 }; { 418, 712 }; { 433, 708 }; { 448, 699 }; { 450, 697 };         
      };
    };
  };

  gm.path = {}
  for i = 1, #gm.lines do
    gm.path[i] = {}
    for j = 1, #gm.lines[i] do
      gm.path[i][j] = gm.get_path( gm.lines[i][j] )
      --ld.LogTrace( gm.path[i][j] )
    end;
  end

  

--ld.LogTrace( gm.path[1][1] )
  gm.path_show( gm.path[1][1] , 1 )
  --gm.path[1][1] = gm.path_smoth( gm.path[1][1], 3 )

--ld.LogTrace( gm.path[1][1] )

  --gm.path_show( gm.path[1][1] , 2 )

end;

function gm.get_path( line )

  local path = {}
  local p1
  local p2
  local dx
  local dy
  local len

  for i = 1, #line-1 do
    --ld.LogTrace( i/#line*100,i, #line, line[i], line[i+1] )
    p1 = ld.TableCopy( line[i] )
    p2 = ld.TableCopy( line[i+1] )
    dx = p2[1] - p1[1]
    dy = p2[2] - p1[2]
    len = gm.len( p1[1], p1[2], p2[1], p2[2] )
    table.insert( path, { p1[1], p1[2] } )

    while ( ( dx >= 0 ) and ( p2[1] >= p1[1] ) or ( dx < 0 ) and ( p2[1] < p1[1] ) ) 
    and ( ( dy >= 0 ) and ( p2[2] >= p1[2] ) or ( dy < 0 ) and ( p2[2] < p1[2] ) ) 
    do
      --len = gm.len( p1[1], p1[2], p2[1], p2[2] )
      p1[1] = p1[1] + dx / len
      p1[2] = p1[2] + dy / len
      table.insert( path, { p1[1], p1[2] } )
      --ld.LogTrace( p1[1], p1[2] )
    end;

    --len = gm.len( p1[1], p1[2], p2[1], p2[2] )
    line[i+1][1] = p1[1] + dx / len
    line[i+1][2] = p1[2] + dy / len
    --table.insert( path, { p1[1], p1[2] } )
  
    --if i >= 10 then
    --  break
    --end

  end

  --ld.LogTrace( "get_path len", #path )

  return path

end

function gm.path_show()

  local pix_sec = 600

  for i = 1, #gm.lines[gm.lvl] do

    local fx = "fx_fightext_path_"..gm.lvl.."_"..i.."_0"
    ObjCreate( fx, "partsys" )
    ObjSet( fx, {
      pos_z = -333;
      res = "assets/levels/levelext/mg_fightext/fx_path";
    } )
    ObjAttach( fx, "obj_fightext_mmg_root" )
    PartSysStop( fx, 1 )
    local anim = { 0,0,gm.lines[gm.lvl][i][1][1],gm.lines[gm.lvl][i][1][2] }
    local len
    local t = 0
    local t_all = 0

    ObjSet( "fx_fightext_balls_ball_hide_fx_"..i, { active = 1; pos_x = anim[ 3 ];  pos_y = anim[ 4 ]; } )
    PartSysRestart( "fx_fightext_balls_ball_hide_fx_"..i )

    for j = 1+1, #gm.lines[gm.lvl][i] do
      len = gm.len( gm.lines[gm.lvl][i][j-1][1], gm.lines[gm.lvl][i][j-1][2], gm.lines[gm.lvl][i][j-0][1], gm.lines[gm.lvl][i][j-0][2] )
      t = t + len / pix_sec
      t_all = t_all + len / pix_sec
      table.insert( anim, t );
      table.insert( anim, 0 );
      table.insert( anim, gm.lines[gm.lvl][i][j-0][1] );
      table.insert( anim, gm.lines[gm.lvl][i][j-0][2] );
      --ld.LogTrace( len, t )
    end

    ObjAnimate( fx, 7,0,0, function() 
      PartSysRestart( fx )
      ObjAnimate( fx, 3,1,0, _, anim )
    end, { 0,0,0, 0,0,0 } );

    --local fx_need = math.floor( t * ( 1000 / pix_sec ) )
    --for j = 1, fx_need - 1 do
    --  local fx = "fx_fightext_path_"..gm.lvl.."_"..i.."_"..j
    --  ObjCreate( fx, "partsys" )
    --  ObjSet( fx, {
    --    pos_z = 333;
    --    res = "assets/levels/levelext/mg_fightext/fx_path";
    --  } )
    --  ObjAttach( fx, "obj_fightext_balls_root" )
    --  PartSysStop( fx, 1 )
    --  ObjAnimate( fx, 7,0,0, function() 
    --    PartSysRestart( fx )
    --    ObjAnimate( fx, 3,1,0, _, anim )
    --  end, { 0,0,0, t/fx_need*j,0,0 } );
    --end;
    

  end;
end;

function gm.path_hide()
  for i = 1, #gm.lines[gm.lvl] do
    PartSysStop( "fx_fightext_balls_ball_hide_fx_"..i, 0 )
    local fx = "fx_fightext_path_"..gm.lvl.."_"..i.."_0"
   --( "path_hide", fx )
    ObjAnimate( fx, 8,0,0, function() 
      ObjDelete( fx )
    end, { 0,0,1, 0.5,0,0 } )
  end
end;

function gm.balls_init()
  gm.ball_types = {
    "color1";
    "color2";
    "color3";

    "color4";
  }
  gm.balls_garbage = {}
  gm.balls = {}
  gm.balls_by_name = {}
  
  gm.balls_id_max = 0

  gm.path_init()

  gm.amulet_init()

end;

function gm.balls_tick( line )

  if not ObjGet( "obj_fightext_amulet_root" ) then return end;

  local x_amulet = ObjGet( "obj_fightext_amulet_root" ).pos_x;
  local y_amulet = ObjGet( "obj_fightext_amulet_root" ).pos_y;

  local tTick = gm.ball_pix_per_tick();
  line = line or 1
  gm.balls[line] = gm.balls[line] or {}
  local line_balls = gm.balls[line]
  local x1
  local y1
  local x2
  local y2
  local len
  local len_counter = 0
  

  local len
  local ball = line_balls[#line_balls]
  local ball_back

  if #line_balls == 0 then
    
    gm.ball_new_insert( line )
    ball = line_balls[#line_balls]

  elseif ball.pos > 1 then

    x1 = gm.path[gm.lvl][line][1][1]
    y1 = gm.path[gm.lvl][line][1][2]

    x2,y2 = gm.ball_get_x_y( ball )

    if gm.len( x1, y1, x2, y2 ) >= gm.BALL_D then

      gm.ball_new_insert( line )
      ball = line_balls[#line_balls]

    end;

  end;

  if line_balls[1].pos > #gm.path[gm.lvl][line_balls[1].line] then
    public.Reset()
  end;

  -->> стандартный случай: толкаем шары вперёд >>--
  
  --<< magniting <<--


  -->> талкаем в обратку шары с реверсом и рядом стоящие
  local balls_in_revers = {}
  local destroy = {}
  local speed_old
  local speed_new
  local dpos
  for i = #line_balls-1, 1, -1 do
    if line_balls[i].reverse  then

      if ( line_balls[i].pos - line_balls[i+1].pos ) <= ( line_balls[i].r + line_balls[i+1].r + gm.D_LEN ) then
        --врезались в линию

    SoundSfx( "aud_hit_the_ball" );

        line_balls[i].reverse = false
        --толкаем цепочку
        speed_old = line_balls[i].speed
        speed_new = ( math.abs( speed_old ) ^ 0.75 ) * ( speed_old > 0 and 1 or -1 )
        line_balls[i].speed = speed_new
        --ld.LogTrace( speed_old, speed_new, line_balls[i+1].speed )
        --dpos = gm.BALL_D - ( line_balls[i].pos - line_balls[i+1].pos )
        for j = i, #line_balls-1, 1 do
          if ( line_balls[j].pos - line_balls[j+1].pos ) <= ( line_balls[j].r + line_balls[j+1].r + gm.D_LEN ) then
            line_balls[j+1].speed = line_balls[j].speed
          else
            break
          end;
        end;
        table.insert( destroy, { line_balls[i], speed_old } )
        --line_balls_destroy_line( line_balls[i] )
      else
        --тянем цепочку 
        if line_balls[i].type ~= line_balls[i+1].type then
          --однотипный шарик уже ушатан, тормозим скорость
          line_balls[i].speed = line_balls[i].speed - gm.BALL_MAGNITING_SPEED
          if line_balls[i].speed < 0 then
            line_balls[i].speed = 0;  
            line_balls[i].reverse = false
          end
        else
          --набираем скорость
          line_balls[i].speed = line_balls[i].speed + gm.BALL_MAGNITING_SPEED
        end

        balls_in_revers[ line_balls[i].name ] = line_balls[i].reverse
        for j = i, 1+1, -1 do
          if ( line_balls[j-1].pos - line_balls[j].pos ) <= ( line_balls[j-1].r + line_balls[j].r+ gm.D_LEN ) then
            line_balls[j-1].speed = line_balls[j].speed
            balls_in_revers[ line_balls[j-1].name ] = line_balls[i].reverse
          else
            break
          end;
        end;
      end;

    --точно не нужно магнитить??
    elseif line_balls[i].type == line_balls[i+1].type
    and not gm.balls_is_near( line_balls[i], line_balls[i+1] )
    then
      line_balls[i].reverse = true
    end
  end;
  for i = 1, #destroy do
    gm.balls_destroy_line( destroy[i][1], destroy[i][2] )
  end;

  -->> выравниваем?
  gm.balls_restacker(line)

  -->> проверка на случаи если камни едут вперёд без толкания
  ball = line_balls[#line_balls]
  for i = #line_balls, 1+1, -1 do
    if not gm.balls_is_near( line_balls[i-1], line_balls[i] ) then
      for j = 1, i-1 do
        if line_balls[j].speed > 0 then
          --ObjSet( line_balls[j].name, { color_r = 0.5; color_g = 0.5; color_b = 0.5; } )
          line_balls[j].speed = 0;
        else
          --ObjSet( line_balls[j].name, { color_r = 1; color_G = 1; color_B = 1; } )
        end;
      end;
      break
    end
  end


  -->> проверяем, не упёрлись ли в шар с нулевой скоростью
  for i = #line_balls, 1+1, -1 do
    if line_balls[i].speed > 0 and line_balls[i-1].speed == 0 then
    --if line_balls[i-1].speed == 0 then
      if ( line_balls[i-1].pos - line_balls[i].pos ) <= ( line_balls[i-1].r + line_balls[i].r + gm.D_LEN ) then
        for j = i, 1+1, -1 do
          if ( line_balls[j-1].pos - line_balls[j].pos ) <= ( line_balls[j-1].r + line_balls[j].r + gm.D_LEN ) then
            line_balls[j-1].speed = line_balls[j].speed
          else
            break
          end;
        end;
      end;
    end;
  end;

  -->> если талкун остановился
  ball = line_balls[#line_balls]
  if ball and ball.speed == 0 and ball.pos < 1 then
    ball.speed = 0.000001
  end

  -->> если нет реверсов и начальная группа за началом
  local speed_up = true
  if line_balls[1] and line_balls[1].pos < 0 then
    for i = 1, #line_balls do
      if line_balls[i].speed <= 1 then
        line_balls[i].speed  = 1.000001
      end
      line_balls[i].speed = line_balls[i].speed - gm.BALL_MAGNITING_SPEED * 4
    end
  end;
  local all_stoped = true
  for i = 1, #line_balls do
    if line_balls[i].speed ~= 0 then
      all_stoped = false
      break
    end
  end
  if all_stoped then
    for i = 1, #line_balls do
      line_balls[i].speed = 1
    end
  end

  -->> выставляем x,y шарам на поле -->>
  local alp
          local x_bef, y_bef
          local x_aft, y_aft
          local ang_mid
          local ang_balls
          local drawoff_ang

          local x_out
          local y_out
  for i = #line_balls, 1, -1 do

    ball = line_balls[i]

    -->> востанавливаем скорость
    if not balls_in_revers[ ball.name ] then
      if ball.speed ~= 0 and ball.speed < 1 then
        ball.speed = ball.speed - gm.BALL_MAGNITING_SPEED
        if ball.speed == 0 then 
          ball.speed = 0.000001
        elseif ball.speed > 1 then
          ball.speed = 1
        end
      elseif ball.speed > 1 then
        ball.speed = ball.speed + gm.BALL_MAGNITING_SPEED
      end
    end

    ball.pos = ball.pos + tTick * ball.speed
    --ball.ang_rotate = ball.ang_rotate + tTick * ball.speed * 0.025

    if ball.pos < 1 then
      alp = 0
    elseif ball.pos >= gm.BALL_R then
      alp = 1
    else
      alp = ( ball.pos - 1 ) / ( gm.BALL_R - 1 )
    end

    if ball.owner then
        ball.ang_rotate = 0
        ball.r = ball.r + gm.D_LEN* 0.4
        --ld.LogTrace( ball.r )
        if ball.r >= gm.BALL_R then
        --ObjSet( ball.owner, { blendmode = 0 } )
          ball.insert_pos = nil
          ball.r = gm.BALL_R
          ball.owner = false
          ObjSet( ball.name, { drawoff_x = 0, drawoff_y = 0, pos_z = 0 } )
          --ObjSet( ball.name:gsub("_ball_","_ball_crash_"), { drawoff_x = 0, drawoff_y = 0, pos_z = 0 } )
        else
        --ObjSet( ball.owner, { blendmode = 2 } )
          if not line_balls[i+1] or not gm.balls_is_near( ball, line_balls[i+1] ) then
            ball.pos = ball.pos - gm.D_LEN* 0.4
          else
            ball.pos = ball.pos + gm.D_LEN* 0.4
          end;
          x2,y2 = gm.ball_get_x_y( ball )
          x_bef, y_bef = gm.ball_get_x_y( ball.pos - gm.BALL_R, ball.line )
          x_aft, y_aft = gm.ball_get_x_y( ball.pos, ball.line )
          ang_mid = math.acos( ( gm.BALL_R + ball.r ) / gm.BALL_D )
          ang_balls = gm.ang_gip( x_bef, y_bef, x_aft, y_aft )

          --if not ball.diff_ang_state then
          --  if ang_balls >= math.pi*1.25 and ang_balls <= math.pi*1.75 then
          --    if x_aft > x_amulet then
          --      ball.diff_ang_state = -1
          --    else
          --      ball.diff_ang_state = 1
          --    end
          --  elseif ang_balls >= math.pi*0.25 and ang_balls <= math.pi*0.75 then
          --    if x_aft > x_amulet then
          --      ball.diff_ang_state = 1
          --    else
          --      ball.diff_ang_state = -1
          --    end
          --  elseif ang_balls >= math.pi*0.75 and ang_balls <= math.pi*1.25 then
          --    if y_aft > y_amulet then
          --      ball.diff_ang_state = -1
          --    else
          --      ball.diff_ang_state = 1
          --    end
          --  else
          --    if y_aft > x_amulet then
          --      ball.diff_ang_state = 1
          --    else
          --      ball.diff_ang_state = -1
          --    end
          --  end
          --end
--insert_pos
          --drawoff_ang = ang_mid * ball.diff_ang_state
          
            --if ang_balls >= math.pi*1.25 and ang_balls <= math.pi*1.75 then
            --  if x_aft > x_amulet then
            --    drawoff_ang = -math.abs( ang_mid )
            --  else
            --    drawoff_ang = math.abs( ang_mid )
            --  end
            --elseif ang_balls >= math.pi*0.25 and ang_balls <= math.pi*0.75 then
            --  if x_aft > x_amulet then
            --    drawoff_ang = math.abs( ang_mid )
            --  else
            --    drawoff_ang = -math.abs( ang_mid )
            --  end
            --elseif ang_balls >= math.pi*0.75 and ang_balls <= math.pi*1.25 then
            --  if y_aft > y_amulet then
            --    drawoff_ang = -math.abs( ang_mid )
            --  else
            --    drawoff_ang = math.abs( ang_mid )
            --  end
            --else
            --  if y_aft > x_amulet then
            --    drawoff_ang = math.abs( ang_mid )
            --  else
            --    drawoff_ang = -math.abs( ang_mid )
            --  end
            --end

          --local x_out = x_bef + gm.BALL_R * math.cos( ang_balls - drawoff_ang )
          --local y_out = y_bef - gm.BALL_R * math.sin( ang_balls - drawoff_ang )

          local x_out = ball.r / gm.BALL_R * ( x2 - ball.insert_pos.pos_x )
          local y_out = ball.r / gm.BALL_R * ( y2 - ball.insert_pos.pos_y )
          ball.insert_pos.pos_x = ball.insert_pos.pos_x + x_out;
          ball.insert_pos.pos_y = ball.insert_pos.pos_y + y_out;
              ObjSet( ball.name, { 
                
                drawoff_x = x_out; 
                drawoff_y = y_out;
                --pos_x = x2; 
                --pos_y = y2;
              } )
              --ObjSet( ball.name:gsub("_ball_","_ball_crash_"), { ang = 0; drawoff_x = x2 - x_out, drawoff_y = y2 - y_out } )

        end
    end

    x2,y2 = gm.ball_get_x_y( ball )

      ObjSet( ball.name, { 
        pos_x = x2; 
        pos_y = y2;
        alp = alp;
        --ang = ball.ang_rotate
      } )
      --ObjSet( ball.name:gsub("_ball_","_ball_crash_"), { ang = ball.ang_rotate } )

    --end

  end;
  --<< выставляем x,y шарам на поле --<<
  

  if gm.lines[gm.lvl][line+1] then
    gm.balls_tick(line+1)
  end;

end

function gm.balls_is_near( ball_far, ball_closer )
  if ( ball_far.pos - ball_closer.pos ) <= ( ball_far.r + ball_closer.r + gm.D_LEN ) then
    return true
  else
    return false
  end;
end;

function gm.balls_restacker( line )
  
  local dp
  local dpos
  
    for i = 1, #gm.balls[line]-1 do
      dp = ( gm.balls[line][i].pos - gm.balls[line][i+1].pos )
      if dp < ( gm.balls[line][i].r + gm.balls[line][i+1].r + gm.D_LEN ) then
        dpos = gm.balls[line][i].r + gm.balls[line][i+1].r - dp

        gm.balls[line][i].pos = gm.balls[line][i].pos + dpos

        --ld.LogTrace(  )
        for j = i-1, 1, -1 do
          --обновлять dpos?? да!!
          dp = ( gm.balls[line][j].pos - gm.balls[line][j+1].pos )
          if dp < ( gm.balls[line][j].r + gm.balls[line][j+1].r + gm.D_LEN ) then
            dpos = gm.balls[line][j].r + gm.balls[line][j+1].r - dp
            gm.balls[line][j].pos = gm.balls[line][j].pos + dpos
          else
            break
          end

        end;
      end
    end;

end

-- function gm.balls_len() end
function gm.balls_len( ball1, ball2 )
  local x1,y1 = gm.ball_get_x_y( ball1 )
  local x2,y2 = gm.ball_get_x_y( ball2 )

  return gm.len( x1,y1, x2,y2 )
end;

function gm.balls_destroy_line( ball, speed_old )
 --ld.LogTrace( gm.balls )
  local line = ball.line
  local b2
  local destroy = {ball};
  local id = gm.ball_get_place( ball )
  local x1,y1,x2,y2,len
  local end_check_ball
  for i = id+1, #gm.balls[line] do
    b2 = gm.balls[line][i]
    if ( ball.type == b2.type ) and ( ( gm.balls[line][i-1].pos - b2.pos ) <= ( gm.BALL_D + gm.D_LEN ) ) then
      table.insert( destroy, b2 )
    else
      break
    end
  end;

  for i = id-1, 1, -1 do
    b2 = gm.balls[line][i]
    if ( ball.type == b2.type ) and ( ( b2.pos - gm.balls[line][i+1].pos ) <= ( gm.BALL_D + gm.D_LEN ) ) then
      table.insert( destroy, b2 )
    else
      end_check_ball = b2
      break
    end
  end;

  if #destroy >= 3 then
    SoundSfx( "aud_balls_exp" )
    for i = 1, #destroy do
      gm.ball_destroy( destroy[i] )
    end;
    
    --останавливаем шары либор заставляем катится в обратную сторону
    if end_check_ball then
      local id = gm.ball_get_place( end_check_ball )
      if id and gm.balls[line][id+1] and end_check_ball.type == gm.balls[line][id+1].type then
        end_check_ball.reverse = true
        --нужно магнитить
        end_check_ball.speed = 0
        for i = id-1, 1, -1 do
          --ld.LogTrace( i, gm.balls_len( gm.balls[i+1], gm.balls[i] ) )
          if ( ( gm.balls[line][i].pos - gm.balls[line][i+1].pos ) <= ( gm.BALL_D + gm.D_LEN ) ) then
            gm.balls[line][i].speed = 0
          else
            break
          end
        end;
      else
        --останавливаем
        end_check_ball.speed = 0
        for i = id-1, 1, -1 do
          --ld.LogTrace( i, gm.balls_len( gm.balls[i+1], gm.balls[i] ) )
          if ( ( gm.balls[line][i].pos - gm.balls[line][i+1].pos ) <= ( gm.BALL_D + gm.D_LEN ) ) then
            gm.balls[line][i].speed = 0
          else
            break
          end
        end;
      end;
    end
    
    gm.amulet_add_score( #destroy, speed_old )

    return true
  else
    return false
  end;
end;
--function xxx() end;
function gm.ball_destroy( ball, fx_name )

  --local o = ObjGet( ball.name )
  local op = GetObjPosByObj( ball.name, "obj_fightext_mmg_root" );
  local o = { pos_x = op[ 1 ]; pos_y = op[ 2 ]; }

  if fx_name ~= "silent" then

    if ObjGet( "tmr_"..ball.name.."_destroy_fx" ) then
      ld.LogTrace( "NOT ENAUGH GARBAGE!!!" )
    end

    if not ObjGet( ball.name.."_destroy_fx" ) then
      ObjCreate( ball.name.."_destroy_fx", "partsys" );
      ObjCreate( ball.name.."_fly_fx", "partsys" );
    end

    ObjSet( ball.name.."_destroy_fx", { 
      res = "assets/levels/levelext/mg_fightext/"..( fx_name or gm.ball_types[ ball.type ].."_fx" );
      pos_x = o.pos_x;
      pos_y = o.pos_y;
      pos_z = 39;
    } )
    ObjAttach( ball.name.."_destroy_fx", "obj_fightext_mmg_root" )
    PartSysRestart( ball.name.."_destroy_fx" )
    ld.StartTimer( "tmr_"..ball.name.."_destroy_fx", 1.5, function() ObjAttach( ball.name.."_destroy_fx", "obj_fightext_garbage_root" ) end )

  end

  table.insert( gm.balls_garbage, ball )
  ObjAttach( ball.name, "obj_fightext_garbage_root" )

  local id = gm.ball_get_place( ball )
  if id then
    table.remove( gm.balls[ball.line], id )
  end

  if not fx_name then
    local fx = ball.name.."_fly_fx"
    local amulet = ObjGet( "obj_fightext_amulet_root" )
    ObjSet( fx, { 
      res = "assets/levels/levelext/mg_fightext/fx_fly";
      pos_x = o.pos_x;
      pos_y = o.pos_y;
      pos_z = 999;
    } )
    local t_fly = math.random( 60, 80 ) / 100
    ObjAttach( fx, "obj_fightext_mmg_root" )
    PartSysRestart( fx )
    ObjAnimate( fx, 0,0,0, _, { 0,0,o.pos_x, t_fly,math.random(0,3),amulet.pos_x + math.random(-35,35) } )
    ObjAnimate( fx, 1,0,0, function() 
      PartSysStop( fx, 0 )
      ld.StartTimer( 0.5, function() ObjAttach( fx, "obj_fightext_garbage_root" )  end )
    end, { 0,0,o.pos_y, t_fly,math.random(0,3),amulet.pos_y + math.random(-35,35) } )
  end

end;

function gm.ball_get_place( ball )

  for i = 1, #gm.balls[ball.line] do
    if gm.balls[ball.line][i].id == ball.id then
      return i;
    end;
  end;

end;

function gm.ball_new_insert( line )
  
  local ball = gm.ball_new( line )
  ObjAttach( "spr_fightext_ball_"..ball.id, "obj_fightext_balls_root" )
  table.insert( gm.balls[line], ball )

end

function gm.ball_pix_per_tick()
  local scale = 1
  for i = 1, #gm.balls do
    if gm.balls[ i ][ 1 ] then
      scale = math.min( scale, 1 -( 0.35 * gm.balls[ i ][ 1 ].pos / #gm.path[ gm.lvl ][ gm.balls[ i ][1].line ] ) ^ 2 )
    end
  end
  --gm.ball_pix_per_tick_counter = ( gm.ball_pix_per_tick_counter or 0 ) + 1
  --if gm.ball_pix_per_tick_counter > 59 then
  --  ld.LogTrace(gm.BALL_PIX_PER_TICK[ gm.lvl ],  scale, gm.BALL_PIX_PER_TICK[ gm.lvl ] * scale )
  --  gm.ball_pix_per_tick_counter = 0
  --end
  return gm.BALL_PIX_PER_TICK[ gm.lvl ] * scale
  --return gm.BALL_PIX_PER_TICK[ gm.lvl ]
end

function gm.ball_new( line )

  local ball = {};
  line = line or 1

  if #gm.balls_garbage < 20 then
    gm.balls_id_max = gm.balls_id_max + 1

    ball.id = gm.balls_id_max;
    ball.name = "spr_fightext_ball_"..ball.id
    ball.ang_rotate = 0

    ObjCreate( "spr_fightext_ball_"..ball.id, "spr" );
    ObjSet( "spr_fightext_ball_"..ball.id, { 
      input = 0;
    } )

    --ObjCreate( "spr_fightext_ball_crash_"..ball.id, "spr" );
    --ObjSet( "spr_fightext_ball_crash_"..ball.id, { 
    --  input = 0;
    --  blendmode = 0;
    --  res = "assets/levels/levelext/mg_fightext/sphere_crash";
    --} )
    --ObjAttach( "spr_fightext_ball_crash_"..ball.id, "spr_fightext_ball_"..ball.id )
    
    gm.balls_by_name[ ball.name ] = ball

  else
    ball = table.remove( gm.balls_garbage, 1 )
  end

  ball.r = gm.BALL_R
  ball.pos = 1;
  ball.type = math.random(1,gm.RANDOM_RANGE[gm.lvl]);
  ball.line = line;
  ball.speed = 1;

  ball.ang = 0;
  ball.owner = false;

  ball.x = gm.path[gm.lvl][ball.line][1][1]
  ball.y = gm.path[gm.lvl][ball.line][1][2]
  ball.magniting = false

  ObjSet( ball.name, { 
    pos_z = 1;
    drawoff_x = 0;
    drawoff_y = 0;
    res = "assets/levels/levelext/mg_fightext/"..gm.ball_types[ball.type];
  } )
  ObjSet( ball.name:gsub("_ball_","_ball_crash_"), { 
    drawoff_x = 0;
    drawoff_y = 0;
  } )

  return ball

end;

function gm.ball_get_x_y( ball, bal_line )
  local bal_pos
  if bal_line then
    bal_pos = ball
  else
    bal_pos = ball.pos
    bal_line = ball.line
  end

  local pos, scale = math.modf( bal_pos )
  local x, y, x0, y0;

  if ( pos + 1 ) > #gm.path[gm.lvl][bal_line] then

    x0 = gm.path[gm.lvl][bal_line][#gm.path[gm.lvl][bal_line]-1][1]
    x  = gm.path[gm.lvl][bal_line][ #gm.path[gm.lvl][bal_line] ][1]

    y0 = gm.path[gm.lvl][bal_line][#gm.path[gm.lvl][bal_line]-1][2]
    y  = gm.path[gm.lvl][bal_line][ #gm.path[gm.lvl][bal_line] ][2]

    local a,l = gm.ang_gip( x0, y0, x, y )

    x = x + l * ( bal_pos - #gm.path[gm.lvl][bal_line] ) * math.cos( a )
    y = y - l * ( bal_pos - #gm.path[gm.lvl][bal_line] ) * math.sin( a )
  
  elseif pos < 1 then

    x0 = gm.path[gm.lvl][bal_line][2][1]
    x  = gm.path[gm.lvl][bal_line][1][1]

    y0 = gm.path[gm.lvl][bal_line][2][2]
    y  = gm.path[gm.lvl][bal_line][1][2]

    local a,l = gm.ang_gip( x0, y0, x, y )

    x = x + l * ( -bal_pos + 1 ) * math.cos( a )
    y = y - l * ( -bal_pos + 1 ) * math.sin( a )

  else

    x = gm.path[gm.lvl][bal_line][pos][1]
    x = x + ( gm.path[gm.lvl][bal_line][pos+1][1] - x ) * scale;

    y = gm.path[gm.lvl][bal_line][pos][2]
    y = y + ( gm.path[gm.lvl][bal_line][pos+1][2] - y ) * scale;

  end

  return x, y

end;

function gm.amulet_init()

  ObjSet( "obj_fightext_clicker", {
    event_mdown = gm.amulet_shoot;
    event_menter = function()  end;
    event_mleave = function()  end;
  } )

  ObjSet( "obj_fightext_amulet_root", { pos_x = gm.AMULET_POS[ gm.lvl ][ 1 ]; pos_y = gm.AMULET_POS[ gm.lvl ][ 2 ]; } )

  gm.amulet_shoots = {}

  gm.amulet_score_now = 0
  gm.amulet_add_score( 0 )

  gm.amulet_charge()

end;

function gm.amulet_add_score( destroy_line_len, ball_speed )
  gm.amulet_score_max = gm.SCORE_LVL[gm.lvl]
  local score = destroy_line_len
  for i = 1, destroy_line_len do
    score = score + i + math.abs( ball_speed - 1 )
  end;

  gm.amulet_score_now = gm.amulet_score_now + score

  --ld.LogTrace( score, gm.amulet_score_now, destroy_line_len, ball_speed )

  if gm.amulet_score_now >= gm.amulet_score_max then
    gm.amulet_score_now = gm.amulet_score_max
    gm.amulet_kill()
  end
  
  --local added = math.floor( gm.amulet_score_now / gm.amulet_score_max * 7 )
  --local o
  --for i = 1, 7 do
  --  o = ObjGet( "spr_fightext_amulet_life_"..i )
  --  ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, 0.5,0,i > added and 0 or 1 } )
  --end

end
function   gm.amulet_add_score_anim()
  local h = 158
  local o = ObjGet( "spr_fightext_lifebar_arrow" )
  local score_percent = gm.amulet_score_now / gm.amulet_score_max;
  if score_percent == 0 then
    score_percent = 0.000001;
  end
  if o then
    ObjAnimate( o.name, 1,0,0, nil, { 0,0,o.pos_y, 0.4,2,h/2-h*score_percent } )
    ObjSet( "spr_fightext_lifebar_energy", { croprect_h = ( h - o.pos_y ) * 2; croprect_y = o.pos_y; } )
    ObjAnimate( "spr_fightext_lifebar_energy", 7,0,0, gm.amulet_add_score_anim, { 0,0,0, 0,0,0 } )
  end
end

function gm.amulet_uncharge()
  gm.ball_destroy( gm.amulet_charged )
  gm.amulet_charged = nil
  gm.amulet_charging = false;
end

function gm.amulet_charge()
  if not gm.amulet_charging then
    gm.amulet_charged = gm.ball_new(  )
    ObjAttach( gm.amulet_charged.name, "obj_fightext_amulet_root" )
    ObjSet( gm.amulet_charged.name, { pos_y = 0, pos_x = 0, pos_z = 0, alp = 0 } )
    --gm.amulet_charged.x = - 999;
    --gm.amulet_charged.y = - 999;
    gm.amulet_charging = true;

    local clr = {
      { 46/255, 141/255, 20/255 };  --sphere_green
      { 255/255, 255/255, 20/255 };  --sphere_yellow
      { 37/255, 98/255, 209/255 };  --sphere_blue
      { 186/255, 0/255, 13/255 };   --sphere_red

      { 167/255, 18/255,156 /255 }; --sphere_purple
      { 204/255, 158/255, 0/255 }; --sphere_orange
    }
    local o = ObjGet( "spr_fightext_amulet_line" )
    ObjAnimate( "spr_fightext_amulet_line", 8,0,0, _, { 0,0,o.alp, gm.AMULET_CHARGE_TIME,0,1 } )
    ObjAnimate( "spr_fightext_amulet_line", 12,0,0, _, { 
      0,0,o.color_r,o.color_g,o.color_b, 
      gm.AMULET_CHARGE_TIME,0,clr[gm.amulet_charged.type][1],clr[gm.amulet_charged.type][2],clr[gm.amulet_charged.type][3]
    } )
    ObjAnimate( gm.amulet_charged.name, 8,0,0, function() 
      gm.amulet_charging = false;
    end, { 0,0,0, gm.AMULET_CHARGE_TIME,0,1 } )

  end
end;

function gm.amulet_fly_to_next_place()
  local o = ObjGet( "obj_fightext_amulet_root" )
  ObjAnimate( o.name, 3,0,0, nil, { 0,0,o.pos_x,o.pos_y, 1,3,gm.AMULET_POS[ gm.lvl ][ 1 ], gm.AMULET_POS[ gm.lvl ][ 2 ] } )
  ObjAnimate( "obj_fightext_amulet_life", 8,0,0, _, { 0,0,0, 0.5,0,1 } )
end

function gm.amulet_shoot()
  
  if not gm.amulet_charging then
    SoundSfx( "aud_ball_shot1" );
    local o = ObjGet( "spr_fightext_amulet_trunk" )
    local p = GetObjPosByObj( gm.amulet_charged.name, "obj_fightext_mmg_root" );

    local ball = ld.TableCopy(gm.amulet_charged)

    table.insert( gm.amulet_shoots, 1, ball )

    ObjAttach( ball.name, "obj_fightext_mmg_root" )

    ObjSet( ball.name, { pos_z = 9 } )

    gm.vid_player( "vid_fightext_vid_fairy_fire_25", function() 
      gm.vid_player( "vid_fightext_vid_fairy_static_32" )
    end )

    ObjAnimate( ball.name, 3,0,0, 
      function() 
        for i = 1, #gm.amulet_shoots do
          if gm.amulet_shoots[ i ].id == ball.id then
            table.remove( gm.amulet_shoots, i )
            gm.ball_destroy( ball, "silent" )
            return
          end
        end
      end,
      { 
        0;
        0;
        p[1];
        p[2];

        gm.AMULET_SHOOT_FLY_TIME;
        0;
        p[1] + gm.AMULET_SHOOT_FLY_LEN*math.cos(o.ang+math.pi/2);
        p[2] - gm.AMULET_SHOOT_FLY_LEN*math.sin(o.ang+math.pi/2);
      }
    );
    
    gm.amulet_charge()

  end;

end;
function gm.amulet_tick( line )
  gm.amulet_add_score_anim()
  local line = line or 1
  local o = ObjGet( "obj_fightext_amulet_root" )
  local p = GetZoomCursorPos()

  if not o then return end

  if math.abs( p[1] - o.pos_x ) < gm.BALL_D and math.abs( p[2] - o.pos_y ) < gm.BALL_D then



  else

    ObjSet( "spr_fightext_amulet_trunk", { ang = gm.ang_gip( o.pos_x,o.pos_y, p[1],p[2] ) - math.pi/2 } )

  end

  

  -->> Обработка столкновений отстреленных шаров с шарами на пути >>--

  local b_shoot
  local b_line
  local len
  local x1,y1,x2,y2,xx,yy
  local b_o

  for i = #gm.amulet_shoots, 1, -1 do

    b_shoot = gm.amulet_shoots[i]

    b_o = ObjGet( b_shoot.name )
    x1 = b_o.pos_x;
    y1 = b_o.pos_y;

    for j = 1, #gm.balls[line] do

      b_line = gm.balls[line][j]
      x2, y2 = gm.ball_get_x_y( b_line ) 

      if b_line.pos > gm.BALL_R and math.abs( x1 - x2 ) <= gm.BALL_D and math.abs( y1 - y2 ) <= gm.BALL_D then

        len = gm.len( x1, y1, x2, y2 );

        if len <= gm.BALL_D then

          --ld.LogTrace( "COLLISION MAIN", b_shoot.name, b_line.name )
          --следующий шар ближе?
          if gm.balls[line][j+1] and gm.balls[line][j+1].pos > gm.BALL_R then
            xx, yy = gm.ball_get_x_y( gm.balls[line][j+1] ) 
            if math.abs( x1 - xx ) <= gm.BALL_D and math.abs( y1 - yy ) <= gm.BALL_D then
              --xx,yy = gm.balls[line][j+1]
              if gm.len( x1, y1, xx,yy  ) < len then
                b_line = gm.balls[line][j+1]
                --ld.LogTrace( "COLLISION change to next", b_line.name )
              end
            end
          end

          local id = gm.ball_get_place( b_line )
          gm.amulet_shoots[ i ] = "remove"
          ObjStopAnimate( b_shoot.name, 3 )

        SoundSfx( "aud_hit_the_ball" );

              b_shoot.line = line
              x0, y0 = gm.ball_get_x_y( b_line.pos, b_line.line ) 
              x1, y1 = gm.ball_get_x_y( b_line.pos+gm.D_LEN, b_line.line ) 
              x2, y2 = gm.ball_get_x_y( b_line.pos-gm.D_LEN, b_line.line ) 

              b_shoot.r = gm.D_LEN*2
              b_shoot.owner = b_line.name
              b_shoot.speed = b_line.speed;
              --b_shoot.collision_x = b_o.pos_x;
              --b_shoot.collision_y = b_o.pos_y;

              --SoundSfx( "aud_mg_zuma_set", -1 );
              if gm.len( b_o.pos_x, b_o.pos_y, x1,y1 ) < gm.len( b_o.pos_x, b_o.pos_y, x2,y2 ) then
                b_shoot.insert_pos = { pos_x = b_o.pos_x; pos_y = b_o.pos_y; }
                --производим вставку перед шаром столкновения
                table.insert( gm.balls[line], id, b_shoot )
                b_shoot.pos = b_line.pos + b_shoot.r + b_line.r
              else
                b_shoot.insert_pos = { pos_x = b_o.pos_x; pos_y = b_o.pos_y; }
                table.insert( gm.balls[line], id+1, b_shoot )
                b_shoot.pos = b_line.pos - b_line.r - b_shoot.r
              end;

              if not gm.balls_destroy_line( b_shoot, 1 ) then

                gm.balls_restacker( line )

              end

          break

        end;

      end;

    end;

  end

  local count = 1
  while gm.amulet_shoots[ count ] do
    if gm.amulet_shoots[ count ] == "remove" then
      --ld.LogTrace( "Remove At", count, gm.amulet_shoots )
      table.remove( gm.amulet_shoots, count )
      count = count - 1
      --ld.LogTrace( "Remove At", count, gm.amulet_shoots )
    end;
    count = count + 1
  end;

  --<< Обработка столкновений отстреленных шаров с шарами на пути <<--
  
  if gm.lines[gm.lvl][line+1] then
    gm.amulet_tick(line+1)
  end;

end;

function gm.amulet_kill()
  if not gm.amulet_killing then
    --ld.LogTrace( "amulet_kill!!!",#gm.balls )
    ld.Lock( 1 )
    gm.amulet_killing = true
    gm.amulet_kill_balls_played = false
    gm.amulet_kill_greta_played = false
    
    --VidStop( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2" )
    --ObjAttach( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2", "mg_fightext" )
    ----for i = 1, gm.lvl do
    ----  ObjDetach( "spr_fightext_greta_"..i )
    ----end
    --ObjAnimate( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2", 8, 0, 0, _, { 0,0,0, 0.25,2,1 } );
    --ObjAnimate( "anm_fightext_anm", 8, 0, 0, _, { 0,0,1, 0.25,1,0 } );
    --SoundSfx( "aud_greta_moves" );
    --VidPlay( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2", function()

    ld.StartTimer( 0.0, function()

      gm.path_hide()
      gm.amulet_score_now = 0;

      local coords = {
        { 300; 340; };
        { 760; 320; };
        { 500; 120; };
      }

      local x_target = coords[ gm.lvl ][ 1 ]-- ObjGet( "obj_fightext_amulet_root" ).pos_x;
      local y_target = coords[ gm.lvl ][ 2 ]-- ObjGet( "obj_fightext_amulet_root" ).pos_y;
      local dx = 75;
      local dy = 75;
      
      local ts = 0.01;
      local ta = 0.5;
      local t = 0.25
      local x,y,o
      local count_max = #gm.balls[1] + ( gm.balls[2] and #gm.balls[2] or 0 )
      local fly_ball = 0

      local sfx_counter = 1

      local lvl = gm.lvl
      for L = 1, #gm.balls do
        local count = #gm.balls[L]
        for i = 1, count do
          fly_ball = fly_ball + 1
          local fly_ball_now = fly_ball
          o = ObjGet( gm.balls[L][i].name )
          x = x_target + math.random( -dx, dx )
          y = y_target + math.random( -dy, dy )
          local ball = gm.balls[L][i]
          ObjAnimate( o.name, 3,0,0, function() 
            sfx_counter = sfx_counter % 2 + 1
            SoundSfx( "aud_ball_to_disk"..sfx_counter )
            gm.lifebar_hit( lvl, fly_ball_now, count_max )
            gm.ball_destroy( ball, "fx_hit" );
          end, { 
            0,0,o.pos_x,o.pos_y, 
            t,0,o.pos_x,o.pos_y, 
            t+ta,1,x_target + math.random( -dx, dx ),y_target + math.random( -dy, dy )  
          } )
          t = t + ts
        end;
      end
      local o = ObjGet( "spr_fightext_amulet_line" )
      --ObjAnimate( "spr_fightext_amulet_line", 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, 0.5,0,1,1,1 } )
      ObjAnimate( "spr_fightext_amulet_line", 8,0,0, _, { 0,0,1, 0.5,0,0 } )
      ObjAnimate( "obj_fightext_amulet_life", 8,0,0, _, { 0,0,1, 0.5,0,0 } )
      ObjAnimate( "spr_fightext_amulet_trunk", 7,0,0, _, { 0,0,ObjGet( "spr_fightext_amulet_trunk" ).ang, 0.5,0,0 } )
      gm.amulet_uncharge()

      ld.StartTimer( t+ta, function() 
        --gm.amulet_kill_balls_played = true
        --if gm.amulet_kill_balls_played and gm.amulet_kill_greta_played then
          gm.lvl_next()
        --end
      end );

      --VidStop( "vid_fightext_vid_greta_loses_2" ) 
      --ObjAttach( "vid_fightext_vid_greta_loses_2", "mg_fightext" )
      --ObjDetach( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2" )


      --local n = math.random(3,3)
      --if gm.lvl == 3 then
      --  n = 7
      --end
      --SoundVoice( "aud_greta_extra_"..n.."_voc" )
      --ld.ShowBbt( "aud_greta_extra_"..n.."_voc" )
      --ld.StartTimer( 1.5, function() int_blackbartext.Hide()  end )

      --SoundSfx( "aud_greta_loses_2" );
      --VidPlay( "vid_fightext_vid_greta_loses_2", function() 
      --ld.StartTimer( 0.0, function()
      --  gm.amulet_kill_greta_played = true
      --  --if gm.amulet_kill_balls_played and gm.amulet_kill_greta_played then
      --    gm.lvl_next()
      --  --end
      --end );

    end );



  end
end;

function gm.lifebar_init()
  gm.lifibar_lifes = 12 - gm.lvl * 3
  local obj
  for i = 1, 9 do
    obj = "spr_fightext_lifebar_life_"..i
    ObjCreate( obj, "spr" )
    ObjSet( obj, { 
      res = "assets/levels/levelext/mg_fightext/head_lvl";
      pos_x = -160 + ( i - 1 ) * 40;
      alp = i <= gm.lifibar_lifes and 1 or 0;
    } )
    ObjAttach( obj, "obj_fightext_lifebar_root" )
    ObjSet( "spr_fightext_lifebar_life_back_"..i, { pos_x = -160 + ( i - 1 ) * 40; blendmode = 0 } )
  end
end;

function gm.lifebar_hit( lvl, now, max )
  local o = ObjGet( "spr_fightext_life_bar_life" ) 
  
  local lifes = 12 - lvl * 3 - math.floor( ( now - 1 ) * 3 / max )
  if gm.lvl_skiping then
    lifes = 1
  end
  --ld.LogTrace( lvl, now, max, lifes )

  if lifes < gm.lifibar_lifes then
    for i = gm.lifibar_lifes, lifes, -1 do
      local o = ObjGet( "spr_fightext_lifebar_life_"..i )
      --ld.LogTrace( lvl, now, max, lifes, gm.lifibar_lifes,  o.name )
      ObjAnimate( o.name, 7,0,0, function() 
      if not ObjGet( "fx_fightext_lifebar_life_"..i ) then
        ObjCreate( "fx_fightext_lifebar_life_"..i, "partsys" )
        ObjSet( "fx_fightext_lifebar_life_"..i, { 
          res = "assets/levels/levelext/mg_fightext/head_lvl_fx";
          pos_x = o.pos_x;
        } )
        ObjAttach( "fx_fightext_lifebar_life_"..i, "obj_fightext_lifebar_root" )
      else
        PartSysRestart( "fx_fightext_lifebar_life_"..i );
      end
      end, { 0,0,o.ang, 0.05,0,o.ang } )
      ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, 0.5,0,0 } )
    end
    gm.lifibar_lifes = lifes
  end


end;

function gm.lvl_reset()
  if not gm.lvl_reseting then
    gm.lvl_reseting = true
    gm.amulet_kill_greta_played = false
    gm.amulet_kill_balls_played = false
    ld.Lock( 1 )
    
    --VidStop( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2" )
    --ObjAttach( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2", "mg_fightext" )
    --ObjAnimate( "anm_fightext_anm", 8, 0, 0, _, { 0,0,1, 0.25,1,0 } );
    --ObjAnimate( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2", 8, 0, 0, _, { 0,0,0, 0.25,2,1 } );
    --SoundSfx( "aud_greta_moves" );
    --VidPlay( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2", function()

      --local n = math.random(4,6)
      --SoundVoice( "aud_greta_extra_"..n.."_voc" )
      --ld.ShowBbt( "aud_greta_extra_"..n.."_voc" )
      --ld.StartTimer( 1.5, function() int_blackbartext.Hide()  end )

      --VidStop( "vid_fightext_vid_greta_attack_38" ) 
      --ObjAttach( "vid_fightext_vid_greta_attack_38", "mg_fightext" )
      --ObjDetach( "vid_fightext_vid_greta_pose_"..gm.lvl.."_2" )
      --SoundSfx( "aud_greta_attack_38" );
      --if not (gm.amulet_kill_balls_played and gm.amulet_kill_greta_played) then
      --   SoundSfx( "aud_mg_zuma_attack" );               
      --end
      
--      VidPlay( "vid_fightext_vid_greta_attack_38", function() 
--          gm.amulet_kill_greta_played = true
--          if gm.amulet_kill_balls_played and gm.amulet_kill_greta_played then
--            gm.reset_end()           
--          end
--
--      end );

      ObjSet( "obj_fightext_balls_root", { pos_z = 11 } )
SoundSfx( "aud_reset_fight" )
      local x_target = ObjGet( "obj_fightext_amulet_root" ).pos_x;
      local y_target = ObjGet( "obj_fightext_amulet_root" ).pos_y;
      local dx = 50;
      local dy = 50;

      local ts = 0.05;
      local ta = 0.5;
      local t = 0.25
      local x,y,o
      local count_max = #gm.balls[1] + ( gm.balls[2] and #gm.balls[2] or 0 )
      
      local sfx_counter = 1;

      for L = 1, #gm.balls do
        local count = #gm.balls[L]
        local score_minus = -(gm.amulet_score_now/count_max)
        for i = 1, count do
          o = ObjGet( gm.balls[L][i].name )
          x = x_target + math.random( -dx, dx )
          y = y_target + math.random( -dy, dy )
          local ball = gm.balls[L][i]
          
          ObjAnimate( o.name, 3,0,0, function() 
            sfx_counter = sfx_counter % 2 + 1
            SoundSfx( "aud_ball_to_disk"..sfx_counter )
            gm.amulet_add_score( score_minus )
            gm.ball_destroy( ball, "fx_hit" );
            --ld.LogTrace( "ball fly ends "..o.name )
          end, { 
            0,0,o.pos_x,o.pos_y, 
            t,0,o.pos_x,o.pos_y, 
            t+ta,1,x_target + math.random( -dx, dx ),y_target + math.random( -dy, dy )  
          } )
          t = t + ts
        end;
      end

      local o = ObjGet( "spr_fightext_amulet_line" )
      --ObjAnimate( "spr_fightext_amulet_line", 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, 0.5,0,1,1,1 } )
      ObjAnimate( "spr_fightext_amulet_line", 8,0,0, _, { 0,0,1, 0.5,0,0 } )
      ObjAnimate( "spr_fightext_amulet_trunk", 7,0,0, _, { 0,0,ObjGet( "spr_fightext_amulet_trunk" ).ang, 0.5,0,0 } )


      ld.StartTimer( t+ta, function() 
        --ld.LogTrace( t+ta )
        --gm.amulet_kill_balls_played = true
        --if gm.amulet_kill_balls_played and gm.amulet_kill_greta_played then
          gm.reset_end()
        --end
      end );

    --end );
  end;
end;

function gm.reset_end()
  --ld.LogTrace( "reset_end" )
  --ObjSet( "vid_fightext_vid_greta_pose_"..gm.lvl.."_1", { alp = 1 } )
  --VidStop( "vid_fightext_vid_greta_pose_"..gm.lvl.."_1" )
  --ObjAttach( "vid_fightext_vid_greta_pose_"..gm.lvl.."_1", "mg_fightext" )
  --ObjDetach( "vid_fightext_vid_greta_attack_38" )
  --SoundSfx( "aud_greta_moves" );
  --VidPlay( "vid_fightext_vid_greta_pose_"..gm.lvl.."_1", function()

    --ObjSet( "anm_fightext_anm", { alp = 1 } )
    --AnimPlay( "anm_fightext_anm", "greta"..gm.lvl, _ )
    --ObjDetach( "vid_fightext_vid_greta_pose_"..gm.lvl.."_1" )
    
    

    ObjSet( "obj_fightext_balls_root", { pos_z = 0 } )
    gm.lvl_reseting = false
    gm.ticker()
    --SoundEnv("aud_zuma_env",1);  --!!!!!!!!!!
    gm.amulet_score_now = 0
    gm.amulet_add_score( 0 )
    local o = ObjGet( "spr_fightext_amulet_line" )
    ObjAnimate( "spr_fightext_amulet_line", 8,0,0, _, { 0,0,o.alp, gm.AMULET_CHARGE_TIME,0,1 } )
    ld.Lock( 0 )

  --end );

end

function gm.lvl_skip()
  gm.lvl_skiping = true
  ld.Lock( 1 )
  --gm.lvl = #gm.lines
  gm.amulet_kill()
end;

function gm.lvl_next()
  --gm.lifebar_hit()
  if not gm.lvl_skiping and gm.lvl < #gm.lines then

    SoundSfx( "aud_win_round"..gm.lvl )

      gm.lvl = gm.lvl + 1
      ld.LogTrace( "lvl_next", gm.lvl )
      gm.amulet_fly_to_next_place()
      gm.animator( "cat"..( gm.lvl- 1 ).."_"..gm.lvl, function() 


        gm.amulet_killing = false
        gm.path_show()
        gm.ticker()
        --SoundEnv("aud_zuma_env",1); ----!!!!!!!!!!
        gm.amulet_score_now = 0
        gm.amulet_add_score( 0 )
        local o = ObjGet( "spr_fightext_amulet_line" )
        ObjAnimate( "spr_fightext_amulet_line", 8,0,0, _, { 0,0,o.alp, gm.AMULET_CHARGE_TIME,0,1 } )
        ng_global.progress["ext"]["win_fightext"].state = gm.lvl
        gm.amulet_charge()
        ld.Lock( 0 )

      end )


  else
    private.Win();
  end;
end

function gm.ticker()
  
  --заряд накоплен, стреляем
  if gm.amulet_killing or gm.lvl_reseting or gm.lvl_skiping then 
    --SoundEnv("aud_zuma_env",0);
    return
  end;
  

  gm.balls_tick()
  gm.amulet_tick()

  ObjAnimate( "obj_fightext_lifebar_root", 8,0,0, gm.ticker, { 0,0,1, gm.TICKER_TIME,0,1 } )
end;

function gm.animator( anim_func, func_end )
  if not ng_global.progress then return end
  local n = gm.lvl

  if not ld.CheckRequirements( { "use_fairyext_fightext" } ) then
    n = 3
  end


  anim_func = anim_func or "cat"..n.."_static"..math.random( 1, 2 )
  ld.AnimPlay( "anm_fightext_anm", anim_func, function() 
    if func_end then
      func_end()
    else
      gm.animator()
    end
  end )
end

function gm.vid_player( vid, func_end )
  if vid and vid ~= gm.vid_player_current then
    if gm.vid_player_current then
      ObjDetach( gm.vid_player_current );
      VidStop( gm.vid_player_current )
    end
    gm.vid_player_current = vid
    ObjAttach( gm.vid_player_current, "obj_fightext_amulet_root" )
  end
  VidPlay( gm.vid_player_current, func_end or function() gm.vid_player() end )
end

function gm.len( x1, y1, x2, y2 )
  return ( ( x1 - x2 ) ^ 2 + ( y1 - y2 ) ^ 2 ) ^ 0.5
end;

--[[********************************************************************]]
--[[  возвращает угол между прямой и осью ОХ, расстояние между точками  ]]
--[[--------------------------------------------------------------------]]
--[[]]function gm.ang_gip( x1,y1,x2,y2,len )
--[[]]  len = len or ( (x1-x2)^2 +(y1-y2)^2 )^0.5
--[[]]  y1=-y1; --переворот для игровой системы координат
--[[]]  y2=-y2; --переворот для игровой системы координат
--[[]]  if len == 0 then return 0,0 end --исключение
--[[]]  local k = ( y1 - y2 ) / len
--[[]]  local a = math.abs( math.asin( k ) )
--[[]]  if x2 >= x1 and y2 <= y1 then
--[[]]    a = math.pi*2 - a
--[[]]    return a,len
--[[]]  elseif x2 >= x1 and y2 >= y1 then
--[[]]    return a,len
--[[]]  elseif x2 <= x1 and y2 <= y1 then
--[[]]    a = math.pi + a
--[[]]    return a,len
--[[]]  elseif x2 <= x1 and y2 >= y1 then
--[[]]    a = math.pi - a
--[[]]    return a,len
--[[]]  end;
--[[]]end
--[[********************************************************************]]
--[[                                                                    ]]
--[[--------------------------------------------------------------------]]

--*********************************************************************************************************************
function gm.lifebar_new( name, x, y, life, way, width, height )
  gm.lifebar = gm.lifebar or {}
  local bar = {}
  gm.lifebar[ name ] = bar

  way = way or 1;
  bar.way = way;
  bar.x = x;
  bar.y = y;
  bar.life_max = life;
  bar.life_now = life;

  bar.root = "obj_"..private.room_objname.."_lifebar_root_"..name;
  bar.back = "obj_"..private.room_objname.."_lifebar_back_"..name;
  bar.midle = "obj_"..private.room_objname.."_lifebar_midle_"..name;
  bar.midle_dot = "obj_"..private.room_objname.."_lifebar_midle_dot_"..name;
  bar.front = "obj_"..private.room_objname.."_lifebar_front_"..name;

  ObjCreate( bar.root, "obj" )
  ObjSet( bar.root, { 
    input = 0;
    pos_x = bar.x;
    pos_y = bar.y;
    pos_z = 4;
    --ang = math.pi / 2;
    scale_x = way
  } )
  ObjAttach( bar.root, "obj_castleext_root" )

  ObjCreate( bar.back, "spr" )
  ObjSet( bar.back, { 
    res = "assets/levels/levelext/"..private.room_objname.."/lifebar_back";
    input = 0;
    pos_z = -9;
  } )
  ObjAttach( bar.back, bar.root )

  ObjCreate( bar.midle, "spr" )
  ObjSet( bar.midle, { 
    res = "assets/levels/levelext/"..private.room_objname.."/lifebar_midle";
    input = 0;
    pos_z = 0;
    croprect_init = 1;
    --pos_x = -bar.width / 2;
    --drawoff_x = 1;
    --scale_y = bar.height / 2;
  } )
  ObjAttach( bar.midle, bar.root )
  bar.width = ObjGet( bar.midle ).draw_width;
  bar.height = ObjGet( bar.midle ).draw_height;

  ObjCreate( bar.midle_dot, "spr" )
  ObjSet( bar.midle_dot, { 
    res = "assets/levels/levelext/"..private.room_objname.."/lifebar_midle_dot";
    input = 0;
    pos_z = 99;
  } )
  ObjAttach( bar.midle_dot, bar.root )

  ObjCreate( bar.front, "spr" )
  ObjSet( bar.front, { 
    res = "assets/levels/levelext/"..private.room_objname.."/lifebar_front";
    input = 0;
    pos_z = 9;
  } )
  ObjAttach( bar.front, bar.root )

  gm.lifebar_set( name, life )

end;
function   gm.lifebar_set( name, life )
  local bar = gm.lifebar[ name ]
  life = life or bar.life_now
  bar.life_now = life
  ObjSet( bar.midle, { 
    croprect_x = -bar.width / 2;
    croprect_y = -bar.height / 2;
    croprect_w = ( bar.width * ( bar.life_now / bar.life_max ) ) + 0.0001;
    croprect_h = bar.height;
  } )
  ObjSet( bar.midle_dot, { 
    pos_x = -bar.width / 2 + ( bar.width * ( bar.life_now / bar.life_max ) );
  } );
end
function   gm.lifebar_add( name, val )

  local bar = gm.lifebar[ name ]
  bar.life_now = bar.life_now + val


  if bar.life_now > bar.life_max then
    bar.life_now = bar.life_max
  elseif bar.life_now <= 0 then
    bar.life_now = 0
  end

  gm.lifebar_add_anim( name )

end;
function   gm.lifebar_add_anim( name, second )

  local bar = gm.lifebar[ name ]
  local o = ObjGet( bar.midle_dot )
  local x_end = ( - bar.width / 2 + bar.width * ( bar.life_now / bar.life_max ) )

  if not second then
    ObjAnimate( bar.midle_dot, 0,0,0, _, { 0,0,o.pos_x, 0.3,3,x_end } )
  end

  if o.pos_x ~= x_end then
    ObjSet( bar.midle, { croprect_w = bar.width / 2 + o.pos_x + 0.00001 } )
    ObjAnimate( bar.midle_dot, 7,0,0, function() gm.lifebar_add_anim( name, true ) end, { 0,0,0, 0.015,0,0  } )
  end

end
function   gm.lifebar_reset( name )
  local bar = gm.lifebar[ name ]
  gm.lifebar_add( name, -bar.life_now, false )
end;
function   gm.lifebar_skip( name )
  local bar = gm.lifebar[ name ]
  gm.lifebar_add( name, bar.life_max - bar.life_now, false )
end;