-- name=mg_laceext
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_laceext";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_laceext" ] = {type = "win", use_place = "mg_laceext", room = "rm_dressingroomext", zz = "mg_laceext", zz_gate = "gmg_dressingroomext_laceext" };

  local win_laceext_logic = function()
    if ld.CheckRequirements( {"win_laceext"} ) then
      ObjSet( "spr_laceext_dresslaceext", { visible = 0, input = 1, active = 1 } )
      int_simon.SimonSetVisible(1)
    end
  end;
  local win_laceext = function()
    if ld.CheckRequirements( {"win_laceext"} ) then
      ObjSet( "obj_laceext_root", { input = 0 } )
      --ObjDelete( "obj_laceext_trash_lace_root" )
      ObjDelete( "obj_laceext_counter_root" )
      ObjDelete( "obj_laceext_magnifier" )
      ObjSet( "gfx_laceext_dresslaceext", { active = 1 } )
    end
  end;
  cmn.AddSubscriber("win_laceext", win_laceext, private.room_objname )
  cmn.AddSubscriber("win_laceext", win_laceext_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_dresslaceext" ] = { type = "get", get_obj = "spr_laceext_dresslaceext", room = "rm_dressingroomext", zz = "mg_laceext", zz_gate = "gmg_dressingroomext_laceext" };

private.get_dresslaceext_logic = function()
  
end;
private.get_dresslaceext_inv = function()
  interface.InventoryItemAdd("inv_dresslaceext","spr_laceext_dresslaceext");
end;
private.get_dresslaceext_beg = function()
  ObjDelete("gfx_laceext_dresslaceext")
end;
private.get_dresslaceext_end = function()
  ObjDelete( "obj_laceext_trash_lace_root" )
end;

cmn.AddSubscriber( "get_dresslaceext", private.get_dresslaceext_inv );
cmn.AddSubscriber( "get_dresslaceext", private.get_dresslaceext_beg, private.room_objname );
cmn.AddSubscriber( "get_dresslaceext", private.get_dresslaceext_end, private.room_objname );
cmn.AddSubscriber( "get_dresslaceext", private.get_dresslaceext_logic );
--------------------------------------------------------------------
function public.get_dresslaceext()
  ObjSet( "spr_laceext_dresslaceext", { visible = 1 } )
  cmn.SetEventDone( "get_dresslaceext" );
  cmn.CallEventHandler( "get_dresslaceext" );
  if common_impl.ZzCompleteCheck( "get_dresslaceext" ) then cmn.GotoRoom( "rm_dressingroomext" ); end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_laceext"} ) then
    SoundMgTheme( true )
    cmn.MiniGameShow( "laceext" );
    gm.arrow_show_all( true )
    gm.magnifer_show( true )
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_dressroom_env" )
  gm.load();
  gm.vid_player( "vid_laceext_vid_fairy_static_51" )
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_laceext"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "laceext" );
    ObjSet( "obj_laceext_magnifier", { alp = 0 } )
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  if ld.Lock( 1 ) then
    gm.magnifer_hide( function() 
      gm.counter_update()
      gm.magnifer_show( function() 
        gm.event_end()
      end )
    end )
    for i = 1, #gm.laces_now do
      gm.lace_choise( gm.laces_now[ i ], false )
    end
    for i = 1, gm.lvl_now - 1 do
      local o = ObjGet( "spr_laceext_lace"..i )
      ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T,0,1 } )
    end
    gm.default()
    for i = 1, 8 do
      gm.arrow_anim_to_state( i )
    end
  end
end;
--*********************************************************************************************************************
function public.Skip()
    port.skip_mg = true;
  --if ld.Lock( 1 ) then
    --SoundSfx( "aud_win_mannequinn" )
    gm.counter_hide()
    for i = 1, #gm.laces_now do
      gm.lace_choise( gm.laces_now[ i ], false )
    end
    gm.laces_now = {}
    for i = gm.lvl_now, gm.LVL_MAX do
      local o = ObjGet( "spr_laceext_lace"..i )
      ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T,0,0 } )
    end
    gm.arrow_show_all( false )
    gm.magnifer_hide( private.Win )
    gm.lvl_now = gm.LVL_MAX
  --end
end;
--*********************************************************************************************************************
function private.WinEnd()
  gm.save()
  ld.Lock(0);
  cmn.SetEventDone( "win_laceext" );
  cmn.CallEventHandler( "win_laceext" );
  if common_impl.ZzCompleteCheck( "win_laceext" ) then cmn.GotoRoom( "rm_dressingroomext" ); end;
  interface_impl.ShowMgAchievements();
  int_simon.SimonSetVisible( 0 )
  ld.Lock( 1 )
  ObjDelete( "vid_laceext_vid_fairy_static_51" )
  ObjSet( "spr_laceext_fairy", { visible = 1 } )
  int_inventory.StdItemFlyAnimation( "spr_laceext_fairy", "obj_int_button_map_point_for_cube", function()
    ld.Lock( 0 )
    int_simon.SimonSetVisible( 1 )
    interface.SimonReturn()
  end );
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide();
  SoundMgTheme( false )
  ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then

    gm.T = 0.4
    gm.LVL_LACES = { 
      {1,4,7};
      {3,5,8};
      {2,6,7};
      {4,3,8};
    }
    gm.LVL_LACE_ANGS = { 
      {1,2,3};
      {0,1,2};
      {3,0,1};
      {2,3,0};
    }
    gm.LVL_MAX = #gm.LVL_LACES

  
    gm.default()
    if ng_global.progress["ext"]["win_laceext"].state then
      local s = ld.TableCopy( ng_global.progress["ext"]["win_laceext"].state )
      gm.lvl_now = s.lvl_now
      gm.arrow = ld.TableCopy( s.arrow )
      gm.laces_now = ld.TableCopy( s.laces_now )
    end
    gm.build()
    gm.counter_init()
    gm.set_all()
    gm.counter_update()
    gm.loaded  = true;
  else
  
  end;
end
--*********************************************************************************************************************
function gm.default()
  gm.arrow = { 0, 0, 0, 0, 0, 0, 0, 0 }
  gm.lvl_now = 1
  gm.laces_now = {}
end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["ext"]["win_laceext"].state = {
    lvl_now = gm.lvl_now;
    arrow = ld.TableCopy( gm.arrow );
    laces_now = ld.TableCopy( gm.laces_now );
  }
end;
--*********************************************************************************************************************
function gm.build()
  for i = 1, 8 do
    ObjSet( "spr_laceext_arrow_"..i, {
      event_mdown = function() gm.event_mdown_arrow( i ) end;
      event_menter = gm.event_menter;
      event_mleave = gm.event_mleave;
    } )
    ObjSet( "spr_laceext_mini"..i.."_light", {
      event_mdown = function() gm.event_mdown_lace( i ) end;
      event_menter = gm.event_menter;
      event_mleave = gm.event_mleave;
      input = 1;
    } )
    ObjSet( "obj_laceext_arrowback_"..i, { scale_x = 0.7, scale_y = 0.7 } )
    ObjSet( "spr_laceext_controller_"..i.."_choise", { blendmode = 0; } )
  end
  ObjSet( "obj_laceext_fairy", {
    event_mdown = function() gm.event_mdown_fairy() end;
    event_menter = gm.event_menter;
    event_mleave = gm.event_mleave;
  } )
end
--*********************************************************************************************************************
function gm.set_all()
  for i = 1, 8 do
    ObjSet( "spr_laceext_arrow_"..i, { ang = gm.get_ang( gm.arrow[ i ] ) } )
    ObjSet( "spr_laceext_mini"..i, { ang = gm.get_ang( gm.arrow[ i ] ) } )
  end
    for i = 1, gm.lvl_now - 1 do
      ObjSet( "spr_laceext_lace"..i, { alp = 0 } )
    end
  for i = 1, #gm.laces_now do
    gm.lace_choise( gm.laces_now[ i ], true )
  end
end
--*********************************************************************************************************************
function gm.event_mdown_arrow( num )
  if ld.Lock( 1 ) then
    SoundSfx( "aud_twist_loop" )
    gm.arrow[ num ] = ( gm.arrow[ num ] + 1 ) % 4
    gm.arrow_anim_to_state( num, gm.event_end )
    gm.counter_update()
  end
end
--*********************************************************************************************************************
function gm.event_mdown_lace( num )
  key = ld.TableContains( gm.laces_now, num, true )
  if key > 0 then
    SoundSfx( "aud_clk_loop" )
    table.remove( gm.laces_now, key )
    gm.lace_choise( num, false )
  elseif #gm.laces_now < #gm.LVL_LACES[ gm.lvl_now ] then
    SoundSfx( "aud_clk_loop" )
    table.insert( gm.laces_now, num )
    gm.lace_choise( num, true )
  else
    SoundSfx( "aud_clk_wrong1" )
    gm.counter_wrong( num )
  end
  gm.counter_update()
  gm.save();
end
--*********************************************************************************************************************
function gm.event_mdown_fairy()
  if #gm.laces_now ~= #gm.LVL_LACES[ gm.lvl_now ] then
    gm.counter_wrong()
    ld.Lock( 1 )
    SoundSfx( "aud_clk_wrong1" )
    gm.vid_player( "vid_laceext_vid_fairy_wrong_31", function() 
      ld.Lock( 0 )
      gm.vid_player( "vid_laceext_vid_fairy_static_51" )
    end )
  else
    if gm.win_check() and ld.Lock( 1 ) then
      SoundSfx( "aud_clk_wright_combination" )
      for i = 1, #gm.laces_now do
        gm.lace_choise( gm.laces_now[ i ], false )
      end
      gm.laces_now = {}
      local func_step = function() 
        if gm.lvl_now == gm.LVL_MAX then
          public.Skip()
        else
          ObjAnimate( "spr_laceext_lace"..gm.lvl_now, 8,0,0, nil, { 0,0,1, 0.35,0,0 } )
          gm.magnifer_hide( function() 
            gm.lvl_now = gm.lvl_now + 1
            gm.magnifer_show( function() 
              gm.counter_update()
              gm.event_end()
            end )
          end )
        end
      end
      ld.StartTimer( 2, function() 
        gm.fx_fly( { pos_x = 590; pos_y = 90; }, ObjGet( "spr_laceext_lace"..gm.lvl_now ), function()
          ld.StartTimer( 1.0, func_step )
        end )
      end )
      gm.vid_player( "vid_laceext_vid_fairy_action_61", function() 
        gm.vid_player( "vid_laceext_vid_fairy_static_51" )
      end )
    elseif ld.Lock( 1 ) then
      SoundSfx( "aud_clk_wrong1" )
      local anm = ld.Anim.Liquid( gm.T * 1.75, 8 , 0, 1, 0.95 )
      local names = {}
      for i = 1, 8 do
        table.insert( names, "spr_laceext_controller_"..i.."_wrong" )
      end
      for i = 1, 8 do
        ObjAnimate( "spr_laceext_controller_"..i.."_wrong", 8,0,0, nil, table.remove( anm, math.random( 1, #anm ) ) )
      end
      gm.vid_player( "vid_laceext_vid_fairy_wrong_31", function() 
        ld.Lock( 0 )
        gm.vid_player( "vid_laceext_vid_fairy_static_51" )
      end )
    end
  end
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if not o then o = ObjGet( obj ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (0.75-o.alp)/3,0,0.75 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if not o then o = ObjGet( obj ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;
--*********************************************************************************************************************
function gm.event_end()
  gm.save()
  ld.Lock( 0 )
end
--*********************************************************************************************************************
function gm.win_check()

  if #gm.laces_now == 0 then
    return false
  end

  if #gm.laces_now == #gm.LVL_LACES[ gm.lvl_now ] then
    for i = 1, #gm.laces_now do
      local key = ld.TableContains( gm.LVL_LACES[ gm.lvl_now ], gm.laces_now[ i ], true )
      --ld.LogTrace( i, key, gm.LVL_LACE_ANGS[ gm.lvl_now ], gm.arrow )
      if key == 0 or gm.LVL_LACE_ANGS[ gm.lvl_now ][ key ] ~= gm.arrow[ gm.laces_now[ i ] ] then
        return false
      end
    end
  else
    return false
  end

  return true
end
--*********************************************************************************************************************
function gm.get_ang( pos )
  return ld.AngNorm( - pos * math.pi / 2 )
end
--*********************************************************************************************************************
function gm.arrow_anim_to_state( num, func_end )
  local ang_end = gm.get_ang( gm.arrow[ num ] )
  local ang_beg = ld.AngCloser( ObjGet( "spr_laceext_arrow_"..num ).ang, ang_end )
  ObjAnimate( "spr_laceext_arrow_"..num, 7,0,0, nil, { 0,0,ang_beg, gm.T,3,ang_end } )
  ObjAnimate( "spr_laceext_mini"..num, 7,0,0, func_end, { 0,0,ang_beg, gm.T,3,ang_end } )
end
function gm.arrow_show_all( bool )
  if bool ~= gm.arrow_show_all_state then
    ObjAnimate( "spr_laceext_back", 7,0,0, function() 
      SoundSfx( "aud_win_mannequinn" )
    end, { 0,0,0, 0,0,0 } ) 
    gm.arrow_show_all_state = bool
    local o
    local dx = 22
    local x_on_left = 322 - dx
    local x_off_left = 212 --+ dx
    local x_on_right = 702 + dx
    local x_off_right = 812 --- dx
    local ts = 0.08
    for i = 4, 1, -1 do
      o = ObjGet( "obj_laceext_arrowback_"..i )
      ObjAnimate( o.name, 0,0,0, nil, { 0,0,o.pos_x, ts * ( 4 - i ),0,o.pos_x,ts * ( 4 - i )+gm.T,3, bool and x_on_left or x_off_left } )
      o = ObjGet( "obj_laceext_arrowback_"..( i + 4 ) )
      ObjAnimate( o.name, 0,0,0, nil, { 0,0,o.pos_x, ts * ( 4 - i ),0,o.pos_x,ts * ( 4 - i )+gm.T,3, bool and x_on_right or x_off_right } )
    end
  end
end
--*********************************************************************************************************************
function gm.lace_choise( num, bool )
  local o = ObjGet( "spr_laceext_controller_"..num.."_choise" )
  ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T*0.5,0,bool and 1 or 0 } )
end
--*********************************************************************************************************************
function gm.counter_init()
  ObjSet( "spr_laceext_counter_wrong", { alp = 0 } )
  for i = 0, 5 do
    ObjSet( "spr_laceext_n"..i, { alp = 0 } )
  end
  gm.counter_now = #gm.LVL_LACES[ gm.lvl_now ] - #gm.laces_now
  ObjSet( "spr_laceext_n"..gm.counter_now, { alp = 1 } )
end
function gm.counter_update()
  local counter_next = #gm.LVL_LACES[ gm.lvl_now ] - #gm.laces_now
  if counter_next ~= gm.counter_now then
    local o = ObjGet( "spr_laceext_n"..gm.counter_now )
    ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T*0.5,1,0 } )
    gm.counter_now = counter_next
    local o = ObjGet( "spr_laceext_n"..gm.counter_now )
    ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T*0.5,2,1 } )
  end
  local o = ObjGet( "anm_laceext_mgnifer_anm" )
  if counter_next == 0 and gm.win_check() then
    ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T*0.5,2,1 } )
  else
    ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T*0.5,1,0 } )
  end
end
function gm.counter_wrong( num )
  local anm = { 0,0,ObjGet( "spr_laceext_counter_wrong" ).alp, gm.T*0.25,2,1, gm.T*0.5,1,0, gm.T*0.75,2,1, gm.T,1,0 }
  ObjAnimate( "spr_laceext_counter_wrong", 8,0,0, nil, anm )
  if num then
    ObjAnimate( "spr_laceext_controller_"..num.."_wrong", 8,0,0, nil, anm )
  end
end
function gm.counter_hide()
  local o = ObjGet( "spr_laceext_n"..gm.counter_now )
  ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T*0.5,1,0 } )
end
--*********************************************************************************************************************
function gm.magnifer_show( func_end )
  gm.magnifer_update()
  local o = ObjGet( "spr_laceext_lace"..gm.lvl_now )
  local dx = math.random( 30, 40 ) * ( math.random( 0, 1 ) == 0 and -1 or 1 )
  local dy = math.random( 30, 40 ) * ( math.random( 0, 1 ) == 0 and -1 or 1 )
  ObjAnimate( "obj_laceext_magnifier", 3,0,0, nil, { 
      0, 0, o.pos_x + dx, o.pos_y + dy,
      gm.T, 2, o.pos_x, o.pos_y
    } )
  local childs = ObjGetRelations( "spr_laceext_magnifier_back" ).childs
  for i = 1, #childs do
    ObjAnimate( childs[ i ], 8,0,0, nil, { 0,0,1, gm.T,2,1 } )
  end
  ObjAnimate( "spr_laceext_magnifier_back_light", 3,0,0, nil, { 0,0,25,25, gm.T,2,0,0 } )
  --ObjAnimate( "obj_laceext_magnifier", 6,0,0, nil, { 0,0,2,2, gm.T,2,1,1 } )
  ObjAnimate( "obj_laceext_magnifier", 8,0,0, func_end, { 0,0,0, gm.T,2,1 } )
end
function gm.magnifer_hide( func_end )
  local o = ObjGet( "spr_laceext_lace"..gm.lvl_now )
  local dx = math.random( 30, 40 ) * ( math.random( 0, 1 ) == 0 and -1 or 1 )
  local dy = math.random( 30, 40 ) * ( math.random( 0, 1 ) == 0 and -1 or 1 )
  ObjAnimate( "obj_laceext_magnifier", 3,0,0, nil, { 
      0, 0, o.pos_x, o.pos_y,
      gm.T, 2, o.pos_x + dx, o.pos_y + dy
    } )
  local childs = ObjGetRelations( "spr_laceext_magnifier_back" ).childs
  for i = 1, #childs do
    ObjAnimate( childs[ i ], 8,0,0, nil, { 0,0,1, gm.T,2,0 } )
  end
  ObjAnimate( "spr_laceext_magnifier_back_light", 3,0,0, nil, { 0,0,0,0, gm.T,2,25,25 } )
  --ObjAnimate( "obj_laceext_magnifier", 6,0,0, nil, { 0,0,1,1, gm.T,2,2,2 } )
  ObjAnimate( "obj_laceext_magnifier", 8,0,0, func_end, { 0,0,1, gm.T,2,0 } )
end
function gm.magnifer_update()
  local childs = ObjGetRelations( "spr_laceext_magnifier_back" ).childs
  for i = 1, #childs do
    ObjSet( childs[ i ], { visible = 0; } )
  end
  for i = 1, #gm.LVL_LACES[ gm.lvl_now ] do
    local n = gm.LVL_LACES[ gm.lvl_now ][ i ]
    local obj = "spr_laceext_magnifier_win_"..n
    if not ObjGet( obj ) then
      ObjCreate( obj, "spr" )
      ObjSet( obj, { res = "assets/levels/levelext/mg_laceext/"..n; alp = 1 } )
      ObjAttach( obj, "spr_laceext_magnifier_back" )
    end
    ObjSet( obj, { visible = 1; ang = gm.get_ang( gm.LVL_LACE_ANGS[ gm.lvl_now ][ i ] ); } )
  end
end
--*********************************************************************************************************************
function gm.vid_player( vid, func_end )
  if vid and vid ~= gm.vid_player_current then
    if gm.vid_player_current then
      ObjDetach( gm.vid_player_current );
      VidStop( gm.vid_player_current )
    end
    gm.vid_player_current = vid
    ObjAttach( gm.vid_player_current, "obj_laceext_root" )
  end
  VidPlay( gm.vid_player_current, func_end or function() gm.vid_player() end )
end
--*********************************************************************************************************************
function gm.fx_fly( from, to, func_end )
  
  local fx_fly = "fx_laceext_fx_fly"

    ObjSet( fx_fly, { 
      pos_x = from.pos_x;
      pos_y = from.pos_y;
      active = 1;
    } )
    PartSysRestart( fx_fly )

    local t_fly = math.random( 60, 80 ) / 100
    PartSysRestart( fx_fly )
    ObjAnimate( fx_fly, 0,0,0, _, { 0,0,from.pos_x, t_fly,math.random(0,3),to.pos_x + math.random(-15,15) } )
    ObjAnimate( fx_fly, 1,0,0, function() 
      PartSysStop( fx_fly, 0 )
      ObjSet( "fx_laceext_fx", { 
        pos_x = to.pos_x;
        pos_y = to.pos_y;
        active = 1;
      } );
      PartSysRestart( "fx_laceext_fx" )
      if func_end then func_end() end
    end, { 0,0,from.pos_y, t_fly,math.random(0,3),to.pos_y + math.random(-15,15) } )

end;