-- name=levelext_inv
function public.ProcessGetCubeextAll( prg )
  local inv = "inv_cubeext"
  local prg_all = {"get_cubeext1","get_cubeext2"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  public.ProcessDragChecker( inv, prg, prg_all )
end
function public.ProcessGetScrewextAll( prg )
  local inv = "inv_screwext"
  local prg_all = {"get_screwext1","get_screwext2"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  public.ProcessDragChecker( inv, prg, prg_all )
end
function public.ProcessGetCoinextAll( prg )
  local inv = "inv_coinext"
  local prg_all = {"get_coinext1","get_coinext2","get_coinext3","get_coinext4"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  public.ProcessDragChecker( inv, prg, prg_all )
end
function public.ProcessGetAcornextAll( prg )
  local inv = "inv_acornext"
  local prg_all = {"get_acornext1","get_acornext2","get_acornext3"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  public.ProcessDragChecker( inv, prg, prg_all )
end
function public.ProcessGetCogextAll( prg )
  local inv = "inv_cogext"
  local prg_all = {"get_cogext1","get_cogext2","get_cogext3"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  public.ProcessDragChecker( inv, prg, prg_all )
end
function public.ProcessGetColoredglassextAll( prg )
  local inv = "inv_coloredglassext"
  local prg_all = {"get_coloredglassext1","get_coloredglassext2","get_coloredglassext3","get_coloredglassext4"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  public.ProcessDragChecker( inv, prg, prg_all )
end
function public.ProcessGetMistletoeextAll( prg )
  local inv = "inv_mistletoeext"
  local prg_all = {"get_mistletoeext1","win_painthoext"}
  ObjSet( inv, { frame = ObjGet( inv ).frame + 1 } );
  public.ProcessDragChecker( inv, prg, prg_all )
end
-- name=levelext_inv

function public.Init()

  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
  
public.use_add = {

["obj_simon_cursor_drag"]  = {     --Саймон
  { "gfx_mannequinext_fairywithscissorsext_zone","dressingroomext_wrong_fairy_no_scissors"};
  { "gfx_pantrydoorext_fairyclewext_zone","pantrydoorext_wrong_fairy_no_ball"};
};

["inv_towelext"]    = {
  {"gfx_ovenext_christmasspotholderext_zone" ,"dressingroomext_wrong_towel_mulledwineext"};
};

----
--  ["obj_simon_cursor_drag"]  = {     --Саймон
--    { "gfx_sweetwindow_ropeladder_zone","simon_on_use_ropeladder"};
--    { "obj_neargrot_ropefakepuss_zone","puss_on_ropeneargrot"};
--  };
--
--  --["obj_simon_cursor_drag"]  = {     --Саймон
--  --  { "obj_neargrot_ropefakepuss_zone","puss_on_ropeneargrot"};
--  --};
--


}
ld.InvSetDropable         = int_inventory.InvSetDropable;

private.ProcessDragChecker_func_cache = {}
function public.ProcessDragChecker( inv, prg, prg_all )
  if ( int_inventory.InventoryItemAddFly[inv] and int_inventory.InventoryItemAddFly[inv] == 0 and ( ld.CheckRequirements( prg_all, 1 ) == ( #prg_all - ( ld.CheckRequirements( { prg } ) and 0 or 1 ) ) ) )
  or ( not int_inventory.InventoryItemAddFly[inv] and ld.CheckRequirements( prg_all ) ) then 
    if not private.ProcessDragChecker_func_cache[ inv ] then
      private.ProcessDragChecker_func_cache[ inv ] = ObjGet( inv ).event_menter
    end
    ObjSet( inv, { 
      drag = 1; 
      event_mdown = ""; 
      event_menter = function()
        private.ProcessDragChecker_func_cache[ inv ]();
        interface.PopupShow( "pop_"..inv.."_all" );
      end;
    } );
    --return true
  else
    ObjSet( inv, { drag = 0 } );
    --return false
  end 
  interface.CheckInvPlus()
end;

function public.ProcessUseChecker( inv, prg, prg_all )
  if ( ld.CheckRequirements( prg_all, 1 ) == ( #prg_all - ( ld.CheckRequirements( { prg } ) and 0 or 1 ) ) )
  then 
    return true
  else
    return false
  end 
end;

--*********************************************************************************************************************
--*********************************************************************************************************************
--ПЕРЕОПРЕДЕЛЕНИЕ ССЫЛКИ НА ИНВЕНТАРЬ
  level_inv = levelext_inv
--*********************************************************************************************************************
--*********************************************************************************************************************

--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_snowmanpyramidext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowmanbodyext" ] = { type = "use", inv_obj = "inv_snowmanbodyext", use_place = "gfx_snowmanpyramidext_snowmanbodyext_zone", room = "inv_complex_inv", zz = "inv_complex_snowmanpyramidext", zz_gate = "inv_snowmanpyramidext" };

private.use_snowmanbodyext_logic = function()
  ObjSet( "gfx_snowmanpyramidext_snowmanheadext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_snowmanbodyext_inv = function()
  common_impl.ProcessMultiUseAll("snowmanbodyext", "snowmanbodyext")
end;
private.use_snowmanbodyext_beg = function()
  ObjDelete( "gfx_snowmanpyramidext_snowmanbodyext_zone" );
end;
private.use_snowmanbodyext_end = function()
  ObjSet( "anm_snowmanpyramidext_anm", { animfunc = "use_partb", frame = 0 } )
  ObjDelete( "inv_snowmanpyramidext_back" )
  ObjSet( "inv_snowmanpyramidext_st_1", { visible = 1 } )
  ObjSet( "inv_snowmanpyramidext_st_2", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowmanbodyext", private.use_snowmanbodyext_inv );
cmn.AddSubscriber( "use_snowmanbodyext", private.use_snowmanbodyext_beg );
cmn.AddSubscriber( "use_snowmanbodyext", private.use_snowmanbodyext_end );
cmn.AddSubscriber( "use_snowmanbodyext", private.use_snowmanbodyext_logic );
cmn.AddSubscriber( "use_snowmanbodyext_inv", private.use_snowmanbodyext_inv );
cmn.AddSubscriber( "use_snowmanbodyext_beg", private.use_snowmanbodyext_beg );
cmn.AddSubscriber( "use_snowmanbodyext_end", private.use_snowmanbodyext_end );
cmn.AddSubscriber( "use_snowmanbodyext_end", private.use_snowmanbodyext_logic );
--------------------------------------------------------------------------------------------
function public.use_snowmanbodyext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowmanbodyext" );
    cmn.CallEventHandler( "use_snowmanbodyext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowmanbodyext_inv" );
  cmn.CallEventHandler( "use_snowmanbodyext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_snowmanbodyext_snowmanpyramidext" )
  
  ld.AnimPlay( "anm_snowmanpyramidext_anm", "use_parta", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowmanheadext" ] = { type = "use", inv_obj = "inv_snowmanheadext", use_place = "gfx_snowmanpyramidext_snowmanheadext_zone", room = "inv_complex_inv", zz = "inv_complex_snowmanpyramidext", zz_gate = "inv_snowmanpyramidext" };

private.use_snowmanheadext_logic = function()
  ObjSet( "spr_snowmanpyramidext_snowmanext", { visible = 0, input = 1, active = 1 } )

end;
private.use_snowmanheadext_inv = function()
  common_impl.ProcessMultiUseAll("snowmanheadext", "snowmanheadext")
end;
private.use_snowmanheadext_beg = function()
  ObjDelete( "gfx_snowmanpyramidext_snowmanheadext_zone" );
end;
private.use_snowmanheadext_end = function()
  ObjSet( "anm_snowmanpyramidext_anm", { animfunc = "use_partb", frame = 999 } )
  ObjSet( "gfx_snowmanpyramidext_snowmanext", { active = 1 } )
  ObjSet( "inv_snowmanpyramidext_st_3", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowmanheadext", private.use_snowmanheadext_inv );
cmn.AddSubscriber( "use_snowmanheadext", private.use_snowmanheadext_beg );
cmn.AddSubscriber( "use_snowmanheadext", private.use_snowmanheadext_end );
cmn.AddSubscriber( "use_snowmanheadext", private.use_snowmanheadext_logic );
cmn.AddSubscriber( "use_snowmanheadext_inv", private.use_snowmanheadext_inv );
cmn.AddSubscriber( "use_snowmanheadext_beg", private.use_snowmanheadext_beg );
cmn.AddSubscriber( "use_snowmanheadext_end", private.use_snowmanheadext_end );
cmn.AddSubscriber( "use_snowmanheadext_end", private.use_snowmanheadext_logic );
--------------------------------------------------------------------------------------------
function public.use_snowmanheadext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowmanheadext" );
    cmn.CallEventHandler( "use_snowmanheadext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowmanheadext_inv" );
  cmn.CallEventHandler( "use_snowmanheadext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_snowmanbodyext_snowmanpyramidext" )
  
  ld.AnimPlay( "anm_snowmanpyramidext_anm", "use_partb", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_snowmanext" ] = { type = "get", get_obj = "spr_snowmanpyramidext_snowmanext", room = "inv_complex_inv", zz = "inv_complex_snowmanpyramidext", zz_gate = "inv_snowmanpyramidext" };

private.get_snowmanext_logic = function()
 
end;
private.get_snowmanext_inv = function()
  interface.InventoryItemAdd("inv_snowmanext","spr_snowmanpyramidext_snowmanext");
  if common_impl.ZzCompleteCheck("get_snowmanext") then interface.InventoryItemRemove("inv_snowmanpyramidext") end;
end;
private.get_snowmanext_beg = function()
  ObjDelete("gfx_snowmanpyramidext_snowmanext");
end;
private.get_snowmanext_end = function()
  ObjDelete( "anm_snowmanpyramidext_anm" )
end;

cmn.AddSubscriber( "get_snowmanext", private.get_snowmanext_inv );
cmn.AddSubscriber( "get_snowmanext", private.get_snowmanext_beg );
cmn.AddSubscriber( "get_snowmanext", private.get_snowmanext_end );
cmn.AddSubscriber( "get_snowmanext", private.get_snowmanext_logic );
--------------------------------------------------------------------
function public.get_snowmanext()
  ObjSet( "spr_snowmanpyramidext_snowmanext", { visible = 1 } )
  cmn.SetEventDone( "get_snowmanext" );
  cmn.CallEventHandler( "get_snowmanext" );
  if common_impl.ZzCompleteCheck("get_snowmanext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_candleext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_matchesext" ] = { type = "use", inv_obj = "inv_matchesext", use_place = "gfx_candleext_matchesext_zone", room = "inv_complex_inv", zz = "inv_complex_candleext", zz_gate = "inv_candleext" };

private.use_matchesext_logic = function()
  ObjSet( "spr_candleext_firedcandleext", { visible = 1, input = 1, active = 1 } )
end;
private.use_matchesext_inv = function()
  common_impl.ProcessMultiUseAll("matchesext", "matchesext")
end;
private.use_matchesext_beg = function()
  ObjDelete( "gfx_candleext_matchesext_zone" );
end;
private.use_matchesext_end = function()
  ObjDelete( "anm_candleext_anm" )
  ObjSet( "anm_candleext_anm_light", { visible = 1, playing = 1, active = 1 } )
  ObjSet( "inv_candleext_st_2", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_matchesext", private.use_matchesext_inv );
cmn.AddSubscriber( "use_matchesext", private.use_matchesext_beg );
cmn.AddSubscriber( "use_matchesext", private.use_matchesext_end );
cmn.AddSubscriber( "use_matchesext", private.use_matchesext_logic );
cmn.AddSubscriber( "use_matchesext_inv", private.use_matchesext_inv );
cmn.AddSubscriber( "use_matchesext_beg", private.use_matchesext_beg );
cmn.AddSubscriber( "use_matchesext_end", private.use_matchesext_end );
cmn.AddSubscriber( "use_matchesext_end", private.use_matchesext_logic );
--------------------------------------------------------------------------------------------
function public.use_matchesext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_matchesext" );
    cmn.CallEventHandler( "use_matchesext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_matchesext_inv" );
  cmn.CallEventHandler( "use_matchesext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_matchesext_candleext" )
  
  ld.AnimPlay( "anm_candleext_anm", "use_matches", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_firedcandleext" ] = { type = "get", get_obj = "spr_candleext_firedcandleext", room = "inv_complex_inv", zz = "inv_complex_candleext", zz_gate = "inv_candleext" };

private.get_firedcandleext_logic = function()
 
end;
private.get_firedcandleext_inv = function()
  interface.InventoryItemAdd("inv_firedcandleext","spr_candleext_firedcandleext");
  if common_impl.ZzCompleteCheck("get_firedcandleext") then interface.InventoryItemRemove("inv_candleext") end;
end;
private.get_firedcandleext_beg = function()
  ObjDelete("gfx_candleext_firedcandleext");
end;
private.get_firedcandleext_end = function()
  
end;

cmn.AddSubscriber( "get_firedcandleext", private.get_firedcandleext_inv );
cmn.AddSubscriber( "get_firedcandleext", private.get_firedcandleext_beg );
cmn.AddSubscriber( "get_firedcandleext", private.get_firedcandleext_end );
cmn.AddSubscriber( "get_firedcandleext", private.get_firedcandleext_logic );
--------------------------------------------------------------------
function public.get_firedcandleext()
  cmn.SetEventDone( "get_firedcandleext" );
  cmn.CallEventHandler( "get_firedcandleext" );
  if common_impl.ZzCompleteCheck("get_firedcandleext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_brokenscissorsext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scissorspartext" ] = { type = "use", inv_obj = "inv_scissorspartext", use_place = "gfx_brokenscissorsext_scissorspartext_zone", room = "inv_complex_inv", zz = "inv_complex_brokenscissorsext", zz_gate = "inv_brokenscissorsext" };

private.use_scissorspartext_logic = function()
  ObjSet( "gfx_brokenscissorsext_boltext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_scissorspartext_inv = function()
  common_impl.ProcessMultiUseAll("scissorspartext", "scissorspartext")
end;
private.use_scissorspartext_beg = function()
  ObjDelete( "gfx_brokenscissorsext_scissorspartext_zone" );
end;
private.use_scissorspartext_end = function()
  ObjSet( "anm_brokenscissorsext_anm", { animfunc = "use_screw", frame = 0 } )
  ObjSet( "inv_brokenscissorsext_back", { visible = 0 } )
  ObjSet( "inv_brokenscissorsext_tr_2", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scissorspartext", private.use_scissorspartext_inv );
cmn.AddSubscriber( "use_scissorspartext", private.use_scissorspartext_beg );
cmn.AddSubscriber( "use_scissorspartext", private.use_scissorspartext_end );
cmn.AddSubscriber( "use_scissorspartext", private.use_scissorspartext_logic );
cmn.AddSubscriber( "use_scissorspartext_inv", private.use_scissorspartext_inv );
cmn.AddSubscriber( "use_scissorspartext_beg", private.use_scissorspartext_beg );
cmn.AddSubscriber( "use_scissorspartext_end", private.use_scissorspartext_end );
cmn.AddSubscriber( "use_scissorspartext_end", private.use_scissorspartext_logic );
--------------------------------------------------------------------------------------------
function public.use_scissorspartext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scissorspartext" );
    cmn.CallEventHandler( "use_scissorspartext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scissorspartext_inv" );
  cmn.CallEventHandler( "use_scissorspartext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_scissorspartext_brokenscissorsext" )
  
  ld.AnimPlay( "anm_brokenscissorsext_anm", "use_scissors", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_boltext" ] = { type = "use", inv_obj = "inv_boltext", use_place = "gfx_brokenscissorsext_boltext_zone", room = "inv_complex_inv", zz = "inv_complex_brokenscissorsext", zz_gate = "inv_brokenscissorsext" };

private.use_boltext_logic = function()
  ObjSet( "gfx_brokenscissorsext_screwdriverext_brokenscissorsext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_boltext_inv = function()
  common_impl.ProcessMultiUseAll("boltext", "boltext")
end;
private.use_boltext_beg = function()
  ObjDelete( "gfx_brokenscissorsext_boltext_zone" );
end;
private.use_boltext_end = function()
  ObjSet( "anm_brokenscissorsext_anm", { animfunc = "use_screwdriver", frame = 0 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_boltext", private.use_boltext_inv );
cmn.AddSubscriber( "use_boltext", private.use_boltext_beg );
cmn.AddSubscriber( "use_boltext", private.use_boltext_end );
cmn.AddSubscriber( "use_boltext", private.use_boltext_logic );
cmn.AddSubscriber( "use_boltext_inv", private.use_boltext_inv );
cmn.AddSubscriber( "use_boltext_beg", private.use_boltext_beg );
cmn.AddSubscriber( "use_boltext_end", private.use_boltext_end );
cmn.AddSubscriber( "use_boltext_end", private.use_boltext_logic );
--------------------------------------------------------------------------------------------
function public.use_boltext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_boltext" );
    cmn.CallEventHandler( "use_boltext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_boltext_inv" );
  cmn.CallEventHandler( "use_boltext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_boltext_brokenscissorsext" )
  
  ld.AnimPlay( "anm_brokenscissorsext_anm", "use_screw", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_screwdriverext_brokenscissorsext" ] = { type = "use", inv_obj = "inv_screwdriverext", use_place = "gfx_brokenscissorsext_screwdriverext_brokenscissorsext_zone", room = "inv_complex_inv", zz = "inv_complex_brokenscissorsext", zz_gate = "inv_brokenscissorsext" };

private.use_screwdriverext_brokenscissorsext_logic = function()
  ObjSet( "gfx_brokenscissorsext_fairyext_brokenscissorsext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_screwdriverext_brokenscissorsext_inv = function()
  common_impl.ProcessMultiUseAll("screwdriverext", "screwdriverext_brokenscissorsext")
end;
private.use_screwdriverext_brokenscissorsext_beg = function()
  ObjDelete( "gfx_brokenscissorsext_screwdriverext_brokenscissorsext_zone" );
end;
private.use_screwdriverext_brokenscissorsext_end = function()
  ObjSet( "anm_brokenscissorsext_anm", { animfunc = "use_screwdriver", frame = 999 } )
  ObjSet( "inv_brokenscissorsext_tr_3", { visible = 1 } )
  ObjDelete( "inv_brokenscissorsext_tr_2" )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screwdriverext_brokenscissorsext", private.use_screwdriverext_brokenscissorsext_inv );
cmn.AddSubscriber( "use_screwdriverext_brokenscissorsext", private.use_screwdriverext_brokenscissorsext_beg );
cmn.AddSubscriber( "use_screwdriverext_brokenscissorsext", private.use_screwdriverext_brokenscissorsext_end );
cmn.AddSubscriber( "use_screwdriverext_brokenscissorsext", private.use_screwdriverext_brokenscissorsext_logic );
cmn.AddSubscriber( "use_screwdriverext_brokenscissorsext_inv", private.use_screwdriverext_brokenscissorsext_inv );
cmn.AddSubscriber( "use_screwdriverext_brokenscissorsext_beg", private.use_screwdriverext_brokenscissorsext_beg );
cmn.AddSubscriber( "use_screwdriverext_brokenscissorsext_end", private.use_screwdriverext_brokenscissorsext_end );
cmn.AddSubscriber( "use_screwdriverext_brokenscissorsext_end", private.use_screwdriverext_brokenscissorsext_logic );
--------------------------------------------------------------------------------------------
function public.use_screwdriverext_brokenscissorsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screwdriverext_brokenscissorsext" );
    cmn.CallEventHandler( "use_screwdriverext_brokenscissorsext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screwdriverext_brokenscissorsext_inv" );
  cmn.CallEventHandler( "use_screwdriverext_brokenscissorsext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_screwdriverext_brokenscissorsext" )
  
  ld.AnimPlay( "anm_brokenscissorsext_anm", "use_screwdriver", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fairyext_brokenscissorsext" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_brokenscissorsext_fairyext_brokenscissorsext_zone", room = "inv_complex_inv", zz = "inv_complex_brokenscissorsext", zz_gate = "inv_brokenscissorsext" };

private.use_fairyext_brokenscissorsext_logic = function()
  ObjSet( "spr_brokenscissorsext_fairywithscissorsext", { visible = 1, input = 1, active = 1 } )
  int_simon.SimonSetVisible(0) 
end;
private.use_fairyext_brokenscissorsext_inv = function()
  common_impl.ProcessMultiUseAll("fairyext", "fairyext_brokenscissorsext")
end;
private.use_fairyext_brokenscissorsext_beg = function()
  ObjDelete( "gfx_brokenscissorsext_fairyext_brokenscissorsext_zone" );
end;
private.use_fairyext_brokenscissorsext_end = function()
  ObjDelete( "anm_brokenscissorsext_anm" )
  ObjDelete( "vid_brokenscissorsext_vid_fairy_get_scissors_81" )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fairyext_brokenscissorsext", private.use_fairyext_brokenscissorsext_inv );
cmn.AddSubscriber( "use_fairyext_brokenscissorsext", private.use_fairyext_brokenscissorsext_beg );
cmn.AddSubscriber( "use_fairyext_brokenscissorsext", private.use_fairyext_brokenscissorsext_end );
cmn.AddSubscriber( "use_fairyext_brokenscissorsext", private.use_fairyext_brokenscissorsext_logic );
cmn.AddSubscriber( "use_fairyext_brokenscissorsext_inv", private.use_fairyext_brokenscissorsext_inv );
cmn.AddSubscriber( "use_fairyext_brokenscissorsext_beg", private.use_fairyext_brokenscissorsext_beg );
cmn.AddSubscriber( "use_fairyext_brokenscissorsext_end", private.use_fairyext_brokenscissorsext_end );
cmn.AddSubscriber( "use_fairyext_brokenscissorsext_end", private.use_fairyext_brokenscissorsext_logic );
--------------------------------------------------------------------------------------------
function public.use_fairyext_brokenscissorsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fairyext_brokenscissorsext" );
    cmn.CallEventHandler( "use_fairyext_brokenscissorsext_end" );
    common_impl.Lock(0);
    public.get_fairywithscissorsext()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fairyext_brokenscissorsext_inv" );
  cmn.CallEventHandler( "use_fairyext_brokenscissorsext_beg" );
  common_impl.Lock(1);

  interface.SimonJump( function() 
    ObjAttach( "vid_brokenscissorsext_vid_fairy_get_scissors_81", "inv_complex_brokenscissorsext" )
    ObjAnimate( "anm_brokenscissorsext_anm", 8,0,0, nil, { 0,0,1, 0.35,0,0 } )
    ObjAnimate( "vid_brokenscissorsext_vid_fairy_get_scissors_81", 8,0,0, nil, { 0,0,0, 0.35,0,1 } )
    SoundSfx( "aud_fairy_get_scissors_81" )
    VidPlay( "vid_brokenscissorsext_vid_fairy_get_scissors_81", func_end )
  end ) 

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fairywithscissorsext" ] = { type = "get", get_obj = "spr_brokenscissorsext_fairywithscissorsext", room = "inv_complex_inv", zz = "inv_complex_brokenscissorsext", zz_gate = "inv_brokenscissorsext" };

private.get_fairywithscissorsext_logic = function()
 
end;
private.get_fairywithscissorsext_inv = function()
  interface.InventoryItemAdd("inv_fairywithscissorsext","spr_brokenscissorsext_fairywithscissorsext");
  if common_impl.ZzCompleteCheck("get_fairywithscissorsext") then interface.InventoryItemRemove("inv_brokenscissorsext") end;
end;
private.get_fairywithscissorsext_beg = function()
  ObjDelete("gfx_brokenscissorsext_fairywithscissorsext");
end;
private.get_fairywithscissorsext_end = function()
  
end;

cmn.AddSubscriber( "get_fairywithscissorsext", private.get_fairywithscissorsext_inv );
cmn.AddSubscriber( "get_fairywithscissorsext", private.get_fairywithscissorsext_beg );
cmn.AddSubscriber( "get_fairywithscissorsext", private.get_fairywithscissorsext_end );
cmn.AddSubscriber( "get_fairywithscissorsext", private.get_fairywithscissorsext_logic );
--------------------------------------------------------------------
function public.get_fairywithscissorsext()
  cmn.SetEventDone( "get_fairywithscissorsext" );
  cmn.CallEventHandler( "get_fairywithscissorsext" );
  if common_impl.ZzCompleteCheck("get_fairywithscissorsext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_sockext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_giftgunext" ] = { type = "use", inv_obj = "inv_giftgunext", use_place = "gfx_sockext_giftgunext_zone", room = "inv_complex_inv", zz = "inv_complex_sockext", zz_gate = "inv_sockext" };

private.use_giftgunext_logic = function()
  if ld.CheckRequirements( { "use_bowext", "use_giftgunext" } ) then
    ObjSet( "spr_sockext_giftsockext", { visible = 0, input = 1, active = 1 } )
  end
end;
private.use_giftgunext_inv = function()
  common_impl.ProcessMultiUseAll("giftgunext", "giftgunext")
end;
private.use_giftgunext_beg = function()
  ObjDelete( "gfx_sockext_giftgunext_zone" );
end;
private.use_giftgunext_end = function()
  if ld.CheckRequirements( { "use_bowext", "use_giftgunext" } ) then
    ObjSet( "anm_sockext_anm", { animfunc = "end_bow", frame = 0 } )
  else
    ObjSet( "anm_sockext_anm", { animfunc = "use_bow", frame = 0 } )
  end
  ObjSet( "inv_sockext_tr_2", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_giftgunext", private.use_giftgunext_inv );
cmn.AddSubscriber( "use_giftgunext", private.use_giftgunext_beg );
cmn.AddSubscriber( "use_giftgunext", private.use_giftgunext_end );
cmn.AddSubscriber( "use_giftgunext", private.use_giftgunext_logic );
cmn.AddSubscriber( "use_giftgunext_inv", private.use_giftgunext_inv );
cmn.AddSubscriber( "use_giftgunext_beg", private.use_giftgunext_beg );
cmn.AddSubscriber( "use_giftgunext_end", private.use_giftgunext_end );
cmn.AddSubscriber( "use_giftgunext_end", private.use_giftgunext_logic );
--------------------------------------------------------------------------------------------
function public.use_giftgunext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_giftgunext" );
    cmn.CallEventHandler( "use_giftgunext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_giftgunext_inv" );
  cmn.CallEventHandler( "use_giftgunext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_giftgunext_sockext" )
  if ld.CheckRequirements( { "use_bowext" } ) then
    ld.AnimPlay( "anm_sockext_anm", "use_pistol1_bow", func_end );
  else
    ld.AnimPlay( "anm_sockext_anm", "use_pistol", func_end );
  end

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bowext" ] = { type = "use", inv_obj = "inv_bowext", use_place = "gfx_sockext_bowext_zone", room = "inv_complex_inv", zz = "inv_complex_sockext", zz_gate = "inv_sockext" };

private.use_bowext_logic = function()
  if ld.CheckRequirements( { "use_bowext", "use_giftgunext" } ) then
    ObjSet( "spr_sockext_giftsockext", { visible = 0, input = 1, active = 1 } )
  end
end;
private.use_bowext_inv = function()
  common_impl.ProcessMultiUseAll("bowext", "bowext")
end;
private.use_bowext_beg = function()
  ObjDelete( "gfx_sockext_bowext_zone" );
end;
private.use_bowext_end = function()
  if ld.CheckRequirements( { "use_bowext", "use_giftgunext" } ) then
    ObjSet( "anm_sockext_anm", { animfunc = "end_bow", frame = 0 } )
  else
    ObjSet( "anm_sockext_anm", { animfunc = "use_pistol1_bow", frame = 0 } )
  end
  ObjSet( "gfx_sockext_giftsockext", { active = 1 } )
  ObjSet( "inv_sockext_tr_3", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bowext", private.use_bowext_inv );
cmn.AddSubscriber( "use_bowext", private.use_bowext_beg );
cmn.AddSubscriber( "use_bowext", private.use_bowext_end );
cmn.AddSubscriber( "use_bowext", private.use_bowext_logic );
cmn.AddSubscriber( "use_bowext_inv", private.use_bowext_inv );
cmn.AddSubscriber( "use_bowext_beg", private.use_bowext_beg );
cmn.AddSubscriber( "use_bowext_end", private.use_bowext_end );
cmn.AddSubscriber( "use_bowext_end", private.use_bowext_logic );
--------------------------------------------------------------------------------------------
function public.use_bowext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bowext" );
    cmn.CallEventHandler( "use_bowext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bowext_inv" );
  cmn.CallEventHandler( "use_bowext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_bowext_sockext" )
  if ld.CheckRequirements( { "use_giftgunext" } ) then
    ld.AnimPlay( "anm_sockext_anm", "use_bow", func_end );
  else
    ld.AnimPlay( "anm_sockext_anm", "use_bow_withoutpistol", func_end );
  end

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_giftsockext" ] = { type = "get", get_obj = "spr_sockext_giftsockext", room = "inv_complex_inv", zz = "inv_complex_sockext", zz_gate = "inv_sockext" };

private.get_giftsockext_logic = function()
 
end;
private.get_giftsockext_inv = function()
  interface.InventoryItemAdd("inv_giftsockext","anm_sockext_anm");
  if common_impl.ZzCompleteCheck("get_giftsockext") then interface.InventoryItemRemove("inv_sockext") end;
end;
private.get_giftsockext_beg = function()
  ObjDelete("gfx_sockext_giftsockext");
  ObjDelete( "spr_sockext_giftsockext" )
end;
private.get_giftsockext_end = function()
  
end;

cmn.AddSubscriber( "get_giftsockext", private.get_giftsockext_inv );
cmn.AddSubscriber( "get_giftsockext", private.get_giftsockext_beg );
cmn.AddSubscriber( "get_giftsockext", private.get_giftsockext_end );
cmn.AddSubscriber( "get_giftsockext", private.get_giftsockext_logic );
--------------------------------------------------------------------
function public.get_giftsockext()
  cmn.SetEventDone( "get_giftsockext" );
  cmn.CallEventHandler( "get_giftsockext" );
  if common_impl.ZzCompleteCheck("get_giftsockext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_potholderext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_needleandcottonext" ] = { type = "use", inv_obj = "inv_needleandcottonext", use_place = "gfx_potholderext_needleandcottonext_zone", room = "inv_complex_inv", zz = "inv_complex_potholderext", zz_gate = "inv_potholderext" };

private.use_needleandcottonext_logic = function()
  ObjSet( "spr_potholderext_christmasspotholderext", { visible = 1, input = 1, active = 1 } )
end;
private.use_needleandcottonext_inv = function()
  common_impl.ProcessMultiUseAll("needleandcottonext", "needleandcottonext")
end;
private.use_needleandcottonext_beg = function()
  ObjDelete( "gfx_potholderext_needleandcottonext_zone" );
end;
private.use_needleandcottonext_end = function()
  ObjDelete("anm_potholderext_anim");
  ObjSet("inv_potholderext_tr",{visible=1})
  ObjSet("inv_potholderext_back",{visible=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_needleandcottonext", private.use_needleandcottonext_inv );
cmn.AddSubscriber( "use_needleandcottonext", private.use_needleandcottonext_beg );
cmn.AddSubscriber( "use_needleandcottonext", private.use_needleandcottonext_end );
cmn.AddSubscriber( "use_needleandcottonext", private.use_needleandcottonext_logic );
cmn.AddSubscriber( "use_needleandcottonext_inv", private.use_needleandcottonext_inv );
cmn.AddSubscriber( "use_needleandcottonext_beg", private.use_needleandcottonext_beg );
cmn.AddSubscriber( "use_needleandcottonext_end", private.use_needleandcottonext_end );
cmn.AddSubscriber( "use_needleandcottonext_end", private.use_needleandcottonext_logic );
--------------------------------------------------------------------------------------------
function public.use_needleandcottonext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_needleandcottonext" );
    cmn.CallEventHandler( "use_needleandcottonext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_needleandcottonext_inv" );
  cmn.CallEventHandler( "use_needleandcottonext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_needleandcottonext_potholderext" )
  
  ld.AnimPlay( "anm_potholderext_anim", "use_needle", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_christmasspotholderext" ] = { type = "get", get_obj = "spr_potholderext_christmasspotholderext", room = "inv_complex_inv", zz = "inv_complex_potholderext", zz_gate = "inv_potholderext" };

private.get_christmasspotholderext_logic = function()
 
end;
private.get_christmasspotholderext_inv = function()
  interface.InventoryItemAdd("inv_christmasspotholderext","spr_potholderext_christmasspotholderext");
  if common_impl.ZzCompleteCheck("get_christmasspotholderext") then interface.InventoryItemRemove("inv_potholderext") end;
end;
private.get_christmasspotholderext_beg = function()
  ObjDelete("gfx_potholderext_christmasspotholderext");
end;
private.get_christmasspotholderext_end = function()
  
end;

cmn.AddSubscriber( "get_christmasspotholderext", private.get_christmasspotholderext_inv );
cmn.AddSubscriber( "get_christmasspotholderext", private.get_christmasspotholderext_beg );
cmn.AddSubscriber( "get_christmasspotholderext", private.get_christmasspotholderext_end );
cmn.AddSubscriber( "get_christmasspotholderext", private.get_christmasspotholderext_logic );
--------------------------------------------------------------------
function public.get_christmasspotholderext()
  cmn.SetEventDone( "get_christmasspotholderext" );
  cmn.CallEventHandler( "get_christmasspotholderext" );
  if common_impl.ZzCompleteCheck("get_christmasspotholderext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_towerext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_towerroofext" ] = { type = "use", inv_obj = "inv_towerroofext", use_place = "gfx_towerext_towerroofext_zone", room = "inv_complex_inv", zz = "inv_complex_towerext", zz_gate = "inv_towerext" };

private.use_towerroofext_logic = function()
  ObjSet( "spr_towerext_acornext3", { visible = 1, input = 1, active = 1 } )
end;
private.use_towerroofext_inv = function()
  common_impl.ProcessMultiUseAll("towerroofext", "towerroofext")
  ObjSet( "inv_towerext_back", { visible = 0 } )
  ObjSet( "inv_towerext_st_2", { visible = 1 } )
  ObjSet( "inv_towerext_st_3", { visible = 1 } )
  ObjSet( "inv_towerext_st_4", { visible = 1 } )
end;
private.use_towerroofext_beg = function()
  ObjDelete( "gfx_towerext_towerroofext_zone" );
end;
private.use_towerroofext_end = function()
  ObjSet( "gfx_towerext_acornext3", { active = 1 } )
  ObjSet( "anm_towerext_anm", { animfunc = "end_roof", frame = 0 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_towerroofext", private.use_towerroofext_inv );
cmn.AddSubscriber( "use_towerroofext", private.use_towerroofext_beg );
cmn.AddSubscriber( "use_towerroofext", private.use_towerroofext_end );
cmn.AddSubscriber( "use_towerroofext", private.use_towerroofext_logic );
cmn.AddSubscriber( "use_towerroofext_inv", private.use_towerroofext_inv );
cmn.AddSubscriber( "use_towerroofext_beg", private.use_towerroofext_beg );
cmn.AddSubscriber( "use_towerroofext_end", private.use_towerroofext_end );
cmn.AddSubscriber( "use_towerroofext_end", private.use_towerroofext_logic );
--------------------------------------------------------------------------------------------
function public.use_towerroofext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_towerroofext" );
    cmn.CallEventHandler( "use_towerroofext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_towerroofext_inv" );
  cmn.CallEventHandler( "use_towerroofext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_towerroofext_towerext" )
  
  ld.AnimPlay( "anm_towerext_anm", "use_roof", func_end );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bunnyext" ] = { type = "get", get_obj = "spr_towerext_bunnyext", room = "inv_complex_inv", zz = "inv_complex_towerext", zz_gate = "inv_towerext" };

private.get_bunnyext_logic = function()
  ObjSet( "spr_towerext_glasstowerext", { visible = 0, input = 1, active = 1 } )
end;
private.get_bunnyext_inv = function()
  ObjDelete( "inv_towerext_st_4" )
  interface.InventoryItemAdd("inv_bunnyext","spr_towerext_bunnyext");
  if common_impl.ZzCompleteCheck("get_bunnyext") then interface.InventoryItemRemove("inv_towerext") end;
end;
private.get_bunnyext_beg = function()
  ObjDelete("gfx_towerext_bunnyext");
end;
private.get_bunnyext_end = function()
  ObjSet( "gfx_towerext_bunnyext", { active = 1 } )
  ObjDelete( "spr_towerext_sh_bunnyext" )
end;

cmn.AddSubscriber( "get_bunnyext", private.get_bunnyext_inv );
cmn.AddSubscriber( "get_bunnyext", private.get_bunnyext_beg );
cmn.AddSubscriber( "get_bunnyext", private.get_bunnyext_end );
cmn.AddSubscriber( "get_bunnyext", private.get_bunnyext_logic );
--------------------------------------------------------------------
function public.get_bunnyext()
  cmn.SetEventDone( "get_bunnyext" );
  cmn.CallEventHandler( "get_bunnyext" );
  if common_impl.ZzCompleteCheck("get_bunnyext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_acornext3" ] = { type = "get", get_obj = "spr_towerext_acornext3", room = "inv_complex_inv", zz = "inv_complex_towerext", zz_gate = "inv_towerext" };

private.get_acornext3_logic = function()
  ObjSet( "spr_towerext_bunnyext", { visible = 1, input = 1, active = 1 } )
end;
private.get_acornext3_inv = function()
  ObjDelete( "inv_towerext_st_3" )
  interface.InventoryItemAdd("inv_acornext","spr_towerext_acornext3",function() level_inv.ProcessGetAcornextAll( "get_acornext3" ) end);
  if common_impl.ZzCompleteCheck("get_acornext3") then interface.InventoryItemRemove("inv_towerext") end;
end;
private.get_acornext3_beg = function()
  ObjDelete("gfx_towerext_acornext3");
end;
private.get_acornext3_end = function()
  ObjSet( "gfx_towerext_bunnyext", { active = 1 } )
  ObjDelete( "spr_towerext_sh_acornext3" )
end;

cmn.AddSubscriber( "get_acornext3", private.get_acornext3_inv );
cmn.AddSubscriber( "get_acornext3", private.get_acornext3_beg );
cmn.AddSubscriber( "get_acornext3", private.get_acornext3_end );
cmn.AddSubscriber( "get_acornext3", private.get_acornext3_logic );
--------------------------------------------------------------------
function public.get_acornext3()
  cmn.SetEventDone( "get_acornext3" );
  cmn.CallEventHandler( "get_acornext3" );
  if common_impl.ZzCompleteCheck("get_acornext3") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_glasstowerext" ] = { type = "get", get_obj = "spr_towerext_glasstowerext", room = "inv_complex_inv", zz = "inv_complex_towerext", zz_gate = "inv_towerext" };

private.get_glasstowerext_logic = function()

end;
private.get_glasstowerext_inv = function()
  interface.InventoryItemAdd("inv_glasstowerext","anm_towerext_anm");
  if common_impl.ZzCompleteCheck("get_glasstowerext") then interface.InventoryItemRemove("inv_towerext") end;
end;
private.get_glasstowerext_beg = function()
  ObjDelete("gfx_towerext_glasstowerext");
end;
private.get_glasstowerext_end = function()
  ObjDelete( "spr_towerext_glasstowerext" )
end;

cmn.AddSubscriber( "get_glasstowerext", private.get_glasstowerext_inv );
cmn.AddSubscriber( "get_glasstowerext", private.get_glasstowerext_beg );
cmn.AddSubscriber( "get_glasstowerext", private.get_glasstowerext_end );
cmn.AddSubscriber( "get_glasstowerext", private.get_glasstowerext_logic );
--------------------------------------------------------------------
function public.get_glasstowerext()
  cmn.SetEventDone( "get_glasstowerext" );
  cmn.CallEventHandler( "get_glasstowerext" );
  if common_impl.ZzCompleteCheck("get_glasstowerext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_instructionext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.inv_complex_instructionext_idle( bbt_need )
  ld.Lock( 1 )
  local count = 1;
  local func_end = function() 
    count = count - 1
    if count == 0 then
      if bbt_need then
        ld.ShowBbt( bbt_need )
      end
      ld.Lock( 0 )
    end
  end
  SoundSfx( "aud_clk_paperdove_3" )
  ld.AnimPlay( "anm_inv_complex_instructionext_anm_idle_paper", "idle_paper", func_end )
  if ld.CheckRequirements( { "use_acornext" } ) then
    ld.AnimPlay( "anm_inv_complex_instructionext_anm_use_acorn", "idle_acorn", func_end )
  end
  if ld.CheckRequirements( { "use_deerhornsext" } ) then
    ld.AnimPlay( "anm_inv_complex_instructionext_anm_use_horn", "idle_horn", func_end )
  end
  if ld.CheckRequirements( { "use_plasticineext" } ) then
    ld.AnimPlay( "anm_inv_complex_instructionext_anm_use_plasticine", "idle_plasticine", func_end )
  end
  if ld.CheckRequirements( { "use_toothpicksext" } ) then
    ld.AnimPlay( "anm_inv_complex_instructionext_anm_use_toothpick", "idle_toothpick", func_end )
  end
end
function private.inv_complex_instructionext_use( anim_func, func_end )
  if ld.CheckRequirements( { "use_acornext", "use_horn", "use_plasticine", "use_toothpick" }, 1 ) == 0 then
    local o = ObjGet( "anm_inv_complex_instructionext_anm_idle_paper" )
    ObjAnimate( o.name, 3,0,0, nil, { 0,0,o.pos_x,o.pos_y, 0.4,3,0,0 } )
  end
  local anm = "anm_inv_complex_instructionext_anm_"..anim_func
  ObjSet( anm, { pos_z = 6 } )
  ld.AnimPlay( anm, anim_func, function() 
    ObjSet( anm, { pos_z = 5 } )
    func_end()
  end )
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_acornext" ] = { type = "use", inv_obj = "inv_acornext", use_place = "gfx_instructionext_acornext_zone", room = "inv_complex_inv", zz = "inv_complex_instructionext", zz_gate = "inv_instructionext" };

private.use_acornext_logic = function()
  if ld.CheckRequirements( {"use_acornext","use_deerhornsext","use_plasticineext","use_toothpicksext"} ) then
    ObjSet( "gfx_instructionext_clk_instructionext1_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_acornext_inv = function()
  common_impl.ProcessMultiUseAll("acornext", "acornext")
end;
private.use_acornext_beg = function()
  ObjDelete( "gfx_instructionext_acornext_zone" );
end;
private.use_acornext_end = function()
  ObjSet( "anm_inv_complex_instructionext_anm_use_acorn", { animfunc = "use_acorn", frame = 999 } )
  ObjSet( "anm_inv_complex_instructionext_anm_idle_paper", { pos_x = 0; pos_y = 0; } )
  ObjSet( "inv_instructionext_tr_1", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_acornext", private.use_acornext_inv );
cmn.AddSubscriber( "use_acornext", private.use_acornext_beg );
cmn.AddSubscriber( "use_acornext", private.use_acornext_end );
cmn.AddSubscriber( "use_acornext", private.use_acornext_logic );
cmn.AddSubscriber( "use_acornext_inv", private.use_acornext_inv );
cmn.AddSubscriber( "use_acornext_beg", private.use_acornext_beg );
cmn.AddSubscriber( "use_acornext_end", private.use_acornext_end );
cmn.AddSubscriber( "use_acornext_end", private.use_acornext_logic );
--------------------------------------------------------------------------------------------
function public.use_acornext( obj )

  local func_end = function()
   ObjSet( "anm_inv_complex_instructionext_anm_use_acorn", { pos_z = 0 } )
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_acornext" );
    cmn.CallEventHandler( "use_acornext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_acornext_inv" );
  cmn.CallEventHandler( "use_acornext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_acornext_instructionext" )
  
  private.inv_complex_instructionext_use( "use_acorn", func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_deerhornsext" ] = { type = "use", inv_obj = "inv_deerhornsext", use_place = "gfx_instructionext_deerhornsext_zone", room = "inv_complex_inv", zz = "inv_complex_instructionext", zz_gate = "inv_instructionext" };

private.use_deerhornsext_logic = function()
  if ld.CheckRequirements( {"use_deerhornsext","use_acornext","use_plasticineext","use_toothpicksext"} ) then
    ObjSet( "gfx_instructionext_clk_instructionext1_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_deerhornsext_inv = function()
  common_impl.ProcessMultiUseAll("deerhornsext", "deerhornsext")
end;
private.use_deerhornsext_beg = function()
  ObjDelete( "gfx_instructionext_deerhornsext_zone" );
end;
private.use_deerhornsext_end = function()
  ObjSet( "anm_inv_complex_instructionext_anm_use_horn", { animfunc = "use_horn", frame = 999 } )
  ObjSet( "anm_inv_complex_instructionext_anm_idle_paper", { pos_x = 0; pos_y = 0; } )
  ObjSet( "inv_instructionext_tr_3", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_deerhornsext", private.use_deerhornsext_inv );
cmn.AddSubscriber( "use_deerhornsext", private.use_deerhornsext_beg );
cmn.AddSubscriber( "use_deerhornsext", private.use_deerhornsext_end );
cmn.AddSubscriber( "use_deerhornsext", private.use_deerhornsext_logic );
cmn.AddSubscriber( "use_deerhornsext_inv", private.use_deerhornsext_inv );
cmn.AddSubscriber( "use_deerhornsext_beg", private.use_deerhornsext_beg );
cmn.AddSubscriber( "use_deerhornsext_end", private.use_deerhornsext_end );
cmn.AddSubscriber( "use_deerhornsext_end", private.use_deerhornsext_logic );
--------------------------------------------------------------------------------------------
function public.use_deerhornsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_deerhornsext" );
    cmn.CallEventHandler( "use_deerhornsext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_deerhornsext_inv" );
  cmn.CallEventHandler( "use_deerhornsext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_deerhornsext_instructionext" )
  
  private.inv_complex_instructionext_use( "use_horn", func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_plasticineext" ] = { type = "use", inv_obj = "inv_plasticineext", use_place = "gfx_instructionext_plasticineext_zone", room = "inv_complex_inv", zz = "inv_complex_instructionext", zz_gate = "inv_instructionext" };

private.use_plasticineext_logic = function()
  if ld.CheckRequirements( {"use_plasticineext","use_acornext","use_deerhornsext","use_toothpicksext"} ) then
    ObjSet( "gfx_instructionext_clk_instructionext1_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_plasticineext_inv = function()
  common_impl.ProcessMultiUseAll("plasticineext", "plasticineext")
end;
private.use_plasticineext_beg = function()
  ObjDelete( "gfx_instructionext_plasticineext_zone" );
end;
private.use_plasticineext_end = function()
  ObjSet( "anm_inv_complex_instructionext_anm_use_plasticine", { animfunc = "use_plasticine", frame = 999 } )
  ObjSet( "anm_inv_complex_instructionext_anm_idle_paper", { pos_x = 0; pos_y = 0; } )
  ObjSet( "inv_instructionext_tr_5", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_plasticineext", private.use_plasticineext_inv );
cmn.AddSubscriber( "use_plasticineext", private.use_plasticineext_beg );
cmn.AddSubscriber( "use_plasticineext", private.use_plasticineext_end );
cmn.AddSubscriber( "use_plasticineext", private.use_plasticineext_logic );
cmn.AddSubscriber( "use_plasticineext_inv", private.use_plasticineext_inv );
cmn.AddSubscriber( "use_plasticineext_beg", private.use_plasticineext_beg );
cmn.AddSubscriber( "use_plasticineext_end", private.use_plasticineext_end );
cmn.AddSubscriber( "use_plasticineext_end", private.use_plasticineext_logic );
--------------------------------------------------------------------------------------------
function public.use_plasticineext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_plasticineext" );
    cmn.CallEventHandler( "use_plasticineext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_plasticineext_inv" );
  cmn.CallEventHandler( "use_plasticineext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_put_ho" )
  
  private.inv_complex_instructionext_use( "use_plasticine", func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_toothpicksext" ] = { type = "use", inv_obj = "inv_toothpicksext", use_place = "gfx_instructionext_toothpicksext_zone", room = "inv_complex_inv", zz = "inv_complex_instructionext", zz_gate = "inv_instructionext" };

private.use_toothpicksext_logic = function()
  if ld.CheckRequirements( {"use_toothpicksext","use_acornext","use_deerhornsext","use_plasticineext"} ) then
    ObjSet( "gfx_instructionext_clk_instructionext1_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_toothpicksext_inv = function()
  common_impl.ProcessMultiUseAll("toothpicksext", "toothpicksext")
end;
private.use_toothpicksext_beg = function()
  ObjDelete( "gfx_instructionext_toothpicksext_zone" );
end;
private.use_toothpicksext_end = function()
  ObjSet( "anm_inv_complex_instructionext_anm_use_toothpick", { animfunc = "use_toothpick", frame = 999 } )
  ObjSet( "anm_inv_complex_instructionext_anm_idle_paper", { pos_x = 0; pos_y = 0; } )
  ObjSet( "inv_instructionext_tr_2", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_toothpicksext", private.use_toothpicksext_inv );
cmn.AddSubscriber( "use_toothpicksext", private.use_toothpicksext_beg );
cmn.AddSubscriber( "use_toothpicksext", private.use_toothpicksext_end );
cmn.AddSubscriber( "use_toothpicksext", private.use_toothpicksext_logic );
cmn.AddSubscriber( "use_toothpicksext_inv", private.use_toothpicksext_inv );
cmn.AddSubscriber( "use_toothpicksext_beg", private.use_toothpicksext_beg );
cmn.AddSubscriber( "use_toothpicksext_end", private.use_toothpicksext_end );
cmn.AddSubscriber( "use_toothpicksext_end", private.use_toothpicksext_logic );
--------------------------------------------------------------------------------------------
function public.use_toothpicksext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_toothpicksext" );
    cmn.CallEventHandler( "use_toothpicksext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_toothpicksext_inv" );
  cmn.CallEventHandler( "use_toothpicksext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_toothpicksext_instructionext" )
  
  private.inv_complex_instructionext_use( "use_toothpick", func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_instructionext1" ] = { type = "click", use_place = "gfx_instructionext_clk_instructionext1_zone", room = "inv_complex_inv", zz = "inv_complex_instructionext", zz_gate = "inv_instructionext" };

private.clk_instructionext1_logic = function()
  ObjSet( "spr_instructionext_deerext", { visible = 0, input = 1, active = 1 } )
end;
private.clk_instructionext1_beg = function()
  ObjDelete( "gfx_instructionext_clk_instructionext1_zone" );
  --ObjDelete( "anm_inv_complex_instructionext_anm_use_acorn" )
  ObjDelete( "anm_inv_complex_instructionext_anm_use_horn" )
  ObjDelete( "anm_inv_complex_instructionext_anm_use_toothpick" )
  ObjDelete( "anm_inv_complex_instructionext_anm_use_plasticine" )
end;
private.clk_instructionext1_end = function()
  ObjSet( "gfx_instructionext_deerext", { active = 1 } )
  ObjSet( "anm_inv_complex_instructionext_anm_use_acorn", { animfunc = "use_plasticine_small", frame = 999 } )
  ObjDelete( "inv_instructionext_tr_1" )
  ObjDelete( "inv_instructionext_tr_2" )
  ObjDelete( "inv_instructionext_tr_3" )
  ObjDelete( "inv_instructionext_tr_5" )
  ObjSet( "inv_instructionext_tr_4", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_instructionext1", private.clk_instructionext1_beg );
cmn.AddSubscriber( "clk_instructionext1", private.clk_instructionext1_end );
cmn.AddSubscriber( "clk_instructionext1", private.clk_instructionext1_logic );
cmn.AddSubscriber( "clk_instructionext1_beg", private.clk_instructionext1_beg );
cmn.AddSubscriber( "clk_instructionext1_end", private.clk_instructionext1_end );
cmn.AddSubscriber( "clk_instructionext1_end", private.clk_instructionext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_instructionext1()

  local func_end = function()
    cmn.SetEventDone( "clk_instructionext1" );
    cmn.CallEventHandler( "clk_instructionext1_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_instructionext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_inv_complex_instructionext_anm_use_acorn", "use_plasticine_small", func_end );
  SoundSfx( "aud_clk_instructionext1_instructionext" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_deerext" ] = { type = "get", get_obj = "spr_instructionext_deerext", room = "inv_complex_inv", zz = "inv_complex_instructionext", zz_gate = "inv_instructionext" };

private.get_deerext_logic = function()
 
end;
private.get_deerext_inv = function()
  interface.InventoryItemAdd("inv_deerext","spr_instructionext_deerext");
  if common_impl.ZzCompleteCheck("get_deerext") then interface.InventoryItemRemove("inv_instructionext") end;
end;
private.get_deerext_beg = function()
  ObjDelete("gfx_instructionext_deerext");
end;
private.get_deerext_end = function()
  
end;

cmn.AddSubscriber( "get_deerext", private.get_deerext_inv );
cmn.AddSubscriber( "get_deerext", private.get_deerext_beg );
cmn.AddSubscriber( "get_deerext", private.get_deerext_end );
cmn.AddSubscriber( "get_deerext", private.get_deerext_logic );
--------------------------------------------------------------------
function public.get_deerext()
  ObjSet( "spr_instructionext_deerext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "anm_inv_complex_instructionext_anm_use_acorn", { animfunc = "end_plasticine", frame = 0 } )
  cmn.SetEventDone( "get_deerext" );
  cmn.CallEventHandler( "get_deerext" );
  if common_impl.ZzCompleteCheck("get_deerext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_cinderellastaffext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_necklaceext" ] = { type = "use", inv_obj = "inv_necklaceext", use_place = "gfx_cinderellastaffext_necklaceext_zone", room = "inv_complex_inv", zz = "inv_complex_cinderellastaffext", zz_gate = "inv_cinderellastaffext" };

private.use_necklaceext_logic = function()
  if ld.CheckRequirements( {"use_necklaceext","use_crystalshoesext","use_tiaraext"} ) then
    ObjSet( "spr_cinderellastaffext_cinderellasetext", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_necklaceext_inv = function()
  common_impl.ProcessMultiUseAll("necklaceext", "necklaceext")
end;
private.use_necklaceext_beg = function()
  ObjDelete( "gfx_cinderellastaffext_necklaceext_zone" );
end;
private.use_necklaceext_end = function()
  if ld.CheckRequirements( {"use_necklaceext","use_crystalshoesext","use_tiaraext"} ) then
    ObjDelete("anm_cinderellastaffext_anm_use_necklace")
    ObjDelete("anm_cinderellastaffext_anm_use_shoes")
    ObjDelete("anm_cinderellastaffext_anm_idle_dress")
    ObjDelete("anm_cinderellastaffext_anm_use_diadem")
    
    ObjDelete("inv_cinderellastaffext_back")
    ObjDelete("inv_cinderellastaffext_tr1")
    ObjDelete("inv_cinderellastaffext_tr2")
    ObjDelete("inv_cinderellastaffext_tr3")
    ObjSet("inv_cinderellastaffext_tr4",{visible=1,active=1})
  else
    ObjSet("anm_cinderellastaffext_anm_use_necklace",{animfunc="use_necklace",frame=999})
    ObjSet("inv_cinderellastaffext_tr1",{visible=1,active=1})
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_necklaceext", private.use_necklaceext_inv );
cmn.AddSubscriber( "use_necklaceext", private.use_necklaceext_beg );
cmn.AddSubscriber( "use_necklaceext", private.use_necklaceext_end );
cmn.AddSubscriber( "use_necklaceext", private.use_necklaceext_logic );
cmn.AddSubscriber( "use_necklaceext_inv", private.use_necklaceext_inv );
cmn.AddSubscriber( "use_necklaceext_beg", private.use_necklaceext_beg );
cmn.AddSubscriber( "use_necklaceext_end", private.use_necklaceext_end );
cmn.AddSubscriber( "use_necklaceext_end", private.use_necklaceext_logic );
--------------------------------------------------------------------------------------------
function public.use_necklaceext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_necklaceext" );
    cmn.CallEventHandler( "use_necklaceext_end" );
    common_impl.Lock(0);
  end;
  
  local func_step = function()
    if ld.CheckRequirements( {"use_crystalshoesext","use_tiaraext"} ) then
      ObjDelete("anm_cinderellastaffext_anm_use_necklace")
      ObjDelete("anm_cinderellastaffext_anm_use_shoes")
      ObjDelete("anm_cinderellastaffext_anm_use_diadem")
      SoundSfx( "aud_xx_magic" )
      ld.AnimPlay( "anm_cinderellastaffext_anm_idle_dress", "cinderellasetext", func_end );
    else
      func_end();
    end
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_necklaceext_inv" );
  cmn.CallEventHandler( "use_necklaceext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_necklaceext_cinderellastaffext" )
  
  ld.AnimPlay( "anm_cinderellastaffext_anm_use_necklace", "use_necklace", func_step );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crystalshoesext" ] = { type = "use", inv_obj = "inv_crystalshoesext", use_place = "gfx_cinderellastaffext_crystalshoesext_zone", room = "inv_complex_inv", zz = "inv_complex_cinderellastaffext", zz_gate = "inv_cinderellastaffext" };

private.use_crystalshoesext_logic = function()
  if ld.CheckRequirements( {"use_crystalshoesext","use_necklaceext","use_tiaraext"} ) then
    ObjSet( "spr_cinderellastaffext_cinderellasetext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_crystalshoesext_inv = function()
  common_impl.ProcessMultiUseAll("crystalshoesext", "crystalshoesext")
end;
private.use_crystalshoesext_beg = function()
  ObjDelete( "gfx_cinderellastaffext_crystalshoesext_zone" );
end;
private.use_crystalshoesext_end = function()
  if ld.CheckRequirements( {"use_necklaceext","use_crystalshoesext","use_tiaraext"} ) then
    ObjDelete("anm_cinderellastaffext_anm_use_necklace")
    ObjDelete("anm_cinderellastaffext_anm_use_shoes")
    ObjDelete("anm_cinderellastaffext_anm_idle_dress")
    ObjDelete("anm_cinderellastaffext_anm_use_diadem")
    
    ObjDelete("inv_cinderellastaffext_back")
    ObjDelete("inv_cinderellastaffext_tr1")
    ObjDelete("inv_cinderellastaffext_tr2")
    ObjDelete("inv_cinderellastaffext_tr3")
    ObjSet("inv_cinderellastaffext_tr4",{visible=1,active=1})
  else
    ObjSet("anm_cinderellastaffext_anm_use_shoes",{animfunc="use_shoes",frame=999})
    ObjSet("inv_cinderellastaffext_tr2",{visible=1,active=1})
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crystalshoesext", private.use_crystalshoesext_inv );
cmn.AddSubscriber( "use_crystalshoesext", private.use_crystalshoesext_beg );
cmn.AddSubscriber( "use_crystalshoesext", private.use_crystalshoesext_end );
cmn.AddSubscriber( "use_crystalshoesext", private.use_crystalshoesext_logic );
cmn.AddSubscriber( "use_crystalshoesext_inv", private.use_crystalshoesext_inv );
cmn.AddSubscriber( "use_crystalshoesext_beg", private.use_crystalshoesext_beg );
cmn.AddSubscriber( "use_crystalshoesext_end", private.use_crystalshoesext_end );
cmn.AddSubscriber( "use_crystalshoesext_end", private.use_crystalshoesext_logic );
--------------------------------------------------------------------------------------------
function public.use_crystalshoesext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crystalshoesext" );
    cmn.CallEventHandler( "use_crystalshoesext_end" );
    common_impl.Lock(0);
  end;
  
  local func_step = function()
    if ld.CheckRequirements( {"use_necklaceext","use_tiaraext"} ) then
      ObjDelete("anm_cinderellastaffext_anm_use_necklace")
      ObjDelete("anm_cinderellastaffext_anm_use_shoes")
      ObjDelete("anm_cinderellastaffext_anm_use_diadem")
      SoundSfx( "aud_xx_magic" )
      ld.AnimPlay( "anm_cinderellastaffext_anm_idle_dress", "cinderellasetext", func_end );
    else
      func_end();
    end
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crystalshoesext_inv" );
  cmn.CallEventHandler( "use_crystalshoesext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_necklaceext_cinderellastaffext" )
  
  ld.AnimPlay( "anm_cinderellastaffext_anm_use_shoes", "use_shoes", func_step );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_tiaraext" ] = { type = "use", inv_obj = "inv_tiaraext", use_place = "gfx_cinderellastaffext_tiaraext_zone", room = "inv_complex_inv", zz = "inv_complex_cinderellastaffext", zz_gate = "inv_cinderellastaffext" };

private.use_tiaraext_logic = function()
  if ld.CheckRequirements( {"use_tiaraext","use_necklaceext","use_crystalshoesext"} ) then
    ObjSet( "spr_cinderellastaffext_cinderellasetext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_tiaraext_inv = function()
  common_impl.ProcessMultiUseAll("tiaraext", "tiaraext")
end;
private.use_tiaraext_beg = function()
  ObjDelete( "gfx_cinderellastaffext_tiaraext_zone" );
end;
private.use_tiaraext_end = function()
  if ld.CheckRequirements( {"use_necklaceext","use_crystalshoesext","use_tiaraext"} ) then
    ObjDelete("anm_cinderellastaffext_anm_use_necklace")
    ObjDelete("anm_cinderellastaffext_anm_use_shoes")
    ObjDelete("anm_cinderellastaffext_anm_idle_dress")
    ObjDelete("anm_cinderellastaffext_anm_use_diadem")
    
    ObjDelete("inv_cinderellastaffext_back")
    ObjDelete("inv_cinderellastaffext_tr1")
    ObjDelete("inv_cinderellastaffext_tr2")
    ObjDelete("inv_cinderellastaffext_tr3")
    ObjSet("inv_cinderellastaffext_tr4",{visible=1,active=1})
  else
    ObjSet("anm_cinderellastaffext_anm_use_diadem",{animfunc="use_diadem",frame=999})
    ObjSet("inv_cinderellastaffext_tr3",{visible=1,active=1})
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tiaraext", private.use_tiaraext_inv );
cmn.AddSubscriber( "use_tiaraext", private.use_tiaraext_beg );
cmn.AddSubscriber( "use_tiaraext", private.use_tiaraext_end );
cmn.AddSubscriber( "use_tiaraext", private.use_tiaraext_logic );
cmn.AddSubscriber( "use_tiaraext_inv", private.use_tiaraext_inv );
cmn.AddSubscriber( "use_tiaraext_beg", private.use_tiaraext_beg );
cmn.AddSubscriber( "use_tiaraext_end", private.use_tiaraext_end );
cmn.AddSubscriber( "use_tiaraext_end", private.use_tiaraext_logic );
--------------------------------------------------------------------------------------------
function public.use_tiaraext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tiaraext" );
    cmn.CallEventHandler( "use_tiaraext_end" );
    common_impl.Lock(0);
  end;

  local func_step = function()
    if ld.CheckRequirements( {"use_necklaceext","use_crystalshoesext"} ) then
      ObjDelete("anm_cinderellastaffext_anm_use_necklace")
      ObjDelete("anm_cinderellastaffext_anm_use_shoes")
      ObjDelete("anm_cinderellastaffext_anm_use_diadem")
      SoundSfx( "aud_xx_magic" )
      ld.AnimPlay( "anm_cinderellastaffext_anm_idle_dress", "cinderellasetext", func_end );
    else
      func_end();
    end
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tiaraext_inv" );
  cmn.CallEventHandler( "use_tiaraext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_necklaceext_cinderellastaffext" )
  
  ld.AnimPlay( "anm_cinderellastaffext_anm_use_diadem", "use_diadem", func_step );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cinderellasetext" ] = { type = "get", get_obj = "spr_cinderellastaffext_cinderellasetext", room = "inv_complex_inv", zz = "inv_complex_cinderellastaffext", zz_gate = "inv_cinderellastaffext" };

private.get_cinderellasetext_logic = function()
 
end;
private.get_cinderellasetext_inv = function()
  interface.InventoryItemAdd("inv_cinderellasetext","spr_cinderellastaffext_cinderellasetext");
  if common_impl.ZzCompleteCheck("get_cinderellasetext") then interface.InventoryItemRemove("inv_cinderellastaffext") end;
end;
private.get_cinderellasetext_beg = function()
  ObjDelete("gfx_cinderellastaffext_cinderellasetext");
end;
private.get_cinderellasetext_end = function()
  
end;

cmn.AddSubscriber( "get_cinderellasetext", private.get_cinderellasetext_inv );
cmn.AddSubscriber( "get_cinderellasetext", private.get_cinderellasetext_beg );
cmn.AddSubscriber( "get_cinderellasetext", private.get_cinderellasetext_end );
cmn.AddSubscriber( "get_cinderellasetext", private.get_cinderellasetext_logic );
--------------------------------------------------------------------
function public.get_cinderellasetext()
  cmn.SetEventDone( "get_cinderellasetext" );
  cmn.CallEventHandler( "get_cinderellasetext" );
  if common_impl.ZzCompleteCheck("get_cinderellasetext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_cinderellabagext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_cinderellabagext" ] = { type = "click", use_place = "gfx_cinderellabagext_clk_cinderellabagext_zone", room = "inv_complex_inv", zz = "inv_complex_cinderellabagext", zz_gate = "inv_cinderellabagext" };

private.clk_cinderellabagext_logic = function()
  ObjSet( "spr_cinderellabagext_medalionpawext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_cinderellabagext_beg = function()
  ObjDelete( "gfx_cinderellabagext_clk_cinderellabagext_zone" );
end;
private.clk_cinderellabagext_end = function()
  ObjSet("spr_cinderellabagext_tr",{visible=1})
  ObjSet("anm_cinderellabagext_anm",{animfunc="open_bag",frame=999})
  --ObjSet( "spr_cinderellabagext_invitationext", { visible = 1, active = 1 } )
  ObjSet("inv_cinderellabagext_back",{visible=0})
  ObjSet("inv_cinderellabagext_2",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_cinderellabagext", private.clk_cinderellabagext_beg );
cmn.AddSubscriber( "clk_cinderellabagext", private.clk_cinderellabagext_end );
cmn.AddSubscriber( "clk_cinderellabagext", private.clk_cinderellabagext_logic );
cmn.AddSubscriber( "clk_cinderellabagext_beg", private.clk_cinderellabagext_beg );
cmn.AddSubscriber( "clk_cinderellabagext_end", private.clk_cinderellabagext_end );
cmn.AddSubscriber( "clk_cinderellabagext_end", private.clk_cinderellabagext_logic );
--------------------------------------------------------------------------------------------
function public.clk_cinderellabagext()

  local func_end = function()
    cmn.SetEventDone( "clk_cinderellabagext" );
    cmn.CallEventHandler( "clk_cinderellabagext_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_cinderellabagext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cinderellabagext_anm", "open_bag", func_end );
  SoundSfx( "aud_clk_cinderellabagext_cinderellabagext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------




--------------------------------------------------------------------
common_impl.hint[ "get_medalionpawext" ] = { type = "get", get_obj = "spr_cinderellabagext_medalionpawext", room = "inv_complex_inv", zz = "inv_complex_cinderellabagext", zz_gate = "inv_cinderellabagext" };

private.get_medalionpawext_logic = function()
 ObjSet( "gfx_cinderellabagext_clk_invitationext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_medalionpawext_inv = function()
  interface.InventoryItemAdd("inv_medalionpawext","spr_cinderellabagext_medalionpawext");
  if common_impl.ZzCompleteCheck("get_medalionpawext") then interface.InventoryItemRemove("inv_cinderellabagext") end;
end;
private.get_medalionpawext_beg = function()
  ObjDelete("gfx_cinderellabagext_medalionpawext");
end;
private.get_medalionpawext_end = function()
  ObjSet("anm_cinderellabagext_anm",{animfunc="end_medalion"})
  ObjSet("spr_cinderellabagext_tr",{visible=0})
  
  ObjSet("inv_cinderellabagext_2",{visible=0})
  ObjSet("inv_cinderellabagext_3",{visible=1})
end;

cmn.AddSubscriber( "get_medalionpawext", private.get_medalionpawext_inv );
cmn.AddSubscriber( "get_medalionpawext", private.get_medalionpawext_beg );
cmn.AddSubscriber( "get_medalionpawext", private.get_medalionpawext_end );
cmn.AddSubscriber( "get_medalionpawext", private.get_medalionpawext_logic );
--------------------------------------------------------------------
function public.get_medalionpawext()
  cmn.SetEventDone( "get_medalionpawext" );
  cmn.CallEventHandler( "get_medalionpawext" );
  if common_impl.ZzCompleteCheck("get_medalionpawext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------





--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_invitationext" ] = { type = "click", use_place = "gfx_cinderellabagext_clk_invitationext_zone", room = "inv_complex_inv", zz = "inv_complex_cinderellabagext", zz_gate = "inv_cinderellabagext" };

private.clk_invitationext_logic = function()

end;
private.clk_invitationext_beg = function()
  ObjDelete( "gfx_cinderellabagext_clk_invitationext_zone" );
end;
private.clk_invitationext_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_invitationext", private.clk_invitationext_beg );
cmn.AddSubscriber( "clk_invitationext", private.clk_invitationext_end );
cmn.AddSubscriber( "clk_invitationext", private.clk_invitationext_logic );
cmn.AddSubscriber( "clk_invitationext_beg", private.clk_invitationext_beg );
cmn.AddSubscriber( "clk_invitationext_end", private.clk_invitationext_end );
cmn.AddSubscriber( "clk_invitationext_end", private.clk_invitationext_logic );
--------------------------------------------------------------------------------------------
function public.clk_invitationext()

  --local func_end = function()
  --  cmn.SetEventDone( "clk_invitationext" );
  --  cmn.CallEventHandler( "clk_invitationext_end" );
  --  common_impl.Lock(0);
  --end;

  local func_end = function()
    ObjSet("spr_cinderellabagext_invitationext",{visible=1,input=1,active=1,alp=1})
    ObjSet("anm_cinderellabagext_anm",{animfunc = "paper_closed",frame=999})
    common_impl.Lock(0);
  end

  cmn.CallEventHandler( "clk_invitationext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cinderellabagext_anm", "paper_open", func_end );
  SoundSfx( "aud_paperzoom_in" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_invitationext" ] = { type = "get", get_obj = "spr_cinderellabagext_invitationext", room = "inv_complex_inv", zz = "inv_complex_cinderellabagext", zz_gate = "inv_cinderellabagext" };

private.get_invitationext_logic = function()
  ObjSet( "spr_cinderellabagext_screwext1", { visible = 1, input = 1, active = 1 } )
end;
private.get_invitationext_inv = function()
  interface.InventoryItemAdd("inv_invitationext","spr_cinderellabagext_invitationext");
  if common_impl.ZzCompleteCheck("get_invitationext") then interface.InventoryItemRemove("inv_cinderellabagext") end;
end;
private.get_invitationext_beg = function()
  ObjDelete("gfx_cinderellabagext_invitationext");
end;
private.get_invitationext_end = function()
  ObjSet("anm_cinderellabagext_anm",{animfunc="paper_closed",frame=999})
  ObjSet("inv_cinderellabagext_3",{visible=0})
  ObjSet("inv_cinderellabagext_4",{visible=1})
end;

cmn.AddSubscriber( "get_invitationext", private.get_invitationext_inv );
cmn.AddSubscriber( "get_invitationext", private.get_invitationext_beg );
cmn.AddSubscriber( "get_invitationext", private.get_invitationext_end );
cmn.AddSubscriber( "get_invitationext", private.get_invitationext_logic );
--------------------------------------------------------------------
function public.get_invitationext()
  
  cmn.SetEventDone( "clk_invitationext" );
  cmn.CallEventHandler( "clk_invitationext_end" );
  
  cmn.SetEventDone( "get_invitationext" );
  cmn.CallEventHandler( "get_invitationext" );
  if common_impl.ZzCompleteCheck("get_invitationext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------





--------------------------------------------------------------------
common_impl.hint[ "get_screwext1" ] = { type = "get", get_obj = "spr_cinderellabagext_screwext1", room = "inv_complex_inv", zz = "inv_complex_cinderellabagext", zz_gate = "inv_cinderellabagext" };

private.get_screwext1_logic = function()
 
end;
private.get_screwext1_inv = function()
  interface.InventoryItemAdd("inv_screwext","spr_cinderellabagext_screwext1",function() level_inv.ProcessGetScrewextAll( "get_screwext1" ) end);
  if common_impl.ZzCompleteCheck("get_screwext1") then interface.InventoryItemRemove("inv_cinderellabagext") end;
end;
private.get_screwext1_beg = function()
  ObjDelete("gfx_cinderellabagext_screwext1");
end;
private.get_screwext1_end = function()
  ObjSet("anm_cinderellabagext_anm",{animfunc="end_bag1"})
end;

cmn.AddSubscriber( "get_screwext1", private.get_screwext1_inv );
cmn.AddSubscriber( "get_screwext1", private.get_screwext1_beg );
cmn.AddSubscriber( "get_screwext1", private.get_screwext1_end );
cmn.AddSubscriber( "get_screwext1", private.get_screwext1_logic );
--------------------------------------------------------------------
function public.get_screwext1()
  cmn.SetEventDone( "get_screwext1" );
  cmn.CallEventHandler( "get_screwext1" );
  if common_impl.ZzCompleteCheck("get_screwext1") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_tangleext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fairyext_tangleext" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_tangleext_fairyext_tangleext_zone", room = "inv_complex_inv", zz = "inv_complex_tangleext", zz_gate = "inv_tangleext" };

private.use_fairyext_tangleext_logic = function()
  ObjSet( "spr_tangleext_fairyclewext", { visible = 1, input = 1, active = 1 } )
  int_simon.SimonSetVisible(0)
end;
private.use_fairyext_tangleext_inv = function()
  common_impl.ProcessMultiUseAll("fairyext", "fairyext_tangleext")
end;
private.use_fairyext_tangleext_beg = function()
  ObjDelete( "gfx_tangleext_fairyext_tangleext_zone" );
end;
private.use_fairyext_tangleext_end = function()
  ObjDelete("anm_tangleext_anm")
  ObjSet("inv_tangleext_tr1",{visible=1})
  ObjSet("inv_tangleext_back",{visible=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fairyext_tangleext", private.use_fairyext_tangleext_inv );
cmn.AddSubscriber( "use_fairyext_tangleext", private.use_fairyext_tangleext_beg );
cmn.AddSubscriber( "use_fairyext_tangleext", private.use_fairyext_tangleext_end );
cmn.AddSubscriber( "use_fairyext_tangleext", private.use_fairyext_tangleext_logic );
cmn.AddSubscriber( "use_fairyext_tangleext_inv", private.use_fairyext_tangleext_inv );
cmn.AddSubscriber( "use_fairyext_tangleext_beg", private.use_fairyext_tangleext_beg );
cmn.AddSubscriber( "use_fairyext_tangleext_end", private.use_fairyext_tangleext_end );
cmn.AddSubscriber( "use_fairyext_tangleext_end", private.use_fairyext_tangleext_logic );
--------------------------------------------------------------------------------------------
function public.use_fairyext_tangleext( obj )

  local func_end = function()
    ObjDelete("vid_tangleext_vid_fairy_get_clew_69")
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fairyext_tangleext" );
    cmn.CallEventHandler( "use_fairyext_tangleext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fairyext_tangleext_inv" );
  cmn.CallEventHandler( "use_fairyext_tangleext_beg" );
  common_impl.Lock(1);
    
  local func_step_1 = function()
    SoundSfx( "aud_fairy_get_clew_69" );
    VidPlay("vid_tangleext_vid_fairy_get_clew_69",func_end)
  end
  
  local func_step_0 = function()
    local t = 0.5;
    ObjAnimate("anm_tangleext_anm", 8, 0, 0, _, {0,0,1, t,0,0});
    ObjAttach("vid_tangleext_vid_fairy_get_clew_69","inv_complex_tangleext");
    ObjAnimate("vid_tangleext_vid_fairy_get_clew_69", 8, 0, 0, _, {0,0,0, t,0,1});
    ld.StartTimer(t,func_step_1);
  end
  
  interface.SimonJump( func_step_0 )
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fairyclewext" ] = { type = "get", get_obj = "spr_tangleext_fairyclewext", room = "inv_complex_inv", zz = "inv_complex_tangleext", zz_gate = "inv_tangleext" };

private.get_fairyclewext_logic = function()
 
end;
private.get_fairyclewext_inv = function()
  interface.InventoryItemAdd("inv_fairyclewext","spr_tangleext_fairyclewext");
  if common_impl.ZzCompleteCheck("get_fairyclewext") then interface.InventoryItemRemove("inv_tangleext") end;
end;
private.get_fairyclewext_beg = function()
  ObjDelete("gfx_tangleext_fairyclewext");
end;
private.get_fairyclewext_end = function()
  
end;

cmn.AddSubscriber( "get_fairyclewext", private.get_fairyclewext_inv );
cmn.AddSubscriber( "get_fairyclewext", private.get_fairyclewext_beg );
cmn.AddSubscriber( "get_fairyclewext", private.get_fairyclewext_end );
cmn.AddSubscriber( "get_fairyclewext", private.get_fairyclewext_logic );
--------------------------------------------------------------------
function public.get_fairyclewext()
  cmn.SetEventDone( "get_fairyclewext" );
  cmn.CallEventHandler( "get_fairyclewext" );
  if common_impl.ZzCompleteCheck("get_fairyclewext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_jarext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_jacrclick" ] = { type = "click", use_place = "gfx_jarext_clk_jacrclick_zone", room = "inv_complex_inv", zz = "inv_complex_jarext", zz_gate = "inv_jarext" };

private.clk_jacrclick_logic = function()
  ObjSet("gfx_jarext_valerianext_zone",{visible=1,active=1,input=1})
end;
private.clk_jacrclick_beg = function()
  ObjDelete( "gfx_jarext_clk_jacrclick_zone" );
end;
private.clk_jacrclick_end = function()
  ObjSet("anm_jarext_anm",{animfunc="use_flask",frame=999})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_jacrclick", private.clk_jacrclick_beg );
cmn.AddSubscriber( "clk_jacrclick", private.clk_jacrclick_end );
cmn.AddSubscriber( "clk_jacrclick", private.clk_jacrclick_logic );
cmn.AddSubscriber( "clk_jacrclick_beg", private.clk_jacrclick_beg );
cmn.AddSubscriber( "clk_jacrclick_end", private.clk_jacrclick_end );
cmn.AddSubscriber( "clk_jacrclick_end", private.clk_jacrclick_logic );
--------------------------------------------------------------------------------------------
function public.clk_jacrclick()

  local func_end = function()
    cmn.SetEventDone( "clk_jacrclick" );
    cmn.CallEventHandler( "clk_jacrclick_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_jacrclick_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_jarext_anm", "use_flask", func_end );
  SoundSfx( "aud_clk_jar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_valerianext" ] = { type = "use", inv_obj = "inv_valerianext", use_place = "gfx_jarext_valerianext_zone", room = "inv_complex_inv", zz = "inv_complex_jarext", zz_gate = "inv_jarext" };

private.use_valerianext_logic = function()
  ObjSet( "spr_jarext_valerianjarext", { visible = 1, input = 1, active = 1 } )

end;
private.use_valerianext_inv = function()
  common_impl.ProcessMultiUseAll("valerianext", "valerianext")
end;
private.use_valerianext_beg = function()
  ObjDelete( "gfx_jarext_valerianext_zone" );
end;
private.use_valerianext_end = function()
  ObjDelete("anm_jarext_anm")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_valerianext", private.use_valerianext_inv );
cmn.AddSubscriber( "use_valerianext", private.use_valerianext_beg );
cmn.AddSubscriber( "use_valerianext", private.use_valerianext_end );
cmn.AddSubscriber( "use_valerianext", private.use_valerianext_logic );
cmn.AddSubscriber( "use_valerianext_inv", private.use_valerianext_inv );
cmn.AddSubscriber( "use_valerianext_beg", private.use_valerianext_beg );
cmn.AddSubscriber( "use_valerianext_end", private.use_valerianext_end );
cmn.AddSubscriber( "use_valerianext_end", private.use_valerianext_logic );
--------------------------------------------------------------------------------------------
function public.use_valerianext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_valerianext" );
    cmn.CallEventHandler( "use_valerianext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_valerianext_inv" );
  cmn.CallEventHandler( "use_valerianext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_valerianext_jarext" )
  
  ld.AnimPlay( "anm_jarext_anm", "use_valerian", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_valerianjarext" ] = { type = "get", get_obj = "spr_jarext_valerianjarext", room = "inv_complex_inv", zz = "inv_complex_jarext", zz_gate = "inv_jarext" };

private.get_valerianjarext_logic = function()
 
end;
private.get_valerianjarext_inv = function()
  interface.InventoryItemAdd("inv_valerianjarext","spr_jarext_valerianjarext");
  if common_impl.ZzCompleteCheck("get_valerianjarext") then interface.InventoryItemRemove("inv_jarext") end;
end;
private.get_valerianjarext_beg = function()
  ObjDelete("gfx_jarext_valerianjarext");
end;
private.get_valerianjarext_end = function()
  
end;

cmn.AddSubscriber( "get_valerianjarext", private.get_valerianjarext_inv );
cmn.AddSubscriber( "get_valerianjarext", private.get_valerianjarext_beg );
cmn.AddSubscriber( "get_valerianjarext", private.get_valerianjarext_end );
cmn.AddSubscriber( "get_valerianjarext", private.get_valerianjarext_logic );
--------------------------------------------------------------------
function public.get_valerianjarext()
  cmn.SetEventDone( "get_valerianjarext" );
  cmn.CallEventHandler( "get_valerianjarext" );
  if common_impl.ZzCompleteCheck("get_valerianjarext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_maskext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_maskext1" ] = { type = "click", use_place = "gfx_maskext_clk_maskext1_zone", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.clk_maskext1_logic = function()
  ObjSet( "gfx_maskext_ribbonext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_maskext1_beg = function()
  ObjDelete( "gfx_maskext_clk_maskext1_zone" );
end;
private.clk_maskext1_end = function()
  ObjSet("anm_maskext_anm",{animfunc="click_mask",frame=999})
  
  ObjSet("inv_maskext_back",{visible=0})
  ObjSet("inv_maskext_tr_2",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_maskext1", private.clk_maskext1_beg );
cmn.AddSubscriber( "clk_maskext1", private.clk_maskext1_end );
cmn.AddSubscriber( "clk_maskext1", private.clk_maskext1_logic );
cmn.AddSubscriber( "clk_maskext1_beg", private.clk_maskext1_beg );
cmn.AddSubscriber( "clk_maskext1_end", private.clk_maskext1_end );
cmn.AddSubscriber( "clk_maskext1_end", private.clk_maskext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_maskext1()

  local func_end = function()
    cmn.SetEventDone( "clk_maskext1" );
    cmn.CallEventHandler( "clk_maskext1_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_maskext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_maskext_anm", "click_mask", func_end );
  SoundSfx( "aud_clk_maskext1_maskext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ribbonext" ] = { type = "use", inv_obj = "inv_ribbonext", use_place = "gfx_maskext_ribbonext_zone", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.use_ribbonext_logic = function()
  ObjSet( "gfx_maskext_hairstickext_maskext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_ribbonext_inv = function()
  common_impl.ProcessMultiUseAll("ribbonext", "ribbonext")
end;
private.use_ribbonext_beg = function()
  ObjDelete( "gfx_maskext_ribbonext_zone" );
end;
private.use_ribbonext_end = function()
  ObjSet("anm_maskext_anm",{animfunc="use_tape",frame=999})
  ObjSet("inv_maskext_tr_2",{visible=0})
  ObjSet("inv_maskext_tr_3",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ribbonext", private.use_ribbonext_inv );
cmn.AddSubscriber( "use_ribbonext", private.use_ribbonext_beg );
cmn.AddSubscriber( "use_ribbonext", private.use_ribbonext_end );
cmn.AddSubscriber( "use_ribbonext", private.use_ribbonext_logic );
cmn.AddSubscriber( "use_ribbonext_inv", private.use_ribbonext_inv );
cmn.AddSubscriber( "use_ribbonext_beg", private.use_ribbonext_beg );
cmn.AddSubscriber( "use_ribbonext_end", private.use_ribbonext_end );
cmn.AddSubscriber( "use_ribbonext_end", private.use_ribbonext_logic );
--------------------------------------------------------------------------------------------
function public.use_ribbonext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ribbonext" );
    cmn.CallEventHandler( "use_ribbonext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ribbonext_inv" );
  cmn.CallEventHandler( "use_ribbonext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_ribbonext_maskext" )
  
  ld.AnimPlay( "anm_maskext_anm", "use_tape", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hairstickext_maskext" ] = { type = "use", inv_obj = "inv_hairstickext", use_place = "gfx_maskext_hairstickext_maskext_zone", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.use_hairstickext_maskext_logic = function()
  
  ObjSet( "gfx_maskext_clk_maskext2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_hairstickext_maskext_inv = function()
  common_impl.ProcessMultiUseAll("hairstickext", "hairstickext_maskext")
end;
private.use_hairstickext_maskext_beg = function()
  ObjDelete( "gfx_maskext_hairstickext_maskext_zone" );
end;
private.use_hairstickext_maskext_end = function()
  ObjSet("anm_maskext_anm",{animfunc="use_flower",frame=999})
  
  ObjSet("inv_maskext_tr_3",{visible=0})
  ObjSet("inv_maskext_tr_4",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hairstickext_maskext", private.use_hairstickext_maskext_inv );
cmn.AddSubscriber( "use_hairstickext_maskext", private.use_hairstickext_maskext_beg );
cmn.AddSubscriber( "use_hairstickext_maskext", private.use_hairstickext_maskext_end );
cmn.AddSubscriber( "use_hairstickext_maskext", private.use_hairstickext_maskext_logic );
cmn.AddSubscriber( "use_hairstickext_maskext_inv", private.use_hairstickext_maskext_inv );
cmn.AddSubscriber( "use_hairstickext_maskext_beg", private.use_hairstickext_maskext_beg );
cmn.AddSubscriber( "use_hairstickext_maskext_end", private.use_hairstickext_maskext_end );
cmn.AddSubscriber( "use_hairstickext_maskext_end", private.use_hairstickext_maskext_logic );
--------------------------------------------------------------------------------------------
function public.use_hairstickext_maskext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hairstickext_maskext" );
    cmn.CallEventHandler( "use_hairstickext_maskext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hairstickext_maskext_inv" );
  cmn.CallEventHandler( "use_hairstickext_maskext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_hairstickext_maskext" )
  
  ld.AnimPlay( "anm_maskext_anm", "use_flower", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pearlflowerext" ] = { type = "get", get_obj = "spr_maskext_pearlflowerext", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.get_pearlflowerext_logic = function()
 
end;
private.get_pearlflowerext_inv = function()
  interface.InventoryItemAdd("inv_pearlflowerext","spr_maskext_pearlflowerext");
  if common_impl.ZzCompleteCheck("get_pearlflowerext") then interface.InventoryItemRemove("inv_maskext") end;
end;
private.get_pearlflowerext_beg = function()
  ObjDelete("gfx_maskext_pearlflowerext");
end;
private.get_pearlflowerext_end = function()
  ObjSet("inv_maskext_tr_5",{visible=0})
  ObjSet("inv_maskext_tr_6",{visible=1})
end;

cmn.AddSubscriber( "get_pearlflowerext", private.get_pearlflowerext_inv );
cmn.AddSubscriber( "get_pearlflowerext", private.get_pearlflowerext_beg );
cmn.AddSubscriber( "get_pearlflowerext", private.get_pearlflowerext_end );
cmn.AddSubscriber( "get_pearlflowerext", private.get_pearlflowerext_logic );
--------------------------------------------------------------------
function public.get_pearlflowerext()
  cmn.SetEventDone( "get_pearlflowerext" );
  cmn.CallEventHandler( "get_pearlflowerext" );
  if common_impl.ZzCompleteCheck("get_pearlflowerext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_maskext2" ] = { type = "click", use_place = "gfx_maskext_clk_maskext2_zone", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.clk_maskext2_logic = function()
  ObjSet( "gfx_maskext_clk_maskext3_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_maskext_pearlflowerext", { visible = 1, input = 1, active = 1 } )
end;
private.clk_maskext2_beg = function()
  ObjDelete( "gfx_maskext_clk_maskext2_zone" );
end;
private.clk_maskext2_end = function()
  ObjSet("anm_maskext_anm",{animfunc="end_click_flower",frame=999})
  ObjSet("inv_maskext_tr_4",{visible=0})
  ObjSet("inv_maskext_tr_5",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_maskext2", private.clk_maskext2_beg );
cmn.AddSubscriber( "clk_maskext2", private.clk_maskext2_end );
cmn.AddSubscriber( "clk_maskext2", private.clk_maskext2_logic );
cmn.AddSubscriber( "clk_maskext2_beg", private.clk_maskext2_beg );
cmn.AddSubscriber( "clk_maskext2_end", private.clk_maskext2_end );
cmn.AddSubscriber( "clk_maskext2_end", private.clk_maskext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_maskext2()

  local func_end = function()
    cmn.SetEventDone( "clk_maskext2" );
    cmn.CallEventHandler( "clk_maskext2_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_maskext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_maskext_anm", "click_flower1", func_end );
  SoundSfx( "aud_clk_maskext2_maskext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_maskext3" ] = { type = "click", use_place = "gfx_maskext_clk_maskext3_zone", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.clk_maskext3_logic = function()
  ObjSet( "gfx_maskext_clk_maskext4_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_maskext3_beg = function()
  ObjDelete( "gfx_maskext_clk_maskext3_zone" );
end;
private.clk_maskext3_end = function()
  ObjSet("anm_maskext_anm",{frame=999,animfunc="click_hook1"})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_maskext3", private.clk_maskext3_beg );
cmn.AddSubscriber( "clk_maskext3", private.clk_maskext3_end );
cmn.AddSubscriber( "clk_maskext3", private.clk_maskext3_logic );
cmn.AddSubscriber( "clk_maskext3_beg", private.clk_maskext3_beg );
cmn.AddSubscriber( "clk_maskext3_end", private.clk_maskext3_end );
cmn.AddSubscriber( "clk_maskext3_end", private.clk_maskext3_logic );
--------------------------------------------------------------------------------------------
function public.clk_maskext3()

  local func_end = function()
    cmn.SetEventDone( "clk_maskext3" );
    cmn.CallEventHandler( "clk_maskext3_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_maskext3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_maskext_anm", "click_hook1", func_end );
  SoundSfx( "aud_clk_maskext2_maskext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_maskext4" ] = { type = "click", use_place = "gfx_maskext_clk_maskext4_zone", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.clk_maskext4_logic = function()
  ObjSet( "gfx_maskext_clk_maskext5_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_maskext4_beg = function()
  ObjDelete( "gfx_maskext_clk_maskext4_zone" );
end;
private.clk_maskext4_end = function()
  ObjSet("anm_maskext_anm",{frame=999,animfunc="click_hook2"})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_maskext4", private.clk_maskext4_beg );
cmn.AddSubscriber( "clk_maskext4", private.clk_maskext4_end );
cmn.AddSubscriber( "clk_maskext4", private.clk_maskext4_logic );
cmn.AddSubscriber( "clk_maskext4_beg", private.clk_maskext4_beg );
cmn.AddSubscriber( "clk_maskext4_end", private.clk_maskext4_end );
cmn.AddSubscriber( "clk_maskext4_end", private.clk_maskext4_logic );
--------------------------------------------------------------------------------------------
function public.clk_maskext4()

  local func_end = function()
    cmn.SetEventDone( "clk_maskext4" );
    cmn.CallEventHandler( "clk_maskext4_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_maskext4_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_maskext_anm", "click_hook2", func_end );
  SoundSfx( "aud_clk_maskext2_maskext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_maskext5" ] = { type = "click", use_place = "gfx_maskext_clk_maskext5_zone", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.clk_maskext5_logic = function()
  ObjSet( "spr_maskext_fishingrodext", { visible = 1, input = 1, active = 1 } )

end;
private.clk_maskext5_beg = function()
  ObjDelete( "gfx_maskext_clk_maskext5_zone" );
end;
private.clk_maskext5_end = function()
  --ObjSet("anm_maskext_anm",{frame=999,animfunc="click_hook3"})
  ObjDelete("anm_maskext_anm")  
  ObjSet("inv_maskext_tr_6",{visible=0})
  ObjSet("inv_maskext_tr_7",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_maskext5", private.clk_maskext5_beg );
cmn.AddSubscriber( "clk_maskext5", private.clk_maskext5_end );
cmn.AddSubscriber( "clk_maskext5", private.clk_maskext5_logic );
cmn.AddSubscriber( "clk_maskext5_beg", private.clk_maskext5_beg );
cmn.AddSubscriber( "clk_maskext5_end", private.clk_maskext5_end );
cmn.AddSubscriber( "clk_maskext5_end", private.clk_maskext5_logic );
--------------------------------------------------------------------------------------------
function public.clk_maskext5()

  local func_end = function()
    cmn.SetEventDone( "clk_maskext5" );
    cmn.CallEventHandler( "clk_maskext5_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_maskext5_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_maskext_anm", "click_hook3", function() ld.AnimPlay("anm_maskext_anm","use_hook",func_end); end);
  SoundSfx( "aud_clk_maskext5_maskext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fishingrodext" ] = { type = "get", get_obj = "spr_maskext_fishingrodext", room = "inv_complex_inv", zz = "inv_complex_maskext", zz_gate = "inv_maskext" };

private.get_fishingrodext_logic = function()
 
end;
private.get_fishingrodext_inv = function()
  interface.InventoryItemAdd("inv_fishingrodext","spr_maskext_fishingrodext");
  if common_impl.ZzCompleteCheck("get_fishingrodext") then interface.InventoryItemRemove("inv_maskext") end;
end;
private.get_fishingrodext_beg = function()
  ObjDelete("gfx_maskext_fishingrodext");
end;
private.get_fishingrodext_end = function()
  
end;

cmn.AddSubscriber( "get_fishingrodext", private.get_fishingrodext_inv );
cmn.AddSubscriber( "get_fishingrodext", private.get_fishingrodext_beg );
cmn.AddSubscriber( "get_fishingrodext", private.get_fishingrodext_end );
cmn.AddSubscriber( "get_fishingrodext", private.get_fishingrodext_logic );
--------------------------------------------------------------------
function public.get_fishingrodext()
  cmn.SetEventDone( "get_fishingrodext" );
  cmn.CallEventHandler( "get_fishingrodext" );
  if common_impl.ZzCompleteCheck("get_fishingrodext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_brokenshacksawext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_sawhandleext" ] = { type = "use", inv_obj = "inv_sawhandleext", use_place = "gfx_brokenshacksawext_sawhandleext_zone", room = "inv_complex_inv", zz = "inv_complex_brokenshacksawext", zz_gate = "inv_brokenshacksawext" };

private.use_sawhandleext_logic = function()
  if ld.CheckRequirements( {"use_sawhandleext","use_toysmithsext"} ) then
    ObjSet( "spr_brokenshacksawext_sawext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.use_sawhandleext_inv = function()
  common_impl.ProcessMultiUseAll("sawhandleext", "sawhandleext")
end;
private.use_sawhandleext_beg = function()
  ObjDelete( "gfx_brokenshacksawext_sawhandleext_zone" );
end;
private.use_sawhandleext_end = function()
  if ld.CheckRequirements( {"use_sawhandleext","use_toysmithsext"} ) then
    ObjDelete("anm_brokenshacksawext_anm")
    ObjDelete("anm_brokenshacksawext_anm_use_handle")
    
    ObjSet("inv_brokenshacksawext_back",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_2",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_3",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_4",{visible=1})
    
  else
    ObjSet("anm_brokenshacksawext_anm_use_handle",{frame=999,animfunc="use_handle"})
    
    ObjSet("inv_brokenshacksawext_back",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_2",{visible=1})
    ObjSet("inv_brokenshacksawext_tr_3",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_4",{visible=0})
  end
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sawhandleext", private.use_sawhandleext_inv );
cmn.AddSubscriber( "use_sawhandleext", private.use_sawhandleext_beg );
cmn.AddSubscriber( "use_sawhandleext", private.use_sawhandleext_end );
cmn.AddSubscriber( "use_sawhandleext", private.use_sawhandleext_logic );
cmn.AddSubscriber( "use_sawhandleext_inv", private.use_sawhandleext_inv );
cmn.AddSubscriber( "use_sawhandleext_beg", private.use_sawhandleext_beg );
cmn.AddSubscriber( "use_sawhandleext_end", private.use_sawhandleext_end );
cmn.AddSubscriber( "use_sawhandleext_end", private.use_sawhandleext_logic );
--------------------------------------------------------------------------------------------
function public.use_sawhandleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sawhandleext" );
    cmn.CallEventHandler( "use_sawhandleext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sawhandleext_inv" );
  cmn.CallEventHandler( "use_sawhandleext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_sawhandleext_brokenshacksawext" )
  
  ld.AnimPlay( "anm_brokenshacksawext_anm_use_handle", "use_handle", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_toysmithsext" ] = { type = "use", inv_obj = "inv_toysmithsext", use_place = "gfx_brokenshacksawext_toysmithsext_zone", room = "inv_complex_inv", zz = "inv_complex_brokenshacksawext", zz_gate = "inv_brokenshacksawext" };

private.use_toysmithsext_logic = function()
  if ld.CheckRequirements( {"use_sawhandleext","use_toysmithsext"} ) then
    ObjSet( "spr_brokenshacksawext_sawext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.use_toysmithsext_inv = function()
  common_impl.ProcessMultiUseAll("toysmithsext", "toysmithsext")
end;
private.use_toysmithsext_beg = function()
  ObjDelete( "gfx_brokenshacksawext_toysmithsext_zone" );
end;
private.use_toysmithsext_end = function()
  --ObjSet("anm_brokenshacksawext_anm",{frame=999,animfunc="use_plaything"})
  --ObjSet("anm_brokenshacksawext_anm_use_handle",{frame=999,animfunc="use_plaything"})
  if ld.CheckRequirements( {"use_sawhandleext","use_toysmithsext"} ) then
    ObjDelete("anm_brokenshacksawext_anm")
    ObjDelete("anm_brokenshacksawext_anm_use_handle")
    
    ObjSet("inv_brokenshacksawext_back",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_2",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_3",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_4",{visible=1})
    
  else
    ObjSet("anm_brokenshacksawext_anm",{frame=999,animfunc="use_plaything"})
    
    ObjSet("inv_brokenshacksawext_back",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_2",{visible=0})
    ObjSet("inv_brokenshacksawext_tr_3",{visible=1})
    ObjSet("inv_brokenshacksawext_tr_4",{visible=0})
    
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_toysmithsext", private.use_toysmithsext_inv );
cmn.AddSubscriber( "use_toysmithsext", private.use_toysmithsext_beg );
cmn.AddSubscriber( "use_toysmithsext", private.use_toysmithsext_end );
cmn.AddSubscriber( "use_toysmithsext", private.use_toysmithsext_logic );
cmn.AddSubscriber( "use_toysmithsext_inv", private.use_toysmithsext_inv );
cmn.AddSubscriber( "use_toysmithsext_beg", private.use_toysmithsext_beg );
cmn.AddSubscriber( "use_toysmithsext_end", private.use_toysmithsext_end );
cmn.AddSubscriber( "use_toysmithsext_end", private.use_toysmithsext_logic );
--------------------------------------------------------------------------------------------
function public.use_toysmithsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_toysmithsext" );
    cmn.CallEventHandler( "use_toysmithsext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_toysmithsext_inv" );
  cmn.CallEventHandler( "use_toysmithsext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_toysmithsext_brokenshacksawext" )
  
  ld.AnimPlay( "anm_brokenshacksawext_anm", "use_plaything", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sawext" ] = { type = "get", get_obj = "spr_brokenshacksawext_sawext", room = "inv_complex_inv", zz = "inv_complex_brokenshacksawext", zz_gate = "inv_brokenshacksawext" };

private.get_sawext_logic = function()
 
end;
private.get_sawext_inv = function()
  interface.InventoryItemAdd("inv_sawext","spr_brokenshacksawext_sawext");
  if common_impl.ZzCompleteCheck("get_sawext") then interface.InventoryItemRemove("inv_brokenshacksawext") end;
end;
private.get_sawext_beg = function()
  ObjDelete("gfx_brokenshacksawext_sawext");
end;
private.get_sawext_end = function()
  
end;

cmn.AddSubscriber( "get_sawext", private.get_sawext_inv );
cmn.AddSubscriber( "get_sawext", private.get_sawext_beg );
cmn.AddSubscriber( "get_sawext", private.get_sawext_end );
cmn.AddSubscriber( "get_sawext", private.get_sawext_logic );
--------------------------------------------------------------------
function public.get_sawext()
  cmn.SetEventDone( "get_sawext" );
  cmn.CallEventHandler( "get_sawext" );
  if common_impl.ZzCompleteCheck("get_sawext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ inv_complex_unloadedcrossbowext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fishinglineext" ] = { type = "use", inv_obj = "inv_fishinglineext", use_place = "gfx_unloadedcrossbowext_fishinglineext_zone", room = "inv_complex_inv", zz = "inv_complex_unloadedcrossbowext", zz_gate = "inv_unloadedcrossbowext" };

private.use_fishinglineext_logic = function()
  --if ld.CheckRequirements( {"use_fishinglineext","use_quiverext"} ) then
    ObjSet( "gfx_unloadedcrossbowext_quiverext_zone", { visible = 1, input = 1, active = 1 } )
  --end;

end;
private.use_fishinglineext_inv = function()
  common_impl.ProcessMultiUseAll("fishinglineext", "fishinglineext")
end;
private.use_fishinglineext_beg = function()
  ObjDelete( "gfx_unloadedcrossbowext_fishinglineext_zone" );
end;
private.use_fishinglineext_end = function()
  ObjSet("anm_unloadedcrossbowext_anm",{frame=999,animfunc="use_fishingline1"})
  ObjSet("inv_unloadedcrossbowext_tr_1",{visible=1})
  ObjSet("inv_unloadedcrossbowext_back",{visible=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fishinglineext", private.use_fishinglineext_inv );
cmn.AddSubscriber( "use_fishinglineext", private.use_fishinglineext_beg );
cmn.AddSubscriber( "use_fishinglineext", private.use_fishinglineext_end );
cmn.AddSubscriber( "use_fishinglineext", private.use_fishinglineext_logic );
cmn.AddSubscriber( "use_fishinglineext_inv", private.use_fishinglineext_inv );
cmn.AddSubscriber( "use_fishinglineext_beg", private.use_fishinglineext_beg );
cmn.AddSubscriber( "use_fishinglineext_end", private.use_fishinglineext_end );
cmn.AddSubscriber( "use_fishinglineext_end", private.use_fishinglineext_logic );
--------------------------------------------------------------------------------------------
function public.use_fishinglineext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fishinglineext" );
    cmn.CallEventHandler( "use_fishinglineext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fishinglineext_inv" );
  cmn.CallEventHandler( "use_fishinglineext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_fishinglineext_unloadedcrossbowext" )
  
  ld.AnimPlay( "anm_unloadedcrossbowext_anm", "use_fishingline1", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_quiverext" ] = { type = "use", inv_obj = "inv_quiverext", use_place = "gfx_unloadedcrossbowext_quiverext_zone", room = "inv_complex_inv", zz = "inv_complex_unloadedcrossbowext", zz_gate = "inv_unloadedcrossbowext" };

private.use_quiverext_logic = function()
  --if ld.CheckRequirements( {"use_quiverext","use_fishinglineext"} ) then
    --ObjSet( "spr_unloadedcrossbowext_crossbowext", { visible = 1, input = 1, active = 1 } )
  --end;
  ObjSet("anm_unloadedcrossbowext_anm",{input=1})
end;
private.use_quiverext_inv = function()
  common_impl.ProcessMultiUseAll("quiverext", "quiverext")
end;
private.use_quiverext_beg = function()
  ObjDelete( "gfx_unloadedcrossbowext_quiverext_zone" );
end;
private.use_quiverext_end = function()
  ObjSet("anm_unloadedcrossbowext_anm",{frame=999,animfunc="use_quiver"})
  ObjSet("gfx_unloadedcrossbowext_crossbowext",{active=1,visible=1})
  
  ObjSet("inv_unloadedcrossbowext_tr_2",{visible=1})
  ObjSet("inv_unloadedcrossbowext_tr_1",{visible=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_quiverext", private.use_quiverext_inv );
cmn.AddSubscriber( "use_quiverext", private.use_quiverext_beg );
cmn.AddSubscriber( "use_quiverext", private.use_quiverext_end );
cmn.AddSubscriber( "use_quiverext", private.use_quiverext_logic );
cmn.AddSubscriber( "use_quiverext_inv", private.use_quiverext_inv );
cmn.AddSubscriber( "use_quiverext_beg", private.use_quiverext_beg );
cmn.AddSubscriber( "use_quiverext_end", private.use_quiverext_end );
cmn.AddSubscriber( "use_quiverext_end", private.use_quiverext_logic );
--------------------------------------------------------------------------------------------
function public.use_quiverext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_quiverext" );
    cmn.CallEventHandler( "use_quiverext_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_quiverext_inv" );
  cmn.CallEventHandler( "use_quiverext_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_quiverext_unloadedcrossbowext" )
  
  ld.AnimPlay( "anm_unloadedcrossbowext_anm", "use_quiver", func_end );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_crossbowext" ] = { type = "get", get_obj = "anm_unloadedcrossbowext_anm", room = "inv_complex_inv", zz = "inv_complex_unloadedcrossbowext", zz_gate = "inv_unloadedcrossbowext" };

private.get_crossbowext_logic = function()
 
end;
private.get_crossbowext_inv = function()
  interface.InventoryItemAdd("inv_crossbowext","anm_unloadedcrossbowext_anm");
  if common_impl.ZzCompleteCheck("get_crossbowext") then interface.InventoryItemRemove("inv_unloadedcrossbowext") end;
end;
private.get_crossbowext_beg = function()
  ObjDelete("gfx_unloadedcrossbowext_crossbowext");
end;
private.get_crossbowext_end = function()
  
end;

cmn.AddSubscriber( "get_crossbowext", private.get_crossbowext_inv );
cmn.AddSubscriber( "get_crossbowext", private.get_crossbowext_beg );
cmn.AddSubscriber( "get_crossbowext", private.get_crossbowext_end );
cmn.AddSubscriber( "get_crossbowext", private.get_crossbowext_logic );
--------------------------------------------------------------------
function public.get_crossbowext()
  cmn.SetEventDone( "get_crossbowext" );
  cmn.CallEventHandler( "get_crossbowext" );
  if common_impl.ZzCompleteCheck("get_crossbowext") then common_impl.HideComplexItem() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
end;
function public.Reset()
  mg_name = interface.GetCurrentComplexInv()
end
function public.Skip()
  mg_name = interface.GetCurrentComplexInv()
end