-- name=rm_nearcastleext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearcastleext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  
  ld.NoteInit("spr_tentext_paper", "spr_tentext_paper_big", "txt_tentext_note" )
  ld.NoteRelaseLock( "spr_tentext_paper" )
  
  --------------------------------------------------------------------------------------------
  private.vid_list_1 = 
  {
    "vid_guardianext_vid_cat_guardian_1_statc_80",
    "vid_guardianext_vid_cat_guardian_2_static_121"
  }
  ld.VidStaticInit(
    private.vid_list_1,
    "zz_guardianext",            --owners
    false, --sounds
    false,                    --{t_min,t_max}, default = {0,0} 
    nil,      --run after that progress event
    {"use_valerianjarext"},        --stop after that progress event
    sfx_rnd,                  --sounds under all videos
    "obj_guardianext_vid_guardianext_root_1" --root holder
  );
  
  
  private.vid_list_2 = 
  {
    "vid_guardianext_vid_cat_guardian_sleep_static_85",
  }
  ld.VidStaticInit(
    private.vid_list_2,
    "zz_guardianext",            --owners
    false, --sounds
    false,                    --{t_min,t_max}, default = {0,0} 
    {"use_valerianjarext"},      --run after that progress event
    {"win_yardext"},        --stop after that progress event
    sfx_rnd,                  --sounds under all videos
    "obj_guardianext_vid_guardianext_root_2" --root holder
  );
  
  
  
  
  
  private.vid_list_3 = 
  {
    "vid_nearcastleext_vid_cat_guardian_static2_124",
    "vid_nearcastleext_vid_cat_guardian_static1_79"
  }
  ld.VidStaticInit(
    private.vid_list_3,
    "rm_nearcastleext",            --owners
    false, --sounds
    false,                    --{t_min,t_max}, default = {0,0} 
    nil,      --run after that progress event
    {"use_valerianjarext"},        --stop after that progress event
    sfx_rnd,                  --sounds under all videos
    "obj_nearcastleext_tentext_vid_guardianext_root_1" --root holder
  );
  
  private.vid_list_4 = 
  {
    "vid_nearcastleext_vid_cat_guardian_sleep_static_85",
  }
  ld.VidStaticInit(
    private.vid_list_4,
    "rm_nearcastleext",            --owners
    false, --sounds
    false,                    --{t_min,t_max}, default = {0,0} 
    {"use_valerianjarext"},      --run after that progress event
    nil,        --stop after that progress event
    sfx_rnd,                  --sounds under all videos
    "obj_nearcastleext_tentext_vid_guardianext_root_2" --root holder
  );
  
  
  

  private.vid_list_5 = 
  {
    "vid_nearcastleext_vid_cinderella_static_89",
  }
  ld.VidStaticInit(
    private.vid_list_5,
    "rm_nearcastleext",            --owners
    false, --sounds
    {2,3},                    --{t_min,t_max}, default = {0,0} 
    nil,      --run after that progress event
    {"win_yardext"},        --stop after that progress event
    sfx_rnd,                  --sounds under all videos
    "obj_nearcastleext_vid_cinderella_root_5" --root holder cmn.IsEventDone( "win_yardext" )
  );
  
  --------------------------------------------------------------------------------------------
  function private.opn_nearcastleext()
    if not ( cmn.IsEventDone( "opn_nearcastleext" ) ) then
      local func_end = function()
          cmn.SetEventDone( "opn_nearcastleext" );
          cmn.CallEventHandler( "opn_nearcastleext" )
          ld.ShowBbtOpn( private.room_objname )
      end;
      func_end()
    end;

  end;
--------------------------------------------------------------------
local opn_nearcastleext = function() end;
local opn_nearcastleext_logic = function() end;
cmn.AddSubscriber( "opn_nearcastleext", opn_nearcastleext_logic )
cmn.AddSubscriber( "opn_nearcastleext", opn_nearcastleext, private.room_objname )
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_guardianext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.GuardianIdle()
  
  local vid = "vid_guardianext_vid_cat_guardian_no_way_66"
  
  local func_end = function()
    ld.VidStaticPlay( private.vid_list_1 );
    if not ld.CheckRequirements( {"use_invitationext"} ) then
      common_impl.ShowBbt( 'need_invitationext' )
    elseif not ld.CheckRequirements( {"use_valerianjarext"} ) then
      common_impl.ShowBbt( 'need_valerianjarext' )
    end    
    ObjDetach(vid);
    ld.Lock(0);
  end
  
  ld.Lock(1);
  
  ld.VidStaticDetach( private.vid_list_1 );
  
  SoundSfx( "aud_xx_guard_cat" )
  ObjAttach(vid,"zz_guardianext");
  VidPlay(vid,func_end);
  
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_invitationext" ] = { type = "use", inv_obj = "inv_invitationext", use_place = "gfx_guardianext_invitationext_zone", room = "rm_nearcastleext", zz = "zz_guardianext", zz_gate = "gzz_nearcastleext_guardianext" };

private.use_invitationext_logic = function()
  ObjSet( "spr_guardianext_jarext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_guardianext_valerianjarext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_invitationext_inv = function()
  common_impl.ProcessMultiUseAll("invitationext", "invitationext")
end;
private.use_invitationext_beg = function()
  ObjDelete( "gfx_guardianext_invitationext_zone" );
end;
private.use_invitationext_end = function()
  if common_impl.ZzCompleteCheck("use_invitationext") then ObjSet( common_impl.hint["use_invitationext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("spr_guardianext_jarext_shadow",{alp=1,visible=1,active=1})
  ObjSet("spr_nearcastleext_tr_jarext",{visible=1,active=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_invitationext", private.use_invitationext_inv );
cmn.AddSubscriber( "use_invitationext", private.use_invitationext_beg, private.room_objname );
cmn.AddSubscriber( "use_invitationext", private.use_invitationext_end, private.room_objname );
cmn.AddSubscriber( "use_invitationext", private.use_invitationext_logic );
cmn.AddSubscriber( "use_invitationext_inv", private.use_invitationext_inv, private.room_objname );
cmn.AddSubscriber( "use_invitationext_beg", private.use_invitationext_beg, private.room_objname );
cmn.AddSubscriber( "use_invitationext_end", private.use_invitationext_end, private.room_objname );
cmn.AddSubscriber( "use_invitationext_end", private.use_invitationext_logic );
--------------------------------------------------------------------------------------------
function public.use_invitationext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_invitationext" );
    cmn.CallEventHandler( "use_invitationext_end" );
    
    ld.VidStaticPlay( private.vid_list_1 );
    ObjDetach("vid_guardianext_vid_cat_guardian_fail_pass_130")
    
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_invitationext") then ld.CloseSubRoom() end;
    
    common_impl.ShowBbt( 'guardianext_invitation' )
    
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_invitationext_inv" );
  cmn.CallEventHandler( "use_invitationext_beg" );
  common_impl.Lock(1);

  
  
  ld.VidStaticDetach(private.vid_list_1);
  ObjAttach("vid_guardianext_vid_cat_guardian_fail_pass_130","zz_guardianext");
  VidPlay("vid_guardianext_vid_cat_guardian_fail_pass_130",func_end)
  
  
  
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_invitationext_nearcastleext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_jarext" ] = { type = "get", get_obj = "spr_guardianext_jarext", room = "rm_nearcastleext", zz = "zz_guardianext", zz_gate = "gzz_nearcastleext_guardianext" };

private.get_jarext_logic = function()
  
end;
private.get_jarext_inv = function()
  interface.InventoryItemAdd("inv_jarext","spr_guardianext_jarext");
  ObjSet( "inv_jarext", { drag = 0 } );
end;
private.get_jarext_beg = function()
  ObjDelete("gfx_guardianext_jarext")
end;
private.get_jarext_end = function()
  if common_impl.ZzCompleteCheck("get_jarext") then ObjSet( common_impl.hint["get_jarext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_guardianext_jarext_shadow")
  ObjDelete("spr_nearcastleext_tr_jarext")
end;

cmn.AddSubscriber( "get_jarext", private.get_jarext_inv );
cmn.AddSubscriber( "get_jarext", private.get_jarext_beg, private.room_objname );
cmn.AddSubscriber( "get_jarext", private.get_jarext_end, private.room_objname );
cmn.AddSubscriber( "get_jarext", private.get_jarext_logic );
--------------------------------------------------------------------
function public.get_jarext()
  cmn.SetEventDone( "get_jarext" );
  cmn.CallEventHandler( "get_jarext" );
  if common_impl.ZzCompleteCheck("get_jarext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_valerianjarext" ] = { type = "use", inv_obj = "inv_valerianjarext", use_place = "gfx_guardianext_valerianjarext_zone", room = "rm_nearcastleext", zz = "zz_guardianext", zz_gate = "gzz_nearcastleext_guardianext" };

private.use_valerianjarext_logic = function()
  ObjSet( "spr_guardianext_unloadedcrossbowext", { visible = 1, input = 1, active = 1 } )
  

end;
private.use_valerianjarext_inv = function()
  common_impl.ProcessMultiUseAll("valerianjarext", "valerianjarext")
end;
private.use_valerianjarext_beg = function()
  ObjDelete( "gfx_guardianext_valerianjarext_zone" );
end;
private.use_valerianjarext_end = function()
  if common_impl.ZzCompleteCheck("use_valerianjarext") then ObjSet( common_impl.hint["use_valerianjarext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("gfx_guardianext_unloadedcrossbowext",{visible=1,active=1})
  ObjSet( "gfx_guardianext_clk_guardiankeyext_zone", { visible = 1, active = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_valerianjarext", private.use_valerianjarext_inv );
cmn.AddSubscriber( "use_valerianjarext", private.use_valerianjarext_beg, private.room_objname );
cmn.AddSubscriber( "use_valerianjarext", private.use_valerianjarext_end, private.room_objname );
cmn.AddSubscriber( "use_valerianjarext", private.use_valerianjarext_logic );
cmn.AddSubscriber( "use_valerianjarext_inv", private.use_valerianjarext_inv, private.room_objname );
cmn.AddSubscriber( "use_valerianjarext_beg", private.use_valerianjarext_beg, private.room_objname );
cmn.AddSubscriber( "use_valerianjarext_end", private.use_valerianjarext_end, private.room_objname );
cmn.AddSubscriber( "use_valerianjarext_end", private.use_valerianjarext_logic );
--------------------------------------------------------------------------------------------
function public.use_valerianjarext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_valerianjarext" );
    cmn.CallEventHandler( "use_valerianjarext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_valerianjarext") then ld.CloseSubRoom() end;
    
    ld.VidStaticDetach( private.vid_list_3 );
    ld.VidStaticPlay( private.vid_list_4 );
    
    
    ld.VidStaticPlay( private.vid_list_2 );
    ObjDetach("vid_guardianext_vid_cat_guardian_drink_250")
    
    common_impl.ShowBbt( 'guardianext_valerianjar' )
    
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_valerianjarext_inv" );
  cmn.CallEventHandler( "use_valerianjarext_beg" );
  common_impl.Lock(1);

  
  ld.VidStaticDetach(private.vid_list_1);
  ObjAttach("vid_guardianext_vid_cat_guardian_drink_250","zz_guardianext");
  VidPlay("vid_guardianext_vid_cat_guardian_drink_250",func_end)
  
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_valerianjarext_nearcastleext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------























--------------------------------------------------------------------
common_impl.hint[ "get_unloadedcrossbowext" ] = { type = "get", get_obj = "spr_guardianext_unloadedcrossbowext", room = "rm_nearcastleext", zz = "zz_guardianext", zz_gate = "gzz_nearcastleext_guardianext" };

private.get_unloadedcrossbowext_logic = function()
  ObjSet( "gfx_guardianext_clk_guardiankeyext_zone", { visible = 1,input=1, active = 1 } )
end;
private.get_unloadedcrossbowext_inv = function()
  interface.InventoryItemAdd("inv_unloadedcrossbowext","spr_guardianext_unloadedcrossbowext");
  ObjSet( "inv_unloadedcrossbowext", { drag = 0 } );
end;
private.get_unloadedcrossbowext_beg = function()
  ObjDelete("gfx_guardianext_unloadedcrossbowext")
end;
private.get_unloadedcrossbowext_end = function()
  if common_impl.ZzCompleteCheck("get_unloadedcrossbowext") then ObjSet( common_impl.hint["get_unloadedcrossbowext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_guardianext_unloadedcrossbowext_sh")
  ObjDelete("spr_nearcastleext_tr_unloadedcrossbowext")
end;

cmn.AddSubscriber( "get_unloadedcrossbowext", private.get_unloadedcrossbowext_inv );
cmn.AddSubscriber( "get_unloadedcrossbowext", private.get_unloadedcrossbowext_beg, private.room_objname );
cmn.AddSubscriber( "get_unloadedcrossbowext", private.get_unloadedcrossbowext_end, private.room_objname );
cmn.AddSubscriber( "get_unloadedcrossbowext", private.get_unloadedcrossbowext_logic );
--------------------------------------------------------------------
function public.get_unloadedcrossbowext()
  cmn.SetEventDone( "get_unloadedcrossbowext" );
  cmn.CallEventHandler( "get_unloadedcrossbowext" );
  if common_impl.ZzCompleteCheck("get_unloadedcrossbowext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_guardiankeyext" ] = { type = "click", use_place = "gfx_guardianext_clk_guardiankeyext_zone", room = "rm_nearcastleext", zz = "zz_guardianext", zz_gate = "gzz_nearcastleext_guardianext" };

private.clk_guardiankeyext_logic = function()
  ObjSet( "gmg_nearcastleext_yardext", { visible = 1, input = 1, active = 1 } );
end;
private.clk_guardiankeyext_beg = function()
  ObjDelete( "gfx_guardianext_clk_guardiankeyext_zone" );
end;
private.clk_guardiankeyext_end = function()
  if common_impl.ZzCompleteCheck("clk_guardiankeyext") then ObjSet( common_impl.hint["clk_guardiankeyext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("spr_nearcastleext_tr_opendoor",{alp=1,visible=1,active=1});
  ObjSet("vid_nearcastleext_vid_cat_guardian_sleep_static_85",{pos_x=507,pos_y=496});
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_guardiankeyext", private.clk_guardiankeyext_beg, private.room_objname );
cmn.AddSubscriber( "clk_guardiankeyext", private.clk_guardiankeyext_end, private.room_objname );
cmn.AddSubscriber( "clk_guardiankeyext", private.clk_guardiankeyext_logic );
cmn.AddSubscriber( "clk_guardiankeyext_beg", private.clk_guardiankeyext_beg, private.room_objname );
cmn.AddSubscriber( "clk_guardiankeyext_end", private.clk_guardiankeyext_end, private.room_objname );
cmn.AddSubscriber( "clk_guardiankeyext_end", private.clk_guardiankeyext_logic );
--------------------------------------------------------------------------------------------
function public.clk_guardiankeyext()

  local func_end = function()
    cmn.SetEventDone( "clk_guardiankeyext" );
    cmn.CallEventHandler( "clk_guardiankeyext_end" );
    --common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("clk_guardiankeyext") then ld.CloseSubRoom() end;
    
    common_impl.Gate_MDown( "gmg_nearcastleext_yardext" );
    
    ld.StartTimer(0.5,function() common_impl.Lock(0); end)
    
  end;
    
  local func_step = function()
    ObjAnimate("spr_nearcastleext_tr_opendoor", 8,0,0, func_end, {0,0,0, 0.5,0,1});
  end  

  cmn.CallEventHandler( "clk_guardiankeyext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_guardiankeyext_nearcastleext" )
  
  --func_end()
  ObjSet("vid_nearcastleext_vid_cat_guardian_sleep_static_85",{pos_x=507,pos_y=496});
  
  ld.CloseSubRoom()
  ld.StartTimer(0.5,func_step);
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tentext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_toysmithsext" ] = { type = "get", get_obj = "spr_tentext_toysmithsext", room = "rm_nearcastleext", zz = "zz_tentext", zz_gate = "gzz_nearcastleext_tentext" };

private.get_toysmithsext_logic = function()
  
end;
private.get_toysmithsext_inv = function()
  interface.InventoryItemAdd("inv_toysmithsext","spr_tentext_toysmithsext");
end;
private.get_toysmithsext_beg = function()
  ObjDelete("gfx_tentext_toysmithsext")
end;
private.get_toysmithsext_end = function()
  if common_impl.ZzCompleteCheck("get_toysmithsext") then ObjSet( common_impl.hint["get_toysmithsext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tentext_toysmithsext_shadow")
  ObjDelete("spr_nearcastleext_tr_toysmithsext")
end;

cmn.AddSubscriber( "get_toysmithsext", private.get_toysmithsext_inv );
cmn.AddSubscriber( "get_toysmithsext", private.get_toysmithsext_beg, private.room_objname );
cmn.AddSubscriber( "get_toysmithsext", private.get_toysmithsext_end, private.room_objname );
cmn.AddSubscriber( "get_toysmithsext", private.get_toysmithsext_logic );
--------------------------------------------------------------------
function public.get_toysmithsext()
  cmn.SetEventDone( "get_toysmithsext" );
  cmn.CallEventHandler( "get_toysmithsext" );
  if common_impl.ZzCompleteCheck("get_toysmithsext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_coinext" ] = { type = "use", inv_obj = "inv_coinext", use_place = "gfx_tentext_coinext_zone", room = "rm_nearcastleext", zz = "zz_tentext", zz_gate = "gzz_nearcastleext_tentext" };

private.use_coinext_logic = function()
  --ObjSet( "spr_tentext_valerianext", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "gfx_tentext_crossbowext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_tentext_clk_coinext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_coinext_inv = function()
  common_impl.ProcessMultiUseAll("coinext", "coinext")
end;
private.use_coinext_beg = function()
  ObjDelete( "gfx_tentext_coinext_zone" );
end;
private.use_coinext_end = function()
  if common_impl.ZzCompleteCheck("use_coinext") then ObjSet( common_impl.hint["use_coinext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_coinext", private.use_coinext_inv );
cmn.AddSubscriber( "use_coinext", private.use_coinext_beg, private.room_objname );
cmn.AddSubscriber( "use_coinext", private.use_coinext_end, private.room_objname );
cmn.AddSubscriber( "use_coinext", private.use_coinext_logic );
cmn.AddSubscriber( "use_coinext_inv", private.use_coinext_inv, private.room_objname );
cmn.AddSubscriber( "use_coinext_beg", private.use_coinext_beg, private.room_objname );
cmn.AddSubscriber( "use_coinext_end", private.use_coinext_end, private.room_objname );
cmn.AddSubscriber( "use_coinext_end", private.use_coinext_logic );
--------------------------------------------------------------------------------------------
function public.use_coinext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_coinext" );
    cmn.CallEventHandler( "use_coinext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_coinext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_coinext_inv" );
  cmn.CallEventHandler( "use_coinext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tentext_anim", "anim_coin1", func_end );
  SoundSfx( "aud_use_coinext_nearcastleext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_coinext" ] = { type = "click", use_place = "gfx_tentext_clk_coinext_zone", room = "rm_nearcastleext", zz = "zz_tentext", zz_gate = "gzz_nearcastleext_tentext" };

private.clk_coinext_logic = function()
  ObjSet( "spr_tentext_valerianext", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "gfx_tentext_crossbowext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.clk_coinext_beg = function()
  ObjDelete( "gfx_tentext_clk_coinext_zone" );
end;
private.clk_coinext_end = function()
  if common_impl.ZzCompleteCheck("clk_coinext") then ObjSet( common_impl.hint["clk_coinext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_tentext_anim",{animfunc="anim_coin_openbox_end",frame=999})
  ObjSet( "spr_tentext_valerianext_shadow", {visible = 1,input = 1,active = 1} )
  ObjSet("spr_nearcastleext_tr_openbox",{alp=1,visible=1})
  ObjSet("spr_nearcastleext_tr_valerianext",{alp=1,visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_coinext", private.clk_coinext_beg, private.room_objname );
cmn.AddSubscriber( "clk_coinext", private.clk_coinext_end, private.room_objname );
cmn.AddSubscriber( "clk_coinext", private.clk_coinext_logic );
cmn.AddSubscriber( "clk_coinext_beg", private.clk_coinext_beg, private.room_objname );
cmn.AddSubscriber( "clk_coinext_end", private.clk_coinext_end, private.room_objname );
cmn.AddSubscriber( "clk_coinext_end", private.clk_coinext_logic );
--------------------------------------------------------------------------------------------
function public.clk_coinext()

  local func_end = function()
    cmn.SetEventDone( "clk_coinext" );
    cmn.CallEventHandler( "clk_coinext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_coinext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_coinext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tentext_anim", "anim_coin_openbox", func_end );
  SoundSfx( "aud_clk_open_phonetable_box" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_valerianext" ] = { type = "get", get_obj = "spr_tentext_valerianext", room = "rm_nearcastleext", zz = "zz_tentext", zz_gate = "gzz_nearcastleext_tentext" };

private.get_valerianext_logic = function()
  
end;
private.get_valerianext_inv = function()
  interface.InventoryItemAdd("inv_valerianext","spr_tentext_valerianext");
end;
private.get_valerianext_beg = function()
  ObjDelete("gfx_tentext_valerianext")
end;
private.get_valerianext_end = function()
  if common_impl.ZzCompleteCheck("get_valerianext") then ObjSet( common_impl.hint["get_valerianext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tentext_valerianext_shadow")
  ObjDelete("spr_nearcastleext_tr_valerianext")
end;

cmn.AddSubscriber( "get_valerianext", private.get_valerianext_inv );
cmn.AddSubscriber( "get_valerianext", private.get_valerianext_beg, private.room_objname );
cmn.AddSubscriber( "get_valerianext", private.get_valerianext_end, private.room_objname );
cmn.AddSubscriber( "get_valerianext", private.get_valerianext_logic );
--------------------------------------------------------------------
function public.get_valerianext()
  cmn.SetEventDone( "get_valerianext" );
  cmn.CallEventHandler( "get_valerianext" );
  if common_impl.ZzCompleteCheck("get_valerianext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crossbowext" ] = { type = "use", inv_obj = "inv_crossbowext", use_place = "gfx_tentext_crossbowext_zone", room = "rm_nearcastleext", zz = "zz_tentext", zz_gate = "gzz_nearcastleext_tentext" };

private.use_crossbowext_logic = function()
  ObjSet( "gho_nearcastleext_prizesext", { visible = 1, input = 1, active = 1 } )

end;
private.use_crossbowext_inv = function()
  common_impl.ProcessMultiUseAll("crossbowext", "crossbowext")
end;
private.use_crossbowext_beg = function()
  ObjDelete( "gfx_tentext_crossbowext_zone" );
end;
private.use_crossbowext_end = function()
  if common_impl.ZzCompleteCheck("use_crossbowext") then ObjSet( common_impl.hint["use_crossbowext"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjSet("anm_tentext_anim_ho",{playing=true})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crossbowext", private.use_crossbowext_inv );
cmn.AddSubscriber( "use_crossbowext", private.use_crossbowext_beg, private.room_objname );
cmn.AddSubscriber( "use_crossbowext", private.use_crossbowext_end, private.room_objname );
cmn.AddSubscriber( "use_crossbowext", private.use_crossbowext_logic );
cmn.AddSubscriber( "use_crossbowext_inv", private.use_crossbowext_inv, private.room_objname );
cmn.AddSubscriber( "use_crossbowext_beg", private.use_crossbowext_beg, private.room_objname );
cmn.AddSubscriber( "use_crossbowext_end", private.use_crossbowext_end, private.room_objname );
cmn.AddSubscriber( "use_crossbowext_end", private.use_crossbowext_logic );
--------------------------------------------------------------------------------------------
function public.use_crossbowext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crossbowext" );
    cmn.CallEventHandler( "use_crossbowext_end" );
    --common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_crossbowext") then ld.CloseSubRoom() end;
    ld.CloseSubRoom();
    
    local func_end_2 = function()
      common_impl.Gate_MDown( "gho_nearcastleext_prizesext" )
      ld.StartTimer(0.5,function() common_impl.Lock(0); end)
    end
    
    ld.StartTimer(0.5,func_end_2)
    
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crossbowext_inv" );
  cmn.CallEventHandler( "use_crossbowext_beg" );
  common_impl.Lock(1);
  
  
  --ld.AnimPlay( "anm_tentext_anim_ho", "anim_ho", _ );
  SoundSfx( "aud_use_crossbowext_nearcastleext" )
  func_end()

  --ld.StartTimer(0.5,func_end);
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_icesculptureext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_coinext2" ] = { type = "get", get_obj = "spr_icesculptureext_coinext2", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.get_coinext2_logic = function()
  
end;
private.get_coinext2_inv = function()
  interface.InventoryItemAdd("inv_coinext","spr_icesculptureext_coinext2",function() level_inv.ProcessGetCoinextAll( "get_coinext2" ) end);
end;
private.get_coinext2_beg = function()
  ObjDelete("gfx_icesculptureext_coinext2")
end;
private.get_coinext2_end = function()
  if common_impl.ZzCompleteCheck("get_coinext2") then ObjSet( common_impl.hint["get_coinext2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_icesculptureext_coinext2_sh")
  ObjDelete("spr_nearcastleext_tr_coinext2")
end;

cmn.AddSubscriber( "get_coinext2", private.get_coinext2_inv );
cmn.AddSubscriber( "get_coinext2", private.get_coinext2_beg, private.room_objname );
cmn.AddSubscriber( "get_coinext2", private.get_coinext2_end, private.room_objname );
cmn.AddSubscriber( "get_coinext2", private.get_coinext2_logic );
--------------------------------------------------------------------
function public.get_coinext2()
  cmn.SetEventDone( "get_coinext2" );
  cmn.CallEventHandler( "get_coinext2" );
  if common_impl.ZzCompleteCheck("get_coinext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hairstickext_icesculptureext" ] = { type = "use", inv_obj = "inv_hairstickext", use_place = "gfx_icesculptureext_hairstickext_icesculptureext_zone", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.use_hairstickext_icesculptureext_logic = function()
  ObjSet( "spr_icesculptureext_coinext4", { visible = 1, input = 1, active = 1 } )

end;
private.use_hairstickext_icesculptureext_inv = function()
  common_impl.ProcessMultiUseAll("hairstickext", "hairstickext_icesculptureext")
end;
private.use_hairstickext_icesculptureext_beg = function()
  ObjDelete( "gfx_icesculptureext_hairstickext_icesculptureext_zone" );
end;
private.use_hairstickext_icesculptureext_end = function()
  if common_impl.ZzCompleteCheck("use_hairstickext_icesculptureext") then ObjSet( common_impl.hint["use_hairstickext_icesculptureext"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjSet("anm_icesculptureext_anim_use_stick",{animfunc="anim_use_stick",frame=999})
  ObjDelete("anm_icesculptureext_anim_use_stick");
  ObjSet("spr_nearcastleext_tr_coinext4",{visible=1,alp=1})
  ObjSet("inv_hairstickext_tr",{visible=1,active=1})
  ObjSet("inv_hairstickext_back",{visible=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hairstickext_icesculptureext", private.use_hairstickext_icesculptureext_inv );
cmn.AddSubscriber( "use_hairstickext_icesculptureext", private.use_hairstickext_icesculptureext_beg, private.room_objname );
cmn.AddSubscriber( "use_hairstickext_icesculptureext", private.use_hairstickext_icesculptureext_end, private.room_objname );
cmn.AddSubscriber( "use_hairstickext_icesculptureext", private.use_hairstickext_icesculptureext_logic );
cmn.AddSubscriber( "use_hairstickext_icesculptureext_inv", private.use_hairstickext_icesculptureext_inv, private.room_objname );
cmn.AddSubscriber( "use_hairstickext_icesculptureext_beg", private.use_hairstickext_icesculptureext_beg, private.room_objname );
cmn.AddSubscriber( "use_hairstickext_icesculptureext_end", private.use_hairstickext_icesculptureext_end, private.room_objname );
cmn.AddSubscriber( "use_hairstickext_icesculptureext_end", private.use_hairstickext_icesculptureext_logic );
--------------------------------------------------------------------------------------------
function public.use_hairstickext_icesculptureext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hairstickext_icesculptureext" );
    cmn.CallEventHandler( "use_hairstickext_icesculptureext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hairstickext_icesculptureext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hairstickext_icesculptureext_inv" );
  cmn.CallEventHandler( "use_hairstickext_icesculptureext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icesculptureext_anim_use_stick", "anim_use_stick", func_end );
  SoundSfx( "aud_use_hairstickext_icesculptureext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coinext4" ] = { type = "get", get_obj = "spr_icesculptureext_coinext4", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.get_coinext4_logic = function()
  
end;
private.get_coinext4_inv = function()
  interface.InventoryItemAdd("inv_coinext","spr_icesculptureext_coinext4",function() level_inv.ProcessGetCoinextAll( "get_coinext4" ) end);
end;
private.get_coinext4_beg = function()
  ObjDelete("gfx_icesculptureext_coinext4")
end;
private.get_coinext4_end = function()
  if common_impl.ZzCompleteCheck("get_coinext4") then ObjSet( common_impl.hint["get_coinext4"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_nearcastleext_tr_coinext4")
end;

cmn.AddSubscriber( "get_coinext4", private.get_coinext4_inv );
cmn.AddSubscriber( "get_coinext4", private.get_coinext4_beg, private.room_objname );
cmn.AddSubscriber( "get_coinext4", private.get_coinext4_end, private.room_objname );
cmn.AddSubscriber( "get_coinext4", private.get_coinext4_logic );
--------------------------------------------------------------------
function public.get_coinext4()
  cmn.SetEventDone( "get_coinext4" );
  cmn.CallEventHandler( "get_coinext4" );
  if common_impl.ZzCompleteCheck("get_coinext4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_rewardext" ] = { type = "use", inv_obj = "inv_rewardext", use_place = "gfx_icesculptureext_rewardext_zone", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.use_rewardext_logic = function()
  ObjSet( "spr_icesculptureext_sawhandleext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_icesculptureext_cupidext1", { visible = 1, input = 1, active = 1 } )

end;
private.use_rewardext_inv = function()
  common_impl.ProcessMultiUseAll("rewardext", "rewardext")
end;
private.use_rewardext_beg = function()
  ObjDelete( "gfx_icesculptureext_rewardext_zone" );
end;
private.use_rewardext_end = function()
  if common_impl.ZzCompleteCheck("use_rewardext") then ObjSet( common_impl.hint["use_rewardext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_icesculptureext_anim_use_medal",{frame=999,animfunc="anim_use_medal_end"});
  ObjDelete("spr_nearcastleext_paw1");
  ObjSet("spr_nearcastleext_paw2",{visible=1,alp=1});
  ObjSet("spr_nearcastleext_tr_reward",{visible=1,alp=1})
  
  ObjSet("spr_nearcastleext_tr_sawhandleext",{pos_y=442-5})
  ObjSet("spr_nearcastleext_tr_cupidext1",{pos_y=445-8,pos_x=332+5})
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rewardext", private.use_rewardext_inv );
cmn.AddSubscriber( "use_rewardext", private.use_rewardext_beg, private.room_objname );
cmn.AddSubscriber( "use_rewardext", private.use_rewardext_end, private.room_objname );
cmn.AddSubscriber( "use_rewardext", private.use_rewardext_logic );
cmn.AddSubscriber( "use_rewardext_inv", private.use_rewardext_inv, private.room_objname );
cmn.AddSubscriber( "use_rewardext_beg", private.use_rewardext_beg, private.room_objname );
cmn.AddSubscriber( "use_rewardext_end", private.use_rewardext_end, private.room_objname );
cmn.AddSubscriber( "use_rewardext_end", private.use_rewardext_logic );
--------------------------------------------------------------------------------------------
function public.use_rewardext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rewardext" );
    cmn.CallEventHandler( "use_rewardext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rewardext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rewardext_inv" );
  cmn.CallEventHandler( "use_rewardext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icesculptureext_anim_use_medal", "anim_use_medal", func_end );
  SoundSfx( "aud_use_rewardext_nearcastleext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sawhandleext" ] = { type = "get", get_obj = "spr_icesculptureext_sawhandleext", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.get_sawhandleext_logic = function()
  
end;
private.get_sawhandleext_inv = function()
  interface.InventoryItemAdd("inv_sawhandleext","spr_icesculptureext_sawhandleext");
end;
private.get_sawhandleext_beg = function()
  ObjDelete("gfx_icesculptureext_sawhandleext")
end;
private.get_sawhandleext_end = function()
  if common_impl.ZzCompleteCheck("get_sawhandleext") then ObjSet( common_impl.hint["get_sawhandleext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_nearcastleext_tr_sawhandleext")
end;

cmn.AddSubscriber( "get_sawhandleext", private.get_sawhandleext_inv );
cmn.AddSubscriber( "get_sawhandleext", private.get_sawhandleext_beg, private.room_objname );
cmn.AddSubscriber( "get_sawhandleext", private.get_sawhandleext_end, private.room_objname );
cmn.AddSubscriber( "get_sawhandleext", private.get_sawhandleext_logic );
--------------------------------------------------------------------
function public.get_sawhandleext()
  cmn.SetEventDone( "get_sawhandleext" );
  cmn.CallEventHandler( "get_sawhandleext" );
  if common_impl.ZzCompleteCheck("get_sawhandleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cupidext1" ] = { type = "get", get_obj = "spr_icesculptureext_cupidext1", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.get_cupidext1_logic = function()
  
end;
private.get_cupidext1_inv = function()
  interface.InventoryItemAdd("inv_cupidext1","spr_icesculptureext_cupidext1");
end;
private.get_cupidext1_beg = function()
  ObjDelete("gfx_icesculptureext_cupidext1")
end;
private.get_cupidext1_end = function()
  if common_impl.ZzCompleteCheck("get_cupidext1") then ObjSet( common_impl.hint["get_cupidext1"].zz_gate, { visible = 0, input = 0 } ); end;
  --ObjDelete("spr_nearcastleext_tr_cubeext1")
  ObjDelete("spr_nearcastleext_tr_cupidext1")
end;

cmn.AddSubscriber( "get_cupidext1", private.get_cupidext1_inv );
cmn.AddSubscriber( "get_cupidext1", private.get_cupidext1_beg, private.room_objname );
cmn.AddSubscriber( "get_cupidext1", private.get_cupidext1_end, private.room_objname );
cmn.AddSubscriber( "get_cupidext1", private.get_cupidext1_logic );
--------------------------------------------------------------------
function public.get_cupidext1()
  cmn.SetEventDone( "get_cupidext1" );
  cmn.CallEventHandler( "get_cupidext1" );
  if common_impl.ZzCompleteCheck("get_cupidext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crystalflowerext" ] = { type = "use", inv_obj = "inv_crystalflowerext", use_place = "gfx_icesculptureext_crystalflowerext_zone", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.use_crystalflowerext_logic = function()
  if ld.CheckRequirements( {"use_crystalflowerext","use_emeraldflowerext","use_pearlflowerext"} ) then
    ObjSet( "spr_icesculptureext_elfcatext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_icesculptureext_cubeext1", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_crystalflowerext_inv = function()
  common_impl.ProcessMultiUseAll("crystalflowerext", "crystalflowerext")
end;
private.use_crystalflowerext_beg = function()
  ObjDelete( "gfx_icesculptureext_crystalflowerext_zone" );
end;
private.use_crystalflowerext_end = function()
  if common_impl.ZzCompleteCheck("use_crystalflowerext") then ObjSet( common_impl.hint["use_crystalflowerext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_icesculptureext_anim_use_cristalflower",{frame=999})
  if ld.CheckRequirements( {"use_crystalflowerext","use_emeraldflowerext","use_pearlflowerext"} ) then
    ObjDelete("anm_icesculptureext_anim_open")
    ObjDelete("spr_nearcastleext_tr_plate")
    ObjSet("spr_icesculptureext_elfcatext_shadow",{visible=1,active=1})
  end
  ObjSet("spr_nearcastleext_tr_flower_3",{visible=1,alp=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crystalflowerext", private.use_crystalflowerext_inv );
cmn.AddSubscriber( "use_crystalflowerext", private.use_crystalflowerext_beg, private.room_objname );
cmn.AddSubscriber( "use_crystalflowerext", private.use_crystalflowerext_end, private.room_objname );
cmn.AddSubscriber( "use_crystalflowerext", private.use_crystalflowerext_logic );
cmn.AddSubscriber( "use_crystalflowerext_inv", private.use_crystalflowerext_inv, private.room_objname );
cmn.AddSubscriber( "use_crystalflowerext_beg", private.use_crystalflowerext_beg, private.room_objname );
cmn.AddSubscriber( "use_crystalflowerext_end", private.use_crystalflowerext_end, private.room_objname );
cmn.AddSubscriber( "use_crystalflowerext_end", private.use_crystalflowerext_logic );
--------------------------------------------------------------------------------------------
function public.use_crystalflowerext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crystalflowerext" );
    cmn.CallEventHandler( "use_crystalflowerext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_crystalflowerext") then ld.CloseSubRoom() end;
  end;
  
  local func_step = function()
    ObjSet("anm_icesculptureext_anim_use_cristalflower",{pos_z=30})
    if ld.CheckRequirements( {"use_emeraldflowerext","use_pearlflowerext"} ) then
      SoundSfx( "aud_open_small_hide" )
      ld.AnimPlay( "anm_icesculptureext_anim_open", "anim_open", func_end );
    else
      func_end();
    end
  end
    
 
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crystalflowerext_inv" );
  cmn.CallEventHandler( "use_crystalflowerext_beg" );
  common_impl.Lock(1);

  ObjSet("anm_icesculptureext_anim_use_cristalflower",{pos_z=33})
  ld.AnimPlay( "anm_icesculptureext_anim_use_cristalflower", "anim_use_cristalflower", func_step );
  SoundSfx( "aud_use_crystalflowerext_nearcastleext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_emeraldflowerext" ] = { type = "use", inv_obj = "inv_emeraldflowerext", use_place = "gfx_icesculptureext_emeraldflowerext_zone", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.use_emeraldflowerext_logic = function()
  if ld.CheckRequirements( {"use_emeraldflowerext","use_crystalflowerext","use_pearlflowerext"} ) then
    ObjSet( "spr_icesculptureext_elfcatext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_icesculptureext_cubeext1", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_emeraldflowerext_inv = function()
  common_impl.ProcessMultiUseAll("emeraldflowerext", "emeraldflowerext")
end;
private.use_emeraldflowerext_beg = function()
  ObjDelete( "gfx_icesculptureext_emeraldflowerext_zone" );
end;
private.use_emeraldflowerext_end = function()
  if common_impl.ZzCompleteCheck("use_emeraldflowerext") then ObjSet( common_impl.hint["use_emeraldflowerext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_icesculptureext_anim_use_emaralflower",{frame=999})
  if ld.CheckRequirements( {"use_crystalflowerext","use_emeraldflowerext","use_pearlflowerext"} ) then
    ObjDelete("anm_icesculptureext_anim_open")
    ObjSet("spr_icesculptureext_elfcatext_shadow",{visible=1,active=1})
    ObjDelete("spr_nearcastleext_tr_plate")
  end
  ObjSet("spr_nearcastleext_tr_flower_2",{visible=1,alp=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_emeraldflowerext", private.use_emeraldflowerext_inv );
cmn.AddSubscriber( "use_emeraldflowerext", private.use_emeraldflowerext_beg, private.room_objname );
cmn.AddSubscriber( "use_emeraldflowerext", private.use_emeraldflowerext_end, private.room_objname );
cmn.AddSubscriber( "use_emeraldflowerext", private.use_emeraldflowerext_logic );
cmn.AddSubscriber( "use_emeraldflowerext_inv", private.use_emeraldflowerext_inv, private.room_objname );
cmn.AddSubscriber( "use_emeraldflowerext_beg", private.use_emeraldflowerext_beg, private.room_objname );
cmn.AddSubscriber( "use_emeraldflowerext_end", private.use_emeraldflowerext_end, private.room_objname );
cmn.AddSubscriber( "use_emeraldflowerext_end", private.use_emeraldflowerext_logic );
--------------------------------------------------------------------------------------------
function public.use_emeraldflowerext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_emeraldflowerext" );
    cmn.CallEventHandler( "use_emeraldflowerext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_emeraldflowerext") then ld.CloseSubRoom() end;
  end;

  local func_step = function()
    ObjSet("anm_icesculptureext_anim_use_emaralflower",{pos_z=30})
    if ld.CheckRequirements( {"use_crystalflowerext","use_pearlflowerext"} ) then
      SoundSfx( "aud_open_small_hide" )
      ld.AnimPlay( "anm_icesculptureext_anim_open", "anim_open", func_end );
    else
      func_end();
    end
  end
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_emeraldflowerext_inv" );
  cmn.CallEventHandler( "use_emeraldflowerext_beg" );
  common_impl.Lock(1);

  ObjSet("anm_icesculptureext_anim_use_emaralflower",{pos_z=33})
  ld.AnimPlay( "anm_icesculptureext_anim_use_emaralflower", "anim_use_emaralflower", func_step );
  SoundSfx( "aud_use_crystalflowerext_nearcastleext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pearlflowerext" ] = { type = "use", inv_obj = "inv_pearlflowerext", use_place = "gfx_icesculptureext_pearlflowerext_zone", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.use_pearlflowerext_logic = function()
  if ld.CheckRequirements( {"use_pearlflowerext","use_crystalflowerext","use_emeraldflowerext"} ) then
    ObjSet( "spr_icesculptureext_elfcatext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_icesculptureext_cubeext1", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_pearlflowerext_inv = function()
  common_impl.ProcessMultiUseAll("pearlflowerext", "pearlflowerext")
end;
private.use_pearlflowerext_beg = function()
  ObjDelete( "gfx_icesculptureext_pearlflowerext_zone" );
end;
private.use_pearlflowerext_end = function()
  if common_impl.ZzCompleteCheck("use_pearlflowerext") then ObjSet( common_impl.hint["use_pearlflowerext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_icesculptureext_anim_use_pearlflower",{frame=999});
  if ld.CheckRequirements( {"use_crystalflowerext","use_emeraldflowerext","use_pearlflowerext"} ) then
    ObjDelete("anm_icesculptureext_anim_open")
    ObjSet("spr_icesculptureext_elfcatext_shadow",{visible=1,active=1})
    ObjDelete("spr_nearcastleext_tr_plate")
  end
  ObjSet("spr_nearcastleext_tr_flower_1",{visible=1,alp=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pearlflowerext", private.use_pearlflowerext_inv );
cmn.AddSubscriber( "use_pearlflowerext", private.use_pearlflowerext_beg, private.room_objname );
cmn.AddSubscriber( "use_pearlflowerext", private.use_pearlflowerext_end, private.room_objname );
cmn.AddSubscriber( "use_pearlflowerext", private.use_pearlflowerext_logic );
cmn.AddSubscriber( "use_pearlflowerext_inv", private.use_pearlflowerext_inv, private.room_objname );
cmn.AddSubscriber( "use_pearlflowerext_beg", private.use_pearlflowerext_beg, private.room_objname );
cmn.AddSubscriber( "use_pearlflowerext_end", private.use_pearlflowerext_end, private.room_objname );
cmn.AddSubscriber( "use_pearlflowerext_end", private.use_pearlflowerext_logic );
--------------------------------------------------------------------------------------------
function public.use_pearlflowerext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pearlflowerext" );
    cmn.CallEventHandler( "use_pearlflowerext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pearlflowerext") then ld.CloseSubRoom() end;
  end;

  local func_step = function()
    ObjSet("anm_icesculptureext_anim_use_pearlflower",{pos_z=30})
    if ld.CheckRequirements( {"use_crystalflowerext","use_emeraldflowerext"} ) then
      SoundSfx( "aud_open_small_hide" )
      ld.AnimPlay( "anm_icesculptureext_anim_open", "anim_open", func_end );
    else
      func_end();
    end
  end
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pearlflowerext_inv" );
  cmn.CallEventHandler( "use_pearlflowerext_beg" );
  common_impl.Lock(1);

  ObjSet("anm_icesculptureext_anim_use_pearlflower",{pos_z=33})
  ld.AnimPlay( "anm_icesculptureext_anim_use_pearlflower", "anim_use_pearlflower", func_step );
  SoundSfx( "aud_use_crystalflowerext_nearcastleext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_elfcatext" ] = { type = "get", get_obj = "spr_icesculptureext_elfcatext", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.get_elfcatext_logic = function()
  
end;
private.get_elfcatext_inv = function()
  interface.InventoryItemAdd("inv_elfcatext","spr_icesculptureext_elfcatext");
end;
private.get_elfcatext_beg = function()
  ObjDelete("gfx_icesculptureext_elfcatext")
end;
private.get_elfcatext_end = function()
  if common_impl.ZzCompleteCheck("get_elfcatext") then ObjSet( common_impl.hint["get_elfcatext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_icesculptureext_elfcatext_shadow")
  ObjDelete("spr_nearcastleext_tr_elfcatext")
end;

cmn.AddSubscriber( "get_elfcatext", private.get_elfcatext_inv );
cmn.AddSubscriber( "get_elfcatext", private.get_elfcatext_beg, private.room_objname );
cmn.AddSubscriber( "get_elfcatext", private.get_elfcatext_end, private.room_objname );
cmn.AddSubscriber( "get_elfcatext", private.get_elfcatext_logic );
--------------------------------------------------------------------
function public.get_elfcatext()
  cmn.SetEventDone( "get_elfcatext" );
  cmn.CallEventHandler( "get_elfcatext" );
  if common_impl.ZzCompleteCheck("get_elfcatext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cubeext1" ] = { type = "get", get_obj = "spr_icesculptureext_cubeext1", room = "rm_nearcastleext", zz = "zz_icesculptureext", zz_gate = "gzz_nearcastleext_icesculptureext" };

private.get_cubeext1_logic = function()
  
end;
private.get_cubeext1_inv = function()
  interface.InventoryItemAdd("inv_cubeext","spr_icesculptureext_cubeext1",function() level_inv.ProcessGetCubeextAll( "get_cubeext1" ) end);
end;
private.get_cubeext1_beg = function()
  ObjDelete("gfx_icesculptureext_cubeext1")
end;
private.get_cubeext1_end = function()
  if common_impl.ZzCompleteCheck("get_cubeext1") then ObjSet( common_impl.hint["get_cubeext1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_nearcastleext_tr_cubeext1")
end;

cmn.AddSubscriber( "get_cubeext1", private.get_cubeext1_inv );
cmn.AddSubscriber( "get_cubeext1", private.get_cubeext1_beg, private.room_objname );
cmn.AddSubscriber( "get_cubeext1", private.get_cubeext1_end, private.room_objname );
cmn.AddSubscriber( "get_cubeext1", private.get_cubeext1_logic );
--------------------------------------------------------------------
function public.get_cubeext1()
  cmn.SetEventDone( "get_cubeext1" );
  cmn.CallEventHandler( "get_cubeext1" );
  if common_impl.ZzCompleteCheck("get_cubeext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_lucext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wrenchext_lucext" ] = { type = "use", inv_obj = "inv_wrenchext", use_place = "gfx_lucext_wrenchext_lucext_zone", room = "rm_nearcastleext", zz = "zz_lucext", zz_gate = "gzz_nearcastleext_lucext" };

private.use_wrenchext_lucext_logic = function()
  ObjSet( "spr_lucext_coinext3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_lucext_hairstickext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_lucext_fishingrodext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_wrenchext_lucext_inv = function()
  common_impl.ProcessMultiUseAll("wrenchext", "wrenchext_lucext")
end;
private.use_wrenchext_lucext_beg = function()
  ObjDelete( "gfx_lucext_wrenchext_lucext_zone" );
end;
private.use_wrenchext_lucext_end = function()
  if common_impl.ZzCompleteCheck("use_wrenchext_lucext") then ObjSet( common_impl.hint["use_wrenchext_lucext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_lucext_anim",{animfunc="anim_usespanner",frame=999})
  ObjDelete("spr_nearcastleext_close")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wrenchext_lucext", private.use_wrenchext_lucext_inv );
cmn.AddSubscriber( "use_wrenchext_lucext", private.use_wrenchext_lucext_beg, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_lucext", private.use_wrenchext_lucext_end, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_lucext", private.use_wrenchext_lucext_logic );
cmn.AddSubscriber( "use_wrenchext_lucext_inv", private.use_wrenchext_lucext_inv, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_lucext_beg", private.use_wrenchext_lucext_beg, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_lucext_end", private.use_wrenchext_lucext_end, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_lucext_end", private.use_wrenchext_lucext_logic );
--------------------------------------------------------------------------------------------
function public.use_wrenchext_lucext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wrenchext_lucext" );
    cmn.CallEventHandler( "use_wrenchext_lucext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wrenchext_lucext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wrenchext_lucext_inv" );
  cmn.CallEventHandler( "use_wrenchext_lucext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lucext_anim", "anim_usespanner", func_end );
  SoundSfx( "aud_use_wrenchext_lucext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coinext3" ] = { type = "get", get_obj = "spr_lucext_coinext3", room = "rm_nearcastleext", zz = "zz_lucext", zz_gate = "gzz_nearcastleext_lucext" };

private.get_coinext3_logic = function()
  
end;
private.get_coinext3_inv = function()
  interface.InventoryItemAdd("inv_coinext","spr_lucext_coinext3",function() level_inv.ProcessGetCoinextAll( "get_coinext3" ) end);
end;
private.get_coinext3_beg = function()
  ObjDelete("gfx_lucext_coinext3")
end;
private.get_coinext3_end = function()
  if common_impl.ZzCompleteCheck("get_coinext3") then ObjSet( common_impl.hint["get_coinext3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_lucext_coinext3_shadow")
end;

cmn.AddSubscriber( "get_coinext3", private.get_coinext3_inv );
cmn.AddSubscriber( "get_coinext3", private.get_coinext3_beg, private.room_objname );
cmn.AddSubscriber( "get_coinext3", private.get_coinext3_end, private.room_objname );
cmn.AddSubscriber( "get_coinext3", private.get_coinext3_logic );
--------------------------------------------------------------------
function public.get_coinext3()
  cmn.SetEventDone( "get_coinext3" );
  cmn.CallEventHandler( "get_coinext3" );
  if common_impl.ZzCompleteCheck("get_coinext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hairstickext" ] = { type = "get", get_obj = "spr_lucext_hairstickext", room = "rm_nearcastleext", zz = "zz_lucext", zz_gate = "gzz_nearcastleext_lucext" };

private.get_hairstickext_logic = function()
  
end;
private.get_hairstickext_inv = function()
  interface.InventoryItemAdd("inv_hairstickext","spr_lucext_hairstickext");
end;
private.get_hairstickext_beg = function()
  ObjDelete("gfx_lucext_hairstickext")
end;
private.get_hairstickext_end = function()
  if common_impl.ZzCompleteCheck("get_hairstickext") then ObjSet( common_impl.hint["get_hairstickext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_lucext_hairstickext_shadow")
end;

cmn.AddSubscriber( "get_hairstickext", private.get_hairstickext_inv );
cmn.AddSubscriber( "get_hairstickext", private.get_hairstickext_beg, private.room_objname );
cmn.AddSubscriber( "get_hairstickext", private.get_hairstickext_end, private.room_objname );
cmn.AddSubscriber( "get_hairstickext", private.get_hairstickext_logic );
--------------------------------------------------------------------
function public.get_hairstickext()
  cmn.SetEventDone( "get_hairstickext" );
  cmn.CallEventHandler( "get_hairstickext" );
  if common_impl.ZzCompleteCheck("get_hairstickext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fishingrodext" ] = { type = "use", inv_obj = "inv_fishingrodext", use_place = "gfx_lucext_fishingrodext_zone", room = "rm_nearcastleext", zz = "zz_lucext", zz_gate = "gzz_nearcastleext_lucext" };

private.use_fishingrodext_logic = function()
  ObjSet( "spr_lucext_brokenshacksawext", { visible = 1, input = 1, active = 1 } )

end;
private.use_fishingrodext_inv = function()
  common_impl.ProcessMultiUseAll("fishingrodext", "fishingrodext")
end;
private.use_fishingrodext_beg = function()
  ObjDelete( "gfx_lucext_fishingrodext_zone" );
end;
private.use_fishingrodext_end = function()
  if common_impl.ZzCompleteCheck("use_fishingrodext") then ObjSet( common_impl.hint["use_fishingrodext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("spr_lucext_brokenshacksawext_shadow",{visible=1})
  ObjSet("anm_lucext_anim",{animfunc="luk_end",frame=999})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fishingrodext", private.use_fishingrodext_inv );
cmn.AddSubscriber( "use_fishingrodext", private.use_fishingrodext_beg, private.room_objname );
cmn.AddSubscriber( "use_fishingrodext", private.use_fishingrodext_end, private.room_objname );
cmn.AddSubscriber( "use_fishingrodext", private.use_fishingrodext_logic );
cmn.AddSubscriber( "use_fishingrodext_inv", private.use_fishingrodext_inv, private.room_objname );
cmn.AddSubscriber( "use_fishingrodext_beg", private.use_fishingrodext_beg, private.room_objname );
cmn.AddSubscriber( "use_fishingrodext_end", private.use_fishingrodext_end, private.room_objname );
cmn.AddSubscriber( "use_fishingrodext_end", private.use_fishingrodext_logic );
--------------------------------------------------------------------------------------------
function public.use_fishingrodext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fishingrodext" );
    cmn.CallEventHandler( "use_fishingrodext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fishingrodext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fishingrodext_inv" );
  cmn.CallEventHandler( "use_fishingrodext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lucext_anim", "anim_use_rod", func_end );
  SoundSfx( "aud_use_fishingrodext_nearcastleext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brokenshacksawext" ] = { type = "get", get_obj = "spr_lucext_brokenshacksawext", room = "rm_nearcastleext", zz = "zz_lucext", zz_gate = "gzz_nearcastleext_lucext" };

private.get_brokenshacksawext_logic = function()
  
end;
private.get_brokenshacksawext_inv = function()
  interface.InventoryItemAdd("inv_brokenshacksawext","spr_lucext_brokenshacksawext");
  ObjSet( "inv_brokenshacksawext", { drag = 0 } );
end;
private.get_brokenshacksawext_beg = function()
  ObjDelete("gfx_lucext_brokenshacksawext")
end;
private.get_brokenshacksawext_end = function()
  if common_impl.ZzCompleteCheck("get_brokenshacksawext") then ObjSet( common_impl.hint["get_brokenshacksawext"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_lucext_brokenshacksawext_shadow")
end;

cmn.AddSubscriber( "get_brokenshacksawext", private.get_brokenshacksawext_inv );
cmn.AddSubscriber( "get_brokenshacksawext", private.get_brokenshacksawext_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenshacksawext", private.get_brokenshacksawext_end, private.room_objname );
cmn.AddSubscriber( "get_brokenshacksawext", private.get_brokenshacksawext_logic );
--------------------------------------------------------------------
function public.get_brokenshacksawext()
  cmn.SetEventDone( "get_brokenshacksawext" );
  cmn.CallEventHandler( "get_brokenshacksawext" );
  if common_impl.ZzCompleteCheck("get_brokenshacksawext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_prizesext_for_nearcastleext = function()
    if ld.CheckRequirements( {"win_prizesext"} ) then
      ObjSet( "gho_nearcastleext_prizesext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_prizesext", win_prizesext_for_nearcastleext, private.room_objname )
  local win_yardext_for_nearcastleext = function()
    if ld.CheckRequirements( {"win_yardext"} ) then
      ObjSet( "gmg_nearcastleext_yardext", {input = 0, visible = 0} );
      ObjSet("grm_nearcastleext_hallext",{visible=1,input=1,active=1});
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nearcastleext_hallext_focus");
      end;
    end
  end;
  cmn.AddSubscriber("win_yardext", win_yardext_for_nearcastleext )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_nearcastleext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_mansion_env" )
  if cmn.IsEventDone( "win_yardext" ) then
    ObjDelete("obj_nearcastleext_cinderela");
    ObjDetach("vid_nearcastleext_vid_cinderella_static_89")
  end
  if cmn.IsEventDone( "clk_guardiankeyext" ) then
    ObjDetach("vid_nearcastleext_vid_cat_guardian_static2_124")
    ObjDetach("vid_nearcastleext_vid_cat_guardian_static1_79")
  end
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_lucext" );
  function zz_lucext.Open()
  end;
  function zz_lucext.PreOpen()
  end;
  function zz_lucext.PreClose()
  end;
  function zz_lucext.Close()
  end;

  subroom.Define( "zz_icesculptureext" );
  function zz_icesculptureext.Open()
  end;
  function zz_icesculptureext.PreOpen()
  end;
  function zz_icesculptureext.PreClose()
  end;
  function zz_icesculptureext.Close()
  end;

  subroom.Define( "zz_tentext" );
  function zz_tentext.Open()
  end;
  function zz_tentext.PreOpen()
  end;
  function zz_tentext.PreClose()
  end;
  function zz_tentext.Close()
  end;

  subroom.Define( "zz_guardianext" );
  function zz_guardianext.Open()
  end;
  function zz_guardianext.PreOpen()
  end;
  function zz_guardianext.PreClose()
  end;
  function zz_guardianext.Close()
  end;
  
end;
--*********************************************************************************************************************