-- name=ho_icearbourscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "icearbourscr" );
  game.relations[ "ho_icearbourscr" ].exitroom = "rm_backyard";
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_icearbourscr" ] = { type = "win", room = "rm_backyard", zz = "ho_icearbourscr", zz_gate = "gho_backyard_icearbourscr" };
 
  local win_icearbourscr_func = function ()

    if ( cmn.IsEventDone( "win_icearbourscr" ) ) then
      interface.InventoryItemAdd( "inv_childrenstruck", "spr_icearbourscr_win" );
      ObjDelete( "gho_backyard_icearbourscr" );
      ObjSet( "inv_childrenstruck", { drag = 0 } )
    end;

  end;
  cmn.AddSubscriber( "win_icearbourscr", win_icearbourscr_func );
  
  local start_icearbourscr_func = function ()
    if not cmn.IsEventDone("win_icearbourscr") then
      common_impl.ProcessHoStart( "icearbourscr" );
      local ho_found = ng_global.progress[ "scr" ][ "win_icearbourscr" ].found;
      for i = 1, #ho_found do
        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false} );
        if ObjGet("spr_"..name.."_sh") then
          ObjDelete("spr_"..name.."_sh")
        end
      end;
    end
  end;
  cmn.AddSubscriber( "win_icearbourscr", start_icearbourscr_func, "ho_icearbourscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  private.tr_playing={}
  
  SoundEnv( "aud_mansion_env" )
  if ( not cmn.IsEventDone( "opn_icearbourscr" ) ) then
    cmn.InitHo( "icearbourscr" );
    cmn.SetEventDone( "opn_icearbourscr" );
  end;
  local ho_items = {};
  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_icearbourscr_aaa"}); --1
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_icearbourscr_bbb"}); --2
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_icearbourscr_ccc"}); --3
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_icearbourscr_ddd"}); --4
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_icearbourscr_eee"}); --5
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_icearbourscr_fff"}); --6
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_icearbourscr_ggg"}); --7
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_icearbourscr_hhh"}); --8
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_icearbourscr_iii"}); --9
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_icearbourscr_jjj"}); --10
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_icearbourscr_kkk"}); --11
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_icearbourscr_lll"}); --12
  SoundHoTheme( true );
  interface.ItemPanelShow( ho_items );
  
end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.ItemPanelHide();
end;
--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show() 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.TaskComplete( task_name )
  
  --ObjSet( "spr_icearbourscr_"..task_name, { pos_z = 1 } );
  cmn.HoItemFind("spr_icearbourscr_"..task_name,"itm_icearbourscr_"..task_name);
  if ObjGet("spr_icearbourscr_"..task_name.."_sh") then
    ObjDelete("spr_icearbourscr_"..task_name.."_sh")
  end
end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.tr_anim(tr)
  if not private.tr_playing[tr] then
    
    private.tr_playing[tr]=true;
    ld.AnimPlay("anm_icearbourscr_anm_tr_"..tr,"tr_"..tr, function() private.tr_playing[tr]=false; end)
    
    if tr==1 then
      SoundSfx( "aud_xx_bear" )
    end
    if tr==2 then
      SoundSfx( "aud_sfx_keys" )
    end
    if tr==3 then
      SoundSfx( "aud_sfx_grammophone" )
    end  
  end
end
