-- name=ho_jewelryhoscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "jewelryhoscr" );
  game.relations[ "ho_jewelryhoscr" ].exitroom = "rm_jewelryshop";
  -------------------------------------------------------------------------------------------------- 
  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";
  private.abc[12] = "lll";
  private.suff = {"","1"};
  private.max_alpha = 0.6;
  for n=1,#private.abc do
    for l=1,2 do
      local name = "spr_jewelryhoscr_"..private.abc[n]..private.suff[l];
      ObjSet(name,{
        input=1;
        visible=1;
        event_menter = function() private.event_menter( private.abc[n] ) end;
        event_mleave = function() private.event_mleave( private.abc[n] ) end;
        event_mdown  = function() private.TaskComplete( private.abc[n], private.suff[l] ) end;
      })
    end
  end
  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_jewelryhoscr" ] = { type = "win", room = "rm_jewelryshop", zz = "ho_jewelryhoscr", zz_gate = "gho_jewelryshop_jewelryhoscr" };
 
  local win_jewelryhoscr_func = function ()

    if ( cmn.IsEventDone( "win_jewelryhoscr" ) ) then
      interface.InventoryItemAdd( "inv_lionpen", "spr_jewelryhoscr_win" );
      ObjDelete( "gho_jewelryshop_jewelryhoscr" );
    end;

  end;
  cmn.AddSubscriber( "win_jewelryhoscr", win_jewelryhoscr_func );
  
  local start_jewelryhoscr_func = function ()
  if not cmn.IsEventDone("win_jewelryhoscr") then
  
  end
  end;
  cmn.AddSubscriber( "win_jewelryhoscr", start_jewelryhoscr_func, "ho_jewelryhoscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;

--*********************************************************************************************************************


function public.Open()
  local t = 2;  
  M = {
    0,0,0,   
    1*t/6,0,1,
    2*t/6,0,0,
    3*t/6,0,1,  
    4*t/6,0,0,
    5*t/6,0,1,
    t,0,0
  }
  ObjAnimate("spr_jewelryhoscr_arrow_up_left_light",     8, 0, 0, "", M);  
  ObjAnimate("spr_jewelryhoscr_arrow_up_right_light",    8, 0, 0, "", M);  
  ObjAnimate("spr_jewelryhoscr_arrow_down_left_light",   8, 0, 0, "", M);  
  ObjAnimate("spr_jewelryhoscr_arrow_down_right_light",  8, 0, 0, "", M);  
  ld.StartTimer(t,function() private.arrow_anim=true; end)
end

function public.PreOpen()

  
  private.curr = "";
  private.prev = "";
  private.obj_prev = "";
  
  ObjSet("spr_jewelryhoscr_arrow_up_left",{
    input=1;
    event_mdown  = function() private.turn("up") end;
    event_menter = function() private.arrow_menter("spr_jewelryhoscr_arrow_up_left") end;  
    event_mleave = function() private.arrow_mleave("spr_jewelryhoscr_arrow_up_left") end;  
  })
  ObjSet("spr_jewelryhoscr_arrow_up_right",{
    input=1;
    event_mdown  = function() private.turn("up") end;
    event_menter = function() private.arrow_menter("spr_jewelryhoscr_arrow_up_right") end;  
    event_mleave = function() private.arrow_mleave("spr_jewelryhoscr_arrow_up_right") end;  
  })
  
  
  ObjSet("spr_jewelryhoscr_arrow_down_left",{
    input=1;
    event_mdown  = function() private.turn("down") end;
    event_menter = function() private.arrow_menter("spr_jewelryhoscr_arrow_down_left") end;  
    event_mleave = function() private.arrow_mleave("spr_jewelryhoscr_arrow_down_left") end;  
  })
  ObjSet("spr_jewelryhoscr_arrow_down_right",{
    input=1;
    event_mdown  = function() private.turn("down") end;
    event_menter = function() private.arrow_menter("spr_jewelryhoscr_arrow_down_right") end;  
    event_mleave = function() private.arrow_mleave("spr_jewelryhoscr_arrow_down_right") end;  
  })
  
  for n=1,#private.abc do
    for l=1,2 do
      local name = "spr_jewelryhoscr_"..private.abc[n]..private.suff[l].."_light";
      ObjSet(name,{
        blendmode=2;
        pos_z=32.1;
        input=0;
        alp=0;
      })
    end
  end  
   
  SoundEnv( "aud_jewelryshop_env" )

  
  if ( not cmn.IsEventDone( "opn_jewelryhoscr" ) ) then
    ng_global.progress["scr"]["win_jewelryhoscr"].state    = {};
    ng_global.progress["scr"]["win_jewelryhoscr"].state["down_1"] = true;
    ng_global.progress["scr"]["win_jewelryhoscr"].state["down_2"] = false;
    ng_global.progress["scr"]["win_jewelryhoscr"].state["up_1"] = true;
    ng_global.progress["scr"]["win_jewelryhoscr"].state["up_2"] = false;
    cmn.InitHo( "jewelryhoscr" );
    cmn.SetEventDone( "opn_jewelryhoscr" );
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_jewelryhoscr_aaa","spr_jewelryhoscr_aaa1" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_jewelryhoscr_bbb","spr_jewelryhoscr_bbb1" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_jewelryhoscr_ccc","spr_jewelryhoscr_ccc1" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_jewelryhoscr_ddd","spr_jewelryhoscr_ddd1" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_jewelryhoscr_eee","spr_jewelryhoscr_eee1" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_jewelryhoscr_fff","spr_jewelryhoscr_fff1" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_jewelryhoscr_ggg","spr_jewelryhoscr_ggg1" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_jewelryhoscr_hhh","spr_jewelryhoscr_hhh1" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_jewelryhoscr_iii","spr_jewelryhoscr_iii1" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_jewelryhoscr_jjj","spr_jewelryhoscr_jjj1" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_jewelryhoscr_kkk","spr_jewelryhoscr_kkk1" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_jewelryhoscr_lll","spr_jewelryhoscr_lll1" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "jewelryhoscr" );

  local cnt = 0;
  for j = 1, #ng_global.progress["scr"]["win_jewelryhoscr"].found do
    local name = tostring( ng_global.progress["scr"]["win_jewelryhoscr"].found[j]["object"] );
    ObjDelete( name );
    ObjDelete( name.."1" );
    local task = tostring( ng_global.progress["scr"]["win_jewelryhoscr"].found[j]["task"] );
    --
    local name_del = "spr_jewelryhoscr_"..task.."1_sh"
    if ObjGet(name_del) then
      ObjDelete(name_del)
    end
    
    local name_del = "spr_jewelryhoscr_"..task.."_sh"
    if ObjGet(name_del) then
      ObjDelete(name_del)
    end
    
    cnt=cnt+1;
  end;

  
  
  local res = ng_global.progress["scr"]["win_jewelryhoscr"].state["down_1"]
  ObjSet("obj_jewelryhoscr_down_1",{input=res,visible=res})
  
  local res = ng_global.progress["scr"]["win_jewelryhoscr"].state["down_2"]
  ObjSet("obj_jewelryhoscr_down_2",{input=res,visible=res})
  
  local res = ng_global.progress["scr"]["win_jewelryhoscr"].state["up_1"]
  ObjSet("obj_jewelryhoscr_up_1",{input=res,visible=res})
  
  local res = ng_global.progress["scr"]["win_jewelryhoscr"].state["up_2"]
  ObjSet("obj_jewelryhoscr_up_2",{input=res,visible=res})
  
  
  
  ObjSet("txt_jewelryhoscr_taskpanel",{param0 = cnt})
  private.obj_input()
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()
  int_taskpanel_impl.ShowTextPanel( "jewelryhoscr" );
end;

--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.event_menter( task_name )
  --ld.ShCur(CURSOR_HAND);
end
--------------------------------------------------------------------------------------------
function private.event_mleave( task_name )
  --ld.ShCur(CURSOR_DEFAULT);
end
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, dop )
  
  local func_end = function()
    ld.Lock(1);
    local name1 = "spr_jewelryhoscr_"..task_name.."1"
    ObjSet(name1,{input=0})
    private.sparkle(name1)
    ObjAnimate(name1, 8, 0, 0, function() ObjDelete(name1);ld.Lock(0); end, {0,0,1, 0.5,0,0});
    
    local name = "spr_jewelryhoscr_"..task_name
    ObjSet( "spr_jewelryhoscr_"..task_name, { pos_z = 1 } );
    cmn.HoTaskFind( "spr_jewelryhoscr_"..task_name, task_name );
    
    local name_del = "spr_jewelryhoscr_"..task_name.."1_sh"
    if ObjGet(name_del) then
      ObjDelete(name_del)
    end
    
    local name_del = "spr_jewelryhoscr_"..task_name.."_sh"
    if ObjGet(name_del) then
      ObjDelete(name_del)
    end
    
    ObjSet("txt_jewelryhoscr_taskpanel",{param0 = #ng_global.progress["scr"]["win_jewelryhoscr"].found})
  end
  
  
  private.obj_curr = "spr_jewelryhoscr_"..task_name..dop;  
  private.curr = task_name;
  
  if private.curr == private.prev and private.obj_curr ~= private.obj_prev then
    
    ObjSet(private.obj_curr.."_light",{alp=0})
    ObjSet(private.obj_prev.."_light",{alp=0})
    
    private.curr = "";
    private.prev = "";
    private.obj_prev = "";
    
    func_end();
  else
    
    if private.prev == "" then
      ObjSet(private.obj_curr.."_light",{alp=private.max_alpha})
      private.prev = private.curr;
      private.obj_prev = private.obj_curr;
    elseif (private.curr ~= private.prev or private.obj_curr == private.obj_prev) then
      
      -- IDLE FUNCTION, Мерцание подсветкой когда выбираем неправильную пару
      
      local func_end = function()
        ObjSet(private.obj_curr.."_light",{alp=0})
        ObjSet(private.obj_prev.."_light",{alp=0})
        private.curr = "";
        private.prev = "";
        private.obj_prev = "";
        ld.Lock(0);
      end
      
      if private.obj_curr == private.obj_prev then
        func_end()
      else
        ld.Lock(1);
        local t = 0.5;
        ObjAnimate(private.obj_curr.."_light",  8, 0, 0, func_end, {0,0,0,  t/4,0,private.max_alpha,  2*t/4,0,0,  3*t/4,0,private.max_alpha,  t,0,0});
        ObjAnimate(private.obj_prev.."_light",  8, 0, 0, "",       {0,0,0,  t/4,0,private.max_alpha,  2*t/4,0,0,  3*t/4,0,private.max_alpha,  t,0,0});
      end
    end
    
  end
  
  SoundSfx("aud_clk_ho")
  
end;
----------------------------------------------------------------------------
function private.GetItem( name )
  --ld.PlayAudio("sfx","common/audio/aud_get_item");
end;
----------------------------------------------------------------------------





----------------------------------------------------------------------------
function private.arrow_mleave(obj)
  ld.ShCur(CURSOR_DEFAULT)
  if private.arrow_anim then
    ObjSet(obj.."_light",{alp=0})
  end
end
----------------------------------------------------------------------------
----------------------------------------------------------------------------
function private.arrow_menter(obj)
  ld.ShCur(CURSOR_HAND)
  if private.arrow_anim then
    ObjSet(obj.."_light",{alp=1})
  end
end
----------------------------------------------------------------------------




----------------------------------------------------------------------------
function private.turn(obj)
  local obj1 = "obj_jewelryhoscr_"..obj.."_1"
  local obj2 = "obj_jewelryhoscr_"..obj.."_2"
  if ObjGet(obj1).visible then
    ObjSet(obj1,{visible=0,input=0})
    ObjSet(obj2,{visible=1,input=1})
    SoundSfx("aud_twist_lower_shelf")
  else
    ObjSet(obj1,{visible=1,input=1})
    ObjSet(obj2,{visible=0,input=0})
    SoundSfx("aud_twist_upper_shelf")
  end
  
  ng_global.progress["scr"]["win_jewelryhoscr"].state["up_1"] = ObjGet("obj_jewelryhoscr_up_1").input
  ng_global.progress["scr"]["win_jewelryhoscr"].state["up_2"] = ObjGet("obj_jewelryhoscr_up_2").input
  ng_global.progress["scr"]["win_jewelryhoscr"].state["down_1"] = ObjGet("obj_jewelryhoscr_down_1").input
  ng_global.progress["scr"]["win_jewelryhoscr"].state["down_2"] = ObjGet("obj_jewelryhoscr_down_2").input
  
  private.obj_input()
end
----------------------------------------------------------------------------
function private.obj_input()
  for n=1,#private.abc do
    for l=1,2 do
      local name = "spr_jewelryhoscr_"..private.abc[n]..private.suff[l];
      if ObjGet(name) then
        local res = ObjGet( ObjGetRelations(name).parent ).input;
        ObjSet(name,{input=res})
        if not res then
          if private.prev == private.abc[n] then
            ObjSet(private.obj_prev.."_light",{alp=0})
            private.obj_prev = "";
            private.prev = "";
            
          end
        end
      end
    end
  end
end
---------------------------------------------------------------------------









--------------------------------------------------------------------------------
function private.HintShow(hint_obj_name)
  local hints_table = { hint = {} };
  table.insert( hints_table.hint,  { ["pos_x"]=ObjGet(hint_obj_name).pos_x, ["pos_y"]=ObjGet(hint_obj_name).pos_y, ["obj_name"]=hint_obj_name } )   
  MsgSend( Command_Effect_ShowHoHint, hints_table );
end
--------------------------------------------------------------------------------
function public.clk_hint()
  local done = false;
  for n=1,#private.abc do
    local name  = "spr_jewelryhoscr_"..private.abc[n]
    local name1 = "spr_jewelryhoscr_"..private.abc[n].."1"
    if ObjGet(name) and ObjGet(name1) then
      if ObjGet(name).input and ObjGet(name1).input then
        private.HintShow(name);
        private.HintShow(name1);
        done = true;
        break;
      end
    end
  end
  
  if not done then
    local name_to_find;
    for n=1,#private.abc do
      local name  = "spr_jewelryhoscr_"..private.abc[n]
      local name1 = "spr_jewelryhoscr_"..private.abc[n].."1"
      if ObjGet(name) and ObjGet(name1) then
        
        local res = false;
        local res1 = false;
        if ObjGet(name) then
          if ObjGet(name).input then
            res=true;
          end
        end
        if ObjGet(name1) then
          if ObjGet(name1).input then
            res1=true;
          end
        end
        
        if res or res1 then
          if res then
            name_to_find=name1;
            private.HintShow(name);
          end
          if res1 then
            name_to_find=name;
            private.HintShow(name1);
          end
          done = true;
          break;
        end
      end
    end
    if done then
      if string.find( ObjGetRelations(name_to_find).parent, "down" ) then
        private.HintShow("spr_jewelryhoscr_arrow_down_left");
      else
        private.HintShow("spr_jewelryhoscr_arrow_up_left");
      end
    else
      private.HintShow("spr_jewelryhoscr_arrow_up_left");
      private.HintShow("spr_jewelryhoscr_arrow_down_left");
    end
    
    
  end
  
end
--------------------------------------------------------------------------------















-- simple effect from HO -------------------------------------------------------
function private.sparkle(object_name)
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 32, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  ObjSet(collect_name, {});
  
  PartSysSetMaskObj( collect_name, object_name );  
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
end
-- simple effect from HO -------------------------------------------------------
