-- name=ho_musicanshoscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "musicanshoscr" );
  game.relations[ "ho_musicanshoscr" ].exitroom = "rm_citystreets";
 
  --------------------------------------------------------------------------------------------------
  private.TASK_COLOR_R = 0.918;
  private.TASK_COLOR_G = 0.671;
  private.TASK_COLOR_B = 0.278;
  
  private.TASK_MARKED_COLOR_R = 0.427;
  private.TASK_MARKED_COLOR_G = 0.761;
  private.TASK_MARKED_COLOR_B = 0.996;
  
  private.TASK_COMPLETED_COLOR_R = 0.259;
  private.TASK_COMPLETED_COLOR_G = 0.259;
  private.TASK_COMPLETED_COLOR_B = 0.259;
  --------------------------------------------------------------------------------------------------

  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";
  private.abc[12] = "lll";
  private.abc[13] = "mmm";
  private.abc[14] = "nnn";
  private.abc[15] = "ooo";
  private.abc[16] = "ppp";
  private.abc[17] = "qqq";
  private.abc[18] = "rrr";
  private.abc[19] = "sss";
  private.abc[20] = "ttt";
  private.abc[21] = "uuu";
  private.abc[22] = "vvv";
  private.abc[23] = "www";
  private.abc[24] = "xxx";
  private.N = #private.abc;
  private.abc2num={}
  for n=1,private.N do
    private.abc2num[ private.abc[n] ]=n;
  end
  
  
  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_musicanshoscr" ] = { type = "win", room = "rm_citystreets", zz = "ho_musicanshoscr", zz_gate = "gho_citystreets_musicanshoscr" };
 
  local win_musicanshoscr_func = function ()

    if ( cmn.IsEventDone( "win_musicanshoscr" ) ) then
      interface.InventoryItemAdd( "inv_candyprize", "spr_musicanshoscr_win" );
      ObjSet("inv_candyprize",{drag=false})
      ObjDelete( "gho_citystreets_musicanshoscr" );
    end;

  end;
  cmn.AddSubscriber( "win_musicanshoscr", win_musicanshoscr_func );
  
  local start_musicanshoscr_func = function ()
  if not cmn.IsEventDone("win_musicanshoscr") then
  
  end
  end;
  cmn.AddSubscriber( "win_musicanshoscr", start_musicanshoscr_func, "ho_musicanshoscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_citystreets_env" )

  interface.WidgetSetVisible( "InterfaceWidget_Inventory", false,true );
  interface.WidgetSetInput("InterfaceWidget_Inventory", 0 );
  
  
  -- FIRST INIT
  if ng_global.progress[ "scr" ][ "win_musicanshoscr" ].start ~= 1 then
    
    ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks = {};
    for n=1,private.N do
      ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[n] = false;
    end
    ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark = {};
    ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark["ooo"] = true;
    ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark["qqq"] = true;
    
  end
  
  
  
  
  -- SET FUNC TO CLICK FOR OBJECTS
  
  ObjSet("spr_musicanshoscr_box",{
    event_mdown = function() private.idle_gate("spr_musicanshoscr_box");     end;
    event_menter= function() ld.ShCur(CURSOR_HAND);    end;
    event_mleave= function() ld.ShCur(CURSOR_DEFAULT); end;
  })
  
  ObjSet("spr_musicanshoscr_piano",{
    event_mdown = function() private.idle_gate("spr_musicanshoscr_piano");     end;
    event_menter= function() ld.ShCur(CURSOR_HAND);    end;
    event_mleave= function() ld.ShCur(CURSOR_DEFAULT); end;
  })  
    
  private.idle_playing={}
  --unmark area's:
  ObjSet("obj_musicanshoscr_ooo_unmark",{ 
    event_mdown  = function() private.unmark_ooo(); end;
    event_menter = function() ld.ShCur(CURSOR_HAND); end;
    event_mleave = function() ld.ShCur(CURSOR_DEFAULT); end;  
 })
  ObjSet("obj_musicanshoscr_qqq_unmark",{ 
    event_mdown  = function() private.unmark_qqq(); end;
    event_menter = function() ld.ShCur(CURSOR_HAND); end;
    event_mleave = function() ld.ShCur(CURSOR_DEFAULT); end;  
  })
  --main objects
  for n=1,private.N do
    ObjSet("spr_musicanshoscr_"..private.abc[n],{
      event_mdown = function() private.clk_task(private.abc[n]) end;
    })
  end
  
  SoundHoTheme( true );
  
  --remove and activate objects according the progress:
  private.set_task();
end;
--*********************************************************************************************************************

function public.Open()
  if ( not cmn.IsEventDone( "opn_musicanshoscr" ) ) then
    cmn.InitHo( "musicanshoscr" );
    cmn.SetEventDone( "opn_musicanshoscr" );
  end;
  interface_impl.StartHoAchievements( "musicanshoscr" );
end



function public.PreClose()
  SoundHoTheme( false );
  interface.WidgetSetVisible( "InterfaceWidget_Inventory", true,true );
  interface.WidgetSetInput("InterfaceWidget_Inventory", 1 );
end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
  
  common_impl.DialogHo_Show()
  ObjAnimate( "obj_musicanshoscr_panel", 8, 0, 0, "", {0,0,1,   0.5,0,0} );
  ObjAnimate( "obj_musicanshoscr_panel", 1, 0, 0, "", {0,0,708, 0.5,0,908} );
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_musicanshoscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_musicanshoscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------
function private.GetItem( name )
  --ld.PlayAudio("sfx","common/audio/aud_get_item");
end;
----------------------------------------------------------------------------
-- ====================================================================== --
function private.set_task(slow_mode)
  
  local cnt_1 = 0;
  local cnt_2 = 0;
  local cnt   = 0;
  
  local t = 0.35;
  
  if slow_mode then
    ld.StartTimer(t,function() ld.Lock(0) end)
  else
    ld.Lock(0)
  end
  
  for n=1,private.N do
    if ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[ n ] then
      
      
      if ObjGet("txt_musicanshoscr_task_"..private.abc[n]) and ObjGet("spr_musicanshoscr_"..private.abc[n]) then
        
        if slow_mode then
          local txt1 = "txt_musicanshoscr_task_"..private.abc[n];
          local o1 = ObjGet(txt1)
          local txt2 = "txt_musicanshoscr_task_smooth";
          local o2 = ObjGet(txt2)
          ObjAttach(txt2,ObjGetRelations(txt1).parent);
          ObjSet( txt2, {
            pos_x=o1.pos_x; pos_y=o1.pos_y;visible=1;alp=1,
            fontcolor_r=o1.fontcolor_r; 
            fontcolor_g=o1.fontcolor_g;  
            fontcolor_b=o1.fontcolor_b;
            text=o1.text;
          })
          
          ObjSet(txt1,{alp=0;
            fontcolor_r = private.TASK_COMPLETED_COLOR_R;
            fontcolor_g = private.TASK_COMPLETED_COLOR_G;
            fontcolor_b = private.TASK_COMPLETED_COLOR_B;
          })
          
          
          
          ObjAnimate(txt1, 8, 0, 0, _, {0,0,0,  t,0,1});
          ObjAnimate(txt2, 8, 0, 0, _, {0,0,1,  t,0,0});
        
        else
          ObjSet("txt_musicanshoscr_task_"..private.abc[n],{
            fontcolor_r = private.TASK_COMPLETED_COLOR_R;
            fontcolor_g = private.TASK_COMPLETED_COLOR_G;
            fontcolor_b = private.TASK_COMPLETED_COLOR_B;
          })
        end
        
      end
      
      ObjDelete("spr_musicanshoscr_"..private.abc[n])
      
      cnt=cnt+1;
      if n<6 then
        cnt_1=cnt_1+1;
      end
      if n>18 then
        cnt_2=cnt_2+1;
      end
    
    else
      
      if private.abc[n]=="ooo" or private.abc[n]=="qqq" then
      if ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark[ private.abc[n] ] then
        ObjSet("txt_musicanshoscr_task_"..private.abc[n],{
          fontcolor_r = private.TASK_MARKED_COLOR_R;
          fontcolor_g = private.TASK_MARKED_COLOR_G;
          fontcolor_b = private.TASK_MARKED_COLOR_B;
        })
      end
      
      if not ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark[ private.abc[n] ] then
        if ObjGet("txt_musicanshoscr_task_"..private.abc[n]).fontcolor_b > 0.5 then
          
          local txt1 = "txt_musicanshoscr_task_"..private.abc[n];
          local o1 = ObjGet(txt1)
          local txt2 = "txt_musicanshoscr_task_smooth";
          local o2 = ObjGet(txt2)
          ObjAttach(txt2,ObjGetRelations(txt1).parent);
          ObjSet( txt2, {
            pos_x=o1.pos_x; pos_y=o1.pos_y;visible=1;alp=1,
            fontcolor_r=o1.fontcolor_r; 
            fontcolor_g=o1.fontcolor_g;  
            fontcolor_b=o1.fontcolor_b;
            text=o1.text;
          })
          
          ObjSet(txt1,{alp=0;
            fontcolor_r = private.TASK_COLOR_R;
            fontcolor_g = private.TASK_COLOR_G;
            fontcolor_b = private.TASK_COLOR_B;
          })
          ObjAnimate(txt1, 8, 0, 0, _, {0,0,0,  t,0,1});
          ObjAnimate(txt2, 8, 0, 0, _, {0,0,1,  t,0,0});
          
        end
      end
      end
      
    end
    
    
    
    if private.abc[n]=="ooo" or private.abc[n]=="qqq" then
      if not ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark[ private.abc[n] ] then
        if ObjGet("obj_musicanshoscr_"..private.abc[n].."_unmark") then
        ObjDelete("obj_musicanshoscr_"..private.abc[n].."_unmark");
        end
        
        if private.abc[n]=="ooo" then
          ObjSet("anm_musicanshoscr_anim_bant",{frame=999})
        end
        if private.abc[n]=="qqq" then
          ObjSet("anm_musicanshoscr_anim_paw",{frame=999})
        end
      end
    end
  
    
  end
  
  
  
      
  ObjSet("txt_musicanshoscr_counter_1",{text=tostring(cnt_1.."/5")})
  ObjSet("txt_musicanshoscr_counter_2",{text=tostring(cnt_2.."/5")})
  
  if cnt_1>=5 then
    ObjDelete("spr_musicanshoscr_gate_1")
    ObjDelete("spr_musicanshoscr_gate_2")
    ObjDelete("spr_musicanshoscr_box")
    ObjDelete("spr_musicanshoscr_box_open")
    ObjDelete("spr_musicanshoscr_fff_part_2")
    ObjDelete("spr_musicanshoscr_fff_set")
    ObjSet("obj_musicanho_taskpart_1",{alp=1});
    ObjSet("obj_musicanho_taskpart_2",{alp=1});
    
    
    for n=7,12 do
      local name = "spr_musicanshoscr_"..private.abc[n];
      if ObjGet(name) then
        ObjSet(name,{input=1})
      end
    end
  end
  
  
  
  if cnt_2>=5 then
    ObjDelete("spr_musicanshoscr_gate_3")
    ObjDelete("spr_musicanshoscr_gate_4")
    ObjDelete("spr_musicanshoscr_piano")
    ObjDelete("spr_musicanshoscr_piano_open")
    ObjSet("obj_musicanho_taskpart_3",{alp=1});
    ObjSet("obj_musicanho_taskpart_4",{alp=1});
    ObjSet("obj_musicanshoscr_qqq_unmark",{input=1})
    ObjSet("obj_musicanshoscr_ooo_unmark",{input=1})
    for n=13,18 do
      local name = "spr_musicanshoscr_"..private.abc[n];
      if ObjGet(name) and not ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark[ private.abc[n] ] then
        ObjSet(name,{input=1})
      end
    end
  end
  
  
  if cnt>=private.N then
    ho_musicanshoscr.HoComplete();
  end
end





-- ====================================================================== --
function private.clk_task(task)
  local obj = "spr_musicanshoscr_"..task;
  local o = ObjGet(obj);
  local n = private.abc2num[task];
  
  
  
  local func_end = function()
    
    if n<6 or n>18 then
      
      
      
      local fast_end = true;
      
      local cnt_1=0;
      local cnt_2=0;
      for nn=1,private.N do
        if ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[nn] then
          if nn<6 then
            cnt_1=cnt_1+1;
          end
          if nn>18 then
            cnt_2=cnt_2+1;
          end
        end
      end
      
      
       
      -- MONSTROSITY PROGRAMM ANIMATION 
      -- OPEN THE BOX IN GATE 2
      if cnt_1==4 and n<=5 and not ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[6] then
        
        local func_end_1 = function()
          ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[n]=true;
          ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[6]=true;
          private.set_task();
        end
        
        fast_end=false;
        
        
        -- ANIM STAGE 4 appear task and hide box after with panel
        local func_step_2 = function()
          SoundSfx( "aud_discover" );
          local t4 = 0.8;
          local t5 = 0.7;
          ObjAnimate("obj_musicanho_taskpart_1",  8, 0, 0, _, 
                                                              {0,0,0,    t4*0.1,0,1});
          ObjAnimate("obj_musicanho_taskpart_2",  8, 0, 0, _, {0,0,0,    t4*0.1,0,1});
          
          ObjAnimate("obj_musicanho_taskpart_1", 6, 0, 0, _,  {0,0,0,0,  t4,0,1,1});
          ObjAnimate("obj_musicanho_taskpart_2", 6, 0, 0, _,  {0,0,0,0,  t4,0,1,1});
          
          ObjAnimate("obj_musicanho_taskpart_1",12, 0, 0, _,  {0,0,  0,0,0,  t4,0, 0,0,0,       t4+t5,0, 1,1,1});
          ObjAnimate("obj_musicanho_taskpart_2",12, 0, 0, _,  {0,0,  0,0,0,  t4,0, 0,0,0,       t4+t5,0, 1,1,1});
          
          
          ObjAnimate("obj_musicanho_taskpart_1",  0, 0, 0, _, {0,0,-111, t4,0,-284});
          
          ObjAnimate("spr_musicanshoscr_gate_1", 1, 0, 0, _,     {0,0,1,  t4,0,1,  t4+t5,0,138});
          ObjAnimate("spr_musicanshoscr_gate_2", 1, 0, 0, func_end_1,                                               {0,0,1,  t4,0,1,  t4+t5,0,138});
        end
        
        -- ANIM STAGE 3 open box
        local func_step_1 = function()
          local t3 = 0.8;
          ObjAnimate("spr_musicanshoscr_fff",      8, 0, 0,   func_step_2, {0,1,1,  t3,0,0});
          ObjAnimate("spr_musicanshoscr_box",      8, 0, 0,   _, {0,1,1,  t3,0,0});
          ObjAnimate("spr_musicanshoscr_box_open", 8, 0, 0,   _, {0,0,0,  t3,2,1});
        end
        
        
        -- ANIM STAGE 1 transfrom contour to object
        local t1 = 0.4;
        ObjAnimate("spr_musicanshoscr_fff_contour", 8, 0, 0, _, {0,0,1, t1,0,0});
        ObjAnimate("spr_musicanshoscr_fff",         8, 0, 0, function() private.sparkle("spr_musicanshoscr_fff") end, {0,0,0, t1,0,1});
        
        -- ANIM STAGE 2 move object (key) to his slot
        local t2 = 0.4;
        local o1 = ObjGet("spr_musicanshoscr_fff")
        local o2 = ObjGet("spr_musicanshoscr_fff_set")
        ObjAnimate("spr_musicanshoscr_fff", 3,0,0, _, {0,0, o1.pos_x,o1.pos_y,   t1,0,o1.pos_x,o1.pos_y,
          t1+t2, 0, o2.pos_x,o2.pos_y
        });
        ObjAnimate("spr_musicanshoscr_fff", 6,0,0, _, {0,0, o1.scale_x,o1.scale_y,   t1,0,o1.scale_x,o1.scale_y,
          t1+t2, 0, o2.scale_x,o2.scale_y
        });
        ObjAnimate("spr_musicanshoscr_fff", 7,0,0, func_step_1, {0,0, o1.ang,   t1,0,o1.ang,
          t1+t2, 0, o2.ang
        });
        
        ObjSet("txt_musicanshoscr_counter_1",{text=tostring("5/5")})
        ObjAnimate("txt_musicanshoscr_counter_1", 8, 0, 0, _, {0,0,1, 0.8,0,0});
        
        SoundSfx( "aud_keys_or_notes_complete" );
      end
      
      
      
      
      
      
      -- SECOND MONSTROSITY PROGRAMM ANIMATION
      -- OPEN THE PIANO IN GATE 3
      if cnt_2==4 and n>=18 and not ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[24] then
        
        local func_end_2 = function()
          
          ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[n]=true;
          ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[24]=true;
          private.set_task();
        end
        
        
        fast_end=false;
        
        
        
        -- ANIM STAGE 4 appear task and hide box after with panel
        local func_step_2 = function()
          local t4 = 0.8;
          local t5 = 0.7;
          SoundSfx( "aud_discover" );
          ObjAnimate("obj_musicanho_taskpart_3",  8, 0, 0, _, {0,0,0,    t4*0.1,0,1});
          ObjAnimate("obj_musicanho_taskpart_4",  8, 0, 0, _, {0,0,0,    t4*0.1,0,1});
          
          ObjAnimate("obj_musicanho_taskpart_3", 6, 0, 0, _,  {0,0,0,0,  t4,0,1,1});
          ObjAnimate("obj_musicanho_taskpart_4", 6, 0, 0, _,  {0,0,0,0,  t4,0,1,1});
          
          ObjAnimate("obj_musicanho_taskpart_4",  0, 0, 0, _, {0,0,63, t4,0,237});
          
          ObjAnimate("spr_musicanshoscr_gate_3", 1, 0, 0, _,     {0,0,1,  t4,0,1,  t4+t5,0,138});
          ObjAnimate("spr_musicanshoscr_gate_4", 1, 0, 0, func_end_2,  
                                                              {0,0,1,  t4,0,1,  t4+t5,0,138});
        end
        
        -- ANIM STAGE 3 open box
        local func_step_1 = function()
          ObjAnimate("spr_musicanshoscr_xxx", 8, 0, 0, _, {0,0,1, 0.3,0,0});
          local t3 = 0.7;
          local t3_dop = 1;
          -- object the brouken dissappearing firstly
          ObjAnimate("spr_musicanshoscr_piano_brouken", 8, 0, 0, _,          {0,0,1,   t3,0,0});
          ObjAnimate("spr_musicanshoscr_piano",      8, 0, 0,   func_step_2, {0,1,1,   t3,0,1,      t3+t3_dop,0,0});
          ObjAnimate("spr_musicanshoscr_piano_open", 8, 0, 0,   _,           {0,0,0,   t3,0,0,      t3+t3_dop,2,1});
        end
        
        
        -- ANIM STAGE 1 transfrom contour to object
        local t1 = 0.4;
        ObjAnimate("spr_musicanshoscr_xxx_contour", 8, 0, 0, _, {0,0,1, t1,0,0});
        ObjAnimate("spr_musicanshoscr_xxx",         8, 0, 0, function() private.sparkle("spr_musicanshoscr_xxx") end, {0,0,0, t1,0,1});
        
        -- ANIM STAGE 2 move object (key) to his slot
        local t2 = 0.4;
        local o1 = ObjGet("spr_musicanshoscr_xxx");
        local o2 = ObjGet("spr_musicanshoscr_gate_3");
        ObjAnimate("spr_musicanshoscr_xxx", 3, 0, 0, _,           {0,0,o1.pos_x,o1.pos_y,    t1,0,o1.pos_x,o1.pos_y,    t1+t2, 0, o2.pos_x,o2.pos_y});
        ObjAnimate("spr_musicanshoscr_xxx", 6, 0, 0, func_step_1, {0,0,1,1,  t1,0,1,1,   t1+t2,0,0.3,0.3});
        
        
        ObjSet("txt_musicanshoscr_counter_2",{text=tostring("5/5")});
        ObjAnimate("txt_musicanshoscr_counter_2", 8, 0, 0, _, {0,0,1, 0.8,0,0});
        
        SoundSfx( "aud_keys_or_notes_complete" );
        
      end
      
      -- IF PLAYER COLLECT SOME KEY WITHOUT OPEN ANY SLOT
      if fast_end then
        ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[n]=true;
        private.set_task()
      end
      
    else
      
      -- THEN PLAYER GET USUAL OBJECT
      ng_global.progress[ "scr" ][ "win_musicanshoscr" ].ho_tasks[n]=true;
      private.set_task(true);
      SoundSfx( "aud_get_ho" );
    end
    
    
  end
  
  ld.Lock(1);
  local t = 0.35;
  private.sparkle(obj,t)
  ObjAnimate( obj, 8,0,0, func_end,{ 
      0,   0, 1,
      t/2, 0, 1,
      t,   0, 0
  });
  
  local moving = false;  
  local x_end,y_end;  
  local pos1 = GetObjPosByObj("spr_musicanshoscr_fff", "ho_musicanshoscr");
  local pos2 = GetObjPosByObj("spr_musicanshoscr_xxx", "ho_musicanshoscr");
  if n<6 then
    moving=true
    x_end = pos1[1]
    y_end = pos1[2]
    SoundSfx( "aud_clk_ho_2" );
  end
  if n>18 then
    moving=true
    x_end = pos2[1]
    y_end = pos2[2]
    SoundSfx( "aud_clk_ho_2" );
  end
  
  if moving then
    ObjSet(obj,{pos_z=102})
    ObjAnimate(obj, 3, 0, 0, _, {0,0,o.pos_x,o.pos_y,    t,0,x_end,y_end});
  end
  
end
-- ====================================================================== --
function private.unmark_ooo()
  local func_end = function()
    ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark[ "ooo" ]=false;
    private.set_task(true);
  end
  ld.Lock(1)
  SoundSfx( "aud_discover" )
  ld.AnimPlay("anm_musicanshoscr_anim_bant","anim_bant",func_end)  
end
-- ====================================================================== --
function private.unmark_qqq()
  local func_end = function()
    ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark[ "qqq" ]=false;
    private.set_task(true);
  end
  ld.Lock(1)
  SoundSfx( "aud_discover" )
  ld.AnimPlay("anm_musicanshoscr_anim_paw","anim_paw",func_end)
end
-- ====================================================================== --



---------------------------------------------------------------------------
function private.HintShow(hint_obj_name)
  local hints_table = { hint = {} };
  table.insert( hints_table.hint,  { ["pos_x"]=ObjGet(hint_obj_name).pos_x, ["pos_y"]=ObjGet(hint_obj_name).pos_y, ["obj_name"]=hint_obj_name } )   
  MsgSend( Command_Effect_ShowHoHint, hints_table );
end
---------------------------------------------------------------------------
function public.clk_hint()
  
  
  local doit = true;
  while doit do 
    local n = math.random(1,private.N);
    local obj = "spr_musicanshoscr_"..private.abc[n];
    if ObjGet(obj) then
      if ObjGet(obj).input or (ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark[ private.abc[n] ] and  ObjGet("obj_musicanshoscr_"..private.abc[n].."_unmark").input  ) then
        
        if ng_global.progress[ "scr" ][ "win_musicanshoscr" ].state_unmark[ private.abc[n] ] then
          private.HintShow("obj_musicanshoscr_"..private.abc[n].."_unmark");
        else
          private.HintShow(obj);
        end
        
        doit = false;
        break;
      end
    end
  end
  
end
---------------------------------------------------------------------------






function private.idle_gate(obj)
  
  if not private.idle_playing[obj] then
    private.idle_playing[obj] = true;
    local ang = ObjGet(obj).ang;
    local t = 0.5;
    ObjAnimate(obj, 7, 0, 0, function() private.idle_playing[obj]=false; end, 
    {
      0,    0,ang,
      1*t/4,0,ang-0.1,
      2*t/4,0,ang,
      3*t/4,0,ang+0.1,
        t,  0,ang
    });
  end
   
  SoundSfx( "aud_xx_inv_box_and_keys" );
end



-- simple effect from HO -------------------------------------------------------
function private.sparkle(object_name,t_end)
  
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 100, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  
  PartSysSetMaskObj( collect_name, object_name );  
  
  if t_end then
    ld.StartTimer( t_end*0.97, function() PartSysStop(collect_name,0);  end )  
  else
    ld.StartTimer( 5, function() ObjDelete( collect_name ) end )  
  end
  
end
-- simple effect from HO -------------------------------------------------------
