-- name=rm_achievements
--******************************************************************************************
function public.Init()

  ObjAttach( "rm_achievements", "rooms_hub" );


  ObjSet("spr_achievements_button_main_menu",{ 
    event_mdown =  function () private.Exit()           end,
    event_menter = function () private.ButtonMouseEnter( "main_menu" ); end,
    event_mleave = function () private.ButtonMouseLeave( "main_menu" ); end 
                    })


  common_impl.SetButtonTextColor({"txt_achievements_button_main_menu"}, nil, common_impl.ButtonTextOutlineColor())
end;
--******************************************************************************************
function public.PreOpen()

  private.achievements_show = 0
  ObjSet( "spr_achievements_achievement_back", {scale_x=0,scale_y=0} );

  if not cmn.is_inmenunow then
    --DbgTrace("screensaver open game")
      local widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Dialog_Task,
        InterfaceWidget_Simon,
      }


      if ObjGet("int_dialog_character") and ObjGet("int_dialog_character").input then
        private.dialog_char = true 
        interface.WidgetSetVisible( InterfaceWidget_DialogCharacter, false,true );
        interface.WidgetSetInput( InterfaceWidget_DialogCharacter, false)    
      else
        for i = 1, #widget_settings do
          interface.WidgetSetVisible( widget_settings[i], false,true );
          interface.WidgetSetInput(widget_settings[i],false)
        end;        
      end
    --int.InterfaceSetVisible(false,true);
    --int.InterfaceSetInput(false);
  end

  private.LoadAch()  

  --SoundTheme( "aud_achieve_mus", 1 )
end;
--******************************************************************************************
function public.Open()
  SoundEnv( "aud_track11_mus_env" )
  private.current_room = common.GetCurrentRoom();
  for i,o in ipairs(private.first_list) do
    
    if ng_global.achievements.done[o] then
      --ld.LogTrace( o,"false" );
      ObjSet( "fx_achievements_"..o, {active = 0, visible = 0} );
    else
      --ld.LogTrace( o,"true" );
      ng_global.achievements.done[o] = true
      ObjSet( "fx_achievements_"..o, {active = 1, visible = 1} );
    end
  end
end;

function public.Close()

  if not cmn.is_inmenunow then
    local widget_settings = 
    {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Dialog_Task,
        InterfaceWidget_Simon
        }


    if private.dialog_char then
      private.dialog_char = false
      interface.WidgetSetVisible( InterfaceWidget_DialogCharacter, true, true );
      interface.WidgetSetInput( InterfaceWidget_DialogCharacter, true)    
    else
      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], true, true );
        interface.WidgetSetInput(widget_settings[i],true)
      end;      
    end    
    --int.InterfaceSetVisible(true,true);
    --int.InterfaceSetInput(true);
  end
  SoundTheme( 0 )
end
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );

  local obj = "spr_achievements_button_"..but_name.."_focus";
  local txt = "txt_achievements_button_"..but_name;
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );
  ObjSet( txt, {color_r = 1, color_g = 1, color_b = 1} );
end;
--******************************************************************************************
--port.
function public.Hide()
  private.Exit();
end;
--******************************************************************************************
function private.Exit()
  if ( not private.current_room ) then

    private.current_room = "rm_extra";

  end;
    common.GotoRoom( private.current_room );

  SoundSfx( "aud_clk_menu" )
end


function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_achievements_button_"..but_name.."_focus";
  local txt = "txt_achievements_button_"..but_name;
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  local r,g,b = common_impl.ButtonTextColorLeave()
  ObjSet( txt, {color_r = r, color_g = g, color_b = b} );
end;



function private.LoadAch()
  private.first_list = {}
  local showallcheat = false
  local achive = {"ho_complete_task_3",
                  "ho_complete_task_5",
                  "ho_complete_task_10",
                  "ho_less_1min",
                  "ho_more_10min",
                  "ho_without_hint_all",
                  "mg_without_skip_all",
                  "miniature_all",
                  "morph_all",
                  "coll_all",
                  "mg_less_1min",

                  "scr_complete_simple",
                  "scr_complete_less6",
                  "scr_complete_less12",
                  "scr_complete_nohint",

                  --"achiev_fixdevice",
                  --"achiev_moonwalk",
                  --"achiev_coffee",
                  --"achiev_duel",
                  --"achiev_returnstar",
                  --"achiev_fatherfrost",
                  --"achiev_months",

  }

  local achive_with_counter = {"ho_without_hint",
                               "mg_without_skip",
                               "ho_less_3min"}

  for i=1,#achive do
    if showallcheat or ng_global.achievements.flag[ achive[ i ] ]then
      --DbgTrace("true "..achive[i])
      ObjSet( "spr_achievements_"..achive[i], {alp=1} );
      table.insert(private.first_list,achive[i])
    else 
      --DbgTrace("false "..achive[i])
      ObjSet( "spr_achievements_"..achive[i], {alp=0} );
    end
  end
  
  for j= 1,#achive_with_counter do
    local  count = {1,3,5,10}
        for a=1,#count do
          ObjSet( "spr_achievements_"..achive_with_counter[j].."_"..count[a], {alp=0} );
          if showallcheat or ng_global.achievements.counter[ achive_with_counter[ j ] ] >= count[a] then 
            ObjSet( "spr_achievements_"..achive_with_counter[j].."_"..count[a], {alp=1} );
            table.insert(private.first_list,achive_with_counter[j].."_"..count[a])
          end
        end
      
  end
end

private.achievements_show = 0
function public.ClkAch(name)
  --ld.LogTrace(name)

-- PlaySfx( "assets/levels/common/audio/aud_click_on_toys", 0, "", 0 )
  if private.achievements_show == 0 then
     private.achievements_show = 1 
    ObjAnimate( "spr_achievements_achievement_back", 6, 0, 0, "", {0,0,0,0, 0.5,0,1,1} );
  else

  end
  ObjSet( "txt_achievements_name", {text="str_achievement_"..name} );
  ObjSet( "txt_achievements_description", {text="str_achievement_"..name.."_description"} );

  if name == "morph_all" then 
    local count = 0
    for j=1,#ng_global.achievements.puzzle do
      if ng_global.achievements.puzzle[j] then
        count = count + 1
      end
    end 
    if count < #ng_global.achievements.puzzle then
      ObjSet( "txt_achievements_description", {text="str_achievement_morphtrash",param0 = count,param1 = #ng_global.achievements.puzzle} );   
    end
  end    

  if name == "coll_all" then 
    local count = 0
    for j=1,#ng_global.achievements.miniature do
      if ng_global.achievements.miniature[j] then
        count = count + 1
      end
    end 
    if count < #ng_global.achievements.miniature then
      ObjSet( "txt_achievements_description", {text="str_achievement_miniature",param0 = count,param1 = #ng_global.achievements.miniature} );   
    end
  end    

  SoundSfx( "aud_clk_menu" )
  
end

--******************************************************************************************
function public.AchMouseEnter ( ach_name )

  SetCursor( CURSOR_HAND );

  local obj = "spr_achievements_"..ach_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function public.AchMouseLeave ( ach_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_achievements_"..ach_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;

