-- name=rm_collectibles
--******************************************************************************************
function public.Init()
              
  ObjAttach( "rm_collectibles", "rooms_hub" );


  ObjSet("spr_collectibles_button_main_menu",{ 
    event_mdown =  function () private.Exit()           end,
    event_menter = function () private.ButtonMouseEnter( "main_menu" ); end,
    event_mleave = function () private.ButtonMouseLeave( "main_menu" ); end 
                    })

  common_impl.SetButtonTextColor({"txt_collectibles_button_main_menu"}, nil, common_impl.ButtonTextOutlineColor())
end;
--******************************************************************************************
function public.PreOpen()
  if not cmn.is_inmenunow then
    --DbgTrace("screensaver open game")
--      local widget_settings = 
--      {
--        InterfaceWidget_Inventory,
--        InterfaceWidget_BtnHint,
--        InterfaceWidget_BtnMap,
--        InterfaceWidget_BtnGuide,
--        InterfaceWidget_BtnMenu,
--        InterfaceWidget_Dialog_Task,
--      }
--
--      for i = 1, #widget_settings do
--        interface.WidgetSetVisible( widget_settings[i], false,true );
--        interface.WidgetSetInput(widget_settings[i],false)
--      end;
    int.InterfaceSetVisible(false,true);
    int.InterfaceSetInput(false);
  end

  private.Load()  
  --SoundTheme( "aud_achieve_mus", 1 )
end;
--******************************************************************************************
function public.Open()
  SoundEnv( "aud_track11_mus_env" )
  private.current_room = common.GetCurrentRoom();

  for i,o in ipairs(private.first_list) do
    
    if ng_global.achievements.done["coll"..tostring(o)] then

      ObjSet( "fx_rm_collectibles_col_"..o, {active = 0, visible = 0} );    
    
    else

      ld.CopyObj("fx_rm_collectibles_col", "fx_rm_collectibles_col_"..o, "partsys", "spr_collectibles_mouse_"..o)
      ObjSet( "fx_rm_collectibles_col_"..o, {active = 1, visible = 1} );
      ng_global.achievements.done["coll"..tostring(o)] = true

    end

  end

end;

function public.Close()
  if not cmn.is_inmenunow then
--    local widget_settings = 
--    {
--        InterfaceWidget_Inventory,
--        InterfaceWidget_BtnHint,
--        InterfaceWidget_BtnMap,
--        InterfaceWidget_BtnGuide,
--        InterfaceWidget_BtnMenu,
--        InterfaceWidget_Dialog_Task,
--    }
--
--    for i = 1, #widget_settings do
--      interface.WidgetSetVisible( widget_settings[i], true, true );
--      interface.WidgetSetInput(widget_settings[i],true)
--    end;
    int.InterfaceSetVisible(true,true);
    int.InterfaceSetInput(true);
  end
  SoundTheme( 0 )
end
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );
  interface.PopupShow( 'str_menu_back')
  local obj = "spr_collectibles_button_"..but_name.."_focus";
  local txt = "txt_collectibles_button_"..but_name;
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );
  ObjSet( txt, {color_r = 1, color_g = 1, color_b = 1} );
end;


function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );
  interface.PopupHide()
  local obj = "spr_collectibles_button_"..but_name.."_focus";
  local txt = "txt_collectibles_button_"..but_name;
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  local r,g,b = common_impl.ButtonTextColorLeave()
  ObjSet( txt, {color_r = r, color_g = g, color_b = b} );
end;
--******************************************************************************************
function public.CollMouseClick ( coll_name )

  local obj = coll_name.."_focus";
  
end;
--******************************************************************************************
function public.CollMouseEnter ( coll_name )

--  SetCursor( CURSOR_HAND );

  local obj = coll_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function public.CollMouseLeave ( coll_name )

--  SetCursor( CURSOR_DEFAULT );

  local obj = coll_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
--port.
function public.Hide()
  private.Exit();
end;
--******************************************************************************************
function private.Exit()
  if ( not private.current_room ) then

    private.current_room = "rm_extra";

  end;
    common.GotoRoom( private.current_room );
  SoundSfx( "aud_clk_menu" )
end






function private.Load()
  private.first_list = {}
  for i=1,#ng_global.achievements.miniature do
    local obj = "spr_collectibles_mouse_"..i
    local foc = "spr_collectibles_mouse_"..i.."_focus"
    ObjSet( foc, {alp = 0} );
    if ng_global.achievements.miniature[i] then
      if ng_global.achievements.show_miniature[i] then
        ld.Lock(1)
        ObjAnimate( obj, 8, 0, 0, function() ObjSet( obj, {input = 1} ); ld.Lock(0);end, {0,0,0, 0.5,0,1} );
      else
        ObjSet( obj, {input = 1, visible = 1} );
        ObjSet( foc, {visible = 1} );
      end
      table.insert(private.first_list,i)
    else
      ObjSet( obj, {input = 0, visible = 0} );
      ObjSet( foc, {visible = 0} );
    end
  end

end

