-- name=rm_credits
--******************************************************************************************
function public.Init()

  private.screen_current = 0;

  private.screen_max = #ObjGetRelations( "obj_credits_screens" ).childs;
  --private.screen_countline = { 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3 };

  SetCursor(CURSOR_DEFAULT);

  ObjSet("obj_credits_btn_quit", {
    event_mdown = function () private.QuitClk(); end,
    event_menter = function () private.ButtonMouseEnter("obj_credits_btn_quit"); end,
    event_mleave = function () private.ButtonMouseLeave("obj_credits_btn_quit"); end
  }); 

  common_impl.SetButtonTextColor({"txt_credits_btn_quit"}, nil, common_impl.ButtonTextOutlineColor())


  local function GetTextParams(obj) 
    local obj = ObjGet(obj);
    return obj.outline_size, obj.color_r, obj.color_g, obj.color_b, "text";
  end
  local function GetStringsList(string, n, postfix) 
    local result = {}
    postfix = postfix or ""
    for i = 1, n do
      result[i] = string..i..postfix
    end
    return result;
  end
  common_impl.SetButtonTextColor(GetStringsList("txt_credits_",private.screen_max), nil, GetTextParams("txt_credits_1"))
  common_impl.SetButtonTextColor(GetStringsList("txt_credits_",private.screen_max,"_1"), nil, GetTextParams("txt_credits_1_1"))
end;
--******************************************************************************************
function public.PreOpen()

  SoundEnv( 0 )
 
  ObjSet( "rm_credits", { alp = 1 });

  interface.InterfaceSetInput( false ); 
  interface.InterfaceSetVisible( false );

  if IsCollectorsEdition() then

    ObjSet( "spr_credits_colectorsedition", { visible  = 1, alp = 1 } );

  else

    ObjSet( "spr_credits_colectorsedition", { visible = 0 } );

  end;

  ObjSet( "obj_credits_btn_quit", { alp = 0, input = 0 } );

  for i = 1, private.screen_max do

    ObjSet( "obj_credits_screen_"..i, { alp = 0 } );
    
    --ObjSet( "txt_credits_"..i, { res = "assets/fonts/times", fontsize = 24, color_r = 1, color_g = 0.733, color_b = 0.556 } );
    --ObjSet( "txt_credits_"..i.."_1", { res = "assets/fonts/times", fontsize = 24, color_r = 0.239, color_g = 0.811, color_b = 1 } );

  end;

  ObjSet( "txt_credits_title_1", { alp = 0 } );
  ObjSet( "txt_credits_title_2", { alp = 0 } );

end;
--******************************************************************************************
function public.Open()

  --SoundTheme( 0 )
  private.SoundThemePlay()

  --SoundTheme( "aud_catstown_mus" )
  private.current_room = common.GetCurrentRoom();

  private.screen_current = 0;

  private.Screen();

  local prg  = ng_global.currentprogress;  

  local func_end = function ()

    ObjSet( "obj_credits_btn_quit", { alp = 1, input = 1 } );

  end;

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,  0,  0, 
    2,  0,  0, 
    3,  0,  1 
  });

  --common_impl.StopAllMus( "common/audio/mus/aud_credits_mus" );
  --common_impl.PlayAudio( "mus", "common/audio/mus/aud_credits_mus", 1 );


  if  ( not cmn.is_inmenunow ) then
  if prg == "std" then 
    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "std" ][ "clk_outro3" ] and 
       cmn.IsEventDone( "clk_outro3" ) --[[ng_global.progress[ "std" ][ "vid_fork_3_autro" ].done == 1]]  then
      ng_global.progress[ "std" ].common.gamewin   = true; 
      ng_global.progress[ "std" ].common.gamestart = false;
      SaveProfiles();
      SaveSettings();

    end;

  elseif prg == "ext" then

    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "ext" ][ "clk_outroext" ] and
       cmn.IsEventDone( "clk_outroext" ) then
      ng_global.progress[ "ext" ].common.gamewin   = true; 
      ng_global.progress[ "ext" ].common.gamestart = false;
      SaveProfiles();
      SaveSettings();
    end;
  end;
  end

end;
--******************************************************************************************
function public.Close()

  interface.InterfaceSetInput( true );
  interface.InterfaceSetVisible( true );

  for i = 1, private.screen_max do

    ObjStopAnimate( "obj_credits_screen_"..i, "alp" );
    ObjSet( "obj_credits_screen_"..i, { alp = 0 } );

  end;

end;
--******************************************************************************************
function public.PreClose()
  private.SoundThemeStop()
end;
--******************************************************************************************
function private.Screen ()

  ObjSet( "rm_credits", { input = true } );

  local line_time = 1.0;
  local min_screen_time = 4.0;
  local time = 0;

  local func_exit = function ()

    private.Exit();
  
  end;

  local func_continue = function ()

    private.Screen();
  
  end;

  if private.screen_current > 0 then

    ObjAnimate("obj_credits_screen_"..private.screen_current, "alp", 0, 0, "", { 
      0,  0,  1, 
      1,  0,  0, 
    })

    private.screen_current = private.screen_current + 1;

    if private.screen_current > private.screen_max then

      ObjAnimate( "rm_credits", "alp", 0, 0, func_exit, { 0,0,1, 2,0,0 });

    else

      local text = StringGet( ObjGet( "txt_credits_"..private.screen_current.."_1" ).text )
      local _, lines = text:gsub( "\n", "" );
      lines = lines + 1
      time = math.max(lines * line_time, min_screen_time);

      ObjAnimate("obj_credits_screen_"..private.screen_current, "alp", 0, 0, func_continue, { 
        0,     0,  0, 
        1,     0,  0, 
        1.5,   0,  1,
        time,  0,  1 
      });

    end;

    if private.screen_current == 9 then

      ObjAnimate( "txt_credits_title_1", "alp", 0, 0, "", { 
        0,   0, 1,   
        0.5, 0, 0 
      });

      ObjAnimate( "txt_credits_title_2", "alp", 0, 0, "", { 
        0,   0, 0,   
        1.0, 0, 1 
      });

    elseif private.screen_current == private.screen_max then

      ObjAnimate("txt_credits_title_2", "alp", 0, 0, "", { 
        0,0,1, 
        0.5,0,0 
      });

    end;

  else
    private.screen_current = private.screen_current + 1;
    if private.screen_current == 1  then

      ObjAnimate( "txt_credits_title_1", "alp", 0, 0, "", { 
        0,0,0, 
        1,0,1 
      });

      local text = StringGet( ObjGet( "txt_credits_"..private.screen_current.."_1" ).text )
      local _, lines = text:gsub( "\n", "" );
      lines = lines + 1
      time = lines * line_time;

    end;



    ObjAnimate( "obj_credits_screen_"..private.screen_current, "alp", 0, 0, func_continue, { 
      0,     0,  0, 
      1,     0,  1, 
      1.5,   0,  1,
      time,  0,  1

    });
--    
    
--
--    ObjAnimate( "obj_credits_screen_"..private.screen_current, "alp", 0, 0, func_continue, { 
--      0,     0,  0, 
--      1,     0,  0, 
--      1.5,   0,  0,
--      time,  0,  0,
--      time+1,0,  0,
--    time+1.5,0,  1,
--      2*time,0,  1 
--    });
--


  end;

end;
--******************************************************************************************
function private.ButtonMouseEnter (sender)

  local tme = 0.3;
  local obj = "spr_credits_btn_quit_focus";
  local alp = ObjGet( obj ).alp;
  SetCursor( CURSOR_HAND );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,               0,    alp, 
    tme *( 1 - alp ),  0,    1
  } );
  if (sender == "obj_credits_btn_quit") then 
    ObjSet( "txt_credits_btn_quit", {color_r = 1, color_g = 1, color_b = 1} );
  end

end;
--******************************************************************************************
function private.ButtonMouseLeave (sender)

  local tme = 0.3;
  local obj = "spr_credits_btn_quit_focus";
  local alp = ObjGet( obj ).alp;
  SetCursor( CURSOR_DEFAULT );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,                      0, alp, 
    tme * alp, 0,    0
  } );
  if (sender == "obj_credits_btn_quit") then
    local r,g,b = common_impl.ButtonTextColorLeave()
    ObjSet( "txt_credits_btn_quit", {color_r = r, color_g = g, color_b = b} );
  end

end;
--******************************************************************************************
function private.QuitClk ()

  ObjSet( "rm_credits", { input = 0 } );

  ObjStopAnimate( "obj_credits_screen_"..private.screen_current, "alp" );

  local func_end = function ()

    private.Exit();

  end;

  if ObjGet( "obj_credits_screen_"..private.screen_current - 1 ) then
    ObjAnimate("obj_credits_screen_"..private.screen_current - 1, "alp", 0, 0, "", { 
      0,    0,  ObjGet( "obj_credits_screen_"..private.screen_current-1 ).alp, 
      0.5,  0,  0 
    });
  end
  if ObjGet( "obj_credits_screen_"..private.screen_current ) then
    ObjAnimate("obj_credits_screen_"..private.screen_current, "alp", 0, 0, "", { 
      0,    0,  ObjGet( "obj_credits_screen_"..private.screen_current ).alp, 
      0.5,  0,  0 
    });
  end

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,    0,  1, 
    0.5,  0,  1, 
    0.8,  0,  0 
  });

  common_impl.PlayAudio( "sfx", "common/audio/aud_clk_menu" );

end;
--******************************************************************************************
--port. fix 
function public.Exit()
  private.Exit();
end;
--******************************************************************************************
function private.Exit ()

  local prg  = ng_global.currentprogress;  
  local flag = true;
if  ( not cmn.is_inmenunow ) then
  if prg == "std" then 

    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "std" ][ "clk_outro3" ] and 
       cmn.IsEventDone( "clk_outro3" ) --[[ng_global.progress[ "std" ][ "vid_fork_3_autro" ].done == 1]]  then
        
        private.Skip();

        flag = false;

    end;

  elseif prg == "ext" then

    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "ext" ][ "clk_outroext" ] and
       cmn.IsEventDone( "clk_outroext" ) then
        
      private.SkipExt();
      flag = false;
      
    end;

  end;
end

  common_impl.StopAllMus();

  if ( not private.current_room ) then

    private.current_room = "rm_menu";

  end;

  if ( flag ) then

    common.GotoRoom( private.current_room );

  end;

end;
--******************************************************************************************
function private.Skip ()

--  ng_global.progress[ "std" ].common.gamewin   = true; 
--  ng_global.progress[ "std" ].common.gamestart = false;
--
--  SaveProfiles();
--  SaveSettings();
----
 SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;
--******************************************************************************************
function private.SkipExt ()

--  ng_global.progress[ "ext" ].common.gamewin   = true; 
--  ng_global.progress[ "ext" ].common.gamestart = false;
--
--  SaveProfiles();
--  SaveSettings();
--
  SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;
--******************************************************************************************
function private.SoundThemePlay( next_treck )
  if ( not next_treck ) or ( not private.PlayMus_count ) then
    private.PlayMus_count = 0
  end
  private.PlayMus_count = private.PlayMus_count % 3 + 1
  local mus = {
    { "aud_credits_mus", 86 };
    { "aud_track11_mus_env", 56 };
    { "aud_track10_mus_env", 81 };
  }
  SoundTheme( mus[ private.PlayMus_count ][ 1 ] )
  ld.LogTrace( "SoundThemePlay", mus[ private.PlayMus_count ][ 1 ], mus[ private.PlayMus_count ][ 2 ], next_treck )
  ld.StartTimer( mus[ private.PlayMus_count ][ 2 ], function() private.SoundThemePlay( true ) end )
end
--******************************************************************************************
function private.SoundThemeStop()
  SoundTheme( 0 )
end