-- name=rm_menu
--******************************************************************************************
function public.Init()

  ObjSet("menu_but_play", 
  {
    event_mdown = private.PlayDown
  });
  ObjSet("menu_but_options", 
  {
    event_mdown = private.OptionsDown
  });
  
  ObjSet("menu_but_moregames", 
  {
    event_mdown = private.MoreGamesDown
  });
  
  ObjSet("menu_but_profile", 
  {
    event_mdown = private.ProfileDown
  });
  
  ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown });
  ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
  ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
  ObjSet("menu_but_gear", { event_mdown = private.GearClick });
  ObjSet("menu_but_extra", { event_mdown = private.ExtraDown });
  ObjSet("menu_but_forum", { event_mdown = private.ForumDown });
  ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
  ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
  ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
  ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
    
    
  ObjSet("spr_menu_but_back_button", { event_mdown = function() public.closeGearSubMenu(); end });
  ObjSet("menu_but_gear", { event_mdown = function() public.openGearSubMenu(); end });
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });

  private.wait_gear = false;
  public.sub_menu_active = false;
  
  if port.ios_lang() == "ja" then
    ObjSet("txt_menu_but_sequel",{ scale_x = 0.85, scale_y = 0.7, pos_y = 66, fontsize = 14 });
  end;
  
  if GetPlatform() == "android" then
    ObjSet("menu_but_forum",{ alp = 0, input = false, visible = false });  
    ObjSet("menu_but_credits",{ pos_x = 512 });  
  end;
end;


--******************************************************************************************
function public.closeGearSubMenu()
  
  public.sub_menu_active = false;
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
end;
--******************************************************************************************

function public.openGearSubMenu()
  
  public.sub_menu_active = true;
  ObjSet("menu_port_hub_sub_menu", { active = true, visible = true, input = true, alp = true });
  
end;

 --******************************************************************************************
function public.gearOverAngle()
  local current_ang = ObjGet("spr_menu_but_gear").ang;
  if GetCurrentRoom() == "rm_menu" then
    if private.wait_gear then
      ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() 
        private.wait_gear = false; 
        rm_menu.gearOverAngle();
      end  } );
    else
      private.wait_gear = true;
      local end_ang = current_ang + ((360/8)*3.14)/180;
      ObjAnimate( "spr_menu_but_gear", "ang", 0, 0, function() public.gearOverAngle(); end , {0,0,current_ang, 1,0,end_ang} ); 
    end;
  end;
  
end;
--******************************************************************************************
function public.PreOpen()
    
  --ObjSet( "menu_ce_buttons_left",  { active = false, visible = false, input = false } );
  --ObjSet( "menu_ce_buttons_right", { active = false, visible = false, input = false } );

  --if ( IsCollectorsEdition()) then --or ld.IsLdCheater() then
  --  ObjSet( "menu_ce_buttons_right", { active = true, visible = true, input = true } );
  --  ObjSet( "spr_menu_logo_ce", {visible = 1} );
  --else
  --  ObjSet( "menu_ce_buttons_right", { active = false, visible = false, input = false } );
  --  ObjSet( "spr_menu_logo_ce", {visible = 0} );
  --end;


  --if IsSurveyEdition() then --and not ld.IsLdCheater() then
  --  ObjSet( "menu_but_strguide", {visible = 0, input = 0} );
  --  ObjSet( "menu_but_moregames", {visible = 0, input = 0} );
  --end
  
  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();

  SoundEnv( "aud_main_menu_env" )
  SoundTheme( "aud_main_theme_mus", 1 )
  
  --=============================================================================
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
  private.wait_gear = false;
  public.gearOverAngle();
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      iOS_LogEvents(2);
      
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if not preformance_warning then
      preformance_warning = true;
      ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 2, playing = 1 });
    end;

    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;
  --============================================================
  
end;
--******************************************************************************************
function private.PerformanceWarning()
  if tostring(GetPlatform()) == "ios" then
    iOS_PerformanceWarning();
  else
    DbgTrace("SetPerformanceMode(1)");
    SetPerformanceMode(1);
  end;
end;
--******************************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--******************************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-------------------------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
--******************************************************************************************
function public.Open()

    if ng_global.progress then
      if ( (not ng_global.progress[ "std" ].common.gamestart ) and ( ng_global.progress[ "std" ].common.gamewin ) ) and  not (ng_global.bonusunlock) then
        if IsCollectorsEdition() then
          common.DialogWindowShow( "common", "complete_std",true );
        else 
          common.DialogWindowShow( "common", "complete_std_se",true );
        end
      
        ng_global.bonusunlock = true
        SaveProfiles();
      end;
    end

end;
--******************************************************************************************
function public.SetProfileText ( name )
  
  local obj = "txt_menu_but_profile_change";
  local profile_name = "";
  if  ( name ~= "ng_noprofiles" )
  and ( name ~= "ng_error" )
  then
  profile_name = name;
  end;
  ObjSet( obj, { text = profile_name } );

end;
--******************************************************************************************
function private.PlayDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )
  common_impl.MenuPlay();


end;
--******************************************************************************************
function private.OptionsDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )
  common.MenuOptions();
end;
--******************************************************************************************
function private.CreditsDown()
  --PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )
  common.MenuCredits();
end;
--******************************************************************************************
function private.QuitDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )
  common.MenuQuit();  
end;
--******************************************************************************************
function private.ExtraDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )
  if port.isPortable() == 1 then
    if iOS_IsBought() == 1 then
      common.MenuExtra();
    else
      common.MenuUnlock();
    end;
  else
    common.MenuExtra();
  end;
end;
--******************************************************************************************
function private.StrguideDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )


    if IsCollectorsEdition() then

      common_impl.ButtonGuide_Click();
      interface.StrategyGuideShow();

    else

      local guide_url = GetGuideUrl();
      OpenBrowser( guide_url );

    end;

end;
--******************************************************************************************
function private.ProfileDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )
  common.MenuProfile();
end;
--******************************************************************************************
function private.ShopDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )
  common.MenuShop();
end;
--*****************************************************************************************
function private.MoreGamesDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 )
  --common.GotoRoom( "rm_moregames" );
  iOS_MoreGamesPressed();
end;
--*************************************ios*****************************************************
function private.Save50Down()
  
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 );
  
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 );
  
  common.MenuUnlock();
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 );
  
  common.MenuSneakPeak();
end;
--*************************************ios*****************************************************
function private.ForumDown()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 );
  iOS_LaunchForum();
end;
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )
  SetCursor( CURSOR_HAND );
  local obj = "spr_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  PlaySfx( "assets/levels/common/audio/aud_menu_icon_focus", 0, "", 0.0 )

  local obj_txt = "txt_menu_but_"..but_name
  local txt_param = ObjGet(obj_txt)
  ObjAnimate( obj_txt, 12, 0, 0, "", {0,0,txt_param.color_r,txt_param.color_g,txt_param.color_b, ( common_impl.animtime * alp ) ,0,common_impl.ButtonTextColorEnter()} );

  if but_name == "play" then
    --SoundEnv( "aud_candle_burn_env", 1 )
    --ObjAnimate( "pfx_menu_pm_candel", 8, 0, 0, "", {0,0,0, ( common_impl.animtime * alp ),0,1} );
  end
end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )
  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  local obj_txt = "txt_menu_but_"..but_name
  local txt_param = ObjGet(obj_txt)
  ObjAnimate( obj_txt, 12, 0, 0, "", {0,0,txt_param.color_r,txt_param.color_g,txt_param.color_b, ( common_impl.animtime * alp ) ,0,common_impl.ButtonTextColorLeave()} );

  if but_name == "play" then
    SoundEnv( "aud_candle_burn_env", 0 )
    ObjAnimate( "pfx_menu_pm_candel", 8, 0, 0, "", {0,0,1, ( common_impl.animtime * alp ),0,0} );
  end

end;
--******************************************************************************************
function public.ButtonSetPos()
  local offwidth = 0.5 * ( GetAppWidth() - 1024 );
  --ObjSet( "menu_objects_left",  { pos_x = ( 512 - offwidth ) } );
  --ObjSet( "menu_objects_right", { pos_x = ( 512 + offwidth ) } );
end;
--*****************************************************************************************
-------------------------------CLK-FUCTIONS-----------------------------------------------
------------------------------------------------------------------------------------------

--*****************************************************************************************
