-- name=rm_moregames
--******************************************************************************************
function public.Init()

  ObjAttach( "rm_moregames", "rooms_hub" );

  local countOfScreens = 4

  local table_multiset = {};

  for i = 1,countOfScreens do 
 
    table.insert( table_multiset, 
                  {
                    "btn_moregames_button_"..i, 
                      { 
                        event_mdown =  function () private.ChangeURL( i );          end,
                        event_menter = function () private.ButtonMouseEnter( i ); end,
                        event_mleave = function () private.ButtonMouseLeave( i ); end 
                      }
                } 
    );

    common_impl.SetButtonTextColor({"txt_moregames_button_"..i}, nil, common_impl.ButtonTextOutlineColor())

  end;

  table.insert( table_multiset, 
                {
                  "spr_moregames_button_main_menu", 
                    { 
                      event_mdown =  function () common.GotoRoom( "rm_menu" );            end,
                      event_menter = function () private.ButtonMouseEnter( "main_menu" ); end,
                      event_mleave = function () private.ButtonMouseLeave( "main_menu" ); end 
                    }
                }
  );
  common_impl.SetButtonTextColor({"txt_moregames_button_main_menu"}, nil, common_impl.ButtonTextOutlineColor())
  
  ObjMultiSet( table_multiset );
  

  ----------------------------------------------------------------------------------------
  private.Link = 
  {
    -- game_nutcracker
    { 
      mac_ce = "http://www.bigfishgames.com/games/7959/christmas-stories-nutcracker-ce/?mac",
      mac_se = "http://www.bigfishgames.com/games/8005/christmas-stories-the-nutcracker/?mac",

      win_ce = "http://www.bigfishgames.com/games/7959/christmas-stories-nutcracker-ce/",
      win_se = "http://www.bigfishgames.com/games/8005/christmas-stories-the-nutcracker/"
    },
    -- game_christmascarol 
    { 
      mac_ce = "http://www.bigfishgames.com/games/7772/christmas-stories-a-christmas-carol-ce/?mac",
      mac_se = "http://www.bigfishgames.com/games/7790/christmas-stories-a-christmas-carol/?mac",

      win_ce = "http://www.bigfishgames.com/games/7772/christmas-stories-a-christmas-carol-ce/",
      win_se = "http://www.bigfishgames.com/games/7790/christmas-stories-a-christmas-carol/"
    },
    -- game_tinsoldier 
    { 
      mac_ce = "http://www.bigfishgames.com/games/8382/christmas-stories-3-andersens-tin-soldier-ce/?mac",
      mac_se = "http://www.bigfishgames.com/games/8466/christmas-stories-3-andersens-tin-soldier/?mac",

      win_ce = "http://www.bigfishgames.com/games/8382/christmas-stories-3-andersens-tin-soldier-ce/?pc",
      win_se = "http://www.bigfishgames.com/games/8466/christmas-stories-3-andersens-tin-soldier/?pc"
    },
--     game_pussinboots
    { 
      mac_ce = "http://www.bigfishgames.com/games/11234/christmas-stories-puss-in-boots-ce/?mac",
      mac_se = "http://www.bigfishgames.com/games/8967/christmas-stories-puss-in-boots/?mac",

      win_ce = "http://www.bigfishgames.com/games/11234/christmas-stories-puss-in-boots-ce/",
      win_se = "http://www.bigfishgames.com/games/8967/christmas-stories-puss-in-boots/?pc"
    }

  }
end;
--******************************************************************************************
function public.PreOpen()
    if IsCollectorsEdition() then
      ObjSet( "spr_moregames_logo_ce", {visible = 1} );
      ObjSet( "obj_moregames_collectors_edition", {visible = 1} );
    else 
      ObjSet( "spr_moregames_logo_ce", {visible = 0} );
      ObjSet( "obj_moregames_collectors_edition", {visible = 0} );
    end
end;
--******************************************************************************************
function public.Open()

end;

--******************************************************************************************
function private.ChangeURL( but_name )
  
  local link = "";
  local mas_name = "Link";
  --local platform = GetPlatform();
-- -- local name = ne_params.sender;
-- -- local num_games = tonumber(  string.sub( name, string.len( name ) ,string.len( name ) ) );
-- 
  local num_games = tonumber(  string.sub( but_name, string.len( but_name ) ,string.len( but_name ) ) );
--
  if IsCollectorsEdition() then

--    if platform == "mac" then
    if GetPlatform() =="mac" then

      link = private[mas_name][ num_games ][ "mac_ce" ];

    else
     
      link = private[mas_name][ num_games ][ "win_ce" ];
  
    end;
--
  else
--
    --if platform == "mac" then
    if GetPlatform() =="mac" then
     
      link = private[mas_name][ num_games ][ "mac_se" ];      

    else
      
      link = private[mas_name][ num_games ][ "win_se" ];      
    
    end;

  end;
  

  OpenBrowser( link );

end;
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );

  local obj = "spr_moregames_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  local obj_txt = "txt_moregames_button_"..but_name;

  local txt_param = ObjGet(obj_txt)
  if txt_param then
    --ObjAnimate( obj_txt, 12, 0, 0, "", {0,0,txt_param.color_r,txt_param.color_g,txt_param.color_b, ( common_impl.animtime * alp ) ,0,common_impl.ButtonTextColorEnter()} );
  end
  --ObjSet( "txt_moregames_button_"..but_name, {fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );
  ObjSet( "txt_moregames_button_"..but_name, {color_r = 1, color_g = 1, color_b = 1} );
end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_moregames_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  local obj_txt = "txt_moregames_button_"..but_name;

  local txt_param = ObjGet(obj_txt)
  if txt_param then
    --ObjAnimate( obj_txt, 12, 0, 0, "", {0,0,txt_param.color_r,txt_param.color_g,txt_param.color_b, ( common_impl.animtime * alp ) ,0,common_impl.ButtonTextColorLeave()} );
  end
  --ObjSet( "txt_moregames_button_"..but_name, {fontcolor_r = 1, fontcolor_g = 0.635, fontcolor_b = 0.282 } );
  local r,g,b = common_impl.ButtonTextColorLeave()
  ObjSet( "txt_moregames_button_"..but_name, {color_r = r, color_g = g, color_b = b} );

end;