-- name=rm_sequel
--*****************************************************************************************
function public.Open()
  
end;

function public.PreClose()
  iOS_LogEvents(0);
end;

function public.Init()
  ObjAttach("rm_sequel", "ng_rooms_hub");
end;

function private.button_click()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 );
end;
--------------------------------------------------------------
port.sequel = {};
port.sequel.screen_curr = 0;
local slide_animation = 0;
 
--------------------------------------------------------------------
local screen_start_pos = {0,0,0,0};
local screen = 0;
local screen_arr_pos = {
  { 230,640,3,0 }
 ,{ 230,400,2,0 }
 ,{ 230,160,1,0 }
};
local circle_arr_pos = {
  { -48, 0 }
 ,{   0, 0 }
 ,{  47, 0 }
};

--------------------------------------------------------------------
function public.ScreenDown( number )
    local num = number or port.sequel.screen_curr;
    if (slide_animation == 0) then
      private.button_click();
      port.TapDown(0.7);
      screen = "spr_sequel_screen_"..num;
    

    if ObjGet( screen ).scale_x == 1 then

        ObjSet( "spr_sequel_screen_black", { input = 0 } );
        ObjSet( "obj_sequel_btn_screen_hub", { visible = 0, active = 0, input = 0 } );
        ObjAnimate( "spr_sequel_screen_black", "alp", 0, 0, "", { 0,0,0.6, 0.2,0,0 });
        ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,512,384, 0.3,3,screen_start_pos[1],screen_start_pos[2]});
        ObjAnimate( screen , "pos_z", 0, 0, "", {0,0,11,  0.1,0,screen_start_pos[3]});
        ObjAnimate( screen , "ang", 0, 0, "", {0,3,0, 0.3,3,screen_start_pos[4]} );
        ObjAnimate( screen , "scale_xy", 0, 0, "", {0,3,1,1, 0.3,3,0.3,0.3} );
        ObjAnimate( "spr_sequel_circles", "alp", 0, 0, function() private.SlideEnd(); end, { 0,0,1, 0.3,0,0 });     
        screen_start_pos = {0,0,0,0};
        screen = 0;

    else

        port.sequel.screen_curr = num;
        screen = "spr_sequel_screen_"..num;
        screen_start_pos[1] = ObjGet( screen).pos_x;
        screen_start_pos[2] = ObjGet( screen ).pos_y;
        screen_start_pos[3] = ObjGet( screen ).pos_z;
        screen_start_pos[4] = ObjGet( screen ).ang;

        ObjSet( "spr_sequel_screen_black", { input = 1 } );
        ObjSet( "obj_sequel_btn_screen_hub", { visible = 1, active = 1, input = 1 } );
        ObjAnimate( "spr_sequel_screen_black", "alp", 0, 0, "", { 0,0,0, 0.2,0,0.6 });
        ObjAnimate( "obj_sequel_btn_screen_hub", "alp", 0, 0, "", { 0,0,0, 0.1,0,0, 0.4,0,1 });
        ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,screen_start_pos[1],screen_start_pos[2],  0.3,3,512,384});
        ObjAnimate( screen , "pos_z", 0, 0, "", {0,0,screen_start_pos[3],  0.1,0,11});
        ObjAnimate( screen , "ang", 0, 0, "", {0,3,screen_start_pos[4], 0.3,3,0} );
        ObjAnimate( screen , "scale_xy", 0, 0, "", {0,3,0.3,0.3, 0.3,3,1,1} );
        ObjAnimate( "spr_sequel_circles", "alp", 0, 0, function() private.SlideEnd(); end, { 0,0,0, 0.3,0,1 });
        ObjSet( "spr_sequel_circle", { pos_x = circle_arr_pos[port.sequel.screen_curr][1] });
    end;
    slide_animation = 1;
    end;
end;

--------------------------------------------------------------------
function public.BackDown()

    private.button_click();
       
    iOS_LogEvents( 0 );

    if cmn.is_inmenunow then
        common.GotoRoom( "rm_menu" );
    else
        SwitchLevel("assets/levels/menu/menu", "menu_start(game)");
    end;

end;
--------------------------------------------------------------------
function public.SequelDown()

    private.button_click();
       iOS_RateItPressed();
    common.GotoRoom( "rm_menu" );
 
end;

function public.SequelFeedbackDown()

    private.button_click();
       iOS_FeedbackPress();
    common.GotoRoom( "rm_menu" );
 
end;
-------------------------------------------------------------------
function private.SlideEnd()
slide_animation = 0;
end;
--------------------------------------------------------------------
function public.ArrowDown( way )
  
  if (slide_animation == 0) then
    private.button_click();
       
  port.TapDown(1.3);
  ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,512,384, 1,3,512+1100*way,384, 1,3,screen_start_pos[1],screen_start_pos[2]});
  ObjAnimate( screen , "pos_z", 0, 0, "", {0,0,11,  0.8,0,11, 0.9,0,screen_start_pos[3]});
  ObjAnimate( screen , "ang", 0, 0, "", {0,3,0, 1,3,screen_start_pos[4]} );
  ObjAnimate( screen , "scale_xy", 0, 0, "", {0,3,1,1, 1,3,0.3,0.3} );
  local start_pos_x = circle_arr_pos[port.sequel.screen_curr][1];

  port.sequel.screen_curr = port.sequel.screen_curr + way;

  if (port.sequel.screen_curr > 3) then
    port.sequel.screen_curr = 1;
  end
  if (port.sequel.screen_curr < 1) then
    port.sequel.screen_curr = 3;
  end

  screen = "spr_sequel_screen_"..port.sequel.screen_curr;
  screen_start_pos[1] = screen_arr_pos[port.sequel.screen_curr][1];
  screen_start_pos[2] = screen_arr_pos[port.sequel.screen_curr][2];
  screen_start_pos[3] = screen_arr_pos[port.sequel.screen_curr][3];
  screen_start_pos[4] = screen_arr_pos[port.sequel.screen_curr][4];

  way = way*(-1);

  ObjAnimate( "spr_sequel_circle", "pos_x", 0, 0, "", { 0,3,start_pos_x, 0.3,3,start_pos_x, 0.3,3,circle_arr_pos[port.sequel.screen_curr][1] });
  ObjAnimate( "spr_sequel_circle", "alp", 0, 0, "", { 0,3,1, 0.3,3,0, 0.3,3,0, 1.0,3,1 });
  ObjAnimate( "obj_sequel_btn_screen_hub", "alp", 0, 0, "", { 0,0,1, 0.3,0,0, 1,0,0, 1.3,0,1 });
  ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,screen_start_pos[1],screen_start_pos[2],  0.3,3,512,384});
  ObjAnimate( screen , "pos_z", 0, 0, "", {0,0,11,  1,0,11});
  ObjAnimate( screen , "ang", 0, 0, "", {0,3,0, 1,3,screen_start_pos[4]} );
  ObjAnimate( screen , "scale_xy", 0, 0, function() private.SlideEnd(); end, {0,3,0.4,0.4, 1.3,3,1,1} );
  --ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,512+1100*way,384, 1,3,512,384});
  
  slide_animation = 1;
  end;
end;
--------------------------------------------------------------------
--*****************************************************************************************
