-- name=rm_unlock
--******************************************************************************************
function public.Init()

  ObjAttach("rm_unlock", "ng_rooms_hub");
  if tostring(GetPlatform()) == "android" then
    ObjSet("obj_unlock_already_purchase",{ input = 0, alp = 0, visible = 0 });
  end;
end;

function private.button_click()
  PlaySfx( "assets/levels/common/audio/aud_clk_menu", 0, "", 0.0 );
end;

--------------------------------------------------------------------
port.unlock = {};
port.unlock.screen_curr = 0;

--------------------------------------------------------------------
local screen_start_pos = {0,0,0,0};
local screen = 0;
local screen_arr_pos = {
  { 160,150,1,0 }
 ,{ 310,290,2,0 }
 ,{ 160,370,1,0 }
 ,{ 310,520,2,0 }
 ,{ 160,610,1,0 }
};
local circle_arr_pos = {
  { -92, -3 }
 ,{ -46, -3 }
 ,{   0, -3 }
 ,{  46, -3 }
 ,{  92, -3 }
};

local slide_enable = 0;
--------------------------------------------------------------------
screen_start_pos = {0,0,0,0};
screen = 0;
--------------------------------------------------------------------
function public.ScreenDown( number )
    local num = number or port.unlock.screen_curr;

    if (slide_enable == 0 ) then
      private.button_click();
      port.TapDown(0.7);
    screen = "spr_unlock_screen_"..num;

    if ObjGet( screen ).scale_x == 1 then
        ObjSet( "spr_unlock_screen_black", { input = 0 } );
        ObjSet( "obj_unlock_btn_screen_hub", { visible = 0, active = 0, input = 0 } );
        ObjAnimate( "spr_unlock_screen_black", "alp", 0, 0, "", { 0,0,0.6, 0.2,0,0 });
        ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,512,384, 0.3,3,screen_start_pos[1],screen_start_pos[2]});
        ObjAnimate( screen , "pos_z", 0, 0, "", {0,0,11,  0.1,0,screen_start_pos[3]});
        ObjAnimate( screen , "ang", 0, 0, "", {0,3,0, 0.3,3,screen_start_pos[4]} );
        ObjAnimate( screen , "scale_xy", 0, 0, "", {0,3,1,1, 0.3,3,0.28,0.28} );   
        ObjAnimate( "obj_unlock_circle_hub", "alp", 0, 0, function() private.SlideEnd(); end, { 0,0,1, 0.3,0,0 });     
        screen_start_pos = {0,0,0,0};
        screen = 0;
    else
        port.unlock.screen_curr = num;
        screen = "spr_unlock_screen_"..num;
        screen_start_pos[1] = ObjGet( screen ).pos_x;
        screen_start_pos[2] = ObjGet( screen ).pos_y;
        screen_start_pos[3] = ObjGet( screen ).pos_z;
        screen_start_pos[4] = ObjGet( screen ).ang;
        ObjSet( "spr_unlock_screen_black", { input = 1 } );
        ObjSet( "obj_unlock_btn_screen_hub", { visible = 1, active = 1, input = 1 } );
        ObjAnimate( "spr_unlock_screen_black", "alp", 0, 0, "", { 0,0,0, 0.2,0,0.6 });
        ObjAnimate( "obj_unlock_btn_screen_hub", "alp", 0, 0, "", { 0,0,0, 0.1,0,0, 0.4,0,1 });
        ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,screen_start_pos[1],screen_start_pos[2],  0.3,3,512,384});
        ObjAnimate( screen , "pos_z", 0, 0, "", {0,0,screen_start_pos[3],  0.1,0,11});
        ObjAnimate( screen , "ang", 0, 0, "", {0,3,screen_start_pos[4], 0.3,3,0} );
        ObjAnimate( screen , "scale_xy", 0, 0, "", {0,3,0.28,0.28, 0.3,3,1,1} );
        ObjAnimate( "obj_unlock_circle_hub", "alp", 0, 0, function() private.SlideEnd(); end, { 0,0,0, 0.3,0,1 });
        ObjSet( "spr_unlock_circle_light", { pos_x = circle_arr_pos[port.unlock.screen_curr][1] });
    end;

    slide_enable =1;
    end;
end;
--------------------------------------------------------------------
function public.ArrowDown( way )
  if (slide_enable == 0) then
  port.TapDown(1.3);
  private.button_click();
  ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,512,384, 1,3,512+1100*way,384, 1,3,screen_start_pos[1],screen_start_pos[2]});
  ObjAnimate( screen , "pos_z", 0, 0, "", {0,0,11,  0.8,0,11, 0.9,0,screen_start_pos[3]});
  ObjAnimate( screen , "ang", 0, 0, "", {0,3,0, 1,3,screen_start_pos[4]} );
  ObjAnimate( screen , "scale_xy", 0, 0, "", {0,3,1,1, 1,3,0.28,0.28} );
  local start_pos_x = circle_arr_pos[port.unlock.screen_curr][1];

  port.unlock.screen_curr = port.unlock.screen_curr + way;

  if (port.unlock.screen_curr > 5) then
    port.unlock.screen_curr = 1;
  end;
  if (port.unlock.screen_curr < 1) then
    port.unlock.screen_curr = 5;
  end;

  screen = "spr_unlock_screen_"..port.unlock.screen_curr;
  screen_start_pos[1] = screen_arr_pos[port.unlock.screen_curr][1];
  screen_start_pos[2] = screen_arr_pos[port.unlock.screen_curr][2];
  screen_start_pos[3] = screen_arr_pos[port.unlock.screen_curr][3];
  screen_start_pos[4] = screen_arr_pos[port.unlock.screen_curr][4];

  way = way*(-1);

  ObjAnimate( "spr_unlock_circle_light", "pos_x", 0, 0, "", { 0,3,start_pos_x, 0.3,3,start_pos_x, 0.3,3,circle_arr_pos[port.unlock.screen_curr][1] });
  ObjAnimate( "spr_unlock_circle_light", "alp", 0, 0, "", { 0,3,1, 0.3,3,0, 0.3,3,0, 1.0,3,1 });
  ObjAnimate( "obj_unlock_btn_screen_hub", "alp", 0, 0, "", { 0,0,1, 0.3,0,0, 1,0,0, 1.3,0,1 });
  ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,screen_start_pos[1],screen_start_pos[2],  0.3,3,512,384});
  ObjAnimate( screen , "pos_z", 0, 0, "", {0,0,11,  1,0,11});
  ObjAnimate( screen , "ang", 0, 0, "", {0,3,0, 1,3,screen_start_pos[4]} );
  ObjAnimate( screen , "scale_xy", 0, 0, function() private.SlideEnd(); end, {0,3,0.3,0.3, 1.3,3,1,1} );
  --ObjAnimate( screen , "pos_xy", 0, 0, "", {0,3,512+1100*way,384, 1,3,512,384});
  slide_enable = 1;
  end;
end;
---------------------------------------------------------------------
function private.SlideEnd()
  slide_enable = 0;
end;
--------------------------------------------------------------------
function public.BackDown()



    private.button_click();
    port.TapDown(0.7);

    if cmn.is_inmenunow == true then
      iOS_LogEvents(10,"");
      cmn.is_inmenunow = true;
      common.GotoRoom( "rm_menu" );
    else
      iOS_LogEvents(11,"");
      local prg = ng_global.currentprogress;
      local level = ng_global.progress[ prg ].common.chapter;

      if (iOS_IsBought() == 0) then
        if (ng_global.progress[ "std" ][ "clk_outro1" ]) then
          if (ng_global.progress[ "std" ][ "clk_outro1" ].done==1) then
            cmn.is_inmenunow = true;
            common.GotoRoom( "rm_menu" );
          else
            common.LevelSwitch( level );
          end;
        else
          common.LevelSwitch( level );
        end;
      else
        common.LevelSwitch( level );
      end;
    end;

end;
--------------------------------------------------------------------
function public.UnlockDown()
 
    private.button_click();
    ObjSet("spr_unlock_black", {visible = 1, input = 1});
    ObjSet("txt_unlock_black_text", {visible = 1});
    port.TapDown(0.7);

    if cmn.is_inmenunow then

        iOS_LogEvents(4);
    else

        iOS_LogEvents(1);
       
    end;
      
      
      iOS_BuyFull();
      --public.FullBack();
end;
--------------------------------------------------------------------
function public.RestorePurchaseDown()

    private.button_click();
    port.TapDown(0.7);
    --DbgTrace("Already purchased down");
    iOS_RestorePurchase();

end;
--------------------------------------------------------------------
function public.FullHideWait()  -- unlock_full_hide_please_wait

    ObjSet("spr_unlock_black", {visible = 0, input = 0});
    ObjSet("txt_unlock_black_text", {visible = 0});

end;
--------------------------------------------------------------------
function public.FullBack()  -- unlock_full_button_back
  
  local prg = ng_global.currentprogress;
  if GetCurrentRoom() == "rm_unlock" then
    if iOS_IsBought() == 1 then
      if extraspressed == 1 then
        
        cmn.is_inmenunow = true;
        common.GotoRoom( "rm_extra" );
      elseif cmn.is_inmenunow then
        
        cmn.is_inmenunow = true;
        common.GotoRoom( "rm_menu" );
      else
        
        if ( not ng_global.progress[ prg ].common.gamestart ) then
              ng_global.progress[ prg ].common.gamestart = true;
        end;
        local level = ng_global.progress[ prg ].common.chapter;
        cmn.is_inmenunow = false;
        
        if (ng_global.progress[ "std" ][ "clk_outro1" ]) then
          if (ng_global.progress[ "std" ][ "clk_outro1" ].done==1) then
            if ng_global.progress[ "std" ][ "opn_workshop" ].done~=1 then
              ng_global.progress[ "std" ].common.currentroom = "rm_workshop";
            end;
            common.LevelSwitch(level);
          end;
        else
          common.LevelSwitch(level);
        end;
      end;
    else
      
      cmn.is_inmenunow = true;
      common.GotoRoom( "rm_menu" );
    end;
    extraspressed = 0; 
  end;
end;
--*****************************************************************************************
