-- name=int_pause
--******************************************************************************************
function public.Init( pos_z )

  private.event_anim_end = {};

  interface.LoadImplementation( "pause" );
  ObjAttach( "int_pause", interface.originhub );
  ObjSet( "int_pause", { pos_z = pos_z } );

  MsgSubscribe( Command_Pause_Show, private.Show );
  MsgSubscribe( Command_Pause_Hide, private.Hide );

  ---port. fix for android
  private.pause_active = false;
  MsgSubscribe( Event_Application_Paused, private.Show );
  MsgSubscribe( Command_Pause, private.Pause );
  ObjSet("obj_int_pause_pause",{ event_mdown = private.Hide });
  
end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Pause_Show, private.Show );
  MsgUnsubscribe( Command_Pause_Hide, private.Hide );
  
  ---port. fix for android
  MsgUnsubscribe( Event_Application_Paused, private.Show );
  MsgUnsubscribe( Command_Pause, private.Pause );

end;
--******************************************************************************************
function public.EventAnimEnd( event_id )

  local event_params = private.event_anim_end[ event_id ];
------------------------------------------------------------------------------------
  if ( event_id == "show" ) then

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  end;
------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Show()

  if IsEditor() then return; end;

   --port. fix android
  private.pause_active = true;
  
  local event_id = "pause_show";
  private.event_anim_end[ event_id ] = {};
  int_pause_impl.ShowAnim( event_id );

end;
--******************************************************************************************
function private.Hide()

  if IsEditor() then return; end;

  local event_id = "pause_hide";
  private.event_anim_end[ event_id ] = {};
  int_pause_impl.HideAnim( event_id );
  
    ---port. fix for android
  PauseLevel(0);
  if int_dialog_video.GetDialogVideoActive() ~= nil then
    VidPause(int_dialog_video.GetDialogVideoActive(),0);
  end;
  SndPauseAll( false );

end;
--******************************************************************************************
---port. fix for android
function private.Pause(msg, params)
 
  DbgTrace("int_pause -> private.Pause msg:"..tostring(msg).." params.pause:"..tostring(params.pause).." private.pause_active:"..tostring(private.pause_active));
  if (params.pause == 0 and private.pause_active == true) then
    SndPauseAll( true );
    ObjSet("obj_int_pause_pause",{ input = true });
    if int_dialog_video.GetDialogVideoActive() ~= nil then
      VidPause(int_dialog_video.GetDialogVideoActive(),1);
    end;
    PauseLevel(1);
    private.pause_active = false;
  end;
  
  
end;